""" Cisco_IOS_XR_infra_policymgr_oper 

This module contains a collection of YANG definitions
for Cisco IOS\-XR infra\-policymgr package operational data.

This module contains definitions
for the following management objects\:
  policy\-manager\: Policy\-map operational data

Copyright (c) 2013\-2017 by Cisco Systems, Inc.
All rights reserved.

"""
from ydk.types import Entity, EntityPath, Identity, Enum, YType, YLeaf, YLeafList, YList, LeafDataList, Bits, Empty, Decimal64
from ydk.filters import YFilter
from ydk.errors import YPYError, YPYModelError
from ydk.errors.error_handler import handle_type_error as _handle_type_error


class AcctEn(Enum):
    """
    AcctEn

    Acct en

    .. data:: policy_acct_evt_unspecified = 0

    	policy acct evt unspecified

    .. data:: policy_acct_evt_start = 1

    	policy acct evt start

    .. data:: policy_acct_evt_stop = 2

    	policy acct evt stop

    .. data:: policy_acct_evt_update = 3

    	policy acct evt update

    """

    policy_acct_evt_unspecified = Enum.YLeaf(0, "policy-acct-evt-unspecified")

    policy_acct_evt_start = Enum.YLeaf(1, "policy-acct-evt-start")

    policy_acct_evt_stop = Enum.YLeaf(2, "policy-acct-evt-stop")

    policy_acct_evt_update = Enum.YLeaf(3, "policy-acct-evt-update")


class AfmonAlarmSevEn(Enum):
    """
    AfmonAlarmSevEn

    AFMon Alarm Severities

    .. data:: afmon_alm_none = 0

    	afmon alm none

    .. data:: afmon_alm_info = 1

    	afmon alm info

    .. data:: afmon_alm_notif = 2

    	afmon alm notif

    .. data:: afmon_alm_warn = 3

    	afmon alm warn

    .. data:: afmon_alm_error = 4

    	afmon alm error

    .. data:: afmon_alm_crit = 5

    	afmon alm crit

    .. data:: afmon_alm_alert = 6

    	afmon alm alert

    .. data:: afmon_alm_emerg = 7

    	afmon alm emerg

    .. data:: afmon_alm_sev_max = 8

    	afmon alm sev max

    """

    afmon_alm_none = Enum.YLeaf(0, "afmon-alm-none")

    afmon_alm_info = Enum.YLeaf(1, "afmon-alm-info")

    afmon_alm_notif = Enum.YLeaf(2, "afmon-alm-notif")

    afmon_alm_warn = Enum.YLeaf(3, "afmon-alm-warn")

    afmon_alm_error = Enum.YLeaf(4, "afmon-alm-error")

    afmon_alm_crit = Enum.YLeaf(5, "afmon-alm-crit")

    afmon_alm_alert = Enum.YLeaf(6, "afmon-alm-alert")

    afmon_alm_emerg = Enum.YLeaf(7, "afmon-alm-emerg")

    afmon_alm_sev_max = Enum.YLeaf(8, "afmon-alm-sev-max")


class AfmonAlarmTypeEn(Enum):
    """
    AfmonAlarmTypeEn

    Afmon alarm type en

    .. data:: afmon_alm_type_invalid = 0

    	afmon alm type invalid

    .. data:: afmon_alm_discrete = 1

    	afmon alm discrete

    .. data:: afmon_alm_grp_cnt = 2

    	afmon alm grp cnt

    .. data:: afmon_alm_grp_pct = 3

    	afmon alm grp pct

    .. data:: afmon_alm_type_max = 4

    	afmon alm type max

    """

    afmon_alm_type_invalid = Enum.YLeaf(0, "afmon-alm-type-invalid")

    afmon_alm_discrete = Enum.YLeaf(1, "afmon-alm-discrete")

    afmon_alm_grp_cnt = Enum.YLeaf(2, "afmon-alm-grp-cnt")

    afmon_alm_grp_pct = Enum.YLeaf(3, "afmon-alm-grp-pct")

    afmon_alm_type_max = Enum.YLeaf(4, "afmon-alm-type-max")


class AfmonFlowParmTypeEn(Enum):
    """
    AfmonFlowParmTypeEn

    (afmon) Flow submode param types

    .. data:: afmon_flow_parm_invalid = 0

    	invalid

    .. data:: afmon_flow_parm_max_mon_flow_s = 1

    	Max monitored flows

    .. data:: afmon_flow_parm_mon_interval = 2

    	Monitoring interval

    .. data:: afmon_flow_parm_intvl_hist = 3

    	Interval History

    .. data:: afmon_flow_parm_flow_timeout = 4

    	Flow Timeout

    .. data:: afmon_flow_parm_max = 5

    	Maximum flow parm type

    """

    afmon_flow_parm_invalid = Enum.YLeaf(0, "afmon-flow-parm-invalid")

    afmon_flow_parm_max_mon_flow_s = Enum.YLeaf(1, "afmon-flow-parm-max-mon-flow-s")

    afmon_flow_parm_mon_interval = Enum.YLeaf(2, "afmon-flow-parm-mon-interval")

    afmon_flow_parm_intvl_hist = Enum.YLeaf(3, "afmon-flow-parm-intvl-hist")

    afmon_flow_parm_flow_timeout = Enum.YLeaf(4, "afmon-flow-parm-flow-timeout")

    afmon_flow_parm_max = Enum.YLeaf(5, "afmon-flow-parm-max")


class AfmonIpcbrParmTypeEn(Enum):
    """
    AfmonIpcbrParmTypeEn

    Afmon ipcbr parm type en

    .. data:: afmon_ipcbr_parm_invalid = 0

    	afmon ipcbr parm invalid

    .. data:: afmon_ipcbr_parm_ip_pkt_rate = 1

    	afmon ipcbr parm ip pkt rate

    .. data:: afmon_ipcbr_parm_ip_bit_rate = 2

    	afmon ipcbr parm ip bit rate

    .. data:: afmon_ipcbr_parm_media_bit_rate = 3

    	afmon ipcbr parm media bit rate

    .. data:: afmon_ipcbr_parm_media_pkt_size = 4

    	afmon ipcbr parm media pkt size

    .. data:: afmon_ipcbr_parm_media_pkts_per_ip = 5

    	afmon ipcbr parm media pkts per ip

    .. data:: afmon_ipcbr_parm_max = 6

    	afmon ipcbr parm max

    """

    afmon_ipcbr_parm_invalid = Enum.YLeaf(0, "afmon-ipcbr-parm-invalid")

    afmon_ipcbr_parm_ip_pkt_rate = Enum.YLeaf(1, "afmon-ipcbr-parm-ip-pkt-rate")

    afmon_ipcbr_parm_ip_bit_rate = Enum.YLeaf(2, "afmon-ipcbr-parm-ip-bit-rate")

    afmon_ipcbr_parm_media_bit_rate = Enum.YLeaf(3, "afmon-ipcbr-parm-media-bit-rate")

    afmon_ipcbr_parm_media_pkt_size = Enum.YLeaf(4, "afmon-ipcbr-parm-media-pkt-size")

    afmon_ipcbr_parm_media_pkts_per_ip = Enum.YLeaf(5, "afmon-ipcbr-parm-media-pkts-per-ip")

    afmon_ipcbr_parm_max = Enum.YLeaf(6, "afmon-ipcbr-parm-max")


class AfmonMdiParmTypeEn(Enum):
    """
    AfmonMdiParmTypeEn

    Afmon mdi parm type en

    .. data:: afmon_mdi_parm_invalid = 0

    	afmon mdi parm invalid

    .. data:: afmon_mdi_parm_pids = 1

    	afmon mdi parm pids

    .. data:: afmon_mdi_parm_pkt_rate = 2

    	afmon mdi parm pkt rate

    .. data:: afmon_mdi_parm_ip_pkt_rate = 3

    	afmon mdi parm ip pkt rate

    .. data:: afmon_mdi_parm_ip_bit_rate = 4

    	afmon mdi parm ip bit rate

    .. data:: afmon_mdi_parm_max = 5

    	afmon mdi parm max

    """

    afmon_mdi_parm_invalid = Enum.YLeaf(0, "afmon-mdi-parm-invalid")

    afmon_mdi_parm_pids = Enum.YLeaf(1, "afmon-mdi-parm-pids")

    afmon_mdi_parm_pkt_rate = Enum.YLeaf(2, "afmon-mdi-parm-pkt-rate")

    afmon_mdi_parm_ip_pkt_rate = Enum.YLeaf(3, "afmon-mdi-parm-ip-pkt-rate")

    afmon_mdi_parm_ip_bit_rate = Enum.YLeaf(4, "afmon-mdi-parm-ip-bit-rate")

    afmon_mdi_parm_max = Enum.YLeaf(5, "afmon-mdi-parm-max")


class AfmonReactActnEn(Enum):
    """
    AfmonReactActnEn

    Afmon react actn en

    .. data:: afmon_react_actn_none = 0

    	afmon react actn none

    .. data:: afmon_react_syslog = 1

    	afmon react syslog

    .. data:: afmon_react_snmp = 2

    	afmon react snmp

    .. data:: afmon_react_clone = 3

    	afmon react clone

    """

    afmon_react_actn_none = Enum.YLeaf(0, "afmon-react-actn-none")

    afmon_react_syslog = Enum.YLeaf(1, "afmon-react-syslog")

    afmon_react_snmp = Enum.YLeaf(2, "afmon-react-snmp")

    afmon_react_clone = Enum.YLeaf(3, "afmon-react-clone")


class AfmonReactCriterionEn(Enum):
    """
    AfmonReactCriterionEn

    Afmon react criterion en

    .. data:: afmon_react_crit_invalid = 0

    	afmon react crit invalid

    .. data:: afmon_react_mrv = 1

    	afmon react mrv

    .. data:: afmon_react_df = 2

    	afmon react df

    .. data:: afmon_react_mse = 3

    	afmon react mse

    .. data:: afmon_react_pkt_rate = 4

    	afmon react pkt rate

    .. data:: afmon_react_flow_cnt = 5

    	afmon react flow cnt

    .. data:: afmon_react_rtp_loss_fraction = 6

    	afmon react rtp loss fraction

    .. data:: afmon_react_rtp_jitter = 7

    	afmon react rtp jitter

    .. data:: afmon_react_rtp_max_jitter = 8

    	afmon react rtp max jitter

    .. data:: afmon_react_rtp_out_of_order = 9

    	afmon react rtp out of order

    .. data:: afmon_react_rtp_loss_pkts = 10

    	afmon react rtp loss pkts

    .. data:: afmon_react_rtp_ta = 11

    	afmon react rtp ta

    .. data:: afmon_react_rtp_es = 12

    	afmon react rtp es

    .. data:: afmon_react_mdi_mlr = 13

    	afmon react mdi mlr

    .. data:: afmon_react_mdi_mdc = 14

    	afmon react mdi mdc

    .. data:: afmon_react_mdi_jitter = 15

    	afmon react mdi jitter

    .. data:: afmon_react_mdi_loss_pkts = 16

    	afmon react mdi loss pkts

    .. data:: afmon_react_mdi_ta = 17

    	afmon react mdi ta

    .. data:: afmon_react_mdi_es = 18

    	afmon react mdi es

    .. data:: afmon_react_crit_max = 19

    	afmon react crit max

    """

    afmon_react_crit_invalid = Enum.YLeaf(0, "afmon-react-crit-invalid")

    afmon_react_mrv = Enum.YLeaf(1, "afmon-react-mrv")

    afmon_react_df = Enum.YLeaf(2, "afmon-react-df")

    afmon_react_mse = Enum.YLeaf(3, "afmon-react-mse")

    afmon_react_pkt_rate = Enum.YLeaf(4, "afmon-react-pkt-rate")

    afmon_react_flow_cnt = Enum.YLeaf(5, "afmon-react-flow-cnt")

    afmon_react_rtp_loss_fraction = Enum.YLeaf(6, "afmon-react-rtp-loss-fraction")

    afmon_react_rtp_jitter = Enum.YLeaf(7, "afmon-react-rtp-jitter")

    afmon_react_rtp_max_jitter = Enum.YLeaf(8, "afmon-react-rtp-max-jitter")

    afmon_react_rtp_out_of_order = Enum.YLeaf(9, "afmon-react-rtp-out-of-order")

    afmon_react_rtp_loss_pkts = Enum.YLeaf(10, "afmon-react-rtp-loss-pkts")

    afmon_react_rtp_ta = Enum.YLeaf(11, "afmon-react-rtp-ta")

    afmon_react_rtp_es = Enum.YLeaf(12, "afmon-react-rtp-es")

    afmon_react_mdi_mlr = Enum.YLeaf(13, "afmon-react-mdi-mlr")

    afmon_react_mdi_mdc = Enum.YLeaf(14, "afmon-react-mdi-mdc")

    afmon_react_mdi_jitter = Enum.YLeaf(15, "afmon-react-mdi-jitter")

    afmon_react_mdi_loss_pkts = Enum.YLeaf(16, "afmon-react-mdi-loss-pkts")

    afmon_react_mdi_ta = Enum.YLeaf(17, "afmon-react-mdi-ta")

    afmon_react_mdi_es = Enum.YLeaf(18, "afmon-react-mdi-es")

    afmon_react_crit_max = Enum.YLeaf(19, "afmon-react-crit-max")


class AfmonReactParmTypeEn(Enum):
    """
    AfmonReactParmTypeEn

    (afmon) React submode param types

    .. data:: afmon_react_parm_invalid = 0

    	invalid

    .. data:: afmon_react_parm_oper_id = 1

    	Operation ID

    .. data:: afmon_react_parm_crit_erion = 2

    	Criterion

    .. data:: afmon_react_parm_desc = 3

    	Description

    .. data:: afmon_react_parm_trig_value = 4

    	Trigger value

    .. data:: afmon_react_parm_trig_type = 5

    	Trigger Type

    .. data:: afmon_react_parm_action = 6

    	Action

    .. data:: afmon_react_parm_alm_type = 7

    	Alarm type

    .. data:: afmon_react_parm_alm_severity = 8

    	Alarm Severity

    .. data:: afmon_react_parm_max = 9

    	Maximum react parm type

    """

    afmon_react_parm_invalid = Enum.YLeaf(0, "afmon-react-parm-invalid")

    afmon_react_parm_oper_id = Enum.YLeaf(1, "afmon-react-parm-oper-id")

    afmon_react_parm_crit_erion = Enum.YLeaf(2, "afmon-react-parm-crit-erion")

    afmon_react_parm_desc = Enum.YLeaf(3, "afmon-react-parm-desc")

    afmon_react_parm_trig_value = Enum.YLeaf(4, "afmon-react-parm-trig-value")

    afmon_react_parm_trig_type = Enum.YLeaf(5, "afmon-react-parm-trig-type")

    afmon_react_parm_action = Enum.YLeaf(6, "afmon-react-parm-action")

    afmon_react_parm_alm_type = Enum.YLeaf(7, "afmon-react-parm-alm-type")

    afmon_react_parm_alm_severity = Enum.YLeaf(8, "afmon-react-parm-alm-severity")

    afmon_react_parm_max = Enum.YLeaf(9, "afmon-react-parm-max")


class AfmonRtpClockRateTypeEn(Enum):
    """
    AfmonRtpClockRateTypeEn

    Afmon rtp clock rate type en

    .. data:: afmon_rtp_cr_invalid = 0

    	afmon rtp cr invalid

    .. data:: afmon_rtp_cr_8k = 1

    	afmon rtp cr 8k

    .. data:: afmon_rtp_cr_16k = 2

    	afmon rtp cr 16k

    .. data:: afmon_rtp_cr_11025 = 3

    	afmon rtp cr 11025

    .. data:: afmon_rtp_cr_22050 = 4

    	afmon rtp cr 22050

    .. data:: afmon_rtp_cr_44100 = 5

    	afmon rtp cr 44100

    .. data:: afmon_rtp_cr_48k = 6

    	afmon rtp cr 48k

    .. data:: afmon_rtp_cr_90k = 7

    	afmon rtp cr 90k

    .. data:: afmon_rtp_cr_27m = 8

    	afmon rtp cr 27m

    .. data:: afmon_rtp_cr_148500k = 9

    	afmon rtp cr 148500k

    .. data:: afmon_rtp_cr_148351k = 10

    	afmon rtp cr 148351k

    .. data:: afmon_rtp_cr_max = 11

    	afmon rtp cr max

    """

    afmon_rtp_cr_invalid = Enum.YLeaf(0, "afmon-rtp-cr-invalid")

    afmon_rtp_cr_8k = Enum.YLeaf(1, "afmon-rtp-cr-8k")

    afmon_rtp_cr_16k = Enum.YLeaf(2, "afmon-rtp-cr-16k")

    afmon_rtp_cr_11025 = Enum.YLeaf(3, "afmon-rtp-cr-11025")

    afmon_rtp_cr_22050 = Enum.YLeaf(4, "afmon-rtp-cr-22050")

    afmon_rtp_cr_44100 = Enum.YLeaf(5, "afmon-rtp-cr-44100")

    afmon_rtp_cr_48k = Enum.YLeaf(6, "afmon-rtp-cr-48k")

    afmon_rtp_cr_90k = Enum.YLeaf(7, "afmon-rtp-cr-90k")

    afmon_rtp_cr_27m = Enum.YLeaf(8, "afmon-rtp-cr-27m")

    afmon_rtp_cr_148500k = Enum.YLeaf(9, "afmon-rtp-cr-148500k")

    afmon_rtp_cr_148351k = Enum.YLeaf(10, "afmon-rtp-cr-148351k")

    afmon_rtp_cr_max = Enum.YLeaf(11, "afmon-rtp-cr-max")


class AfmonRtpParmTypeEn(Enum):
    """
    AfmonRtpParmTypeEn

    Afmon rtp parm type en

    .. data:: afmon_rtp_parm_invalid = 0

    	afmon rtp parm invalid

    .. data:: afmon_rtp_parm_min_seq = 1

    	afmon rtp parm min seq

    .. data:: afmon_rtp_parm_max_drop = 2

    	afmon rtp parm max drop

    .. data:: afmon_rtp_parm_max_mis_order = 3

    	afmon rtp parm max mis order

    .. data:: afmon_rtp_parm_seq_ext_cop4 = 4

    	afmon rtp parm seq ext cop4

    .. data:: afmon_rtp_parm_clock_rate = 5

    	afmon rtp parm clock rate

    .. data:: afmon_rtp_parm_max = 6

    	afmon rtp parm max

    """

    afmon_rtp_parm_invalid = Enum.YLeaf(0, "afmon-rtp-parm-invalid")

    afmon_rtp_parm_min_seq = Enum.YLeaf(1, "afmon-rtp-parm-min-seq")

    afmon_rtp_parm_max_drop = Enum.YLeaf(2, "afmon-rtp-parm-max-drop")

    afmon_rtp_parm_max_mis_order = Enum.YLeaf(3, "afmon-rtp-parm-max-mis-order")

    afmon_rtp_parm_seq_ext_cop4 = Enum.YLeaf(4, "afmon-rtp-parm-seq-ext-cop4")

    afmon_rtp_parm_clock_rate = Enum.YLeaf(5, "afmon-rtp-parm-clock-rate")

    afmon_rtp_parm_max = Enum.YLeaf(6, "afmon-rtp-parm-max")


class AfmonTrigRelopEn(Enum):
    """
    AfmonTrigRelopEn

    Afmon trig relop en

    .. data:: afmon_trig_relop_invalid = 0

    	afmon trig relop invalid

    .. data:: afmon_trig_lt = 1

    	afmon trig lt

    .. data:: afmon_trig_le = 2

    	afmon trig le

    .. data:: afmon_trig_gt = 3

    	afmon trig gt

    .. data:: afmon_trig_ge = 4

    	afmon trig ge

    .. data:: afmon_trig_range = 5

    	afmon trig range

    .. data:: afmon_trig_relop_max = 6

    	afmon trig relop max

    """

    afmon_trig_relop_invalid = Enum.YLeaf(0, "afmon-trig-relop-invalid")

    afmon_trig_lt = Enum.YLeaf(1, "afmon-trig-lt")

    afmon_trig_le = Enum.YLeaf(2, "afmon-trig-le")

    afmon_trig_gt = Enum.YLeaf(3, "afmon-trig-gt")

    afmon_trig_ge = Enum.YLeaf(4, "afmon-trig-ge")

    afmon_trig_range = Enum.YLeaf(5, "afmon-trig-range")

    afmon_trig_relop_max = Enum.YLeaf(6, "afmon-trig-relop-max")


class AfmonTrigTypeEn(Enum):
    """
    AfmonTrigTypeEn

    Afmon trig type en

    .. data:: afmon_trig_type_invalid = 0

    	afmon trig type invalid

    .. data:: afmon_trig_immed = 1

    	afmon trig immed

    .. data:: afmon_trig_avg = 2

    	afmon trig avg

    .. data:: afmon_trig_type_max = 3

    	afmon trig type max

    """

    afmon_trig_type_invalid = Enum.YLeaf(0, "afmon-trig-type-invalid")

    afmon_trig_immed = Enum.YLeaf(1, "afmon-trig-immed")

    afmon_trig_avg = Enum.YLeaf(2, "afmon-trig-avg")

    afmon_trig_type_max = Enum.YLeaf(3, "afmon-trig-type-max")


class AuthorizeIdEn(Enum):
    """
    AuthorizeIdEn

    Authorize id en

    .. data:: policy_authorize_ident_unspecified = 0

    	policy authorize ident unspecified

    .. data:: policy_authorize_ident_dnis = 1

    	policy authorize ident dnis

    .. data:: policy_authorize_ident_domain = 2

    	policy authorize ident domain

    .. data:: policy_authorize_ident_user_name = 3

    	policy authorize ident user name

    .. data:: policy_authorize_ident_nas_port = 4

    	policy authorize ident nas port

    .. data:: policy_authorize_ident_source_address_ipv4 = 5

    	policy authorize ident source address ipv4

    .. data:: policy_authorize_ident_source_address_ipv6 = 6

    	policy authorize ident source address ipv6

    .. data:: policy_authorize_ident_source_address_mac = 7

    	policy authorize ident source address mac

    .. data:: policy_authorize_ident_auto_detect = 8

    	policy authorize ident auto detect

    .. data:: policy_authorize_ident_tunnel_name = 9

    	policy authorize ident tunnel name

    .. data:: policy_authorize_ident_dhcp_client_id = 10

    	policy authorize ident dhcp client id

    .. data:: policy_authorize_ident_circuit_id = 11

    	policy authorize ident circuit id

    .. data:: policy_authorize_ident_remote_id = 12

    	policy authorize ident remote id

    .. data:: policy_authorize_ident_vendor_id = 13

    	policy authorize ident vendor id

    .. data:: policy_authorize_ident_service_name = 14

    	policy authorize ident service name

    .. data:: policy_authorize_ident_max = 15

    	policy authorize ident max

    """

    policy_authorize_ident_unspecified = Enum.YLeaf(0, "policy-authorize-ident-unspecified")

    policy_authorize_ident_dnis = Enum.YLeaf(1, "policy-authorize-ident-dnis")

    policy_authorize_ident_domain = Enum.YLeaf(2, "policy-authorize-ident-domain")

    policy_authorize_ident_user_name = Enum.YLeaf(3, "policy-authorize-ident-user-name")

    policy_authorize_ident_nas_port = Enum.YLeaf(4, "policy-authorize-ident-nas-port")

    policy_authorize_ident_source_address_ipv4 = Enum.YLeaf(5, "policy-authorize-ident-source-address-ipv4")

    policy_authorize_ident_source_address_ipv6 = Enum.YLeaf(6, "policy-authorize-ident-source-address-ipv6")

    policy_authorize_ident_source_address_mac = Enum.YLeaf(7, "policy-authorize-ident-source-address-mac")

    policy_authorize_ident_auto_detect = Enum.YLeaf(8, "policy-authorize-ident-auto-detect")

    policy_authorize_ident_tunnel_name = Enum.YLeaf(9, "policy-authorize-ident-tunnel-name")

    policy_authorize_ident_dhcp_client_id = Enum.YLeaf(10, "policy-authorize-ident-dhcp-client-id")

    policy_authorize_ident_circuit_id = Enum.YLeaf(11, "policy-authorize-ident-circuit-id")

    policy_authorize_ident_remote_id = Enum.YLeaf(12, "policy-authorize-ident-remote-id")

    policy_authorize_ident_vendor_id = Enum.YLeaf(13, "policy-authorize-ident-vendor-id")

    policy_authorize_ident_service_name = Enum.YLeaf(14, "policy-authorize-ident-service-name")

    policy_authorize_ident_max = Enum.YLeaf(15, "policy-authorize-ident-max")


class CacFlowActnTypeEn(Enum):
    """
    CacFlowActnTypeEn

    CAC flow types

    .. data:: cac_flow_actn_type_local = 0

    	CAC flow local

    .. data:: cac_flow_actn_type_max = 1

    	Max CAC flow types

    """

    cac_flow_actn_type_local = Enum.YLeaf(0, "cac-flow-actn-type-local")

    cac_flow_actn_type_max = Enum.YLeaf(1, "cac-flow-actn-type-max")


class ClassMapModeEn(Enum):
    """
    ClassMapModeEn

    Class\-Map Mode

    .. data:: class_map_mode_match_any = 0

    	Type Match-Any

    .. data:: class_map_mode_match_all = 1

    	Type Match-All

    .. data:: class_map_mode_max = 2

    	Not a valid mode

    .. data:: class_map_mode_usr_def = 1073741824

    	User defined match type

    """

    class_map_mode_match_any = Enum.YLeaf(0, "class-map-mode-match-any")

    class_map_mode_match_all = Enum.YLeaf(1, "class-map-mode-match-all")

    class_map_mode_max = Enum.YLeaf(2, "class-map-mode-max")

    class_map_mode_usr_def = Enum.YLeaf(1073741824, "class-map-mode-usr-def")


class ClassMapTypeEn(Enum):
    """
    ClassMapTypeEn

    Class map type en

    .. data:: class_map_type_none = 0

    	class map type none

    .. data:: class_map_type_qos = 1

    	class map type qos

    .. data:: class_map_type_pbr = 2

    	class map type pbr

    .. data:: class_map_type_traffic = 3

    	class map type traffic

    .. data:: class_map_type_subs_control = 4

    	class map type subs control

    .. data:: class_map_type_max = 5

    	class map type max

    """

    class_map_type_none = Enum.YLeaf(0, "class-map-type-none")

    class_map_type_qos = Enum.YLeaf(1, "class-map-type-qos")

    class_map_type_pbr = Enum.YLeaf(2, "class-map-type-pbr")

    class_map_type_traffic = Enum.YLeaf(3, "class-map-type-traffic")

    class_map_type_subs_control = Enum.YLeaf(4, "class-map-type-subs-control")

    class_map_type_max = Enum.YLeaf(5, "class-map-type-max")


class DecodeIdentifierEn(Enum):
    """
    DecodeIdentifierEn

    Decode identifier en

    .. data:: policy_decid_unspecified = 0

    	policy decid unspecified

    .. data:: policy_decid_remote_id = 1

    	policy decid remote id

    .. data:: policy_decid_circuit_id = 2

    	policy decid circuit id

    .. data:: policy_decid_user_name = 3

    	policy decid user name

    .. data:: policy_decid_max = 4

    	policy decid max

    """

    policy_decid_unspecified = Enum.YLeaf(0, "policy-decid-unspecified")

    policy_decid_remote_id = Enum.YLeaf(1, "policy-decid-remote-id")

    policy_decid_circuit_id = Enum.YLeaf(2, "policy-decid-circuit-id")

    policy_decid_user_name = Enum.YLeaf(3, "policy-decid-user-name")

    policy_decid_max = Enum.YLeaf(4, "policy-decid-max")


class DpssSnidTypeEn(Enum):
    """
    DpssSnidTypeEn

    Dpss snid type en

    .. data:: dpss_snid_invalid = 0

    	dpss snid invalid

    .. data:: dpss_snid_index = 1

    	dpss snid index

    .. data:: dpss_snid_name = 2

    	dpss snid name

    .. data:: dpss_snid_type_max = 3

    	dpss snid type max

    """

    dpss_snid_invalid = Enum.YLeaf(0, "dpss-snid-invalid")

    dpss_snid_index = Enum.YLeaf(1, "dpss-snid-index")

    dpss_snid_name = Enum.YLeaf(2, "dpss-snid-name")

    dpss_snid_type_max = Enum.YLeaf(3, "dpss-snid-type-max")


class FlowKeyEn(Enum):
    """
    FlowKeyEn

    Flow key en

    .. data:: flow_key_invalid = 0

    	Flow key invalid

    .. data:: flow_key_src_ip = 1

    	Flow key source ip

    .. data:: flow_key_dst_ip = 2

    	Flow key destination ip

    .. data:: flow_key_five_tuple = 3

    	Flow key five tuple

    .. data:: flow_key_max = 4

    	Flow key max

    """

    flow_key_invalid = Enum.YLeaf(0, "flow-key-invalid")

    flow_key_src_ip = Enum.YLeaf(1, "flow-key-src-ip")

    flow_key_dst_ip = Enum.YLeaf(2, "flow-key-dst-ip")

    flow_key_five_tuple = Enum.YLeaf(3, "flow-key-five-tuple")

    flow_key_max = Enum.YLeaf(4, "flow-key-max")


class IdentifierEn(Enum):
    """
    IdentifierEn

    Identifier en

    .. data:: policy_ident_unspecified = 0

    	policy ident unspecified

    .. data:: policy_ident_authen_status = 1

    	policy ident authen status

    .. data:: policy_ident_dnis = 2

    	policy ident dnis

    .. data:: policy_ident_media = 3

    	policy ident media

    .. data:: policy_ident_mlp_negotiated = 4

    	policy ident mlp negotiated

    .. data:: policy_ident_nas_port = 5

    	policy ident nas port

    .. data:: policy_ident_no_user_name = 6

    	policy ident no user name

    .. data:: policy_ident_protocol = 7

    	policy ident protocol

    .. data:: policy_ident_service_name = 8

    	policy ident service name

    .. data:: policy_ident_source_address_ipv4 = 9

    	policy ident source address ipv4

    .. data:: policy_ident_source_address_ipv6 = 10

    	policy ident source address ipv6

    .. data:: policy_ident_source_address_mac = 11

    	policy ident source address mac

    .. data:: policy_ident_timer = 12

    	policy ident timer

    .. data:: policy_ident_tunnel_name = 13

    	policy ident tunnel name

    .. data:: policy_ident_auth_domain = 14

    	policy ident auth domain

    .. data:: policy_ident_auth_user_name = 15

    	policy ident auth user name

    .. data:: policy_ident_unauth_domain = 16

    	policy ident unauth domain

    .. data:: policy_ident_unauth_user_name = 17

    	policy ident unauth user name

    .. data:: policy_ident_max = 18

    	policy ident max

    """

    policy_ident_unspecified = Enum.YLeaf(0, "policy-ident-unspecified")

    policy_ident_authen_status = Enum.YLeaf(1, "policy-ident-authen-status")

    policy_ident_dnis = Enum.YLeaf(2, "policy-ident-dnis")

    policy_ident_media = Enum.YLeaf(3, "policy-ident-media")

    policy_ident_mlp_negotiated = Enum.YLeaf(4, "policy-ident-mlp-negotiated")

    policy_ident_nas_port = Enum.YLeaf(5, "policy-ident-nas-port")

    policy_ident_no_user_name = Enum.YLeaf(6, "policy-ident-no-user-name")

    policy_ident_protocol = Enum.YLeaf(7, "policy-ident-protocol")

    policy_ident_service_name = Enum.YLeaf(8, "policy-ident-service-name")

    policy_ident_source_address_ipv4 = Enum.YLeaf(9, "policy-ident-source-address-ipv4")

    policy_ident_source_address_ipv6 = Enum.YLeaf(10, "policy-ident-source-address-ipv6")

    policy_ident_source_address_mac = Enum.YLeaf(11, "policy-ident-source-address-mac")

    policy_ident_timer = Enum.YLeaf(12, "policy-ident-timer")

    policy_ident_tunnel_name = Enum.YLeaf(13, "policy-ident-tunnel-name")

    policy_ident_auth_domain = Enum.YLeaf(14, "policy-ident-auth-domain")

    policy_ident_auth_user_name = Enum.YLeaf(15, "policy-ident-auth-user-name")

    policy_ident_unauth_domain = Enum.YLeaf(16, "policy-ident-unauth-domain")

    policy_ident_unauth_user_name = Enum.YLeaf(17, "policy-ident-unauth-user-name")

    policy_ident_max = Enum.YLeaf(18, "policy-ident-max")


class MarkTypeEn(Enum):
    """
    MarkTypeEn

    Mark Type Enumeration

    .. data:: mark_type_none = 0

    	Mark None

    .. data:: mark_type_dscp = 1

    	Mark DSCP

    .. data:: mark_type_prec = 2

    	Mark Precedence

    .. data:: mark_type_mpls_exp_topmost = 3

    	Mark MPLS EXP on topmost header

    .. data:: mark_type_mpls_exp_imposition = 4

    	Mark MPLS EXP on imposition header

    .. data:: mark_type_qos_group = 5

    	Mark QoS Group

    .. data:: mark_type_discard_class = 6

    	Mark Discard Class

    .. data:: mark_type_cos = 7

    	Mark CoS

    .. data:: mark_type_cos_inner = 8

    	Mark COS Inner

    .. data:: mark_type_srp_priority = 9

    	Mark Priority

    .. data:: mark_type_atm_clp = 10

    	Mark ATM CLP

    .. data:: mark_type_fr_de = 11

    	Mark FR DE

    .. data:: mark_type_dscp_tunnel = 12

    	Mark DSCP in Tunnel Header

    .. data:: mark_type_prec_tunnel = 13

    	Mark Precedence in Tunnel Header

    .. data:: mark_type_dei = 14

    	Mark DEI

    .. data:: mark_type_dei_imposition = 15

    	Mark DEI on imposition header

    .. data:: mark_type_forward_class = 16

    	Mark forward class

    .. data:: mark_type_df = 17

    	Mark DF bit

    .. data:: mark_type_traffic_class = 18

    	Mark Traffic Class

    .. data:: mark_type_src_mac = 19

    	Mark source mac

    .. data:: mark_type_dst_mac = 20

    	Mark destination mac

    .. data:: mark_type_ipv4_src_addr = 21

    	Mark ipv4 source address

    .. data:: mark_type_ipv4_dst_addr = 22

    	Mark ipv4 destination address

    .. data:: mark_type_vlan_id = 23

    	Mark vlan id

    .. data:: mark_type_udp_src_port = 24

    	Mark type udp source port

    .. data:: mark_type_udp_dst_port = 25

    	Mark type udp destination port

    .. data:: mark_type_tcp_src_port = 26

    	Mark type tcp source port

    .. data:: mark_type_tcp_dst_port = 27

    	Mark type tcp destination port

    .. data:: mark_type_sctp_src_port = 28

    	Mark type sctp source port

    .. data:: mark_type_sctp_dst_port = 29

    	Mark type sctp destination port

    .. data:: mark_type_max = 30

    	Mark Type Max (Invalid)

    """

    mark_type_none = Enum.YLeaf(0, "mark-type-none")

    mark_type_dscp = Enum.YLeaf(1, "mark-type-dscp")

    mark_type_prec = Enum.YLeaf(2, "mark-type-prec")

    mark_type_mpls_exp_topmost = Enum.YLeaf(3, "mark-type-mpls-exp-topmost")

    mark_type_mpls_exp_imposition = Enum.YLeaf(4, "mark-type-mpls-exp-imposition")

    mark_type_qos_group = Enum.YLeaf(5, "mark-type-qos-group")

    mark_type_discard_class = Enum.YLeaf(6, "mark-type-discard-class")

    mark_type_cos = Enum.YLeaf(7, "mark-type-cos")

    mark_type_cos_inner = Enum.YLeaf(8, "mark-type-cos-inner")

    mark_type_srp_priority = Enum.YLeaf(9, "mark-type-srp-priority")

    mark_type_atm_clp = Enum.YLeaf(10, "mark-type-atm-clp")

    mark_type_fr_de = Enum.YLeaf(11, "mark-type-fr-de")

    mark_type_dscp_tunnel = Enum.YLeaf(12, "mark-type-dscp-tunnel")

    mark_type_prec_tunnel = Enum.YLeaf(13, "mark-type-prec-tunnel")

    mark_type_dei = Enum.YLeaf(14, "mark-type-dei")

    mark_type_dei_imposition = Enum.YLeaf(15, "mark-type-dei-imposition")

    mark_type_forward_class = Enum.YLeaf(16, "mark-type-forward-class")

    mark_type_df = Enum.YLeaf(17, "mark-type-df")

    mark_type_traffic_class = Enum.YLeaf(18, "mark-type-traffic-class")

    mark_type_src_mac = Enum.YLeaf(19, "mark-type-src-mac")

    mark_type_dst_mac = Enum.YLeaf(20, "mark-type-dst-mac")

    mark_type_ipv4_src_addr = Enum.YLeaf(21, "mark-type-ipv4-src-addr")

    mark_type_ipv4_dst_addr = Enum.YLeaf(22, "mark-type-ipv4-dst-addr")

    mark_type_vlan_id = Enum.YLeaf(23, "mark-type-vlan-id")

    mark_type_udp_src_port = Enum.YLeaf(24, "mark-type-udp-src-port")

    mark_type_udp_dst_port = Enum.YLeaf(25, "mark-type-udp-dst-port")

    mark_type_tcp_src_port = Enum.YLeaf(26, "mark-type-tcp-src-port")

    mark_type_tcp_dst_port = Enum.YLeaf(27, "mark-type-tcp-dst-port")

    mark_type_sctp_src_port = Enum.YLeaf(28, "mark-type-sctp-src-port")

    mark_type_sctp_dst_port = Enum.YLeaf(29, "mark-type-sctp-dst-port")

    mark_type_max = Enum.YLeaf(30, "mark-type-max")


class MatchAttrE(Enum):
    """
    MatchAttrE

    Match attribute type

    .. data:: value = 0

    	Match attribute value

    .. data:: range = 1

    	Match attribute range

    .. data:: mask = 2

    	Match attribute mask

    """

    value = Enum.YLeaf(0, "value")

    range = Enum.YLeaf(1, "range")

    mask = Enum.YLeaf(2, "mask")


class MatchAuthenStatusEn(Enum):
    """
    MatchAuthenStatusEn

    Match authen status en

    .. data:: match_authen_status_unspecified = 0

    	match authen status unspecified

    .. data:: match_authen_status_authenticated = 1

    	match authen status authenticated

    .. data:: match_authen_status_unauthenticated = 2

    	match authen status unauthenticated

    .. data:: match_authen_status_max = 3

    	match authen status max

    """

    match_authen_status_unspecified = Enum.YLeaf(0, "match-authen-status-unspecified")

    match_authen_status_authenticated = Enum.YLeaf(1, "match-authen-status-authenticated")

    match_authen_status_unauthenticated = Enum.YLeaf(2, "match-authen-status-unauthenticated")

    match_authen_status_max = Enum.YLeaf(3, "match-authen-status-max")


class MatchAvailableIdEn(Enum):
    """
    MatchAvailableIdEn

    Match available id en

    .. data:: match_avail_ident_unspecified = 0

    	match avail ident unspecified

    .. data:: match_avail_ident_dnis = 1

    	match avail ident dnis

    .. data:: match_avail_ident_domain = 2

    	match avail ident domain

    .. data:: match_avail_ident_circuit_id = 3

    	match avail ident circuit id

    .. data:: match_avail_ident_remote_id = 4

    	match avail ident remote id

    .. data:: match_avail_ident_media = 5

    	match avail ident media

    .. data:: match_avail_ident_nas_port = 6

    	match avail ident nas port

    .. data:: match_avail_ident_protocol = 7

    	match avail ident protocol

    .. data:: match_avail_ident_source_address_ipv4 = 8

    	match avail ident source address ipv4

    .. data:: match_avail_ident_source_address_ipv6 = 9

    	match avail ident source address ipv6

    .. data:: match_avail_ident_source_address_mac = 10

    	match avail ident source address mac

    .. data:: match_avail_ident_tunnel_name = 11

    	match avail ident tunnel name

    .. data:: match_avail_ident_user_name = 12

    	match avail ident user name

    .. data:: match_avail_ident_vendor_id = 13

    	match avail ident vendor id

    .. data:: match_avail_ident_dhcp_client_id = 14

    	match avail ident dhcp client id

    .. data:: match_avail_ident_max = 15

    	match avail ident max

    """

    match_avail_ident_unspecified = Enum.YLeaf(0, "match-avail-ident-unspecified")

    match_avail_ident_dnis = Enum.YLeaf(1, "match-avail-ident-dnis")

    match_avail_ident_domain = Enum.YLeaf(2, "match-avail-ident-domain")

    match_avail_ident_circuit_id = Enum.YLeaf(3, "match-avail-ident-circuit-id")

    match_avail_ident_remote_id = Enum.YLeaf(4, "match-avail-ident-remote-id")

    match_avail_ident_media = Enum.YLeaf(5, "match-avail-ident-media")

    match_avail_ident_nas_port = Enum.YLeaf(6, "match-avail-ident-nas-port")

    match_avail_ident_protocol = Enum.YLeaf(7, "match-avail-ident-protocol")

    match_avail_ident_source_address_ipv4 = Enum.YLeaf(8, "match-avail-ident-source-address-ipv4")

    match_avail_ident_source_address_ipv6 = Enum.YLeaf(9, "match-avail-ident-source-address-ipv6")

    match_avail_ident_source_address_mac = Enum.YLeaf(10, "match-avail-ident-source-address-mac")

    match_avail_ident_tunnel_name = Enum.YLeaf(11, "match-avail-ident-tunnel-name")

    match_avail_ident_user_name = Enum.YLeaf(12, "match-avail-ident-user-name")

    match_avail_ident_vendor_id = Enum.YLeaf(13, "match-avail-ident-vendor-id")

    match_avail_ident_dhcp_client_id = Enum.YLeaf(14, "match-avail-ident-dhcp-client-id")

    match_avail_ident_max = Enum.YLeaf(15, "match-avail-ident-max")


class MatchLogicalOperatorEn(Enum):
    """
    MatchLogicalOperatorEn

    Logical Operators

    .. data:: match_operator_unspecified = 0

    	match operator unspecified

    .. data:: match_equal_to = 1

    	match equal to

    .. data:: match_greater_than = 2

    	match greater than

    .. data:: match_greater_than_or_equal = 3

    	match greater than or equal

    .. data:: match_less_than = 4

    	match less than

    .. data:: match_less_than_or_equal = 5

    	match less than or equal

    .. data:: match_operator_max = 6

    	match operator max

    """

    match_operator_unspecified = Enum.YLeaf(0, "match-operator-unspecified")

    match_equal_to = Enum.YLeaf(1, "match-equal-to")

    match_greater_than = Enum.YLeaf(2, "match-greater-than")

    match_greater_than_or_equal = Enum.YLeaf(3, "match-greater-than-or-equal")

    match_less_than = Enum.YLeaf(4, "match-less-than")

    match_less_than_or_equal = Enum.YLeaf(5, "match-less-than-or-equal")

    match_operator_max = Enum.YLeaf(6, "match-operator-max")


class MatchMediaTypeEn(Enum):
    """
    MatchMediaTypeEn

    Match media type en

    .. data:: match_media_type_unspecified = 0

    	match media type unspecified

    .. data:: match_media_type_async = 1

    	match media type async

    .. data:: match_media_type_atm = 2

    	match media type atm

    .. data:: match_media_type_ether = 3

    	match media type ether

    .. data:: match_media_type_ip = 4

    	match media type ip

    .. data:: match_media_type_isdn = 5

    	match media type isdn

    .. data:: match_media_type_mpls = 6

    	match media type mpls

    .. data:: match_media_type_sync = 7

    	match media type sync

    .. data:: match_media_type_max = 8

    	match media type max

    """

    match_media_type_unspecified = Enum.YLeaf(0, "match-media-type-unspecified")

    match_media_type_async = Enum.YLeaf(1, "match-media-type-async")

    match_media_type_atm = Enum.YLeaf(2, "match-media-type-atm")

    match_media_type_ether = Enum.YLeaf(3, "match-media-type-ether")

    match_media_type_ip = Enum.YLeaf(4, "match-media-type-ip")

    match_media_type_isdn = Enum.YLeaf(5, "match-media-type-isdn")

    match_media_type_mpls = Enum.YLeaf(6, "match-media-type-mpls")

    match_media_type_sync = Enum.YLeaf(7, "match-media-type-sync")

    match_media_type_max = Enum.YLeaf(8, "match-media-type-max")


class MatchMlpNegotiatedEn(Enum):
    """
    MatchMlpNegotiatedEn

    Match mlp negotiated en

    .. data:: match_mlp_negotiated_unspecified = 0

    	match mlp negotiated unspecified

    .. data:: match_mlp_negotiated = 1

    	match mlp negotiated

    .. data:: match_mlp_not_negotiated = 2

    	match mlp not negotiated

    .. data:: match_mlp_max = 3

    	match mlp max

    """

    match_mlp_negotiated_unspecified = Enum.YLeaf(0, "match-mlp-negotiated-unspecified")

    match_mlp_negotiated = Enum.YLeaf(1, "match-mlp-negotiated")

    match_mlp_not_negotiated = Enum.YLeaf(2, "match-mlp-not-negotiated")

    match_mlp_max = Enum.YLeaf(3, "match-mlp-max")


class MatchNasPortIntfTypeEn(Enum):
    """
    MatchNasPortIntfTypeEn

    Match nas port intf type en

    .. data:: match_nas_port_intf_type_unspecified = 0

    	match nas port intf type unspecified

    .. data:: match_nas_port_intf_type_async = 1

    	match nas port intf type async

    .. data:: match_nas_port_intf_type_atm = 2

    	match nas port intf type atm

    .. data:: match_nas_port_intf_type_bri = 3

    	match nas port intf type bri

    .. data:: match_nas_port_intf_type_ether = 4

    	match nas port intf type ether

    .. data:: match_nas_port_intf_type_ipsec = 5

    	match nas port intf type ipsec

    .. data:: match_nas_port_intf_type_none = 6

    	match nas port intf type none

    .. data:: match_nas_port_intf_type_piafs = 7

    	match nas port intf type piafs

    .. data:: match_nas_port_intf_type_pppatm = 8

    	match nas port intf type pppatm

    .. data:: match_nas_port_intf_type_ppp_ether = 9

    	match nas port intf type ppp ether

    .. data:: match_nas_port_intf_type_pppoeatm = 10

    	match nas port intf type pppoeatm

    .. data:: match_nas_port_intf_type_pppqinq = 11

    	match nas port intf type pppqinq

    .. data:: match_nas_port_intf_type_pppvlan = 12

    	match nas port intf type pppvlan

    .. data:: match_nas_port_intf_type_pri = 13

    	match nas port intf type pri

    .. data:: match_nas_port_intf_type_sync = 14

    	match nas port intf type sync

    .. data:: match_nas_port_intf_type_v110 = 15

    	match nas port intf type v110

    .. data:: match_nas_port_intf_type_v120 = 16

    	match nas port intf type v120

    .. data:: match_nas_port_intf_type_vty = 17

    	match nas port intf type vty

    .. data:: match_nas_port_intf_type_x75 = 18

    	match nas port intf type x75

    .. data:: match_nas_port_intf_type_max = 19

    	match nas port intf type max

    """

    match_nas_port_intf_type_unspecified = Enum.YLeaf(0, "match-nas-port-intf-type-unspecified")

    match_nas_port_intf_type_async = Enum.YLeaf(1, "match-nas-port-intf-type-async")

    match_nas_port_intf_type_atm = Enum.YLeaf(2, "match-nas-port-intf-type-atm")

    match_nas_port_intf_type_bri = Enum.YLeaf(3, "match-nas-port-intf-type-bri")

    match_nas_port_intf_type_ether = Enum.YLeaf(4, "match-nas-port-intf-type-ether")

    match_nas_port_intf_type_ipsec = Enum.YLeaf(5, "match-nas-port-intf-type-ipsec")

    match_nas_port_intf_type_none = Enum.YLeaf(6, "match-nas-port-intf-type-none")

    match_nas_port_intf_type_piafs = Enum.YLeaf(7, "match-nas-port-intf-type-piafs")

    match_nas_port_intf_type_pppatm = Enum.YLeaf(8, "match-nas-port-intf-type-pppatm")

    match_nas_port_intf_type_ppp_ether = Enum.YLeaf(9, "match-nas-port-intf-type-ppp-ether")

    match_nas_port_intf_type_pppoeatm = Enum.YLeaf(10, "match-nas-port-intf-type-pppoeatm")

    match_nas_port_intf_type_pppqinq = Enum.YLeaf(11, "match-nas-port-intf-type-pppqinq")

    match_nas_port_intf_type_pppvlan = Enum.YLeaf(12, "match-nas-port-intf-type-pppvlan")

    match_nas_port_intf_type_pri = Enum.YLeaf(13, "match-nas-port-intf-type-pri")

    match_nas_port_intf_type_sync = Enum.YLeaf(14, "match-nas-port-intf-type-sync")

    match_nas_port_intf_type_v110 = Enum.YLeaf(15, "match-nas-port-intf-type-v110")

    match_nas_port_intf_type_v120 = Enum.YLeaf(16, "match-nas-port-intf-type-v120")

    match_nas_port_intf_type_vty = Enum.YLeaf(17, "match-nas-port-intf-type-vty")

    match_nas_port_intf_type_x75 = Enum.YLeaf(18, "match-nas-port-intf-type-x75")

    match_nas_port_intf_type_max = Enum.YLeaf(19, "match-nas-port-intf-type-max")


class MatchNasPortSubIdEn(Enum):
    """
    MatchNasPortSubIdEn

    Match nas port sub id en

    .. data:: match_nas_port_sub_id_unspecified = 0

    	match nas port sub id unspecified

    .. data:: match_nas_port_sub_id_adapter = 1

    	match nas port sub id adapter

    .. data:: match_nas_port_sub_id_channel = 2

    	match nas port sub id channel

    .. data:: match_nas_port_sub_id_ip_addr = 3

    	match nas port sub id ip addr

    .. data:: match_nas_port_sub_id_port = 4

    	match nas port sub id port

    .. data:: match_nas_port_sub_id_shelf = 5

    	match nas port sub id shelf

    .. data:: match_nas_port_sub_id_slot = 6

    	match nas port sub id slot

    .. data:: match_nas_port_sub_id_sub_interface = 7

    	match nas port sub id sub interface

    .. data:: match_nas_port_sub_id_type = 8

    	match nas port sub id type

    .. data:: match_nas_port_sub_id_vci = 9

    	match nas port sub id vci

    .. data:: match_nas_port_sub_id_vlan = 10

    	match nas port sub id vlan

    .. data:: match_nas_port_sub_id_vpi = 11

    	match nas port sub id vpi

    .. data:: match_nas_port_sub_id_max = 12

    	match nas port sub id max

    """

    match_nas_port_sub_id_unspecified = Enum.YLeaf(0, "match-nas-port-sub-id-unspecified")

    match_nas_port_sub_id_adapter = Enum.YLeaf(1, "match-nas-port-sub-id-adapter")

    match_nas_port_sub_id_channel = Enum.YLeaf(2, "match-nas-port-sub-id-channel")

    match_nas_port_sub_id_ip_addr = Enum.YLeaf(3, "match-nas-port-sub-id-ip-addr")

    match_nas_port_sub_id_port = Enum.YLeaf(4, "match-nas-port-sub-id-port")

    match_nas_port_sub_id_shelf = Enum.YLeaf(5, "match-nas-port-sub-id-shelf")

    match_nas_port_sub_id_slot = Enum.YLeaf(6, "match-nas-port-sub-id-slot")

    match_nas_port_sub_id_sub_interface = Enum.YLeaf(7, "match-nas-port-sub-id-sub-interface")

    match_nas_port_sub_id_type = Enum.YLeaf(8, "match-nas-port-sub-id-type")

    match_nas_port_sub_id_vci = Enum.YLeaf(9, "match-nas-port-sub-id-vci")

    match_nas_port_sub_id_vlan = Enum.YLeaf(10, "match-nas-port-sub-id-vlan")

    match_nas_port_sub_id_vpi = Enum.YLeaf(11, "match-nas-port-sub-id-vpi")

    match_nas_port_sub_id_max = Enum.YLeaf(12, "match-nas-port-sub-id-max")


class MatchNoUsernameEn(Enum):
    """
    MatchNoUsernameEn

    Match no username en

    .. data:: match_no_user_name_unspecified = 0

    	match no user name unspecified

    .. data:: match_no_user_name = 1

    	match no user name

    .. data:: match_user_name = 2

    	match user name

    .. data:: match_no_user_name_max = 3

    	match no user name max

    """

    match_no_user_name_unspecified = Enum.YLeaf(0, "match-no-user-name-unspecified")

    match_no_user_name = Enum.YLeaf(1, "match-no-user-name")

    match_user_name = Enum.YLeaf(2, "match-user-name")

    match_no_user_name_max = Enum.YLeaf(3, "match-no-user-name-max")


class MatchSubsProtocolEn(Enum):
    """
    MatchSubsProtocolEn

    Match subs protocol en

    .. data:: match_subs_protocol_unspecified = 0

    	match subs protocol unspecified

    .. data:: match_subs_protocol_ipv4 = 1

    	match subs protocol ipv4

    .. data:: match_subs_protocol_ppp = 2

    	match subs protocol ppp

    .. data:: match_subs_protocol_dhcpv4 = 3

    	match subs protocol dhcpv4

    .. data:: match_subs_protocol_dhcpv6 = 4

    	match subs protocol dhcpv6

    .. data:: match_subs_protocol_max = 5

    	match subs protocol max

    """

    match_subs_protocol_unspecified = Enum.YLeaf(0, "match-subs-protocol-unspecified")

    match_subs_protocol_ipv4 = Enum.YLeaf(1, "match-subs-protocol-ipv4")

    match_subs_protocol_ppp = Enum.YLeaf(2, "match-subs-protocol-ppp")

    match_subs_protocol_dhcpv4 = Enum.YLeaf(3, "match-subs-protocol-dhcpv4")

    match_subs_protocol_dhcpv6 = Enum.YLeaf(4, "match-subs-protocol-dhcpv6")

    match_subs_protocol_max = Enum.YLeaf(5, "match-subs-protocol-max")


class MatchTypeEn(Enum):
    """
    MatchTypeEn

    Match Type

    .. data:: match_type_none = 0

    	Match Type None

    .. data:: match_type_ipv4_dscp = 1

    	Match Type IPv4 DSCP

    .. data:: match_type_ipv4_prec = 2

    	Match Type IPv4 Precedence

    .. data:: match_type_ipv6_dscp = 3

    	Match Type IPv6 DSCP

    .. data:: match_type_packet_length = 4

    	Match Type Packet length

    .. data:: match_type_ipv4_packet_length = 5

    	Match Type IPv4 Packet length

    .. data:: match_type_ipv6_packet_length = 6

    	Match Type IPv6 Packet length

    .. data:: match_type_flow_tag = 7

    	Match Type Flow Tag

    .. data:: match_type_icmpv4_type = 8

    	Match Type IPv4 icmp-type

    .. data:: match_type_icmpv4_code = 9

    	Match Type IPv4 icmp-code

    .. data:: match_type_icmpv6_type = 10

    	Match Type IPv6 icmp-type

    .. data:: match_type_icmpv6_code = 11

    	Match Type IPv6 icmp-code

    .. data:: match_type_ipv6_prec = 12

    	Match Type IPv6 Precedence

    .. data:: match_type_fragment_type = 13

    	Match type fragment-type

    .. data:: match_type_tcp_flag = 14

    	Match type TCP flag

    .. data:: match_type_dscp = 15

    	Match Type DSCP

    .. data:: match_type_prec = 16

    	Match Type Precedence

    .. data:: match_type_proto = 17

    	Match Type Protocol

    .. data:: match_type_proto_icmpv4 = 18

    	Match Type protocol ICMPv4

    .. data:: match_type_proto_icmpv6 = 19

    	Match Type protocol ICMPv6

    .. data:: match_type_mpls_exp_top = 20

    	Match Type MPLS EXP Topmost

    .. data:: match_type_mpls_exp_imp = 21

    	Match Type MPLS EXP Imposition

    .. data:: match_type_mpls_disp_ipv4_acl = 22

    	Match Type MPLS DISP IPv4 ACL

    .. data:: match_type_mpls_disp_ipv6_acl = 23

    	Match Type MPLS DISP IPv6 ACL

    .. data:: match_type_mpls_topmost_eos = 24

    	Match Type MPLS TOPMOST EOS

    .. data:: match_type_mpls_topmost_label = 25

    	Match Type MPLS TOPMOST LABEL

    .. data:: match_type_cos = 26

    	Match Type COS

    .. data:: match_type_cos_inner = 27

    	Match Type inner COS

    .. data:: match_type_dei = 28

    	Match Type DEI

    .. data:: match_type_dei_inner = 29

    	Match Type inner DEI

    .. data:: match_type_vlan = 30

    	Match Type VLAN

    .. data:: match_type_vlan_inner = 31

    	Match Type inner VLAN

    .. data:: match_type_fr_dlci = 32

    	Match Type  FR DLCI

    .. data:: match_type_src_mac = 33

    	Match Type Source MAC Address

    .. data:: match_type_dst_mac = 34

    	Match Type Destination MAC Address

    .. data:: match_type_atm_oam = 35

    	Match Type ATM OAM

    .. data:: match_type_atm_clp = 36

    	Match Type ATM CLP

    .. data:: match_type_fr_de = 37

    	Match Type FR DE

    .. data:: match_type_qos_grp = 38

    	Match Type QoS Group

    .. data:: match_type_traffic_class = 39

    	Match Type Traffic Class

    .. data:: match_type_disc_cls = 40

    	Match Type Discard Class

    .. data:: match_type_vpls_known = 41

    	Match Type VPLS Known

    .. data:: match_type_vpls_unknown = 42

    	Match Type VPLS Unknown

    .. data:: match_type_vpls_mcast = 43

    	Match Type VPLS Multicast

    .. data:: match_type_vpls_bcast = 44

    	Match Type VPLS Broadcast

    .. data:: match_type_vpls_control = 45

    	Match Type VPLS Control

    .. data:: match_type_ipv4_acl = 46

    	Match Type IPv4 ACL

    .. data:: match_type_ipv6_acl = 47

    	Match Type IPv6 ACL

    .. data:: match_type_flow_key = 48

    	Match Type Flow Key

    .. data:: match_type_avail_id = 49

    	Match Type Available Identifier

    .. data:: match_type_authen_status = 50

    	Match Type Authentication Status

    .. data:: match_type_media = 51

    	Match Type Media

    .. data:: match_type_mlp_negotiated = 52

    	Match Type MLP Negotiated

    .. data:: match_type_subs_protocol = 53

    	Match Type Protocol

    .. data:: match_type_dnis = 54

    	Match Type DNIS

    .. data:: match_type_dnis_regexp = 55

    	Match Type DNIS Regular Exp

    .. data:: match_type_domain = 56

    	Match Type Domain

    .. data:: match_type_domain_regexp = 57

    	Match Type Domain Regular Exp

    .. data:: match_type_nas_port = 58

    	Match Type NAS Port

    .. data:: match_type_service_name = 59

    	Match Type Service Name

    .. data:: match_type_service_name_regexp = 60

    	Match Type Service Name Regular Exp

    .. data:: match_type_src_addr_ipv4 = 61

    	Match Type Source Address IPV4

    .. data:: match_type_dst_addr_ipv4 = 62

    	Match Type Source Address IPV4

    .. data:: match_type_src_addr_ipv6 = 63

    	Match Type Source Address IPV6

    .. data:: match_type_dst_addr_ipv6 = 64

    	Match Type Source Address IPV6

    .. data:: match_type_src_addr_mac = 65

    	Match Type Source Address Mac

    .. data:: match_type_src_port = 66

    	Match Type Source Port

    .. data:: match_type_dst_port = 67

    	Match Type Source Port

    .. data:: match_type_timer = 68

    	Match Type Timer

    .. data:: match_type_timer_regexp = 69

    	Match Type Timer Regular Exp

    .. data:: match_type_tunnel_name = 70

    	Match Type Tunnel Name

    .. data:: match_type_tunnel_name_regexp = 71

    	Match Type Tunnel Name Regular Exp

    .. data:: match_type_user_name = 72

    	Match Type User Name

    .. data:: match_type_user_name_regexp = 73

    	Match Type User Name Regular Exp

    .. data:: match_type_auth_user_name = 74

    	Match Type Authenticated User Name

    .. data:: match_type_auth_user_name_regexp = 75

    	Match Type Authenticated Userame Reg Exp

    .. data:: match_type_unauth_user_name = 76

    	Match Type Unauthenticated Username

    .. data:: match_type_unauth_user_name_regexp = 77

    	Match Type Unauthenicated Username RegEx

    .. data:: match_type_no_user_name = 78

    	Match Type No Username

    .. data:: match_type_auth_domain = 79

    	Match Type Authenticated Domain

    .. data:: match_type_auth_domain_regexp = 80

    	Match Type Authenticated Domain RegEx

    .. data:: match_type_unauth_domain = 81

    	Match Type Unauthenticated Domain

    .. data:: match_type_unauth_domain_regexp = 82

    	Match Type Unauthenticated Domain RegEx

    .. data:: match_type_vendor_id = 83

    	Match Type Vendor ID

    .. data:: match_type_vendor_id_regexp = 84

    	Match Type Vendor ID RegEx

    .. data:: match_type_access_interface = 85

    	Match Type Access Interface

    .. data:: match_type_input_interface = 86

    	Match Type Input Interface

    .. data:: match_type_input_interface_hdl = 87

    	Match Type Input Interface handle

    .. data:: match_type_ether_type = 88

    	Match Type Ethernet Type

    .. data:: match_type_dhcp_client_id = 89

    	Match DHCP Client ID

    .. data:: match_type_dhcp_client_id_regexp = 90

    	Match DHCP Client ID RegEx

    .. data:: match_type_circuit_id = 91

    	Match Type Circuit ID

    .. data:: match_type_circuit_id_regexp = 92

    	Match Type Circuit ID RegEx

    .. data:: match_type_remote_id = 93

    	Match Type Remote ID

    .. data:: match_type_remote_id_regexp = 94

    	Match Type Remote ID RegEx

    .. data:: match_type_cac_admit_local = 95

    	Match Type CAC admitted

    .. data:: match_type_cac_unadmit_local = 96

    	Match Type CAC unadmitted

    .. data:: match_type_any_internal = 97

    	Match Type Any (Used only for class-default)

    .. data:: match_type_ethernet_service_s_acl = 98

    	Match Type Ethernet-Services ACL

    .. data:: match_type_ptrs = 99

    	Dummy match type for internal use

    .. data:: match_type_max = 100

    	Match Type Max (Invalid)

    """

    match_type_none = Enum.YLeaf(0, "match-type-none")

    match_type_ipv4_dscp = Enum.YLeaf(1, "match-type-ipv4-dscp")

    match_type_ipv4_prec = Enum.YLeaf(2, "match-type-ipv4-prec")

    match_type_ipv6_dscp = Enum.YLeaf(3, "match-type-ipv6-dscp")

    match_type_packet_length = Enum.YLeaf(4, "match-type-packet-length")

    match_type_ipv4_packet_length = Enum.YLeaf(5, "match-type-ipv4-packet-length")

    match_type_ipv6_packet_length = Enum.YLeaf(6, "match-type-ipv6-packet-length")

    match_type_flow_tag = Enum.YLeaf(7, "match-type-flow-tag")

    match_type_icmpv4_type = Enum.YLeaf(8, "match-type-icmpv4-type")

    match_type_icmpv4_code = Enum.YLeaf(9, "match-type-icmpv4-code")

    match_type_icmpv6_type = Enum.YLeaf(10, "match-type-icmpv6-type")

    match_type_icmpv6_code = Enum.YLeaf(11, "match-type-icmpv6-code")

    match_type_ipv6_prec = Enum.YLeaf(12, "match-type-ipv6-prec")

    match_type_fragment_type = Enum.YLeaf(13, "match-type-fragment-type")

    match_type_tcp_flag = Enum.YLeaf(14, "match-type-tcp-flag")

    match_type_dscp = Enum.YLeaf(15, "match-type-dscp")

    match_type_prec = Enum.YLeaf(16, "match-type-prec")

    match_type_proto = Enum.YLeaf(17, "match-type-proto")

    match_type_proto_icmpv4 = Enum.YLeaf(18, "match-type-proto-icmpv4")

    match_type_proto_icmpv6 = Enum.YLeaf(19, "match-type-proto-icmpv6")

    match_type_mpls_exp_top = Enum.YLeaf(20, "match-type-mpls-exp-top")

    match_type_mpls_exp_imp = Enum.YLeaf(21, "match-type-mpls-exp-imp")

    match_type_mpls_disp_ipv4_acl = Enum.YLeaf(22, "match-type-mpls-disp-ipv4-acl")

    match_type_mpls_disp_ipv6_acl = Enum.YLeaf(23, "match-type-mpls-disp-ipv6-acl")

    match_type_mpls_topmost_eos = Enum.YLeaf(24, "match-type-mpls-topmost-eos")

    match_type_mpls_topmost_label = Enum.YLeaf(25, "match-type-mpls-topmost-label")

    match_type_cos = Enum.YLeaf(26, "match-type-cos")

    match_type_cos_inner = Enum.YLeaf(27, "match-type-cos-inner")

    match_type_dei = Enum.YLeaf(28, "match-type-dei")

    match_type_dei_inner = Enum.YLeaf(29, "match-type-dei-inner")

    match_type_vlan = Enum.YLeaf(30, "match-type-vlan")

    match_type_vlan_inner = Enum.YLeaf(31, "match-type-vlan-inner")

    match_type_fr_dlci = Enum.YLeaf(32, "match-type-fr-dlci")

    match_type_src_mac = Enum.YLeaf(33, "match-type-src-mac")

    match_type_dst_mac = Enum.YLeaf(34, "match-type-dst-mac")

    match_type_atm_oam = Enum.YLeaf(35, "match-type-atm-oam")

    match_type_atm_clp = Enum.YLeaf(36, "match-type-atm-clp")

    match_type_fr_de = Enum.YLeaf(37, "match-type-fr-de")

    match_type_qos_grp = Enum.YLeaf(38, "match-type-qos-grp")

    match_type_traffic_class = Enum.YLeaf(39, "match-type-traffic-class")

    match_type_disc_cls = Enum.YLeaf(40, "match-type-disc-cls")

    match_type_vpls_known = Enum.YLeaf(41, "match-type-vpls-known")

    match_type_vpls_unknown = Enum.YLeaf(42, "match-type-vpls-unknown")

    match_type_vpls_mcast = Enum.YLeaf(43, "match-type-vpls-mcast")

    match_type_vpls_bcast = Enum.YLeaf(44, "match-type-vpls-bcast")

    match_type_vpls_control = Enum.YLeaf(45, "match-type-vpls-control")

    match_type_ipv4_acl = Enum.YLeaf(46, "match-type-ipv4-acl")

    match_type_ipv6_acl = Enum.YLeaf(47, "match-type-ipv6-acl")

    match_type_flow_key = Enum.YLeaf(48, "match-type-flow-key")

    match_type_avail_id = Enum.YLeaf(49, "match-type-avail-id")

    match_type_authen_status = Enum.YLeaf(50, "match-type-authen-status")

    match_type_media = Enum.YLeaf(51, "match-type-media")

    match_type_mlp_negotiated = Enum.YLeaf(52, "match-type-mlp-negotiated")

    match_type_subs_protocol = Enum.YLeaf(53, "match-type-subs-protocol")

    match_type_dnis = Enum.YLeaf(54, "match-type-dnis")

    match_type_dnis_regexp = Enum.YLeaf(55, "match-type-dnis-regexp")

    match_type_domain = Enum.YLeaf(56, "match-type-domain")

    match_type_domain_regexp = Enum.YLeaf(57, "match-type-domain-regexp")

    match_type_nas_port = Enum.YLeaf(58, "match-type-nas-port")

    match_type_service_name = Enum.YLeaf(59, "match-type-service-name")

    match_type_service_name_regexp = Enum.YLeaf(60, "match-type-service-name-regexp")

    match_type_src_addr_ipv4 = Enum.YLeaf(61, "match-type-src-addr-ipv4")

    match_type_dst_addr_ipv4 = Enum.YLeaf(62, "match-type-dst-addr-ipv4")

    match_type_src_addr_ipv6 = Enum.YLeaf(63, "match-type-src-addr-ipv6")

    match_type_dst_addr_ipv6 = Enum.YLeaf(64, "match-type-dst-addr-ipv6")

    match_type_src_addr_mac = Enum.YLeaf(65, "match-type-src-addr-mac")

    match_type_src_port = Enum.YLeaf(66, "match-type-src-port")

    match_type_dst_port = Enum.YLeaf(67, "match-type-dst-port")

    match_type_timer = Enum.YLeaf(68, "match-type-timer")

    match_type_timer_regexp = Enum.YLeaf(69, "match-type-timer-regexp")

    match_type_tunnel_name = Enum.YLeaf(70, "match-type-tunnel-name")

    match_type_tunnel_name_regexp = Enum.YLeaf(71, "match-type-tunnel-name-regexp")

    match_type_user_name = Enum.YLeaf(72, "match-type-user-name")

    match_type_user_name_regexp = Enum.YLeaf(73, "match-type-user-name-regexp")

    match_type_auth_user_name = Enum.YLeaf(74, "match-type-auth-user-name")

    match_type_auth_user_name_regexp = Enum.YLeaf(75, "match-type-auth-user-name-regexp")

    match_type_unauth_user_name = Enum.YLeaf(76, "match-type-unauth-user-name")

    match_type_unauth_user_name_regexp = Enum.YLeaf(77, "match-type-unauth-user-name-regexp")

    match_type_no_user_name = Enum.YLeaf(78, "match-type-no-user-name")

    match_type_auth_domain = Enum.YLeaf(79, "match-type-auth-domain")

    match_type_auth_domain_regexp = Enum.YLeaf(80, "match-type-auth-domain-regexp")

    match_type_unauth_domain = Enum.YLeaf(81, "match-type-unauth-domain")

    match_type_unauth_domain_regexp = Enum.YLeaf(82, "match-type-unauth-domain-regexp")

    match_type_vendor_id = Enum.YLeaf(83, "match-type-vendor-id")

    match_type_vendor_id_regexp = Enum.YLeaf(84, "match-type-vendor-id-regexp")

    match_type_access_interface = Enum.YLeaf(85, "match-type-access-interface")

    match_type_input_interface = Enum.YLeaf(86, "match-type-input-interface")

    match_type_input_interface_hdl = Enum.YLeaf(87, "match-type-input-interface-hdl")

    match_type_ether_type = Enum.YLeaf(88, "match-type-ether-type")

    match_type_dhcp_client_id = Enum.YLeaf(89, "match-type-dhcp-client-id")

    match_type_dhcp_client_id_regexp = Enum.YLeaf(90, "match-type-dhcp-client-id-regexp")

    match_type_circuit_id = Enum.YLeaf(91, "match-type-circuit-id")

    match_type_circuit_id_regexp = Enum.YLeaf(92, "match-type-circuit-id-regexp")

    match_type_remote_id = Enum.YLeaf(93, "match-type-remote-id")

    match_type_remote_id_regexp = Enum.YLeaf(94, "match-type-remote-id-regexp")

    match_type_cac_admit_local = Enum.YLeaf(95, "match-type-cac-admit-local")

    match_type_cac_unadmit_local = Enum.YLeaf(96, "match-type-cac-unadmit-local")

    match_type_any_internal = Enum.YLeaf(97, "match-type-any-internal")

    match_type_ethernet_service_s_acl = Enum.YLeaf(98, "match-type-ethernet-service-s-acl")

    match_type_ptrs = Enum.YLeaf(99, "match-type-ptrs")

    match_type_max = Enum.YLeaf(100, "match-type-max")


class PclassExecStratEn(Enum):
    """
    PclassExecStratEn

    Policy class execution strategy

    .. data:: pclass_exe_strat_unspecified = 0

    	Unspecified

    .. data:: pclass_exe_strat_do_all = 1

    	Exec all actions

    .. data:: pclass_exe_strat_do_until_success = 2

    	Exec until one of actions succeeds

    .. data:: pclass_exe_strat_do_until_failure = 3

    	Exec until there is a failure

    .. data:: pclass_exe_strat_max = 4

    	Invalid

    """

    pclass_exe_strat_unspecified = Enum.YLeaf(0, "pclass-exe-strat-unspecified")

    pclass_exe_strat_do_all = Enum.YLeaf(1, "pclass-exe-strat-do-all")

    pclass_exe_strat_do_until_success = Enum.YLeaf(2, "pclass-exe-strat-do-until-success")

    pclass_exe_strat_do_until_failure = Enum.YLeaf(3, "pclass-exe-strat-do-until-failure")

    pclass_exe_strat_max = Enum.YLeaf(4, "pclass-exe-strat-max")


class PeventCondEvalEn(Enum):
    """
    PeventCondEvalEn

    Policy event execution strategy enumeration

    .. data:: pevent_cond_eval_unspecified = 0

    	Unspecified execution strategy

    .. data:: pevent_cond_eval_match_first = 1

    	Match-first execution strategy

    .. data:: pevent_cond_eval_match_all = 2

    	Match-all execution strategy

    .. data:: pevent_cond_eval_max = 3

    	Internal use only

    """

    pevent_cond_eval_unspecified = Enum.YLeaf(0, "pevent-cond-eval-unspecified")

    pevent_cond_eval_match_first = Enum.YLeaf(1, "pevent-cond-eval-match-first")

    pevent_cond_eval_match_all = Enum.YLeaf(2, "pevent-cond-eval-match-all")

    pevent_cond_eval_max = Enum.YLeaf(3, "pevent-cond-eval-max")


class PeventTypeEn(Enum):
    """
    PeventTypeEn

    Policy event enumeration

    .. data:: pevent_type_unspecified = 0

    	Unspecified event

    .. data:: pevent_type_acct_logon = 1

    	Log on event

    .. data:: pevent_type_acct_logoff = 2

    	Log off event

    .. data:: pevent_type_credit_exhausted = 3

    	Credit exhausted event

    .. data:: pevent_type_idle_timeout = 4

    	Idle timeout event

    .. data:: pevent_type_absolute_timeout = 5

    	Absolute timeout event

    .. data:: pevent_type_quota_depleted = 6

    	Quota depletion event

    .. data:: pevent_type_service_start = 7

    	Service start event

    .. data:: pevent_type_service_stop = 8

    	Service stop event

    .. data:: pevent_type_session_start = 9

    	Session start event

    .. data:: pevent_type_session_activate = 10

    	Session activate event

    .. data:: pevent_type_session_restart = 11

    	Session restart event

    .. data:: pevent_type_session_stop = 12

    	Session stop event

    .. data:: pevent_type_session_disconnect = 13

    	Session disconnect event

    .. data:: pevent_type_session_update = 14

    	Session update event

    .. data:: pevent_type_flow_start = 15

    	Flow start event

    .. data:: pevent_type_flow_stop = 16

    	Flow stop event

    .. data:: pevent_type_accouting_start = 17

    	Accounting start event

    .. data:: pevent_type_acountng_g_stop = 18

    	Accounting stop event

    .. data:: pevent_type_acountng_g_update = 19

    	Accounting update event

    .. data:: pevent_type_timer_expiry = 20

    	Timer expierd event

    .. data:: pevent_type_threshold_reached = 21

    	Threshold reached event

    .. data:: pevent_type_ka_success = 22

    	Keep alive success event

    .. data:: pevent_type_ka_failure = 23

    	Keep alive failure event

    .. data:: pevent_type_link_up = 24

    	Link up event

    .. data:: pevent_type_link_down = 25

    	Link down event

    .. data:: pevent_type_authorization_failure = 26

    	Authorization failure event

    .. data:: pevent_type_authorization_no_response = 27

    	Authorization no response event

    .. data:: pevent_type_authentication_failure = 28

    	Authentication failure event

    .. data:: pevent_type_authentication_no_response = 29

    	Authentication no response event

    .. data:: pevent_type_exception = 30

    	Exception event

    .. data:: pevent_type_session_ident_chg = 31

    	Session identity change event

    .. data:: pevent_type_max = 32

    	Internal use only

    """

    pevent_type_unspecified = Enum.YLeaf(0, "pevent-type-unspecified")

    pevent_type_acct_logon = Enum.YLeaf(1, "pevent-type-acct-logon")

    pevent_type_acct_logoff = Enum.YLeaf(2, "pevent-type-acct-logoff")

    pevent_type_credit_exhausted = Enum.YLeaf(3, "pevent-type-credit-exhausted")

    pevent_type_idle_timeout = Enum.YLeaf(4, "pevent-type-idle-timeout")

    pevent_type_absolute_timeout = Enum.YLeaf(5, "pevent-type-absolute-timeout")

    pevent_type_quota_depleted = Enum.YLeaf(6, "pevent-type-quota-depleted")

    pevent_type_service_start = Enum.YLeaf(7, "pevent-type-service-start")

    pevent_type_service_stop = Enum.YLeaf(8, "pevent-type-service-stop")

    pevent_type_session_start = Enum.YLeaf(9, "pevent-type-session-start")

    pevent_type_session_activate = Enum.YLeaf(10, "pevent-type-session-activate")

    pevent_type_session_restart = Enum.YLeaf(11, "pevent-type-session-restart")

    pevent_type_session_stop = Enum.YLeaf(12, "pevent-type-session-stop")

    pevent_type_session_disconnect = Enum.YLeaf(13, "pevent-type-session-disconnect")

    pevent_type_session_update = Enum.YLeaf(14, "pevent-type-session-update")

    pevent_type_flow_start = Enum.YLeaf(15, "pevent-type-flow-start")

    pevent_type_flow_stop = Enum.YLeaf(16, "pevent-type-flow-stop")

    pevent_type_accouting_start = Enum.YLeaf(17, "pevent-type-accouting-start")

    pevent_type_acountng_g_stop = Enum.YLeaf(18, "pevent-type-acountng-g-stop")

    pevent_type_acountng_g_update = Enum.YLeaf(19, "pevent-type-acountng-g-update")

    pevent_type_timer_expiry = Enum.YLeaf(20, "pevent-type-timer-expiry")

    pevent_type_threshold_reached = Enum.YLeaf(21, "pevent-type-threshold-reached")

    pevent_type_ka_success = Enum.YLeaf(22, "pevent-type-ka-success")

    pevent_type_ka_failure = Enum.YLeaf(23, "pevent-type-ka-failure")

    pevent_type_link_up = Enum.YLeaf(24, "pevent-type-link-up")

    pevent_type_link_down = Enum.YLeaf(25, "pevent-type-link-down")

    pevent_type_authorization_failure = Enum.YLeaf(26, "pevent-type-authorization-failure")

    pevent_type_authorization_no_response = Enum.YLeaf(27, "pevent-type-authorization-no-response")

    pevent_type_authentication_failure = Enum.YLeaf(28, "pevent-type-authentication-failure")

    pevent_type_authentication_no_response = Enum.YLeaf(29, "pevent-type-authentication-no-response")

    pevent_type_exception = Enum.YLeaf(30, "pevent-type-exception")

    pevent_type_session_ident_chg = Enum.YLeaf(31, "pevent-type-session-ident-chg")

    pevent_type_max = Enum.YLeaf(32, "pevent-type-max")


class PfcPauseType(Enum):
    """
    PfcPauseType

    Pfc pause type

    .. data:: pfc_buffer_size_defined = 0

    	pfc buffer size defined

    .. data:: pfc_pause_threshold_defined = 1

    	pfc pause threshold defined

    .. data:: pfc_resume_threshold_defined = 2

    	pfc resume threshold defined

    .. data:: pfc_buffer_size_value = 3

    	pfc buffer size value

    .. data:: pfc_pause_threshold_value = 4

    	pfc pause threshold value

    .. data:: pfc_resume_threshold_value = 5

    	pfc resume threshold value

    """

    pfc_buffer_size_defined = Enum.YLeaf(0, "pfc-buffer-size-defined")

    pfc_pause_threshold_defined = Enum.YLeaf(1, "pfc-pause-threshold-defined")

    pfc_resume_threshold_defined = Enum.YLeaf(2, "pfc-resume-threshold-defined")

    pfc_buffer_size_value = Enum.YLeaf(3, "pfc-buffer-size-value")

    pfc_pause_threshold_value = Enum.YLeaf(4, "pfc-pause-threshold-value")

    pfc_resume_threshold_value = Enum.YLeaf(5, "pfc-resume-threshold-value")


class PlmgrAppFwdingTypeE(Enum):
    """
    PlmgrAppFwdingTypeE

    Forwarding types

    .. data:: layer2 = 0

    	 Forwarding type layer2

    .. data:: layer3 = 1

    	 Forwarding type layer3

    .. data:: any = 2

    	Forwarding type any

    """

    layer2 = Enum.YLeaf(0, "layer2")

    layer3 = Enum.YLeaf(1, "layer3")

    any = Enum.YLeaf(2, "any")


class PlmgrApplnTypeEn(Enum):
    """
    PlmgrApplnTypeEn

    Different Application types

    .. data:: qos = 1

    	Application type QOS

    .. data:: pbr = 2

    	Application type PBR

    .. data:: subscriber_control = 3

    	Application type subscriber control

    .. data:: accounting = 4

    	Application type accounting

    .. data:: traffic = 5

    	Application type traffic

    .. data:: performance_traffic = 6

    	Application type performance traffic

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    subscriber_control = Enum.YLeaf(3, "subscriber-control")

    accounting = Enum.YLeaf(4, "accounting")

    traffic = Enum.YLeaf(5, "traffic")

    performance_traffic = Enum.YLeaf(6, "performance-traffic")


class PlmgrVarTypeEn(Enum):
    """
    PlmgrVarTypeEn

    Type of default variable values

    .. data:: plmgr_var_type_class_name = 0

    	plmgr var type class name

    .. data:: plmgr_var_type_uint8 = 1

    	plmgr var type uint8

    .. data:: plmgr_var_type_uint16 = 2

    	plmgr var type uint16

    .. data:: plmgr_var_type_uint32 = 3

    	plmgr var type uint32

    .. data:: plmgr_var_type_param_uint32 = 4

    	plmgr var type param uint32

    .. data:: plmgr_var_type_dscp = 5

    	plmgr var type dscp

    .. data:: plmgr_var_type_prec = 6

    	plmgr var type prec

    .. data:: plmgr_var_type_max = 7

    	plmgr var type max

    """

    plmgr_var_type_class_name = Enum.YLeaf(0, "plmgr-var-type-class-name")

    plmgr_var_type_uint8 = Enum.YLeaf(1, "plmgr-var-type-uint8")

    plmgr_var_type_uint16 = Enum.YLeaf(2, "plmgr-var-type-uint16")

    plmgr_var_type_uint32 = Enum.YLeaf(3, "plmgr-var-type-uint32")

    plmgr_var_type_param_uint32 = Enum.YLeaf(4, "plmgr-var-type-param-uint32")

    plmgr_var_type_dscp = Enum.YLeaf(5, "plmgr-var-type-dscp")

    plmgr_var_type_prec = Enum.YLeaf(6, "plmgr-var-type-prec")

    plmgr_var_type_max = Enum.YLeaf(7, "plmgr-var-type-max")


class PoliceActionTypeEn(Enum):
    """
    PoliceActionTypeEn

    Policer Action Type

    .. data:: police_action_none = 0

    	Policer Action None

    .. data:: police_action_transmit = 1

    	Policer Action Transmit

    .. data:: police_action_drop = 2

    	Policer Action Drop

    .. data:: police_action_mark = 3

    	Policer Action Mark

    .. data:: police_action_max = 4

    	Policer Action Max

    """

    police_action_none = Enum.YLeaf(0, "police-action-none")

    police_action_transmit = Enum.YLeaf(1, "police-action-transmit")

    police_action_drop = Enum.YLeaf(2, "police-action-drop")

    police_action_mark = Enum.YLeaf(3, "police-action-mark")

    police_action_max = Enum.YLeaf(4, "police-action-max")


class PoliceActnCategoryEn(Enum):
    """
    PoliceActnCategoryEn

    Police Action Categories

    .. data:: police_actn_category_conform = 0

    	Conform action

    .. data:: police_actn_category_exceed = 1

    	Exceed action

    .. data:: police_actn_category_violate = 2

    	Violate action

    .. data:: police_actn_category_max = 3

    	Maximum police action categories

    """

    police_actn_category_conform = Enum.YLeaf(0, "police-actn-category-conform")

    police_actn_category_exceed = Enum.YLeaf(1, "police-actn-category-exceed")

    police_actn_category_violate = Enum.YLeaf(2, "police-actn-category-violate")

    police_actn_category_max = Enum.YLeaf(3, "police-actn-category-max")


class PolicyActionAttrEn(Enum):
    """
    PolicyActionAttrEn

    Policy action attribute enum

    .. data:: action_attribute = 1

    	action attribute

    .. data:: sub_action_attribute = 2

    	sub action attribute

    """

    action_attribute = Enum.YLeaf(1, "action-attribute")

    sub_action_attribute = Enum.YLeaf(2, "sub-action-attribute")


class PolicyActionEn(Enum):
    """
    PolicyActionEn

    Policy Actions Enumeration

    .. data:: policy_action_none = 0

    	Policy Action None

    .. data:: policy_action_unspecified = 1

    	Policy Action is not specified

    .. data:: policy_action_mark = 2

    	Policy Action Mark

    .. data:: policy_action_mark2 = 3

    	Policy Action Mark2

    .. data:: policy_action_wred = 4

    	Policy Action WRED

    .. data:: policy_action_encap_seq = 5

    	Policy action encap-sequence number

    .. data:: policy_action_priority = 6

    	Policy Action Priority Queue

    .. data:: policy_action_iphc = 7

    	Policy Action IP Header Compression

    .. data:: policy_action_bw_remaining = 8

    	Policy Action Bandwidth Remaining Queue

    .. data:: policy_action_min_bw = 9

    	Policy Action Minimum Bandwidth Queue

    .. data:: policy_action_authenticate_aaa = 10

    	Policy Action authenticate

    .. data:: policy_action_collect_id = 11

    	Policy Action collect identifier

    .. data:: policy_action_disconnect = 12

    	Policy Action disconnect session

    .. data:: policy_action_set_timer = 13

    	Policy Action set timer

    .. data:: policy_action_stop_timer = 14

    	Policy Action stop timer

    .. data:: policy_action_query_ancp = 15

    	Policy Action query ancp

    .. data:: policy_action_accounting_aaa_list = 16

    	Policy Action accounting aaa

    .. data:: policy_action_prepaid_config = 17

    	Policy Action prepaid config

    .. data:: policy_action_timeout_idle = 18

    	Policy Action timeout idle

    .. data:: policy_action_proxy_aaa = 19

    	Policy Action proxy aaa

    .. data:: policy_action_template_activate = 20

    	Policy Action activate template

    .. data:: policy_action_template_deactivate = 21

    	Policy Action deactivate template

    .. data:: policy_action_decode_identifier = 22

    	Policy Action decode identifier

    .. data:: policy_action_q_limit = 23

    	Policy Action Queue Limit

    .. data:: policy_action_authorize_id = 24

    	Policy Action authorize idetifier

    .. data:: policy_action_accounting_event_aaa_list = 25

    	Policy Action accounting event

    .. data:: policy_action_afmon_react = 26

    	Policy Action React (afmon)

    .. data:: policy_action_httpr = 27

    	Policy Action httpr (pbr)

    .. data:: policy_action_pbr_transmit = 28

    	Policy Action pbr transmit

    .. data:: policy_action_pbr_drop = 29

    	Policy Action pbr drop

    .. data:: policy_action_punt = 30

    	Policy Action pbr punt

    .. data:: policy_action_copy = 31

    	Policy Action pbr copy

    .. data:: policy_action_sfrag = 32

    	Policy Action Service fragment

    .. data:: policy_action_monitor = 33

    	Policy Action Monitor

    .. data:: policy_action_redirect = 34

    	Policy Action redirect

    .. data:: policy_action_ipv4_nh = 35

    	Policy Action ipv4 next hop

    .. data:: policy_action_ipv6_nh = 36

    	Policy Action ipv6 next hop

    .. data:: policy_action_vlan_pop = 37

    	Policy Action pop

    .. data:: policy_action_pbr_next_hop = 38

    	Policy Action PBR Forward

    .. data:: policy_action_decap_gre = 39

    	Policy Action decapsule GRE

    .. data:: policy_action_output_interface = 40

    	Policy Action PBR redirect interface

    .. data:: policy_action_service_function_path = 41

    	Policy Action PBR service chaining

    .. data:: policy_action_ptrs = 42

    	Dummy action for internal use

    .. data:: policy_action_police = 43

    	Policy Action Police

    .. data:: policy_action_shape = 44

    	Policy Action Shape

    .. data:: policy_action_serv_pol = 45

    	Policy Action Service Policy

    .. data:: policy_action_cac = 46

    	Policy Action CAC

    .. data:: policy_action_afmon_flow_parm = 47

    	Policy Action Flow params (afmon)

    .. data:: policy_action_afmon_ipcbr_metric = 48

    	Policy Action IP-CBR Metric (afmon)

    .. data:: policy_action_afmon_rtp_metric = 49

    	Policy Action RTP-Custom Metric (afmon)

    .. data:: policy_action_afmon_rtp_mmr_metric = 50

    	Policy Action RTP-MMR Metric (afmon)

    .. data:: policy_action_afmon_rtp_j2k_metric = 51

    	Policy Action RTP-J2K Metric (afmon)

    .. data:: policy_action_afmon_rtp_voice_metric = 52

    	Policy Action RTP-Voice Metric (afmon)

    .. data:: policy_action_afmon_mdi_metric = 53

    	Policy Action MDI Metric (afmon)

    .. data:: policy_action_afmon_mdi_rtp_metric = 54

    	Policy Action MDI RTP Metric (afmon)

    .. data:: policy_action_afmon_fmm = 55

    	Policy Action flow monitor (afmon)

    .. data:: policy_action_pfc = 56

    	Policy Action PFC

    .. data:: policy_action_max = 57

    	Policy Action Max (Invalid)

    """

    policy_action_none = Enum.YLeaf(0, "policy-action-none")

    policy_action_unspecified = Enum.YLeaf(1, "policy-action-unspecified")

    policy_action_mark = Enum.YLeaf(2, "policy-action-mark")

    policy_action_mark2 = Enum.YLeaf(3, "policy-action-mark2")

    policy_action_wred = Enum.YLeaf(4, "policy-action-wred")

    policy_action_encap_seq = Enum.YLeaf(5, "policy-action-encap-seq")

    policy_action_priority = Enum.YLeaf(6, "policy-action-priority")

    policy_action_iphc = Enum.YLeaf(7, "policy-action-iphc")

    policy_action_bw_remaining = Enum.YLeaf(8, "policy-action-bw-remaining")

    policy_action_min_bw = Enum.YLeaf(9, "policy-action-min-bw")

    policy_action_authenticate_aaa = Enum.YLeaf(10, "policy-action-authenticate-aaa")

    policy_action_collect_id = Enum.YLeaf(11, "policy-action-collect-id")

    policy_action_disconnect = Enum.YLeaf(12, "policy-action-disconnect")

    policy_action_set_timer = Enum.YLeaf(13, "policy-action-set-timer")

    policy_action_stop_timer = Enum.YLeaf(14, "policy-action-stop-timer")

    policy_action_query_ancp = Enum.YLeaf(15, "policy-action-query-ancp")

    policy_action_accounting_aaa_list = Enum.YLeaf(16, "policy-action-accounting-aaa-list")

    policy_action_prepaid_config = Enum.YLeaf(17, "policy-action-prepaid-config")

    policy_action_timeout_idle = Enum.YLeaf(18, "policy-action-timeout-idle")

    policy_action_proxy_aaa = Enum.YLeaf(19, "policy-action-proxy-aaa")

    policy_action_template_activate = Enum.YLeaf(20, "policy-action-template-activate")

    policy_action_template_deactivate = Enum.YLeaf(21, "policy-action-template-deactivate")

    policy_action_decode_identifier = Enum.YLeaf(22, "policy-action-decode-identifier")

    policy_action_q_limit = Enum.YLeaf(23, "policy-action-q-limit")

    policy_action_authorize_id = Enum.YLeaf(24, "policy-action-authorize-id")

    policy_action_accounting_event_aaa_list = Enum.YLeaf(25, "policy-action-accounting-event-aaa-list")

    policy_action_afmon_react = Enum.YLeaf(26, "policy-action-afmon-react")

    policy_action_httpr = Enum.YLeaf(27, "policy-action-httpr")

    policy_action_pbr_transmit = Enum.YLeaf(28, "policy-action-pbr-transmit")

    policy_action_pbr_drop = Enum.YLeaf(29, "policy-action-pbr-drop")

    policy_action_punt = Enum.YLeaf(30, "policy-action-punt")

    policy_action_copy = Enum.YLeaf(31, "policy-action-copy")

    policy_action_sfrag = Enum.YLeaf(32, "policy-action-sfrag")

    policy_action_monitor = Enum.YLeaf(33, "policy-action-monitor")

    policy_action_redirect = Enum.YLeaf(34, "policy-action-redirect")

    policy_action_ipv4_nh = Enum.YLeaf(35, "policy-action-ipv4-nh")

    policy_action_ipv6_nh = Enum.YLeaf(36, "policy-action-ipv6-nh")

    policy_action_vlan_pop = Enum.YLeaf(37, "policy-action-vlan-pop")

    policy_action_pbr_next_hop = Enum.YLeaf(38, "policy-action-pbr-next-hop")

    policy_action_decap_gre = Enum.YLeaf(39, "policy-action-decap-gre")

    policy_action_output_interface = Enum.YLeaf(40, "policy-action-output-interface")

    policy_action_service_function_path = Enum.YLeaf(41, "policy-action-service-function-path")

    policy_action_ptrs = Enum.YLeaf(42, "policy-action-ptrs")

    policy_action_police = Enum.YLeaf(43, "policy-action-police")

    policy_action_shape = Enum.YLeaf(44, "policy-action-shape")

    policy_action_serv_pol = Enum.YLeaf(45, "policy-action-serv-pol")

    policy_action_cac = Enum.YLeaf(46, "policy-action-cac")

    policy_action_afmon_flow_parm = Enum.YLeaf(47, "policy-action-afmon-flow-parm")

    policy_action_afmon_ipcbr_metric = Enum.YLeaf(48, "policy-action-afmon-ipcbr-metric")

    policy_action_afmon_rtp_metric = Enum.YLeaf(49, "policy-action-afmon-rtp-metric")

    policy_action_afmon_rtp_mmr_metric = Enum.YLeaf(50, "policy-action-afmon-rtp-mmr-metric")

    policy_action_afmon_rtp_j2k_metric = Enum.YLeaf(51, "policy-action-afmon-rtp-j2k-metric")

    policy_action_afmon_rtp_voice_metric = Enum.YLeaf(52, "policy-action-afmon-rtp-voice-metric")

    policy_action_afmon_mdi_metric = Enum.YLeaf(53, "policy-action-afmon-mdi-metric")

    policy_action_afmon_mdi_rtp_metric = Enum.YLeaf(54, "policy-action-afmon-mdi-rtp-metric")

    policy_action_afmon_fmm = Enum.YLeaf(55, "policy-action-afmon-fmm")

    policy_action_pfc = Enum.YLeaf(56, "policy-action-pfc")

    policy_action_max = Enum.YLeaf(57, "policy-action-max")


class PolicyActionExecTypeE(Enum):
    """
    PolicyActionExecTypeE

    Policy action execution type enum

    .. data:: execution_immediate = 1

    	execution immediate

    .. data:: execution_deferred = 2

    	execution deferred

    """

    execution_immediate = Enum.YLeaf(1, "execution-immediate")

    execution_deferred = Enum.YLeaf(2, "execution-deferred")


class PolicyClassInfoEn(Enum):
    """
    PolicyClassInfoEn

    Policy class info en

    .. data:: policy_class_info_key_type = 0

    	Policy Class Info Key

    .. data:: policy_class_info_mod_type = 1

    	Policy Class Info Modify Bag

    """

    policy_class_info_key_type = Enum.YLeaf(0, "policy-class-info-key-type")

    policy_class_info_mod_type = Enum.YLeaf(1, "policy-class-info-mod-type")


class PolicyMapTableTypeEn(Enum):
    """
    PolicyMapTableTypeEn

    Policy\-Map Table Type

    .. data:: policy_map_table_type_none = 0

    	policy map table type none

    .. data:: policy_map_table_type_l2_any = 1

    	policy map table type l2 any

    .. data:: policy_map_table_type_l2_l3 = 2

    	policy map table type l2 l3

    .. data:: policy_map_table_type_l3_ipv4 = 3

    	policy map table type l3 ipv4

    .. data:: policy_map_table_type_l3_ds = 4

    	policy map table type l3 ds

    .. data:: policy_map_table_type_traffic_ingress = 5

    	policy map table type traffic ingress

    .. data:: policy_map_table_type_qos_ingress = 6

    	policy map table type qos ingress

    .. data:: policy_map_table_type_qos_egress = 7

    	policy map table type qos egress

    .. data:: policy_map_table_type_max = 8

    	policy map table type max

    """

    policy_map_table_type_none = Enum.YLeaf(0, "policy-map-table-type-none")

    policy_map_table_type_l2_any = Enum.YLeaf(1, "policy-map-table-type-l2-any")

    policy_map_table_type_l2_l3 = Enum.YLeaf(2, "policy-map-table-type-l2-l3")

    policy_map_table_type_l3_ipv4 = Enum.YLeaf(3, "policy-map-table-type-l3-ipv4")

    policy_map_table_type_l3_ds = Enum.YLeaf(4, "policy-map-table-type-l3-ds")

    policy_map_table_type_traffic_ingress = Enum.YLeaf(5, "policy-map-table-type-traffic-ingress")

    policy_map_table_type_qos_ingress = Enum.YLeaf(6, "policy-map-table-type-qos-ingress")

    policy_map_table_type_qos_egress = Enum.YLeaf(7, "policy-map-table-type-qos-egress")

    policy_map_table_type_max = Enum.YLeaf(8, "policy-map-table-type-max")


class PolicyMapTypeEn(Enum):
    """
    PolicyMapTypeEn

    Policy map type en

    .. data:: policy_map_type_none = 0

    	policy map type none

    .. data:: policy_map_type_qos = 1

    	policy map type qos

    .. data:: policy_map_type_pbr = 2

    	policy map type pbr

    .. data:: policy_map_type_traffic = 3

    	policy map type traffic

    .. data:: policy_map_type_subs_control = 4

    	policy map type subs control

    .. data:: policy_map_type_accounting = 5

    	policy map type accounting

    .. data:: policy_map_type_redirect = 6

    	policy map type redirect

    .. data:: policy_map_type_afmon = 7

    	policy map type afmon

    .. data:: policy_map_type_merge = 8

    	policy map type merge

    .. data:: policy_map_type_max = 9

    	policy map type max

    """

    policy_map_type_none = Enum.YLeaf(0, "policy-map-type-none")

    policy_map_type_qos = Enum.YLeaf(1, "policy-map-type-qos")

    policy_map_type_pbr = Enum.YLeaf(2, "policy-map-type-pbr")

    policy_map_type_traffic = Enum.YLeaf(3, "policy-map-type-traffic")

    policy_map_type_subs_control = Enum.YLeaf(4, "policy-map-type-subs-control")

    policy_map_type_accounting = Enum.YLeaf(5, "policy-map-type-accounting")

    policy_map_type_redirect = Enum.YLeaf(6, "policy-map-type-redirect")

    policy_map_type_afmon = Enum.YLeaf(7, "policy-map-type-afmon")

    policy_map_type_merge = Enum.YLeaf(8, "policy-map-type-merge")

    policy_map_type_max = Enum.YLeaf(9, "policy-map-type-max")


class PolicyObjEncEn(Enum):
    """
    PolicyObjEncEn

    Child policy related encoding information

    .. data:: policy_obj_enc_name = 0

    	Name of the Policy

    .. data:: policy_obj_enc_hdl = 1

    	Policy Handle

    .. data:: policy_obj_enc_var_idx = 2

    	Policy Variable Index

    .. data:: policy_obj_enc_in_line = 3

    	Inline Class

    """

    policy_obj_enc_name = Enum.YLeaf(0, "policy-obj-enc-name")

    policy_obj_enc_hdl = Enum.YLeaf(1, "policy-obj-enc-hdl")

    policy_obj_enc_var_idx = Enum.YLeaf(2, "policy-obj-enc-var-idx")

    policy_obj_enc_in_line = Enum.YLeaf(3, "policy-obj-enc-in-line")


class PolicyParamUnitType(Enum):
    """
    PolicyParamUnitType

    Policy param unit type

    .. data:: policy_param_unit_invalid = 0

    	policy param unit invalid

    .. data:: policy_param_unit_bytes = 1

    	policy param unit bytes

    .. data:: policy_param_unit_kbytes = 2

    	policy param unit kbytes

    .. data:: policy_param_unit_mbytes = 3

    	policy param unit mbytes

    .. data:: policy_param_unit_gbytes = 4

    	policy param unit gbytes

    .. data:: policy_param_unit_bitsps = 5

    	policy param unit bitsps

    .. data:: policy_param_unit_kbitsps = 6

    	policy param unit kbitsps

    .. data:: policy_param_unit_mbitsps = 7

    	policy param unit mbitsps

    .. data:: policy_param_unit_gbitsps = 8

    	policy param unit gbitsps

    .. data:: policy_param_unit_cells_ps = 9

    	policy param unit cells ps

    .. data:: policy_param_unit_packets_ps = 10

    	policy param unit packets ps

    .. data:: policy_param_unit_us = 11

    	policy param unit us

    .. data:: policy_param_unit_ms = 12

    	policy param unit ms

    .. data:: policy_param_unit_seconds = 13

    	policy param unit seconds

    .. data:: policy_param_unit_packets = 14

    	policy param unit packets

    .. data:: policy_param_unit_cells = 15

    	policy param unit cells

    .. data:: policy_param_unit_percent = 16

    	policy param unit percent

    .. data:: policy_param_unit_per_thousand = 17

    	policy param unit per thousand

    .. data:: policy_param_unit_per_million = 18

    	policy param unit per million

    .. data:: policy_param_unit_hz = 19

    	policy param unit hz

    .. data:: policy_param_unit_khz = 20

    	policy param unit khz

    .. data:: policy_param_unit_mhz = 21

    	policy param unit mhz

    .. data:: policy_param_unit_ratio = 22

    	policy param unit ratio

    .. data:: policy_param_unit_max = 23

    	policy param unit max

    """

    policy_param_unit_invalid = Enum.YLeaf(0, "policy-param-unit-invalid")

    policy_param_unit_bytes = Enum.YLeaf(1, "policy-param-unit-bytes")

    policy_param_unit_kbytes = Enum.YLeaf(2, "policy-param-unit-kbytes")

    policy_param_unit_mbytes = Enum.YLeaf(3, "policy-param-unit-mbytes")

    policy_param_unit_gbytes = Enum.YLeaf(4, "policy-param-unit-gbytes")

    policy_param_unit_bitsps = Enum.YLeaf(5, "policy-param-unit-bitsps")

    policy_param_unit_kbitsps = Enum.YLeaf(6, "policy-param-unit-kbitsps")

    policy_param_unit_mbitsps = Enum.YLeaf(7, "policy-param-unit-mbitsps")

    policy_param_unit_gbitsps = Enum.YLeaf(8, "policy-param-unit-gbitsps")

    policy_param_unit_cells_ps = Enum.YLeaf(9, "policy-param-unit-cells-ps")

    policy_param_unit_packets_ps = Enum.YLeaf(10, "policy-param-unit-packets-ps")

    policy_param_unit_us = Enum.YLeaf(11, "policy-param-unit-us")

    policy_param_unit_ms = Enum.YLeaf(12, "policy-param-unit-ms")

    policy_param_unit_seconds = Enum.YLeaf(13, "policy-param-unit-seconds")

    policy_param_unit_packets = Enum.YLeaf(14, "policy-param-unit-packets")

    policy_param_unit_cells = Enum.YLeaf(15, "policy-param-unit-cells")

    policy_param_unit_percent = Enum.YLeaf(16, "policy-param-unit-percent")

    policy_param_unit_per_thousand = Enum.YLeaf(17, "policy-param-unit-per-thousand")

    policy_param_unit_per_million = Enum.YLeaf(18, "policy-param-unit-per-million")

    policy_param_unit_hz = Enum.YLeaf(19, "policy-param-unit-hz")

    policy_param_unit_khz = Enum.YLeaf(20, "policy-param-unit-khz")

    policy_param_unit_mhz = Enum.YLeaf(21, "policy-param-unit-mhz")

    policy_param_unit_ratio = Enum.YLeaf(22, "policy-param-unit-ratio")

    policy_param_unit_max = Enum.YLeaf(23, "policy-param-unit-max")


class PolicyRouteTargetEn(Enum):
    """
    PolicyRouteTargetEn

    Policy route target en

    .. data:: policy_rt_type_none = 0

    	policy rt type none

    .. data:: policy_rt_type_asn2 = 1

    	policy rt type asn2

    .. data:: policy_rt_type_ipv4 = 2

    	policy rt type ipv4

    .. data:: policy_rt_type_asn4 = 3

    	policy rt type asn4

    .. data:: policy_rt_type_max = 4

    	policy rt type max

    """

    policy_rt_type_none = Enum.YLeaf(0, "policy-rt-type-none")

    policy_rt_type_asn2 = Enum.YLeaf(1, "policy-rt-type-asn2")

    policy_rt_type_ipv4 = Enum.YLeaf(2, "policy-rt-type-ipv4")

    policy_rt_type_asn4 = Enum.YLeaf(3, "policy-rt-type-asn4")

    policy_rt_type_max = Enum.YLeaf(4, "policy-rt-type-max")


class PolicymgrClassMap(Enum):
    """
    PolicymgrClassMap

    Policymgr class map

    .. data:: qos = 1

    	QoS Classmap

    .. data:: pbr = 2

    	PBR Classmap

    .. data:: traffic = 3

    	TRAFFIC Classmap

    .. data:: subscriber_control = 4

    	SUBSCONTROL Classmap

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    traffic = Enum.YLeaf(3, "traffic")

    subscriber_control = Enum.YLeaf(4, "subscriber-control")


class PolicymgrPolicyMap(Enum):
    """
    PolicymgrPolicyMap

    Policymgr policy map

    .. data:: qos = 1

    	QoS Policymap

    .. data:: pbr = 2

    	PBR Policymap

    .. data:: traffic = 3

    	TRAFFIC Policymap

    .. data:: subscriber_control = 4

    	SUBSCONTROL Policymap

    .. data:: accounting = 5

    	ACCOUNTING Policymap

    .. data:: redirect = 6

    	REDIRECT Policy map

    .. data:: flow_monitor = 7

    	FlOWMONITOR Policy map

    """

    qos = Enum.YLeaf(1, "qos")

    pbr = Enum.YLeaf(2, "pbr")

    traffic = Enum.YLeaf(3, "traffic")

    subscriber_control = Enum.YLeaf(4, "subscriber-control")

    accounting = Enum.YLeaf(5, "accounting")

    redirect = Enum.YLeaf(6, "redirect")

    flow_monitor = Enum.YLeaf(7, "flow-monitor")


class QlimitTypeEn(Enum):
    """
    QlimitTypeEn

    Queue Limit Types

    .. data:: qlimit_cmd = 0

    	Queue Limit

    .. data:: qlimit_discard_class = 1

    	Queue Limit based on Discard Class

    .. data:: qlimit_qos_group = 2

    	Queue Limit based on Qos Group

    .. data:: qlimit_precedence = 3

    	Queue Limit based on Precedence

    .. data:: qlimit_mpls_exp = 4

    	Queue Limit based on Mpls Exp

    .. data:: qlimit_dscp = 5

    	Queue Limit based on Dscp

    .. data:: qlimit_max = 6

    	Queue Limit Max (Invalid)

    """

    qlimit_cmd = Enum.YLeaf(0, "qlimit-cmd")

    qlimit_discard_class = Enum.YLeaf(1, "qlimit-discard-class")

    qlimit_qos_group = Enum.YLeaf(2, "qlimit-qos-group")

    qlimit_precedence = Enum.YLeaf(3, "qlimit-precedence")

    qlimit_mpls_exp = Enum.YLeaf(4, "qlimit-mpls-exp")

    qlimit_dscp = Enum.YLeaf(5, "qlimit-dscp")

    qlimit_max = Enum.YLeaf(6, "qlimit-max")


class RedirectTypeEn(Enum):
    """
    RedirectTypeEn

    Redirect types Enumeration

    .. data:: redirect_type_none = 0

    	Redirect None

    .. data:: redirect_type_output_interface = 1

    	Redirect to output intreface

    .. data:: redirect_type_max = 2

    	Redirect Max (Invalid)

    """

    redirect_type_none = Enum.YLeaf(0, "redirect-type-none")

    redirect_type_output_interface = Enum.YLeaf(1, "redirect-type-output-interface")

    redirect_type_max = Enum.YLeaf(2, "redirect-type-max")


class SharedBucketType(Enum):
    """
    SharedBucketType

    Shared bucket type

    .. data:: shared_bucket_type_not_specified = 0

    	shared bucket type not specified

    .. data:: shared_bucket_referred = 1

    	shared bucket referred

    .. data:: shared_bucket_defined = 2

    	shared bucket defined

    """

    shared_bucket_type_not_specified = Enum.YLeaf(0, "shared-bucket-type-not-specified")

    shared_bucket_referred = Enum.YLeaf(1, "shared-bucket-referred")

    shared_bucket_defined = Enum.YLeaf(2, "shared-bucket-defined")


class VsvcServiceTypeT(Enum):
    """
    VsvcServiceTypeT

    Vsvc service type t

    .. data:: vsvc_service_invalid = 0

    	vsvc service invalid

    .. data:: vsvc_service_v_path = 1

    	vsvc service v path

    .. data:: vsvc_service_ipsec = 2

    	vsvc service ipsec

    .. data:: vsvc_service_cgn = 3

    	vsvc service cgn

    .. data:: vsvc_service_o_flow = 4

    	vsvc service o flow

    .. data:: vsvc_service_output = 5

    	vsvc service output

    .. data:: vsvc_service_cfg_v_path = 6

    	vsvc service cfg v path

    .. data:: vsvc_service_sfp = 7

    	vsvc service sfp

    .. data:: vsvc_service_sfl = 8

    	vsvc service sfl

    .. data:: vsvc_service_sffl = 9

    	vsvc service sffl

    .. data:: vsvc_service_max = 10

    	vsvc service max

    """

    vsvc_service_invalid = Enum.YLeaf(0, "vsvc-service-invalid")

    vsvc_service_v_path = Enum.YLeaf(1, "vsvc-service-v-path")

    vsvc_service_ipsec = Enum.YLeaf(2, "vsvc-service-ipsec")

    vsvc_service_cgn = Enum.YLeaf(3, "vsvc-service-cgn")

    vsvc_service_o_flow = Enum.YLeaf(4, "vsvc-service-o-flow")

    vsvc_service_output = Enum.YLeaf(5, "vsvc-service-output")

    vsvc_service_cfg_v_path = Enum.YLeaf(6, "vsvc-service-cfg-v-path")

    vsvc_service_sfp = Enum.YLeaf(7, "vsvc-service-sfp")

    vsvc_service_sfl = Enum.YLeaf(8, "vsvc-service-sfl")

    vsvc_service_sffl = Enum.YLeaf(9, "vsvc-service-sffl")

    vsvc_service_max = Enum.YLeaf(10, "vsvc-service-max")


class WredTypeEn(Enum):
    """
    WredTypeEn

    Wred type en

    .. data:: wred_cos_cmd = 0

    	wred cos cmd

    .. data:: wred_dscp_cmd = 1

    	wred dscp cmd

    .. data:: wred_precedence_cmd = 2

    	wred precedence cmd

    .. data:: wred_discard_class_cmd = 3

    	wred discard class cmd

    .. data:: wred_mpls_exp_cmd = 4

    	wred mpls exp cmd

    .. data:: red_with_user_min_max = 5

    	red with user min max

    .. data:: red_with_default_min_max = 6

    	red with default min max

    .. data:: wred_dei_cmd = 7

    	wred dei cmd

    .. data:: wred_ecn_cmd = 8

    	wred ecn cmd

    .. data:: wred_invalid_cmd = 9

    	wred invalid cmd

    """

    wred_cos_cmd = Enum.YLeaf(0, "wred-cos-cmd")

    wred_dscp_cmd = Enum.YLeaf(1, "wred-dscp-cmd")

    wred_precedence_cmd = Enum.YLeaf(2, "wred-precedence-cmd")

    wred_discard_class_cmd = Enum.YLeaf(3, "wred-discard-class-cmd")

    wred_mpls_exp_cmd = Enum.YLeaf(4, "wred-mpls-exp-cmd")

    red_with_user_min_max = Enum.YLeaf(5, "red-with-user-min-max")

    red_with_default_min_max = Enum.YLeaf(6, "red-with-default-min-max")

    wred_dei_cmd = Enum.YLeaf(7, "wred-dei-cmd")

    wred_ecn_cmd = Enum.YLeaf(8, "wred-ecn-cmd")

    wred_invalid_cmd = Enum.YLeaf(9, "wred-invalid-cmd")



class PolicyManager(Entity):
    """
    Policy\-map operational data
    
    .. attribute:: global_
    
    	Global QOS operational data
    	**type**\:   :py:class:`Global_ <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_>`
    
    .. attribute:: nodes
    
    	Node\-specific Policymgr operational data
    	**type**\:   :py:class:`Nodes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes>`
    
    

    """

    _prefix = 'infra-policymgr-oper'
    _revision = '2017-05-27'

    def __init__(self):
        super(PolicyManager, self).__init__()
        self._top_entity = None

        self.yang_name = "policy-manager"
        self.yang_parent_name = "Cisco-IOS-XR-infra-policymgr-oper"
        self.is_top_level_class = True
        self.has_list_ancestor = False
        self._child_container_classes = {"global" : ("global_", PolicyManager.Global_), "nodes" : ("nodes", PolicyManager.Nodes)}
        self._child_list_classes = {}

        self.global_ = PolicyManager.Global_()
        self.global_.parent = self
        self._children_name_map["global_"] = "global"
        self._children_yang_names.add("global")

        self.nodes = PolicyManager.Nodes()
        self.nodes.parent = self
        self._children_name_map["nodes"] = "nodes"
        self._children_yang_names.add("nodes")
        self._segment_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager"


    class Global_(Entity):
        """
        Global QOS operational data
        
        .. attribute:: class_map
        
        	List of classmap details
        	**type**\:   :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap>`
        
        .. attribute:: policy_map
        
        	List of policymap details
        	**type**\:   :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap>`
        
        .. attribute:: policy_map_applied_types
        
        	List of Applied policymap details
        	**type**\:   :py:class:`PolicyMapAppliedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes>`
        
        .. attribute:: summary
        
        	Summary of policy\-maps and class\-maps configured
        	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary>`
        
        .. attribute:: target_policy_map_types
        
        	Targets of a policymap
        	**type**\:   :py:class:`TargetPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes>`
        
        .. attribute:: transient_policy_map_applied_types
        
        	Transient policy\-map applied type
        	**type**\:   :py:class:`TransientPolicyMapAppliedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes>`
        
        .. attribute:: transient_policy_map_targets_types
        
        	Transient policy\-map target table
        	**type**\:   :py:class:`TransientPolicyMapTargetsTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes>`
        
        

        """

        _prefix = 'infra-policymgr-oper'
        _revision = '2017-05-27'

        def __init__(self):
            super(PolicyManager.Global_, self).__init__()

            self.yang_name = "global"
            self.yang_parent_name = "policy-manager"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self._child_container_classes = {"class-map" : ("class_map", PolicyManager.Global_.ClassMap), "policy-map" : ("policy_map", PolicyManager.Global_.PolicyMap), "policy-map-applied-types" : ("policy_map_applied_types", PolicyManager.Global_.PolicyMapAppliedTypes), "summary" : ("summary", PolicyManager.Global_.Summary), "target-policy-map-types" : ("target_policy_map_types", PolicyManager.Global_.TargetPolicyMapTypes), "transient-policy-map-applied-types" : ("transient_policy_map_applied_types", PolicyManager.Global_.TransientPolicyMapAppliedTypes), "transient-policy-map-targets-types" : ("transient_policy_map_targets_types", PolicyManager.Global_.TransientPolicyMapTargetsTypes)}
            self._child_list_classes = {}

            self.class_map = PolicyManager.Global_.ClassMap()
            self.class_map.parent = self
            self._children_name_map["class_map"] = "class-map"
            self._children_yang_names.add("class-map")

            self.policy_map = PolicyManager.Global_.PolicyMap()
            self.policy_map.parent = self
            self._children_name_map["policy_map"] = "policy-map"
            self._children_yang_names.add("policy-map")

            self.policy_map_applied_types = PolicyManager.Global_.PolicyMapAppliedTypes()
            self.policy_map_applied_types.parent = self
            self._children_name_map["policy_map_applied_types"] = "policy-map-applied-types"
            self._children_yang_names.add("policy-map-applied-types")

            self.summary = PolicyManager.Global_.Summary()
            self.summary.parent = self
            self._children_name_map["summary"] = "summary"
            self._children_yang_names.add("summary")

            self.target_policy_map_types = PolicyManager.Global_.TargetPolicyMapTypes()
            self.target_policy_map_types.parent = self
            self._children_name_map["target_policy_map_types"] = "target-policy-map-types"
            self._children_yang_names.add("target-policy-map-types")

            self.transient_policy_map_applied_types = PolicyManager.Global_.TransientPolicyMapAppliedTypes()
            self.transient_policy_map_applied_types.parent = self
            self._children_name_map["transient_policy_map_applied_types"] = "transient-policy-map-applied-types"
            self._children_yang_names.add("transient-policy-map-applied-types")

            self.transient_policy_map_targets_types = PolicyManager.Global_.TransientPolicyMapTargetsTypes()
            self.transient_policy_map_targets_types.parent = self
            self._children_name_map["transient_policy_map_targets_types"] = "transient-policy-map-targets-types"
            self._children_yang_names.add("transient-policy-map-targets-types")
            self._segment_path = lambda: "global"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/%s" % self._segment_path()


        class ClassMap(Entity):
            """
            List of classmap details
            
            .. attribute:: class_map_types
            
            	Application type of a classmap
            	**type**\:   :py:class:`ClassMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.ClassMap, self).__init__()

                self.yang_name = "class-map"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {"class-map-types" : ("class_map_types", PolicyManager.Global_.ClassMap.ClassMapTypes)}
                self._child_list_classes = {}

                self.class_map_types = PolicyManager.Global_.ClassMap.ClassMapTypes()
                self.class_map_types.parent = self
                self._children_name_map["class_map_types"] = "class-map-types"
                self._children_yang_names.add("class-map-types")
                self._segment_path = lambda: "class-map"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()


            class ClassMapTypes(Entity):
                """
                Application type of a classmap
                
                .. attribute:: class_map_type
                
                	Policymgr application type
                	**type**\: list of    :py:class:`ClassMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.ClassMap.ClassMapTypes, self).__init__()

                    self.yang_name = "class-map-types"
                    self.yang_parent_name = "class-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"class-map-type" : ("class_map_type", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType)}

                    self.class_map_type = YList(self)
                    self._segment_path = lambda: "class-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/class-map/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes, [], name, value)


                class ClassMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrClassMap>`
                    
                    .. attribute:: class_map_briefs
                    
                    	Class\-map brief table
                    	**type**\:   :py:class:`ClassMapBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs>`
                    
                    .. attribute:: class_map_details
                    
                    	Class\-map detail table
                    	**type**\:   :py:class:`ClassMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails>`
                    
                    .. attribute:: class_maps
                    
                    	Class\-map definition table
                    	**type**\:   :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType, self).__init__()

                        self.yang_name = "class-map-type"
                        self.yang_parent_name = "class-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {"class-map-briefs" : ("class_map_briefs", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs), "class-map-details" : ("class_map_details", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails), "class-maps" : ("class_maps", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.class_map_briefs = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs()
                        self.class_map_briefs.parent = self
                        self._children_name_map["class_map_briefs"] = "class-map-briefs"
                        self._children_yang_names.add("class-map-briefs")

                        self.class_map_details = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails()
                        self.class_map_details.parent = self
                        self._children_name_map["class_map_details"] = "class-map-details"
                        self._children_yang_names.add("class-map-details")

                        self.class_maps = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps()
                        self.class_maps.parent = self
                        self._children_name_map["class_maps"] = "class-maps"
                        self._children_yang_names.add("class-maps")
                        self._segment_path = lambda: "class-map-type" + "[type='" + self.type.get() + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/class-map/class-map-types/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType, ['type'], name, value)


                    class ClassMapBriefs(Entity):
                        """
                        Class\-map brief table
                        
                        .. attribute:: class_map_brief
                        
                        	Class\-map brief information
                        	**type**\: list of    :py:class:`ClassMapBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, self).__init__()

                            self.yang_name = "class-map-briefs"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"class-map-brief" : ("class_map_brief", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief)}

                            self.class_map_brief = YList(self)
                            self._segment_path = lambda: "class-map-briefs"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, [], name, value)


                        class ClassMapBrief(Entity):
                            """
                            Class\-map brief information
                            
                            .. attribute:: class_map_name  <key>
                            
                            	Name of class\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference>`
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects>`
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, self).__init__()

                                self.yang_name = "class-map-brief"
                                self.yang_parent_name = "class-map-briefs"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects), "reference" : ("reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference)}

                                self.class_map_name = YLeaf(YType.str, "class-map-name")

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.total_objects = YLeaf(YType.uint32, "total-objects")

                                self.transient = YLeaf(YType.boolean, "transient")

                                self.class_map_reference = YList(self)
                                self.objects = YList(self)
                                self.reference = YList(self)
                                self._segment_path = lambda: "class-map-brief" + "[class-map-name='" + self.class_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference>`
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference)}

                                    self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_type = YLeaf(YType.enumeration, "object-type")

                                        self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                        self._segment_path = lambda: "policy-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.object_name = YLeaf(YType.str, "object-name")
                                    self._segment_path = lambda: "objects"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, ['object_name'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "class-map-brief"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                    self.total_flows = YLeaf(YType.uint32, "total-flows")

                                    self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                    self._segment_path = lambda: "reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                    class ClassMapDetails(Entity):
                        """
                        Class\-map detail table
                        
                        .. attribute:: class_map_detail
                        
                        	Class\-map detail information
                        	**type**\: list of    :py:class:`ClassMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, self).__init__()

                            self.yang_name = "class-map-details"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"class-map-detail" : ("class_map_detail", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail)}

                            self.class_map_detail = YList(self)
                            self._segment_path = lambda: "class-map-details"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, [], name, value)


                        class ClassMapDetail(Entity):
                            """
                            Class\-map detail information
                            
                            .. attribute:: class_map_name  <key>
                            
                            	Name of class\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference>`
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects>`
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, self).__init__()

                                self.yang_name = "class-map-detail"
                                self.yang_parent_name = "class-map-details"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects), "reference" : ("reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference)}

                                self.class_map_name = YLeaf(YType.str, "class-map-name")

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.total_objects = YLeaf(YType.uint32, "total-objects")

                                self.transient = YLeaf(YType.boolean, "transient")

                                self.class_map_reference = YList(self)
                                self.objects = YList(self)
                                self.reference = YList(self)
                                self._segment_path = lambda: "class-map-detail" + "[class-map-name='" + self.class_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference>`
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference)}

                                    self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_type = YLeaf(YType.enumeration, "object-type")

                                        self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                        self._segment_path = lambda: "policy-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.object_name = YLeaf(YType.str, "object-name")
                                    self._segment_path = lambda: "objects"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, ['object_name'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "class-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                    self.total_flows = YLeaf(YType.uint32, "total-flows")

                                    self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                    self._segment_path = lambda: "reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                    class ClassMaps(Entity):
                        """
                        Class\-map definition table
                        
                        .. attribute:: class_map
                        
                        	Class\-map configuration
                        	**type**\: list of    :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, self).__init__()

                            self.yang_name = "class-maps"
                            self.yang_parent_name = "class-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"class-map" : ("class_map", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap)}

                            self.class_map = YList(self)
                            self._segment_path = lambda: "class-maps"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, [], name, value)


                        class ClassMap(Entity):
                            """
                            Class\-map configuration
                            
                            .. attribute:: class_map_name  <key>
                            
                            	Name of class\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_bg
                            
                            	class map bg
                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap, self).__init__()

                                self.yang_name = "class-map"
                                self.yang_parent_name = "class-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg)}

                                self.class_map_name = YLeaf(YType.str, "class-map-name")

                                self.class_map_bg = YList(self)
                                self._segment_path = lambda: "class-map" + "[class-map-name='" + self.class_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap, ['class_map_name'], name, value)


                            class ClassMapBg(Entity):
                                """
                                class map bg
                                
                                .. attribute:: description
                                
                                	description
                                	**type**\:  str
                                
                                .. attribute:: match_infop
                                
                                	Pointer to the first Match info
                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop>`
                                
                                .. attribute:: mode
                                
                                	Class\-Map Mode Match any/Match all
                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                
                                .. attribute:: name
                                
                                	Name of the class\-map
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: type
                                
                                	Class\-Map Type QoS/PBR/Netflow/..
                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg, self).__init__()

                                    self.yang_name = "class-map-bg"
                                    self.yang_parent_name = "class-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop)}
                                    self._child_list_classes = {}

                                    self.description = YLeaf(YType.str, "description")

                                    self.mode = YLeaf(YType.enumeration, "mode")

                                    self.name = YLeaf(YType.str, "name")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.match_infop = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop()
                                    self.match_infop.parent = self
                                    self._children_name_map["match_infop"] = "match-infop"
                                    self._children_yang_names.add("match-infop")
                                    self._segment_path = lambda: "class-map-bg"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                class MatchInfop(Entity):
                                    """
                                    Pointer to the first Match info
                                    
                                    .. attribute:: class_match_info_st
                                    
                                    	class match info st
                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop, self).__init__()

                                        self.yang_name = "match-infop"
                                        self.yang_parent_name = "class-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                        self.class_match_info_st = YList(self)
                                        self._segment_path = lambda: "match-infop"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop, [], name, value)


                                    class ClassMatchInfoSt(Entity):
                                        """
                                        class match info st
                                        
                                        .. attribute:: flags
                                        
                                        	Flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: match_data
                                        
                                        	Match criteria
                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                            self.yang_name = "class-match-info-st"
                                            self.yang_parent_name = "match-infop"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                            self._child_list_classes = {}

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.match_data = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                            self.match_data.parent = self
                                            self._children_name_map["match_data"] = "match-data"
                                            self._children_yang_names.add("match-data")
                                            self._segment_path = lambda: "class-match-info-st"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                        class MatchData(Entity):
                                            """
                                            Match criteria
                                            
                                            .. attribute:: access_interface
                                            
                                            	Access interface
                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                            
                                            .. attribute:: atm_clp
                                            
                                            	Match ATM CLP level
                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                            
                                            .. attribute:: auth_domain
                                            
                                            	Authenticated domain name
                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                            
                                            .. attribute:: auth_domain_regex
                                            
                                            	Authenticated Domain Name RegEx
                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                            
                                            .. attribute:: auth_username
                                            
                                            	Authenticated User Name
                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                            
                                            .. attribute:: auth_username_regex
                                            
                                            	Authenticated User Name RegEx
                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                            
                                            .. attribute:: authen_status
                                            
                                            	Authentication Status
                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                            
                                            .. attribute:: avail_id
                                            
                                            	Available Identifiers
                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                            
                                            .. attribute:: circuit_id
                                            
                                            	Circuit ID
                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                            
                                            .. attribute:: circuit_id_regex
                                            
                                            	Circuit ID RegEx
                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                            
                                            .. attribute:: cos
                                            
                                            	Match CoS array
                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                            
                                            .. attribute:: cos_inr
                                            
                                            	Match inner header CoS
                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                            
                                            .. attribute:: dei
                                            
                                            	Match DEI Bit
                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                            
                                            .. attribute:: dei_inr
                                            
                                            	Match inner DEI Bit
                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                            
                                            .. attribute:: dhcp_client_id
                                            
                                            	Dhcp Client ID
                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                            
                                            .. attribute:: dhcp_client_id_regex
                                            
                                            	Dhcp Client ID RegEx
                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                            
                                            .. attribute:: discard_class
                                            
                                            	Match Discard Class array
                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                            
                                            .. attribute:: dnis
                                            
                                            	DNIS
                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                            
                                            .. attribute:: dnis_regex
                                            
                                            	DNIS Regular Expression
                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                            
                                            .. attribute:: domain
                                            
                                            	Domain Name
                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                            
                                            .. attribute:: domain_regex
                                            
                                            	Domain Regular Expression
                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                            
                                            .. attribute:: dscp
                                            
                                            	Match DSCP range array
                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                            
                                            .. attribute:: dst_addr_ipv4
                                            
                                            	Destination Address IPV4
                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                            
                                            .. attribute:: dst_addr_ipv6
                                            
                                            	Destination Address IPV6
                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                            
                                            .. attribute:: dst_mac
                                            
                                            	Match Destination MAC address
                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                            
                                            .. attribute:: dst_port
                                            
                                            	Destination port
                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                            
                                            .. attribute:: ether_service_acl
                                            
                                            	Ethernet\-Services Access\-list
                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                            
                                            .. attribute:: ethertype
                                            
                                            	Ethernet type
                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                            
                                            .. attribute:: flow_key_data
                                            
                                            	Flow key structure
                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                            
                                            .. attribute:: flow_tag
                                            
                                            	Match flow\-tag array
                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                            
                                            .. attribute:: fr_de
                                            
                                            	Match FR DE value
                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                            
                                            .. attribute:: fr_dlci
                                            
                                            	Match FR DLCI range array
                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                            
                                            .. attribute:: fragment_type
                                            
                                            	Fragment type
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: icmp_v4
                                            
                                            	Match ICMPV4 Protocol
                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                            
                                            .. attribute:: icmp_v6
                                            
                                            	Match ICMPV6 Protocol array
                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                            
                                            .. attribute:: icmpv4_code
                                            
                                            	Match ipv4 icmp code
                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                            
                                            .. attribute:: icmpv4_type
                                            
                                            	Match ipv4 icmp type
                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                            
                                            .. attribute:: icmpv6_code
                                            
                                            	Match ipv6 icmp code
                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                            
                                            .. attribute:: icmpv6_type
                                            
                                            	Match ipv6 icmp type
                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                            
                                            .. attribute:: input_interface
                                            
                                            	Input interface
                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                            
                                            .. attribute:: input_intfhdl
                                            
                                            	Input interface handle
                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                            
                                            .. attribute:: ipv4_acl
                                            
                                            	IPv4 Access\-list
                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                            
                                            .. attribute:: ipv4_dscp
                                            
                                            	IPv4 DSCP
                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                            
                                            .. attribute:: ipv4_packet_len
                                            
                                            	IPv4 packet length array
                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                            
                                            .. attribute:: ipv4_prec
                                            
                                            	IPv4 Precedence
                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                            
                                            .. attribute:: ipv6_acl
                                            
                                            	IPv6 Access\-list
                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                            
                                            .. attribute:: ipv6_dscp
                                            
                                            	IPv6 DSCP
                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                            
                                            .. attribute:: ipv6_packet_len
                                            
                                            	IPv6 packet length array
                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                            
                                            .. attribute:: ipv6_prec
                                            
                                            	IPv6 Precedence
                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                            
                                            .. attribute:: media_type
                                            
                                            	Media Type
                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                            
                                            .. attribute:: mlp_negotiated
                                            
                                            	MLP Negotiated
                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                            
                                            .. attribute:: mpls_disp_ipv4_acl
                                            
                                            	MPLS Disposition IPv4 Access\-list
                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                            
                                            .. attribute:: mpls_disp_ipv6_acl
                                            
                                            	MPLS Disposition IPv6 Access\-list
                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                            
                                            .. attribute:: mpls_exp
                                            
                                            	Match MPLS experimental topmost array
                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                            
                                            .. attribute:: mpls_exp_imp
                                            
                                            	Match MPLS experimental imposition array
                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                            
                                            .. attribute:: mpls_top_eos
                                            
                                            	MPLS Topmost EOS
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: mpls_top_label
                                            
                                            	MPLS Topmost LABEL
                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                            
                                            .. attribute:: nas_port
                                            
                                            	NAS Port
                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                            
                                            .. attribute:: packet_len
                                            
                                            	Match packet length array
                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                            
                                            .. attribute:: prec
                                            
                                            	Match Precedence array
                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                            
                                            .. attribute:: proto
                                            
                                            	Match Protocol array
                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                            
                                            .. attribute:: qos_group
                                            
                                            	Match QoS group array
                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                            
                                            .. attribute:: remote_id
                                            
                                            	Remote ID
                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                            
                                            .. attribute:: remote_id_regex
                                            
                                            	Remote ID RegEx
                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                            
                                            .. attribute:: service_name
                                            
                                            	Service Name
                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                            
                                            .. attribute:: service_name_regex
                                            
                                            	Service Name Regular Exp
                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                            
                                            .. attribute:: src_addr_ipv4
                                            
                                            	Source Address IPV4
                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                            
                                            .. attribute:: src_addr_ipv6
                                            
                                            	Source Address IPV6
                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                            
                                            .. attribute:: src_addr_mac
                                            
                                            	Source Address MAC
                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                            
                                            .. attribute:: src_mac
                                            
                                            	Match Source MAC address
                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                            
                                            .. attribute:: src_port
                                            
                                            	Source port
                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                            
                                            .. attribute:: subs_protocol
                                            
                                            	Protocol
                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                            
                                            .. attribute:: tcp_flag
                                            
                                            	Match tcp flag value
                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                            
                                            .. attribute:: timer
                                            
                                            	Timer
                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                            
                                            .. attribute:: timer_regexp
                                            
                                            	Timer Regular Expression
                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                            
                                            .. attribute:: traffic_class
                                            
                                            	Match Traffic class array
                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                            
                                            .. attribute:: tunnel_name
                                            
                                            	Tunnel Name
                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                            
                                            .. attribute:: tunnel_name_regex
                                            
                                            	Tunnel Name Regular Expression
                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                            
                                            .. attribute:: unauth_domain
                                            
                                            	Unauthenticated Domain Name
                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                            
                                            .. attribute:: unauth_domain_regex
                                            
                                            	Unauthenticated Domain Name RegEx
                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                            
                                            .. attribute:: unauth_username
                                            
                                            	Unauthenticated User Name
                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                            
                                            .. attribute:: unauth_username_regex
                                            
                                            	Unauthenticated User Name RegEx
                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                            
                                            .. attribute:: user_name
                                            
                                            	User Name
                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                            
                                            .. attribute:: user_name_regex
                                            
                                            	User Name Regular Expression
                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                            
                                            .. attribute:: vendor_id
                                            
                                            	Vendor ID
                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                            
                                            .. attribute:: vendor_id_regex
                                            
                                            	Vendor ID RegEx
                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                            
                                            .. attribute:: vlan
                                            
                                            	Match VLAN array
                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                            
                                            .. attribute:: vlan_inr
                                            
                                            	Match inner header VLAN range array
                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                self.yang_name = "match-data"
                                                self.yang_parent_name = "class-match-info-st"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                self._child_list_classes = {}

                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.access_interface = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                self.access_interface.parent = self
                                                self._children_name_map["access_interface"] = "access-interface"
                                                self._children_yang_names.add("access-interface")

                                                self.atm_clp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                self.atm_clp.parent = self
                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                self._children_yang_names.add("atm-clp")

                                                self.auth_domain = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                self.auth_domain.parent = self
                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                self._children_yang_names.add("auth-domain")

                                                self.auth_domain_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                self.auth_domain_regex.parent = self
                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                self._children_yang_names.add("auth-domain-regex")

                                                self.auth_username = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                self.auth_username.parent = self
                                                self._children_name_map["auth_username"] = "auth-username"
                                                self._children_yang_names.add("auth-username")

                                                self.auth_username_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                self.auth_username_regex.parent = self
                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                self._children_yang_names.add("auth-username-regex")

                                                self.avail_id = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                self.avail_id.parent = self
                                                self._children_name_map["avail_id"] = "avail-id"
                                                self._children_yang_names.add("avail-id")

                                                self.circuit_id = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                self.circuit_id.parent = self
                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                self._children_yang_names.add("circuit-id")

                                                self.circuit_id_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                self.circuit_id_regex.parent = self
                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                self._children_yang_names.add("circuit-id-regex")

                                                self.cos = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                self.cos.parent = self
                                                self._children_name_map["cos"] = "cos"
                                                self._children_yang_names.add("cos")

                                                self.cos_inr = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                self.cos_inr.parent = self
                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                self._children_yang_names.add("cos-inr")

                                                self.dei = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                self.dei.parent = self
                                                self._children_name_map["dei"] = "dei"
                                                self._children_yang_names.add("dei")

                                                self.dei_inr = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                self.dei_inr.parent = self
                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                self._children_yang_names.add("dei-inr")

                                                self.dhcp_client_id = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                self.dhcp_client_id.parent = self
                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                self._children_yang_names.add("dhcp-client-id")

                                                self.dhcp_client_id_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                self.dhcp_client_id_regex.parent = self
                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                self.discard_class = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                self.discard_class.parent = self
                                                self._children_name_map["discard_class"] = "discard-class"
                                                self._children_yang_names.add("discard-class")

                                                self.dnis = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                self.dnis.parent = self
                                                self._children_name_map["dnis"] = "dnis"
                                                self._children_yang_names.add("dnis")

                                                self.dnis_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                self.dnis_regex.parent = self
                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                self._children_yang_names.add("dnis-regex")

                                                self.domain = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                self.domain.parent = self
                                                self._children_name_map["domain"] = "domain"
                                                self._children_yang_names.add("domain")

                                                self.domain_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                self.domain_regex.parent = self
                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                self._children_yang_names.add("domain-regex")

                                                self.dscp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                self.dscp.parent = self
                                                self._children_name_map["dscp"] = "dscp"
                                                self._children_yang_names.add("dscp")

                                                self.dst_addr_ipv4 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                self.dst_addr_ipv4.parent = self
                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                self._children_yang_names.add("dst-addr-ipv4")

                                                self.dst_addr_ipv6 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                self.dst_addr_ipv6.parent = self
                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                self._children_yang_names.add("dst-addr-ipv6")

                                                self.dst_mac = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                self.dst_mac.parent = self
                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                self._children_yang_names.add("dst-mac")

                                                self.dst_port = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                self.dst_port.parent = self
                                                self._children_name_map["dst_port"] = "dst-port"
                                                self._children_yang_names.add("dst-port")

                                                self.ether_service_acl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                self.ether_service_acl.parent = self
                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                self._children_yang_names.add("ether-service-acl")

                                                self.ethertype = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                self.ethertype.parent = self
                                                self._children_name_map["ethertype"] = "ethertype"
                                                self._children_yang_names.add("ethertype")

                                                self.flow_key_data = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                self.flow_key_data.parent = self
                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                self._children_yang_names.add("flow-key-data")

                                                self.flow_tag = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                self.flow_tag.parent = self
                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                self._children_yang_names.add("flow-tag")

                                                self.fr_de = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                self.fr_de.parent = self
                                                self._children_name_map["fr_de"] = "fr-de"
                                                self._children_yang_names.add("fr-de")

                                                self.fr_dlci = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                self.fr_dlci.parent = self
                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                self._children_yang_names.add("fr-dlci")

                                                self.icmp_v4 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                self.icmp_v4.parent = self
                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                self._children_yang_names.add("icmp-v4")

                                                self.icmp_v6 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                self.icmp_v6.parent = self
                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                self._children_yang_names.add("icmp-v6")

                                                self.icmpv4_code = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                self.icmpv4_code.parent = self
                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                self._children_yang_names.add("icmpv4-code")

                                                self.icmpv4_type = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                self.icmpv4_type.parent = self
                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                self._children_yang_names.add("icmpv4-type")

                                                self.icmpv6_code = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                self.icmpv6_code.parent = self
                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                self._children_yang_names.add("icmpv6-code")

                                                self.icmpv6_type = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                self.icmpv6_type.parent = self
                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                self._children_yang_names.add("icmpv6-type")

                                                self.input_interface = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                self.input_interface.parent = self
                                                self._children_name_map["input_interface"] = "input-interface"
                                                self._children_yang_names.add("input-interface")

                                                self.input_intfhdl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                self.input_intfhdl.parent = self
                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                self._children_yang_names.add("input-intfhdl")

                                                self.ipv4_acl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                self.ipv4_acl.parent = self
                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                self._children_yang_names.add("ipv4-acl")

                                                self.ipv4_dscp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                self.ipv4_dscp.parent = self
                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                self._children_yang_names.add("ipv4-dscp")

                                                self.ipv4_packet_len = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                self.ipv4_packet_len.parent = self
                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                self._children_yang_names.add("ipv4-packet-len")

                                                self.ipv4_prec = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                self.ipv4_prec.parent = self
                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                self._children_yang_names.add("ipv4-prec")

                                                self.ipv6_acl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                self.ipv6_acl.parent = self
                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                self._children_yang_names.add("ipv6-acl")

                                                self.ipv6_dscp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                self.ipv6_dscp.parent = self
                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                self._children_yang_names.add("ipv6-dscp")

                                                self.ipv6_packet_len = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                self.ipv6_packet_len.parent = self
                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                self._children_yang_names.add("ipv6-packet-len")

                                                self.ipv6_prec = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                self.ipv6_prec.parent = self
                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                self._children_yang_names.add("ipv6-prec")

                                                self.media_type = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                self.media_type.parent = self
                                                self._children_name_map["media_type"] = "media-type"
                                                self._children_yang_names.add("media-type")

                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                self.mpls_disp_ipv4_acl.parent = self
                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                self.mpls_disp_ipv6_acl.parent = self
                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                self.mpls_exp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                self.mpls_exp.parent = self
                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                self._children_yang_names.add("mpls-exp")

                                                self.mpls_exp_imp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                self.mpls_exp_imp.parent = self
                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                self._children_yang_names.add("mpls-exp-imp")

                                                self.mpls_top_label = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                self.mpls_top_label.parent = self
                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                self._children_yang_names.add("mpls-top-label")

                                                self.nas_port = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                self.nas_port.parent = self
                                                self._children_name_map["nas_port"] = "nas-port"
                                                self._children_yang_names.add("nas-port")

                                                self.packet_len = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                self.packet_len.parent = self
                                                self._children_name_map["packet_len"] = "packet-len"
                                                self._children_yang_names.add("packet-len")

                                                self.prec = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                self.prec.parent = self
                                                self._children_name_map["prec"] = "prec"
                                                self._children_yang_names.add("prec")

                                                self.proto = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                self.proto.parent = self
                                                self._children_name_map["proto"] = "proto"
                                                self._children_yang_names.add("proto")

                                                self.qos_group = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                self.qos_group.parent = self
                                                self._children_name_map["qos_group"] = "qos-group"
                                                self._children_yang_names.add("qos-group")

                                                self.remote_id = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                self.remote_id.parent = self
                                                self._children_name_map["remote_id"] = "remote-id"
                                                self._children_yang_names.add("remote-id")

                                                self.remote_id_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                self.remote_id_regex.parent = self
                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                self._children_yang_names.add("remote-id-regex")

                                                self.service_name = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                self.service_name.parent = self
                                                self._children_name_map["service_name"] = "service-name"
                                                self._children_yang_names.add("service-name")

                                                self.service_name_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                self.service_name_regex.parent = self
                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                self._children_yang_names.add("service-name-regex")

                                                self.src_addr_ipv4 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                self.src_addr_ipv4.parent = self
                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                self._children_yang_names.add("src-addr-ipv4")

                                                self.src_addr_ipv6 = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                self.src_addr_ipv6.parent = self
                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                self._children_yang_names.add("src-addr-ipv6")

                                                self.src_addr_mac = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                self.src_addr_mac.parent = self
                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                self._children_yang_names.add("src-addr-mac")

                                                self.src_mac = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                self.src_mac.parent = self
                                                self._children_name_map["src_mac"] = "src-mac"
                                                self._children_yang_names.add("src-mac")

                                                self.src_port = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                self.src_port.parent = self
                                                self._children_name_map["src_port"] = "src-port"
                                                self._children_yang_names.add("src-port")

                                                self.subs_protocol = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                self.subs_protocol.parent = self
                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                self._children_yang_names.add("subs-protocol")

                                                self.tcp_flag = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                self.tcp_flag.parent = self
                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                self._children_yang_names.add("tcp-flag")

                                                self.timer = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                self.timer.parent = self
                                                self._children_name_map["timer"] = "timer"
                                                self._children_yang_names.add("timer")

                                                self.timer_regexp = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                self.timer_regexp.parent = self
                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                self._children_yang_names.add("timer-regexp")

                                                self.traffic_class = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                self.traffic_class.parent = self
                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                self._children_yang_names.add("traffic-class")

                                                self.tunnel_name = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                self.tunnel_name.parent = self
                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                self._children_yang_names.add("tunnel-name")

                                                self.tunnel_name_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                self.tunnel_name_regex.parent = self
                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                self._children_yang_names.add("tunnel-name-regex")

                                                self.unauth_domain = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                self.unauth_domain.parent = self
                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                self._children_yang_names.add("unauth-domain")

                                                self.unauth_domain_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                self.unauth_domain_regex.parent = self
                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                self._children_yang_names.add("unauth-domain-regex")

                                                self.unauth_username = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                self.unauth_username.parent = self
                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                self._children_yang_names.add("unauth-username")

                                                self.unauth_username_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                self.unauth_username_regex.parent = self
                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                self._children_yang_names.add("unauth-username-regex")

                                                self.user_name = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                self.user_name.parent = self
                                                self._children_name_map["user_name"] = "user-name"
                                                self._children_yang_names.add("user-name")

                                                self.user_name_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                self.user_name_regex.parent = self
                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                self._children_yang_names.add("user-name-regex")

                                                self.vendor_id = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                self.vendor_id.parent = self
                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                self._children_yang_names.add("vendor-id")

                                                self.vendor_id_regex = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                self.vendor_id_regex.parent = self
                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                self._children_yang_names.add("vendor-id-regex")

                                                self.vlan = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                self.vlan.parent = self
                                                self._children_name_map["vlan"] = "vlan"
                                                self._children_yang_names.add("vlan")

                                                self.vlan_inr = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                self.vlan_inr.parent = self
                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                self._children_yang_names.add("vlan-inr")
                                                self._segment_path = lambda: "match-data"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                            class AccessInterface(Entity):
                                                """
                                                Access interface
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                    self.yang_name = "access-interface"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "access-interface"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                            class AtmClp(Entity):
                                                """
                                                Match ATM CLP level
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                    self.yang_name = "atm-clp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "atm-clp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                            class AuthDomain(Entity):
                                                """
                                                Authenticated domain name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                    self.yang_name = "auth-domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "auth-domain"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                            class AuthDomainRegex(Entity):
                                                """
                                                Authenticated Domain Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                    self.yang_name = "auth-domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "auth-domain-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                            class AuthUsername(Entity):
                                                """
                                                Authenticated User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                    self.yang_name = "auth-username"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "auth-username"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                            class AuthUsernameRegex(Entity):
                                                """
                                                Authenticated User Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                    self.yang_name = "auth-username-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "auth-username-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                            class AvailId(Entity):
                                                """
                                                Available Identifiers
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                    self.yang_name = "avail-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "avail-id"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                            class CircuitId(Entity):
                                                """
                                                Circuit ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                    self.yang_name = "circuit-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "circuit-id"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                            class CircuitIdRegex(Entity):
                                                """
                                                Circuit ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                    self.yang_name = "circuit-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "circuit-id-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                            class Cos(Entity):
                                                """
                                                Match CoS array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                    self.yang_name = "cos"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "cos"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                            class CosInr(Entity):
                                                """
                                                Match inner header CoS
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                    self.yang_name = "cos-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "cos-inr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                            class Dei(Entity):
                                                """
                                                Match DEI Bit
                                                
                                                .. attribute:: bit_value
                                                
                                                	Value of the DEI bit
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                    self.yang_name = "dei"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                    self._segment_path = lambda: "dei"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                            class DeiInr(Entity):
                                                """
                                                Match inner DEI Bit
                                                
                                                .. attribute:: bit_value
                                                
                                                	Value of the DEI bit
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                    self.yang_name = "dei-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                    self._segment_path = lambda: "dei-inr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                            class DhcpClientId(Entity):
                                                """
                                                Dhcp Client ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                    self.yang_name = "dhcp-client-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "dhcp-client-id"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                            class DhcpClientIdRegex(Entity):
                                                """
                                                Dhcp Client ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                    self.yang_name = "dhcp-client-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                            class DiscardClass(Entity):
                                                """
                                                Match Discard Class array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                    self.yang_name = "discard-class"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "discard-class"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                            class Dnis(Entity):
                                                """
                                                DNIS
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                    self.yang_name = "dnis"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "dnis"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                            class DnisRegex(Entity):
                                                """
                                                DNIS Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                    self.yang_name = "dnis-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "dnis-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                            class Domain(Entity):
                                                """
                                                Domain Name
                                                
                                                .. attribute:: domain_array
                                                
                                                	domain array
                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                    self.yang_name = "domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                    self.domain_array = YList(self)
                                                    self._segment_path = lambda: "domain"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                class DomainArray(Entity):
                                                    """
                                                    domain array
                                                    
                                                    .. attribute:: domain_name
                                                    
                                                    	domain name
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: format_name
                                                    
                                                    	format name
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                        self.yang_name = "domain-array"
                                                        self.yang_parent_name = "domain"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                        self._segment_path = lambda: "domain-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                            class DomainRegex(Entity):
                                                """
                                                Domain Regular Expression
                                                
                                                .. attribute:: domain_array
                                                
                                                	domain array
                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                    self.yang_name = "domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                    self.domain_array = YList(self)
                                                    self._segment_path = lambda: "domain-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                class DomainArray(Entity):
                                                    """
                                                    domain array
                                                    
                                                    .. attribute:: domain_name
                                                    
                                                    	domain name
                                                    	**type**\:  str
                                                    
                                                    .. attribute:: format_name
                                                    
                                                    	format name
                                                    	**type**\:  str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                        self.yang_name = "domain-array"
                                                        self.yang_parent_name = "domain-regex"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                        self._segment_path = lambda: "domain-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                            class Dscp(Entity):
                                                """
                                                Match DSCP range array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                    self.yang_name = "dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "dscp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                            class DstAddrIpv4(Entity):
                                                """
                                                Destination Address IPV4
                                                
                                                .. attribute:: ipv4_addr_array
                                                
                                                	ipv4 addr array
                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                    self.yang_name = "dst-addr-ipv4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                    self.ipv4_addr_array = YList(self)
                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                class Ipv4AddrArray(Entity):
                                                    """
                                                    ipv4 addr array
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	mask
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	prefix
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                        self.yang_name = "ipv4-addr-array"
                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mask = YLeaf(YType.str, "mask")

                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                            class DstAddrIpv6(Entity):
                                                """
                                                Destination Address IPV6
                                                
                                                .. attribute:: ipv6_addr_array
                                                
                                                	ipv6 addr array
                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                    self.yang_name = "dst-addr-ipv6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                    self.ipv6_addr_array = YList(self)
                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                class Ipv6AddrArray(Entity):
                                                    """
                                                    ipv6 addr array
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	IPV6 mask
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	IPV6 prefix
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                        self.yang_name = "ipv6-addr-array"
                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                            class DstMac(Entity):
                                                """
                                                Match Destination MAC address
                                                
                                                .. attribute:: mac_addr
                                                
                                                	MAC address
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: mask
                                                
                                                	MAC mask
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                    self.yang_name = "dst-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                    self._segment_path = lambda: "dst-mac"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                            class DstPort(Entity):
                                                """
                                                Destination port
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                    self.yang_name = "dst-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "dst-port"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "dst-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                            class EtherServiceAcl(Entity):
                                                """
                                                Ethernet\-Services Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                    self.yang_name = "ether-service-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "ether-service-acl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                            class Ethertype(Entity):
                                                """
                                                Ethernet type
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                    self.yang_name = "ethertype"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ethertype"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ethertype"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                            class FlowKeyData(Entity):
                                                """
                                                Flow key structure
                                                
                                                .. attribute:: flow_keys
                                                
                                                	flow keys
                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                
                                                .. attribute:: idle_timeout
                                                
                                                	Idle timeout of flows (in seconds)
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                	**units**\: second
                                                
                                                .. attribute:: max_count
                                                
                                                	Maximum count of flows
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                    self.yang_name = "flow-key-data"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                    self._child_list_classes = {}

                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                    self.flow_keys = PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                    self.flow_keys.parent = self
                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                    self._children_yang_names.add("flow-keys")
                                                    self._segment_path = lambda: "flow-key-data"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                class FlowKeys(Entity):
                                                    """
                                                    flow keys
                                                    
                                                    .. attribute:: keys
                                                    
                                                    	keys
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                    
                                                    .. attribute:: num
                                                    
                                                    	num
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                        self.yang_name = "flow-keys"
                                                        self.yang_parent_name = "flow-key-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.keys = YLeaf(YType.str, "keys")

                                                        self.num = YLeaf(YType.uint8, "num")
                                                        self._segment_path = lambda: "flow-keys"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                            class FlowTag(Entity):
                                                """
                                                Match flow\-tag array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                    self.yang_name = "flow-tag"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "flow-tag"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "flow-tag"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                            class FrDe(Entity):
                                                """
                                                Match FR DE value
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                    self.yang_name = "fr-de"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "fr-de"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                            class FrDlci(Entity):
                                                """
                                                Match FR DLCI range array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                    self.yang_name = "fr-dlci"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "fr-dlci"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "fr-dlci"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                            class IcmpV4(Entity):
                                                """
                                                Match ICMPV4 Protocol
                                                
                                                .. attribute:: code
                                                
                                                	Protocol code
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	Protocol type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                    self.yang_name = "icmp-v4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.code = YLeaf(YType.uint8, "code")

                                                    self.type = YLeaf(YType.uint8, "type")
                                                    self._segment_path = lambda: "icmp-v4"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                            class IcmpV6(Entity):
                                                """
                                                Match ICMPV6 Protocol array
                                                
                                                .. attribute:: code
                                                
                                                	Protocol code
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	Protocol type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                    self.yang_name = "icmp-v6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.code = YLeaf(YType.uint8, "code")

                                                    self.type = YLeaf(YType.uint8, "type")
                                                    self._segment_path = lambda: "icmp-v6"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                            class Icmpv4Code(Entity):
                                                """
                                                Match ipv4 icmp code
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                    self.yang_name = "icmpv4-code"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv4-code"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv4-code"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                            class Icmpv4Type(Entity):
                                                """
                                                Match ipv4 icmp type
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                    self.yang_name = "icmpv4-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv4-type"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv4-type"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                            class Icmpv6Code(Entity):
                                                """
                                                Match ipv6 icmp code
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                    self.yang_name = "icmpv6-code"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv6-code"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv6-code"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                            class Icmpv6Type(Entity):
                                                """
                                                Match ipv6 icmp type
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                    self.yang_name = "icmpv6-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "icmpv6-type"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "icmpv6-type"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                            class InputInterface(Entity):
                                                """
                                                Input interface
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                    self.yang_name = "input-interface"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "input-interface"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                            class InputIntfhdl(Entity):
                                                """
                                                Input interface handle
                                                
                                                .. attribute:: uint64_array
                                                
                                                	uint64 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                    self.yang_name = "input-intfhdl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                    self._segment_path = lambda: "input-intfhdl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                            class Ipv4Acl(Entity):
                                                """
                                                IPv4 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                    self.yang_name = "ipv4-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "ipv4-acl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                            class Ipv4Dscp(Entity):
                                                """
                                                IPv4 DSCP
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                    self.yang_name = "ipv4-dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv4-dscp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "ipv4-dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                            class Ipv4PacketLen(Entity):
                                                """
                                                IPv4 packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                    self.yang_name = "ipv4-packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ipv4-packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                            class Ipv4Prec(Entity):
                                                """
                                                IPv4 Precedence
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                    self.yang_name = "ipv4-prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "ipv4-prec"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                            class Ipv6Acl(Entity):
                                                """
                                                IPv6 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                    self.yang_name = "ipv6-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "ipv6-acl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                            class Ipv6Dscp(Entity):
                                                """
                                                IPv6 DSCP
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                    self.yang_name = "ipv6-dscp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv6-dscp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "ipv6-dscp"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                            class Ipv6PacketLen(Entity):
                                                """
                                                IPv6 packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                    self.yang_name = "ipv6-packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "ipv6-packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                            class Ipv6Prec(Entity):
                                                """
                                                IPv6 Precedence
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                    self.yang_name = "ipv6-prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "ipv6-prec"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                            class MediaType(Entity):
                                                """
                                                Media Type
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                    self.yang_name = "media-type"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "media-type"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                            class MplsDispIpv4Acl(Entity):
                                                """
                                                MPLS Disposition IPv4 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                            class MplsDispIpv6Acl(Entity):
                                                """
                                                MPLS Disposition IPv6 Access\-list
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                            class MplsExp(Entity):
                                                """
                                                Match MPLS experimental topmost array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                    self.yang_name = "mpls-exp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "mpls-exp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                            class MplsExpImp(Entity):
                                                """
                                                Match MPLS experimental imposition array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                    self.yang_name = "mpls-exp-imp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                            class MplsTopLabel(Entity):
                                                """
                                                MPLS Topmost LABEL
                                                
                                                .. attribute:: uint32_rng_array
                                                
                                                	uint32 rng array
                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                    self.yang_name = "mpls-top-label"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                    self.uint32_rng_array = YList(self)
                                                    self._segment_path = lambda: "mpls-top-label"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                class Uint32RngArray(Entity):
                                                    """
                                                    uint32 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                        self.yang_name = "uint32_rng_array"
                                                        self.yang_parent_name = "mpls-top-label"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint32, "max")

                                                        self.min = YLeaf(YType.uint32, "min")
                                                        self._segment_path = lambda: "uint32_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                            class NasPort(Entity):
                                                """
                                                NAS Port
                                                
                                                .. attribute:: nas_port_array
                                                
                                                	nas port array
                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                    self.yang_name = "nas-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                    self.nas_port_array = YList(self)
                                                    self._segment_path = lambda: "nas-port"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                class NasPortArray(Entity):
                                                    """
                                                    nas port array
                                                    
                                                    .. attribute:: operator
                                                    
                                                    	operator
                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                    
                                                    .. attribute:: sub_id
                                                    
                                                    	sub id
                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                    
                                                    .. attribute:: value
                                                    
                                                    	value
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                        self.yang_name = "nas-port-array"
                                                        self.yang_parent_name = "nas-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                        self.value = YLeaf(YType.uint32, "value")
                                                        self._segment_path = lambda: "nas-port-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                            class PacketLen(Entity):
                                                """
                                                Match packet length array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                    self.yang_name = "packet-len"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "packet-len"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "packet-len"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                            class Prec(Entity):
                                                """
                                                Match Precedence array
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                    self.yang_name = "prec"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "prec"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                            class Proto(Entity):
                                                """
                                                Match Protocol array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                    self.yang_name = "proto"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "proto"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "proto"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                            class QosGroup(Entity):
                                                """
                                                Match QoS group array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                    self.yang_name = "qos-group"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "qos-group"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "qos-group"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                            class RemoteId(Entity):
                                                """
                                                Remote ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                    self.yang_name = "remote-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "remote-id"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                            class RemoteIdRegex(Entity):
                                                """
                                                Remote ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                    self.yang_name = "remote-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "remote-id-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                            class ServiceName(Entity):
                                                """
                                                Service Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                    self.yang_name = "service-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "service-name"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                            class ServiceNameRegex(Entity):
                                                """
                                                Service Name Regular Exp
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                    self.yang_name = "service-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "service-name-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                            class SrcAddrIpv4(Entity):
                                                """
                                                Source Address IPV4
                                                
                                                .. attribute:: ipv4_addr_array
                                                
                                                	ipv4 addr array
                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                    self.yang_name = "src-addr-ipv4"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                    self.ipv4_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                class Ipv4AddrArray(Entity):
                                                    """
                                                    ipv4 addr array
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	mask
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	prefix
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                        self.yang_name = "ipv4-addr-array"
                                                        self.yang_parent_name = "src-addr-ipv4"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mask = YLeaf(YType.str, "mask")

                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                            class SrcAddrIpv6(Entity):
                                                """
                                                Source Address IPV6
                                                
                                                .. attribute:: ipv6_addr_array
                                                
                                                	ipv6 addr array
                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                    self.yang_name = "src-addr-ipv6"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                    self.ipv6_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                class Ipv6AddrArray(Entity):
                                                    """
                                                    ipv6 addr array
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	IPV6 mask
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prefix
                                                    
                                                    	IPV6 prefix
                                                    	**type**\:  str
                                                    
                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                        self.yang_name = "ipv6-addr-array"
                                                        self.yang_parent_name = "src-addr-ipv6"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                            class SrcAddrMac(Entity):
                                                """
                                                Source Address MAC
                                                
                                                .. attribute:: mac_addr_array
                                                
                                                	mac addr array
                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                    self.yang_name = "src-addr-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                    self.mac_addr_array = YList(self)
                                                    self._segment_path = lambda: "src-addr-mac"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                class MacAddrArray(Entity):
                                                    """
                                                    mac addr array
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                        self.yang_name = "mac-addr-array"
                                                        self.yang_parent_name = "src-addr-mac"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                        self._segment_path = lambda: "mac-addr-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                            class SrcMac(Entity):
                                                """
                                                Match Source MAC address
                                                
                                                .. attribute:: mac_addr
                                                
                                                	MAC address
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: mask
                                                
                                                	MAC mask
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                    self.yang_name = "src-mac"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                    self._segment_path = lambda: "src-mac"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                            class SrcPort(Entity):
                                                """
                                                Source port
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                    self.yang_name = "src-port"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "src-port"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "src-port"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                            class SubsProtocol(Entity):
                                                """
                                                Protocol
                                                
                                                .. attribute:: uint8_array
                                                
                                                	uint8 array
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                    self.yang_name = "subs-protocol"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                    self._segment_path = lambda: "subs-protocol"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                            class TcpFlag(Entity):
                                                """
                                                Match tcp flag value
                                                
                                                .. attribute:: match_any
                                                
                                                	Match any TCP flag bit
                                                	**type**\:  bool
                                                
                                                .. attribute:: value
                                                
                                                	Value of TCP flag
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                    self.yang_name = "tcp-flag"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                    self.value = YLeaf(YType.uint16, "value")
                                                    self._segment_path = lambda: "tcp-flag"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                            class Timer(Entity):
                                                """
                                                Timer
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                    self.yang_name = "timer"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "timer"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                            class TimerRegexp(Entity):
                                                """
                                                Timer Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                    self.yang_name = "timer-regexp"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "timer-regexp"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                            class TrafficClass(Entity):
                                                """
                                                Match Traffic class array
                                                
                                                .. attribute:: uint8_rng_array
                                                
                                                	uint8 rng array
                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                    self.yang_name = "traffic-class"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                    self.uint8_rng_array = YList(self)
                                                    self._segment_path = lambda: "traffic-class"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                class Uint8RngArray(Entity):
                                                    """
                                                    uint8 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                        self.yang_name = "uint8_rng_array"
                                                        self.yang_parent_name = "traffic-class"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint8, "max")

                                                        self.min = YLeaf(YType.uint8, "min")
                                                        self._segment_path = lambda: "uint8_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                            class TunnelName(Entity):
                                                """
                                                Tunnel Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                    self.yang_name = "tunnel-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "tunnel-name"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                            class TunnelNameRegex(Entity):
                                                """
                                                Tunnel Name Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                    self.yang_name = "tunnel-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                            class UnauthDomain(Entity):
                                                """
                                                Unauthenticated Domain Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                    self.yang_name = "unauth-domain"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "unauth-domain"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                            class UnauthDomainRegex(Entity):
                                                """
                                                Unauthenticated Domain Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                    self.yang_name = "unauth-domain-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                            class UnauthUsername(Entity):
                                                """
                                                Unauthenticated User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                    self.yang_name = "unauth-username"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "unauth-username"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                            class UnauthUsernameRegex(Entity):
                                                """
                                                Unauthenticated User Name RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                    self.yang_name = "unauth-username-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "unauth-username-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                            class UserName(Entity):
                                                """
                                                User Name
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                    self.yang_name = "user-name"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "user-name"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                            class UserNameRegex(Entity):
                                                """
                                                User Name Regular Expression
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                    self.yang_name = "user-name-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "user-name-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                            class VendorId(Entity):
                                                """
                                                Vendor ID
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                    self.yang_name = "vendor-id"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "vendor-id"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                            class VendorIdRegex(Entity):
                                                """
                                                Vendor ID RegEx
                                                
                                                .. attribute:: string_array
                                                
                                                	string array
                                                	**type**\:  list of str
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                    self.yang_name = "vendor-id-regex"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                    self._segment_path = lambda: "vendor-id-regex"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                            class Vlan(Entity):
                                                """
                                                Match VLAN array
                                                
                                                .. attribute:: vlan_id_array
                                                
                                                	vlan id array
                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                    self.yang_name = "vlan"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                    self.vlan_id_array = YList(self)
                                                    self._segment_path = lambda: "vlan"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                class VlanIdArray(Entity):
                                                    """
                                                    vlan id array
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	VLAN mask
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                        self.yang_name = "vlan-id-array"
                                                        self.yang_parent_name = "vlan"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "vlan-id-array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                            class VlanInr(Entity):
                                                """
                                                Match inner header VLAN range array
                                                
                                                .. attribute:: uint16_rng_array
                                                
                                                	uint16 rng array
                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                    self.yang_name = "vlan-inr"
                                                    self.yang_parent_name = "match-data"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                    self.uint16_rng_array = YList(self)
                                                    self._segment_path = lambda: "vlan-inr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                class Uint16RngArray(Entity):
                                                    """
                                                    uint16 rng array
                                                    
                                                    .. attribute:: max
                                                    
                                                    	Upper limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: min
                                                    
                                                    	Lower limit of the range
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                        self.yang_name = "uint16_rng_array"
                                                        self.yang_parent_name = "vlan-inr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.max = YLeaf(YType.uint16, "max")

                                                        self.min = YLeaf(YType.uint16, "min")
                                                        self._segment_path = lambda: "uint16_rng_array"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


        class PolicyMap(Entity):
            """
            List of policymap details
            
            .. attribute:: policy_map_types
            
            	Application type of a policymap
            	**type**\:   :py:class:`PolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes>`
            
            .. attribute:: policy_map_unused_types
            
            	Policy\-map unused table
            	**type**\:   :py:class:`PolicyMapUnusedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes>`
            
            .. attribute:: transient_policy_map_type_xr
            
            	Application type of transient policy\-map
            	**type**\:   :py:class:`TransientPolicyMapTypeXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr>`
            
            .. attribute:: transient_policy_map_types
            
            	Application type of transient policy\-map list
            	**type**\:   :py:class:`TransientPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.PolicyMap, self).__init__()

                self.yang_name = "policy-map"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {"policy-map-types" : ("policy_map_types", PolicyManager.Global_.PolicyMap.PolicyMapTypes), "policy-map-unused-types" : ("policy_map_unused_types", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes), "transient-policy-map-type-xr" : ("transient_policy_map_type_xr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr), "transient-policy-map-types" : ("transient_policy_map_types", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes)}
                self._child_list_classes = {}

                self.policy_map_types = PolicyManager.Global_.PolicyMap.PolicyMapTypes()
                self.policy_map_types.parent = self
                self._children_name_map["policy_map_types"] = "policy-map-types"
                self._children_yang_names.add("policy-map-types")

                self.policy_map_unused_types = PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes()
                self.policy_map_unused_types.parent = self
                self._children_name_map["policy_map_unused_types"] = "policy-map-unused-types"
                self._children_yang_names.add("policy-map-unused-types")

                self.transient_policy_map_type_xr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr()
                self.transient_policy_map_type_xr.parent = self
                self._children_name_map["transient_policy_map_type_xr"] = "transient-policy-map-type-xr"
                self._children_yang_names.add("transient-policy-map-type-xr")

                self.transient_policy_map_types = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes()
                self.transient_policy_map_types.parent = self
                self._children_name_map["transient_policy_map_types"] = "transient-policy-map-types"
                self._children_yang_names.add("transient-policy-map-types")
                self._segment_path = lambda: "policy-map"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()


            class PolicyMapTypes(Entity):
                """
                Application type of a policymap
                
                .. attribute:: policy_map_type
                
                	Policymgr application type
                	**type**\: list of    :py:class:`PolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes, self).__init__()

                    self.yang_name = "policy-map-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"policy-map-type" : ("policy_map_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType)}

                    self.policy_map_type = YList(self)
                    self._segment_path = lambda: "policy-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes, [], name, value)


                class PolicyMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: policy_map_details
                    
                    	Policy\-map table
                    	**type**\:   :py:class:`PolicyMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails>`
                    
                    .. attribute:: policy_maps
                    
                    	Policy\-map definition table
                    	**type**\:   :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType, self).__init__()

                        self.yang_name = "policy-map-type"
                        self.yang_parent_name = "policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {"policy-map-details" : ("policy_map_details", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails), "policy-maps" : ("policy_maps", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.policy_map_details = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails()
                        self.policy_map_details.parent = self
                        self._children_name_map["policy_map_details"] = "policy-map-details"
                        self._children_yang_names.add("policy-map-details")

                        self.policy_maps = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps()
                        self.policy_maps.parent = self
                        self._children_name_map["policy_maps"] = "policy-maps"
                        self._children_yang_names.add("policy-maps")
                        self._segment_path = lambda: "policy-map-type" + "[type='" + self.type.get() + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/policy-map-types/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType, ['type'], name, value)


                    class PolicyMapDetails(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: policy_map_detail
                        
                        	Policy\-map detail information
                        	**type**\: list of    :py:class:`PolicyMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, self).__init__()

                            self.yang_name = "policy-map-details"
                            self.yang_parent_name = "policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"policy-map-detail" : ("policy_map_detail", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail)}

                            self.policy_map_detail = YList(self)
                            self._segment_path = lambda: "policy-map-details"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, [], name, value)


                        class PolicyMapDetail(Entity):
                            """
                            Policy\-map detail information
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference>`
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects>`
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, self).__init__()

                                self.yang_name = "policy-map-detail"
                                self.yang_parent_name = "policy-map-details"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects), "reference" : ("reference", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference)}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.total_objects = YLeaf(YType.uint32, "total-objects")

                                self.transient = YLeaf(YType.boolean, "transient")

                                self.class_map_reference = YList(self)
                                self.objects = YList(self)
                                self.reference = YList(self)
                                self._segment_path = lambda: "policy-map-detail" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference>`
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference)}

                                    self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_type = YLeaf(YType.enumeration, "object-type")

                                        self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                        self._segment_path = lambda: "policy-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.object_name = YLeaf(YType.str, "object-name")
                                    self._segment_path = lambda: "objects"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, ['object_name'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "policy-map-detail"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                    self.total_flows = YLeaf(YType.uint32, "total-flows")

                                    self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                    self._segment_path = lambda: "reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                    class PolicyMaps(Entity):
                        """
                        Policy\-map definition table
                        
                        .. attribute:: policy_map
                        
                        	Policy\-map configuration
                        	**type**\: list of    :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, self).__init__()

                            self.yang_name = "policy-maps"
                            self.yang_parent_name = "policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"policy-map" : ("policy_map", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap)}

                            self.policy_map = YList(self)
                            self._segment_path = lambda: "policy-maps"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, [], name, value)


                        class PolicyMap(Entity):
                            """
                            Policy\-map configuration
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: policy_map_bg
                            
                            	policy map bg
                            	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap, self).__init__()

                                self.yang_name = "policy-map"
                                self.yang_parent_name = "policy-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg)}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.policy_map_bg = YList(self)
                                self._segment_path = lambda: "policy-map" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap, ['policy_map_name'], name, value)


                            class PolicyMapBg(Entity):
                                """
                                policy map bg
                                
                                .. attribute:: description
                                
                                	description
                                	**type**\:  str
                                
                                .. attribute:: event_infop
                                
                                	event infop
                                	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop>`
                                
                                .. attribute:: name
                                
                                	name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList>`
                                
                                .. attribute:: type
                                
                                	type
                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg, self).__init__()

                                    self.yang_name = "policy-map-bg"
                                    self.yang_parent_name = "policy-map"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList)}
                                    self._child_list_classes = {}

                                    self.description = YLeaf(YType.str, "description")

                                    self.name = YLeaf(YType.str, "name")

                                    self.type = YLeaf(YType.enumeration, "type")

                                    self.event_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop()
                                    self.event_infop.parent = self
                                    self._children_name_map["event_infop"] = "event-infop"
                                    self._children_yang_names.add("event-infop")

                                    self.pmap_var_list = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList()
                                    self.pmap_var_list.parent = self
                                    self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                    self._children_yang_names.add("pmap-var-list")
                                    self._segment_path = lambda: "policy-map-bg"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                class EventInfop(Entity):
                                    """
                                    event infop
                                    
                                    .. attribute:: policy_event_info_bg
                                    
                                    	policy event info bg
                                    	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop, self).__init__()

                                        self.yang_name = "event-infop"
                                        self.yang_parent_name = "policy-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                        self.policy_event_info_bg = YList(self)
                                        self._segment_path = lambda: "event-infop"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop, [], name, value)


                                    class PolicyEventInfoBg(Entity):
                                        """
                                        policy event info bg
                                        
                                        .. attribute:: avl_tree
                                        
                                        	avl tree
                                        	**type**\:  int
                                        
                                        	**range:** 0..18446744073709551615
                                        
                                        .. attribute:: class_infop
                                        
                                        	class infop
                                        	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                        
                                        .. attribute:: cond_eval
                                        
                                        	cond eval
                                        	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                        
                                        .. attribute:: event_type
                                        
                                        	event type
                                        	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                        
                                        .. attribute:: flags
                                        
                                        	flags
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                            self.yang_name = "policy-event-info-bg"
                                            self.yang_parent_name = "event-infop"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                            self._child_list_classes = {}

                                            self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                            self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                            self.event_type = YLeaf(YType.enumeration, "event-type")

                                            self.flags = YLeaf(YType.uint32, "flags")

                                            self.class_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                            self.class_infop.parent = self
                                            self._children_name_map["class_infop"] = "class-infop"
                                            self._children_yang_names.add("class-infop")
                                            self._segment_path = lambda: "policy-event-info-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                        class ClassInfop(Entity):
                                            """
                                            class infop
                                            
                                            .. attribute:: policy_class_info_bg
                                            
                                            	policy class info bg
                                            	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                self.yang_name = "class-infop"
                                                self.yang_parent_name = "policy-event-info-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                self.policy_class_info_bg = YList(self)
                                                self._segment_path = lambda: "class-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                            class PolicyClassInfoBg(Entity):
                                                """
                                                policy class info bg
                                                
                                                .. attribute:: act_infop
                                                
                                                	act infop
                                                	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                
                                                .. attribute:: cl_encode
                                                
                                                	cl encode
                                                	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                
                                                .. attribute:: clmp_p
                                                
                                                	clmp p
                                                	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                
                                                .. attribute:: ctype
                                                
                                                	ctype
                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                
                                                .. attribute:: exe_strat
                                                
                                                	exe strat
                                                	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: num_actions
                                                
                                                	num actions
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: policy_class_hd
                                                
                                                	policy class hd
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: seq
                                                
                                                	seq
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: version
                                                
                                                	version
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                    self.yang_name = "policy-class-info-bg"
                                                    self.yang_parent_name = "class-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                    self._child_list_classes = {}

                                                    self.ctype = YLeaf(YType.enumeration, "ctype")

                                                    self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                    self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                    self.seq = YLeaf(YType.uint32, "seq")

                                                    self.version = YLeaf(YType.uint8, "version")

                                                    self.act_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                    self.act_infop.parent = self
                                                    self._children_name_map["act_infop"] = "act-infop"
                                                    self._children_yang_names.add("act-infop")

                                                    self.cl_encode = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                    self.cl_encode.parent = self
                                                    self._children_name_map["cl_encode"] = "cl-encode"
                                                    self._children_yang_names.add("cl-encode")

                                                    self.clmp_p = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                    self.clmp_p.parent = self
                                                    self._children_name_map["clmp_p"] = "clmp-p"
                                                    self._children_yang_names.add("clmp-p")
                                                    self._segment_path = lambda: "policy-class-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                class ActInfop(Entity):
                                                    """
                                                    act infop
                                                    
                                                    .. attribute:: policy_action_info_st
                                                    
                                                    	policy action info st
                                                    	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                        self.yang_name = "act-infop"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                        self.policy_action_info_st = YList(self)
                                                        self._segment_path = lambda: "act-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                    class PolicyActionInfoSt(Entity):
                                                        """
                                                        policy action info st
                                                        
                                                        .. attribute:: actp
                                                        
                                                        	actp
                                                        	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                            self.yang_name = "policy-action-info-st"
                                                            self.yang_parent_name = "act-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                            self._child_list_classes = {}

                                                            self.flags = YLeaf(YType.uint16, "flags")

                                                            self.seq = YLeaf(YType.uint16, "seq")

                                                            self.actp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                            self.actp.parent = self
                                                            self._children_name_map["actp"] = "actp"
                                                            self._children_yang_names.add("actp")
                                                            self._segment_path = lambda: "policy-action-info-st"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                        class Actp(Entity):
                                                            """
                                                            actp
                                                            
                                                            .. attribute:: accounting_event_aaa
                                                            
                                                            	accounting event aaa
                                                            	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                            
                                                            .. attribute:: acct_aaa_list
                                                            
                                                            	acct aaa list
                                                            	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                            
                                                            .. attribute:: act_template
                                                            
                                                            	act template
                                                            	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                            
                                                            .. attribute:: afm_react
                                                            
                                                            	afm react
                                                            	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                            
                                                            .. attribute:: authen_aaa
                                                            
                                                            	authen aaa
                                                            	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                            
                                                            .. attribute:: authorize_id
                                                            
                                                            	authorize id
                                                            	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                            
                                                            .. attribute:: bwrem
                                                            
                                                            	bwrem
                                                            	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                            
                                                            .. attribute:: cac
                                                            
                                                            	cac
                                                            	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                            
                                                            .. attribute:: child_policy
                                                            
                                                            	child policy
                                                            	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                            
                                                            .. attribute:: collect_id
                                                            
                                                            	collect id
                                                            	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                            
                                                            .. attribute:: copy
                                                            
                                                            	copy
                                                            	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                            
                                                            .. attribute:: data_p
                                                            
                                                            	data p
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: deact_template
                                                            
                                                            	deact template
                                                            	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                            
                                                            .. attribute:: decode_id
                                                            
                                                            	decode id
                                                            	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                            
                                                            .. attribute:: encap
                                                            
                                                            	encap
                                                            	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                            
                                                            .. attribute:: flow_parm
                                                            
                                                            	flow parm
                                                            	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                            
                                                            .. attribute:: fmm
                                                            
                                                            	fmm
                                                            	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                            
                                                            .. attribute:: httpr
                                                            
                                                            	httpr
                                                            	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                            
                                                            .. attribute:: ipcbr
                                                            
                                                            	ipcbr
                                                            	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                            
                                                            .. attribute:: ipv4_nh
                                                            
                                                            	ipv4 nh
                                                            	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                            
                                                            .. attribute:: ipv6_nh
                                                            
                                                            	ipv6 nh
                                                            	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                            
                                                            .. attribute:: mark
                                                            
                                                            	mark
                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                            
                                                            .. attribute:: mark2
                                                            
                                                            	mark2
                                                            	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                            
                                                            .. attribute:: mdi
                                                            
                                                            	mdi
                                                            	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                            
                                                            .. attribute:: mdi_rtp
                                                            
                                                            	mdi rtp
                                                            	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                            
                                                            .. attribute:: min_bw
                                                            
                                                            	min bw
                                                            	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                            
                                                            .. attribute:: out_intf
                                                            
                                                            	out intf
                                                            	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                            
                                                            .. attribute:: pbf
                                                            
                                                            	pbf
                                                            	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                            
                                                            .. attribute:: pfc
                                                            
                                                            	pfc
                                                            	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                            
                                                            .. attribute:: police
                                                            
                                                            	police
                                                            	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                            
                                                            .. attribute:: prepaid_cfg
                                                            
                                                            	prepaid cfg
                                                            	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                            
                                                            .. attribute:: prio
                                                            
                                                            	prio
                                                            	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                            
                                                            .. attribute:: proxy_aaa
                                                            
                                                            	proxy aaa
                                                            	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                            
                                                            .. attribute:: punt
                                                            
                                                            	punt
                                                            	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                            
                                                            .. attribute:: qlimit
                                                            
                                                            	qlimit
                                                            	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                            
                                                            .. attribute:: query_ancp
                                                            
                                                            	query ancp
                                                            	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                            
                                                            .. attribute:: redirect
                                                            
                                                            	redirect
                                                            	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                            
                                                            .. attribute:: rtp
                                                            
                                                            	rtp
                                                            	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                            
                                                            .. attribute:: rtp_j2k
                                                            
                                                            	rtp j2k
                                                            	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                            
                                                            .. attribute:: rtp_mmr
                                                            
                                                            	rtp mmr
                                                            	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                            
                                                            .. attribute:: rtp_voice
                                                            
                                                            	rtp voice
                                                            	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                            
                                                            .. attribute:: serv_func
                                                            
                                                            	serv func
                                                            	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                            
                                                            .. attribute:: set_timer
                                                            
                                                            	set timer
                                                            	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                            
                                                            .. attribute:: sfrag
                                                            
                                                            	sfrag
                                                            	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                            
                                                            .. attribute:: shape
                                                            
                                                            	shape
                                                            	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                            
                                                            .. attribute:: stop_timer
                                                            
                                                            	stop timer
                                                            	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                            
                                                            .. attribute:: timeout_idle
                                                            
                                                            	timeout idle
                                                            	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                            
                                                            .. attribute:: type
                                                            
                                                            	type
                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                            
                                                            .. attribute:: wred
                                                            
                                                            	wred
                                                            	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                self.yang_name = "actp"
                                                                self.yang_parent_name = "policy-action-info-st"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                self._child_list_classes = {}

                                                                self.data_p = YLeaf(YType.uint32, "data-p")

                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                self.accounting_event_aaa = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                self.accounting_event_aaa.parent = self
                                                                self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                self._children_yang_names.add("accounting-event-aaa")

                                                                self.acct_aaa_list = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                self.acct_aaa_list.parent = self
                                                                self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                self._children_yang_names.add("acct-aaa-list")

                                                                self.act_template = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                self.act_template.parent = self
                                                                self._children_name_map["act_template"] = "act-template"
                                                                self._children_yang_names.add("act-template")

                                                                self.afm_react = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                self.afm_react.parent = self
                                                                self._children_name_map["afm_react"] = "afm-react"
                                                                self._children_yang_names.add("afm-react")

                                                                self.authen_aaa = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                self.authen_aaa.parent = self
                                                                self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                self._children_yang_names.add("authen-aaa")

                                                                self.authorize_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                self.authorize_id.parent = self
                                                                self._children_name_map["authorize_id"] = "authorize-id"
                                                                self._children_yang_names.add("authorize-id")

                                                                self.bwrem = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                self.bwrem.parent = self
                                                                self._children_name_map["bwrem"] = "bwrem"
                                                                self._children_yang_names.add("bwrem")

                                                                self.cac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                self.cac.parent = self
                                                                self._children_name_map["cac"] = "cac"
                                                                self._children_yang_names.add("cac")

                                                                self.child_policy = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                self.child_policy.parent = self
                                                                self._children_name_map["child_policy"] = "child-policy"
                                                                self._children_yang_names.add("child-policy")

                                                                self.collect_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                self.collect_id.parent = self
                                                                self._children_name_map["collect_id"] = "collect-id"
                                                                self._children_yang_names.add("collect-id")

                                                                self.copy = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                self.copy.parent = self
                                                                self._children_name_map["copy"] = "copy"
                                                                self._children_yang_names.add("copy")

                                                                self.deact_template = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                self.deact_template.parent = self
                                                                self._children_name_map["deact_template"] = "deact-template"
                                                                self._children_yang_names.add("deact-template")

                                                                self.decode_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                self.decode_id.parent = self
                                                                self._children_name_map["decode_id"] = "decode-id"
                                                                self._children_yang_names.add("decode-id")

                                                                self.encap = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                self.encap.parent = self
                                                                self._children_name_map["encap"] = "encap"
                                                                self._children_yang_names.add("encap")

                                                                self.flow_parm = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                self.flow_parm.parent = self
                                                                self._children_name_map["flow_parm"] = "flow-parm"
                                                                self._children_yang_names.add("flow-parm")

                                                                self.fmm = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                self.fmm.parent = self
                                                                self._children_name_map["fmm"] = "fmm"
                                                                self._children_yang_names.add("fmm")

                                                                self.httpr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                self.httpr.parent = self
                                                                self._children_name_map["httpr"] = "httpr"
                                                                self._children_yang_names.add("httpr")

                                                                self.ipcbr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                self.ipcbr.parent = self
                                                                self._children_name_map["ipcbr"] = "ipcbr"
                                                                self._children_yang_names.add("ipcbr")

                                                                self.ipv4_nh = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                self.ipv4_nh.parent = self
                                                                self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                self._children_yang_names.add("ipv4-nh")

                                                                self.ipv6_nh = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                self.ipv6_nh.parent = self
                                                                self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                self._children_yang_names.add("ipv6-nh")

                                                                self.mark = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                self.mark.parent = self
                                                                self._children_name_map["mark"] = "mark"
                                                                self._children_yang_names.add("mark")

                                                                self.mark2 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                self.mark2.parent = self
                                                                self._children_name_map["mark2"] = "mark2"
                                                                self._children_yang_names.add("mark2")

                                                                self.mdi = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                self.mdi.parent = self
                                                                self._children_name_map["mdi"] = "mdi"
                                                                self._children_yang_names.add("mdi")

                                                                self.mdi_rtp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                self.mdi_rtp.parent = self
                                                                self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                self._children_yang_names.add("mdi-rtp")

                                                                self.min_bw = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                self.min_bw.parent = self
                                                                self._children_name_map["min_bw"] = "min-bw"
                                                                self._children_yang_names.add("min-bw")

                                                                self.out_intf = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                self.out_intf.parent = self
                                                                self._children_name_map["out_intf"] = "out-intf"
                                                                self._children_yang_names.add("out-intf")

                                                                self.pbf = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                self.pbf.parent = self
                                                                self._children_name_map["pbf"] = "pbf"
                                                                self._children_yang_names.add("pbf")

                                                                self.pfc = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                self.pfc.parent = self
                                                                self._children_name_map["pfc"] = "pfc"
                                                                self._children_yang_names.add("pfc")

                                                                self.police = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                self.police.parent = self
                                                                self._children_name_map["police"] = "police"
                                                                self._children_yang_names.add("police")

                                                                self.prepaid_cfg = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                self.prepaid_cfg.parent = self
                                                                self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                self._children_yang_names.add("prepaid-cfg")

                                                                self.prio = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                self.prio.parent = self
                                                                self._children_name_map["prio"] = "prio"
                                                                self._children_yang_names.add("prio")

                                                                self.proxy_aaa = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                self.proxy_aaa.parent = self
                                                                self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                self._children_yang_names.add("proxy-aaa")

                                                                self.punt = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                self.punt.parent = self
                                                                self._children_name_map["punt"] = "punt"
                                                                self._children_yang_names.add("punt")

                                                                self.qlimit = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                self.qlimit.parent = self
                                                                self._children_name_map["qlimit"] = "qlimit"
                                                                self._children_yang_names.add("qlimit")

                                                                self.query_ancp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                self.query_ancp.parent = self
                                                                self._children_name_map["query_ancp"] = "query-ancp"
                                                                self._children_yang_names.add("query-ancp")

                                                                self.redirect = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                self.redirect.parent = self
                                                                self._children_name_map["redirect"] = "redirect"
                                                                self._children_yang_names.add("redirect")

                                                                self.rtp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                self.rtp.parent = self
                                                                self._children_name_map["rtp"] = "rtp"
                                                                self._children_yang_names.add("rtp")

                                                                self.rtp_j2k = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                self.rtp_j2k.parent = self
                                                                self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                self._children_yang_names.add("rtp-j2k")

                                                                self.rtp_mmr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                self.rtp_mmr.parent = self
                                                                self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                self._children_yang_names.add("rtp-mmr")

                                                                self.rtp_voice = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                self.rtp_voice.parent = self
                                                                self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                self._children_yang_names.add("rtp-voice")

                                                                self.serv_func = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                self.serv_func.parent = self
                                                                self._children_name_map["serv_func"] = "serv-func"
                                                                self._children_yang_names.add("serv-func")

                                                                self.set_timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                self.set_timer.parent = self
                                                                self._children_name_map["set_timer"] = "set-timer"
                                                                self._children_yang_names.add("set-timer")

                                                                self.sfrag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                self.sfrag.parent = self
                                                                self._children_name_map["sfrag"] = "sfrag"
                                                                self._children_yang_names.add("sfrag")

                                                                self.shape = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                self.shape.parent = self
                                                                self._children_name_map["shape"] = "shape"
                                                                self._children_yang_names.add("shape")

                                                                self.stop_timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                self.stop_timer.parent = self
                                                                self._children_name_map["stop_timer"] = "stop-timer"
                                                                self._children_yang_names.add("stop-timer")

                                                                self.timeout_idle = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                self.timeout_idle.parent = self
                                                                self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                self._children_yang_names.add("timeout-idle")

                                                                self.wred = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                self.wred.parent = self
                                                                self._children_name_map["wred"] = "wred"
                                                                self._children_yang_names.add("wred")
                                                                self._segment_path = lambda: "actp"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                            class AccountingEventAaa(Entity):
                                                                """
                                                                accounting event aaa
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: action
                                                                
                                                                	action
                                                                	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                    self.yang_name = "accounting-event-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.action = YLeaf(YType.enumeration, "action")
                                                                    self._segment_path = lambda: "accounting-event-aaa"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                            class AcctAaaList(Entity):
                                                                """
                                                                acct aaa list
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: secs
                                                                
                                                                	secs
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                    self.yang_name = "acct-aaa-list"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.secs = YLeaf(YType.uint32, "secs")
                                                                    self._segment_path = lambda: "acct-aaa-list"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                            class ActTemplate(Entity):
                                                                """
                                                                act template
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: template_name
                                                                
                                                                	template name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                    self.yang_name = "act-template"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.template_name = YLeaf(YType.str, "template-name")
                                                                    self._segment_path = lambda: "act-template"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                            class AfmReact(Entity):
                                                                """
                                                                afm react
                                                                
                                                                .. attribute:: action_afmon_react_info
                                                                
                                                                	action afmon react info
                                                                	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                    self.yang_name = "afm-react"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                    self.action_afmon_react_info = YList(self)
                                                                    self._segment_path = lambda: "afm-react"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                class ActionAfmonReactInfo(Entity):
                                                                    """
                                                                    action afmon react info
                                                                    
                                                                    .. attribute:: alm_grp_thresh
                                                                    
                                                                    	Num/percent in grp
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    	**units**\: percentage
                                                                    
                                                                    .. attribute:: alm_severity
                                                                    
                                                                    	Major\|Minor\|... alarm
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: alm_type
                                                                    
                                                                    	Discrete \| grouped alarm
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: clone_ifh
                                                                    
                                                                    	Clone interface handle
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: criterion
                                                                    
                                                                    	React Criterion
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	Describing the oper
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: notif_actns
                                                                    
                                                                    	Bitmap of actions on alert
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: oper_id
                                                                    
                                                                    	React Operation ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: trig_level_1
                                                                    
                                                                    	Trigger threshold 1/lower
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: trig_level_2
                                                                    
                                                                    	Trigger upper threshold for range
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: trig_num_intvls
                                                                    
                                                                    	Averaged over N intvls
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: trig_relop
                                                                    
                                                                    	Trigger LT\|LE\|GT\|GE\|Range
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: trig_type
                                                                    
                                                                    	Immediate or averaged thresh trigger
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                        self.yang_name = "action-afmon-react-info"
                                                                        self.yang_parent_name = "afm-react"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                        self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                        self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                        self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                        self.criterion = YLeaf(YType.uint8, "criterion")

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                        self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                        self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                        self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                        self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                        self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                        self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                        self._segment_path = lambda: "action-afmon-react-info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                            class AuthenAaa(Entity):
                                                                """
                                                                authen aaa
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: authen_password
                                                                
                                                                	authen password
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                    self.yang_name = "authen-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.authen_password = YLeaf(YType.str, "authen-password")
                                                                    self._segment_path = lambda: "authen-aaa"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                            class AuthorizeId(Entity):
                                                                """
                                                                authorize id
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: format_name
                                                                
                                                                	format name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: password
                                                                
                                                                	password
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                    self.yang_name = "authorize-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.format_name = YLeaf(YType.str, "format-name")

                                                                    self.id = YLeaf(YType.uint8, "id")

                                                                    self.password = YLeaf(YType.str, "password")
                                                                    self._segment_path = lambda: "authorize-id"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                            class Bwrem(Entity):
                                                                """
                                                                bwrem
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                    self.yang_name = "bwrem"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                    self._child_list_classes = {}

                                                                    self.bwrem = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"
                                                                    self._children_yang_names.add("bwrem")
                                                                    self._segment_path = lambda: "bwrem"


                                                                class Bwrem(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "bwrem"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "bwrem"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                            class Cac(Entity):
                                                                """
                                                                cac
                                                                
                                                                .. attribute:: cac_type
                                                                
                                                                	cac type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: flow_rate
                                                                
                                                                	flow rate
                                                                	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                
                                                                .. attribute:: idle_timeout
                                                                
                                                                	idle timeout
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: rate
                                                                
                                                                	rate
                                                                	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                    self.yang_name = "cac"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                    self._child_list_classes = {}

                                                                    self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                    self.flow_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                    self.flow_rate.parent = self
                                                                    self._children_name_map["flow_rate"] = "flow-rate"
                                                                    self._children_yang_names.add("flow-rate")

                                                                    self.rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                    self.rate.parent = self
                                                                    self._children_name_map["rate"] = "rate"
                                                                    self._children_yang_names.add("rate")
                                                                    self._segment_path = lambda: "cac"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                class FlowRate(Entity):
                                                                    """
                                                                    flow rate
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                        self.yang_name = "flow-rate"
                                                                        self.yang_parent_name = "cac"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "flow-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                class Rate(Entity):
                                                                    """
                                                                    rate
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                        self.yang_name = "rate"
                                                                        self.yang_parent_name = "cac"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                            class ChildPolicy(Entity):
                                                                """
                                                                child policy
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                .. attribute:: hd_info
                                                                
                                                                	hd info
                                                                	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                
                                                                .. attribute:: info
                                                                
                                                                	info
                                                                	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                    self.yang_name = "child-policy"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                    self._child_list_classes = {}

                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                    self.hd_info = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                    self.hd_info.parent = self
                                                                    self._children_name_map["hd_info"] = "hd-info"
                                                                    self._children_yang_names.add("hd-info")

                                                                    self.info = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                    self.info.parent = self
                                                                    self._children_name_map["info"] = "info"
                                                                    self._children_yang_names.add("info")
                                                                    self._segment_path = lambda: "child-policy"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                class HdInfo(Entity):
                                                                    """
                                                                    hd info
                                                                    
                                                                    .. attribute:: data_hd
                                                                    
                                                                    	data hd
                                                                    	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                        self.yang_name = "hd-info"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                        self._child_list_classes = {}

                                                                        self.hd = YLeaf(YType.uint64, "hd")

                                                                        self.data_hd = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                        self.data_hd.parent = self
                                                                        self._children_name_map["data_hd"] = "data-hd"
                                                                        self._children_yang_names.add("data-hd")
                                                                        self._segment_path = lambda: "hd-info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                    class DataHd(Entity):
                                                                        """
                                                                        data hd
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                            self.yang_name = "data-hd"
                                                                            self.yang_parent_name = "hd-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}
                                                                            self._segment_path = lambda: "data-hd"


                                                                class Info(Entity):
                                                                    """
                                                                    info
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                        self.yang_name = "info"
                                                                        self.yang_parent_name = "child-policy"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.type = YLeaf(YType.enumeration, "type")
                                                                        self._segment_path = lambda: "info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                            class CollectId(Entity):
                                                                """
                                                                collect id
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                    self.yang_name = "collect-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.id = YLeaf(YType.enumeration, "id")
                                                                    self._segment_path = lambda: "collect-id"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                            class Copy(Entity):
                                                                """
                                                                copy
                                                                
                                                                .. attribute:: app_id
                                                                
                                                                	application ID
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: local_id
                                                                
                                                                	local ID
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: num_byte
                                                                
                                                                	number of bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: sn_index
                                                                
                                                                	service node index
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sn_name
                                                                
                                                                	service node url
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: sn_type
                                                                
                                                                	service node ID type
                                                                	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                
                                                                .. attribute:: vsnode_type
                                                                
                                                                	vservice node type
                                                                	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                    self.yang_name = "copy"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.app_id = YLeaf(YType.uint32, "app-id")

                                                                    self.local_id = YLeaf(YType.uint32, "local-id")

                                                                    self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                    self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                    self.sn_name = YLeaf(YType.str, "sn-name")

                                                                    self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                    self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                    self._segment_path = lambda: "copy"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                            class DeactTemplate(Entity):
                                                                """
                                                                deact template
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: template_name
                                                                
                                                                	template name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                    self.yang_name = "deact-template"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.template_name = YLeaf(YType.str, "template-name")
                                                                    self._segment_path = lambda: "deact-template"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                            class DecodeId(Entity):
                                                                """
                                                                decode id
                                                                
                                                                .. attribute:: format_name
                                                                
                                                                	format name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: id
                                                                
                                                                	id
                                                                	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                    self.yang_name = "decode-id"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.format_name = YLeaf(YType.str, "format-name")

                                                                    self.id = YLeaf(YType.enumeration, "id")
                                                                    self._segment_path = lambda: "decode-id"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                            class Encap(Entity):
                                                                """
                                                                encap
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                    self.yang_name = "encap"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.seq = YLeaf(YType.uint8, "seq")
                                                                    self._segment_path = lambda: "encap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                            class FlowParm(Entity):
                                                                """
                                                                flow parm
                                                                
                                                                .. attribute:: flow_timeout
                                                                
                                                                	timeout in secs
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: second
                                                                
                                                                .. attribute:: intvl_hist
                                                                
                                                                	num intervals of data stored on rtr
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_mon_flows
                                                                
                                                                	max simult flows monitored per policy class
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: mon_interval
                                                                
                                                                	monitored interval duration in secs
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: second
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                    self.yang_name = "flow-parm"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                    self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                    self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                    self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                    self._segment_path = lambda: "flow-parm"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                            class Fmm(Entity):
                                                                """
                                                                fmm
                                                                
                                                                .. attribute:: fmm_name
                                                                
                                                                	flow monitor name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..33
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                    self.yang_name = "fmm"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                    self._segment_path = lambda: "fmm"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                            class Httpr(Entity):
                                                                """
                                                                httpr
                                                                
                                                                .. attribute:: redirect_url
                                                                
                                                                	redirect url
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                    self.yang_name = "httpr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                    self._segment_path = lambda: "httpr"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                            class Ipcbr(Entity):
                                                                """
                                                                ipcbr
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: media_bit_rate
                                                                
                                                                	media data rate in bps
                                                                	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                
                                                                .. attribute:: media_pkt_size
                                                                
                                                                	media packet size in bytes
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                	**units**\: byte
                                                                
                                                                .. attribute:: media_pkts_per_ip
                                                                
                                                                	media packets per ip pkt
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                    self.yang_name = "ipcbr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                    self._child_list_classes = {}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                    self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                    self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                    self.ip_bit_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                    self._children_yang_names.add("ip-bit-rate")

                                                                    self.media_bit_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                    self.media_bit_rate.parent = self
                                                                    self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                    self._children_yang_names.add("media-bit-rate")
                                                                    self._segment_path = lambda: "ipcbr"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "ipcbr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "ip-bit-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                class MediaBitRate(Entity):
                                                                    """
                                                                    media data rate in bps
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                        self.yang_name = "media-bit-rate"
                                                                        self.yang_parent_name = "ipcbr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "media-bit-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                            class Ipv4Nh(Entity):
                                                                """
                                                                ipv4 nh
                                                                
                                                                .. attribute:: action_ipv4_nh_info_array
                                                                
                                                                	action ipv4 nh info array
                                                                	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                    self.yang_name = "ipv4-nh"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                    self.action_ipv4_nh_info_array = YList(self)
                                                                    self._segment_path = lambda: "ipv4-nh"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                class ActionIpv4NhInfoArray(Entity):
                                                                    """
                                                                    action ipv4 nh info array
                                                                    
                                                                    .. attribute:: nh_addr
                                                                    
                                                                    	nh addr
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: vrf_name
                                                                    
                                                                    	Vrf name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                        self.yang_name = "action-ipv4-nh-info-array"
                                                                        self.yang_parent_name = "ipv4-nh"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                        self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                        self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                            class Ipv6Nh(Entity):
                                                                """
                                                                ipv6 nh
                                                                
                                                                .. attribute:: action_ipv6_nh_info_array
                                                                
                                                                	action ipv6 nh info array
                                                                	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                    self.yang_name = "ipv6-nh"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                    self.action_ipv6_nh_info_array = YList(self)
                                                                    self._segment_path = lambda: "ipv6-nh"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                class ActionIpv6NhInfoArray(Entity):
                                                                    """
                                                                    action ipv6 nh info array
                                                                    
                                                                    .. attribute:: nh_addr
                                                                    
                                                                    	IPV6 Address
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: vrf_name
                                                                    
                                                                    	Vrf name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                        self.yang_name = "action-ipv6-nh-info-array"
                                                                        self.yang_parent_name = "ipv6-nh"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                        self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                        self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                            class Mark(Entity):
                                                                """
                                                                mark
                                                                
                                                                .. attribute:: action_mark_info
                                                                
                                                                	action mark info
                                                                	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                    self.yang_name = "mark"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                    self.action_mark_info = YList(self)
                                                                    self._segment_path = lambda: "mark"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                class ActionMarkInfo(Entity):
                                                                    """
                                                                    action mark info
                                                                    
                                                                    .. attribute:: mark_flags
                                                                    
                                                                    	mark flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                        self.yang_name = "action-mark-info"
                                                                        self.yang_parent_name = "mark"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                        self._segment_path = lambda: "action-mark-info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                            class Mark2(Entity):
                                                                """
                                                                mark2
                                                                
                                                                .. attribute:: action_mark2_info
                                                                
                                                                	action mark2 info
                                                                	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                    self.yang_name = "mark2"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                    self.action_mark2_info = YList(self)
                                                                    self._segment_path = lambda: "mark2"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                class ActionMark2Info(Entity):
                                                                    """
                                                                    action mark2 info
                                                                    
                                                                    .. attribute:: mark_flags
                                                                    
                                                                    	mark flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: value_overflow
                                                                    
                                                                    	value overflow
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                        self.yang_name = "action-mark2-info"
                                                                        self.yang_parent_name = "mark2"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                        self.type = YLeaf(YType.uint8, "type")

                                                                        self.value = YLeaf(YType.uint32, "value")

                                                                        self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                        self._segment_path = lambda: "action-mark2-info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                            class Mdi(Entity):
                                                                """
                                                                mdi
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: filtered_pkt_rate
                                                                
                                                                	filtered packet rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pids
                                                                
                                                                	array of monitoredcd  pids
                                                                	**type**\:  list of int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                    self.yang_name = "mdi"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                    self._child_list_classes = {}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                    self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                    self.pids = YLeafList(YType.uint32, "pids")

                                                                    self.ip_bit_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                    self._children_yang_names.add("ip-bit-rate")
                                                                    self._segment_path = lambda: "mdi"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "mdi"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "ip-bit-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                            class MdiRtp(Entity):
                                                                """
                                                                mdi rtp
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: filtered_pkt_rate
                                                                
                                                                	filtered packet rate
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: ip_bit_rate
                                                                
                                                                	data rate in bps
                                                                	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                
                                                                .. attribute:: ip_pkt_rate
                                                                
                                                                	packet rate in pps
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pids
                                                                
                                                                	array of monitoredcd  pids
                                                                	**type**\:  list of int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                    self.yang_name = "mdi-rtp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                    self._child_list_classes = {}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                    self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                    self.pids = YLeafList(YType.uint32, "pids")

                                                                    self.ip_bit_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                    self.ip_bit_rate.parent = self
                                                                    self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                    self._children_yang_names.add("ip-bit-rate")
                                                                    self._segment_path = lambda: "mdi-rtp"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                class IpBitRate(Entity):
                                                                    """
                                                                    data rate in bps
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                        self.yang_name = "ip-bit-rate"
                                                                        self.yang_parent_name = "mdi-rtp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "ip-bit-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                            class MinBw(Entity):
                                                                """
                                                                min bw
                                                                
                                                                .. attribute:: bw
                                                                
                                                                	bw
                                                                	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                    self.yang_name = "min-bw"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                    self._child_list_classes = {}

                                                                    self.bw = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                    self.bw.parent = self
                                                                    self._children_name_map["bw"] = "bw"
                                                                    self._children_yang_names.add("bw")
                                                                    self._segment_path = lambda: "min-bw"


                                                                class Bw(Entity):
                                                                    """
                                                                    bw
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                        self.yang_name = "bw"
                                                                        self.yang_parent_name = "min-bw"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "bw"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                            class OutIntf(Entity):
                                                                """
                                                                out intf
                                                                
                                                                .. attribute:: out_ifname
                                                                
                                                                	output interface name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                    self.yang_name = "out-intf"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                    self._segment_path = lambda: "out-intf"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                            class Pbf(Entity):
                                                                """
                                                                pbf
                                                                
                                                                .. attribute:: action_pbf_info_array
                                                                
                                                                	action pbf info array
                                                                	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                    self.yang_name = "pbf"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                    self.action_pbf_info_array = YList(self)
                                                                    self._segment_path = lambda: "pbf"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                class ActionPbfInfoArray(Entity):
                                                                    """
                                                                    action pbf info array
                                                                    
                                                                    .. attribute:: addr
                                                                    
                                                                    	v4 or v6 address
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                    
                                                                    .. attribute:: rt
                                                                    
                                                                    	route target
                                                                    	**type**\:  str
                                                                    
                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                    
                                                                    .. attribute:: rt_type
                                                                    
                                                                    	route target type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: vrf
                                                                    
                                                                    	vrf name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                        self.yang_name = "action-pbf-info-array"
                                                                        self.yang_parent_name = "pbf"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.addr = YLeaf(YType.str, "addr")

                                                                        self.rt = YLeaf(YType.str, "rt")

                                                                        self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                        self.vrf = YLeaf(YType.str, "vrf")
                                                                        self._segment_path = lambda: "action-pbf-info-array"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                            class Pfc(Entity):
                                                                """
                                                                pfc
                                                                
                                                                .. attribute:: buffer_size
                                                                
                                                                	buffer size
                                                                	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                
                                                                .. attribute:: buffer_size_flag
                                                                
                                                                	buffer size flag
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: pause_threshold
                                                                
                                                                	pause threshold
                                                                	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                
                                                                .. attribute:: pfc_pause_set
                                                                
                                                                	pfc pause set
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: resume_threshold
                                                                
                                                                	resume threshold
                                                                	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                    self.yang_name = "pfc"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                    self._child_list_classes = {}

                                                                    self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                    self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                    self.buffer_size = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                    self.buffer_size.parent = self
                                                                    self._children_name_map["buffer_size"] = "buffer-size"
                                                                    self._children_yang_names.add("buffer-size")

                                                                    self.pause_threshold = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                    self.pause_threshold.parent = self
                                                                    self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                    self._children_yang_names.add("pause-threshold")

                                                                    self.resume_threshold = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                    self.resume_threshold.parent = self
                                                                    self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                    self._children_yang_names.add("resume-threshold")
                                                                    self._segment_path = lambda: "pfc"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                class BufferSize(Entity):
                                                                    """
                                                                    buffer size
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                        self.yang_name = "buffer-size"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "buffer-size"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                class PauseThreshold(Entity):
                                                                    """
                                                                    pause threshold
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                        self.yang_name = "pause-threshold"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "pause-threshold"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                class ResumeThreshold(Entity):
                                                                    """
                                                                    resume threshold
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                        self.yang_name = "resume-threshold"
                                                                        self.yang_parent_name = "pfc"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "resume-threshold"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                            class Police(Entity):
                                                                """
                                                                police
                                                                
                                                                .. attribute:: burst
                                                                
                                                                	burst
                                                                	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                
                                                                .. attribute:: cdvt
                                                                
                                                                	cdvt
                                                                	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                
                                                                .. attribute:: confclass_encode
                                                                
                                                                	confclass encode
                                                                	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                
                                                                .. attribute:: confclass_p
                                                                
                                                                	confclass p
                                                                	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                
                                                                .. attribute:: conform_actns
                                                                
                                                                	conform actns
                                                                	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                
                                                                .. attribute:: excdclass_encode
                                                                
                                                                	excdclass encode
                                                                	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                
                                                                .. attribute:: excdclass_p
                                                                
                                                                	excdclass p
                                                                	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                
                                                                .. attribute:: exceed_actns
                                                                
                                                                	exceed actns
                                                                	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: peak_burst
                                                                
                                                                	peak burst
                                                                	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                
                                                                .. attribute:: peak_rate
                                                                
                                                                	peak rate
                                                                	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                
                                                                .. attribute:: police_flags
                                                                
                                                                	police flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: rate
                                                                
                                                                	rate
                                                                	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                
                                                                .. attribute:: sbuck_name
                                                                
                                                                	sbuck name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: sbuck_type
                                                                
                                                                	sbuck type
                                                                	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                
                                                                .. attribute:: violate_actns
                                                                
                                                                	violate actns
                                                                	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                    self.yang_name = "police"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                    self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                    self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                    self.burst = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                    self.burst.parent = self
                                                                    self._children_name_map["burst"] = "burst"
                                                                    self._children_yang_names.add("burst")

                                                                    self.cdvt = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                    self.cdvt.parent = self
                                                                    self._children_name_map["cdvt"] = "cdvt"
                                                                    self._children_yang_names.add("cdvt")

                                                                    self.confclass_encode = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                    self.confclass_encode.parent = self
                                                                    self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                    self._children_yang_names.add("confclass-encode")

                                                                    self.confclass_p = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                    self.confclass_p.parent = self
                                                                    self._children_name_map["confclass_p"] = "confclass-p"
                                                                    self._children_yang_names.add("confclass-p")

                                                                    self.conform_actns = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                    self.conform_actns.parent = self
                                                                    self._children_name_map["conform_actns"] = "conform-actns"
                                                                    self._children_yang_names.add("conform-actns")

                                                                    self.excdclass_encode = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                    self.excdclass_encode.parent = self
                                                                    self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                    self._children_yang_names.add("excdclass-encode")

                                                                    self.excdclass_p = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                    self.excdclass_p.parent = self
                                                                    self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                    self._children_yang_names.add("excdclass-p")

                                                                    self.exceed_actns = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                    self.exceed_actns.parent = self
                                                                    self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                    self._children_yang_names.add("exceed-actns")

                                                                    self.peak_burst = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                    self.peak_burst.parent = self
                                                                    self._children_name_map["peak_burst"] = "peak-burst"
                                                                    self._children_yang_names.add("peak-burst")

                                                                    self.peak_rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                    self.peak_rate.parent = self
                                                                    self._children_name_map["peak_rate"] = "peak-rate"
                                                                    self._children_yang_names.add("peak-rate")

                                                                    self.rate = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                    self.rate.parent = self
                                                                    self._children_name_map["rate"] = "rate"
                                                                    self._children_yang_names.add("rate")

                                                                    self.violate_actns = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                    self.violate_actns.parent = self
                                                                    self._children_name_map["violate_actns"] = "violate-actns"
                                                                    self._children_yang_names.add("violate-actns")
                                                                    self._segment_path = lambda: "police"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                class Burst(Entity):
                                                                    """
                                                                    burst
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                        self.yang_name = "burst"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "burst"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                class Cdvt(Entity):
                                                                    """
                                                                    cdvt
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                        self.yang_name = "cdvt"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "cdvt"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                class ConfclassEncode(Entity):
                                                                    """
                                                                    confclass encode
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	class name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: idx
                                                                    
                                                                    	idx
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: inline_cmap
                                                                    
                                                                    	inline cmap
                                                                    	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                        self.yang_name = "confclass-encode"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                        self._child_list_classes = {}

                                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                                        self.enc = YLeaf(YType.enumeration, "enc")

                                                                        self.hd = YLeaf(YType.uint64, "hd")

                                                                        self.idx = YLeaf(YType.uint8, "idx")

                                                                        self.inline_cmap = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                        self.inline_cmap.parent = self
                                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                        self._children_yang_names.add("inline-cmap")
                                                                        self._segment_path = lambda: "confclass-encode"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                    class InlineCmap(Entity):
                                                                        """
                                                                        inline cmap
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Inline Class\-Map flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_count
                                                                        
                                                                        	Number of Match infos
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Inline Class\-Map Mode Match any/all
                                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                            self.yang_name = "inline-cmap"
                                                                            self.yang_parent_name = "confclass-encode"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_count = YLeaf(YType.uint32, "match-count")

                                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._children_yang_names.add("match-infop")
                                                                            self._segment_path = lambda: "inline-cmap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "inline-cmap"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._children_yang_names.add("match-data")
                                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                        self._child_list_classes = {}

                                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                                        self._children_yang_names.add("access-interface")

                                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                                        self._children_yang_names.add("atm-clp")

                                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                                        self._children_yang_names.add("auth-domain")

                                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                                        self._children_yang_names.add("auth-username")

                                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                        self._children_yang_names.add("auth-username-regex")

                                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                                        self._children_yang_names.add("avail-id")

                                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                                        self._children_yang_names.add("circuit-id")

                                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"
                                                                                        self._children_yang_names.add("cos")

                                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                                        self._children_yang_names.add("cos-inr")

                                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"
                                                                                        self._children_yang_names.add("dei")

                                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                                        self._children_yang_names.add("dei-inr")

                                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                                        self._children_yang_names.add("discard-class")

                                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"
                                                                                        self._children_yang_names.add("dnis")

                                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                        self._children_yang_names.add("dnis-regex")

                                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"
                                                                                        self._children_yang_names.add("domain")

                                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                                        self._children_yang_names.add("domain-regex")

                                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"
                                                                                        self._children_yang_names.add("dscp")

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                                        self._children_yang_names.add("dst-mac")

                                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._children_yang_names.add("dst-port")

                                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                        self._children_yang_names.add("ether-service-acl")

                                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                                        self._children_yang_names.add("ethertype")

                                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                        self._children_yang_names.add("flow-key-data")

                                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                                        self._children_yang_names.add("flow-tag")

                                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                                        self._children_yang_names.add("fr-de")

                                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                        self._children_yang_names.add("fr-dlci")

                                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                        self._children_yang_names.add("icmp-v4")

                                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                        self._children_yang_names.add("icmp-v6")

                                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                        self._children_yang_names.add("icmpv4-code")

                                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                        self._children_yang_names.add("icmpv4-type")

                                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                        self._children_yang_names.add("icmpv6-code")

                                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                        self._children_yang_names.add("icmpv6-type")

                                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                                        self._children_yang_names.add("input-interface")

                                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                        self._children_yang_names.add("input-intfhdl")

                                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                        self._children_yang_names.add("ipv4-acl")

                                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                        self._children_yang_names.add("ipv4-prec")

                                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                        self._children_yang_names.add("ipv6-acl")

                                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                        self._children_yang_names.add("ipv6-prec")

                                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"
                                                                                        self._children_yang_names.add("media-type")

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                        self._children_yang_names.add("mpls-exp")

                                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                        self._children_yang_names.add("mpls-top-label")

                                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                                        self._children_yang_names.add("nas-port")

                                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                                        self._children_yang_names.add("packet-len")

                                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"
                                                                                        self._children_yang_names.add("prec")

                                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"
                                                                                        self._children_yang_names.add("proto")

                                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                                        self._children_yang_names.add("qos-group")

                                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                                        self._children_yang_names.add("remote-id")

                                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                        self._children_yang_names.add("remote-id-regex")

                                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"
                                                                                        self._children_yang_names.add("service-name")

                                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                        self._children_yang_names.add("service-name-regex")

                                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                        self._children_yang_names.add("src-addr-mac")

                                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                                        self._children_yang_names.add("src-mac")

                                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"
                                                                                        self._children_yang_names.add("src-port")

                                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                        self._children_yang_names.add("subs-protocol")

                                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                        self._children_yang_names.add("tcp-flag")

                                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"
                                                                                        self._children_yang_names.add("timer")

                                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                        self._children_yang_names.add("timer-regexp")

                                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                                        self._children_yang_names.add("traffic-class")

                                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                        self._children_yang_names.add("tunnel-name")

                                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                        self._children_yang_names.add("unauth-domain")

                                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                                        self._children_yang_names.add("unauth-username")

                                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"
                                                                                        self._children_yang_names.add("user-name")

                                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                        self._children_yang_names.add("user-name-regex")

                                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                                        self._children_yang_names.add("vendor-id")

                                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"
                                                                                        self._children_yang_names.add("vlan")

                                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                        self._children_yang_names.add("vlan-inr")
                                                                                        self._segment_path = lambda: "match-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "access-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "atm-clp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "avail-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "discard-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "dst-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                            self._child_list_classes = {}

                                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._children_yang_names.add("flow-keys")
                                                                                            self._segment_path = lambda: "flow-key-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                                self._segment_path = lambda: "flow-keys"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "fr-de"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "input-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "media-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                                self._segment_path = lambda: "nas-port-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "src-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "subs-protocol"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\:  bool
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "tcp-flag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer-regexp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                class ConfclassP(Entity):
                                                                    """
                                                                    confclass p
                                                                    
                                                                    .. attribute:: class_map_bg
                                                                    
                                                                    	class map bg
                                                                    	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                        self.yang_name = "confclass-p"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                        self.class_map_bg = YList(self)
                                                                        self._segment_path = lambda: "confclass-p"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                    class ClassMapBg(Entity):
                                                                        """
                                                                        class map bg
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	description
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Class\-Map Mode Match any/Match all
                                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Name of the class\-map
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                            self.yang_name = "class-map-bg"
                                                                            self.yang_parent_name = "confclass-p"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                            self._child_list_classes = {}

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                                            self.name = YLeaf(YType.str, "name")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._children_yang_names.add("match-infop")
                                                                            self._segment_path = lambda: "class-map-bg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "class-map-bg"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._children_yang_names.add("match-data")
                                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                        self._child_list_classes = {}

                                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                                        self._children_yang_names.add("access-interface")

                                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                                        self._children_yang_names.add("atm-clp")

                                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                                        self._children_yang_names.add("auth-domain")

                                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                                        self._children_yang_names.add("auth-username")

                                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                        self._children_yang_names.add("auth-username-regex")

                                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                                        self._children_yang_names.add("avail-id")

                                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                                        self._children_yang_names.add("circuit-id")

                                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"
                                                                                        self._children_yang_names.add("cos")

                                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                                        self._children_yang_names.add("cos-inr")

                                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"
                                                                                        self._children_yang_names.add("dei")

                                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                                        self._children_yang_names.add("dei-inr")

                                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                                        self._children_yang_names.add("discard-class")

                                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"
                                                                                        self._children_yang_names.add("dnis")

                                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                        self._children_yang_names.add("dnis-regex")

                                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"
                                                                                        self._children_yang_names.add("domain")

                                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                                        self._children_yang_names.add("domain-regex")

                                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"
                                                                                        self._children_yang_names.add("dscp")

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                                        self._children_yang_names.add("dst-mac")

                                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._children_yang_names.add("dst-port")

                                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                        self._children_yang_names.add("ether-service-acl")

                                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                                        self._children_yang_names.add("ethertype")

                                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                        self._children_yang_names.add("flow-key-data")

                                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                                        self._children_yang_names.add("flow-tag")

                                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                                        self._children_yang_names.add("fr-de")

                                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                        self._children_yang_names.add("fr-dlci")

                                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                        self._children_yang_names.add("icmp-v4")

                                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                        self._children_yang_names.add("icmp-v6")

                                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                        self._children_yang_names.add("icmpv4-code")

                                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                        self._children_yang_names.add("icmpv4-type")

                                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                        self._children_yang_names.add("icmpv6-code")

                                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                        self._children_yang_names.add("icmpv6-type")

                                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                                        self._children_yang_names.add("input-interface")

                                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                        self._children_yang_names.add("input-intfhdl")

                                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                        self._children_yang_names.add("ipv4-acl")

                                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                        self._children_yang_names.add("ipv4-prec")

                                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                        self._children_yang_names.add("ipv6-acl")

                                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                        self._children_yang_names.add("ipv6-prec")

                                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"
                                                                                        self._children_yang_names.add("media-type")

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                        self._children_yang_names.add("mpls-exp")

                                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                        self._children_yang_names.add("mpls-top-label")

                                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                                        self._children_yang_names.add("nas-port")

                                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                                        self._children_yang_names.add("packet-len")

                                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"
                                                                                        self._children_yang_names.add("prec")

                                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"
                                                                                        self._children_yang_names.add("proto")

                                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                                        self._children_yang_names.add("qos-group")

                                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                                        self._children_yang_names.add("remote-id")

                                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                        self._children_yang_names.add("remote-id-regex")

                                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"
                                                                                        self._children_yang_names.add("service-name")

                                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                        self._children_yang_names.add("service-name-regex")

                                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                        self._children_yang_names.add("src-addr-mac")

                                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                                        self._children_yang_names.add("src-mac")

                                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"
                                                                                        self._children_yang_names.add("src-port")

                                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                        self._children_yang_names.add("subs-protocol")

                                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                        self._children_yang_names.add("tcp-flag")

                                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"
                                                                                        self._children_yang_names.add("timer")

                                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                        self._children_yang_names.add("timer-regexp")

                                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                                        self._children_yang_names.add("traffic-class")

                                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                        self._children_yang_names.add("tunnel-name")

                                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                        self._children_yang_names.add("unauth-domain")

                                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                                        self._children_yang_names.add("unauth-username")

                                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"
                                                                                        self._children_yang_names.add("user-name")

                                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                        self._children_yang_names.add("user-name-regex")

                                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                                        self._children_yang_names.add("vendor-id")

                                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"
                                                                                        self._children_yang_names.add("vlan")

                                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                        self._children_yang_names.add("vlan-inr")
                                                                                        self._segment_path = lambda: "match-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "access-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "atm-clp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "avail-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "discard-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "dst-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                            self._child_list_classes = {}

                                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._children_yang_names.add("flow-keys")
                                                                                            self._segment_path = lambda: "flow-key-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                                self._segment_path = lambda: "flow-keys"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "fr-de"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "input-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "media-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                                self._segment_path = lambda: "nas-port-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "src-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "subs-protocol"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\:  bool
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "tcp-flag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer-regexp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                class ConformActns(Entity):
                                                                    """
                                                                    conform actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                        self.yang_name = "conform-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "conform-actns"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "conform-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.mark = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._children_yang_names.add("mark")
                                                                            self._segment_path = lambda: "police-action-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "mark"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                class ExcdclassEncode(Entity):
                                                                    """
                                                                    excdclass encode
                                                                    
                                                                    .. attribute:: class_name
                                                                    
                                                                    	class name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: hd
                                                                    
                                                                    	hd
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..18446744073709551615
                                                                    
                                                                    .. attribute:: idx
                                                                    
                                                                    	idx
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: inline_cmap
                                                                    
                                                                    	inline cmap
                                                                    	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                        self.yang_name = "excdclass-encode"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                        self._child_list_classes = {}

                                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                                        self.enc = YLeaf(YType.enumeration, "enc")

                                                                        self.hd = YLeaf(YType.uint64, "hd")

                                                                        self.idx = YLeaf(YType.uint8, "idx")

                                                                        self.inline_cmap = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                        self.inline_cmap.parent = self
                                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                        self._children_yang_names.add("inline-cmap")
                                                                        self._segment_path = lambda: "excdclass-encode"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                    class InlineCmap(Entity):
                                                                        """
                                                                        inline cmap
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Inline Class\-Map flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_count
                                                                        
                                                                        	Number of Match infos
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Inline Class\-Map Mode Match any/all
                                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                            self.yang_name = "inline-cmap"
                                                                            self.yang_parent_name = "excdclass-encode"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_count = YLeaf(YType.uint32, "match-count")

                                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._children_yang_names.add("match-infop")
                                                                            self._segment_path = lambda: "inline-cmap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "inline-cmap"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._children_yang_names.add("match-data")
                                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                        self._child_list_classes = {}

                                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                                        self._children_yang_names.add("access-interface")

                                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                                        self._children_yang_names.add("atm-clp")

                                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                                        self._children_yang_names.add("auth-domain")

                                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                                        self._children_yang_names.add("auth-username")

                                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                        self._children_yang_names.add("auth-username-regex")

                                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                                        self._children_yang_names.add("avail-id")

                                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                                        self._children_yang_names.add("circuit-id")

                                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"
                                                                                        self._children_yang_names.add("cos")

                                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                                        self._children_yang_names.add("cos-inr")

                                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"
                                                                                        self._children_yang_names.add("dei")

                                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                                        self._children_yang_names.add("dei-inr")

                                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                                        self._children_yang_names.add("discard-class")

                                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"
                                                                                        self._children_yang_names.add("dnis")

                                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                        self._children_yang_names.add("dnis-regex")

                                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"
                                                                                        self._children_yang_names.add("domain")

                                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                                        self._children_yang_names.add("domain-regex")

                                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"
                                                                                        self._children_yang_names.add("dscp")

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                                        self._children_yang_names.add("dst-mac")

                                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._children_yang_names.add("dst-port")

                                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                        self._children_yang_names.add("ether-service-acl")

                                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                                        self._children_yang_names.add("ethertype")

                                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                        self._children_yang_names.add("flow-key-data")

                                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                                        self._children_yang_names.add("flow-tag")

                                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                                        self._children_yang_names.add("fr-de")

                                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                        self._children_yang_names.add("fr-dlci")

                                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                        self._children_yang_names.add("icmp-v4")

                                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                        self._children_yang_names.add("icmp-v6")

                                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                        self._children_yang_names.add("icmpv4-code")

                                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                        self._children_yang_names.add("icmpv4-type")

                                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                        self._children_yang_names.add("icmpv6-code")

                                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                        self._children_yang_names.add("icmpv6-type")

                                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                                        self._children_yang_names.add("input-interface")

                                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                        self._children_yang_names.add("input-intfhdl")

                                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                        self._children_yang_names.add("ipv4-acl")

                                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                        self._children_yang_names.add("ipv4-prec")

                                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                        self._children_yang_names.add("ipv6-acl")

                                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                        self._children_yang_names.add("ipv6-prec")

                                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"
                                                                                        self._children_yang_names.add("media-type")

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                        self._children_yang_names.add("mpls-exp")

                                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                        self._children_yang_names.add("mpls-top-label")

                                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                                        self._children_yang_names.add("nas-port")

                                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                                        self._children_yang_names.add("packet-len")

                                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"
                                                                                        self._children_yang_names.add("prec")

                                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"
                                                                                        self._children_yang_names.add("proto")

                                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                                        self._children_yang_names.add("qos-group")

                                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                                        self._children_yang_names.add("remote-id")

                                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                        self._children_yang_names.add("remote-id-regex")

                                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"
                                                                                        self._children_yang_names.add("service-name")

                                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                        self._children_yang_names.add("service-name-regex")

                                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                        self._children_yang_names.add("src-addr-mac")

                                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                                        self._children_yang_names.add("src-mac")

                                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"
                                                                                        self._children_yang_names.add("src-port")

                                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                        self._children_yang_names.add("subs-protocol")

                                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                        self._children_yang_names.add("tcp-flag")

                                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"
                                                                                        self._children_yang_names.add("timer")

                                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                        self._children_yang_names.add("timer-regexp")

                                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                                        self._children_yang_names.add("traffic-class")

                                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                        self._children_yang_names.add("tunnel-name")

                                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                        self._children_yang_names.add("unauth-domain")

                                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                                        self._children_yang_names.add("unauth-username")

                                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"
                                                                                        self._children_yang_names.add("user-name")

                                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                        self._children_yang_names.add("user-name-regex")

                                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                                        self._children_yang_names.add("vendor-id")

                                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"
                                                                                        self._children_yang_names.add("vlan")

                                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                        self._children_yang_names.add("vlan-inr")
                                                                                        self._segment_path = lambda: "match-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "access-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "atm-clp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "avail-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "discard-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "dst-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                            self._child_list_classes = {}

                                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._children_yang_names.add("flow-keys")
                                                                                            self._segment_path = lambda: "flow-key-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                                self._segment_path = lambda: "flow-keys"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "fr-de"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "input-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "media-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                                self._segment_path = lambda: "nas-port-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "src-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "subs-protocol"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\:  bool
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "tcp-flag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer-regexp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                class ExcdclassP(Entity):
                                                                    """
                                                                    excdclass p
                                                                    
                                                                    .. attribute:: class_map_bg
                                                                    
                                                                    	class map bg
                                                                    	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                        self.yang_name = "excdclass-p"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                        self.class_map_bg = YList(self)
                                                                        self._segment_path = lambda: "excdclass-p"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                    class ClassMapBg(Entity):
                                                                        """
                                                                        class map bg
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	description
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: match_infop
                                                                        
                                                                        	Pointer to the first Match info
                                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                        
                                                                        .. attribute:: mode
                                                                        
                                                                        	Class\-Map Mode Match any/Match all
                                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Name of the class\-map
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                            self.yang_name = "class-map-bg"
                                                                            self.yang_parent_name = "excdclass-p"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                            self._child_list_classes = {}

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                                            self.name = YLeaf(YType.str, "name")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                            self.match_infop.parent = self
                                                                            self._children_name_map["match_infop"] = "match-infop"
                                                                            self._children_yang_names.add("match-infop")
                                                                            self._segment_path = lambda: "class-map-bg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                        class MatchInfop(Entity):
                                                                            """
                                                                            Pointer to the first Match info
                                                                            
                                                                            .. attribute:: class_match_info_st
                                                                            
                                                                            	class match info st
                                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                self.yang_name = "match-infop"
                                                                                self.yang_parent_name = "class-map-bg"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                self.class_match_info_st = YList(self)
                                                                                self._segment_path = lambda: "match-infop"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                            class ClassMatchInfoSt(Entity):
                                                                                """
                                                                                class match info st
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_data
                                                                                
                                                                                	Match criteria
                                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                    self.yang_name = "class-match-info-st"
                                                                                    self.yang_parent_name = "match-infop"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                    self.match_data.parent = self
                                                                                    self._children_name_map["match_data"] = "match-data"
                                                                                    self._children_yang_names.add("match-data")
                                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                class MatchData(Entity):
                                                                                    """
                                                                                    Match criteria
                                                                                    
                                                                                    .. attribute:: access_interface
                                                                                    
                                                                                    	Access interface
                                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                    
                                                                                    .. attribute:: atm_clp
                                                                                    
                                                                                    	Match ATM CLP level
                                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                    
                                                                                    .. attribute:: auth_domain
                                                                                    
                                                                                    	Authenticated domain name
                                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                    
                                                                                    .. attribute:: auth_domain_regex
                                                                                    
                                                                                    	Authenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: auth_username
                                                                                    
                                                                                    	Authenticated User Name
                                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                    
                                                                                    .. attribute:: auth_username_regex
                                                                                    
                                                                                    	Authenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: authen_status
                                                                                    
                                                                                    	Authentication Status
                                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                    
                                                                                    .. attribute:: avail_id
                                                                                    
                                                                                    	Available Identifiers
                                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                    
                                                                                    .. attribute:: circuit_id
                                                                                    
                                                                                    	Circuit ID
                                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                    
                                                                                    .. attribute:: circuit_id_regex
                                                                                    
                                                                                    	Circuit ID RegEx
                                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                    
                                                                                    .. attribute:: cos
                                                                                    
                                                                                    	Match CoS array
                                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                    
                                                                                    .. attribute:: cos_inr
                                                                                    
                                                                                    	Match inner header CoS
                                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                    
                                                                                    .. attribute:: dei
                                                                                    
                                                                                    	Match DEI Bit
                                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                    
                                                                                    .. attribute:: dei_inr
                                                                                    
                                                                                    	Match inner DEI Bit
                                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id
                                                                                    
                                                                                    	Dhcp Client ID
                                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                    
                                                                                    .. attribute:: dhcp_client_id_regex
                                                                                    
                                                                                    	Dhcp Client ID RegEx
                                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                    
                                                                                    .. attribute:: discard_class
                                                                                    
                                                                                    	Match Discard Class array
                                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                    
                                                                                    .. attribute:: dnis
                                                                                    
                                                                                    	DNIS
                                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                    
                                                                                    .. attribute:: dnis_regex
                                                                                    
                                                                                    	DNIS Regular Expression
                                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                    
                                                                                    .. attribute:: domain
                                                                                    
                                                                                    	Domain Name
                                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                    
                                                                                    .. attribute:: domain_regex
                                                                                    
                                                                                    	Domain Regular Expression
                                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                    
                                                                                    .. attribute:: dscp
                                                                                    
                                                                                    	Match DSCP range array
                                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv4
                                                                                    
                                                                                    	Destination Address IPV4
                                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: dst_addr_ipv6
                                                                                    
                                                                                    	Destination Address IPV6
                                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: dst_mac
                                                                                    
                                                                                    	Match Destination MAC address
                                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                    
                                                                                    .. attribute:: dst_port
                                                                                    
                                                                                    	Destination port
                                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                    
                                                                                    .. attribute:: ether_service_acl
                                                                                    
                                                                                    	Ethernet\-Services Access\-list
                                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                    
                                                                                    .. attribute:: ethertype
                                                                                    
                                                                                    	Ethernet type
                                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                    
                                                                                    .. attribute:: flow_key_data
                                                                                    
                                                                                    	Flow key structure
                                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                    
                                                                                    .. attribute:: flow_tag
                                                                                    
                                                                                    	Match flow\-tag array
                                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                    
                                                                                    .. attribute:: fr_de
                                                                                    
                                                                                    	Match FR DE value
                                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                    
                                                                                    .. attribute:: fr_dlci
                                                                                    
                                                                                    	Match FR DLCI range array
                                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                    
                                                                                    .. attribute:: fragment_type
                                                                                    
                                                                                    	Fragment type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: icmp_v4
                                                                                    
                                                                                    	Match ICMPV4 Protocol
                                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                    
                                                                                    .. attribute:: icmp_v6
                                                                                    
                                                                                    	Match ICMPV6 Protocol array
                                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                    
                                                                                    .. attribute:: icmpv4_code
                                                                                    
                                                                                    	Match ipv4 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                    
                                                                                    .. attribute:: icmpv4_type
                                                                                    
                                                                                    	Match ipv4 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                    
                                                                                    .. attribute:: icmpv6_code
                                                                                    
                                                                                    	Match ipv6 icmp code
                                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                    
                                                                                    .. attribute:: icmpv6_type
                                                                                    
                                                                                    	Match ipv6 icmp type
                                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                    
                                                                                    .. attribute:: input_interface
                                                                                    
                                                                                    	Input interface
                                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                    
                                                                                    .. attribute:: input_intfhdl
                                                                                    
                                                                                    	Input interface handle
                                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                    
                                                                                    .. attribute:: ipv4_acl
                                                                                    
                                                                                    	IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                    
                                                                                    .. attribute:: ipv4_dscp
                                                                                    
                                                                                    	IPv4 DSCP
                                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv4_packet_len
                                                                                    
                                                                                    	IPv4 packet length array
                                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv4_prec
                                                                                    
                                                                                    	IPv4 Precedence
                                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                    
                                                                                    .. attribute:: ipv6_acl
                                                                                    
                                                                                    	IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                    
                                                                                    .. attribute:: ipv6_dscp
                                                                                    
                                                                                    	IPv6 DSCP
                                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                    
                                                                                    .. attribute:: ipv6_packet_len
                                                                                    
                                                                                    	IPv6 packet length array
                                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                    
                                                                                    .. attribute:: ipv6_prec
                                                                                    
                                                                                    	IPv6 Precedence
                                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                    
                                                                                    .. attribute:: media_type
                                                                                    
                                                                                    	Media Type
                                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                    
                                                                                    .. attribute:: mlp_negotiated
                                                                                    
                                                                                    	MLP Negotiated
                                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                                    
                                                                                    	MPLS Disposition IPv4 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                                    
                                                                                    	MPLS Disposition IPv6 Access\-list
                                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                    
                                                                                    .. attribute:: mpls_exp
                                                                                    
                                                                                    	Match MPLS experimental topmost array
                                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                    
                                                                                    .. attribute:: mpls_exp_imp
                                                                                    
                                                                                    	Match MPLS experimental imposition array
                                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                    
                                                                                    .. attribute:: mpls_top_eos
                                                                                    
                                                                                    	MPLS Topmost EOS
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: mpls_top_label
                                                                                    
                                                                                    	MPLS Topmost LABEL
                                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                    
                                                                                    .. attribute:: nas_port
                                                                                    
                                                                                    	NAS Port
                                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                    
                                                                                    .. attribute:: packet_len
                                                                                    
                                                                                    	Match packet length array
                                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                    
                                                                                    .. attribute:: prec
                                                                                    
                                                                                    	Match Precedence array
                                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                    
                                                                                    .. attribute:: proto
                                                                                    
                                                                                    	Match Protocol array
                                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                    
                                                                                    .. attribute:: qos_group
                                                                                    
                                                                                    	Match QoS group array
                                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                    
                                                                                    .. attribute:: remote_id
                                                                                    
                                                                                    	Remote ID
                                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                    
                                                                                    .. attribute:: remote_id_regex
                                                                                    
                                                                                    	Remote ID RegEx
                                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                    
                                                                                    .. attribute:: service_name
                                                                                    
                                                                                    	Service Name
                                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                    
                                                                                    .. attribute:: service_name_regex
                                                                                    
                                                                                    	Service Name Regular Exp
                                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv4
                                                                                    
                                                                                    	Source Address IPV4
                                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                    
                                                                                    .. attribute:: src_addr_ipv6
                                                                                    
                                                                                    	Source Address IPV6
                                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                    
                                                                                    .. attribute:: src_addr_mac
                                                                                    
                                                                                    	Source Address MAC
                                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                    
                                                                                    .. attribute:: src_mac
                                                                                    
                                                                                    	Match Source MAC address
                                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                    
                                                                                    .. attribute:: src_port
                                                                                    
                                                                                    	Source port
                                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                    
                                                                                    .. attribute:: subs_protocol
                                                                                    
                                                                                    	Protocol
                                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                    
                                                                                    .. attribute:: tcp_flag
                                                                                    
                                                                                    	Match tcp flag value
                                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                    
                                                                                    .. attribute:: timer
                                                                                    
                                                                                    	Timer
                                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                    
                                                                                    .. attribute:: timer_regexp
                                                                                    
                                                                                    	Timer Regular Expression
                                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                    
                                                                                    .. attribute:: traffic_class
                                                                                    
                                                                                    	Match Traffic class array
                                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                    
                                                                                    .. attribute:: tunnel_name
                                                                                    
                                                                                    	Tunnel Name
                                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                    
                                                                                    .. attribute:: tunnel_name_regex
                                                                                    
                                                                                    	Tunnel Name Regular Expression
                                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                    
                                                                                    .. attribute:: unauth_domain
                                                                                    
                                                                                    	Unauthenticated Domain Name
                                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                    
                                                                                    .. attribute:: unauth_domain_regex
                                                                                    
                                                                                    	Unauthenticated Domain Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                    
                                                                                    .. attribute:: unauth_username
                                                                                    
                                                                                    	Unauthenticated User Name
                                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                    
                                                                                    .. attribute:: unauth_username_regex
                                                                                    
                                                                                    	Unauthenticated User Name RegEx
                                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                    
                                                                                    .. attribute:: user_name
                                                                                    
                                                                                    	User Name
                                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                    
                                                                                    .. attribute:: user_name_regex
                                                                                    
                                                                                    	User Name Regular Expression
                                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                    
                                                                                    .. attribute:: vendor_id
                                                                                    
                                                                                    	Vendor ID
                                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                    
                                                                                    .. attribute:: vendor_id_regex
                                                                                    
                                                                                    	Vendor ID RegEx
                                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                    
                                                                                    .. attribute:: vlan
                                                                                    
                                                                                    	Match VLAN array
                                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                    
                                                                                    .. attribute:: vlan_inr
                                                                                    
                                                                                    	Match inner header VLAN range array
                                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                        self.yang_name = "match-data"
                                                                                        self.yang_parent_name = "class-match-info-st"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                        self._child_list_classes = {}

                                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                        self.access_interface.parent = self
                                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                                        self._children_yang_names.add("access-interface")

                                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                        self.atm_clp.parent = self
                                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                                        self._children_yang_names.add("atm-clp")

                                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                        self.auth_domain.parent = self
                                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                                        self._children_yang_names.add("auth-domain")

                                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                        self.auth_domain_regex.parent = self
                                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                        self.auth_username.parent = self
                                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                                        self._children_yang_names.add("auth-username")

                                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                        self.auth_username_regex.parent = self
                                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                        self._children_yang_names.add("auth-username-regex")

                                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                        self.avail_id.parent = self
                                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                                        self._children_yang_names.add("avail-id")

                                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                        self.circuit_id.parent = self
                                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                                        self._children_yang_names.add("circuit-id")

                                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                        self.circuit_id_regex.parent = self
                                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                        self.cos.parent = self
                                                                                        self._children_name_map["cos"] = "cos"
                                                                                        self._children_yang_names.add("cos")

                                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                        self.cos_inr.parent = self
                                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                                        self._children_yang_names.add("cos-inr")

                                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                        self.dei.parent = self
                                                                                        self._children_name_map["dei"] = "dei"
                                                                                        self._children_yang_names.add("dei")

                                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                        self.dei_inr.parent = self
                                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                                        self._children_yang_names.add("dei-inr")

                                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                        self.dhcp_client_id.parent = self
                                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                        self.dhcp_client_id_regex.parent = self
                                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                        self.discard_class.parent = self
                                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                                        self._children_yang_names.add("discard-class")

                                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                        self.dnis.parent = self
                                                                                        self._children_name_map["dnis"] = "dnis"
                                                                                        self._children_yang_names.add("dnis")

                                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                        self.dnis_regex.parent = self
                                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                        self._children_yang_names.add("dnis-regex")

                                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                        self.domain.parent = self
                                                                                        self._children_name_map["domain"] = "domain"
                                                                                        self._children_yang_names.add("domain")

                                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                        self.domain_regex.parent = self
                                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                                        self._children_yang_names.add("domain-regex")

                                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                        self.dscp.parent = self
                                                                                        self._children_name_map["dscp"] = "dscp"
                                                                                        self._children_yang_names.add("dscp")

                                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                        self.dst_addr_ipv4.parent = self
                                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                        self.dst_addr_ipv6.parent = self
                                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                        self.dst_mac.parent = self
                                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                                        self._children_yang_names.add("dst-mac")

                                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                        self.dst_port.parent = self
                                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                                        self._children_yang_names.add("dst-port")

                                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                        self.ether_service_acl.parent = self
                                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                        self._children_yang_names.add("ether-service-acl")

                                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                        self.ethertype.parent = self
                                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                                        self._children_yang_names.add("ethertype")

                                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                        self.flow_key_data.parent = self
                                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                        self._children_yang_names.add("flow-key-data")

                                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                        self.flow_tag.parent = self
                                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                                        self._children_yang_names.add("flow-tag")

                                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                        self.fr_de.parent = self
                                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                                        self._children_yang_names.add("fr-de")

                                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                        self.fr_dlci.parent = self
                                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                        self._children_yang_names.add("fr-dlci")

                                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                        self.icmp_v4.parent = self
                                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                        self._children_yang_names.add("icmp-v4")

                                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                        self.icmp_v6.parent = self
                                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                        self._children_yang_names.add("icmp-v6")

                                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                        self.icmpv4_code.parent = self
                                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                        self._children_yang_names.add("icmpv4-code")

                                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                        self.icmpv4_type.parent = self
                                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                        self._children_yang_names.add("icmpv4-type")

                                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                        self.icmpv6_code.parent = self
                                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                        self._children_yang_names.add("icmpv6-code")

                                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                        self.icmpv6_type.parent = self
                                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                        self._children_yang_names.add("icmpv6-type")

                                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                        self.input_interface.parent = self
                                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                                        self._children_yang_names.add("input-interface")

                                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                        self.input_intfhdl.parent = self
                                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                        self._children_yang_names.add("input-intfhdl")

                                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                        self.ipv4_acl.parent = self
                                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                        self._children_yang_names.add("ipv4-acl")

                                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                        self.ipv4_dscp.parent = self
                                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                        self.ipv4_packet_len.parent = self
                                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                        self.ipv4_prec.parent = self
                                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                        self._children_yang_names.add("ipv4-prec")

                                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                        self.ipv6_acl.parent = self
                                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                        self._children_yang_names.add("ipv6-acl")

                                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                        self.ipv6_dscp.parent = self
                                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                        self.ipv6_packet_len.parent = self
                                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                        self.ipv6_prec.parent = self
                                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                        self._children_yang_names.add("ipv6-prec")

                                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                        self.media_type.parent = self
                                                                                        self._children_name_map["media_type"] = "media-type"
                                                                                        self._children_yang_names.add("media-type")

                                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                        self.mpls_exp.parent = self
                                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                        self._children_yang_names.add("mpls-exp")

                                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                        self.mpls_exp_imp.parent = self
                                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                        self.mpls_top_label.parent = self
                                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                        self._children_yang_names.add("mpls-top-label")

                                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                        self.nas_port.parent = self
                                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                                        self._children_yang_names.add("nas-port")

                                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                        self.packet_len.parent = self
                                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                                        self._children_yang_names.add("packet-len")

                                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                        self.prec.parent = self
                                                                                        self._children_name_map["prec"] = "prec"
                                                                                        self._children_yang_names.add("prec")

                                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                        self.proto.parent = self
                                                                                        self._children_name_map["proto"] = "proto"
                                                                                        self._children_yang_names.add("proto")

                                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                        self.qos_group.parent = self
                                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                                        self._children_yang_names.add("qos-group")

                                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                        self.remote_id.parent = self
                                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                                        self._children_yang_names.add("remote-id")

                                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                        self.remote_id_regex.parent = self
                                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                        self._children_yang_names.add("remote-id-regex")

                                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                        self.service_name.parent = self
                                                                                        self._children_name_map["service_name"] = "service-name"
                                                                                        self._children_yang_names.add("service-name")

                                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                        self.service_name_regex.parent = self
                                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                        self._children_yang_names.add("service-name-regex")

                                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                        self.src_addr_ipv4.parent = self
                                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                        self.src_addr_ipv6.parent = self
                                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                        self.src_addr_mac.parent = self
                                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                        self._children_yang_names.add("src-addr-mac")

                                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                        self.src_mac.parent = self
                                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                                        self._children_yang_names.add("src-mac")

                                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                        self.src_port.parent = self
                                                                                        self._children_name_map["src_port"] = "src-port"
                                                                                        self._children_yang_names.add("src-port")

                                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                        self.subs_protocol.parent = self
                                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                        self._children_yang_names.add("subs-protocol")

                                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                        self.tcp_flag.parent = self
                                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                        self._children_yang_names.add("tcp-flag")

                                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                        self.timer.parent = self
                                                                                        self._children_name_map["timer"] = "timer"
                                                                                        self._children_yang_names.add("timer")

                                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                        self.timer_regexp.parent = self
                                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                        self._children_yang_names.add("timer-regexp")

                                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                        self.traffic_class.parent = self
                                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                                        self._children_yang_names.add("traffic-class")

                                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                        self.tunnel_name.parent = self
                                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                        self._children_yang_names.add("tunnel-name")

                                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                        self.tunnel_name_regex.parent = self
                                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                        self.unauth_domain.parent = self
                                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                        self._children_yang_names.add("unauth-domain")

                                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                        self.unauth_domain_regex.parent = self
                                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                        self.unauth_username.parent = self
                                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                                        self._children_yang_names.add("unauth-username")

                                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                        self.unauth_username_regex.parent = self
                                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                        self.user_name.parent = self
                                                                                        self._children_name_map["user_name"] = "user-name"
                                                                                        self._children_yang_names.add("user-name")

                                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                        self.user_name_regex.parent = self
                                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                        self._children_yang_names.add("user-name-regex")

                                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                        self.vendor_id.parent = self
                                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                                        self._children_yang_names.add("vendor-id")

                                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                        self.vendor_id_regex.parent = self
                                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                        self.vlan.parent = self
                                                                                        self._children_name_map["vlan"] = "vlan"
                                                                                        self._children_yang_names.add("vlan")

                                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                        self.vlan_inr.parent = self
                                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                        self._children_yang_names.add("vlan-inr")
                                                                                        self._segment_path = lambda: "match-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                    class AccessInterface(Entity):
                                                                                        """
                                                                                        Access interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                            self.yang_name = "access-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "access-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                    class AtmClp(Entity):
                                                                                        """
                                                                                        Match ATM CLP level
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                            self.yang_name = "atm-clp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "atm-clp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                    class AuthDomain(Entity):
                                                                                        """
                                                                                        Authenticated domain name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                            self.yang_name = "auth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                    class AuthDomainRegex(Entity):
                                                                                        """
                                                                                        Authenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                            self.yang_name = "auth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                    class AuthUsername(Entity):
                                                                                        """
                                                                                        Authenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                            self.yang_name = "auth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                    class AuthUsernameRegex(Entity):
                                                                                        """
                                                                                        Authenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "auth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                    class AvailId(Entity):
                                                                                        """
                                                                                        Available Identifiers
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                            self.yang_name = "avail-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "avail-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                    class CircuitId(Entity):
                                                                                        """
                                                                                        Circuit ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                            self.yang_name = "circuit-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                    class CircuitIdRegex(Entity):
                                                                                        """
                                                                                        Circuit ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                            self.yang_name = "circuit-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                    class Cos(Entity):
                                                                                        """
                                                                                        Match CoS array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                            self.yang_name = "cos"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                    class CosInr(Entity):
                                                                                        """
                                                                                        Match inner header CoS
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                            self.yang_name = "cos-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "cos-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                    class Dei(Entity):
                                                                                        """
                                                                                        Match DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                            self.yang_name = "dei"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                    class DeiInr(Entity):
                                                                                        """
                                                                                        Match inner DEI Bit
                                                                                        
                                                                                        .. attribute:: bit_value
                                                                                        
                                                                                        	Value of the DEI bit
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                            self.yang_name = "dei-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                            self._segment_path = lambda: "dei-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                    class DhcpClientId(Entity):
                                                                                        """
                                                                                        Dhcp Client ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                    class DhcpClientIdRegex(Entity):
                                                                                        """
                                                                                        Dhcp Client ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                    class DiscardClass(Entity):
                                                                                        """
                                                                                        Match Discard Class array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                            self.yang_name = "discard-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "discard-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                    class Dnis(Entity):
                                                                                        """
                                                                                        DNIS
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                            self.yang_name = "dnis"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                    class DnisRegex(Entity):
                                                                                        """
                                                                                        DNIS Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                            self.yang_name = "dnis-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "dnis-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                    class Domain(Entity):
                                                                                        """
                                                                                        Domain Name
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                            self.yang_name = "domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class DomainRegex(Entity):
                                                                                        """
                                                                                        Domain Regular Expression
                                                                                        
                                                                                        .. attribute:: domain_array
                                                                                        
                                                                                        	domain array
                                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                            self.yang_name = "domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                            self.domain_array = YList(self)
                                                                                            self._segment_path = lambda: "domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                        class DomainArray(Entity):
                                                                                            """
                                                                                            domain array
                                                                                            
                                                                                            .. attribute:: domain_name
                                                                                            
                                                                                            	domain name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            .. attribute:: format_name
                                                                                            
                                                                                            	format name
                                                                                            	**type**\:  str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                self.yang_name = "domain-array"
                                                                                                self.yang_parent_name = "domain-regex"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                                self._segment_path = lambda: "domain-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                    class Dscp(Entity):
                                                                                        """
                                                                                        Match DSCP range array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                            self.yang_name = "dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class DstAddrIpv4(Entity):
                                                                                        """
                                                                                        Destination Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstAddrIpv6(Entity):
                                                                                        """
                                                                                        Destination Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                            self.yang_name = "dst-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class DstMac(Entity):
                                                                                        """
                                                                                        Match Destination MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                            self.yang_name = "dst-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "dst-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                    class DstPort(Entity):
                                                                                        """
                                                                                        Destination port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                            self.yang_name = "dst-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "dst-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "dst-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class EtherServiceAcl(Entity):
                                                                                        """
                                                                                        Ethernet\-Services Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                            self.yang_name = "ether-service-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                    class Ethertype(Entity):
                                                                                        """
                                                                                        Ethernet type
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                            self.yang_name = "ethertype"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ethertype"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ethertype"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class FlowKeyData(Entity):
                                                                                        """
                                                                                        Flow key structure
                                                                                        
                                                                                        .. attribute:: flow_keys
                                                                                        
                                                                                        	flow keys
                                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                        
                                                                                        .. attribute:: idle_timeout
                                                                                        
                                                                                        	Idle timeout of flows (in seconds)
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        	**units**\: second
                                                                                        
                                                                                        .. attribute:: max_count
                                                                                        
                                                                                        	Maximum count of flows
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                            self.yang_name = "flow-key-data"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                            self._child_list_classes = {}

                                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                            self.flow_keys.parent = self
                                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                                            self._children_yang_names.add("flow-keys")
                                                                                            self._segment_path = lambda: "flow-key-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                        class FlowKeys(Entity):
                                                                                            """
                                                                                            flow keys
                                                                                            
                                                                                            .. attribute:: keys
                                                                                            
                                                                                            	keys
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                            
                                                                                            .. attribute:: num
                                                                                            
                                                                                            	num
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                self.yang_name = "flow-keys"
                                                                                                self.yang_parent_name = "flow-key-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                                self._segment_path = lambda: "flow-keys"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                    class FlowTag(Entity):
                                                                                        """
                                                                                        Match flow\-tag array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                            self.yang_name = "flow-tag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "flow-tag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "flow-tag"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class FrDe(Entity):
                                                                                        """
                                                                                        Match FR DE value
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                            self.yang_name = "fr-de"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "fr-de"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                    class FrDlci(Entity):
                                                                                        """
                                                                                        Match FR DLCI range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                            self.yang_name = "fr-dlci"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "fr-dlci"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "fr-dlci"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class IcmpV4(Entity):
                                                                                        """
                                                                                        Match ICMPV4 Protocol
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                            self.yang_name = "icmp-v4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                    class IcmpV6(Entity):
                                                                                        """
                                                                                        Match ICMPV6 Protocol array
                                                                                        
                                                                                        .. attribute:: code
                                                                                        
                                                                                        	Protocol code
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	Protocol type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                            self.yang_name = "icmp-v6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                                            self._segment_path = lambda: "icmp-v6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                    class Icmpv4Code(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                            self.yang_name = "icmpv4-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv4Type(Entity):
                                                                                        """
                                                                                        Match ipv4 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                            self.yang_name = "icmpv4-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Code(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp code
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                            self.yang_name = "icmpv6-code"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Icmpv6Type(Entity):
                                                                                        """
                                                                                        Match ipv6 icmp type
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                            self.yang_name = "icmpv6-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class InputInterface(Entity):
                                                                                        """
                                                                                        Input interface
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                            self.yang_name = "input-interface"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "input-interface"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                    class InputIntfhdl(Entity):
                                                                                        """
                                                                                        Input interface handle
                                                                                        
                                                                                        .. attribute:: uint64_array
                                                                                        
                                                                                        	uint64 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..18446744073709551615
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                            self.yang_name = "input-intfhdl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                    class Ipv4Acl(Entity):
                                                                                        """
                                                                                        IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                            self.yang_name = "ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                    class Ipv4Dscp(Entity):
                                                                                        """
                                                                                        IPv4 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                            self.yang_name = "ipv4-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4PacketLen(Entity):
                                                                                        """
                                                                                        IPv4 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv4-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv4Prec(Entity):
                                                                                        """
                                                                                        IPv4 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                            self.yang_name = "ipv4-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                    class Ipv6Acl(Entity):
                                                                                        """
                                                                                        IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                            self.yang_name = "ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                    class Ipv6Dscp(Entity):
                                                                                        """
                                                                                        IPv6 DSCP
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                            self.yang_name = "ipv6-dscp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6PacketLen(Entity):
                                                                                        """
                                                                                        IPv6 packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                            self.yang_name = "ipv6-packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Ipv6Prec(Entity):
                                                                                        """
                                                                                        IPv6 Precedence
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                            self.yang_name = "ipv6-prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                    class MediaType(Entity):
                                                                                        """
                                                                                        Media Type
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                            self.yang_name = "media-type"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "media-type"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                    class MplsDispIpv4Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv4 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                    class MplsDispIpv6Acl(Entity):
                                                                                        """
                                                                                        MPLS Disposition IPv6 Access\-list
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                    class MplsExp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental topmost array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                            self.yang_name = "mpls-exp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                    class MplsExpImp(Entity):
                                                                                        """
                                                                                        Match MPLS experimental imposition array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                            self.yang_name = "mpls-exp-imp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                    class MplsTopLabel(Entity):
                                                                                        """
                                                                                        MPLS Topmost LABEL
                                                                                        
                                                                                        .. attribute:: uint32_rng_array
                                                                                        
                                                                                        	uint32 rng array
                                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                            self.yang_name = "mpls-top-label"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                            self.uint32_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                        class Uint32RngArray(Entity):
                                                                                            """
                                                                                            uint32 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                self.yang_name = "uint32_rng_array"
                                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                    class NasPort(Entity):
                                                                                        """
                                                                                        NAS Port
                                                                                        
                                                                                        .. attribute:: nas_port_array
                                                                                        
                                                                                        	nas port array
                                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                            self.yang_name = "nas-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                            self.nas_port_array = YList(self)
                                                                                            self._segment_path = lambda: "nas-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                        class NasPortArray(Entity):
                                                                                            """
                                                                                            nas port array
                                                                                            
                                                                                            .. attribute:: operator
                                                                                            
                                                                                            	operator
                                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                            
                                                                                            .. attribute:: sub_id
                                                                                            
                                                                                            	sub id
                                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	value
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                self.yang_name = "nas-port-array"
                                                                                                self.yang_parent_name = "nas-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                                self._segment_path = lambda: "nas-port-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                    class PacketLen(Entity):
                                                                                        """
                                                                                        Match packet length array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                            self.yang_name = "packet-len"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "packet-len"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "packet-len"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class Prec(Entity):
                                                                                        """
                                                                                        Match Precedence array
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                            self.yang_name = "prec"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "prec"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                    class Proto(Entity):
                                                                                        """
                                                                                        Match Protocol array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                            self.yang_name = "proto"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "proto"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "proto"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class QosGroup(Entity):
                                                                                        """
                                                                                        Match QoS group array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                            self.yang_name = "qos-group"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "qos-group"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "qos-group"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class RemoteId(Entity):
                                                                                        """
                                                                                        Remote ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                            self.yang_name = "remote-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                    class RemoteIdRegex(Entity):
                                                                                        """
                                                                                        Remote ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                            self.yang_name = "remote-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                    class ServiceName(Entity):
                                                                                        """
                                                                                        Service Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                            self.yang_name = "service-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                    class ServiceNameRegex(Entity):
                                                                                        """
                                                                                        Service Name Regular Exp
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                            self.yang_name = "service-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "service-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                    class SrcAddrIpv4(Entity):
                                                                                        """
                                                                                        Source Address IPV4
                                                                                        
                                                                                        .. attribute:: ipv4_addr_array
                                                                                        
                                                                                        	ipv4 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv4"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                            self.ipv4_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                        class Ipv4AddrArray(Entity):
                                                                                            """
                                                                                            ipv4 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	mask
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv4-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrIpv6(Entity):
                                                                                        """
                                                                                        Source Address IPV6
                                                                                        
                                                                                        .. attribute:: ipv6_addr_array
                                                                                        
                                                                                        	ipv6 addr array
                                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                            self.yang_name = "src-addr-ipv6"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                            self.ipv6_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                        class Ipv6AddrArray(Entity):
                                                                                            """
                                                                                            ipv6 addr array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	IPV6 mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: prefix
                                                                                            
                                                                                            	IPV6 prefix
                                                                                            	**type**\:  str
                                                                                            
                                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                self.yang_name = "ipv6-addr-array"
                                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                    class SrcAddrMac(Entity):
                                                                                        """
                                                                                        Source Address MAC
                                                                                        
                                                                                        .. attribute:: mac_addr_array
                                                                                        
                                                                                        	mac addr array
                                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                            self.yang_name = "src-addr-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                            self.mac_addr_array = YList(self)
                                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                        class MacAddrArray(Entity):
                                                                                            """
                                                                                            mac addr array
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                self.yang_name = "mac-addr-array"
                                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcMac(Entity):
                                                                                        """
                                                                                        Match Source MAC address
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                            self.yang_name = "src-mac"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "src-mac"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                    class SrcPort(Entity):
                                                                                        """
                                                                                        Source port
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                            self.yang_name = "src-port"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "src-port"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "src-port"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                    class SubsProtocol(Entity):
                                                                                        """
                                                                                        Protocol
                                                                                        
                                                                                        .. attribute:: uint8_array
                                                                                        
                                                                                        	uint8 array
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                            self.yang_name = "subs-protocol"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                            self._segment_path = lambda: "subs-protocol"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                    class TcpFlag(Entity):
                                                                                        """
                                                                                        Match tcp flag value
                                                                                        
                                                                                        .. attribute:: match_any
                                                                                        
                                                                                        	Match any TCP flag bit
                                                                                        	**type**\:  bool
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	Value of TCP flag
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                            self.yang_name = "tcp-flag"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "tcp-flag"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                    class Timer(Entity):
                                                                                        """
                                                                                        Timer
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                            self.yang_name = "timer"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                    class TimerRegexp(Entity):
                                                                                        """
                                                                                        Timer Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                            self.yang_name = "timer-regexp"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "timer-regexp"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                    class TrafficClass(Entity):
                                                                                        """
                                                                                        Match Traffic class array
                                                                                        
                                                                                        .. attribute:: uint8_rng_array
                                                                                        
                                                                                        	uint8 rng array
                                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                            self.yang_name = "traffic-class"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                            self.uint8_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "traffic-class"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                        class Uint8RngArray(Entity):
                                                                                            """
                                                                                            uint8 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                self.yang_name = "uint8_rng_array"
                                                                                                self.yang_parent_name = "traffic-class"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                    class TunnelName(Entity):
                                                                                        """
                                                                                        Tunnel Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                            self.yang_name = "tunnel-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                    class TunnelNameRegex(Entity):
                                                                                        """
                                                                                        Tunnel Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                            self.yang_name = "tunnel-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                    class UnauthDomain(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                            self.yang_name = "unauth-domain"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                    class UnauthDomainRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated Domain Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                            self.yang_name = "unauth-domain-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                    class UnauthUsername(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                            self.yang_name = "unauth-username"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                    class UnauthUsernameRegex(Entity):
                                                                                        """
                                                                                        Unauthenticated User Name RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                            self.yang_name = "unauth-username-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                    class UserName(Entity):
                                                                                        """
                                                                                        User Name
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                            self.yang_name = "user-name"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                    class UserNameRegex(Entity):
                                                                                        """
                                                                                        User Name Regular Expression
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                            self.yang_name = "user-name-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "user-name-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                    class VendorId(Entity):
                                                                                        """
                                                                                        Vendor ID
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                            self.yang_name = "vendor-id"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                    class VendorIdRegex(Entity):
                                                                                        """
                                                                                        Vendor ID RegEx
                                                                                        
                                                                                        .. attribute:: string_array
                                                                                        
                                                                                        	string array
                                                                                        	**type**\:  list of str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                            self.yang_name = "vendor-id-regex"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                    class Vlan(Entity):
                                                                                        """
                                                                                        Match VLAN array
                                                                                        
                                                                                        .. attribute:: vlan_id_array
                                                                                        
                                                                                        	vlan id array
                                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                            self.yang_name = "vlan"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                            self.vlan_id_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                        class VlanIdArray(Entity):
                                                                                            """
                                                                                            vlan id array
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	VLAN mask
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                self.yang_name = "vlan-id-array"
                                                                                                self.yang_parent_name = "vlan"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                    class VlanInr(Entity):
                                                                                        """
                                                                                        Match inner header VLAN range array
                                                                                        
                                                                                        .. attribute:: uint16_rng_array
                                                                                        
                                                                                        	uint16 rng array
                                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                            self.yang_name = "vlan-inr"
                                                                                            self.yang_parent_name = "match-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                            self.uint16_rng_array = YList(self)
                                                                                            self._segment_path = lambda: "vlan-inr"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                        class Uint16RngArray(Entity):
                                                                                            """
                                                                                            uint16 rng array
                                                                                            
                                                                                            .. attribute:: max
                                                                                            
                                                                                            	Upper limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: min
                                                                                            
                                                                                            	Lower limit of the range
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                self.yang_name = "uint16_rng_array"
                                                                                                self.yang_parent_name = "vlan-inr"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                class ExceedActns(Entity):
                                                                    """
                                                                    exceed actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                        self.yang_name = "exceed-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "exceed-actns"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "exceed-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.mark = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._children_yang_names.add("mark")
                                                                            self._segment_path = lambda: "police-action-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "mark"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                class PeakBurst(Entity):
                                                                    """
                                                                    peak burst
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                        self.yang_name = "peak-burst"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "peak-burst"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                class PeakRate(Entity):
                                                                    """
                                                                    peak rate
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                        self.yang_name = "peak-rate"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "peak-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                class Rate(Entity):
                                                                    """
                                                                    rate
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                        self.yang_name = "rate"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                class ViolateActns(Entity):
                                                                    """
                                                                    violate actns
                                                                    
                                                                    .. attribute:: police_action_array
                                                                    
                                                                    	police action array
                                                                    	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                        self.yang_name = "violate-actns"
                                                                        self.yang_parent_name = "police"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                        self.police_action_array = YList(self)
                                                                        self._segment_path = lambda: "violate-actns"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                    class PoliceActionArray(Entity):
                                                                        """
                                                                        police action array
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                            self.yang_name = "police-action-array"
                                                                            self.yang_parent_name = "violate-actns"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.mark = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._children_yang_names.add("mark")
                                                                            self._segment_path = lambda: "police-action-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "police-action-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "mark"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                            class PrepaidCfg(Entity):
                                                                """
                                                                prepaid cfg
                                                                
                                                                .. attribute:: prepaid_config_profile_name
                                                                
                                                                	prepaid config profile name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                    self.yang_name = "prepaid-cfg"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                    self._segment_path = lambda: "prepaid-cfg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                            class Prio(Entity):
                                                                """
                                                                prio
                                                                
                                                                .. attribute:: prio_lvl
                                                                
                                                                	prio lvl
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                    self.yang_name = "prio"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                    self._segment_path = lambda: "prio"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                            class ProxyAaa(Entity):
                                                                """
                                                                proxy aaa
                                                                
                                                                .. attribute:: aaa_list_name
                                                                
                                                                	aaa list name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                    self.yang_name = "proxy-aaa"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                    self._segment_path = lambda: "proxy-aaa"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                            class Punt(Entity):
                                                                """
                                                                punt
                                                                
                                                                .. attribute:: app_id
                                                                
                                                                	application ID
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: local_id
                                                                
                                                                	local ID
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sn_index
                                                                
                                                                	service node index
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: sn_name
                                                                
                                                                	service node name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: sn_type
                                                                
                                                                	service node ID type
                                                                	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                
                                                                .. attribute:: vsnode_type
                                                                
                                                                	vservice node type
                                                                	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                    self.yang_name = "punt"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.app_id = YLeaf(YType.uint32, "app-id")

                                                                    self.local_id = YLeaf(YType.uint32, "local-id")

                                                                    self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                    self.sn_name = YLeaf(YType.str, "sn-name")

                                                                    self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                    self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                    self._segment_path = lambda: "punt"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                            class Qlimit(Entity):
                                                                """
                                                                qlimit
                                                                
                                                                .. attribute:: action_qlimit_info_array
                                                                
                                                                	action qlimit info array
                                                                	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                    self.yang_name = "qlimit"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                    self.action_qlimit_info_array = YList(self)
                                                                    self._segment_path = lambda: "qlimit"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                class ActionQlimitInfoArray(Entity):
                                                                    """
                                                                    action qlimit info array
                                                                    
                                                                    .. attribute:: atmclp_qlim
                                                                    
                                                                    	atmclp qlim
                                                                    	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                    
                                                                    .. attribute:: match_values
                                                                    
                                                                    	match values
                                                                    	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                    
                                                                    .. attribute:: qlim
                                                                    
                                                                    	qlim
                                                                    	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                    
                                                                    .. attribute:: qlimit_flags
                                                                    
                                                                    	qlimit flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                        self.yang_name = "action-qlimit-info-array"
                                                                        self.yang_parent_name = "qlimit"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                        self._child_list_classes = {}

                                                                        self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.atmclp_qlim = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                        self.atmclp_qlim.parent = self
                                                                        self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                        self._children_yang_names.add("atmclp-qlim")

                                                                        self.match_values = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                        self.match_values.parent = self
                                                                        self._children_name_map["match_values"] = "match-values"
                                                                        self._children_yang_names.add("match-values")

                                                                        self.qlim = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                        self.qlim.parent = self
                                                                        self._children_name_map["qlim"] = "qlim"
                                                                        self._children_yang_names.add("qlim")
                                                                        self._segment_path = lambda: "action-qlimit-info-array"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                    class AtmclpQlim(Entity):
                                                                        """
                                                                        atmclp qlim
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                            self.yang_name = "atmclp-qlim"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "atmclp-qlim"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                    class MatchValues(Entity):
                                                                        """
                                                                        match values
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                            self.yang_name = "match-values"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "match-values"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "match-values"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Qlim(Entity):
                                                                        """
                                                                        qlim
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                            self.yang_name = "qlim"
                                                                            self.yang_parent_name = "action-qlimit-info-array"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "qlim"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                            class QueryAncp(Entity):
                                                                """
                                                                query ancp
                                                                
                                                                .. attribute:: enable
                                                                
                                                                	enable
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                    self.yang_name = "query-ancp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.enable = YLeaf(YType.uint8, "enable")
                                                                    self._segment_path = lambda: "query-ancp"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                            class Redirect(Entity):
                                                                """
                                                                redirect
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: value
                                                                
                                                                	value
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                    self.yang_name = "redirect"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.type = YLeaf(YType.uint8, "type")

                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                    self._segment_path = lambda: "redirect"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                            class Rtp(Entity):
                                                                """
                                                                rtp
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                    self.yang_name = "rtp"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                    self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                    self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                    self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.frequency = YLeaf(YType.uint32, "frequency")

                                                                        self.pt = YLeaf(YType.uint32, "pt")
                                                                        self._segment_path = lambda: "clock-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                            class RtpJ2K(Entity):
                                                                """
                                                                rtp j2k
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                    self.yang_name = "rtp-j2k"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                    self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                    self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                    self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-j2k"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-j2k"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.frequency = YLeaf(YType.uint32, "frequency")

                                                                        self.pt = YLeaf(YType.uint32, "pt")
                                                                        self._segment_path = lambda: "clock-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                            class RtpMmr(Entity):
                                                                """
                                                                rtp mmr
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                    self.yang_name = "rtp-mmr"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                    self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                    self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                    self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-mmr"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-mmr"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.frequency = YLeaf(YType.uint32, "frequency")

                                                                        self.pt = YLeaf(YType.uint32, "pt")
                                                                        self._segment_path = lambda: "clock-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                            class RtpVoice(Entity):
                                                                """
                                                                rtp voice
                                                                
                                                                .. attribute:: action_metric_type
                                                                
                                                                	metric type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: clock_rate
                                                                
                                                                	clock rate
                                                                	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                
                                                                .. attribute:: max_dropout
                                                                
                                                                	max dropout
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: max_misorder
                                                                
                                                                	max misorder
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: min_sequential
                                                                
                                                                	min sequential
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: seq_ext_cop4
                                                                
                                                                	enable seq extension cop4
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                    self.yang_name = "rtp-voice"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                    self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                    self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                    self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                    self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                    self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                    self.clock_rate = YList(self)
                                                                    self._segment_path = lambda: "rtp-voice"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                class ClockRate(Entity):
                                                                    """
                                                                    clock rate
                                                                    
                                                                    .. attribute:: frequency
                                                                    
                                                                    	frequency
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pt
                                                                    
                                                                    	pt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                        self.yang_name = "clock-rate"
                                                                        self.yang_parent_name = "rtp-voice"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.frequency = YLeaf(YType.uint32, "frequency")

                                                                        self.pt = YLeaf(YType.uint32, "pt")
                                                                        self._segment_path = lambda: "clock-rate"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                            class ServFunc(Entity):
                                                                """
                                                                serv func
                                                                
                                                                .. attribute:: meta_name
                                                                
                                                                	metadata name
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: path_id
                                                                
                                                                	service path id
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: service_index
                                                                
                                                                	service path index
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: vs_index
                                                                
                                                                	vservice index
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                    self.yang_name = "serv-func"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.meta_name = YLeaf(YType.str, "meta-name")

                                                                    self.path_id = YLeaf(YType.uint32, "path-id")

                                                                    self.service_index = YLeaf(YType.uint8, "service-index")

                                                                    self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                    self._segment_path = lambda: "serv-func"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                            class SetTimer(Entity):
                                                                """
                                                                set timer
                                                                
                                                                .. attribute:: absolute_time
                                                                
                                                                	absolute time
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: duration
                                                                
                                                                	duration
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: timer_name
                                                                
                                                                	timer name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                    self.yang_name = "set-timer"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                    self.duration = YLeaf(YType.uint32, "duration")

                                                                    self.timer_name = YLeaf(YType.str, "timer-name")
                                                                    self._segment_path = lambda: "set-timer"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                            class Sfrag(Entity):
                                                                """
                                                                sfrag
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Service Fragment Name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                    self.yang_name = "sfrag"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.name = YLeaf(YType.str, "name")
                                                                    self._segment_path = lambda: "sfrag"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                            class Shape(Entity):
                                                                """
                                                                shape
                                                                
                                                                .. attribute:: be
                                                                
                                                                	be
                                                                	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                
                                                                .. attribute:: bw
                                                                
                                                                	bw
                                                                	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                    self.yang_name = "shape"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                    self._child_list_classes = {}

                                                                    self.be = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                    self.be.parent = self
                                                                    self._children_name_map["be"] = "be"
                                                                    self._children_yang_names.add("be")

                                                                    self.bw = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                    self.bw.parent = self
                                                                    self._children_name_map["bw"] = "bw"
                                                                    self._children_yang_names.add("bw")
                                                                    self._segment_path = lambda: "shape"


                                                                class Be(Entity):
                                                                    """
                                                                    be
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                        self.yang_name = "be"
                                                                        self.yang_parent_name = "shape"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "be"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                class Bw(Entity):
                                                                    """
                                                                    bw
                                                                    
                                                                    .. attribute:: unit
                                                                    
                                                                    	unit
                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                        self.yang_name = "bw"
                                                                        self.yang_parent_name = "shape"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "bw"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                            class StopTimer(Entity):
                                                                """
                                                                stop timer
                                                                
                                                                .. attribute:: timer_name
                                                                
                                                                	timer name
                                                                	**type**\:  str
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                    self.yang_name = "stop-timer"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.timer_name = YLeaf(YType.str, "timer-name")
                                                                    self._segment_path = lambda: "stop-timer"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                            class TimeoutIdle(Entity):
                                                                """
                                                                timeout idle
                                                                
                                                                .. attribute:: secs
                                                                
                                                                	secs
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                    self.yang_name = "timeout-idle"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {}

                                                                    self.secs = YLeaf(YType.uint32, "secs")
                                                                    self._segment_path = lambda: "timeout-idle"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                            class Wred(Entity):
                                                                """
                                                                wred
                                                                
                                                                .. attribute:: action_wred_info
                                                                
                                                                	action wred info
                                                                	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                    self.yang_name = "wred"
                                                                    self.yang_parent_name = "actp"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                    self.action_wred_info = YList(self)
                                                                    self._segment_path = lambda: "wred"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                class ActionWredInfo(Entity):
                                                                    """
                                                                    action wred info
                                                                    
                                                                    .. attribute:: match_ranges
                                                                    
                                                                    	match ranges
                                                                    	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                    
                                                                    .. attribute:: max_threshold
                                                                    
                                                                    	max threshold
                                                                    	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                    
                                                                    .. attribute:: min_threshold
                                                                    
                                                                    	min threshold
                                                                    	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                    
                                                                    .. attribute:: probability
                                                                    
                                                                    	probability
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	cos/prec/dscp/ based WRED
                                                                    	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                    
                                                                    .. attribute:: wred_flags
                                                                    
                                                                    	wred flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                        self.yang_name = "action-wred-info"
                                                                        self.yang_parent_name = "wred"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                        self._child_list_classes = {}

                                                                        self.probability = YLeaf(YType.uint32, "probability")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                        self.match_ranges = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                        self.match_ranges.parent = self
                                                                        self._children_name_map["match_ranges"] = "match-ranges"
                                                                        self._children_yang_names.add("match-ranges")

                                                                        self.max_threshold = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                        self.max_threshold.parent = self
                                                                        self._children_name_map["max_threshold"] = "max-threshold"
                                                                        self._children_yang_names.add("max-threshold")

                                                                        self.min_threshold = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                        self.min_threshold.parent = self
                                                                        self._children_name_map["min_threshold"] = "min-threshold"
                                                                        self._children_yang_names.add("min-threshold")
                                                                        self._segment_path = lambda: "action-wred-info"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                    class MatchRanges(Entity):
                                                                        """
                                                                        match ranges
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                            self.yang_name = "match-ranges"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "match-ranges"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "match-ranges"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class MaxThreshold(Entity):
                                                                        """
                                                                        max threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                            self.yang_name = "max-threshold"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "max-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                    class MinThreshold(Entity):
                                                                        """
                                                                        min threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                            self.yang_name = "min-threshold"
                                                                            self.yang_parent_name = "action-wred-info"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "min-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                class ClEncode(Entity):
                                                    """
                                                    cl encode
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: enc
                                                    
                                                    	enc
                                                    	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                    
                                                    .. attribute:: hd
                                                    
                                                    	hd
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: idx
                                                    
                                                    	idx
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: inline_cmap
                                                    
                                                    	inline cmap
                                                    	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                        self.yang_name = "cl-encode"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.enc = YLeaf(YType.enumeration, "enc")

                                                        self.hd = YLeaf(YType.uint64, "hd")

                                                        self.idx = YLeaf(YType.uint8, "idx")

                                                        self.inline_cmap = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                        self.inline_cmap.parent = self
                                                        self._children_name_map["inline_cmap"] = "inline-cmap"
                                                        self._children_yang_names.add("inline-cmap")
                                                        self._segment_path = lambda: "cl-encode"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                    class InlineCmap(Entity):
                                                        """
                                                        inline cmap
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	Inline Class\-Map flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: match_count
                                                        
                                                        	Number of Match infos
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: match_infop
                                                        
                                                        	Pointer to the first Match info
                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                        
                                                        .. attribute:: mode
                                                        
                                                        	Inline Class\-Map Mode Match any/all
                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                            self.yang_name = "inline-cmap"
                                                            self.yang_parent_name = "cl-encode"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                            self._child_list_classes = {}

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.match_count = YLeaf(YType.uint32, "match-count")

                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                            self.match_infop.parent = self
                                                            self._children_name_map["match_infop"] = "match-infop"
                                                            self._children_yang_names.add("match-infop")
                                                            self._segment_path = lambda: "inline-cmap"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                        class MatchInfop(Entity):
                                                            """
                                                            Pointer to the first Match info
                                                            
                                                            .. attribute:: class_match_info_st
                                                            
                                                            	class match info st
                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                self.yang_name = "match-infop"
                                                                self.yang_parent_name = "inline-cmap"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                self.class_match_info_st = YList(self)
                                                                self._segment_path = lambda: "match-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                            class ClassMatchInfoSt(Entity):
                                                                """
                                                                class match info st
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_data
                                                                
                                                                	Match criteria
                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                    self.yang_name = "class-match-info-st"
                                                                    self.yang_parent_name = "match-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                    self.match_data.parent = self
                                                                    self._children_name_map["match_data"] = "match-data"
                                                                    self._children_yang_names.add("match-data")
                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                class MatchData(Entity):
                                                                    """
                                                                    Match criteria
                                                                    
                                                                    .. attribute:: access_interface
                                                                    
                                                                    	Access interface
                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                    
                                                                    .. attribute:: atm_clp
                                                                    
                                                                    	Match ATM CLP level
                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                    
                                                                    .. attribute:: auth_domain
                                                                    
                                                                    	Authenticated domain name
                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                    
                                                                    .. attribute:: auth_domain_regex
                                                                    
                                                                    	Authenticated Domain Name RegEx
                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                    
                                                                    .. attribute:: auth_username
                                                                    
                                                                    	Authenticated User Name
                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                    
                                                                    .. attribute:: auth_username_regex
                                                                    
                                                                    	Authenticated User Name RegEx
                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                    
                                                                    .. attribute:: authen_status
                                                                    
                                                                    	Authentication Status
                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                    
                                                                    .. attribute:: avail_id
                                                                    
                                                                    	Available Identifiers
                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                    
                                                                    .. attribute:: circuit_id
                                                                    
                                                                    	Circuit ID
                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                    
                                                                    .. attribute:: circuit_id_regex
                                                                    
                                                                    	Circuit ID RegEx
                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                    
                                                                    .. attribute:: cos
                                                                    
                                                                    	Match CoS array
                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                    
                                                                    .. attribute:: cos_inr
                                                                    
                                                                    	Match inner header CoS
                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                    
                                                                    .. attribute:: dei
                                                                    
                                                                    	Match DEI Bit
                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                    
                                                                    .. attribute:: dei_inr
                                                                    
                                                                    	Match inner DEI Bit
                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                    
                                                                    .. attribute:: dhcp_client_id
                                                                    
                                                                    	Dhcp Client ID
                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                    
                                                                    .. attribute:: dhcp_client_id_regex
                                                                    
                                                                    	Dhcp Client ID RegEx
                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                    
                                                                    .. attribute:: discard_class
                                                                    
                                                                    	Match Discard Class array
                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                    
                                                                    .. attribute:: dnis
                                                                    
                                                                    	DNIS
                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                    
                                                                    .. attribute:: dnis_regex
                                                                    
                                                                    	DNIS Regular Expression
                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                    
                                                                    .. attribute:: domain
                                                                    
                                                                    	Domain Name
                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                    
                                                                    .. attribute:: domain_regex
                                                                    
                                                                    	Domain Regular Expression
                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                    
                                                                    .. attribute:: dscp
                                                                    
                                                                    	Match DSCP range array
                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv4
                                                                    
                                                                    	Destination Address IPV4
                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv6
                                                                    
                                                                    	Destination Address IPV6
                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                    
                                                                    .. attribute:: dst_mac
                                                                    
                                                                    	Match Destination MAC address
                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                    
                                                                    .. attribute:: dst_port
                                                                    
                                                                    	Destination port
                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                    
                                                                    .. attribute:: ether_service_acl
                                                                    
                                                                    	Ethernet\-Services Access\-list
                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                    
                                                                    .. attribute:: ethertype
                                                                    
                                                                    	Ethernet type
                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                    
                                                                    .. attribute:: flow_key_data
                                                                    
                                                                    	Flow key structure
                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                    
                                                                    .. attribute:: flow_tag
                                                                    
                                                                    	Match flow\-tag array
                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                    
                                                                    .. attribute:: fr_de
                                                                    
                                                                    	Match FR DE value
                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                    
                                                                    .. attribute:: fr_dlci
                                                                    
                                                                    	Match FR DLCI range array
                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                    
                                                                    .. attribute:: fragment_type
                                                                    
                                                                    	Fragment type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: icmp_v4
                                                                    
                                                                    	Match ICMPV4 Protocol
                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                    
                                                                    .. attribute:: icmp_v6
                                                                    
                                                                    	Match ICMPV6 Protocol array
                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                    
                                                                    .. attribute:: icmpv4_code
                                                                    
                                                                    	Match ipv4 icmp code
                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                    
                                                                    .. attribute:: icmpv4_type
                                                                    
                                                                    	Match ipv4 icmp type
                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                    
                                                                    .. attribute:: icmpv6_code
                                                                    
                                                                    	Match ipv6 icmp code
                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                    
                                                                    .. attribute:: icmpv6_type
                                                                    
                                                                    	Match ipv6 icmp type
                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                    
                                                                    .. attribute:: input_interface
                                                                    
                                                                    	Input interface
                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                    
                                                                    .. attribute:: input_intfhdl
                                                                    
                                                                    	Input interface handle
                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                    
                                                                    .. attribute:: ipv4_acl
                                                                    
                                                                    	IPv4 Access\-list
                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                    
                                                                    .. attribute:: ipv4_dscp
                                                                    
                                                                    	IPv4 DSCP
                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                    
                                                                    .. attribute:: ipv4_packet_len
                                                                    
                                                                    	IPv4 packet length array
                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                    
                                                                    .. attribute:: ipv4_prec
                                                                    
                                                                    	IPv4 Precedence
                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                    
                                                                    .. attribute:: ipv6_acl
                                                                    
                                                                    	IPv6 Access\-list
                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                    
                                                                    .. attribute:: ipv6_dscp
                                                                    
                                                                    	IPv6 DSCP
                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                    
                                                                    .. attribute:: ipv6_packet_len
                                                                    
                                                                    	IPv6 packet length array
                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                    
                                                                    .. attribute:: ipv6_prec
                                                                    
                                                                    	IPv6 Precedence
                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                    
                                                                    .. attribute:: media_type
                                                                    
                                                                    	Media Type
                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                    
                                                                    .. attribute:: mlp_negotiated
                                                                    
                                                                    	MLP Negotiated
                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                    
                                                                    	MPLS Disposition IPv4 Access\-list
                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                    
                                                                    	MPLS Disposition IPv6 Access\-list
                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                    
                                                                    .. attribute:: mpls_exp
                                                                    
                                                                    	Match MPLS experimental topmost array
                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                    
                                                                    .. attribute:: mpls_exp_imp
                                                                    
                                                                    	Match MPLS experimental imposition array
                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                    
                                                                    .. attribute:: mpls_top_eos
                                                                    
                                                                    	MPLS Topmost EOS
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: mpls_top_label
                                                                    
                                                                    	MPLS Topmost LABEL
                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                    
                                                                    .. attribute:: nas_port
                                                                    
                                                                    	NAS Port
                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                    
                                                                    .. attribute:: packet_len
                                                                    
                                                                    	Match packet length array
                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                    
                                                                    .. attribute:: prec
                                                                    
                                                                    	Match Precedence array
                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                    
                                                                    .. attribute:: proto
                                                                    
                                                                    	Match Protocol array
                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                    
                                                                    .. attribute:: qos_group
                                                                    
                                                                    	Match QoS group array
                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                    
                                                                    .. attribute:: remote_id
                                                                    
                                                                    	Remote ID
                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                    
                                                                    .. attribute:: remote_id_regex
                                                                    
                                                                    	Remote ID RegEx
                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                    
                                                                    .. attribute:: service_name
                                                                    
                                                                    	Service Name
                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                    
                                                                    .. attribute:: service_name_regex
                                                                    
                                                                    	Service Name Regular Exp
                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                    
                                                                    .. attribute:: src_addr_ipv4
                                                                    
                                                                    	Source Address IPV4
                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                    
                                                                    .. attribute:: src_addr_ipv6
                                                                    
                                                                    	Source Address IPV6
                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                    
                                                                    .. attribute:: src_addr_mac
                                                                    
                                                                    	Source Address MAC
                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                    
                                                                    .. attribute:: src_mac
                                                                    
                                                                    	Match Source MAC address
                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                    
                                                                    .. attribute:: src_port
                                                                    
                                                                    	Source port
                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                    
                                                                    .. attribute:: subs_protocol
                                                                    
                                                                    	Protocol
                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                    
                                                                    .. attribute:: tcp_flag
                                                                    
                                                                    	Match tcp flag value
                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                    
                                                                    .. attribute:: timer
                                                                    
                                                                    	Timer
                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                    
                                                                    .. attribute:: timer_regexp
                                                                    
                                                                    	Timer Regular Expression
                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                    
                                                                    .. attribute:: traffic_class
                                                                    
                                                                    	Match Traffic class array
                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                    
                                                                    .. attribute:: tunnel_name
                                                                    
                                                                    	Tunnel Name
                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                    
                                                                    .. attribute:: tunnel_name_regex
                                                                    
                                                                    	Tunnel Name Regular Expression
                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                    
                                                                    .. attribute:: unauth_domain
                                                                    
                                                                    	Unauthenticated Domain Name
                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                    
                                                                    .. attribute:: unauth_domain_regex
                                                                    
                                                                    	Unauthenticated Domain Name RegEx
                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                    
                                                                    .. attribute:: unauth_username
                                                                    
                                                                    	Unauthenticated User Name
                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                    
                                                                    .. attribute:: unauth_username_regex
                                                                    
                                                                    	Unauthenticated User Name RegEx
                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                    
                                                                    .. attribute:: user_name
                                                                    
                                                                    	User Name
                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                    
                                                                    .. attribute:: user_name_regex
                                                                    
                                                                    	User Name Regular Expression
                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                    
                                                                    .. attribute:: vendor_id
                                                                    
                                                                    	Vendor ID
                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                    
                                                                    .. attribute:: vendor_id_regex
                                                                    
                                                                    	Vendor ID RegEx
                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                    
                                                                    .. attribute:: vlan
                                                                    
                                                                    	Match VLAN array
                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                    
                                                                    .. attribute:: vlan_inr
                                                                    
                                                                    	Match inner header VLAN range array
                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                        self.yang_name = "match-data"
                                                                        self.yang_parent_name = "class-match-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                        self._child_list_classes = {}

                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                        self.access_interface.parent = self
                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                        self._children_yang_names.add("access-interface")

                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                        self.atm_clp.parent = self
                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                        self._children_yang_names.add("atm-clp")

                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                        self.auth_domain.parent = self
                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                        self._children_yang_names.add("auth-domain")

                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                        self.auth_domain_regex.parent = self
                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                        self.auth_username.parent = self
                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                        self._children_yang_names.add("auth-username")

                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                        self.auth_username_regex.parent = self
                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                        self._children_yang_names.add("auth-username-regex")

                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                        self.avail_id.parent = self
                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                        self._children_yang_names.add("avail-id")

                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                        self.circuit_id.parent = self
                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                        self._children_yang_names.add("circuit-id")

                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                        self.circuit_id_regex.parent = self
                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                        self.cos.parent = self
                                                                        self._children_name_map["cos"] = "cos"
                                                                        self._children_yang_names.add("cos")

                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                        self.cos_inr.parent = self
                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                        self._children_yang_names.add("cos-inr")

                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                        self.dei.parent = self
                                                                        self._children_name_map["dei"] = "dei"
                                                                        self._children_yang_names.add("dei")

                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                        self.dei_inr.parent = self
                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                        self._children_yang_names.add("dei-inr")

                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                        self.dhcp_client_id.parent = self
                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                        self.dhcp_client_id_regex.parent = self
                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                        self.discard_class.parent = self
                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                        self._children_yang_names.add("discard-class")

                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                        self.dnis.parent = self
                                                                        self._children_name_map["dnis"] = "dnis"
                                                                        self._children_yang_names.add("dnis")

                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                        self.dnis_regex.parent = self
                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                        self._children_yang_names.add("dnis-regex")

                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                        self.domain.parent = self
                                                                        self._children_name_map["domain"] = "domain"
                                                                        self._children_yang_names.add("domain")

                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                        self.domain_regex.parent = self
                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                        self._children_yang_names.add("domain-regex")

                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                        self.dscp.parent = self
                                                                        self._children_name_map["dscp"] = "dscp"
                                                                        self._children_yang_names.add("dscp")

                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                        self.dst_addr_ipv4.parent = self
                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                        self.dst_addr_ipv6.parent = self
                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                        self.dst_mac.parent = self
                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                        self._children_yang_names.add("dst-mac")

                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                        self.dst_port.parent = self
                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                        self._children_yang_names.add("dst-port")

                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                        self.ether_service_acl.parent = self
                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                        self._children_yang_names.add("ether-service-acl")

                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                        self.ethertype.parent = self
                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                        self._children_yang_names.add("ethertype")

                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                        self.flow_key_data.parent = self
                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                        self._children_yang_names.add("flow-key-data")

                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                        self.flow_tag.parent = self
                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                        self._children_yang_names.add("flow-tag")

                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                        self.fr_de.parent = self
                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                        self._children_yang_names.add("fr-de")

                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                        self.fr_dlci.parent = self
                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                        self._children_yang_names.add("fr-dlci")

                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                        self.icmp_v4.parent = self
                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                        self._children_yang_names.add("icmp-v4")

                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                        self.icmp_v6.parent = self
                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                        self._children_yang_names.add("icmp-v6")

                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                        self.icmpv4_code.parent = self
                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                        self._children_yang_names.add("icmpv4-code")

                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                        self.icmpv4_type.parent = self
                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                        self._children_yang_names.add("icmpv4-type")

                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                        self.icmpv6_code.parent = self
                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                        self._children_yang_names.add("icmpv6-code")

                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                        self.icmpv6_type.parent = self
                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                        self._children_yang_names.add("icmpv6-type")

                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                        self.input_interface.parent = self
                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                        self._children_yang_names.add("input-interface")

                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                        self.input_intfhdl.parent = self
                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                        self._children_yang_names.add("input-intfhdl")

                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                        self.ipv4_acl.parent = self
                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                        self._children_yang_names.add("ipv4-acl")

                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                        self.ipv4_dscp.parent = self
                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                        self.ipv4_packet_len.parent = self
                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                        self.ipv4_prec.parent = self
                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                        self._children_yang_names.add("ipv4-prec")

                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                        self.ipv6_acl.parent = self
                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                        self._children_yang_names.add("ipv6-acl")

                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                        self.ipv6_dscp.parent = self
                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                        self.ipv6_packet_len.parent = self
                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                        self.ipv6_prec.parent = self
                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                        self._children_yang_names.add("ipv6-prec")

                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                        self.media_type.parent = self
                                                                        self._children_name_map["media_type"] = "media-type"
                                                                        self._children_yang_names.add("media-type")

                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                        self.mpls_exp.parent = self
                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                        self._children_yang_names.add("mpls-exp")

                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                        self.mpls_exp_imp.parent = self
                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                        self.mpls_top_label.parent = self
                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                        self._children_yang_names.add("mpls-top-label")

                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                        self.nas_port.parent = self
                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                        self._children_yang_names.add("nas-port")

                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                        self.packet_len.parent = self
                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                        self._children_yang_names.add("packet-len")

                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                        self.prec.parent = self
                                                                        self._children_name_map["prec"] = "prec"
                                                                        self._children_yang_names.add("prec")

                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                        self.proto.parent = self
                                                                        self._children_name_map["proto"] = "proto"
                                                                        self._children_yang_names.add("proto")

                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                        self.qos_group.parent = self
                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                        self._children_yang_names.add("qos-group")

                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                        self.remote_id.parent = self
                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                        self._children_yang_names.add("remote-id")

                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                        self.remote_id_regex.parent = self
                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                        self._children_yang_names.add("remote-id-regex")

                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                        self.service_name.parent = self
                                                                        self._children_name_map["service_name"] = "service-name"
                                                                        self._children_yang_names.add("service-name")

                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                        self.service_name_regex.parent = self
                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                        self._children_yang_names.add("service-name-regex")

                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                        self.src_addr_ipv4.parent = self
                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                        self.src_addr_ipv6.parent = self
                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                        self.src_addr_mac.parent = self
                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                        self._children_yang_names.add("src-addr-mac")

                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                        self.src_mac.parent = self
                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                        self._children_yang_names.add("src-mac")

                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                        self.src_port.parent = self
                                                                        self._children_name_map["src_port"] = "src-port"
                                                                        self._children_yang_names.add("src-port")

                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                        self.subs_protocol.parent = self
                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                        self._children_yang_names.add("subs-protocol")

                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                        self.tcp_flag.parent = self
                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                        self._children_yang_names.add("tcp-flag")

                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                        self.timer.parent = self
                                                                        self._children_name_map["timer"] = "timer"
                                                                        self._children_yang_names.add("timer")

                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                        self.timer_regexp.parent = self
                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                        self._children_yang_names.add("timer-regexp")

                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                        self.traffic_class.parent = self
                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                        self._children_yang_names.add("traffic-class")

                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                        self.tunnel_name.parent = self
                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                        self._children_yang_names.add("tunnel-name")

                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                        self.tunnel_name_regex.parent = self
                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                        self.unauth_domain.parent = self
                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                        self._children_yang_names.add("unauth-domain")

                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                        self.unauth_domain_regex.parent = self
                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                        self.unauth_username.parent = self
                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                        self._children_yang_names.add("unauth-username")

                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                        self.unauth_username_regex.parent = self
                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                        self.user_name.parent = self
                                                                        self._children_name_map["user_name"] = "user-name"
                                                                        self._children_yang_names.add("user-name")

                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                        self.user_name_regex.parent = self
                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                        self._children_yang_names.add("user-name-regex")

                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                        self.vendor_id.parent = self
                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                        self._children_yang_names.add("vendor-id")

                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                        self.vendor_id_regex.parent = self
                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                        self.vlan.parent = self
                                                                        self._children_name_map["vlan"] = "vlan"
                                                                        self._children_yang_names.add("vlan")

                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                        self.vlan_inr.parent = self
                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                        self._children_yang_names.add("vlan-inr")
                                                                        self._segment_path = lambda: "match-data"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                    class AccessInterface(Entity):
                                                                        """
                                                                        Access interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                            self.yang_name = "access-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "access-interface"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                    class AtmClp(Entity):
                                                                        """
                                                                        Match ATM CLP level
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                            self.yang_name = "atm-clp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "atm-clp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                    class AuthDomain(Entity):
                                                                        """
                                                                        Authenticated domain name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                            self.yang_name = "auth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                    class AuthDomainRegex(Entity):
                                                                        """
                                                                        Authenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                            self.yang_name = "auth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                    class AuthUsername(Entity):
                                                                        """
                                                                        Authenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                            self.yang_name = "auth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-username"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                    class AuthUsernameRegex(Entity):
                                                                        """
                                                                        Authenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                            self.yang_name = "auth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                    class AvailId(Entity):
                                                                        """
                                                                        Available Identifiers
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                            self.yang_name = "avail-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "avail-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                    class CircuitId(Entity):
                                                                        """
                                                                        Circuit ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                            self.yang_name = "circuit-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "circuit-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                    class CircuitIdRegex(Entity):
                                                                        """
                                                                        Circuit ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                            self.yang_name = "circuit-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                    class Cos(Entity):
                                                                        """
                                                                        Match CoS array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                            self.yang_name = "cos"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "cos"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                    class CosInr(Entity):
                                                                        """
                                                                        Match inner header CoS
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                            self.yang_name = "cos-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "cos-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                    class Dei(Entity):
                                                                        """
                                                                        Match DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                            self.yang_name = "dei"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                            self._segment_path = lambda: "dei"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                    class DeiInr(Entity):
                                                                        """
                                                                        Match inner DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                            self.yang_name = "dei-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                            self._segment_path = lambda: "dei-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                    class DhcpClientId(Entity):
                                                                        """
                                                                        Dhcp Client ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                            self.yang_name = "dhcp-client-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                    class DhcpClientIdRegex(Entity):
                                                                        """
                                                                        Dhcp Client ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                    class DiscardClass(Entity):
                                                                        """
                                                                        Match Discard Class array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                            self.yang_name = "discard-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "discard-class"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                    class Dnis(Entity):
                                                                        """
                                                                        DNIS
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                            self.yang_name = "dnis"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dnis"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                    class DnisRegex(Entity):
                                                                        """
                                                                        DNIS Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                            self.yang_name = "dnis-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dnis-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                    class Domain(Entity):
                                                                        """
                                                                        Domain Name
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                            self.yang_name = "domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                self._segment_path = lambda: "domain-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class DomainRegex(Entity):
                                                                        """
                                                                        Domain Regular Expression
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                            self.yang_name = "domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain-regex"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                self._segment_path = lambda: "domain-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class Dscp(Entity):
                                                                        """
                                                                        Match DSCP range array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                            self.yang_name = "dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class DstAddrIpv4(Entity):
                                                                        """
                                                                        Destination Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                    class DstAddrIpv6(Entity):
                                                                        """
                                                                        Destination Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                    class DstMac(Entity):
                                                                        """
                                                                        Match Destination MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                            self.yang_name = "dst-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                            self._segment_path = lambda: "dst-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                    class DstPort(Entity):
                                                                        """
                                                                        Destination port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                            self.yang_name = "dst-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dst-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "dst-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class EtherServiceAcl(Entity):
                                                                        """
                                                                        Ethernet\-Services Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                            self.yang_name = "ether-service-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                    class Ethertype(Entity):
                                                                        """
                                                                        Ethernet type
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                            self.yang_name = "ethertype"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ethertype"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ethertype"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class FlowKeyData(Entity):
                                                                        """
                                                                        Flow key structure
                                                                        
                                                                        .. attribute:: flow_keys
                                                                        
                                                                        	flow keys
                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	Idle timeout of flows (in seconds)
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: max_count
                                                                        
                                                                        	Maximum count of flows
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                            self.yang_name = "flow-key-data"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                            self._child_list_classes = {}

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                            self.flow_keys.parent = self
                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                            self._children_yang_names.add("flow-keys")
                                                                            self._segment_path = lambda: "flow-key-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                        class FlowKeys(Entity):
                                                                            """
                                                                            flow keys
                                                                            
                                                                            .. attribute:: keys
                                                                            
                                                                            	keys
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: num
                                                                            
                                                                            	num
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                self.yang_name = "flow-keys"
                                                                                self.yang_parent_name = "flow-key-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                self._segment_path = lambda: "flow-keys"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                    class FlowTag(Entity):
                                                                        """
                                                                        Match flow\-tag array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                            self.yang_name = "flow-tag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "flow-tag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "flow-tag"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class FrDe(Entity):
                                                                        """
                                                                        Match FR DE value
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                            self.yang_name = "fr-de"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "fr-de"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                    class FrDlci(Entity):
                                                                        """
                                                                        Match FR DLCI range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                            self.yang_name = "fr-dlci"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "fr-dlci"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "fr-dlci"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class IcmpV4(Entity):
                                                                        """
                                                                        Match ICMPV4 Protocol
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                            self.yang_name = "icmp-v4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                            self._segment_path = lambda: "icmp-v4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                    class IcmpV6(Entity):
                                                                        """
                                                                        Match ICMPV6 Protocol array
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                            self.yang_name = "icmp-v6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                            self._segment_path = lambda: "icmp-v6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                    class Icmpv4Code(Entity):
                                                                        """
                                                                        Match ipv4 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                            self.yang_name = "icmpv4-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv4Type(Entity):
                                                                        """
                                                                        Match ipv4 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                            self.yang_name = "icmpv4-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv6Code(Entity):
                                                                        """
                                                                        Match ipv6 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                            self.yang_name = "icmpv6-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv6Type(Entity):
                                                                        """
                                                                        Match ipv6 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                            self.yang_name = "icmpv6-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class InputInterface(Entity):
                                                                        """
                                                                        Input interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                            self.yang_name = "input-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "input-interface"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                    class InputIntfhdl(Entity):
                                                                        """
                                                                        Input interface handle
                                                                        
                                                                        .. attribute:: uint64_array
                                                                        
                                                                        	uint64 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                            self.yang_name = "input-intfhdl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                    class Ipv4Acl(Entity):
                                                                        """
                                                                        IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                            self.yang_name = "ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                    class Ipv4Dscp(Entity):
                                                                        """
                                                                        IPv4 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                            self.yang_name = "ipv4-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Ipv4PacketLen(Entity):
                                                                        """
                                                                        IPv4 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                            self.yang_name = "ipv4-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Ipv4Prec(Entity):
                                                                        """
                                                                        IPv4 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                            self.yang_name = "ipv4-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                    class Ipv6Acl(Entity):
                                                                        """
                                                                        IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                            self.yang_name = "ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                    class Ipv6Dscp(Entity):
                                                                        """
                                                                        IPv6 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                            self.yang_name = "ipv6-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Ipv6PacketLen(Entity):
                                                                        """
                                                                        IPv6 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                            self.yang_name = "ipv6-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Ipv6Prec(Entity):
                                                                        """
                                                                        IPv6 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                            self.yang_name = "ipv6-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                    class MediaType(Entity):
                                                                        """
                                                                        Media Type
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                            self.yang_name = "media-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "media-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                    class MplsDispIpv4Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                    class MplsDispIpv6Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                    class MplsExp(Entity):
                                                                        """
                                                                        Match MPLS experimental topmost array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                            self.yang_name = "mpls-exp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "mpls-exp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                    class MplsExpImp(Entity):
                                                                        """
                                                                        Match MPLS experimental imposition array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                            self.yang_name = "mpls-exp-imp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                    class MplsTopLabel(Entity):
                                                                        """
                                                                        MPLS Topmost LABEL
                                                                        
                                                                        .. attribute:: uint32_rng_array
                                                                        
                                                                        	uint32 rng array
                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                            self.yang_name = "mpls-top-label"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                            self.uint32_rng_array = YList(self)
                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                        class Uint32RngArray(Entity):
                                                                            """
                                                                            uint32 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                self.yang_name = "uint32_rng_array"
                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                    class NasPort(Entity):
                                                                        """
                                                                        NAS Port
                                                                        
                                                                        .. attribute:: nas_port_array
                                                                        
                                                                        	nas port array
                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                            self.yang_name = "nas-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                            self.nas_port_array = YList(self)
                                                                            self._segment_path = lambda: "nas-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                        class NasPortArray(Entity):
                                                                            """
                                                                            nas port array
                                                                            
                                                                            .. attribute:: operator
                                                                            
                                                                            	operator
                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                            
                                                                            .. attribute:: sub_id
                                                                            
                                                                            	sub id
                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                self.yang_name = "nas-port-array"
                                                                                self.yang_parent_name = "nas-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "nas-port-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                    class PacketLen(Entity):
                                                                        """
                                                                        Match packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                            self.yang_name = "packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Prec(Entity):
                                                                        """
                                                                        Match Precedence array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                            self.yang_name = "prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                    class Proto(Entity):
                                                                        """
                                                                        Match Protocol array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                            self.yang_name = "proto"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "proto"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "proto"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class QosGroup(Entity):
                                                                        """
                                                                        Match QoS group array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                            self.yang_name = "qos-group"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "qos-group"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "qos-group"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class RemoteId(Entity):
                                                                        """
                                                                        Remote ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                            self.yang_name = "remote-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "remote-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                    class RemoteIdRegex(Entity):
                                                                        """
                                                                        Remote ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                            self.yang_name = "remote-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                    class ServiceName(Entity):
                                                                        """
                                                                        Service Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                            self.yang_name = "service-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "service-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                    class ServiceNameRegex(Entity):
                                                                        """
                                                                        Service Name Regular Exp
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                            self.yang_name = "service-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "service-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                    class SrcAddrIpv4(Entity):
                                                                        """
                                                                        Source Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                            self.yang_name = "src-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                    class SrcAddrIpv6(Entity):
                                                                        """
                                                                        Source Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                            self.yang_name = "src-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                    class SrcAddrMac(Entity):
                                                                        """
                                                                        Source Address MAC
                                                                        
                                                                        .. attribute:: mac_addr_array
                                                                        
                                                                        	mac addr array
                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                            self.yang_name = "src-addr-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                            self.mac_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                        class MacAddrArray(Entity):
                                                                            """
                                                                            mac addr array
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                self.yang_name = "mac-addr-array"
                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                    class SrcMac(Entity):
                                                                        """
                                                                        Match Source MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                            self.yang_name = "src-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                            self._segment_path = lambda: "src-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                    class SrcPort(Entity):
                                                                        """
                                                                        Source port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                            self.yang_name = "src-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "src-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "src-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class SubsProtocol(Entity):
                                                                        """
                                                                        Protocol
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                            self.yang_name = "subs-protocol"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "subs-protocol"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                    class TcpFlag(Entity):
                                                                        """
                                                                        Match tcp flag value
                                                                        
                                                                        .. attribute:: match_any
                                                                        
                                                                        	Match any TCP flag bit
                                                                        	**type**\:  bool
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	Value of TCP flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                            self.yang_name = "tcp-flag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                            self._segment_path = lambda: "tcp-flag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                    class Timer(Entity):
                                                                        """
                                                                        Timer
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                            self.yang_name = "timer"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                    class TimerRegexp(Entity):
                                                                        """
                                                                        Timer Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                            self.yang_name = "timer-regexp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "timer-regexp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                    class TrafficClass(Entity):
                                                                        """
                                                                        Match Traffic class array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                            self.yang_name = "traffic-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "traffic-class"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "traffic-class"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class TunnelName(Entity):
                                                                        """
                                                                        Tunnel Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                            self.yang_name = "tunnel-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "tunnel-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                    class TunnelNameRegex(Entity):
                                                                        """
                                                                        Tunnel Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                            self.yang_name = "tunnel-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                    class UnauthDomain(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                            self.yang_name = "unauth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                    class UnauthDomainRegex(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                            self.yang_name = "unauth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                    class UnauthUsername(Entity):
                                                                        """
                                                                        Unauthenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                            self.yang_name = "unauth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-username"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                    class UnauthUsernameRegex(Entity):
                                                                        """
                                                                        Unauthenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                            self.yang_name = "unauth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                    class UserName(Entity):
                                                                        """
                                                                        User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                            self.yang_name = "user-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "user-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                    class UserNameRegex(Entity):
                                                                        """
                                                                        User Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                            self.yang_name = "user-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "user-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                    class VendorId(Entity):
                                                                        """
                                                                        Vendor ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                            self.yang_name = "vendor-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "vendor-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                    class VendorIdRegex(Entity):
                                                                        """
                                                                        Vendor ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                            self.yang_name = "vendor-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                    class Vlan(Entity):
                                                                        """
                                                                        Match VLAN array
                                                                        
                                                                        .. attribute:: vlan_id_array
                                                                        
                                                                        	vlan id array
                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                            self.yang_name = "vlan"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                            self.vlan_id_array = YList(self)
                                                                            self._segment_path = lambda: "vlan"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                        class VlanIdArray(Entity):
                                                                            """
                                                                            vlan id array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	VLAN mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                self.yang_name = "vlan-id-array"
                                                                                self.yang_parent_name = "vlan"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                    class VlanInr(Entity):
                                                                        """
                                                                        Match inner header VLAN range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                            self.yang_name = "vlan-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "vlan-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "vlan-inr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                class ClmpP(Entity):
                                                    """
                                                    clmp p
                                                    
                                                    .. attribute:: class_map_bg
                                                    
                                                    	class map bg
                                                    	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                        self.yang_name = "clmp-p"
                                                        self.yang_parent_name = "policy-class-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                        self.class_map_bg = YList(self)
                                                        self._segment_path = lambda: "clmp-p"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                    class ClassMapBg(Entity):
                                                        """
                                                        class map bg
                                                        
                                                        .. attribute:: description
                                                        
                                                        	description
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: match_infop
                                                        
                                                        	Pointer to the first Match info
                                                        	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                        
                                                        .. attribute:: mode
                                                        
                                                        	Class\-Map Mode Match any/Match all
                                                        	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                        
                                                        .. attribute:: name
                                                        
                                                        	Name of the class\-map
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: type
                                                        
                                                        	Class\-Map Type QoS/PBR/Netflow/..
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                            self.yang_name = "class-map-bg"
                                                            self.yang_parent_name = "clmp-p"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                            self._child_list_classes = {}

                                                            self.description = YLeaf(YType.str, "description")

                                                            self.mode = YLeaf(YType.enumeration, "mode")

                                                            self.name = YLeaf(YType.str, "name")

                                                            self.type = YLeaf(YType.enumeration, "type")

                                                            self.match_infop = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                            self.match_infop.parent = self
                                                            self._children_name_map["match_infop"] = "match-infop"
                                                            self._children_yang_names.add("match-infop")
                                                            self._segment_path = lambda: "class-map-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                        class MatchInfop(Entity):
                                                            """
                                                            Pointer to the first Match info
                                                            
                                                            .. attribute:: class_match_info_st
                                                            
                                                            	class match info st
                                                            	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                self.yang_name = "match-infop"
                                                                self.yang_parent_name = "class-map-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                self.class_match_info_st = YList(self)
                                                                self._segment_path = lambda: "match-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                            class ClassMatchInfoSt(Entity):
                                                                """
                                                                class match info st
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_data
                                                                
                                                                	Match criteria
                                                                	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                    self.yang_name = "class-match-info-st"
                                                                    self.yang_parent_name = "match-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                    self.match_data.parent = self
                                                                    self._children_name_map["match_data"] = "match-data"
                                                                    self._children_yang_names.add("match-data")
                                                                    self._segment_path = lambda: "class-match-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                class MatchData(Entity):
                                                                    """
                                                                    Match criteria
                                                                    
                                                                    .. attribute:: access_interface
                                                                    
                                                                    	Access interface
                                                                    	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                    
                                                                    .. attribute:: atm_clp
                                                                    
                                                                    	Match ATM CLP level
                                                                    	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                    
                                                                    .. attribute:: auth_domain
                                                                    
                                                                    	Authenticated domain name
                                                                    	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                    
                                                                    .. attribute:: auth_domain_regex
                                                                    
                                                                    	Authenticated Domain Name RegEx
                                                                    	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                    
                                                                    .. attribute:: auth_username
                                                                    
                                                                    	Authenticated User Name
                                                                    	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                    
                                                                    .. attribute:: auth_username_regex
                                                                    
                                                                    	Authenticated User Name RegEx
                                                                    	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                    
                                                                    .. attribute:: authen_status
                                                                    
                                                                    	Authentication Status
                                                                    	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                    
                                                                    .. attribute:: avail_id
                                                                    
                                                                    	Available Identifiers
                                                                    	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                    
                                                                    .. attribute:: circuit_id
                                                                    
                                                                    	Circuit ID
                                                                    	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                    
                                                                    .. attribute:: circuit_id_regex
                                                                    
                                                                    	Circuit ID RegEx
                                                                    	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                    
                                                                    .. attribute:: cos
                                                                    
                                                                    	Match CoS array
                                                                    	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                    
                                                                    .. attribute:: cos_inr
                                                                    
                                                                    	Match inner header CoS
                                                                    	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                    
                                                                    .. attribute:: dei
                                                                    
                                                                    	Match DEI Bit
                                                                    	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                    
                                                                    .. attribute:: dei_inr
                                                                    
                                                                    	Match inner DEI Bit
                                                                    	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                    
                                                                    .. attribute:: dhcp_client_id
                                                                    
                                                                    	Dhcp Client ID
                                                                    	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                    
                                                                    .. attribute:: dhcp_client_id_regex
                                                                    
                                                                    	Dhcp Client ID RegEx
                                                                    	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                    
                                                                    .. attribute:: discard_class
                                                                    
                                                                    	Match Discard Class array
                                                                    	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                    
                                                                    .. attribute:: dnis
                                                                    
                                                                    	DNIS
                                                                    	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                    
                                                                    .. attribute:: dnis_regex
                                                                    
                                                                    	DNIS Regular Expression
                                                                    	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                    
                                                                    .. attribute:: domain
                                                                    
                                                                    	Domain Name
                                                                    	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                    
                                                                    .. attribute:: domain_regex
                                                                    
                                                                    	Domain Regular Expression
                                                                    	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                    
                                                                    .. attribute:: dscp
                                                                    
                                                                    	Match DSCP range array
                                                                    	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv4
                                                                    
                                                                    	Destination Address IPV4
                                                                    	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                    
                                                                    .. attribute:: dst_addr_ipv6
                                                                    
                                                                    	Destination Address IPV6
                                                                    	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                    
                                                                    .. attribute:: dst_mac
                                                                    
                                                                    	Match Destination MAC address
                                                                    	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                    
                                                                    .. attribute:: dst_port
                                                                    
                                                                    	Destination port
                                                                    	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                    
                                                                    .. attribute:: ether_service_acl
                                                                    
                                                                    	Ethernet\-Services Access\-list
                                                                    	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                    
                                                                    .. attribute:: ethertype
                                                                    
                                                                    	Ethernet type
                                                                    	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                    
                                                                    .. attribute:: flow_key_data
                                                                    
                                                                    	Flow key structure
                                                                    	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                    
                                                                    .. attribute:: flow_tag
                                                                    
                                                                    	Match flow\-tag array
                                                                    	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                    
                                                                    .. attribute:: fr_de
                                                                    
                                                                    	Match FR DE value
                                                                    	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                    
                                                                    .. attribute:: fr_dlci
                                                                    
                                                                    	Match FR DLCI range array
                                                                    	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                    
                                                                    .. attribute:: fragment_type
                                                                    
                                                                    	Fragment type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: icmp_v4
                                                                    
                                                                    	Match ICMPV4 Protocol
                                                                    	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                    
                                                                    .. attribute:: icmp_v6
                                                                    
                                                                    	Match ICMPV6 Protocol array
                                                                    	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                    
                                                                    .. attribute:: icmpv4_code
                                                                    
                                                                    	Match ipv4 icmp code
                                                                    	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                    
                                                                    .. attribute:: icmpv4_type
                                                                    
                                                                    	Match ipv4 icmp type
                                                                    	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                    
                                                                    .. attribute:: icmpv6_code
                                                                    
                                                                    	Match ipv6 icmp code
                                                                    	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                    
                                                                    .. attribute:: icmpv6_type
                                                                    
                                                                    	Match ipv6 icmp type
                                                                    	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                    
                                                                    .. attribute:: input_interface
                                                                    
                                                                    	Input interface
                                                                    	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                    
                                                                    .. attribute:: input_intfhdl
                                                                    
                                                                    	Input interface handle
                                                                    	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                    
                                                                    .. attribute:: ipv4_acl
                                                                    
                                                                    	IPv4 Access\-list
                                                                    	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                    
                                                                    .. attribute:: ipv4_dscp
                                                                    
                                                                    	IPv4 DSCP
                                                                    	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                    
                                                                    .. attribute:: ipv4_packet_len
                                                                    
                                                                    	IPv4 packet length array
                                                                    	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                    
                                                                    .. attribute:: ipv4_prec
                                                                    
                                                                    	IPv4 Precedence
                                                                    	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                    
                                                                    .. attribute:: ipv6_acl
                                                                    
                                                                    	IPv6 Access\-list
                                                                    	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                    
                                                                    .. attribute:: ipv6_dscp
                                                                    
                                                                    	IPv6 DSCP
                                                                    	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                    
                                                                    .. attribute:: ipv6_packet_len
                                                                    
                                                                    	IPv6 packet length array
                                                                    	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                    
                                                                    .. attribute:: ipv6_prec
                                                                    
                                                                    	IPv6 Precedence
                                                                    	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                    
                                                                    .. attribute:: media_type
                                                                    
                                                                    	Media Type
                                                                    	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                    
                                                                    .. attribute:: mlp_negotiated
                                                                    
                                                                    	MLP Negotiated
                                                                    	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv4_acl
                                                                    
                                                                    	MPLS Disposition IPv4 Access\-list
                                                                    	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                    
                                                                    .. attribute:: mpls_disp_ipv6_acl
                                                                    
                                                                    	MPLS Disposition IPv6 Access\-list
                                                                    	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                    
                                                                    .. attribute:: mpls_exp
                                                                    
                                                                    	Match MPLS experimental topmost array
                                                                    	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                    
                                                                    .. attribute:: mpls_exp_imp
                                                                    
                                                                    	Match MPLS experimental imposition array
                                                                    	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                    
                                                                    .. attribute:: mpls_top_eos
                                                                    
                                                                    	MPLS Topmost EOS
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: mpls_top_label
                                                                    
                                                                    	MPLS Topmost LABEL
                                                                    	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                    
                                                                    .. attribute:: nas_port
                                                                    
                                                                    	NAS Port
                                                                    	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                    
                                                                    .. attribute:: packet_len
                                                                    
                                                                    	Match packet length array
                                                                    	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                    
                                                                    .. attribute:: prec
                                                                    
                                                                    	Match Precedence array
                                                                    	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                    
                                                                    .. attribute:: proto
                                                                    
                                                                    	Match Protocol array
                                                                    	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                    
                                                                    .. attribute:: qos_group
                                                                    
                                                                    	Match QoS group array
                                                                    	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                    
                                                                    .. attribute:: remote_id
                                                                    
                                                                    	Remote ID
                                                                    	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                    
                                                                    .. attribute:: remote_id_regex
                                                                    
                                                                    	Remote ID RegEx
                                                                    	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                    
                                                                    .. attribute:: service_name
                                                                    
                                                                    	Service Name
                                                                    	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                    
                                                                    .. attribute:: service_name_regex
                                                                    
                                                                    	Service Name Regular Exp
                                                                    	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                    
                                                                    .. attribute:: src_addr_ipv4
                                                                    
                                                                    	Source Address IPV4
                                                                    	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                    
                                                                    .. attribute:: src_addr_ipv6
                                                                    
                                                                    	Source Address IPV6
                                                                    	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                    
                                                                    .. attribute:: src_addr_mac
                                                                    
                                                                    	Source Address MAC
                                                                    	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                    
                                                                    .. attribute:: src_mac
                                                                    
                                                                    	Match Source MAC address
                                                                    	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                    
                                                                    .. attribute:: src_port
                                                                    
                                                                    	Source port
                                                                    	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                    
                                                                    .. attribute:: subs_protocol
                                                                    
                                                                    	Protocol
                                                                    	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                    
                                                                    .. attribute:: tcp_flag
                                                                    
                                                                    	Match tcp flag value
                                                                    	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                    
                                                                    .. attribute:: timer
                                                                    
                                                                    	Timer
                                                                    	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                    
                                                                    .. attribute:: timer_regexp
                                                                    
                                                                    	Timer Regular Expression
                                                                    	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                    
                                                                    .. attribute:: traffic_class
                                                                    
                                                                    	Match Traffic class array
                                                                    	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                    
                                                                    .. attribute:: tunnel_name
                                                                    
                                                                    	Tunnel Name
                                                                    	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                    
                                                                    .. attribute:: tunnel_name_regex
                                                                    
                                                                    	Tunnel Name Regular Expression
                                                                    	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                    
                                                                    .. attribute:: unauth_domain
                                                                    
                                                                    	Unauthenticated Domain Name
                                                                    	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                    
                                                                    .. attribute:: unauth_domain_regex
                                                                    
                                                                    	Unauthenticated Domain Name RegEx
                                                                    	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                    
                                                                    .. attribute:: unauth_username
                                                                    
                                                                    	Unauthenticated User Name
                                                                    	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                    
                                                                    .. attribute:: unauth_username_regex
                                                                    
                                                                    	Unauthenticated User Name RegEx
                                                                    	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                    
                                                                    .. attribute:: user_name
                                                                    
                                                                    	User Name
                                                                    	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                    
                                                                    .. attribute:: user_name_regex
                                                                    
                                                                    	User Name Regular Expression
                                                                    	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                    
                                                                    .. attribute:: vendor_id
                                                                    
                                                                    	Vendor ID
                                                                    	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                    
                                                                    .. attribute:: vendor_id_regex
                                                                    
                                                                    	Vendor ID RegEx
                                                                    	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                    
                                                                    .. attribute:: vlan
                                                                    
                                                                    	Match VLAN array
                                                                    	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                    
                                                                    .. attribute:: vlan_inr
                                                                    
                                                                    	Match inner header VLAN range array
                                                                    	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                        self.yang_name = "match-data"
                                                                        self.yang_parent_name = "class-match-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                        self._child_list_classes = {}

                                                                        self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                        self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                        self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                        self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.access_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                        self.access_interface.parent = self
                                                                        self._children_name_map["access_interface"] = "access-interface"
                                                                        self._children_yang_names.add("access-interface")

                                                                        self.atm_clp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                        self.atm_clp.parent = self
                                                                        self._children_name_map["atm_clp"] = "atm-clp"
                                                                        self._children_yang_names.add("atm-clp")

                                                                        self.auth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                        self.auth_domain.parent = self
                                                                        self._children_name_map["auth_domain"] = "auth-domain"
                                                                        self._children_yang_names.add("auth-domain")

                                                                        self.auth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                        self.auth_domain_regex.parent = self
                                                                        self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                        self._children_yang_names.add("auth-domain-regex")

                                                                        self.auth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                        self.auth_username.parent = self
                                                                        self._children_name_map["auth_username"] = "auth-username"
                                                                        self._children_yang_names.add("auth-username")

                                                                        self.auth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                        self.auth_username_regex.parent = self
                                                                        self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                        self._children_yang_names.add("auth-username-regex")

                                                                        self.avail_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                        self.avail_id.parent = self
                                                                        self._children_name_map["avail_id"] = "avail-id"
                                                                        self._children_yang_names.add("avail-id")

                                                                        self.circuit_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                        self.circuit_id.parent = self
                                                                        self._children_name_map["circuit_id"] = "circuit-id"
                                                                        self._children_yang_names.add("circuit-id")

                                                                        self.circuit_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                        self.circuit_id_regex.parent = self
                                                                        self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                        self._children_yang_names.add("circuit-id-regex")

                                                                        self.cos = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                        self.cos.parent = self
                                                                        self._children_name_map["cos"] = "cos"
                                                                        self._children_yang_names.add("cos")

                                                                        self.cos_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                        self.cos_inr.parent = self
                                                                        self._children_name_map["cos_inr"] = "cos-inr"
                                                                        self._children_yang_names.add("cos-inr")

                                                                        self.dei = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                        self.dei.parent = self
                                                                        self._children_name_map["dei"] = "dei"
                                                                        self._children_yang_names.add("dei")

                                                                        self.dei_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                        self.dei_inr.parent = self
                                                                        self._children_name_map["dei_inr"] = "dei-inr"
                                                                        self._children_yang_names.add("dei-inr")

                                                                        self.dhcp_client_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                        self.dhcp_client_id.parent = self
                                                                        self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                        self._children_yang_names.add("dhcp-client-id")

                                                                        self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                        self.dhcp_client_id_regex.parent = self
                                                                        self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                        self._children_yang_names.add("dhcp-client-id-regex")

                                                                        self.discard_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                        self.discard_class.parent = self
                                                                        self._children_name_map["discard_class"] = "discard-class"
                                                                        self._children_yang_names.add("discard-class")

                                                                        self.dnis = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                        self.dnis.parent = self
                                                                        self._children_name_map["dnis"] = "dnis"
                                                                        self._children_yang_names.add("dnis")

                                                                        self.dnis_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                        self.dnis_regex.parent = self
                                                                        self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                        self._children_yang_names.add("dnis-regex")

                                                                        self.domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                        self.domain.parent = self
                                                                        self._children_name_map["domain"] = "domain"
                                                                        self._children_yang_names.add("domain")

                                                                        self.domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                        self.domain_regex.parent = self
                                                                        self._children_name_map["domain_regex"] = "domain-regex"
                                                                        self._children_yang_names.add("domain-regex")

                                                                        self.dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                        self.dscp.parent = self
                                                                        self._children_name_map["dscp"] = "dscp"
                                                                        self._children_yang_names.add("dscp")

                                                                        self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                        self.dst_addr_ipv4.parent = self
                                                                        self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                        self._children_yang_names.add("dst-addr-ipv4")

                                                                        self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                        self.dst_addr_ipv6.parent = self
                                                                        self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                        self._children_yang_names.add("dst-addr-ipv6")

                                                                        self.dst_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                        self.dst_mac.parent = self
                                                                        self._children_name_map["dst_mac"] = "dst-mac"
                                                                        self._children_yang_names.add("dst-mac")

                                                                        self.dst_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                        self.dst_port.parent = self
                                                                        self._children_name_map["dst_port"] = "dst-port"
                                                                        self._children_yang_names.add("dst-port")

                                                                        self.ether_service_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                        self.ether_service_acl.parent = self
                                                                        self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                        self._children_yang_names.add("ether-service-acl")

                                                                        self.ethertype = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                        self.ethertype.parent = self
                                                                        self._children_name_map["ethertype"] = "ethertype"
                                                                        self._children_yang_names.add("ethertype")

                                                                        self.flow_key_data = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                        self.flow_key_data.parent = self
                                                                        self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                        self._children_yang_names.add("flow-key-data")

                                                                        self.flow_tag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                        self.flow_tag.parent = self
                                                                        self._children_name_map["flow_tag"] = "flow-tag"
                                                                        self._children_yang_names.add("flow-tag")

                                                                        self.fr_de = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                        self.fr_de.parent = self
                                                                        self._children_name_map["fr_de"] = "fr-de"
                                                                        self._children_yang_names.add("fr-de")

                                                                        self.fr_dlci = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                        self.fr_dlci.parent = self
                                                                        self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                        self._children_yang_names.add("fr-dlci")

                                                                        self.icmp_v4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                        self.icmp_v4.parent = self
                                                                        self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                        self._children_yang_names.add("icmp-v4")

                                                                        self.icmp_v6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                        self.icmp_v6.parent = self
                                                                        self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                        self._children_yang_names.add("icmp-v6")

                                                                        self.icmpv4_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                        self.icmpv4_code.parent = self
                                                                        self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                        self._children_yang_names.add("icmpv4-code")

                                                                        self.icmpv4_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                        self.icmpv4_type.parent = self
                                                                        self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                        self._children_yang_names.add("icmpv4-type")

                                                                        self.icmpv6_code = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                        self.icmpv6_code.parent = self
                                                                        self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                        self._children_yang_names.add("icmpv6-code")

                                                                        self.icmpv6_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                        self.icmpv6_type.parent = self
                                                                        self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                        self._children_yang_names.add("icmpv6-type")

                                                                        self.input_interface = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                        self.input_interface.parent = self
                                                                        self._children_name_map["input_interface"] = "input-interface"
                                                                        self._children_yang_names.add("input-interface")

                                                                        self.input_intfhdl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                        self.input_intfhdl.parent = self
                                                                        self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                        self._children_yang_names.add("input-intfhdl")

                                                                        self.ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                        self.ipv4_acl.parent = self
                                                                        self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                        self._children_yang_names.add("ipv4-acl")

                                                                        self.ipv4_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                        self.ipv4_dscp.parent = self
                                                                        self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                        self._children_yang_names.add("ipv4-dscp")

                                                                        self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                        self.ipv4_packet_len.parent = self
                                                                        self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                        self._children_yang_names.add("ipv4-packet-len")

                                                                        self.ipv4_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                        self.ipv4_prec.parent = self
                                                                        self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                        self._children_yang_names.add("ipv4-prec")

                                                                        self.ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                        self.ipv6_acl.parent = self
                                                                        self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                        self._children_yang_names.add("ipv6-acl")

                                                                        self.ipv6_dscp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                        self.ipv6_dscp.parent = self
                                                                        self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                        self._children_yang_names.add("ipv6-dscp")

                                                                        self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                        self.ipv6_packet_len.parent = self
                                                                        self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                        self._children_yang_names.add("ipv6-packet-len")

                                                                        self.ipv6_prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                        self.ipv6_prec.parent = self
                                                                        self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                        self._children_yang_names.add("ipv6-prec")

                                                                        self.media_type = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                        self.media_type.parent = self
                                                                        self._children_name_map["media_type"] = "media-type"
                                                                        self._children_yang_names.add("media-type")

                                                                        self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                        self.mpls_disp_ipv4_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                        self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                        self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                        self.mpls_disp_ipv6_acl.parent = self
                                                                        self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                        self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                        self.mpls_exp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                        self.mpls_exp.parent = self
                                                                        self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                        self._children_yang_names.add("mpls-exp")

                                                                        self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                        self.mpls_exp_imp.parent = self
                                                                        self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                        self._children_yang_names.add("mpls-exp-imp")

                                                                        self.mpls_top_label = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                        self.mpls_top_label.parent = self
                                                                        self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                        self._children_yang_names.add("mpls-top-label")

                                                                        self.nas_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                        self.nas_port.parent = self
                                                                        self._children_name_map["nas_port"] = "nas-port"
                                                                        self._children_yang_names.add("nas-port")

                                                                        self.packet_len = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                        self.packet_len.parent = self
                                                                        self._children_name_map["packet_len"] = "packet-len"
                                                                        self._children_yang_names.add("packet-len")

                                                                        self.prec = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                        self.prec.parent = self
                                                                        self._children_name_map["prec"] = "prec"
                                                                        self._children_yang_names.add("prec")

                                                                        self.proto = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                        self.proto.parent = self
                                                                        self._children_name_map["proto"] = "proto"
                                                                        self._children_yang_names.add("proto")

                                                                        self.qos_group = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                        self.qos_group.parent = self
                                                                        self._children_name_map["qos_group"] = "qos-group"
                                                                        self._children_yang_names.add("qos-group")

                                                                        self.remote_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                        self.remote_id.parent = self
                                                                        self._children_name_map["remote_id"] = "remote-id"
                                                                        self._children_yang_names.add("remote-id")

                                                                        self.remote_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                        self.remote_id_regex.parent = self
                                                                        self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                        self._children_yang_names.add("remote-id-regex")

                                                                        self.service_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                        self.service_name.parent = self
                                                                        self._children_name_map["service_name"] = "service-name"
                                                                        self._children_yang_names.add("service-name")

                                                                        self.service_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                        self.service_name_regex.parent = self
                                                                        self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                        self._children_yang_names.add("service-name-regex")

                                                                        self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                        self.src_addr_ipv4.parent = self
                                                                        self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                        self._children_yang_names.add("src-addr-ipv4")

                                                                        self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                        self.src_addr_ipv6.parent = self
                                                                        self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                        self._children_yang_names.add("src-addr-ipv6")

                                                                        self.src_addr_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                        self.src_addr_mac.parent = self
                                                                        self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                        self._children_yang_names.add("src-addr-mac")

                                                                        self.src_mac = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                        self.src_mac.parent = self
                                                                        self._children_name_map["src_mac"] = "src-mac"
                                                                        self._children_yang_names.add("src-mac")

                                                                        self.src_port = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                        self.src_port.parent = self
                                                                        self._children_name_map["src_port"] = "src-port"
                                                                        self._children_yang_names.add("src-port")

                                                                        self.subs_protocol = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                        self.subs_protocol.parent = self
                                                                        self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                        self._children_yang_names.add("subs-protocol")

                                                                        self.tcp_flag = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                        self.tcp_flag.parent = self
                                                                        self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                        self._children_yang_names.add("tcp-flag")

                                                                        self.timer = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                        self.timer.parent = self
                                                                        self._children_name_map["timer"] = "timer"
                                                                        self._children_yang_names.add("timer")

                                                                        self.timer_regexp = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                        self.timer_regexp.parent = self
                                                                        self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                        self._children_yang_names.add("timer-regexp")

                                                                        self.traffic_class = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                        self.traffic_class.parent = self
                                                                        self._children_name_map["traffic_class"] = "traffic-class"
                                                                        self._children_yang_names.add("traffic-class")

                                                                        self.tunnel_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                        self.tunnel_name.parent = self
                                                                        self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                        self._children_yang_names.add("tunnel-name")

                                                                        self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                        self.tunnel_name_regex.parent = self
                                                                        self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                        self._children_yang_names.add("tunnel-name-regex")

                                                                        self.unauth_domain = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                        self.unauth_domain.parent = self
                                                                        self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                        self._children_yang_names.add("unauth-domain")

                                                                        self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                        self.unauth_domain_regex.parent = self
                                                                        self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                        self._children_yang_names.add("unauth-domain-regex")

                                                                        self.unauth_username = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                        self.unauth_username.parent = self
                                                                        self._children_name_map["unauth_username"] = "unauth-username"
                                                                        self._children_yang_names.add("unauth-username")

                                                                        self.unauth_username_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                        self.unauth_username_regex.parent = self
                                                                        self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                        self._children_yang_names.add("unauth-username-regex")

                                                                        self.user_name = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                        self.user_name.parent = self
                                                                        self._children_name_map["user_name"] = "user-name"
                                                                        self._children_yang_names.add("user-name")

                                                                        self.user_name_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                        self.user_name_regex.parent = self
                                                                        self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                        self._children_yang_names.add("user-name-regex")

                                                                        self.vendor_id = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                        self.vendor_id.parent = self
                                                                        self._children_name_map["vendor_id"] = "vendor-id"
                                                                        self._children_yang_names.add("vendor-id")

                                                                        self.vendor_id_regex = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                        self.vendor_id_regex.parent = self
                                                                        self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                        self._children_yang_names.add("vendor-id-regex")

                                                                        self.vlan = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                        self.vlan.parent = self
                                                                        self._children_name_map["vlan"] = "vlan"
                                                                        self._children_yang_names.add("vlan")

                                                                        self.vlan_inr = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                        self.vlan_inr.parent = self
                                                                        self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                        self._children_yang_names.add("vlan-inr")
                                                                        self._segment_path = lambda: "match-data"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                    class AccessInterface(Entity):
                                                                        """
                                                                        Access interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                            self.yang_name = "access-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "access-interface"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                    class AtmClp(Entity):
                                                                        """
                                                                        Match ATM CLP level
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                            self.yang_name = "atm-clp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "atm-clp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                    class AuthDomain(Entity):
                                                                        """
                                                                        Authenticated domain name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                            self.yang_name = "auth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                    class AuthDomainRegex(Entity):
                                                                        """
                                                                        Authenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                            self.yang_name = "auth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                    class AuthUsername(Entity):
                                                                        """
                                                                        Authenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                            self.yang_name = "auth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-username"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                    class AuthUsernameRegex(Entity):
                                                                        """
                                                                        Authenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                            self.yang_name = "auth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "auth-username-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                    class AvailId(Entity):
                                                                        """
                                                                        Available Identifiers
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                            self.yang_name = "avail-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "avail-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                    class CircuitId(Entity):
                                                                        """
                                                                        Circuit ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                            self.yang_name = "circuit-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "circuit-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                    class CircuitIdRegex(Entity):
                                                                        """
                                                                        Circuit ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                            self.yang_name = "circuit-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "circuit-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                    class Cos(Entity):
                                                                        """
                                                                        Match CoS array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                            self.yang_name = "cos"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "cos"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                    class CosInr(Entity):
                                                                        """
                                                                        Match inner header CoS
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                            self.yang_name = "cos-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "cos-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                    class Dei(Entity):
                                                                        """
                                                                        Match DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                            self.yang_name = "dei"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                            self._segment_path = lambda: "dei"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                    class DeiInr(Entity):
                                                                        """
                                                                        Match inner DEI Bit
                                                                        
                                                                        .. attribute:: bit_value
                                                                        
                                                                        	Value of the DEI bit
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                            self.yang_name = "dei-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                            self._segment_path = lambda: "dei-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                    class DhcpClientId(Entity):
                                                                        """
                                                                        Dhcp Client ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                            self.yang_name = "dhcp-client-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dhcp-client-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                    class DhcpClientIdRegex(Entity):
                                                                        """
                                                                        Dhcp Client ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                            self.yang_name = "dhcp-client-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dhcp-client-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                    class DiscardClass(Entity):
                                                                        """
                                                                        Match Discard Class array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                            self.yang_name = "discard-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "discard-class"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                    class Dnis(Entity):
                                                                        """
                                                                        DNIS
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                            self.yang_name = "dnis"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dnis"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                    class DnisRegex(Entity):
                                                                        """
                                                                        DNIS Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                            self.yang_name = "dnis-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "dnis-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                    class Domain(Entity):
                                                                        """
                                                                        Domain Name
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                            self.yang_name = "domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                self._segment_path = lambda: "domain-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class DomainRegex(Entity):
                                                                        """
                                                                        Domain Regular Expression
                                                                        
                                                                        .. attribute:: domain_array
                                                                        
                                                                        	domain array
                                                                        	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                            self.yang_name = "domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                            self.domain_array = YList(self)
                                                                            self._segment_path = lambda: "domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                        class DomainArray(Entity):
                                                                            """
                                                                            domain array
                                                                            
                                                                            .. attribute:: domain_name
                                                                            
                                                                            	domain name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                self.yang_name = "domain-array"
                                                                                self.yang_parent_name = "domain-regex"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")
                                                                                self._segment_path = lambda: "domain-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                    class Dscp(Entity):
                                                                        """
                                                                        Match DSCP range array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                            self.yang_name = "dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class DstAddrIpv4(Entity):
                                                                        """
                                                                        Destination Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                    class DstAddrIpv6(Entity):
                                                                        """
                                                                        Destination Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                            self.yang_name = "dst-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "dst-addr-ipv6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "dst-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                    class DstMac(Entity):
                                                                        """
                                                                        Match Destination MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                            self.yang_name = "dst-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                            self._segment_path = lambda: "dst-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                    class DstPort(Entity):
                                                                        """
                                                                        Destination port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                            self.yang_name = "dst-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "dst-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "dst-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class EtherServiceAcl(Entity):
                                                                        """
                                                                        Ethernet\-Services Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                            self.yang_name = "ether-service-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ether-service-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                    class Ethertype(Entity):
                                                                        """
                                                                        Ethernet type
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                            self.yang_name = "ethertype"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ethertype"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ethertype"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class FlowKeyData(Entity):
                                                                        """
                                                                        Flow key structure
                                                                        
                                                                        .. attribute:: flow_keys
                                                                        
                                                                        	flow keys
                                                                        	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	Idle timeout of flows (in seconds)
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: max_count
                                                                        
                                                                        	Maximum count of flows
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                            self.yang_name = "flow-key-data"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                            self._child_list_classes = {}

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.max_count = YLeaf(YType.uint16, "max-count")

                                                                            self.flow_keys = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                            self.flow_keys.parent = self
                                                                            self._children_name_map["flow_keys"] = "flow-keys"
                                                                            self._children_yang_names.add("flow-keys")
                                                                            self._segment_path = lambda: "flow-key-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                        class FlowKeys(Entity):
                                                                            """
                                                                            flow keys
                                                                            
                                                                            .. attribute:: keys
                                                                            
                                                                            	keys
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: num
                                                                            
                                                                            	num
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                self.yang_name = "flow-keys"
                                                                                self.yang_parent_name = "flow-key-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.keys = YLeaf(YType.str, "keys")

                                                                                self.num = YLeaf(YType.uint8, "num")
                                                                                self._segment_path = lambda: "flow-keys"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                    class FlowTag(Entity):
                                                                        """
                                                                        Match flow\-tag array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                            self.yang_name = "flow-tag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "flow-tag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "flow-tag"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class FrDe(Entity):
                                                                        """
                                                                        Match FR DE value
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                            self.yang_name = "fr-de"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "fr-de"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                    class FrDlci(Entity):
                                                                        """
                                                                        Match FR DLCI range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                            self.yang_name = "fr-dlci"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "fr-dlci"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "fr-dlci"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class IcmpV4(Entity):
                                                                        """
                                                                        Match ICMPV4 Protocol
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                            self.yang_name = "icmp-v4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                            self._segment_path = lambda: "icmp-v4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                    class IcmpV6(Entity):
                                                                        """
                                                                        Match ICMPV6 Protocol array
                                                                        
                                                                        .. attribute:: code
                                                                        
                                                                        	Protocol code
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	Protocol type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                            self.yang_name = "icmp-v6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.code = YLeaf(YType.uint8, "code")

                                                                            self.type = YLeaf(YType.uint8, "type")
                                                                            self._segment_path = lambda: "icmp-v6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                    class Icmpv4Code(Entity):
                                                                        """
                                                                        Match ipv4 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                            self.yang_name = "icmpv4-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-code"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv4Type(Entity):
                                                                        """
                                                                        Match ipv4 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                            self.yang_name = "icmpv4-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv4-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv4-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv6Code(Entity):
                                                                        """
                                                                        Match ipv6 icmp code
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                            self.yang_name = "icmpv6-code"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-code"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-code"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Icmpv6Type(Entity):
                                                                        """
                                                                        Match ipv6 icmp type
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                            self.yang_name = "icmpv6-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "icmpv6-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "icmpv6-type"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class InputInterface(Entity):
                                                                        """
                                                                        Input interface
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                            self.yang_name = "input-interface"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "input-interface"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                    class InputIntfhdl(Entity):
                                                                        """
                                                                        Input interface handle
                                                                        
                                                                        .. attribute:: uint64_array
                                                                        
                                                                        	uint64 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                            self.yang_name = "input-intfhdl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                            self._segment_path = lambda: "input-intfhdl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                    class Ipv4Acl(Entity):
                                                                        """
                                                                        IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                            self.yang_name = "ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ipv4-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                    class Ipv4Dscp(Entity):
                                                                        """
                                                                        IPv4 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                            self.yang_name = "ipv4-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv4-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Ipv4PacketLen(Entity):
                                                                        """
                                                                        IPv4 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                            self.yang_name = "ipv4-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv4-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Ipv4Prec(Entity):
                                                                        """
                                                                        IPv4 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                            self.yang_name = "ipv4-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "ipv4-prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                    class Ipv6Acl(Entity):
                                                                        """
                                                                        IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                            self.yang_name = "ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "ipv6-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                    class Ipv6Dscp(Entity):
                                                                        """
                                                                        IPv6 DSCP
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                            self.yang_name = "ipv6-dscp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-dscp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "ipv6-dscp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class Ipv6PacketLen(Entity):
                                                                        """
                                                                        IPv6 packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                            self.yang_name = "ipv6-packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "ipv6-packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Ipv6Prec(Entity):
                                                                        """
                                                                        IPv6 Precedence
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                            self.yang_name = "ipv6-prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "ipv6-prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                    class MediaType(Entity):
                                                                        """
                                                                        Media Type
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                            self.yang_name = "media-type"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "media-type"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                    class MplsDispIpv4Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv4 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv4-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                    class MplsDispIpv6Acl(Entity):
                                                                        """
                                                                        MPLS Disposition IPv6 Access\-list
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                            self.yang_name = "mpls-disp-ipv6-acl"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                    class MplsExp(Entity):
                                                                        """
                                                                        Match MPLS experimental topmost array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                            self.yang_name = "mpls-exp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "mpls-exp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                    class MplsExpImp(Entity):
                                                                        """
                                                                        Match MPLS experimental imposition array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                            self.yang_name = "mpls-exp-imp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "mpls-exp-imp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                    class MplsTopLabel(Entity):
                                                                        """
                                                                        MPLS Topmost LABEL
                                                                        
                                                                        .. attribute:: uint32_rng_array
                                                                        
                                                                        	uint32 rng array
                                                                        	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                            self.yang_name = "mpls-top-label"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                            self.uint32_rng_array = YList(self)
                                                                            self._segment_path = lambda: "mpls-top-label"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                        class Uint32RngArray(Entity):
                                                                            """
                                                                            uint32 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                self.yang_name = "uint32_rng_array"
                                                                                self.yang_parent_name = "mpls-top-label"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint32, "max")

                                                                                self.min = YLeaf(YType.uint32, "min")
                                                                                self._segment_path = lambda: "uint32_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                    class NasPort(Entity):
                                                                        """
                                                                        NAS Port
                                                                        
                                                                        .. attribute:: nas_port_array
                                                                        
                                                                        	nas port array
                                                                        	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                            self.yang_name = "nas-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                            self.nas_port_array = YList(self)
                                                                            self._segment_path = lambda: "nas-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                        class NasPortArray(Entity):
                                                                            """
                                                                            nas port array
                                                                            
                                                                            .. attribute:: operator
                                                                            
                                                                            	operator
                                                                            	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                            
                                                                            .. attribute:: sub_id
                                                                            
                                                                            	sub id
                                                                            	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                self.yang_name = "nas-port-array"
                                                                                self.yang_parent_name = "nas-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.operator = YLeaf(YType.enumeration, "operator")

                                                                                self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "nas-port-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                    class PacketLen(Entity):
                                                                        """
                                                                        Match packet length array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                            self.yang_name = "packet-len"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "packet-len"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "packet-len"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class Prec(Entity):
                                                                        """
                                                                        Match Precedence array
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                            self.yang_name = "prec"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "prec"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                    class Proto(Entity):
                                                                        """
                                                                        Match Protocol array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                            self.yang_name = "proto"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "proto"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "proto"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class QosGroup(Entity):
                                                                        """
                                                                        Match QoS group array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                            self.yang_name = "qos-group"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "qos-group"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "qos-group"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class RemoteId(Entity):
                                                                        """
                                                                        Remote ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                            self.yang_name = "remote-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "remote-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                    class RemoteIdRegex(Entity):
                                                                        """
                                                                        Remote ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                            self.yang_name = "remote-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "remote-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                    class ServiceName(Entity):
                                                                        """
                                                                        Service Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                            self.yang_name = "service-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "service-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                    class ServiceNameRegex(Entity):
                                                                        """
                                                                        Service Name Regular Exp
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                            self.yang_name = "service-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "service-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                    class SrcAddrIpv4(Entity):
                                                                        """
                                                                        Source Address IPV4
                                                                        
                                                                        .. attribute:: ipv4_addr_array
                                                                        
                                                                        	ipv4 addr array
                                                                        	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                            self.yang_name = "src-addr-ipv4"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                            self.ipv4_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv4"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                        class Ipv4AddrArray(Entity):
                                                                            """
                                                                            ipv4 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	mask
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                self.yang_name = "ipv4-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv4"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.str, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv4-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                    class SrcAddrIpv6(Entity):
                                                                        """
                                                                        Source Address IPV6
                                                                        
                                                                        .. attribute:: ipv6_addr_array
                                                                        
                                                                        	ipv6 addr array
                                                                        	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                            self.yang_name = "src-addr-ipv6"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                            self.ipv6_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-ipv6"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                        class Ipv6AddrArray(Entity):
                                                                            """
                                                                            ipv6 addr array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	IPV6 mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: prefix
                                                                            
                                                                            	IPV6 prefix
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                self.yang_name = "ipv6-addr-array"
                                                                                self.yang_parent_name = "src-addr-ipv6"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint32, "mask")

                                                                                self.prefix = YLeaf(YType.str, "prefix")
                                                                                self._segment_path = lambda: "ipv6-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                    class SrcAddrMac(Entity):
                                                                        """
                                                                        Source Address MAC
                                                                        
                                                                        .. attribute:: mac_addr_array
                                                                        
                                                                        	mac addr array
                                                                        	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                            self.yang_name = "src-addr-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                            self.mac_addr_array = YList(self)
                                                                            self._segment_path = lambda: "src-addr-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                        class MacAddrArray(Entity):
                                                                            """
                                                                            mac addr array
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                self.yang_name = "mac-addr-array"
                                                                                self.yang_parent_name = "src-addr-mac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "mac-addr-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                    class SrcMac(Entity):
                                                                        """
                                                                        Match Source MAC address
                                                                        
                                                                        .. attribute:: mac_addr
                                                                        
                                                                        	MAC address
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: mask
                                                                        
                                                                        	MAC mask
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                            self.yang_name = "src-mac"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                            self._segment_path = lambda: "src-mac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                    class SrcPort(Entity):
                                                                        """
                                                                        Source port
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                            self.yang_name = "src-port"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "src-port"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "src-port"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class SubsProtocol(Entity):
                                                                        """
                                                                        Protocol
                                                                        
                                                                        .. attribute:: uint8_array
                                                                        
                                                                        	uint8 array
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                            self.yang_name = "subs-protocol"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                            self._segment_path = lambda: "subs-protocol"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                    class TcpFlag(Entity):
                                                                        """
                                                                        Match tcp flag value
                                                                        
                                                                        .. attribute:: match_any
                                                                        
                                                                        	Match any TCP flag bit
                                                                        	**type**\:  bool
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	Value of TCP flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                            self.yang_name = "tcp-flag"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.match_any = YLeaf(YType.boolean, "match-any")

                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                            self._segment_path = lambda: "tcp-flag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                    class Timer(Entity):
                                                                        """
                                                                        Timer
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                            self.yang_name = "timer"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                    class TimerRegexp(Entity):
                                                                        """
                                                                        Timer Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                            self.yang_name = "timer-regexp"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "timer-regexp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                    class TrafficClass(Entity):
                                                                        """
                                                                        Match Traffic class array
                                                                        
                                                                        .. attribute:: uint8_rng_array
                                                                        
                                                                        	uint8 rng array
                                                                        	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                            self.yang_name = "traffic-class"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                            self.uint8_rng_array = YList(self)
                                                                            self._segment_path = lambda: "traffic-class"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                        class Uint8RngArray(Entity):
                                                                            """
                                                                            uint8 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                self.yang_name = "uint8_rng_array"
                                                                                self.yang_parent_name = "traffic-class"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint8, "max")

                                                                                self.min = YLeaf(YType.uint8, "min")
                                                                                self._segment_path = lambda: "uint8_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                    class TunnelName(Entity):
                                                                        """
                                                                        Tunnel Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                            self.yang_name = "tunnel-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "tunnel-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                    class TunnelNameRegex(Entity):
                                                                        """
                                                                        Tunnel Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                            self.yang_name = "tunnel-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "tunnel-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                    class UnauthDomain(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                            self.yang_name = "unauth-domain"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-domain"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                    class UnauthDomainRegex(Entity):
                                                                        """
                                                                        Unauthenticated Domain Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                            self.yang_name = "unauth-domain-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-domain-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                    class UnauthUsername(Entity):
                                                                        """
                                                                        Unauthenticated User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                            self.yang_name = "unauth-username"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-username"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                    class UnauthUsernameRegex(Entity):
                                                                        """
                                                                        Unauthenticated User Name RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                            self.yang_name = "unauth-username-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "unauth-username-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                    class UserName(Entity):
                                                                        """
                                                                        User Name
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                            self.yang_name = "user-name"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "user-name"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                    class UserNameRegex(Entity):
                                                                        """
                                                                        User Name Regular Expression
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                            self.yang_name = "user-name-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "user-name-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                    class VendorId(Entity):
                                                                        """
                                                                        Vendor ID
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                            self.yang_name = "vendor-id"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "vendor-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                    class VendorIdRegex(Entity):
                                                                        """
                                                                        Vendor ID RegEx
                                                                        
                                                                        .. attribute:: string_array
                                                                        
                                                                        	string array
                                                                        	**type**\:  list of str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                            self.yang_name = "vendor-id-regex"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.string_array = YLeafList(YType.str, "string-array")
                                                                            self._segment_path = lambda: "vendor-id-regex"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                    class Vlan(Entity):
                                                                        """
                                                                        Match VLAN array
                                                                        
                                                                        .. attribute:: vlan_id_array
                                                                        
                                                                        	vlan id array
                                                                        	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                            self.yang_name = "vlan"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                            self.vlan_id_array = YList(self)
                                                                            self._segment_path = lambda: "vlan"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                        class VlanIdArray(Entity):
                                                                            """
                                                                            vlan id array
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	VLAN mask
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                self.yang_name = "vlan-id-array"
                                                                                self.yang_parent_name = "vlan"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mask = YLeaf(YType.uint16, "mask")

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "vlan-id-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                    class VlanInr(Entity):
                                                                        """
                                                                        Match inner header VLAN range array
                                                                        
                                                                        .. attribute:: uint16_rng_array
                                                                        
                                                                        	uint16 rng array
                                                                        	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                            self.yang_name = "vlan-inr"
                                                                            self.yang_parent_name = "match-data"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                            self.uint16_rng_array = YList(self)
                                                                            self._segment_path = lambda: "vlan-inr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                        class Uint16RngArray(Entity):
                                                                            """
                                                                            uint16 rng array
                                                                            
                                                                            .. attribute:: max
                                                                            
                                                                            	Upper limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: min
                                                                            
                                                                            	Lower limit of the range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                self.yang_name = "uint16_rng_array"
                                                                                self.yang_parent_name = "vlan-inr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.max = YLeaf(YType.uint16, "max")

                                                                                self.min = YLeaf(YType.uint16, "min")
                                                                                self._segment_path = lambda: "uint16_rng_array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: offset
                                    
                                    	offset
                                    	**type**\:  list of int
                                    
                                    	**range:** 0..255
                                    
                                    .. attribute:: pmap_var_list_arr
                                    
                                    	pmap var list arr
                                    	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "policy-map-bg"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                        self.offset = YLeafList(YType.uint8, "offset")

                                        self.pmap_var_list_arr = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                    class PmapVarListArr(Entity):
                                        """
                                        pmap var list arr
                                        
                                        .. attribute:: id
                                        
                                        	id
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..32
                                        
                                        .. attribute:: val
                                        
                                        	val
                                        	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                            self.yang_name = "pmap-var-list-arr"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                            self._child_list_classes = {}

                                            self.id = YLeaf(YType.uint32, "id")

                                            self.name = YLeaf(YType.str, "name")

                                            self.val = PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                            self.val.parent = self
                                            self._children_name_map["val"] = "val"
                                            self._children_yang_names.add("val")
                                            self._segment_path = lambda: "pmap-var-list-arr"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                        class Val(Entity):
                                            """
                                            val
                                            
                                            .. attribute:: class_name
                                            
                                            	class name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: dscp_val
                                            
                                            	dscp val
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: param_uint32_val
                                            
                                            	param uint32 val
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: prec_val
                                            
                                            	prec val
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                            
                                            .. attribute:: uint16_val
                                            
                                            	uint16 val
                                            	**type**\:  int
                                            
                                            	**range:** 0..65535
                                            
                                            .. attribute:: uint32_val
                                            
                                            	uint32 val
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: uint8_val
                                            
                                            	uint8 val
                                            	**type**\:  int
                                            
                                            	**range:** 0..255
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                self.yang_name = "val"
                                                self.yang_parent_name = "pmap-var-list-arr"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {}

                                                self.class_name = YLeaf(YType.str, "class-name")

                                                self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                self._segment_path = lambda: "val"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


            class PolicyMapUnusedTypes(Entity):
                """
                Policy\-map unused table
                
                .. attribute:: policy_map_unused_type
                
                	Policy\-map unused
                	**type**\: list of    :py:class:`PolicyMapUnusedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes, self).__init__()

                    self.yang_name = "policy-map-unused-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"policy-map-unused-type" : ("policy_map_unused_type", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType)}

                    self.policy_map_unused_type = YList(self)
                    self._segment_path = lambda: "policy-map-unused-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes, [], name, value)


                class PolicyMapUnusedType(Entity):
                    """
                    Policy\-map unused
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: unuseds
                    
                    	Policy\-map unused
                    	**type**\:   :py:class:`Unuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, self).__init__()

                        self.yang_name = "policy-map-unused-type"
                        self.yang_parent_name = "policy-map-unused-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {"unuseds" : ("unuseds", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.unuseds = PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds()
                        self.unuseds.parent = self
                        self._children_name_map["unuseds"] = "unuseds"
                        self._children_yang_names.add("unuseds")
                        self._segment_path = lambda: "policy-map-unused-type" + "[type='" + self.type.get() + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/policy-map-unused-types/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, ['type'], name, value)


                    class Unuseds(Entity):
                        """
                        Policy\-map unused
                        
                        .. attribute:: unused
                        
                        	Policy\-map unused information
                        	**type**\: list of    :py:class:`Unused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, self).__init__()

                            self.yang_name = "unuseds"
                            self.yang_parent_name = "policy-map-unused-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"unused" : ("unused", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused)}

                            self.unused = YList(self)
                            self._segment_path = lambda: "unuseds"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, [], name, value)


                        class Unused(Entity):
                            """
                            Policy\-map unused information
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference>`
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects>`
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, self).__init__()

                                self.yang_name = "unused"
                                self.yang_parent_name = "unuseds"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects), "reference" : ("reference", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference)}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.total_objects = YLeaf(YType.uint32, "total-objects")

                                self.transient = YLeaf(YType.boolean, "transient")

                                self.class_map_reference = YList(self)
                                self.objects = YList(self)
                                self.reference = YList(self)
                                self._segment_path = lambda: "unused" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference>`
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference)}

                                    self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_type = YLeaf(YType.enumeration, "object-type")

                                        self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                        self._segment_path = lambda: "policy-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.object_name = YLeaf(YType.str, "object-name")
                                    self._segment_path = lambda: "objects"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, ['object_name'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                    self.total_flows = YLeaf(YType.uint32, "total-flows")

                                    self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                    self._segment_path = lambda: "reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


            class TransientPolicyMapTypeXr(Entity):
                """
                Application type of transient policy\-map
                
                .. attribute:: transient_policy_map_type
                
                	Transient policy\-map type
                	**type**\: list of    :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr, self).__init__()

                    self.yang_name = "transient-policy-map-type-xr"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"transient-policy-map-type" : ("transient_policy_map_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType)}

                    self.transient_policy_map_type = YList(self)
                    self._segment_path = lambda: "transient-policy-map-type-xr"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr, [], name, value)


                class TransientPolicyMapType(Entity):
                    """
                    Transient policy\-map type
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: transient_policy_map_names
                    
                    	Transient policy\-map definition table
                    	**type**\:   :py:class:`TransientPolicyMapNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, self).__init__()

                        self.yang_name = "transient-policy-map-type"
                        self.yang_parent_name = "transient-policy-map-type-xr"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {"transient-policy-map-names" : ("transient_policy_map_names", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.transient_policy_map_names = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames()
                        self.transient_policy_map_names.parent = self
                        self._children_name_map["transient_policy_map_names"] = "transient-policy-map-names"
                        self._children_yang_names.add("transient-policy-map-names")
                        self._segment_path = lambda: "transient-policy-map-type" + "[type='" + self.type.get() + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/transient-policy-map-type-xr/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, ['type'], name, value)


                    class TransientPolicyMapNames(Entity):
                        """
                        Transient policy\-map definition table
                        
                        .. attribute:: transient_policy_map_name
                        
                        	Transient policy\-map definition table
                        	**type**\: list of    :py:class:`TransientPolicyMapName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, self).__init__()

                            self.yang_name = "transient-policy-map-names"
                            self.yang_parent_name = "transient-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"transient-policy-map-name" : ("transient_policy_map_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName)}

                            self.transient_policy_map_name = YList(self)
                            self._segment_path = lambda: "transient-policy-map-names"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, [], name, value)


                        class TransientPolicyMapName(Entity):
                            """
                            Transient policy\-map definition table
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_handles
                            
                            	Transient policy\-map class handle table
                            	**type**\:   :py:class:`ClassHandles <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles>`
                            
                            .. attribute:: class_seq_nums
                            
                            	Transient policy\-map sequence number table
                            	**type**\:   :py:class:`ClassSeqNums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums>`
                            
                            .. attribute:: definition
                            
                            	Transient Policy\-map type name
                            	**type**\:   :py:class:`Definition <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, self).__init__()

                                self.yang_name = "transient-policy-map-name"
                                self.yang_parent_name = "transient-policy-map-names"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {"class-handles" : ("class_handles", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles), "class-seq-nums" : ("class_seq_nums", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums), "definition" : ("definition", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition)}
                                self._child_list_classes = {}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.class_handles = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles()
                                self.class_handles.parent = self
                                self._children_name_map["class_handles"] = "class-handles"
                                self._children_yang_names.add("class-handles")

                                self.class_seq_nums = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums()
                                self.class_seq_nums.parent = self
                                self._children_name_map["class_seq_nums"] = "class-seq-nums"
                                self._children_yang_names.add("class-seq-nums")

                                self.definition = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition()
                                self.definition.parent = self
                                self._children_name_map["definition"] = "definition"
                                self._children_yang_names.add("definition")
                                self._segment_path = lambda: "transient-policy-map-name" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, ['policy_map_name'], name, value)


                            class ClassHandles(Entity):
                                """
                                Transient policy\-map class handle table
                                
                                .. attribute:: class_handle
                                
                                	Transient policy\-map class handle
                                	**type**\: list of    :py:class:`ClassHandle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, self).__init__()

                                    self.yang_name = "class-handles"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-handle" : ("class_handle", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle)}

                                    self.class_handle = YList(self)
                                    self._segment_path = lambda: "class-handles"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, [], name, value)


                                class ClassHandle(Entity):
                                    """
                                    Transient policy\-map class handle
                                    
                                    .. attribute:: inline_classhandle  <key>
                                    
                                    	inline class handle
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, self).__init__()

                                        self.yang_name = "class-handle"
                                        self.yang_parent_name = "class-handles"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg)}

                                        self.inline_classhandle = YLeaf(YType.int32, "inline-classhandle")

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "class-handle" + "[inline-classhandle='" + self.inline_classhandle.get() + "']"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, ['inline_classhandle'], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "class-handle"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                            class ClassSeqNums(Entity):
                                """
                                Transient policy\-map sequence number table
                                
                                .. attribute:: class_seq_num
                                
                                	Transient policy\-map sequence number
                                	**type**\: list of    :py:class:`ClassSeqNum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, self).__init__()

                                    self.yang_name = "class-seq-nums"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-seq-num" : ("class_seq_num", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum)}

                                    self.class_seq_num = YList(self)
                                    self._segment_path = lambda: "class-seq-nums"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, [], name, value)


                                class ClassSeqNum(Entity):
                                    """
                                    Transient policy\-map sequence number
                                    
                                    .. attribute:: sequence_num  <key>
                                    
                                    	sequence number
                                    	**type**\:  int
                                    
                                    	**range:** \-2147483648..2147483647
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, self).__init__()

                                        self.yang_name = "class-seq-num"
                                        self.yang_parent_name = "class-seq-nums"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg)}

                                        self.sequence_num = YLeaf(YType.int32, "sequence-num")

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "class-seq-num" + "[sequence-num='" + self.sequence_num.get() + "']"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, ['sequence_num'], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "class-seq-num"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                            class Definition(Entity):
                                """
                                Transient Policy\-map type name
                                
                                .. attribute:: policy_map_bg
                                
                                	policy map bg
                                	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, self).__init__()

                                    self.yang_name = "definition"
                                    self.yang_parent_name = "transient-policy-map-name"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg)}

                                    self.policy_map_bg = YList(self)
                                    self._segment_path = lambda: "definition"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, [], name, value)


                                class PolicyMapBg(Entity):
                                    """
                                    policy map bg
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\:  str
                                    
                                    .. attribute:: event_infop
                                    
                                    	event infop
                                    	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop>`
                                    
                                    .. attribute:: name
                                    
                                    	name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: pmap_var_list
                                    
                                    	pmap var list
                                    	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList>`
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, self).__init__()

                                        self.yang_name = "policy-map-bg"
                                        self.yang_parent_name = "definition"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList)}
                                        self._child_list_classes = {}

                                        self.description = YLeaf(YType.str, "description")

                                        self.name = YLeaf(YType.str, "name")

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.event_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop()
                                        self.event_infop.parent = self
                                        self._children_name_map["event_infop"] = "event-infop"
                                        self._children_yang_names.add("event-infop")

                                        self.pmap_var_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList()
                                        self.pmap_var_list.parent = self
                                        self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                        self._children_yang_names.add("pmap-var-list")
                                        self._segment_path = lambda: "policy-map-bg"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                    class EventInfop(Entity):
                                        """
                                        event infop
                                        
                                        .. attribute:: policy_event_info_bg
                                        
                                        	policy event info bg
                                        	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, self).__init__()

                                            self.yang_name = "event-infop"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                            self.policy_event_info_bg = YList(self)
                                            self._segment_path = lambda: "event-infop"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, [], name, value)


                                        class PolicyEventInfoBg(Entity):
                                            """
                                            policy event info bg
                                            
                                            .. attribute:: avl_tree
                                            
                                            	avl tree
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: class_infop
                                            
                                            	class infop
                                            	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                            
                                            .. attribute:: cond_eval
                                            
                                            	cond eval
                                            	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                            
                                            .. attribute:: event_type
                                            
                                            	event type
                                            	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                            
                                            .. attribute:: flags
                                            
                                            	flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                self.yang_name = "policy-event-info-bg"
                                                self.yang_parent_name = "event-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                self._child_list_classes = {}

                                                self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                self.event_type = YLeaf(YType.enumeration, "event-type")

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.class_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                self.class_infop.parent = self
                                                self._children_name_map["class_infop"] = "class-infop"
                                                self._children_yang_names.add("class-infop")
                                                self._segment_path = lambda: "policy-event-info-bg"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                            class ClassInfop(Entity):
                                                """
                                                class infop
                                                
                                                .. attribute:: policy_class_info_bg
                                                
                                                	policy class info bg
                                                	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                    self.yang_name = "class-infop"
                                                    self.yang_parent_name = "policy-event-info-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                    self.policy_class_info_bg = YList(self)
                                                    self._segment_path = lambda: "class-infop"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                class PolicyClassInfoBg(Entity):
                                                    """
                                                    policy class info bg
                                                    
                                                    .. attribute:: act_infop
                                                    
                                                    	act infop
                                                    	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                    
                                                    .. attribute:: cl_encode
                                                    
                                                    	cl encode
                                                    	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                    
                                                    .. attribute:: clmp_p
                                                    
                                                    	clmp p
                                                    	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                    
                                                    .. attribute:: ctype
                                                    
                                                    	ctype
                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                    
                                                    .. attribute:: exe_strat
                                                    
                                                    	exe strat
                                                    	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: num_actions
                                                    
                                                    	num actions
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: policy_class_hd
                                                    
                                                    	policy class hd
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: seq
                                                    
                                                    	seq
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: version
                                                    
                                                    	version
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                        self.yang_name = "policy-class-info-bg"
                                                        self.yang_parent_name = "class-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                        self._child_list_classes = {}

                                                        self.ctype = YLeaf(YType.enumeration, "ctype")

                                                        self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                        self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                        self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                        self.seq = YLeaf(YType.uint32, "seq")

                                                        self.version = YLeaf(YType.uint8, "version")

                                                        self.act_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                        self.act_infop.parent = self
                                                        self._children_name_map["act_infop"] = "act-infop"
                                                        self._children_yang_names.add("act-infop")

                                                        self.cl_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                        self.cl_encode.parent = self
                                                        self._children_name_map["cl_encode"] = "cl-encode"
                                                        self._children_yang_names.add("cl-encode")

                                                        self.clmp_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                        self.clmp_p.parent = self
                                                        self._children_name_map["clmp_p"] = "clmp-p"
                                                        self._children_yang_names.add("clmp-p")
                                                        self._segment_path = lambda: "policy-class-info-bg"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                    class ActInfop(Entity):
                                                        """
                                                        act infop
                                                        
                                                        .. attribute:: policy_action_info_st
                                                        
                                                        	policy action info st
                                                        	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                            self.yang_name = "act-infop"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                            self.policy_action_info_st = YList(self)
                                                            self._segment_path = lambda: "act-infop"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                        class PolicyActionInfoSt(Entity):
                                                            """
                                                            policy action info st
                                                            
                                                            .. attribute:: actp
                                                            
                                                            	actp
                                                            	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                self.yang_name = "policy-action-info-st"
                                                                self.yang_parent_name = "act-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                self._child_list_classes = {}

                                                                self.flags = YLeaf(YType.uint16, "flags")

                                                                self.seq = YLeaf(YType.uint16, "seq")

                                                                self.actp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                self.actp.parent = self
                                                                self._children_name_map["actp"] = "actp"
                                                                self._children_yang_names.add("actp")
                                                                self._segment_path = lambda: "policy-action-info-st"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                            class Actp(Entity):
                                                                """
                                                                actp
                                                                
                                                                .. attribute:: accounting_event_aaa
                                                                
                                                                	accounting event aaa
                                                                	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                
                                                                .. attribute:: acct_aaa_list
                                                                
                                                                	acct aaa list
                                                                	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                
                                                                .. attribute:: act_template
                                                                
                                                                	act template
                                                                	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                
                                                                .. attribute:: afm_react
                                                                
                                                                	afm react
                                                                	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                
                                                                .. attribute:: authen_aaa
                                                                
                                                                	authen aaa
                                                                	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                
                                                                .. attribute:: authorize_id
                                                                
                                                                	authorize id
                                                                	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                
                                                                .. attribute:: cac
                                                                
                                                                	cac
                                                                	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                
                                                                .. attribute:: collect_id
                                                                
                                                                	collect id
                                                                	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                
                                                                .. attribute:: copy
                                                                
                                                                	copy
                                                                	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                
                                                                .. attribute:: data_p
                                                                
                                                                	data p
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: deact_template
                                                                
                                                                	deact template
                                                                	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                
                                                                .. attribute:: decode_id
                                                                
                                                                	decode id
                                                                	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                
                                                                .. attribute:: encap
                                                                
                                                                	encap
                                                                	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                
                                                                .. attribute:: flow_parm
                                                                
                                                                	flow parm
                                                                	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                
                                                                .. attribute:: fmm
                                                                
                                                                	fmm
                                                                	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                
                                                                .. attribute:: httpr
                                                                
                                                                	httpr
                                                                	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                
                                                                .. attribute:: ipcbr
                                                                
                                                                	ipcbr
                                                                	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                
                                                                .. attribute:: ipv4_nh
                                                                
                                                                	ipv4 nh
                                                                	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                
                                                                .. attribute:: ipv6_nh
                                                                
                                                                	ipv6 nh
                                                                	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                
                                                                .. attribute:: mark
                                                                
                                                                	mark
                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                
                                                                .. attribute:: mark2
                                                                
                                                                	mark2
                                                                	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                
                                                                .. attribute:: mdi
                                                                
                                                                	mdi
                                                                	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                
                                                                .. attribute:: mdi_rtp
                                                                
                                                                	mdi rtp
                                                                	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                
                                                                .. attribute:: min_bw
                                                                
                                                                	min bw
                                                                	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                
                                                                .. attribute:: out_intf
                                                                
                                                                	out intf
                                                                	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                
                                                                .. attribute:: pbf
                                                                
                                                                	pbf
                                                                	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                
                                                                .. attribute:: pfc
                                                                
                                                                	pfc
                                                                	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                
                                                                .. attribute:: police
                                                                
                                                                	police
                                                                	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                
                                                                .. attribute:: prepaid_cfg
                                                                
                                                                	prepaid cfg
                                                                	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                
                                                                .. attribute:: prio
                                                                
                                                                	prio
                                                                	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                
                                                                .. attribute:: proxy_aaa
                                                                
                                                                	proxy aaa
                                                                	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                
                                                                .. attribute:: punt
                                                                
                                                                	punt
                                                                	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                
                                                                .. attribute:: qlimit
                                                                
                                                                	qlimit
                                                                	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                
                                                                .. attribute:: query_ancp
                                                                
                                                                	query ancp
                                                                	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                
                                                                .. attribute:: redirect
                                                                
                                                                	redirect
                                                                	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                
                                                                .. attribute:: rtp
                                                                
                                                                	rtp
                                                                	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                
                                                                .. attribute:: rtp_j2k
                                                                
                                                                	rtp j2k
                                                                	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                
                                                                .. attribute:: rtp_mmr
                                                                
                                                                	rtp mmr
                                                                	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                
                                                                .. attribute:: rtp_voice
                                                                
                                                                	rtp voice
                                                                	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                
                                                                .. attribute:: serv_func
                                                                
                                                                	serv func
                                                                	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                
                                                                .. attribute:: set_timer
                                                                
                                                                	set timer
                                                                	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                
                                                                .. attribute:: sfrag
                                                                
                                                                	sfrag
                                                                	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                
                                                                .. attribute:: shape
                                                                
                                                                	shape
                                                                	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                
                                                                .. attribute:: stop_timer
                                                                
                                                                	stop timer
                                                                	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                
                                                                .. attribute:: timeout_idle
                                                                
                                                                	timeout idle
                                                                	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: wred
                                                                
                                                                	wred
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                    self.yang_name = "actp"
                                                                    self.yang_parent_name = "policy-action-info-st"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                    self._child_list_classes = {}

                                                                    self.data_p = YLeaf(YType.uint32, "data-p")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.accounting_event_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                    self.accounting_event_aaa.parent = self
                                                                    self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                    self._children_yang_names.add("accounting-event-aaa")

                                                                    self.acct_aaa_list = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                    self.acct_aaa_list.parent = self
                                                                    self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                    self._children_yang_names.add("acct-aaa-list")

                                                                    self.act_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                    self.act_template.parent = self
                                                                    self._children_name_map["act_template"] = "act-template"
                                                                    self._children_yang_names.add("act-template")

                                                                    self.afm_react = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                    self.afm_react.parent = self
                                                                    self._children_name_map["afm_react"] = "afm-react"
                                                                    self._children_yang_names.add("afm-react")

                                                                    self.authen_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                    self.authen_aaa.parent = self
                                                                    self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                    self._children_yang_names.add("authen-aaa")

                                                                    self.authorize_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                    self.authorize_id.parent = self
                                                                    self._children_name_map["authorize_id"] = "authorize-id"
                                                                    self._children_yang_names.add("authorize-id")

                                                                    self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"
                                                                    self._children_yang_names.add("bwrem")

                                                                    self.cac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                    self.cac.parent = self
                                                                    self._children_name_map["cac"] = "cac"
                                                                    self._children_yang_names.add("cac")

                                                                    self.child_policy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"
                                                                    self._children_yang_names.add("child-policy")

                                                                    self.collect_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                    self.collect_id.parent = self
                                                                    self._children_name_map["collect_id"] = "collect-id"
                                                                    self._children_yang_names.add("collect-id")

                                                                    self.copy = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                    self.copy.parent = self
                                                                    self._children_name_map["copy"] = "copy"
                                                                    self._children_yang_names.add("copy")

                                                                    self.deact_template = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                    self.deact_template.parent = self
                                                                    self._children_name_map["deact_template"] = "deact-template"
                                                                    self._children_yang_names.add("deact-template")

                                                                    self.decode_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                    self.decode_id.parent = self
                                                                    self._children_name_map["decode_id"] = "decode-id"
                                                                    self._children_yang_names.add("decode-id")

                                                                    self.encap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                    self.encap.parent = self
                                                                    self._children_name_map["encap"] = "encap"
                                                                    self._children_yang_names.add("encap")

                                                                    self.flow_parm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                    self.flow_parm.parent = self
                                                                    self._children_name_map["flow_parm"] = "flow-parm"
                                                                    self._children_yang_names.add("flow-parm")

                                                                    self.fmm = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                    self.fmm.parent = self
                                                                    self._children_name_map["fmm"] = "fmm"
                                                                    self._children_yang_names.add("fmm")

                                                                    self.httpr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                    self.httpr.parent = self
                                                                    self._children_name_map["httpr"] = "httpr"
                                                                    self._children_yang_names.add("httpr")

                                                                    self.ipcbr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                    self.ipcbr.parent = self
                                                                    self._children_name_map["ipcbr"] = "ipcbr"
                                                                    self._children_yang_names.add("ipcbr")

                                                                    self.ipv4_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                    self.ipv4_nh.parent = self
                                                                    self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                    self._children_yang_names.add("ipv4-nh")

                                                                    self.ipv6_nh = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                    self.ipv6_nh.parent = self
                                                                    self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                    self._children_yang_names.add("ipv6-nh")

                                                                    self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                    self.mark.parent = self
                                                                    self._children_name_map["mark"] = "mark"
                                                                    self._children_yang_names.add("mark")

                                                                    self.mark2 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                    self.mark2.parent = self
                                                                    self._children_name_map["mark2"] = "mark2"
                                                                    self._children_yang_names.add("mark2")

                                                                    self.mdi = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                    self.mdi.parent = self
                                                                    self._children_name_map["mdi"] = "mdi"
                                                                    self._children_yang_names.add("mdi")

                                                                    self.mdi_rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                    self.mdi_rtp.parent = self
                                                                    self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                    self._children_yang_names.add("mdi-rtp")

                                                                    self.min_bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                    self.min_bw.parent = self
                                                                    self._children_name_map["min_bw"] = "min-bw"
                                                                    self._children_yang_names.add("min-bw")

                                                                    self.out_intf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                    self.out_intf.parent = self
                                                                    self._children_name_map["out_intf"] = "out-intf"
                                                                    self._children_yang_names.add("out-intf")

                                                                    self.pbf = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                    self.pbf.parent = self
                                                                    self._children_name_map["pbf"] = "pbf"
                                                                    self._children_yang_names.add("pbf")

                                                                    self.pfc = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                    self.pfc.parent = self
                                                                    self._children_name_map["pfc"] = "pfc"
                                                                    self._children_yang_names.add("pfc")

                                                                    self.police = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                    self.police.parent = self
                                                                    self._children_name_map["police"] = "police"
                                                                    self._children_yang_names.add("police")

                                                                    self.prepaid_cfg = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                    self.prepaid_cfg.parent = self
                                                                    self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                    self._children_yang_names.add("prepaid-cfg")

                                                                    self.prio = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                    self.prio.parent = self
                                                                    self._children_name_map["prio"] = "prio"
                                                                    self._children_yang_names.add("prio")

                                                                    self.proxy_aaa = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                    self.proxy_aaa.parent = self
                                                                    self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                    self._children_yang_names.add("proxy-aaa")

                                                                    self.punt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                    self.punt.parent = self
                                                                    self._children_name_map["punt"] = "punt"
                                                                    self._children_yang_names.add("punt")

                                                                    self.qlimit = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                    self.qlimit.parent = self
                                                                    self._children_name_map["qlimit"] = "qlimit"
                                                                    self._children_yang_names.add("qlimit")

                                                                    self.query_ancp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                    self.query_ancp.parent = self
                                                                    self._children_name_map["query_ancp"] = "query-ancp"
                                                                    self._children_yang_names.add("query-ancp")

                                                                    self.redirect = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                    self.redirect.parent = self
                                                                    self._children_name_map["redirect"] = "redirect"
                                                                    self._children_yang_names.add("redirect")

                                                                    self.rtp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                    self.rtp.parent = self
                                                                    self._children_name_map["rtp"] = "rtp"
                                                                    self._children_yang_names.add("rtp")

                                                                    self.rtp_j2k = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                    self.rtp_j2k.parent = self
                                                                    self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                    self._children_yang_names.add("rtp-j2k")

                                                                    self.rtp_mmr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                    self.rtp_mmr.parent = self
                                                                    self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                    self._children_yang_names.add("rtp-mmr")

                                                                    self.rtp_voice = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                    self.rtp_voice.parent = self
                                                                    self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                    self._children_yang_names.add("rtp-voice")

                                                                    self.serv_func = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                    self.serv_func.parent = self
                                                                    self._children_name_map["serv_func"] = "serv-func"
                                                                    self._children_yang_names.add("serv-func")

                                                                    self.set_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                    self.set_timer.parent = self
                                                                    self._children_name_map["set_timer"] = "set-timer"
                                                                    self._children_yang_names.add("set-timer")

                                                                    self.sfrag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                    self.sfrag.parent = self
                                                                    self._children_name_map["sfrag"] = "sfrag"
                                                                    self._children_yang_names.add("sfrag")

                                                                    self.shape = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                    self.shape.parent = self
                                                                    self._children_name_map["shape"] = "shape"
                                                                    self._children_yang_names.add("shape")

                                                                    self.stop_timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                    self.stop_timer.parent = self
                                                                    self._children_name_map["stop_timer"] = "stop-timer"
                                                                    self._children_yang_names.add("stop-timer")

                                                                    self.timeout_idle = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                    self.timeout_idle.parent = self
                                                                    self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                    self._children_yang_names.add("timeout-idle")

                                                                    self.wred = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                    self.wred.parent = self
                                                                    self._children_name_map["wred"] = "wred"
                                                                    self._children_yang_names.add("wred")
                                                                    self._segment_path = lambda: "actp"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                class AccountingEventAaa(Entity):
                                                                    """
                                                                    accounting event aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: action
                                                                    
                                                                    	action
                                                                    	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                        self.yang_name = "accounting-event-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.action = YLeaf(YType.enumeration, "action")
                                                                        self._segment_path = lambda: "accounting-event-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                class AcctAaaList(Entity):
                                                                    """
                                                                    acct aaa list
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                        self.yang_name = "acct-aaa-list"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.secs = YLeaf(YType.uint32, "secs")
                                                                        self._segment_path = lambda: "acct-aaa-list"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                class ActTemplate(Entity):
                                                                    """
                                                                    act template
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                        self.yang_name = "act-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.template_name = YLeaf(YType.str, "template-name")
                                                                        self._segment_path = lambda: "act-template"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                class AfmReact(Entity):
                                                                    """
                                                                    afm react
                                                                    
                                                                    .. attribute:: action_afmon_react_info
                                                                    
                                                                    	action afmon react info
                                                                    	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                        self.yang_name = "afm-react"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                        self.action_afmon_react_info = YList(self)
                                                                        self._segment_path = lambda: "afm-react"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                    class ActionAfmonReactInfo(Entity):
                                                                        """
                                                                        action afmon react info
                                                                        
                                                                        .. attribute:: alm_grp_thresh
                                                                        
                                                                        	Num/percent in grp
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: percentage
                                                                        
                                                                        .. attribute:: alm_severity
                                                                        
                                                                        	Major\|Minor\|... alarm
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: alm_type
                                                                        
                                                                        	Discrete \| grouped alarm
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: clone_ifh
                                                                        
                                                                        	Clone interface handle
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: criterion
                                                                        
                                                                        	React Criterion
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	Describing the oper
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: notif_actns
                                                                        
                                                                        	Bitmap of actions on alert
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: oper_id
                                                                        
                                                                        	React Operation ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: trig_level_1
                                                                        
                                                                        	Trigger threshold 1/lower
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: trig_level_2
                                                                        
                                                                        	Trigger upper threshold for range
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: trig_num_intvls
                                                                        
                                                                        	Averaged over N intvls
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: trig_relop
                                                                        
                                                                        	Trigger LT\|LE\|GT\|GE\|Range
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_type
                                                                        
                                                                        	Immediate or averaged thresh trigger
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                            self.yang_name = "action-afmon-react-info"
                                                                            self.yang_parent_name = "afm-react"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                            self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                            self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                            self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                            self.criterion = YLeaf(YType.uint8, "criterion")

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                            self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                            self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                            self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                            self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                            self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                            self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                            self._segment_path = lambda: "action-afmon-react-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                class AuthenAaa(Entity):
                                                                    """
                                                                    authen aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: authen_password
                                                                    
                                                                    	authen password
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                        self.yang_name = "authen-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.authen_password = YLeaf(YType.str, "authen-password")
                                                                        self._segment_path = lambda: "authen-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                class AuthorizeId(Entity):
                                                                    """
                                                                    authorize id
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: password
                                                                    
                                                                    	password
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                        self.yang_name = "authorize-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.format_name = YLeaf(YType.str, "format-name")

                                                                        self.id = YLeaf(YType.uint8, "id")

                                                                        self.password = YLeaf(YType.str, "password")
                                                                        self._segment_path = lambda: "authorize-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                class Bwrem(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                        self._child_list_classes = {}

                                                                        self.bwrem = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")
                                                                        self._segment_path = lambda: "bwrem"


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "bwrem"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bwrem"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                class Cac(Entity):
                                                                    """
                                                                    cac
                                                                    
                                                                    .. attribute:: cac_type
                                                                    
                                                                    	cac type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: flow_rate
                                                                    
                                                                    	flow rate
                                                                    	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                    
                                                                    .. attribute:: idle_timeout
                                                                    
                                                                    	idle timeout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                        self.yang_name = "cac"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                        self._child_list_classes = {}

                                                                        self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                        self.flow_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                        self.flow_rate.parent = self
                                                                        self._children_name_map["flow_rate"] = "flow-rate"
                                                                        self._children_yang_names.add("flow-rate")

                                                                        self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._children_yang_names.add("rate")
                                                                        self._segment_path = lambda: "cac"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                    class FlowRate(Entity):
                                                                        """
                                                                        flow rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                            self.yang_name = "flow-rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "flow-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: hd_info
                                                                    
                                                                    	hd info
                                                                    	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                    
                                                                    .. attribute:: info
                                                                    
                                                                    	info
                                                                    	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                        self._child_list_classes = {}

                                                                        self.enc = YLeaf(YType.enumeration, "enc")

                                                                        self.hd_info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                        self.hd_info.parent = self
                                                                        self._children_name_map["hd_info"] = "hd-info"
                                                                        self._children_yang_names.add("hd-info")

                                                                        self.info = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                        self.info.parent = self
                                                                        self._children_name_map["info"] = "info"
                                                                        self._children_yang_names.add("info")
                                                                        self._segment_path = lambda: "child-policy"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                    class HdInfo(Entity):
                                                                        """
                                                                        hd info
                                                                        
                                                                        .. attribute:: data_hd
                                                                        
                                                                        	data hd
                                                                        	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                            self.yang_name = "hd-info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                            self._child_list_classes = {}

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.data_hd = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                            self.data_hd.parent = self
                                                                            self._children_name_map["data_hd"] = "data-hd"
                                                                            self._children_yang_names.add("data-hd")
                                                                            self._segment_path = lambda: "hd-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                        class DataHd(Entity):
                                                                            """
                                                                            data hd
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                self.yang_name = "data-hd"
                                                                                self.yang_parent_name = "hd-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}
                                                                                self._segment_path = lambda: "data-hd"


                                                                    class Info(Entity):
                                                                        """
                                                                        info
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                            self.yang_name = "info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")

                                                                            self.type = YLeaf(YType.enumeration, "type")
                                                                            self._segment_path = lambda: "info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                class CollectId(Entity):
                                                                    """
                                                                    collect id
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                        self.yang_name = "collect-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.id = YLeaf(YType.enumeration, "id")
                                                                        self._segment_path = lambda: "collect-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                class Copy(Entity):
                                                                    """
                                                                    copy
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: num_byte
                                                                    
                                                                    	number of bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node url
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                        self.yang_name = "copy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.app_id = YLeaf(YType.uint32, "app-id")

                                                                        self.local_id = YLeaf(YType.uint32, "local-id")

                                                                        self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                        self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                        self.sn_name = YLeaf(YType.str, "sn-name")

                                                                        self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                        self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                        self._segment_path = lambda: "copy"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                class DeactTemplate(Entity):
                                                                    """
                                                                    deact template
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                        self.yang_name = "deact-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.template_name = YLeaf(YType.str, "template-name")
                                                                        self._segment_path = lambda: "deact-template"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                class DecodeId(Entity):
                                                                    """
                                                                    decode id
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                        self.yang_name = "decode-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.format_name = YLeaf(YType.str, "format-name")

                                                                        self.id = YLeaf(YType.enumeration, "id")
                                                                        self._segment_path = lambda: "decode-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                class Encap(Entity):
                                                                    """
                                                                    encap
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                        self.yang_name = "encap"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.seq = YLeaf(YType.uint8, "seq")
                                                                        self._segment_path = lambda: "encap"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                class FlowParm(Entity):
                                                                    """
                                                                    flow parm
                                                                    
                                                                    .. attribute:: flow_timeout
                                                                    
                                                                    	timeout in secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    .. attribute:: intvl_hist
                                                                    
                                                                    	num intervals of data stored on rtr
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_mon_flows
                                                                    
                                                                    	max simult flows monitored per policy class
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: mon_interval
                                                                    
                                                                    	monitored interval duration in secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                        self.yang_name = "flow-parm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                        self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                        self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                        self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                        self._segment_path = lambda: "flow-parm"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                class Fmm(Entity):
                                                                    """
                                                                    fmm
                                                                    
                                                                    .. attribute:: fmm_name
                                                                    
                                                                    	flow monitor name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..33
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                        self.yang_name = "fmm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                        self._segment_path = lambda: "fmm"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                class Httpr(Entity):
                                                                    """
                                                                    httpr
                                                                    
                                                                    .. attribute:: redirect_url
                                                                    
                                                                    	redirect url
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                        self.yang_name = "httpr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                        self._segment_path = lambda: "httpr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                class Ipcbr(Entity):
                                                                    """
                                                                    ipcbr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: media_bit_rate
                                                                    
                                                                    	media data rate in bps
                                                                    	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                    
                                                                    .. attribute:: media_pkt_size
                                                                    
                                                                    	media packet size in bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: media_pkts_per_ip
                                                                    
                                                                    	media packets per ip pkt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                        self.yang_name = "ipcbr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                        self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                        self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")

                                                                        self.media_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                        self.media_bit_rate.parent = self
                                                                        self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                        self._children_yang_names.add("media-bit-rate")
                                                                        self._segment_path = lambda: "ipcbr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MediaBitRate(Entity):
                                                                        """
                                                                        media data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                            self.yang_name = "media-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "media-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                class Ipv4Nh(Entity):
                                                                    """
                                                                    ipv4 nh
                                                                    
                                                                    .. attribute:: action_ipv4_nh_info_array
                                                                    
                                                                    	action ipv4 nh info array
                                                                    	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                        self.yang_name = "ipv4-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                        self.action_ipv4_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv4-nh"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                    class ActionIpv4NhInfoArray(Entity):
                                                                        """
                                                                        action ipv4 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	nh addr
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv4-nh-info-array"
                                                                            self.yang_parent_name = "ipv4-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                            self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                            self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Ipv6Nh(Entity):
                                                                    """
                                                                    ipv6 nh
                                                                    
                                                                    .. attribute:: action_ipv6_nh_info_array
                                                                    
                                                                    	action ipv6 nh info array
                                                                    	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                        self.yang_name = "ipv6-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                        self.action_ipv6_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv6-nh"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                    class ActionIpv6NhInfoArray(Entity):
                                                                        """
                                                                        action ipv6 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	IPV6 Address
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv6-nh-info-array"
                                                                            self.yang_parent_name = "ipv6-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                            self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                            self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Mark(Entity):
                                                                    """
                                                                    mark
                                                                    
                                                                    .. attribute:: action_mark_info
                                                                    
                                                                    	action mark info
                                                                    	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                        self.yang_name = "mark"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                        self.action_mark_info = YList(self)
                                                                        self._segment_path = lambda: "mark"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                    class ActionMarkInfo(Entity):
                                                                        """
                                                                        action mark info
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                            self.yang_name = "action-mark-info"
                                                                            self.yang_parent_name = "mark"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                            self._segment_path = lambda: "action-mark-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                class Mark2(Entity):
                                                                    """
                                                                    mark2
                                                                    
                                                                    .. attribute:: action_mark2_info
                                                                    
                                                                    	action mark2 info
                                                                    	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                        self.yang_name = "mark2"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                        self.action_mark2_info = YList(self)
                                                                        self._segment_path = lambda: "mark2"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                    class ActionMark2Info(Entity):
                                                                        """
                                                                        action mark2 info
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value_overflow
                                                                        
                                                                        	value overflow
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                            self.yang_name = "action-mark2-info"
                                                                            self.yang_parent_name = "mark2"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                            self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                            self._segment_path = lambda: "action-mark2-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                class Mdi(Entity):
                                                                    """
                                                                    mdi
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\:  list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                        self.yang_name = "mdi"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.pids = YLeafList(YType.uint32, "pids")

                                                                        self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")
                                                                        self._segment_path = lambda: "mdi"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                class MdiRtp(Entity):
                                                                    """
                                                                    mdi rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\:  list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                        self.yang_name = "mdi-rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.pids = YLeafList(YType.uint32, "pids")

                                                                        self.ip_bit_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")
                                                                        self._segment_path = lambda: "mdi-rtp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi-rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                class MinBw(Entity):
                                                                    """
                                                                    min bw
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                        self.yang_name = "min-bw"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                        self._child_list_classes = {}

                                                                        self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._children_yang_names.add("bw")
                                                                        self._segment_path = lambda: "min-bw"


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "min-bw"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bw"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                class OutIntf(Entity):
                                                                    """
                                                                    out intf
                                                                    
                                                                    .. attribute:: out_ifname
                                                                    
                                                                    	output interface name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                        self.yang_name = "out-intf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                        self._segment_path = lambda: "out-intf"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                class Pbf(Entity):
                                                                    """
                                                                    pbf
                                                                    
                                                                    .. attribute:: action_pbf_info_array
                                                                    
                                                                    	action pbf info array
                                                                    	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                        self.yang_name = "pbf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                        self.action_pbf_info_array = YList(self)
                                                                        self._segment_path = lambda: "pbf"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                    class ActionPbfInfoArray(Entity):
                                                                        """
                                                                        action pbf info array
                                                                        
                                                                        .. attribute:: addr
                                                                        
                                                                        	v4 or v6 address
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: rt
                                                                        
                                                                        	route target
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                        
                                                                        .. attribute:: rt_type
                                                                        
                                                                        	route target type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vrf
                                                                        
                                                                        	vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                            self.yang_name = "action-pbf-info-array"
                                                                            self.yang_parent_name = "pbf"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.addr = YLeaf(YType.str, "addr")

                                                                            self.rt = YLeaf(YType.str, "rt")

                                                                            self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                            self.vrf = YLeaf(YType.str, "vrf")
                                                                            self._segment_path = lambda: "action-pbf-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                class Pfc(Entity):
                                                                    """
                                                                    pfc
                                                                    
                                                                    .. attribute:: buffer_size
                                                                    
                                                                    	buffer size
                                                                    	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                    
                                                                    .. attribute:: buffer_size_flag
                                                                    
                                                                    	buffer size flag
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pause_threshold
                                                                    
                                                                    	pause threshold
                                                                    	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                    
                                                                    .. attribute:: pfc_pause_set
                                                                    
                                                                    	pfc pause set
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: resume_threshold
                                                                    
                                                                    	resume threshold
                                                                    	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                        self.yang_name = "pfc"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                        self._child_list_classes = {}

                                                                        self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                        self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                        self.buffer_size = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                        self.buffer_size.parent = self
                                                                        self._children_name_map["buffer_size"] = "buffer-size"
                                                                        self._children_yang_names.add("buffer-size")

                                                                        self.pause_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                        self.pause_threshold.parent = self
                                                                        self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                        self._children_yang_names.add("pause-threshold")

                                                                        self.resume_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                        self.resume_threshold.parent = self
                                                                        self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                        self._children_yang_names.add("resume-threshold")
                                                                        self._segment_path = lambda: "pfc"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                    class BufferSize(Entity):
                                                                        """
                                                                        buffer size
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                            self.yang_name = "buffer-size"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "buffer-size"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                    class PauseThreshold(Entity):
                                                                        """
                                                                        pause threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                            self.yang_name = "pause-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "pause-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                    class ResumeThreshold(Entity):
                                                                        """
                                                                        resume threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                            self.yang_name = "resume-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "resume-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                class Police(Entity):
                                                                    """
                                                                    police
                                                                    
                                                                    .. attribute:: burst
                                                                    
                                                                    	burst
                                                                    	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                    
                                                                    .. attribute:: cdvt
                                                                    
                                                                    	cdvt
                                                                    	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                    
                                                                    .. attribute:: confclass_encode
                                                                    
                                                                    	confclass encode
                                                                    	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                    
                                                                    .. attribute:: confclass_p
                                                                    
                                                                    	confclass p
                                                                    	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                    
                                                                    .. attribute:: conform_actns
                                                                    
                                                                    	conform actns
                                                                    	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                    
                                                                    .. attribute:: excdclass_encode
                                                                    
                                                                    	excdclass encode
                                                                    	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                    
                                                                    .. attribute:: excdclass_p
                                                                    
                                                                    	excdclass p
                                                                    	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                    
                                                                    .. attribute:: exceed_actns
                                                                    
                                                                    	exceed actns
                                                                    	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: peak_burst
                                                                    
                                                                    	peak burst
                                                                    	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                    
                                                                    .. attribute:: peak_rate
                                                                    
                                                                    	peak rate
                                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                    
                                                                    .. attribute:: police_flags
                                                                    
                                                                    	police flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                    
                                                                    .. attribute:: sbuck_name
                                                                    
                                                                    	sbuck name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: sbuck_type
                                                                    
                                                                    	sbuck type
                                                                    	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                    
                                                                    .. attribute:: violate_actns
                                                                    
                                                                    	violate actns
                                                                    	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                        self.yang_name = "police"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                        self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                        self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                        self.burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                        self.burst.parent = self
                                                                        self._children_name_map["burst"] = "burst"
                                                                        self._children_yang_names.add("burst")

                                                                        self.cdvt = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                        self.cdvt.parent = self
                                                                        self._children_name_map["cdvt"] = "cdvt"
                                                                        self._children_yang_names.add("cdvt")

                                                                        self.confclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                        self.confclass_encode.parent = self
                                                                        self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                        self._children_yang_names.add("confclass-encode")

                                                                        self.confclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                        self.confclass_p.parent = self
                                                                        self._children_name_map["confclass_p"] = "confclass-p"
                                                                        self._children_yang_names.add("confclass-p")

                                                                        self.conform_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                        self.conform_actns.parent = self
                                                                        self._children_name_map["conform_actns"] = "conform-actns"
                                                                        self._children_yang_names.add("conform-actns")

                                                                        self.excdclass_encode = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                        self.excdclass_encode.parent = self
                                                                        self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                        self._children_yang_names.add("excdclass-encode")

                                                                        self.excdclass_p = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                        self.excdclass_p.parent = self
                                                                        self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                        self._children_yang_names.add("excdclass-p")

                                                                        self.exceed_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                        self.exceed_actns.parent = self
                                                                        self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                        self._children_yang_names.add("exceed-actns")

                                                                        self.peak_burst = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                        self.peak_burst.parent = self
                                                                        self._children_name_map["peak_burst"] = "peak-burst"
                                                                        self._children_yang_names.add("peak-burst")

                                                                        self.peak_rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                        self.peak_rate.parent = self
                                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                                        self._children_yang_names.add("peak-rate")

                                                                        self.rate = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._children_yang_names.add("rate")

                                                                        self.violate_actns = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                        self.violate_actns.parent = self
                                                                        self._children_name_map["violate_actns"] = "violate-actns"
                                                                        self._children_yang_names.add("violate-actns")
                                                                        self._segment_path = lambda: "police"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                    class Burst(Entity):
                                                                        """
                                                                        burst
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                            self.yang_name = "burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "burst"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                    class Cdvt(Entity):
                                                                        """
                                                                        cdvt
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                            self.yang_name = "cdvt"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "cdvt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                    class ConfclassEncode(Entity):
                                                                        """
                                                                        confclass encode
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                            self.yang_name = "confclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                            self._child_list_classes = {}

                                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                                            self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._children_yang_names.add("inline-cmap")
                                                                            self._segment_path = lambda: "confclass-encode"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "confclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "inline-cmap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ConfclassP(Entity):
                                                                        """
                                                                        confclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                            self.yang_name = "confclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "confclass-p"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "confclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "class-map-bg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ConformActns(Entity):
                                                                        """
                                                                        conform actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                            self.yang_name = "conform-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "conform-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "conform-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class ExcdclassEncode(Entity):
                                                                        """
                                                                        excdclass encode
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                            self.yang_name = "excdclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                            self._child_list_classes = {}

                                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                                            self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._children_yang_names.add("inline-cmap")
                                                                            self._segment_path = lambda: "excdclass-encode"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "excdclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "inline-cmap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ExcdclassP(Entity):
                                                                        """
                                                                        excdclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                            self.yang_name = "excdclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "excdclass-p"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "excdclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "class-map-bg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ExceedActns(Entity):
                                                                        """
                                                                        exceed actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                            self.yang_name = "exceed-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "exceed-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "exceed-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PeakBurst(Entity):
                                                                        """
                                                                        peak burst
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                            self.yang_name = "peak-burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "peak-burst"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                    class PeakRate(Entity):
                                                                        """
                                                                        peak rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                            self.yang_name = "peak-rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "peak-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                    class ViolateActns(Entity):
                                                                        """
                                                                        violate actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                            self.yang_name = "violate-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "violate-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "violate-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                class PrepaidCfg(Entity):
                                                                    """
                                                                    prepaid cfg
                                                                    
                                                                    .. attribute:: prepaid_config_profile_name
                                                                    
                                                                    	prepaid config profile name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                        self.yang_name = "prepaid-cfg"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                        self._segment_path = lambda: "prepaid-cfg"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                class Prio(Entity):
                                                                    """
                                                                    prio
                                                                    
                                                                    .. attribute:: prio_lvl
                                                                    
                                                                    	prio lvl
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                        self.yang_name = "prio"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                        self._segment_path = lambda: "prio"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                class ProxyAaa(Entity):
                                                                    """
                                                                    proxy aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                        self.yang_name = "proxy-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                        self._segment_path = lambda: "proxy-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                class Punt(Entity):
                                                                    """
                                                                    punt
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                        self.yang_name = "punt"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.app_id = YLeaf(YType.uint32, "app-id")

                                                                        self.local_id = YLeaf(YType.uint32, "local-id")

                                                                        self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                        self.sn_name = YLeaf(YType.str, "sn-name")

                                                                        self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                        self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                        self._segment_path = lambda: "punt"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                class Qlimit(Entity):
                                                                    """
                                                                    qlimit
                                                                    
                                                                    .. attribute:: action_qlimit_info_array
                                                                    
                                                                    	action qlimit info array
                                                                    	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                        self.yang_name = "qlimit"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                        self.action_qlimit_info_array = YList(self)
                                                                        self._segment_path = lambda: "qlimit"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                    class ActionQlimitInfoArray(Entity):
                                                                        """
                                                                        action qlimit info array
                                                                        
                                                                        .. attribute:: atmclp_qlim
                                                                        
                                                                        	atmclp qlim
                                                                        	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                        
                                                                        .. attribute:: match_values
                                                                        
                                                                        	match values
                                                                        	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                        
                                                                        .. attribute:: qlim
                                                                        
                                                                        	qlim
                                                                        	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                        
                                                                        .. attribute:: qlimit_flags
                                                                        
                                                                        	qlimit flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                            self.yang_name = "action-qlimit-info-array"
                                                                            self.yang_parent_name = "qlimit"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                            self._child_list_classes = {}

                                                                            self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.atmclp_qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                            self.atmclp_qlim.parent = self
                                                                            self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                            self._children_yang_names.add("atmclp-qlim")

                                                                            self.match_values = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                            self.match_values.parent = self
                                                                            self._children_name_map["match_values"] = "match-values"
                                                                            self._children_yang_names.add("match-values")

                                                                            self.qlim = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                            self.qlim.parent = self
                                                                            self._children_name_map["qlim"] = "qlim"
                                                                            self._children_yang_names.add("qlim")
                                                                            self._segment_path = lambda: "action-qlimit-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                        class AtmclpQlim(Entity):
                                                                            """
                                                                            atmclp qlim
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                self.yang_name = "atmclp-qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "atmclp-qlim"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                        class MatchValues(Entity):
                                                                            """
                                                                            match values
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                self.yang_name = "match-values"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-values"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-values"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Qlim(Entity):
                                                                            """
                                                                            qlim
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                self.yang_name = "qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "qlim"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                class QueryAncp(Entity):
                                                                    """
                                                                    query ancp
                                                                    
                                                                    .. attribute:: enable
                                                                    
                                                                    	enable
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                        self.yang_name = "query-ancp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.enable = YLeaf(YType.uint8, "enable")
                                                                        self._segment_path = lambda: "query-ancp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                class Redirect(Entity):
                                                                    """
                                                                    redirect
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                        self.yang_name = "redirect"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.type = YLeaf(YType.uint8, "type")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "redirect"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                class Rtp(Entity):
                                                                    """
                                                                    rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                        self.yang_name = "rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpJ2K(Entity):
                                                                    """
                                                                    rtp j2k
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                        self.yang_name = "rtp-j2k"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-j2k"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-j2k"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpMmr(Entity):
                                                                    """
                                                                    rtp mmr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                        self.yang_name = "rtp-mmr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-mmr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-mmr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpVoice(Entity):
                                                                    """
                                                                    rtp voice
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                        self.yang_name = "rtp-voice"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-voice"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-voice"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                class ServFunc(Entity):
                                                                    """
                                                                    serv func
                                                                    
                                                                    .. attribute:: meta_name
                                                                    
                                                                    	metadata name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: path_id
                                                                    
                                                                    	service path id
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: service_index
                                                                    
                                                                    	service path index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: vs_index
                                                                    
                                                                    	vservice index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                        self.yang_name = "serv-func"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.meta_name = YLeaf(YType.str, "meta-name")

                                                                        self.path_id = YLeaf(YType.uint32, "path-id")

                                                                        self.service_index = YLeaf(YType.uint8, "service-index")

                                                                        self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                        self._segment_path = lambda: "serv-func"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                class SetTimer(Entity):
                                                                    """
                                                                    set timer
                                                                    
                                                                    .. attribute:: absolute_time
                                                                    
                                                                    	absolute time
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: duration
                                                                    
                                                                    	duration
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                        self.yang_name = "set-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                        self.duration = YLeaf(YType.uint32, "duration")

                                                                        self.timer_name = YLeaf(YType.str, "timer-name")
                                                                        self._segment_path = lambda: "set-timer"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                class Sfrag(Entity):
                                                                    """
                                                                    sfrag
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Service Fragment Name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                        self.yang_name = "sfrag"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.name = YLeaf(YType.str, "name")
                                                                        self._segment_path = lambda: "sfrag"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                class Shape(Entity):
                                                                    """
                                                                    shape
                                                                    
                                                                    .. attribute:: be
                                                                    
                                                                    	be
                                                                    	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                        self.yang_name = "shape"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                        self._child_list_classes = {}

                                                                        self.be = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                        self.be.parent = self
                                                                        self._children_name_map["be"] = "be"
                                                                        self._children_yang_names.add("be")

                                                                        self.bw = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._children_yang_names.add("bw")
                                                                        self._segment_path = lambda: "shape"


                                                                    class Be(Entity):
                                                                        """
                                                                        be
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                            self.yang_name = "be"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "be"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bw"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                class StopTimer(Entity):
                                                                    """
                                                                    stop timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                        self.yang_name = "stop-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.timer_name = YLeaf(YType.str, "timer-name")
                                                                        self._segment_path = lambda: "stop-timer"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                class TimeoutIdle(Entity):
                                                                    """
                                                                    timeout idle
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                        self.yang_name = "timeout-idle"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.secs = YLeaf(YType.uint32, "secs")
                                                                        self._segment_path = lambda: "timeout-idle"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                class Wred(Entity):
                                                                    """
                                                                    wred
                                                                    
                                                                    .. attribute:: action_wred_info
                                                                    
                                                                    	action wred info
                                                                    	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                        self.yang_name = "wred"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                        self.action_wred_info = YList(self)
                                                                        self._segment_path = lambda: "wred"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                    class ActionWredInfo(Entity):
                                                                        """
                                                                        action wred info
                                                                        
                                                                        .. attribute:: match_ranges
                                                                        
                                                                        	match ranges
                                                                        	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                        
                                                                        .. attribute:: max_threshold
                                                                        
                                                                        	max threshold
                                                                        	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                        
                                                                        .. attribute:: min_threshold
                                                                        
                                                                        	min threshold
                                                                        	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                        
                                                                        .. attribute:: probability
                                                                        
                                                                        	probability
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	cos/prec/dscp/ based WRED
                                                                        	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                        
                                                                        .. attribute:: wred_flags
                                                                        
                                                                        	wred flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                            self.yang_name = "action-wred-info"
                                                                            self.yang_parent_name = "wred"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.probability = YLeaf(YType.uint32, "probability")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                            self.match_ranges = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                            self.match_ranges.parent = self
                                                                            self._children_name_map["match_ranges"] = "match-ranges"
                                                                            self._children_yang_names.add("match-ranges")

                                                                            self.max_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                            self.max_threshold.parent = self
                                                                            self._children_name_map["max_threshold"] = "max-threshold"
                                                                            self._children_yang_names.add("max-threshold")

                                                                            self.min_threshold = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                            self.min_threshold.parent = self
                                                                            self._children_name_map["min_threshold"] = "min-threshold"
                                                                            self._children_yang_names.add("min-threshold")
                                                                            self._segment_path = lambda: "action-wred-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                        class MatchRanges(Entity):
                                                                            """
                                                                            match ranges
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                self.yang_name = "match-ranges"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-ranges"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-ranges"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class MaxThreshold(Entity):
                                                                            """
                                                                            max threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                self.yang_name = "max-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "max-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                        class MinThreshold(Entity):
                                                                            """
                                                                            min threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                self.yang_name = "min-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "min-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                    class ClEncode(Entity):
                                                        """
                                                        cl encode
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: enc
                                                        
                                                        	enc
                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                        
                                                        .. attribute:: hd
                                                        
                                                        	hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: idx
                                                        
                                                        	idx
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: inline_cmap
                                                        
                                                        	inline cmap
                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                            self.yang_name = "cl-encode"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                            self._child_list_classes = {}

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                            self.inline_cmap = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                            self.inline_cmap.parent = self
                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                            self._children_yang_names.add("inline-cmap")
                                                            self._segment_path = lambda: "cl-encode"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                        class InlineCmap(Entity):
                                                            """
                                                            inline cmap
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	Inline Class\-Map flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_count
                                                            
                                                            	Number of Match infos
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Inline Class\-Map Mode Match any/all
                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                self.yang_name = "inline-cmap"
                                                                self.yang_parent_name = "cl-encode"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                self._child_list_classes = {}

                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._children_yang_names.add("match-infop")
                                                                self._segment_path = lambda: "inline-cmap"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "inline-cmap"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._children_yang_names.add("match-data")
                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                            self._child_list_classes = {}

                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                            self._children_yang_names.add("access-interface")

                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                            self._children_yang_names.add("atm-clp")

                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                            self._children_yang_names.add("auth-domain")

                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                            self._children_yang_names.add("auth-username")

                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                            self._children_yang_names.add("auth-username-regex")

                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                            self._children_yang_names.add("avail-id")

                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                            self._children_yang_names.add("circuit-id")

                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"
                                                                            self._children_yang_names.add("cos")

                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                            self._children_yang_names.add("cos-inr")

                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"
                                                                            self._children_yang_names.add("dei")

                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                            self._children_yang_names.add("dei-inr")

                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                            self._children_yang_names.add("discard-class")

                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"
                                                                            self._children_yang_names.add("dnis")

                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                            self._children_yang_names.add("dnis-regex")

                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"
                                                                            self._children_yang_names.add("domain")

                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                            self._children_yang_names.add("domain-regex")

                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"
                                                                            self._children_yang_names.add("dscp")

                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                            self._children_yang_names.add("dst-mac")

                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._children_yang_names.add("dst-port")

                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                            self._children_yang_names.add("ether-service-acl")

                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                            self._children_yang_names.add("ethertype")

                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                            self._children_yang_names.add("flow-key-data")

                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                            self._children_yang_names.add("flow-tag")

                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                            self._children_yang_names.add("fr-de")

                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                            self._children_yang_names.add("fr-dlci")

                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                            self._children_yang_names.add("icmp-v4")

                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                            self._children_yang_names.add("icmp-v6")

                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                            self._children_yang_names.add("icmpv4-code")

                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                            self._children_yang_names.add("icmpv4-type")

                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                            self._children_yang_names.add("icmpv6-code")

                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                            self._children_yang_names.add("icmpv6-type")

                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                            self._children_yang_names.add("input-interface")

                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                            self._children_yang_names.add("input-intfhdl")

                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                            self._children_yang_names.add("ipv4-acl")

                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                            self._children_yang_names.add("ipv4-prec")

                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                            self._children_yang_names.add("ipv6-acl")

                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                            self._children_yang_names.add("ipv6-prec")

                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"
                                                                            self._children_yang_names.add("media-type")

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                            self._children_yang_names.add("mpls-exp")

                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                            self._children_yang_names.add("mpls-top-label")

                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                            self._children_yang_names.add("nas-port")

                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                            self._children_yang_names.add("packet-len")

                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"
                                                                            self._children_yang_names.add("prec")

                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"
                                                                            self._children_yang_names.add("proto")

                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                            self._children_yang_names.add("qos-group")

                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                            self._children_yang_names.add("remote-id")

                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                            self._children_yang_names.add("remote-id-regex")

                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"
                                                                            self._children_yang_names.add("service-name")

                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                            self._children_yang_names.add("service-name-regex")

                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                            self._children_yang_names.add("src-addr-mac")

                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                            self._children_yang_names.add("src-mac")

                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"
                                                                            self._children_yang_names.add("src-port")

                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                            self._children_yang_names.add("subs-protocol")

                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                            self._children_yang_names.add("tcp-flag")

                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"
                                                                            self._children_yang_names.add("timer")

                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                            self._children_yang_names.add("timer-regexp")

                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                            self._children_yang_names.add("traffic-class")

                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                            self._children_yang_names.add("tunnel-name")

                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                            self._children_yang_names.add("unauth-domain")

                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                            self._children_yang_names.add("unauth-username")

                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"
                                                                            self._children_yang_names.add("user-name")

                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                            self._children_yang_names.add("user-name-regex")

                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                            self._children_yang_names.add("vendor-id")

                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"
                                                                            self._children_yang_names.add("vlan")

                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                            self._children_yang_names.add("vlan-inr")
                                                                            self._segment_path = lambda: "match-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "access-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "atm-clp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "avail-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "discard-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "dst-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                self._child_list_classes = {}

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._children_yang_names.add("flow-keys")
                                                                                self._segment_path = lambda: "flow-key-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "fr-de"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "input-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "media-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "src-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "subs-protocol"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "tcp-flag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer-regexp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                    class ClmpP(Entity):
                                                        """
                                                        clmp p
                                                        
                                                        .. attribute:: class_map_bg
                                                        
                                                        	class map bg
                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                            self.yang_name = "clmp-p"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                            self.class_map_bg = YList(self)
                                                            self._segment_path = lambda: "clmp-p"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                        class ClassMapBg(Entity):
                                                            """
                                                            class map bg
                                                            
                                                            .. attribute:: description
                                                            
                                                            	description
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Class\-Map Mode Match any/Match all
                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: name
                                                            
                                                            	Name of the class\-map
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: type
                                                            
                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                self.yang_name = "class-map-bg"
                                                                self.yang_parent_name = "clmp-p"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                self._child_list_classes = {}

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                self.match_infop = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._children_yang_names.add("match-infop")
                                                                self._segment_path = lambda: "class-map-bg"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "class-map-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._children_yang_names.add("match-data")
                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                            self._child_list_classes = {}

                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.access_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                            self._children_yang_names.add("access-interface")

                                                                            self.atm_clp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                            self._children_yang_names.add("atm-clp")

                                                                            self.auth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                            self._children_yang_names.add("auth-domain")

                                                                            self.auth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                            self.auth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                            self._children_yang_names.add("auth-username")

                                                                            self.auth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                            self._children_yang_names.add("auth-username-regex")

                                                                            self.avail_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                            self._children_yang_names.add("avail-id")

                                                                            self.circuit_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                            self._children_yang_names.add("circuit-id")

                                                                            self.circuit_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                            self.cos = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"
                                                                            self._children_yang_names.add("cos")

                                                                            self.cos_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                            self._children_yang_names.add("cos-inr")

                                                                            self.dei = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"
                                                                            self._children_yang_names.add("dei")

                                                                            self.dei_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                            self._children_yang_names.add("dei-inr")

                                                                            self.dhcp_client_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                            self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                            self.discard_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                            self._children_yang_names.add("discard-class")

                                                                            self.dnis = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"
                                                                            self._children_yang_names.add("dnis")

                                                                            self.dnis_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                            self._children_yang_names.add("dnis-regex")

                                                                            self.domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"
                                                                            self._children_yang_names.add("domain")

                                                                            self.domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                            self._children_yang_names.add("domain-regex")

                                                                            self.dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"
                                                                            self._children_yang_names.add("dscp")

                                                                            self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                            self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                            self.dst_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                            self._children_yang_names.add("dst-mac")

                                                                            self.dst_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._children_yang_names.add("dst-port")

                                                                            self.ether_service_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                            self._children_yang_names.add("ether-service-acl")

                                                                            self.ethertype = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                            self._children_yang_names.add("ethertype")

                                                                            self.flow_key_data = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                            self._children_yang_names.add("flow-key-data")

                                                                            self.flow_tag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                            self._children_yang_names.add("flow-tag")

                                                                            self.fr_de = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                            self._children_yang_names.add("fr-de")

                                                                            self.fr_dlci = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                            self._children_yang_names.add("fr-dlci")

                                                                            self.icmp_v4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                            self._children_yang_names.add("icmp-v4")

                                                                            self.icmp_v6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                            self._children_yang_names.add("icmp-v6")

                                                                            self.icmpv4_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                            self._children_yang_names.add("icmpv4-code")

                                                                            self.icmpv4_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                            self._children_yang_names.add("icmpv4-type")

                                                                            self.icmpv6_code = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                            self._children_yang_names.add("icmpv6-code")

                                                                            self.icmpv6_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                            self._children_yang_names.add("icmpv6-type")

                                                                            self.input_interface = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                            self._children_yang_names.add("input-interface")

                                                                            self.input_intfhdl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                            self._children_yang_names.add("input-intfhdl")

                                                                            self.ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                            self._children_yang_names.add("ipv4-acl")

                                                                            self.ipv4_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                            self.ipv4_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                            self.ipv4_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                            self._children_yang_names.add("ipv4-prec")

                                                                            self.ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                            self._children_yang_names.add("ipv6-acl")

                                                                            self.ipv6_dscp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                            self.ipv6_packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                            self.ipv6_prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                            self._children_yang_names.add("ipv6-prec")

                                                                            self.media_type = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"
                                                                            self._children_yang_names.add("media-type")

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                            self.mpls_exp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                            self._children_yang_names.add("mpls-exp")

                                                                            self.mpls_exp_imp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                            self.mpls_top_label = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                            self._children_yang_names.add("mpls-top-label")

                                                                            self.nas_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                            self._children_yang_names.add("nas-port")

                                                                            self.packet_len = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                            self._children_yang_names.add("packet-len")

                                                                            self.prec = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"
                                                                            self._children_yang_names.add("prec")

                                                                            self.proto = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"
                                                                            self._children_yang_names.add("proto")

                                                                            self.qos_group = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                            self._children_yang_names.add("qos-group")

                                                                            self.remote_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                            self._children_yang_names.add("remote-id")

                                                                            self.remote_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                            self._children_yang_names.add("remote-id-regex")

                                                                            self.service_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"
                                                                            self._children_yang_names.add("service-name")

                                                                            self.service_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                            self._children_yang_names.add("service-name-regex")

                                                                            self.src_addr_ipv4 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                            self.src_addr_ipv6 = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                            self.src_addr_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                            self._children_yang_names.add("src-addr-mac")

                                                                            self.src_mac = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                            self._children_yang_names.add("src-mac")

                                                                            self.src_port = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"
                                                                            self._children_yang_names.add("src-port")

                                                                            self.subs_protocol = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                            self._children_yang_names.add("subs-protocol")

                                                                            self.tcp_flag = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                            self._children_yang_names.add("tcp-flag")

                                                                            self.timer = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"
                                                                            self._children_yang_names.add("timer")

                                                                            self.timer_regexp = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                            self._children_yang_names.add("timer-regexp")

                                                                            self.traffic_class = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                            self._children_yang_names.add("traffic-class")

                                                                            self.tunnel_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                            self._children_yang_names.add("tunnel-name")

                                                                            self.tunnel_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                            self.unauth_domain = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                            self._children_yang_names.add("unauth-domain")

                                                                            self.unauth_domain_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                            self.unauth_username = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                            self._children_yang_names.add("unauth-username")

                                                                            self.unauth_username_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                            self.user_name = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"
                                                                            self._children_yang_names.add("user-name")

                                                                            self.user_name_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                            self._children_yang_names.add("user-name-regex")

                                                                            self.vendor_id = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                            self._children_yang_names.add("vendor-id")

                                                                            self.vendor_id_regex = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                            self.vlan = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"
                                                                            self._children_yang_names.add("vlan")

                                                                            self.vlan_inr = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                            self._children_yang_names.add("vlan-inr")
                                                                            self._segment_path = lambda: "match-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "access-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "atm-clp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "avail-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "discard-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "dst-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                self._child_list_classes = {}

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                self.flow_keys = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._children_yang_names.add("flow-keys")
                                                                                self._segment_path = lambda: "flow-key-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "fr-de"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "input-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "media-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "src-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "subs-protocol"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "tcp-flag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer-regexp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                    class PmapVarList(Entity):
                                        """
                                        pmap var list
                                        
                                        .. attribute:: offset
                                        
                                        	offset
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: pmap_var_list_arr
                                        
                                        	pmap var list arr
                                        	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, self).__init__()

                                            self.yang_name = "pmap-var-list"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                            self.offset = YLeafList(YType.uint8, "offset")

                                            self.pmap_var_list_arr = YList(self)
                                            self._segment_path = lambda: "pmap-var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                        class PmapVarListArr(Entity):
                                            """
                                            pmap var list arr
                                            
                                            .. attribute:: id
                                            
                                            	id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\:  str
                                            
                                            	**length:** 0..32
                                            
                                            .. attribute:: val
                                            
                                            	val
                                            	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                self.yang_name = "pmap-var-list-arr"
                                                self.yang_parent_name = "pmap-var-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                self._child_list_classes = {}

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                                self.val = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                self.val.parent = self
                                                self._children_name_map["val"] = "val"
                                                self._children_yang_names.add("val")
                                                self._segment_path = lambda: "pmap-var-list-arr"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                            class Val(Entity):
                                                """
                                                val
                                                
                                                .. attribute:: class_name
                                                
                                                	class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: dscp_val
                                                
                                                	dscp val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: param_uint32_val
                                                
                                                	param uint32 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: prec_val
                                                
                                                	prec val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                
                                                .. attribute:: uint16_val
                                                
                                                	uint16 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: uint32_val
                                                
                                                	uint32 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: uint8_val
                                                
                                                	uint8 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                    self.yang_name = "val"
                                                    self.yang_parent_name = "pmap-var-list-arr"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                    self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                    self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                    self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                    self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                    self._segment_path = lambda: "val"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


            class TransientPolicyMapTypes(Entity):
                """
                Application type of transient policy\-map list
                
                .. attribute:: transient_policy_map_type
                
                	Transient policy\-map type
                	**type**\: list of    :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes, self).__init__()

                    self.yang_name = "transient-policy-map-types"
                    self.yang_parent_name = "policy-map"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"transient-policy-map-type" : ("transient_policy_map_type", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType)}

                    self.transient_policy_map_type = YList(self)
                    self._segment_path = lambda: "transient-policy-map-types"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes, [], name, value)


                class TransientPolicyMapType(Entity):
                    """
                    Transient policy\-map type
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: transient_list_unuseds
                    
                    	Transient policy\-map list unused table
                    	**type**\:   :py:class:`TransientListUnuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, self).__init__()

                        self.yang_name = "transient-policy-map-type"
                        self.yang_parent_name = "transient-policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {"transient-list-unuseds" : ("transient_list_unuseds", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.transient_list_unuseds = PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds()
                        self.transient_list_unuseds.parent = self
                        self._children_name_map["transient_list_unuseds"] = "transient-list-unuseds"
                        self._children_yang_names.add("transient-list-unuseds")
                        self._segment_path = lambda: "transient-policy-map-type" + "[type='" + self.type.get() + "']"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map/transient-policy-map-types/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, ['type'], name, value)


                    class TransientListUnuseds(Entity):
                        """
                        Transient policy\-map list unused table
                        
                        .. attribute:: transient_list_unused
                        
                        	Policy\-map list unused
                        	**type**\: list of    :py:class:`TransientListUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, self).__init__()

                            self.yang_name = "transient-list-unuseds"
                            self.yang_parent_name = "transient-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"transient-list-unused" : ("transient_list_unused", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused)}

                            self.transient_list_unused = YList(self)
                            self._segment_path = lambda: "transient-list-unuseds"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, [], name, value)


                        class TransientListUnused(Entity):
                            """
                            Policy\-map list unused
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: class_map_reference
                            
                            	Each Classmapdetails
                            	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference>`
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: objects
                            
                            	Each object details
                            	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects>`
                            
                            .. attribute:: reference
                            
                            	Each Policymap details
                            	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference>`
                            
                            .. attribute:: total_objects
                            
                            	Total number of objects configured for a specific object type
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: transient
                            
                            	Transient object
                            	**type**\:  bool
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, self).__init__()

                                self.yang_name = "transient-list-unused"
                                self.yang_parent_name = "transient-list-unuseds"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects), "reference" : ("reference", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference)}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.total_objects = YLeaf(YType.uint32, "total-objects")

                                self.transient = YLeaf(YType.boolean, "transient")

                                self.class_map_reference = YList(self)
                                self.objects = YList(self)
                                self.reference = YList(self)
                                self._segment_path = lambda: "transient-list-unused" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                            class ClassMapReference(Entity):
                                """
                                Each Classmapdetails
                                
                                .. attribute:: policy_map_reference
                                
                                	List of Policymaps referencing a Classmap
                                	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference>`
                                
                                .. attribute:: total_reference_objects
                                
                                	Total number of Policymaps referencing a Classmap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, self).__init__()

                                    self.yang_name = "class-map-reference"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference)}

                                    self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                    self.policy_map_reference = YList(self)
                                    self._segment_path = lambda: "class-map-reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, ['total_reference_objects'], name, value)


                                class PolicyMapReference(Entity):
                                    """
                                    List of Policymaps referencing a Classmap
                                    
                                    .. attribute:: object_type
                                    
                                    	Application type configured
                                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                    
                                    .. attribute:: policy_map_name
                                    
                                    	Name of Policymap referencing a Classmap
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, self).__init__()

                                        self.yang_name = "policy-map-reference"
                                        self.yang_parent_name = "class-map-reference"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_type = YLeaf(YType.enumeration, "object-type")

                                        self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                        self._segment_path = lambda: "policy-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                            class Objects(Entity):
                                """
                                Each object details
                                
                                .. attribute:: object_name
                                
                                	Name of object (Policymap/Classmap)
                                	**type**\:  str
                                
                                	**length:** 0..64
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, self).__init__()

                                    self.yang_name = "objects"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.object_name = YLeaf(YType.str, "object-name")
                                    self._segment_path = lambda: "objects"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, ['object_name'], name, value)


                            class Reference(Entity):
                                """
                                Each Policymap details
                                
                                .. attribute:: total_class_maps
                                
                                	Total number of Classmaps in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_flows
                                
                                	Total flows in a Policymap
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: total_internal_reference_objects
                                
                                	Total number of internal reference objects
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, self).__init__()

                                    self.yang_name = "reference"
                                    self.yang_parent_name = "transient-list-unused"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {}

                                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                    self.total_flows = YLeaf(YType.uint32, "total-flows")

                                    self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                    self._segment_path = lambda: "reference"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


        class PolicyMapAppliedTypes(Entity):
            """
            List of Applied policymap details
            
            .. attribute:: policy_map_applied_type
            
            	Policymgr application type
            	**type**\: list of    :py:class:`PolicyMapAppliedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.PolicyMapAppliedTypes, self).__init__()

                self.yang_name = "policy-map-applied-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {}
                self._child_list_classes = {"policy-map-applied-type" : ("policy_map_applied_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType)}

                self.policy_map_applied_type = YList(self)
                self._segment_path = lambda: "policy-map-applied-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes, [], name, value)


            class PolicyMapAppliedType(Entity):
                """
                Policymgr application type
                
                .. attribute:: type  <key>
                
                	The application type
                	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: if_names
                
                	Interface table
                	**type**\:   :py:class:`IfNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType, self).__init__()

                    self.yang_name = "policy-map-applied-type"
                    self.yang_parent_name = "policy-map-applied-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {"if-names" : ("if_names", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames)}
                    self._child_list_classes = {}

                    self.type = YLeaf(YType.enumeration, "type")

                    self.if_names = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames()
                    self.if_names.parent = self
                    self._children_name_map["if_names"] = "if-names"
                    self._children_yang_names.add("if-names")
                    self._segment_path = lambda: "policy-map-applied-type" + "[type='" + self.type.get() + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/policy-map-applied-types/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType, ['type'], name, value)


                class IfNames(Entity):
                    """
                    Interface table
                    
                    .. attribute:: if_name
                    
                    	WORD interface name
                    	**type**\: list of    :py:class:`IfName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames, self).__init__()

                        self.yang_name = "if-names"
                        self.yang_parent_name = "policy-map-applied-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"if-name" : ("if_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName)}

                        self.if_name = YList(self)
                        self._segment_path = lambda: "if-names"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames, [], name, value)


                    class IfName(Entity):
                        """
                        WORD interface name
                        
                        .. attribute:: interface_name  <key>
                        
                        	Name of the interface
                        	**type**\:  str
                        
                        	**pattern:** [a\-zA\-Z0\-9./\-]+
                        
                        .. attribute:: input
                        
                        	Input direction table
                        	**type**\:   :py:class:`Input <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input>`
                        
                        .. attribute:: output
                        
                        	Output direction table
                        	**type**\:   :py:class:`Output <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName, self).__init__()

                            self.yang_name = "if-name"
                            self.yang_parent_name = "if-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"input" : ("input", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input), "output" : ("output", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output)}
                            self._child_list_classes = {}

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.input = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input()
                            self.input.parent = self
                            self._children_name_map["input"] = "input"
                            self._children_yang_names.add("input")

                            self.output = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output()
                            self.output.parent = self
                            self._children_name_map["output"] = "output"
                            self._children_yang_names.add("output")
                            self._segment_path = lambda: "if-name" + "[interface-name='" + self.interface_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName, ['interface_name'], name, value)


                        class Input(Entity):
                            """
                            Input direction table
                            
                            .. attribute:: detail
                            
                            	WORD interface name
                            	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input, self).__init__()

                                self.yang_name = "input"
                                self.yang_parent_name = "if-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {"detail" : ("detail", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail)}
                                self._child_list_classes = {}

                                self.detail = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._children_yang_names.add("detail")
                                self._segment_path = lambda: "input"


                            class Detail(Entity):
                                """
                                WORD interface name
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of    :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList>`
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of    :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\:  list of str
                                
                                	**length:** 0..65
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList), "pmaps" : ("pmaps", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps)}

                                    self.parent_pmap_name = YLeaf(YType.str, "parent-pmap-name")

                                    self.pmap_type = YLeaf(YType.enumeration, "pmap-type")

                                    self.subscriber_grp = YLeafList(YType.str, "subscriber-grp")

                                    self.pmap_var_list = YList(self)
                                    self.pmaps = YList(self)
                                    self._segment_path = lambda: "detail"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of    :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"var-list" : ("var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList)}

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                            self._segment_path = lambda: "var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.PmapVarList.VarList, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg)}

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Input.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                        class Output(Entity):
                            """
                            Output direction table
                            
                            .. attribute:: detail
                            
                            	WORD interface name
                            	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output, self).__init__()

                                self.yang_name = "output"
                                self.yang_parent_name = "if-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {"detail" : ("detail", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail)}
                                self._child_list_classes = {}

                                self.detail = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._children_yang_names.add("detail")
                                self._segment_path = lambda: "output"


                            class Detail(Entity):
                                """
                                WORD interface name
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of    :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList>`
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of    :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\:  list of str
                                
                                	**length:** 0..65
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList), "pmaps" : ("pmaps", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps)}

                                    self.parent_pmap_name = YLeaf(YType.str, "parent-pmap-name")

                                    self.pmap_type = YLeaf(YType.enumeration, "pmap-type")

                                    self.subscriber_grp = YLeafList(YType.str, "subscriber-grp")

                                    self.pmap_var_list = YList(self)
                                    self.pmaps = YList(self)
                                    self._segment_path = lambda: "detail"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of    :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"var-list" : ("var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList)}

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                            self._segment_path = lambda: "var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.PmapVarList.VarList, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg)}

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.PolicyMapAppliedTypes.PolicyMapAppliedType.IfNames.IfName.Output.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


        class Summary(Entity):
            """
            Summary of policy\-maps and class\-maps configured
            
            .. attribute:: class_maps
            
            	Summary of Classmap database
            	**type**\: list of    :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.ClassMaps>`
            
            .. attribute:: policy_maps
            
            	Summary of Policymap database
            	**type**\: list of    :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.PolicyMaps>`
            
            .. attribute:: total_class_map_types
            
            	Total number of Classmap types configured
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_class_maps
            
            	Total number of Classmaps configured
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_policy_map_types
            
            	Total number of Policymap types configured
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            .. attribute:: total_policy_maps
            
            	Total number of Policymaps configured
            	**type**\:  int
            
            	**range:** 0..4294967295
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.Summary, self).__init__()

                self.yang_name = "summary"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {}
                self._child_list_classes = {"class-maps" : ("class_maps", PolicyManager.Global_.Summary.ClassMaps), "policy-maps" : ("policy_maps", PolicyManager.Global_.Summary.PolicyMaps)}

                self.total_class_map_types = YLeaf(YType.uint32, "total-class-map-types")

                self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                self.total_policy_map_types = YLeaf(YType.uint32, "total-policy-map-types")

                self.total_policy_maps = YLeaf(YType.uint32, "total-policy-maps")

                self.class_maps = YList(self)
                self.policy_maps = YList(self)
                self._segment_path = lambda: "summary"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global_.Summary, ['total_class_map_types', 'total_class_maps', 'total_policy_map_types', 'total_policy_maps'], name, value)


            class ClassMaps(Entity):
                """
                Summary of Classmap database
                
                .. attribute:: class_map_reference
                
                	Each Classmapdetails
                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.ClassMaps.ClassMapReference>`
                
                .. attribute:: object_type
                
                	Application type configured
                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                
                .. attribute:: objects
                
                	Each object details
                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.ClassMaps.Objects>`
                
                .. attribute:: reference
                
                	Each Policymap details
                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.ClassMaps.Reference>`
                
                .. attribute:: total_objects
                
                	Total number of objects configured for a specific object type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transient
                
                	Transient object
                	**type**\:  bool
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.Summary.ClassMaps, self).__init__()

                    self.yang_name = "class-maps"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.Summary.ClassMaps.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.Summary.ClassMaps.Objects), "reference" : ("reference", PolicyManager.Global_.Summary.ClassMaps.Reference)}

                    self.object_type = YLeaf(YType.enumeration, "object-type")

                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                    self.transient = YLeaf(YType.boolean, "transient")

                    self.class_map_reference = YList(self)
                    self.objects = YList(self)
                    self.reference = YList(self)
                    self._segment_path = lambda: "class-maps"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.Summary.ClassMaps, ['object_type', 'total_objects', 'transient'], name, value)


                class ClassMapReference(Entity):
                    """
                    Each Classmapdetails
                    
                    .. attribute:: policy_map_reference
                    
                    	List of Policymaps referencing a Classmap
                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.ClassMaps.ClassMapReference.PolicyMapReference>`
                    
                    .. attribute:: total_reference_objects
                    
                    	Total number of Policymaps referencing a Classmap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.ClassMaps.ClassMapReference, self).__init__()

                        self.yang_name = "class-map-reference"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.Summary.ClassMaps.ClassMapReference.PolicyMapReference)}

                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                        self.policy_map_reference = YList(self)
                        self._segment_path = lambda: "class-map-reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.ClassMaps.ClassMapReference, ['total_reference_objects'], name, value)


                    class PolicyMapReference(Entity):
                        """
                        List of Policymaps referencing a Classmap
                        
                        .. attribute:: object_type
                        
                        	Application type configured
                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                        
                        .. attribute:: policy_map_name
                        
                        	Name of Policymap referencing a Classmap
                        	**type**\:  str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.Summary.ClassMaps.ClassMapReference.PolicyMapReference, self).__init__()

                            self.yang_name = "policy-map-reference"
                            self.yang_parent_name = "class-map-reference"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.object_type = YLeaf(YType.enumeration, "object-type")

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                            self._segment_path = lambda: "policy-map-reference"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/class-map-reference/%s" % self._segment_path()

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.Summary.ClassMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                class Objects(Entity):
                    """
                    Each object details
                    
                    .. attribute:: object_name
                    
                    	Name of object (Policymap/Classmap)
                    	**type**\:  str
                    
                    	**length:** 0..64
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.ClassMaps.Objects, self).__init__()

                        self.yang_name = "objects"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.object_name = YLeaf(YType.str, "object-name")
                        self._segment_path = lambda: "objects"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.ClassMaps.Objects, ['object_name'], name, value)


                class Reference(Entity):
                    """
                    Each Policymap details
                    
                    .. attribute:: total_class_maps
                    
                    	Total number of Classmaps in a Policymap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_flows
                    
                    	Total flows in a Policymap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_internal_reference_objects
                    
                    	Total number of internal reference objects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.ClassMaps.Reference, self).__init__()

                        self.yang_name = "reference"
                        self.yang_parent_name = "class-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                        self._segment_path = lambda: "reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/class-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.ClassMaps.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


            class PolicyMaps(Entity):
                """
                Summary of Policymap database
                
                .. attribute:: class_map_reference
                
                	Each Classmapdetails
                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference>`
                
                .. attribute:: object_type
                
                	Application type configured
                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                
                .. attribute:: objects
                
                	Each object details
                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.PolicyMaps.Objects>`
                
                .. attribute:: reference
                
                	Each Policymap details
                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.PolicyMaps.Reference>`
                
                .. attribute:: total_objects
                
                	Total number of objects configured for a specific object type
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: transient
                
                	Transient object
                	**type**\:  bool
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.Summary.PolicyMaps, self).__init__()

                    self.yang_name = "policy-maps"
                    self.yang_parent_name = "summary"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {}
                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference), "objects" : ("objects", PolicyManager.Global_.Summary.PolicyMaps.Objects), "reference" : ("reference", PolicyManager.Global_.Summary.PolicyMaps.Reference)}

                    self.object_type = YLeaf(YType.enumeration, "object-type")

                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                    self.transient = YLeaf(YType.boolean, "transient")

                    self.class_map_reference = YList(self)
                    self.objects = YList(self)
                    self.reference = YList(self)
                    self._segment_path = lambda: "policy-maps"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.Summary.PolicyMaps, ['object_type', 'total_objects', 'transient'], name, value)


                class ClassMapReference(Entity):
                    """
                    Each Classmapdetails
                    
                    .. attribute:: policy_map_reference
                    
                    	List of Policymaps referencing a Classmap
                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference.PolicyMapReference>`
                    
                    .. attribute:: total_reference_objects
                    
                    	Total number of Policymaps referencing a Classmap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference, self).__init__()

                        self.yang_name = "class-map-reference"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference.PolicyMapReference)}

                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                        self.policy_map_reference = YList(self)
                        self._segment_path = lambda: "class-map-reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference, ['total_reference_objects'], name, value)


                    class PolicyMapReference(Entity):
                        """
                        List of Policymaps referencing a Classmap
                        
                        .. attribute:: object_type
                        
                        	Application type configured
                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                        
                        .. attribute:: policy_map_name
                        
                        	Name of Policymap referencing a Classmap
                        	**type**\:  str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, self).__init__()

                            self.yang_name = "policy-map-reference"
                            self.yang_parent_name = "class-map-reference"
                            self.is_top_level_class = False
                            self.has_list_ancestor = False
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.object_type = YLeaf(YType.enumeration, "object-type")

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                            self._segment_path = lambda: "policy-map-reference"
                            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/class-map-reference/%s" % self._segment_path()

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                class Objects(Entity):
                    """
                    Each object details
                    
                    .. attribute:: object_name
                    
                    	Name of object (Policymap/Classmap)
                    	**type**\:  str
                    
                    	**length:** 0..64
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.PolicyMaps.Objects, self).__init__()

                        self.yang_name = "objects"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.object_name = YLeaf(YType.str, "object-name")
                        self._segment_path = lambda: "objects"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.PolicyMaps.Objects, ['object_name'], name, value)


                class Reference(Entity):
                    """
                    Each Policymap details
                    
                    .. attribute:: total_class_maps
                    
                    	Total number of Classmaps in a Policymap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_flows
                    
                    	Total flows in a Policymap
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_internal_reference_objects
                    
                    	Total number of internal reference objects
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.Summary.PolicyMaps.Reference, self).__init__()

                        self.yang_name = "reference"
                        self.yang_parent_name = "policy-maps"
                        self.is_top_level_class = False
                        self.has_list_ancestor = False
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                        self._segment_path = lambda: "reference"
                        self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/summary/policy-maps/%s" % self._segment_path()

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.Summary.PolicyMaps.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


        class TargetPolicyMapTypes(Entity):
            """
            Targets of a policymap
            
            .. attribute:: target_policy_map_type
            
            	Policymgr application type
            	**type**\: list of    :py:class:`TargetPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.TargetPolicyMapTypes, self).__init__()

                self.yang_name = "target-policy-map-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {}
                self._child_list_classes = {"target-policy-map-type" : ("target_policy_map_type", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType)}

                self.target_policy_map_type = YList(self)
                self._segment_path = lambda: "target-policy-map-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes, [], name, value)


            class TargetPolicyMapType(Entity):
                """
                Policymgr application type
                
                .. attribute:: type  <key>
                
                	The application type
                	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: policy_map_target_summary
                
                	Policy\-map table
                	**type**\:   :py:class:`PolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary>`
                
                .. attribute:: policy_map_targets
                
                	Policy\-map table
                	**type**\:   :py:class:`PolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets>`
                
                .. attribute:: target_summary_per_policy_maps
                
                	Policy\-map table per Policy\-map
                	**type**\:   :py:class:`TargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType, self).__init__()

                    self.yang_name = "target-policy-map-type"
                    self.yang_parent_name = "target-policy-map-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {"policy-map-target-summary" : ("policy_map_target_summary", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary), "policy-map-targets" : ("policy_map_targets", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets), "target-summary-per-policy-maps" : ("target_summary_per_policy_maps", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps)}
                    self._child_list_classes = {}

                    self.type = YLeaf(YType.enumeration, "type")

                    self.policy_map_target_summary = PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary()
                    self.policy_map_target_summary.parent = self
                    self._children_name_map["policy_map_target_summary"] = "policy-map-target-summary"
                    self._children_yang_names.add("policy-map-target-summary")

                    self.policy_map_targets = PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets()
                    self.policy_map_targets.parent = self
                    self._children_name_map["policy_map_targets"] = "policy-map-targets"
                    self._children_yang_names.add("policy-map-targets")

                    self.target_summary_per_policy_maps = PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps()
                    self.target_summary_per_policy_maps.parent = self
                    self._children_name_map["target_summary_per_policy_maps"] = "target-summary-per-policy-maps"
                    self._children_yang_names.add("target-summary-per-policy-maps")
                    self._segment_path = lambda: "target-policy-map-type" + "[type='" + self.type.get() + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/target-policy-map-types/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType, ['type'], name, value)


                class PolicyMapTargetSummary(Entity):
                    """
                    Policy\-map table
                    
                    .. attribute:: total_child_policy_maps_input_direction
                    
                    	Totalpolicymaps applied as child policy in the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_output_direction
                    
                    	Totalpolicymaps applied as child policy in the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_input_direction
                    
                    	Totalinterfaces with service\-policy in the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_output_direction
                    
                    	Totalinterfaces with service\-policy in the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_input_direction
                    
                    	Total policymapsin the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_output_direction
                    
                    	Total policymapsin the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, self).__init__()

                        self.yang_name = "policy-map-target-summary"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                        self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                        self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                        self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                        self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                        self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                        self._segment_path = lambda: "policy-map-target-summary"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, ['total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)


                class PolicyMapTargets(Entity):
                    """
                    Policy\-map table
                    
                    .. attribute:: policy_map_target
                    
                    	Policy\-map targets
                    	**type**\: list of    :py:class:`PolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, self).__init__()

                        self.yang_name = "policy-map-targets"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"policy-map-target" : ("policy_map_target", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget)}

                        self.policy_map_target = YList(self)
                        self._segment_path = lambda: "policy-map-targets"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, [], name, value)


                    class PolicyMapTarget(Entity):
                        """
                        Policy\-map targets
                        
                        .. attribute:: policy_map_name  <key>
                        
                        	Name of policy\-map
                        	**type**\:  str
                        
                        	**length:** 1..63
                        
                        .. attribute:: parent_targets
                        
                        	parent targets
                        	**type**\:  list of str
                        
                        .. attribute:: targets
                        
                        	targets
                        	**type**\:  list of str
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, self).__init__()

                            self.yang_name = "policy-map-target"
                            self.yang_parent_name = "policy-map-targets"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                            self.parent_targets = YLeafList(YType.str, "parent-targets")

                            self.targets = YLeafList(YType.str, "targets")
                            self._segment_path = lambda: "policy-map-target" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, ['policy_map_name', 'parent_targets', 'targets'], name, value)


                class TargetSummaryPerPolicyMaps(Entity):
                    """
                    Policy\-map table per Policy\-map
                    
                    .. attribute:: target_summary_per_policy_map
                    
                    	Policy\-map targets summary
                    	**type**\: list of    :py:class:`TargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, self).__init__()

                        self.yang_name = "target-summary-per-policy-maps"
                        self.yang_parent_name = "target-policy-map-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"target-summary-per-policy-map" : ("target_summary_per_policy_map", PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap)}

                        self.target_summary_per_policy_map = YList(self)
                        self._segment_path = lambda: "target-summary-per-policy-maps"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, [], name, value)


                    class TargetSummaryPerPolicyMap(Entity):
                        """
                        Policy\-map targets summary
                        
                        .. attribute:: policy_map_name  <key>
                        
                        	Name of policy\-map
                        	**type**\:  str
                        
                        	**length:** 1..63
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, self).__init__()

                            self.yang_name = "target-summary-per-policy-map"
                            self.yang_parent_name = "target-summary-per-policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                            self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                            self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                            self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                            self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                            self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                            self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                            self._segment_path = lambda: "target-summary-per-policy-map" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, ['policy_map_name', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)


        class TransientPolicyMapAppliedTypes(Entity):
            """
            Transient policy\-map applied type
            
            .. attribute:: transient_policy_map_applied_type
            
            	Transient policy\-map applied type
            	**type**\: list of    :py:class:`TransientPolicyMapAppliedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes, self).__init__()

                self.yang_name = "transient-policy-map-applied-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {}
                self._child_list_classes = {"transient-policy-map-applied-type" : ("transient_policy_map_applied_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType)}

                self.transient_policy_map_applied_type = YList(self)
                self._segment_path = lambda: "transient-policy-map-applied-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes, [], name, value)


            class TransientPolicyMapAppliedType(Entity):
                """
                Transient policy\-map applied type
                
                .. attribute:: type  <key>
                
                	The application type
                	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: transient_interface_names
                
                	Interface table
                	**type**\:   :py:class:`TransientInterfaceNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType, self).__init__()

                    self.yang_name = "transient-policy-map-applied-type"
                    self.yang_parent_name = "transient-policy-map-applied-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {"transient-interface-names" : ("transient_interface_names", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames)}
                    self._child_list_classes = {}

                    self.type = YLeaf(YType.enumeration, "type")

                    self.transient_interface_names = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames()
                    self.transient_interface_names.parent = self
                    self._children_name_map["transient_interface_names"] = "transient-interface-names"
                    self._children_yang_names.add("transient-interface-names")
                    self._segment_path = lambda: "transient-policy-map-applied-type" + "[type='" + self.type.get() + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/transient-policy-map-applied-types/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType, ['type'], name, value)


                class TransientInterfaceNames(Entity):
                    """
                    Interface table
                    
                    .. attribute:: transient_interface_name
                    
                    	WORD interface name
                    	**type**\: list of    :py:class:`TransientInterfaceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames, self).__init__()

                        self.yang_name = "transient-interface-names"
                        self.yang_parent_name = "transient-policy-map-applied-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"transient-interface-name" : ("transient_interface_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName)}

                        self.transient_interface_name = YList(self)
                        self._segment_path = lambda: "transient-interface-names"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames, [], name, value)


                    class TransientInterfaceName(Entity):
                        """
                        WORD interface name
                        
                        .. attribute:: interface_name  <key>
                        
                        	Name of the interface
                        	**type**\:  str
                        
                        	**pattern:** [a\-zA\-Z0\-9./\-]+
                        
                        .. attribute:: transient_input
                        
                        	Input direction table
                        	**type**\:   :py:class:`TransientInput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput>`
                        
                        .. attribute:: transient_output
                        
                        	Output direction table
                        	**type**\:   :py:class:`TransientOutput <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName, self).__init__()

                            self.yang_name = "transient-interface-name"
                            self.yang_parent_name = "transient-interface-names"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"transient-input" : ("transient_input", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput), "transient-output" : ("transient_output", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput)}
                            self._child_list_classes = {}

                            self.interface_name = YLeaf(YType.str, "interface-name")

                            self.transient_input = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput()
                            self.transient_input.parent = self
                            self._children_name_map["transient_input"] = "transient-input"
                            self._children_yang_names.add("transient-input")

                            self.transient_output = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput()
                            self.transient_output.parent = self
                            self._children_name_map["transient_output"] = "transient-output"
                            self._children_yang_names.add("transient-output")
                            self._segment_path = lambda: "transient-interface-name" + "[interface-name='" + self.interface_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName, ['interface_name'], name, value)


                        class TransientInput(Entity):
                            """
                            Input direction table
                            
                            .. attribute:: detail
                            
                            	Policy map
                            	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput, self).__init__()

                                self.yang_name = "transient-input"
                                self.yang_parent_name = "transient-interface-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {"detail" : ("detail", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail)}
                                self._child_list_classes = {}

                                self.detail = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._children_yang_names.add("detail")
                                self._segment_path = lambda: "transient-input"


                            class Detail(Entity):
                                """
                                Policy map
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of    :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList>`
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of    :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\:  list of str
                                
                                	**length:** 0..65
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "transient-input"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList), "pmaps" : ("pmaps", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps)}

                                    self.parent_pmap_name = YLeaf(YType.str, "parent-pmap-name")

                                    self.pmap_type = YLeaf(YType.enumeration, "pmap-type")

                                    self.subscriber_grp = YLeafList(YType.str, "subscriber-grp")

                                    self.pmap_var_list = YList(self)
                                    self.pmaps = YList(self)
                                    self._segment_path = lambda: "detail"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of    :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"var-list" : ("var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList)}

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                            self._segment_path = lambda: "var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.PmapVarList.VarList, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg)}

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientInput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                        class TransientOutput(Entity):
                            """
                            Output direction table
                            
                            .. attribute:: detail
                            
                            	Policy map
                            	**type**\:   :py:class:`Detail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput, self).__init__()

                                self.yang_name = "transient-output"
                                self.yang_parent_name = "transient-interface-name"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {"detail" : ("detail", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail)}
                                self._child_list_classes = {}

                                self.detail = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail()
                                self.detail.parent = self
                                self._children_name_map["detail"] = "detail"
                                self._children_yang_names.add("detail")
                                self._segment_path = lambda: "transient-output"


                            class Detail(Entity):
                                """
                                Policy map
                                
                                .. attribute:: parent_pmap_name
                                
                                	parent pmap name
                                	**type**\:  str
                                
                                	**length:** 0..65
                                
                                .. attribute:: pmap_type
                                
                                	pmap type
                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                
                                .. attribute:: pmap_var_list
                                
                                	pmap var list
                                	**type**\: list of    :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList>`
                                
                                .. attribute:: pmaps
                                
                                	pmaps
                                	**type**\: list of    :py:class:`Pmaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps>`
                                
                                .. attribute:: subscriber_grp
                                
                                	subscriber grp
                                	**type**\:  list of str
                                
                                	**length:** 0..65
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail, self).__init__()

                                    self.yang_name = "detail"
                                    self.yang_parent_name = "transient-output"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList), "pmaps" : ("pmaps", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps)}

                                    self.parent_pmap_name = YLeaf(YType.str, "parent-pmap-name")

                                    self.pmap_type = YLeaf(YType.enumeration, "pmap-type")

                                    self.subscriber_grp = YLeafList(YType.str, "subscriber-grp")

                                    self.pmap_var_list = YList(self)
                                    self.pmaps = YList(self)
                                    self._segment_path = lambda: "detail"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail, ['parent_pmap_name', 'pmap_type', 'subscriber_grp'], name, value)


                                class PmapVarList(Entity):
                                    """
                                    pmap var list
                                    
                                    .. attribute:: var_list
                                    
                                    	var list
                                    	**type**\: list of    :py:class:`VarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList, self).__init__()

                                        self.yang_name = "pmap-var-list"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"var-list" : ("var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList)}

                                        self.var_list = YList(self)
                                        self._segment_path = lambda: "pmap-var-list"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList, [], name, value)


                                    class VarList(Entity):
                                        """
                                        var list
                                        
                                        .. attribute:: class_name
                                        
                                        	class name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: dscp_val
                                        
                                        	dscp val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: param_uint32_val
                                        
                                        	param uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: prec_val
                                        
                                        	prec val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                        
                                        .. attribute:: uint16_val
                                        
                                        	uint16 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..65535
                                        
                                        .. attribute:: uint32_val
                                        
                                        	uint32 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..4294967295
                                        
                                        .. attribute:: uint8_val
                                        
                                        	uint8 val
                                        	**type**\:  int
                                        
                                        	**range:** 0..255
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList, self).__init__()

                                            self.yang_name = "var-list"
                                            self.yang_parent_name = "pmap-var-list"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.class_name = YLeaf(YType.str, "class-name")

                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                            self._segment_path = lambda: "var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.PmapVarList.VarList, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class Pmaps(Entity):
                                    """
                                    pmaps
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps, self).__init__()

                                        self.yang_name = "pmaps"
                                        self.yang_parent_name = "detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg)}

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "pmaps"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "pmaps"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapAppliedTypes.TransientPolicyMapAppliedType.TransientInterfaceNames.TransientInterfaceName.TransientOutput.Detail.Pmaps.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


        class TransientPolicyMapTargetsTypes(Entity):
            """
            Transient policy\-map target table
            
            .. attribute:: transient_policy_map_targets_type
            
            	Transient Policymgr application type
            	**type**\: list of    :py:class:`TransientPolicyMapTargetsType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Global_.TransientPolicyMapTargetsTypes, self).__init__()

                self.yang_name = "transient-policy-map-targets-types"
                self.yang_parent_name = "global"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {}
                self._child_list_classes = {"transient-policy-map-targets-type" : ("transient_policy_map_targets_type", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType)}

                self.transient_policy_map_targets_type = YList(self)
                self._segment_path = lambda: "transient-policy-map-targets-types"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes, [], name, value)


            class TransientPolicyMapTargetsType(Entity):
                """
                Transient Policymgr application type
                
                .. attribute:: type  <key>
                
                	The application type
                	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                
                .. attribute:: transient_policy_map_target_summary
                
                	Transient Policy\-map table
                	**type**\:   :py:class:`TransientPolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary>`
                
                .. attribute:: transient_policy_map_targets
                
                	Transient Policy\-map table
                	**type**\:   :py:class:`TransientPolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets>`
                
                .. attribute:: transient_target_summary_per_policy_maps
                
                	Transient Policy\-map table per Policy\-map
                	**type**\:   :py:class:`TransientTargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType, self).__init__()

                    self.yang_name = "transient-policy-map-targets-type"
                    self.yang_parent_name = "transient-policy-map-targets-types"
                    self.is_top_level_class = False
                    self.has_list_ancestor = False
                    self._child_container_classes = {"transient-policy-map-target-summary" : ("transient_policy_map_target_summary", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary), "transient-policy-map-targets" : ("transient_policy_map_targets", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets), "transient-target-summary-per-policy-maps" : ("transient_target_summary_per_policy_maps", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps)}
                    self._child_list_classes = {}

                    self.type = YLeaf(YType.enumeration, "type")

                    self.transient_policy_map_target_summary = PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary()
                    self.transient_policy_map_target_summary.parent = self
                    self._children_name_map["transient_policy_map_target_summary"] = "transient-policy-map-target-summary"
                    self._children_yang_names.add("transient-policy-map-target-summary")

                    self.transient_policy_map_targets = PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets()
                    self.transient_policy_map_targets.parent = self
                    self._children_name_map["transient_policy_map_targets"] = "transient-policy-map-targets"
                    self._children_yang_names.add("transient-policy-map-targets")

                    self.transient_target_summary_per_policy_maps = PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps()
                    self.transient_target_summary_per_policy_maps.parent = self
                    self._children_name_map["transient_target_summary_per_policy_maps"] = "transient-target-summary-per-policy-maps"
                    self._children_yang_names.add("transient-target-summary-per-policy-maps")
                    self._segment_path = lambda: "transient-policy-map-targets-type" + "[type='" + self.type.get() + "']"
                    self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/global/transient-policy-map-targets-types/%s" % self._segment_path()

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType, ['type'], name, value)


                class TransientPolicyMapTargetSummary(Entity):
                    """
                    Transient Policy\-map table
                    
                    .. attribute:: total_child_policy_maps_input_direction
                    
                    	Totalpolicymaps applied as child policy in the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_child_policy_maps_output_direction
                    
                    	Totalpolicymaps applied as child policy in the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_input_direction
                    
                    	Totalinterfaces with service\-policy in the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_interfaces_output_direction
                    
                    	Totalinterfaces with service\-policy in the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_input_direction
                    
                    	Total policymapsin the input direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: total_policy_maps_output_direction
                    
                    	Total policymapsin the output direction
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary, self).__init__()

                        self.yang_name = "transient-policy-map-target-summary"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {}

                        self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                        self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                        self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                        self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                        self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                        self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                        self._segment_path = lambda: "transient-policy-map-target-summary"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargetSummary, ['total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)


                class TransientPolicyMapTargets(Entity):
                    """
                    Transient Policy\-map table
                    
                    .. attribute:: transient_policy_map_target
                    
                    	Transient Policy\-map targets
                    	**type**\: list of    :py:class:`TransientPolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets, self).__init__()

                        self.yang_name = "transient-policy-map-targets"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"transient-policy-map-target" : ("transient_policy_map_target", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget)}

                        self.transient_policy_map_target = YList(self)
                        self._segment_path = lambda: "transient-policy-map-targets"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets, [], name, value)


                    class TransientPolicyMapTarget(Entity):
                        """
                        Transient Policy\-map targets
                        
                        .. attribute:: policy_map_name  <key>
                        
                        	Name of policy\-map
                        	**type**\:  str
                        
                        	**length:** 1..63
                        
                        .. attribute:: parent_targets
                        
                        	parent targets
                        	**type**\:  list of str
                        
                        .. attribute:: targets
                        
                        	targets
                        	**type**\:  list of str
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget, self).__init__()

                            self.yang_name = "transient-policy-map-target"
                            self.yang_parent_name = "transient-policy-map-targets"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                            self.parent_targets = YLeafList(YType.str, "parent-targets")

                            self.targets = YLeafList(YType.str, "targets")
                            self._segment_path = lambda: "transient-policy-map-target" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientPolicyMapTargets.TransientPolicyMapTarget, ['policy_map_name', 'parent_targets', 'targets'], name, value)


                class TransientTargetSummaryPerPolicyMaps(Entity):
                    """
                    Transient Policy\-map table per Policy\-map
                    
                    .. attribute:: transient_target_summary_per_policy_map
                    
                    	Policy\-map targets summary
                    	**type**\: list of    :py:class:`TransientTargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps, self).__init__()

                        self.yang_name = "transient-target-summary-per-policy-maps"
                        self.yang_parent_name = "transient-policy-map-targets-type"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"transient-target-summary-per-policy-map" : ("transient_target_summary_per_policy_map", PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap)}

                        self.transient_target_summary_per_policy_map = YList(self)
                        self._segment_path = lambda: "transient-target-summary-per-policy-maps"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps, [], name, value)


                    class TransientTargetSummaryPerPolicyMap(Entity):
                        """
                        Policy\-map targets summary
                        
                        .. attribute:: policy_map_name  <key>
                        
                        	Name of policy\-map
                        	**type**\:  str
                        
                        	**length:** 1..63
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap, self).__init__()

                            self.yang_name = "transient-target-summary-per-policy-map"
                            self.yang_parent_name = "transient-target-summary-per-policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                            self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                            self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                            self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                            self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                            self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                            self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                            self._segment_path = lambda: "transient-target-summary-per-policy-map" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Global_.TransientPolicyMapTargetsTypes.TransientPolicyMapTargetsType.TransientTargetSummaryPerPolicyMaps.TransientTargetSummaryPerPolicyMap, ['policy_map_name', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)


    class Nodes(Entity):
        """
        Node\-specific Policymgr operational data
        
        .. attribute:: node
        
        	Policymgr operational data for a particular node
        	**type**\: list of    :py:class:`Node <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node>`
        
        

        """

        _prefix = 'infra-policymgr-oper'
        _revision = '2017-05-27'

        def __init__(self):
            super(PolicyManager.Nodes, self).__init__()

            self.yang_name = "nodes"
            self.yang_parent_name = "policy-manager"
            self.is_top_level_class = False
            self.has_list_ancestor = False
            self._child_container_classes = {}
            self._child_list_classes = {"node" : ("node", PolicyManager.Nodes.Node)}

            self.node = YList(self)
            self._segment_path = lambda: "nodes"
            self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/%s" % self._segment_path()

        def __setattr__(self, name, value):
            self._perform_setattr(PolicyManager.Nodes, [], name, value)


        class Node(Entity):
            """
            Policymgr operational data for a particular
            node
            
            .. attribute:: node_name  <key>
            
            	Node name
            	**type**\:  str
            
            	**pattern:** ([a\-zA\-Z0\-9\_]\*\\d+/){1,2}([a\-zA\-Z0\-9\_]\*\\d+)
            
            .. attribute:: class_map
            
            	List of classmap details
            	**type**\:   :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap>`
            
            .. attribute:: policy_map
            
            	List of policymap details
            	**type**\:   :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap>`
            
            .. attribute:: summary
            
            	Summary of policy\-maps and class\-maps configured
            	**type**\:   :py:class:`Summary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary>`
            
            .. attribute:: target_policy_map_types
            
            	Targets of a policymap
            	**type**\:   :py:class:`TargetPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes>`
            
            

            """

            _prefix = 'infra-policymgr-oper'
            _revision = '2017-05-27'

            def __init__(self):
                super(PolicyManager.Nodes.Node, self).__init__()

                self.yang_name = "node"
                self.yang_parent_name = "nodes"
                self.is_top_level_class = False
                self.has_list_ancestor = False
                self._child_container_classes = {"class-map" : ("class_map", PolicyManager.Nodes.Node.ClassMap), "policy-map" : ("policy_map", PolicyManager.Nodes.Node.PolicyMap), "summary" : ("summary", PolicyManager.Nodes.Node.Summary), "target-policy-map-types" : ("target_policy_map_types", PolicyManager.Nodes.Node.TargetPolicyMapTypes)}
                self._child_list_classes = {}

                self.node_name = YLeaf(YType.str, "node-name")

                self.class_map = PolicyManager.Nodes.Node.ClassMap()
                self.class_map.parent = self
                self._children_name_map["class_map"] = "class-map"
                self._children_yang_names.add("class-map")

                self.policy_map = PolicyManager.Nodes.Node.PolicyMap()
                self.policy_map.parent = self
                self._children_name_map["policy_map"] = "policy-map"
                self._children_yang_names.add("policy-map")

                self.summary = PolicyManager.Nodes.Node.Summary()
                self.summary.parent = self
                self._children_name_map["summary"] = "summary"
                self._children_yang_names.add("summary")

                self.target_policy_map_types = PolicyManager.Nodes.Node.TargetPolicyMapTypes()
                self.target_policy_map_types.parent = self
                self._children_name_map["target_policy_map_types"] = "target-policy-map-types"
                self._children_yang_names.add("target-policy-map-types")
                self._segment_path = lambda: "node" + "[node-name='" + self.node_name.get() + "']"
                self._absolute_path = lambda: "Cisco-IOS-XR-infra-policymgr-oper:policy-manager/nodes/%s" % self._segment_path()

            def __setattr__(self, name, value):
                self._perform_setattr(PolicyManager.Nodes.Node, ['node_name'], name, value)


            class ClassMap(Entity):
                """
                List of classmap details
                
                .. attribute:: class_map_types
                
                	Application type of a classmap
                	**type**\:   :py:class:`ClassMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.ClassMap, self).__init__()

                    self.yang_name = "class-map"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self._child_container_classes = {"class-map-types" : ("class_map_types", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes)}
                    self._child_list_classes = {}

                    self.class_map_types = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes()
                    self.class_map_types.parent = self
                    self._children_name_map["class_map_types"] = "class-map-types"
                    self._children_yang_names.add("class-map-types")
                    self._segment_path = lambda: "class-map"


                class ClassMapTypes(Entity):
                    """
                    Application type of a classmap
                    
                    .. attribute:: class_map_type
                    
                    	Policymgr application type
                    	**type**\: list of    :py:class:`ClassMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes, self).__init__()

                        self.yang_name = "class-map-types"
                        self.yang_parent_name = "class-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"class-map-type" : ("class_map_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType)}

                        self.class_map_type = YList(self)
                        self._segment_path = lambda: "class-map-types"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes, [], name, value)


                    class ClassMapType(Entity):
                        """
                        Policymgr application type
                        
                        .. attribute:: type  <key>
                        
                        	The application type
                        	**type**\:   :py:class:`PolicymgrClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrClassMap>`
                        
                        .. attribute:: class_map_briefs
                        
                        	Class\-map brief table
                        	**type**\:   :py:class:`ClassMapBriefs <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs>`
                        
                        .. attribute:: class_map_details
                        
                        	Class\-map detail table
                        	**type**\:   :py:class:`ClassMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails>`
                        
                        .. attribute:: class_maps
                        
                        	Class\-map definition table
                        	**type**\:   :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType, self).__init__()

                            self.yang_name = "class-map-type"
                            self.yang_parent_name = "class-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"class-map-briefs" : ("class_map_briefs", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs), "class-map-details" : ("class_map_details", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails), "class-maps" : ("class_maps", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps)}
                            self._child_list_classes = {}

                            self.type = YLeaf(YType.enumeration, "type")

                            self.class_map_briefs = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs()
                            self.class_map_briefs.parent = self
                            self._children_name_map["class_map_briefs"] = "class-map-briefs"
                            self._children_yang_names.add("class-map-briefs")

                            self.class_map_details = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails()
                            self.class_map_details.parent = self
                            self._children_name_map["class_map_details"] = "class-map-details"
                            self._children_yang_names.add("class-map-details")

                            self.class_maps = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps()
                            self.class_maps.parent = self
                            self._children_name_map["class_maps"] = "class-maps"
                            self._children_yang_names.add("class-maps")
                            self._segment_path = lambda: "class-map-type" + "[type='" + self.type.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType, ['type'], name, value)


                        class ClassMapBriefs(Entity):
                            """
                            Class\-map brief table
                            
                            .. attribute:: class_map_brief
                            
                            	Class\-map brief information
                            	**type**\: list of    :py:class:`ClassMapBrief <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, self).__init__()

                                self.yang_name = "class-map-briefs"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-brief" : ("class_map_brief", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief)}

                                self.class_map_brief = YList(self)
                                self._segment_path = lambda: "class-map-briefs"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs, [], name, value)


                            class ClassMapBrief(Entity):
                                """
                                Class\-map brief information
                                
                                .. attribute:: class_map_name  <key>
                                
                                	Name of class\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference>`
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects>`
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, self).__init__()

                                    self.yang_name = "class-map-brief"
                                    self.yang_parent_name = "class-map-briefs"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference)}

                                    self.class_map_name = YLeaf(YType.str, "class-map-name")

                                    self.object_type = YLeaf(YType.enumeration, "object-type")

                                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                                    self.transient = YLeaf(YType.boolean, "transient")

                                    self.class_map_reference = YList(self)
                                    self.objects = YList(self)
                                    self.reference = YList(self)
                                    self._segment_path = lambda: "class-map-brief" + "[class-map-name='" + self.class_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference>`
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference)}

                                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\:  str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.object_type = YLeaf(YType.enumeration, "object-type")

                                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                            self._segment_path = lambda: "policy-map-reference"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_name = YLeaf(YType.str, "object-name")
                                        self._segment_path = lambda: "objects"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Objects, ['object_name'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "class-map-brief"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                        self._segment_path = lambda: "reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapBriefs.ClassMapBrief.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                        class ClassMapDetails(Entity):
                            """
                            Class\-map detail table
                            
                            .. attribute:: class_map_detail
                            
                            	Class\-map detail information
                            	**type**\: list of    :py:class:`ClassMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, self).__init__()

                                self.yang_name = "class-map-details"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map-detail" : ("class_map_detail", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail)}

                                self.class_map_detail = YList(self)
                                self._segment_path = lambda: "class-map-details"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails, [], name, value)


                            class ClassMapDetail(Entity):
                                """
                                Class\-map detail information
                                
                                .. attribute:: class_map_name  <key>
                                
                                	Name of class\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference>`
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects>`
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, self).__init__()

                                    self.yang_name = "class-map-detail"
                                    self.yang_parent_name = "class-map-details"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference)}

                                    self.class_map_name = YLeaf(YType.str, "class-map-name")

                                    self.object_type = YLeaf(YType.enumeration, "object-type")

                                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                                    self.transient = YLeaf(YType.boolean, "transient")

                                    self.class_map_reference = YList(self)
                                    self.objects = YList(self)
                                    self.reference = YList(self)
                                    self._segment_path = lambda: "class-map-detail" + "[class-map-name='" + self.class_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail, ['class_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference>`
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference)}

                                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\:  str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.object_type = YLeaf(YType.enumeration, "object-type")

                                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                            self._segment_path = lambda: "policy-map-reference"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_name = YLeaf(YType.str, "object-name")
                                        self._segment_path = lambda: "objects"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Objects, ['object_name'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "class-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                        self._segment_path = lambda: "reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMapDetails.ClassMapDetail.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                        class ClassMaps(Entity):
                            """
                            Class\-map definition table
                            
                            .. attribute:: class_map
                            
                            	Class\-map configuration
                            	**type**\: list of    :py:class:`ClassMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, self).__init__()

                                self.yang_name = "class-maps"
                                self.yang_parent_name = "class-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"class-map" : ("class_map", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap)}

                                self.class_map = YList(self)
                                self._segment_path = lambda: "class-maps"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps, [], name, value)


                            class ClassMap(Entity):
                                """
                                Class\-map configuration
                                
                                .. attribute:: class_map_name  <key>
                                
                                	Name of class\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_bg
                                
                                	class map bg
                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap, self).__init__()

                                    self.yang_name = "class-map"
                                    self.yang_parent_name = "class-maps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg)}

                                    self.class_map_name = YLeaf(YType.str, "class-map-name")

                                    self.class_map_bg = YList(self)
                                    self._segment_path = lambda: "class-map" + "[class-map-name='" + self.class_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap, ['class_map_name'], name, value)


                                class ClassMapBg(Entity):
                                    """
                                    class map bg
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\:  str
                                    
                                    .. attribute:: match_infop
                                    
                                    	Pointer to the first Match info
                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop>`
                                    
                                    .. attribute:: mode
                                    
                                    	Class\-Map Mode Match any/Match all
                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                    
                                    .. attribute:: name
                                    
                                    	Name of the class\-map
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: type
                                    
                                    	Class\-Map Type QoS/PBR/Netflow/..
                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg, self).__init__()

                                        self.yang_name = "class-map-bg"
                                        self.yang_parent_name = "class-map"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop)}
                                        self._child_list_classes = {}

                                        self.description = YLeaf(YType.str, "description")

                                        self.mode = YLeaf(YType.enumeration, "mode")

                                        self.name = YLeaf(YType.str, "name")

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.match_infop = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop()
                                        self.match_infop.parent = self
                                        self._children_name_map["match_infop"] = "match-infop"
                                        self._children_yang_names.add("match-infop")
                                        self._segment_path = lambda: "class-map-bg"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                    class MatchInfop(Entity):
                                        """
                                        Pointer to the first Match info
                                        
                                        .. attribute:: class_match_info_st
                                        
                                        	class match info st
                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop, self).__init__()

                                            self.yang_name = "match-infop"
                                            self.yang_parent_name = "class-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                            self.class_match_info_st = YList(self)
                                            self._segment_path = lambda: "match-infop"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop, [], name, value)


                                        class ClassMatchInfoSt(Entity):
                                            """
                                            class match info st
                                            
                                            .. attribute:: flags
                                            
                                            	Flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: match_data
                                            
                                            	Match criteria
                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                self.yang_name = "class-match-info-st"
                                                self.yang_parent_name = "match-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                self._child_list_classes = {}

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.match_data = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                self.match_data.parent = self
                                                self._children_name_map["match_data"] = "match-data"
                                                self._children_yang_names.add("match-data")
                                                self._segment_path = lambda: "class-match-info-st"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                            class MatchData(Entity):
                                                """
                                                Match criteria
                                                
                                                .. attribute:: access_interface
                                                
                                                	Access interface
                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                
                                                .. attribute:: atm_clp
                                                
                                                	Match ATM CLP level
                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                
                                                .. attribute:: auth_domain
                                                
                                                	Authenticated domain name
                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                
                                                .. attribute:: auth_domain_regex
                                                
                                                	Authenticated Domain Name RegEx
                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                
                                                .. attribute:: auth_username
                                                
                                                	Authenticated User Name
                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                
                                                .. attribute:: auth_username_regex
                                                
                                                	Authenticated User Name RegEx
                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                
                                                .. attribute:: authen_status
                                                
                                                	Authentication Status
                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                
                                                .. attribute:: avail_id
                                                
                                                	Available Identifiers
                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                
                                                .. attribute:: circuit_id
                                                
                                                	Circuit ID
                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                
                                                .. attribute:: circuit_id_regex
                                                
                                                	Circuit ID RegEx
                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                
                                                .. attribute:: cos
                                                
                                                	Match CoS array
                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                
                                                .. attribute:: cos_inr
                                                
                                                	Match inner header CoS
                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                
                                                .. attribute:: dei
                                                
                                                	Match DEI Bit
                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                
                                                .. attribute:: dei_inr
                                                
                                                	Match inner DEI Bit
                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                
                                                .. attribute:: dhcp_client_id
                                                
                                                	Dhcp Client ID
                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                
                                                .. attribute:: dhcp_client_id_regex
                                                
                                                	Dhcp Client ID RegEx
                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                
                                                .. attribute:: discard_class
                                                
                                                	Match Discard Class array
                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                
                                                .. attribute:: dnis
                                                
                                                	DNIS
                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                
                                                .. attribute:: dnis_regex
                                                
                                                	DNIS Regular Expression
                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                
                                                .. attribute:: domain
                                                
                                                	Domain Name
                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                
                                                .. attribute:: domain_regex
                                                
                                                	Domain Regular Expression
                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                
                                                .. attribute:: dscp
                                                
                                                	Match DSCP range array
                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                
                                                .. attribute:: dst_addr_ipv4
                                                
                                                	Destination Address IPV4
                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                
                                                .. attribute:: dst_addr_ipv6
                                                
                                                	Destination Address IPV6
                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                
                                                .. attribute:: dst_mac
                                                
                                                	Match Destination MAC address
                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                
                                                .. attribute:: dst_port
                                                
                                                	Destination port
                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                
                                                .. attribute:: ether_service_acl
                                                
                                                	Ethernet\-Services Access\-list
                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                
                                                .. attribute:: ethertype
                                                
                                                	Ethernet type
                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                
                                                .. attribute:: flow_key_data
                                                
                                                	Flow key structure
                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                
                                                .. attribute:: flow_tag
                                                
                                                	Match flow\-tag array
                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                
                                                .. attribute:: fr_de
                                                
                                                	Match FR DE value
                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                
                                                .. attribute:: fr_dlci
                                                
                                                	Match FR DLCI range array
                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                
                                                .. attribute:: fragment_type
                                                
                                                	Fragment type
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: icmp_v4
                                                
                                                	Match ICMPV4 Protocol
                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                
                                                .. attribute:: icmp_v6
                                                
                                                	Match ICMPV6 Protocol array
                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                
                                                .. attribute:: icmpv4_code
                                                
                                                	Match ipv4 icmp code
                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                
                                                .. attribute:: icmpv4_type
                                                
                                                	Match ipv4 icmp type
                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                
                                                .. attribute:: icmpv6_code
                                                
                                                	Match ipv6 icmp code
                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                
                                                .. attribute:: icmpv6_type
                                                
                                                	Match ipv6 icmp type
                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                
                                                .. attribute:: input_interface
                                                
                                                	Input interface
                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                
                                                .. attribute:: input_intfhdl
                                                
                                                	Input interface handle
                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                
                                                .. attribute:: ipv4_acl
                                                
                                                	IPv4 Access\-list
                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                
                                                .. attribute:: ipv4_dscp
                                                
                                                	IPv4 DSCP
                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                
                                                .. attribute:: ipv4_packet_len
                                                
                                                	IPv4 packet length array
                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                
                                                .. attribute:: ipv4_prec
                                                
                                                	IPv4 Precedence
                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                
                                                .. attribute:: ipv6_acl
                                                
                                                	IPv6 Access\-list
                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                
                                                .. attribute:: ipv6_dscp
                                                
                                                	IPv6 DSCP
                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                
                                                .. attribute:: ipv6_packet_len
                                                
                                                	IPv6 packet length array
                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                
                                                .. attribute:: ipv6_prec
                                                
                                                	IPv6 Precedence
                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                
                                                .. attribute:: media_type
                                                
                                                	Media Type
                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                
                                                .. attribute:: mlp_negotiated
                                                
                                                	MLP Negotiated
                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                
                                                .. attribute:: mpls_disp_ipv4_acl
                                                
                                                	MPLS Disposition IPv4 Access\-list
                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                
                                                .. attribute:: mpls_disp_ipv6_acl
                                                
                                                	MPLS Disposition IPv6 Access\-list
                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                
                                                .. attribute:: mpls_exp
                                                
                                                	Match MPLS experimental topmost array
                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                
                                                .. attribute:: mpls_exp_imp
                                                
                                                	Match MPLS experimental imposition array
                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                
                                                .. attribute:: mpls_top_eos
                                                
                                                	MPLS Topmost EOS
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: mpls_top_label
                                                
                                                	MPLS Topmost LABEL
                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                
                                                .. attribute:: nas_port
                                                
                                                	NAS Port
                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                
                                                .. attribute:: packet_len
                                                
                                                	Match packet length array
                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                
                                                .. attribute:: prec
                                                
                                                	Match Precedence array
                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                
                                                .. attribute:: proto
                                                
                                                	Match Protocol array
                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                
                                                .. attribute:: qos_group
                                                
                                                	Match QoS group array
                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                
                                                .. attribute:: remote_id
                                                
                                                	Remote ID
                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                
                                                .. attribute:: remote_id_regex
                                                
                                                	Remote ID RegEx
                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                
                                                .. attribute:: service_name
                                                
                                                	Service Name
                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                
                                                .. attribute:: service_name_regex
                                                
                                                	Service Name Regular Exp
                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                
                                                .. attribute:: src_addr_ipv4
                                                
                                                	Source Address IPV4
                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                
                                                .. attribute:: src_addr_ipv6
                                                
                                                	Source Address IPV6
                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                
                                                .. attribute:: src_addr_mac
                                                
                                                	Source Address MAC
                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                
                                                .. attribute:: src_mac
                                                
                                                	Match Source MAC address
                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                
                                                .. attribute:: src_port
                                                
                                                	Source port
                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                
                                                .. attribute:: subs_protocol
                                                
                                                	Protocol
                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                
                                                .. attribute:: tcp_flag
                                                
                                                	Match tcp flag value
                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                
                                                .. attribute:: timer
                                                
                                                	Timer
                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                
                                                .. attribute:: timer_regexp
                                                
                                                	Timer Regular Expression
                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                
                                                .. attribute:: traffic_class
                                                
                                                	Match Traffic class array
                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                
                                                .. attribute:: tunnel_name
                                                
                                                	Tunnel Name
                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                
                                                .. attribute:: tunnel_name_regex
                                                
                                                	Tunnel Name Regular Expression
                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                
                                                .. attribute:: unauth_domain
                                                
                                                	Unauthenticated Domain Name
                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                
                                                .. attribute:: unauth_domain_regex
                                                
                                                	Unauthenticated Domain Name RegEx
                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                
                                                .. attribute:: unauth_username
                                                
                                                	Unauthenticated User Name
                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                
                                                .. attribute:: unauth_username_regex
                                                
                                                	Unauthenticated User Name RegEx
                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                
                                                .. attribute:: user_name
                                                
                                                	User Name
                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                
                                                .. attribute:: user_name_regex
                                                
                                                	User Name Regular Expression
                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                
                                                .. attribute:: vendor_id
                                                
                                                	Vendor ID
                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                
                                                .. attribute:: vendor_id_regex
                                                
                                                	Vendor ID RegEx
                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                
                                                .. attribute:: vlan
                                                
                                                	Match VLAN array
                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                
                                                .. attribute:: vlan_inr
                                                
                                                	Match inner header VLAN range array
                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                    self.yang_name = "match-data"
                                                    self.yang_parent_name = "class-match-info-st"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                    self._child_list_classes = {}

                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.access_interface = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                    self.access_interface.parent = self
                                                    self._children_name_map["access_interface"] = "access-interface"
                                                    self._children_yang_names.add("access-interface")

                                                    self.atm_clp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                    self.atm_clp.parent = self
                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                    self._children_yang_names.add("atm-clp")

                                                    self.auth_domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                    self.auth_domain.parent = self
                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                    self._children_yang_names.add("auth-domain")

                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                    self.auth_domain_regex.parent = self
                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                    self._children_yang_names.add("auth-domain-regex")

                                                    self.auth_username = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                    self.auth_username.parent = self
                                                    self._children_name_map["auth_username"] = "auth-username"
                                                    self._children_yang_names.add("auth-username")

                                                    self.auth_username_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                    self.auth_username_regex.parent = self
                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                    self._children_yang_names.add("auth-username-regex")

                                                    self.avail_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                    self.avail_id.parent = self
                                                    self._children_name_map["avail_id"] = "avail-id"
                                                    self._children_yang_names.add("avail-id")

                                                    self.circuit_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                    self.circuit_id.parent = self
                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                    self._children_yang_names.add("circuit-id")

                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                    self.circuit_id_regex.parent = self
                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                    self._children_yang_names.add("circuit-id-regex")

                                                    self.cos = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                    self.cos.parent = self
                                                    self._children_name_map["cos"] = "cos"
                                                    self._children_yang_names.add("cos")

                                                    self.cos_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                    self.cos_inr.parent = self
                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                    self._children_yang_names.add("cos-inr")

                                                    self.dei = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                    self.dei.parent = self
                                                    self._children_name_map["dei"] = "dei"
                                                    self._children_yang_names.add("dei")

                                                    self.dei_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                    self.dei_inr.parent = self
                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                    self._children_yang_names.add("dei-inr")

                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                    self.dhcp_client_id.parent = self
                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                    self._children_yang_names.add("dhcp-client-id")

                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                    self.dhcp_client_id_regex.parent = self
                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                    self.discard_class = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                    self.discard_class.parent = self
                                                    self._children_name_map["discard_class"] = "discard-class"
                                                    self._children_yang_names.add("discard-class")

                                                    self.dnis = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                    self.dnis.parent = self
                                                    self._children_name_map["dnis"] = "dnis"
                                                    self._children_yang_names.add("dnis")

                                                    self.dnis_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                    self.dnis_regex.parent = self
                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                    self._children_yang_names.add("dnis-regex")

                                                    self.domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                    self.domain.parent = self
                                                    self._children_name_map["domain"] = "domain"
                                                    self._children_yang_names.add("domain")

                                                    self.domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                    self.domain_regex.parent = self
                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                    self._children_yang_names.add("domain-regex")

                                                    self.dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                    self.dscp.parent = self
                                                    self._children_name_map["dscp"] = "dscp"
                                                    self._children_yang_names.add("dscp")

                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                    self.dst_addr_ipv4.parent = self
                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                    self.dst_addr_ipv6.parent = self
                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                    self.dst_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                    self.dst_mac.parent = self
                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                    self._children_yang_names.add("dst-mac")

                                                    self.dst_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                    self.dst_port.parent = self
                                                    self._children_name_map["dst_port"] = "dst-port"
                                                    self._children_yang_names.add("dst-port")

                                                    self.ether_service_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                    self.ether_service_acl.parent = self
                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                    self._children_yang_names.add("ether-service-acl")

                                                    self.ethertype = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                    self.ethertype.parent = self
                                                    self._children_name_map["ethertype"] = "ethertype"
                                                    self._children_yang_names.add("ethertype")

                                                    self.flow_key_data = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                    self.flow_key_data.parent = self
                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                    self._children_yang_names.add("flow-key-data")

                                                    self.flow_tag = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                    self.flow_tag.parent = self
                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                    self._children_yang_names.add("flow-tag")

                                                    self.fr_de = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                    self.fr_de.parent = self
                                                    self._children_name_map["fr_de"] = "fr-de"
                                                    self._children_yang_names.add("fr-de")

                                                    self.fr_dlci = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                    self.fr_dlci.parent = self
                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                    self._children_yang_names.add("fr-dlci")

                                                    self.icmp_v4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                    self.icmp_v4.parent = self
                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                    self._children_yang_names.add("icmp-v4")

                                                    self.icmp_v6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                    self.icmp_v6.parent = self
                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                    self._children_yang_names.add("icmp-v6")

                                                    self.icmpv4_code = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                    self.icmpv4_code.parent = self
                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                    self._children_yang_names.add("icmpv4-code")

                                                    self.icmpv4_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                    self.icmpv4_type.parent = self
                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                    self._children_yang_names.add("icmpv4-type")

                                                    self.icmpv6_code = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                    self.icmpv6_code.parent = self
                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                    self._children_yang_names.add("icmpv6-code")

                                                    self.icmpv6_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                    self.icmpv6_type.parent = self
                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                    self._children_yang_names.add("icmpv6-type")

                                                    self.input_interface = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                    self.input_interface.parent = self
                                                    self._children_name_map["input_interface"] = "input-interface"
                                                    self._children_yang_names.add("input-interface")

                                                    self.input_intfhdl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                    self.input_intfhdl.parent = self
                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                    self._children_yang_names.add("input-intfhdl")

                                                    self.ipv4_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                    self.ipv4_acl.parent = self
                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                    self._children_yang_names.add("ipv4-acl")

                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                    self.ipv4_dscp.parent = self
                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                    self._children_yang_names.add("ipv4-dscp")

                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                    self.ipv4_packet_len.parent = self
                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                    self._children_yang_names.add("ipv4-packet-len")

                                                    self.ipv4_prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                    self.ipv4_prec.parent = self
                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                    self._children_yang_names.add("ipv4-prec")

                                                    self.ipv6_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                    self.ipv6_acl.parent = self
                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                    self._children_yang_names.add("ipv6-acl")

                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                    self.ipv6_dscp.parent = self
                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                    self._children_yang_names.add("ipv6-dscp")

                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                    self.ipv6_packet_len.parent = self
                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                    self._children_yang_names.add("ipv6-packet-len")

                                                    self.ipv6_prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                    self.ipv6_prec.parent = self
                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                    self._children_yang_names.add("ipv6-prec")

                                                    self.media_type = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                    self.media_type.parent = self
                                                    self._children_name_map["media_type"] = "media-type"
                                                    self._children_yang_names.add("media-type")

                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                    self.mpls_disp_ipv4_acl.parent = self
                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                    self.mpls_disp_ipv6_acl.parent = self
                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                    self.mpls_exp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                    self.mpls_exp.parent = self
                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                    self._children_yang_names.add("mpls-exp")

                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                    self.mpls_exp_imp.parent = self
                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                    self._children_yang_names.add("mpls-exp-imp")

                                                    self.mpls_top_label = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                    self.mpls_top_label.parent = self
                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                    self._children_yang_names.add("mpls-top-label")

                                                    self.nas_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                    self.nas_port.parent = self
                                                    self._children_name_map["nas_port"] = "nas-port"
                                                    self._children_yang_names.add("nas-port")

                                                    self.packet_len = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                    self.packet_len.parent = self
                                                    self._children_name_map["packet_len"] = "packet-len"
                                                    self._children_yang_names.add("packet-len")

                                                    self.prec = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                    self.prec.parent = self
                                                    self._children_name_map["prec"] = "prec"
                                                    self._children_yang_names.add("prec")

                                                    self.proto = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                    self.proto.parent = self
                                                    self._children_name_map["proto"] = "proto"
                                                    self._children_yang_names.add("proto")

                                                    self.qos_group = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                    self.qos_group.parent = self
                                                    self._children_name_map["qos_group"] = "qos-group"
                                                    self._children_yang_names.add("qos-group")

                                                    self.remote_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                    self.remote_id.parent = self
                                                    self._children_name_map["remote_id"] = "remote-id"
                                                    self._children_yang_names.add("remote-id")

                                                    self.remote_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                    self.remote_id_regex.parent = self
                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                    self._children_yang_names.add("remote-id-regex")

                                                    self.service_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                    self.service_name.parent = self
                                                    self._children_name_map["service_name"] = "service-name"
                                                    self._children_yang_names.add("service-name")

                                                    self.service_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                    self.service_name_regex.parent = self
                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                    self._children_yang_names.add("service-name-regex")

                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                    self.src_addr_ipv4.parent = self
                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                    self._children_yang_names.add("src-addr-ipv4")

                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                    self.src_addr_ipv6.parent = self
                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                    self._children_yang_names.add("src-addr-ipv6")

                                                    self.src_addr_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                    self.src_addr_mac.parent = self
                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                    self._children_yang_names.add("src-addr-mac")

                                                    self.src_mac = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                    self.src_mac.parent = self
                                                    self._children_name_map["src_mac"] = "src-mac"
                                                    self._children_yang_names.add("src-mac")

                                                    self.src_port = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                    self.src_port.parent = self
                                                    self._children_name_map["src_port"] = "src-port"
                                                    self._children_yang_names.add("src-port")

                                                    self.subs_protocol = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                    self.subs_protocol.parent = self
                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                    self._children_yang_names.add("subs-protocol")

                                                    self.tcp_flag = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                    self.tcp_flag.parent = self
                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                    self._children_yang_names.add("tcp-flag")

                                                    self.timer = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                    self.timer.parent = self
                                                    self._children_name_map["timer"] = "timer"
                                                    self._children_yang_names.add("timer")

                                                    self.timer_regexp = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                    self.timer_regexp.parent = self
                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                    self._children_yang_names.add("timer-regexp")

                                                    self.traffic_class = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                    self.traffic_class.parent = self
                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                    self._children_yang_names.add("traffic-class")

                                                    self.tunnel_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                    self.tunnel_name.parent = self
                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                    self._children_yang_names.add("tunnel-name")

                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                    self.tunnel_name_regex.parent = self
                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                    self._children_yang_names.add("tunnel-name-regex")

                                                    self.unauth_domain = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                    self.unauth_domain.parent = self
                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                    self._children_yang_names.add("unauth-domain")

                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                    self.unauth_domain_regex.parent = self
                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                    self._children_yang_names.add("unauth-domain-regex")

                                                    self.unauth_username = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                    self.unauth_username.parent = self
                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                    self._children_yang_names.add("unauth-username")

                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                    self.unauth_username_regex.parent = self
                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                    self._children_yang_names.add("unauth-username-regex")

                                                    self.user_name = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                    self.user_name.parent = self
                                                    self._children_name_map["user_name"] = "user-name"
                                                    self._children_yang_names.add("user-name")

                                                    self.user_name_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                    self.user_name_regex.parent = self
                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                    self._children_yang_names.add("user-name-regex")

                                                    self.vendor_id = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                    self.vendor_id.parent = self
                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                    self._children_yang_names.add("vendor-id")

                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                    self.vendor_id_regex.parent = self
                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                    self._children_yang_names.add("vendor-id-regex")

                                                    self.vlan = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                    self.vlan.parent = self
                                                    self._children_name_map["vlan"] = "vlan"
                                                    self._children_yang_names.add("vlan")

                                                    self.vlan_inr = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                    self.vlan_inr.parent = self
                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                    self._children_yang_names.add("vlan-inr")
                                                    self._segment_path = lambda: "match-data"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                class AccessInterface(Entity):
                                                    """
                                                    Access interface
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                        self.yang_name = "access-interface"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "access-interface"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                class AtmClp(Entity):
                                                    """
                                                    Match ATM CLP level
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                        self.yang_name = "atm-clp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "atm-clp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                class AuthDomain(Entity):
                                                    """
                                                    Authenticated domain name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                        self.yang_name = "auth-domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "auth-domain"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                class AuthDomainRegex(Entity):
                                                    """
                                                    Authenticated Domain Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                        self.yang_name = "auth-domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "auth-domain-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                class AuthUsername(Entity):
                                                    """
                                                    Authenticated User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                        self.yang_name = "auth-username"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "auth-username"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                class AuthUsernameRegex(Entity):
                                                    """
                                                    Authenticated User Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                        self.yang_name = "auth-username-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "auth-username-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                class AvailId(Entity):
                                                    """
                                                    Available Identifiers
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                        self.yang_name = "avail-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "avail-id"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                class CircuitId(Entity):
                                                    """
                                                    Circuit ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                        self.yang_name = "circuit-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "circuit-id"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                class CircuitIdRegex(Entity):
                                                    """
                                                    Circuit ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                        self.yang_name = "circuit-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "circuit-id-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                class Cos(Entity):
                                                    """
                                                    Match CoS array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                        self.yang_name = "cos"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "cos"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                class CosInr(Entity):
                                                    """
                                                    Match inner header CoS
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                        self.yang_name = "cos-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "cos-inr"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                class Dei(Entity):
                                                    """
                                                    Match DEI Bit
                                                    
                                                    .. attribute:: bit_value
                                                    
                                                    	Value of the DEI bit
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                        self.yang_name = "dei"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                        self._segment_path = lambda: "dei"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                class DeiInr(Entity):
                                                    """
                                                    Match inner DEI Bit
                                                    
                                                    .. attribute:: bit_value
                                                    
                                                    	Value of the DEI bit
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                        self.yang_name = "dei-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                        self._segment_path = lambda: "dei-inr"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                class DhcpClientId(Entity):
                                                    """
                                                    Dhcp Client ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                        self.yang_name = "dhcp-client-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "dhcp-client-id"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                class DhcpClientIdRegex(Entity):
                                                    """
                                                    Dhcp Client ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                        self.yang_name = "dhcp-client-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                class DiscardClass(Entity):
                                                    """
                                                    Match Discard Class array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                        self.yang_name = "discard-class"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "discard-class"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                class Dnis(Entity):
                                                    """
                                                    DNIS
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                        self.yang_name = "dnis"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "dnis"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                class DnisRegex(Entity):
                                                    """
                                                    DNIS Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                        self.yang_name = "dnis-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "dnis-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                class Domain(Entity):
                                                    """
                                                    Domain Name
                                                    
                                                    .. attribute:: domain_array
                                                    
                                                    	domain array
                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                        self.yang_name = "domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                        self.domain_array = YList(self)
                                                        self._segment_path = lambda: "domain"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                    class DomainArray(Entity):
                                                        """
                                                        domain array
                                                        
                                                        .. attribute:: domain_name
                                                        
                                                        	domain name
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: format_name
                                                        
                                                        	format name
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                            self.yang_name = "domain-array"
                                                            self.yang_parent_name = "domain"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                            self._segment_path = lambda: "domain-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                class DomainRegex(Entity):
                                                    """
                                                    Domain Regular Expression
                                                    
                                                    .. attribute:: domain_array
                                                    
                                                    	domain array
                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                        self.yang_name = "domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                        self.domain_array = YList(self)
                                                        self._segment_path = lambda: "domain-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                    class DomainArray(Entity):
                                                        """
                                                        domain array
                                                        
                                                        .. attribute:: domain_name
                                                        
                                                        	domain name
                                                        	**type**\:  str
                                                        
                                                        .. attribute:: format_name
                                                        
                                                        	format name
                                                        	**type**\:  str
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                            self.yang_name = "domain-array"
                                                            self.yang_parent_name = "domain-regex"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                            self._segment_path = lambda: "domain-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                class Dscp(Entity):
                                                    """
                                                    Match DSCP range array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                        self.yang_name = "dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "dscp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                class DstAddrIpv4(Entity):
                                                    """
                                                    Destination Address IPV4
                                                    
                                                    .. attribute:: ipv4_addr_array
                                                    
                                                    	ipv4 addr array
                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                        self.yang_name = "dst-addr-ipv4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                        self.ipv4_addr_array = YList(self)
                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                    class Ipv4AddrArray(Entity):
                                                        """
                                                        ipv4 addr array
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	mask
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	prefix
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                            self.yang_name = "ipv4-addr-array"
                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mask = YLeaf(YType.str, "mask")

                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                class DstAddrIpv6(Entity):
                                                    """
                                                    Destination Address IPV6
                                                    
                                                    .. attribute:: ipv6_addr_array
                                                    
                                                    	ipv6 addr array
                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                        self.yang_name = "dst-addr-ipv6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                        self.ipv6_addr_array = YList(self)
                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                    class Ipv6AddrArray(Entity):
                                                        """
                                                        ipv6 addr array
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	IPV6 mask
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	IPV6 prefix
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                            self.yang_name = "ipv6-addr-array"
                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                class DstMac(Entity):
                                                    """
                                                    Match Destination MAC address
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                        self.yang_name = "dst-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                        self._segment_path = lambda: "dst-mac"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                class DstPort(Entity):
                                                    """
                                                    Destination port
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                        self.yang_name = "dst-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "dst-port"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "dst-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                class EtherServiceAcl(Entity):
                                                    """
                                                    Ethernet\-Services Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                        self.yang_name = "ether-service-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "ether-service-acl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                class Ethertype(Entity):
                                                    """
                                                    Ethernet type
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                        self.yang_name = "ethertype"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ethertype"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ethertype"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                class FlowKeyData(Entity):
                                                    """
                                                    Flow key structure
                                                    
                                                    .. attribute:: flow_keys
                                                    
                                                    	flow keys
                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                    
                                                    .. attribute:: idle_timeout
                                                    
                                                    	Idle timeout of flows (in seconds)
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    	**units**\: second
                                                    
                                                    .. attribute:: max_count
                                                    
                                                    	Maximum count of flows
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                        self.yang_name = "flow-key-data"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                        self._child_list_classes = {}

                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                        self.flow_keys = PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                        self.flow_keys.parent = self
                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                        self._children_yang_names.add("flow-keys")
                                                        self._segment_path = lambda: "flow-key-data"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                    class FlowKeys(Entity):
                                                        """
                                                        flow keys
                                                        
                                                        .. attribute:: keys
                                                        
                                                        	keys
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                        
                                                        .. attribute:: num
                                                        
                                                        	num
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                            self.yang_name = "flow-keys"
                                                            self.yang_parent_name = "flow-key-data"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.keys = YLeaf(YType.str, "keys")

                                                            self.num = YLeaf(YType.uint8, "num")
                                                            self._segment_path = lambda: "flow-keys"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                class FlowTag(Entity):
                                                    """
                                                    Match flow\-tag array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                        self.yang_name = "flow-tag"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "flow-tag"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "flow-tag"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                class FrDe(Entity):
                                                    """
                                                    Match FR DE value
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                        self.yang_name = "fr-de"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "fr-de"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                class FrDlci(Entity):
                                                    """
                                                    Match FR DLCI range array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                        self.yang_name = "fr-dlci"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "fr-dlci"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "fr-dlci"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                class IcmpV4(Entity):
                                                    """
                                                    Match ICMPV4 Protocol
                                                    
                                                    .. attribute:: code
                                                    
                                                    	Protocol code
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	Protocol type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                        self.yang_name = "icmp-v4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.code = YLeaf(YType.uint8, "code")

                                                        self.type = YLeaf(YType.uint8, "type")
                                                        self._segment_path = lambda: "icmp-v4"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                class IcmpV6(Entity):
                                                    """
                                                    Match ICMPV6 Protocol array
                                                    
                                                    .. attribute:: code
                                                    
                                                    	Protocol code
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	Protocol type
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                        self.yang_name = "icmp-v6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.code = YLeaf(YType.uint8, "code")

                                                        self.type = YLeaf(YType.uint8, "type")
                                                        self._segment_path = lambda: "icmp-v6"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                class Icmpv4Code(Entity):
                                                    """
                                                    Match ipv4 icmp code
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                        self.yang_name = "icmpv4-code"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv4-code"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv4-code"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                class Icmpv4Type(Entity):
                                                    """
                                                    Match ipv4 icmp type
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                        self.yang_name = "icmpv4-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv4-type"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv4-type"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                class Icmpv6Code(Entity):
                                                    """
                                                    Match ipv6 icmp code
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                        self.yang_name = "icmpv6-code"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv6-code"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv6-code"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                class Icmpv6Type(Entity):
                                                    """
                                                    Match ipv6 icmp type
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                        self.yang_name = "icmpv6-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "icmpv6-type"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "icmpv6-type"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                class InputInterface(Entity):
                                                    """
                                                    Input interface
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                        self.yang_name = "input-interface"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "input-interface"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                class InputIntfhdl(Entity):
                                                    """
                                                    Input interface handle
                                                    
                                                    .. attribute:: uint64_array
                                                    
                                                    	uint64 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                        self.yang_name = "input-intfhdl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                        self._segment_path = lambda: "input-intfhdl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                class Ipv4Acl(Entity):
                                                    """
                                                    IPv4 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                        self.yang_name = "ipv4-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "ipv4-acl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                class Ipv4Dscp(Entity):
                                                    """
                                                    IPv4 DSCP
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                        self.yang_name = "ipv4-dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv4-dscp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "ipv4-dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                class Ipv4PacketLen(Entity):
                                                    """
                                                    IPv4 packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                        self.yang_name = "ipv4-packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ipv4-packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                class Ipv4Prec(Entity):
                                                    """
                                                    IPv4 Precedence
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                        self.yang_name = "ipv4-prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "ipv4-prec"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                class Ipv6Acl(Entity):
                                                    """
                                                    IPv6 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                        self.yang_name = "ipv6-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "ipv6-acl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                class Ipv6Dscp(Entity):
                                                    """
                                                    IPv6 DSCP
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                        self.yang_name = "ipv6-dscp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv6-dscp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "ipv6-dscp"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                class Ipv6PacketLen(Entity):
                                                    """
                                                    IPv6 packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                        self.yang_name = "ipv6-packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "ipv6-packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                class Ipv6Prec(Entity):
                                                    """
                                                    IPv6 Precedence
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                        self.yang_name = "ipv6-prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "ipv6-prec"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                class MediaType(Entity):
                                                    """
                                                    Media Type
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                        self.yang_name = "media-type"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "media-type"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                class MplsDispIpv4Acl(Entity):
                                                    """
                                                    MPLS Disposition IPv4 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                class MplsDispIpv6Acl(Entity):
                                                    """
                                                    MPLS Disposition IPv6 Access\-list
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                class MplsExp(Entity):
                                                    """
                                                    Match MPLS experimental topmost array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                        self.yang_name = "mpls-exp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "mpls-exp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                class MplsExpImp(Entity):
                                                    """
                                                    Match MPLS experimental imposition array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                        self.yang_name = "mpls-exp-imp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                class MplsTopLabel(Entity):
                                                    """
                                                    MPLS Topmost LABEL
                                                    
                                                    .. attribute:: uint32_rng_array
                                                    
                                                    	uint32 rng array
                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                        self.yang_name = "mpls-top-label"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                        self.uint32_rng_array = YList(self)
                                                        self._segment_path = lambda: "mpls-top-label"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                    class Uint32RngArray(Entity):
                                                        """
                                                        uint32 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                            self.yang_name = "uint32_rng_array"
                                                            self.yang_parent_name = "mpls-top-label"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint32, "max")

                                                            self.min = YLeaf(YType.uint32, "min")
                                                            self._segment_path = lambda: "uint32_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                class NasPort(Entity):
                                                    """
                                                    NAS Port
                                                    
                                                    .. attribute:: nas_port_array
                                                    
                                                    	nas port array
                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                        self.yang_name = "nas-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                        self.nas_port_array = YList(self)
                                                        self._segment_path = lambda: "nas-port"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                    class NasPortArray(Entity):
                                                        """
                                                        nas port array
                                                        
                                                        .. attribute:: operator
                                                        
                                                        	operator
                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                        
                                                        .. attribute:: sub_id
                                                        
                                                        	sub id
                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                        
                                                        .. attribute:: value
                                                        
                                                        	value
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                            self.yang_name = "nas-port-array"
                                                            self.yang_parent_name = "nas-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                            self.value = YLeaf(YType.uint32, "value")
                                                            self._segment_path = lambda: "nas-port-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                class PacketLen(Entity):
                                                    """
                                                    Match packet length array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                        self.yang_name = "packet-len"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "packet-len"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "packet-len"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                class Prec(Entity):
                                                    """
                                                    Match Precedence array
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                        self.yang_name = "prec"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "prec"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                class Proto(Entity):
                                                    """
                                                    Match Protocol array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                        self.yang_name = "proto"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "proto"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "proto"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                class QosGroup(Entity):
                                                    """
                                                    Match QoS group array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                        self.yang_name = "qos-group"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "qos-group"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "qos-group"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                class RemoteId(Entity):
                                                    """
                                                    Remote ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                        self.yang_name = "remote-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "remote-id"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                class RemoteIdRegex(Entity):
                                                    """
                                                    Remote ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                        self.yang_name = "remote-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "remote-id-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                class ServiceName(Entity):
                                                    """
                                                    Service Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                        self.yang_name = "service-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "service-name"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                class ServiceNameRegex(Entity):
                                                    """
                                                    Service Name Regular Exp
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                        self.yang_name = "service-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "service-name-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                class SrcAddrIpv4(Entity):
                                                    """
                                                    Source Address IPV4
                                                    
                                                    .. attribute:: ipv4_addr_array
                                                    
                                                    	ipv4 addr array
                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                        self.yang_name = "src-addr-ipv4"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                        self.ipv4_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                    class Ipv4AddrArray(Entity):
                                                        """
                                                        ipv4 addr array
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	mask
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	prefix
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                            self.yang_name = "ipv4-addr-array"
                                                            self.yang_parent_name = "src-addr-ipv4"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mask = YLeaf(YType.str, "mask")

                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                class SrcAddrIpv6(Entity):
                                                    """
                                                    Source Address IPV6
                                                    
                                                    .. attribute:: ipv6_addr_array
                                                    
                                                    	ipv6 addr array
                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                        self.yang_name = "src-addr-ipv6"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                        self.ipv6_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                    class Ipv6AddrArray(Entity):
                                                        """
                                                        ipv6 addr array
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	IPV6 mask
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: prefix
                                                        
                                                        	IPV6 prefix
                                                        	**type**\:  str
                                                        
                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                            self.yang_name = "ipv6-addr-array"
                                                            self.yang_parent_name = "src-addr-ipv6"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                class SrcAddrMac(Entity):
                                                    """
                                                    Source Address MAC
                                                    
                                                    .. attribute:: mac_addr_array
                                                    
                                                    	mac addr array
                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                        self.yang_name = "src-addr-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                        self.mac_addr_array = YList(self)
                                                        self._segment_path = lambda: "src-addr-mac"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                    class MacAddrArray(Entity):
                                                        """
                                                        mac addr array
                                                        
                                                        .. attribute:: mac_addr
                                                        
                                                        	MAC address
                                                        	**type**\:  list of int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	MAC mask
                                                        	**type**\:  list of int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                            self.yang_name = "mac-addr-array"
                                                            self.yang_parent_name = "src-addr-mac"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                            self._segment_path = lambda: "mac-addr-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                class SrcMac(Entity):
                                                    """
                                                    Match Source MAC address
                                                    
                                                    .. attribute:: mac_addr
                                                    
                                                    	MAC address
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: mask
                                                    
                                                    	MAC mask
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                        self.yang_name = "src-mac"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                        self._segment_path = lambda: "src-mac"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                class SrcPort(Entity):
                                                    """
                                                    Source port
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                        self.yang_name = "src-port"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "src-port"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "src-port"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                class SubsProtocol(Entity):
                                                    """
                                                    Protocol
                                                    
                                                    .. attribute:: uint8_array
                                                    
                                                    	uint8 array
                                                    	**type**\:  list of int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                        self.yang_name = "subs-protocol"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                        self._segment_path = lambda: "subs-protocol"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                class TcpFlag(Entity):
                                                    """
                                                    Match tcp flag value
                                                    
                                                    .. attribute:: match_any
                                                    
                                                    	Match any TCP flag bit
                                                    	**type**\:  bool
                                                    
                                                    .. attribute:: value
                                                    
                                                    	Value of TCP flag
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                        self.yang_name = "tcp-flag"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                        self.value = YLeaf(YType.uint16, "value")
                                                        self._segment_path = lambda: "tcp-flag"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                class Timer(Entity):
                                                    """
                                                    Timer
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                        self.yang_name = "timer"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "timer"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                class TimerRegexp(Entity):
                                                    """
                                                    Timer Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                        self.yang_name = "timer-regexp"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "timer-regexp"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                class TrafficClass(Entity):
                                                    """
                                                    Match Traffic class array
                                                    
                                                    .. attribute:: uint8_rng_array
                                                    
                                                    	uint8 rng array
                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                        self.yang_name = "traffic-class"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                        self.uint8_rng_array = YList(self)
                                                        self._segment_path = lambda: "traffic-class"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                    class Uint8RngArray(Entity):
                                                        """
                                                        uint8 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                            self.yang_name = "uint8_rng_array"
                                                            self.yang_parent_name = "traffic-class"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint8, "max")

                                                            self.min = YLeaf(YType.uint8, "min")
                                                            self._segment_path = lambda: "uint8_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                class TunnelName(Entity):
                                                    """
                                                    Tunnel Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                        self.yang_name = "tunnel-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "tunnel-name"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                class TunnelNameRegex(Entity):
                                                    """
                                                    Tunnel Name Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                        self.yang_name = "tunnel-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                class UnauthDomain(Entity):
                                                    """
                                                    Unauthenticated Domain Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                        self.yang_name = "unauth-domain"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "unauth-domain"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                class UnauthDomainRegex(Entity):
                                                    """
                                                    Unauthenticated Domain Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                        self.yang_name = "unauth-domain-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                class UnauthUsername(Entity):
                                                    """
                                                    Unauthenticated User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                        self.yang_name = "unauth-username"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "unauth-username"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                class UnauthUsernameRegex(Entity):
                                                    """
                                                    Unauthenticated User Name RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                        self.yang_name = "unauth-username-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "unauth-username-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                class UserName(Entity):
                                                    """
                                                    User Name
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                        self.yang_name = "user-name"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "user-name"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                class UserNameRegex(Entity):
                                                    """
                                                    User Name Regular Expression
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                        self.yang_name = "user-name-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "user-name-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                class VendorId(Entity):
                                                    """
                                                    Vendor ID
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                        self.yang_name = "vendor-id"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "vendor-id"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                class VendorIdRegex(Entity):
                                                    """
                                                    Vendor ID RegEx
                                                    
                                                    .. attribute:: string_array
                                                    
                                                    	string array
                                                    	**type**\:  list of str
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                        self.yang_name = "vendor-id-regex"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                        self._segment_path = lambda: "vendor-id-regex"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                class Vlan(Entity):
                                                    """
                                                    Match VLAN array
                                                    
                                                    .. attribute:: vlan_id_array
                                                    
                                                    	vlan id array
                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                        self.yang_name = "vlan"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                        self.vlan_id_array = YList(self)
                                                        self._segment_path = lambda: "vlan"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                    class VlanIdArray(Entity):
                                                        """
                                                        vlan id array
                                                        
                                                        .. attribute:: mask
                                                        
                                                        	VLAN mask
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                            self.yang_name = "vlan-id-array"
                                                            self.yang_parent_name = "vlan"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "vlan-id-array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                class VlanInr(Entity):
                                                    """
                                                    Match inner header VLAN range array
                                                    
                                                    .. attribute:: uint16_rng_array
                                                    
                                                    	uint16 rng array
                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                        self.yang_name = "vlan-inr"
                                                        self.yang_parent_name = "match-data"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                        self.uint16_rng_array = YList(self)
                                                        self._segment_path = lambda: "vlan-inr"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                    class Uint16RngArray(Entity):
                                                        """
                                                        uint16 rng array
                                                        
                                                        .. attribute:: max
                                                        
                                                        	Upper limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: min
                                                        
                                                        	Lower limit of the range
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                            self.yang_name = "uint16_rng_array"
                                                            self.yang_parent_name = "vlan-inr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.max = YLeaf(YType.uint16, "max")

                                                            self.min = YLeaf(YType.uint16, "min")
                                                            self._segment_path = lambda: "uint16_rng_array"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.ClassMap.ClassMapTypes.ClassMapType.ClassMaps.ClassMap.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


            class PolicyMap(Entity):
                """
                List of policymap details
                
                .. attribute:: policy_map_types
                
                	Application type of a policymap
                	**type**\:   :py:class:`PolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes>`
                
                .. attribute:: policy_map_unused_types
                
                	Policy\-map unused table
                	**type**\:   :py:class:`PolicyMapUnusedTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes>`
                
                .. attribute:: transient_policy_map_type_xr
                
                	Application type of transient policy\-map
                	**type**\:   :py:class:`TransientPolicyMapTypeXr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr>`
                
                .. attribute:: transient_policy_map_types
                
                	Application type of transient policy\-map list
                	**type**\:   :py:class:`TransientPolicyMapTypes <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.PolicyMap, self).__init__()

                    self.yang_name = "policy-map"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self._child_container_classes = {"policy-map-types" : ("policy_map_types", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes), "policy-map-unused-types" : ("policy_map_unused_types", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes), "transient-policy-map-type-xr" : ("transient_policy_map_type_xr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr), "transient-policy-map-types" : ("transient_policy_map_types", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes)}
                    self._child_list_classes = {}

                    self.policy_map_types = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes()
                    self.policy_map_types.parent = self
                    self._children_name_map["policy_map_types"] = "policy-map-types"
                    self._children_yang_names.add("policy-map-types")

                    self.policy_map_unused_types = PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes()
                    self.policy_map_unused_types.parent = self
                    self._children_name_map["policy_map_unused_types"] = "policy-map-unused-types"
                    self._children_yang_names.add("policy-map-unused-types")

                    self.transient_policy_map_type_xr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr()
                    self.transient_policy_map_type_xr.parent = self
                    self._children_name_map["transient_policy_map_type_xr"] = "transient-policy-map-type-xr"
                    self._children_yang_names.add("transient-policy-map-type-xr")

                    self.transient_policy_map_types = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes()
                    self.transient_policy_map_types.parent = self
                    self._children_name_map["transient_policy_map_types"] = "transient-policy-map-types"
                    self._children_yang_names.add("transient-policy-map-types")
                    self._segment_path = lambda: "policy-map"


                class PolicyMapTypes(Entity):
                    """
                    Application type of a policymap
                    
                    .. attribute:: policy_map_type
                    
                    	Policymgr application type
                    	**type**\: list of    :py:class:`PolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes, self).__init__()

                        self.yang_name = "policy-map-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"policy-map-type" : ("policy_map_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType)}

                        self.policy_map_type = YList(self)
                        self._segment_path = lambda: "policy-map-types"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes, [], name, value)


                    class PolicyMapType(Entity):
                        """
                        Policymgr application type
                        
                        .. attribute:: type  <key>
                        
                        	The application type
                        	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: policy_map_details
                        
                        	Policy\-map table
                        	**type**\:   :py:class:`PolicyMapDetails <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails>`
                        
                        .. attribute:: policy_maps
                        
                        	Policy\-map definition table
                        	**type**\:   :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType, self).__init__()

                            self.yang_name = "policy-map-type"
                            self.yang_parent_name = "policy-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"policy-map-details" : ("policy_map_details", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails), "policy-maps" : ("policy_maps", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps)}
                            self._child_list_classes = {}

                            self.type = YLeaf(YType.enumeration, "type")

                            self.policy_map_details = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails()
                            self.policy_map_details.parent = self
                            self._children_name_map["policy_map_details"] = "policy-map-details"
                            self._children_yang_names.add("policy-map-details")

                            self.policy_maps = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps()
                            self.policy_maps.parent = self
                            self._children_name_map["policy_maps"] = "policy-maps"
                            self._children_yang_names.add("policy-maps")
                            self._segment_path = lambda: "policy-map-type" + "[type='" + self.type.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType, ['type'], name, value)


                        class PolicyMapDetails(Entity):
                            """
                            Policy\-map table
                            
                            .. attribute:: policy_map_detail
                            
                            	Policy\-map detail information
                            	**type**\: list of    :py:class:`PolicyMapDetail <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, self).__init__()

                                self.yang_name = "policy-map-details"
                                self.yang_parent_name = "policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"policy-map-detail" : ("policy_map_detail", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail)}

                                self.policy_map_detail = YList(self)
                                self._segment_path = lambda: "policy-map-details"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails, [], name, value)


                            class PolicyMapDetail(Entity):
                                """
                                Policy\-map detail information
                                
                                .. attribute:: policy_map_name  <key>
                                
                                	Name of policy\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference>`
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects>`
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, self).__init__()

                                    self.yang_name = "policy-map-detail"
                                    self.yang_parent_name = "policy-map-details"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference)}

                                    self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                    self.object_type = YLeaf(YType.enumeration, "object-type")

                                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                                    self.transient = YLeaf(YType.boolean, "transient")

                                    self.class_map_reference = YList(self)
                                    self.objects = YList(self)
                                    self.reference = YList(self)
                                    self._segment_path = lambda: "policy-map-detail" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference>`
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference)}

                                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\:  str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.object_type = YLeaf(YType.enumeration, "object-type")

                                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                            self._segment_path = lambda: "policy-map-reference"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_name = YLeaf(YType.str, "object-name")
                                        self._segment_path = lambda: "objects"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Objects, ['object_name'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "policy-map-detail"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                        self._segment_path = lambda: "reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMapDetails.PolicyMapDetail.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                        class PolicyMaps(Entity):
                            """
                            Policy\-map definition table
                            
                            .. attribute:: policy_map
                            
                            	Policy\-map configuration
                            	**type**\: list of    :py:class:`PolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, self).__init__()

                                self.yang_name = "policy-maps"
                                self.yang_parent_name = "policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"policy-map" : ("policy_map", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap)}

                                self.policy_map = YList(self)
                                self._segment_path = lambda: "policy-maps"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps, [], name, value)


                            class PolicyMap(Entity):
                                """
                                Policy\-map configuration
                                
                                .. attribute:: policy_map_name  <key>
                                
                                	Name of policy\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: policy_map_bg
                                
                                	policy map bg
                                	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap, self).__init__()

                                    self.yang_name = "policy-map"
                                    self.yang_parent_name = "policy-maps"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg)}

                                    self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                    self.policy_map_bg = YList(self)
                                    self._segment_path = lambda: "policy-map" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap, ['policy_map_name'], name, value)


                                class PolicyMapBg(Entity):
                                    """
                                    policy map bg
                                    
                                    .. attribute:: description
                                    
                                    	description
                                    	**type**\:  str
                                    
                                    .. attribute:: event_infop
                                    
                                    	event infop
                                    	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop>`
                                    
                                    .. attribute:: name
                                    
                                    	name
                                    	**type**\:  str
                                    
                                    	**length:** 0..65
                                    
                                    .. attribute:: pmap_var_list
                                    
                                    	pmap var list
                                    	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList>`
                                    
                                    .. attribute:: type
                                    
                                    	type
                                    	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg, self).__init__()

                                        self.yang_name = "policy-map-bg"
                                        self.yang_parent_name = "policy-map"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList)}
                                        self._child_list_classes = {}

                                        self.description = YLeaf(YType.str, "description")

                                        self.name = YLeaf(YType.str, "name")

                                        self.type = YLeaf(YType.enumeration, "type")

                                        self.event_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop()
                                        self.event_infop.parent = self
                                        self._children_name_map["event_infop"] = "event-infop"
                                        self._children_yang_names.add("event-infop")

                                        self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList()
                                        self.pmap_var_list.parent = self
                                        self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                        self._children_yang_names.add("pmap-var-list")
                                        self._segment_path = lambda: "policy-map-bg"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                    class EventInfop(Entity):
                                        """
                                        event infop
                                        
                                        .. attribute:: policy_event_info_bg
                                        
                                        	policy event info bg
                                        	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop, self).__init__()

                                            self.yang_name = "event-infop"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                            self.policy_event_info_bg = YList(self)
                                            self._segment_path = lambda: "event-infop"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop, [], name, value)


                                        class PolicyEventInfoBg(Entity):
                                            """
                                            policy event info bg
                                            
                                            .. attribute:: avl_tree
                                            
                                            	avl tree
                                            	**type**\:  int
                                            
                                            	**range:** 0..18446744073709551615
                                            
                                            .. attribute:: class_infop
                                            
                                            	class infop
                                            	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                            
                                            .. attribute:: cond_eval
                                            
                                            	cond eval
                                            	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                            
                                            .. attribute:: event_type
                                            
                                            	event type
                                            	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                            
                                            .. attribute:: flags
                                            
                                            	flags
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                self.yang_name = "policy-event-info-bg"
                                                self.yang_parent_name = "event-infop"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                self._child_list_classes = {}

                                                self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                self.event_type = YLeaf(YType.enumeration, "event-type")

                                                self.flags = YLeaf(YType.uint32, "flags")

                                                self.class_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                self.class_infop.parent = self
                                                self._children_name_map["class_infop"] = "class-infop"
                                                self._children_yang_names.add("class-infop")
                                                self._segment_path = lambda: "policy-event-info-bg"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                            class ClassInfop(Entity):
                                                """
                                                class infop
                                                
                                                .. attribute:: policy_class_info_bg
                                                
                                                	policy class info bg
                                                	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                    self.yang_name = "class-infop"
                                                    self.yang_parent_name = "policy-event-info-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                    self.policy_class_info_bg = YList(self)
                                                    self._segment_path = lambda: "class-infop"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                class PolicyClassInfoBg(Entity):
                                                    """
                                                    policy class info bg
                                                    
                                                    .. attribute:: act_infop
                                                    
                                                    	act infop
                                                    	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                    
                                                    .. attribute:: cl_encode
                                                    
                                                    	cl encode
                                                    	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                    
                                                    .. attribute:: clmp_p
                                                    
                                                    	clmp p
                                                    	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                    
                                                    .. attribute:: ctype
                                                    
                                                    	ctype
                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                    
                                                    .. attribute:: exe_strat
                                                    
                                                    	exe strat
                                                    	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: num_actions
                                                    
                                                    	num actions
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: policy_class_hd
                                                    
                                                    	policy class hd
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: seq
                                                    
                                                    	seq
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: version
                                                    
                                                    	version
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                        self.yang_name = "policy-class-info-bg"
                                                        self.yang_parent_name = "class-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                        self._child_list_classes = {}

                                                        self.ctype = YLeaf(YType.enumeration, "ctype")

                                                        self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                        self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                        self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                        self.seq = YLeaf(YType.uint32, "seq")

                                                        self.version = YLeaf(YType.uint8, "version")

                                                        self.act_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                        self.act_infop.parent = self
                                                        self._children_name_map["act_infop"] = "act-infop"
                                                        self._children_yang_names.add("act-infop")

                                                        self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                        self.cl_encode.parent = self
                                                        self._children_name_map["cl_encode"] = "cl-encode"
                                                        self._children_yang_names.add("cl-encode")

                                                        self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                        self.clmp_p.parent = self
                                                        self._children_name_map["clmp_p"] = "clmp-p"
                                                        self._children_yang_names.add("clmp-p")
                                                        self._segment_path = lambda: "policy-class-info-bg"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                    class ActInfop(Entity):
                                                        """
                                                        act infop
                                                        
                                                        .. attribute:: policy_action_info_st
                                                        
                                                        	policy action info st
                                                        	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                            self.yang_name = "act-infop"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                            self.policy_action_info_st = YList(self)
                                                            self._segment_path = lambda: "act-infop"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                        class PolicyActionInfoSt(Entity):
                                                            """
                                                            policy action info st
                                                            
                                                            .. attribute:: actp
                                                            
                                                            	actp
                                                            	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                self.yang_name = "policy-action-info-st"
                                                                self.yang_parent_name = "act-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"actp" : ("actp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                self._child_list_classes = {}

                                                                self.flags = YLeaf(YType.uint16, "flags")

                                                                self.seq = YLeaf(YType.uint16, "seq")

                                                                self.actp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                self.actp.parent = self
                                                                self._children_name_map["actp"] = "actp"
                                                                self._children_yang_names.add("actp")
                                                                self._segment_path = lambda: "policy-action-info-st"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                            class Actp(Entity):
                                                                """
                                                                actp
                                                                
                                                                .. attribute:: accounting_event_aaa
                                                                
                                                                	accounting event aaa
                                                                	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                
                                                                .. attribute:: acct_aaa_list
                                                                
                                                                	acct aaa list
                                                                	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                
                                                                .. attribute:: act_template
                                                                
                                                                	act template
                                                                	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                
                                                                .. attribute:: afm_react
                                                                
                                                                	afm react
                                                                	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                
                                                                .. attribute:: authen_aaa
                                                                
                                                                	authen aaa
                                                                	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                
                                                                .. attribute:: authorize_id
                                                                
                                                                	authorize id
                                                                	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                
                                                                .. attribute:: bwrem
                                                                
                                                                	bwrem
                                                                	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                
                                                                .. attribute:: cac
                                                                
                                                                	cac
                                                                	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                
                                                                .. attribute:: child_policy
                                                                
                                                                	child policy
                                                                	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                
                                                                .. attribute:: collect_id
                                                                
                                                                	collect id
                                                                	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                
                                                                .. attribute:: copy
                                                                
                                                                	copy
                                                                	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                
                                                                .. attribute:: data_p
                                                                
                                                                	data p
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: deact_template
                                                                
                                                                	deact template
                                                                	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                
                                                                .. attribute:: decode_id
                                                                
                                                                	decode id
                                                                	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                
                                                                .. attribute:: encap
                                                                
                                                                	encap
                                                                	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                
                                                                .. attribute:: flow_parm
                                                                
                                                                	flow parm
                                                                	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                
                                                                .. attribute:: fmm
                                                                
                                                                	fmm
                                                                	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                
                                                                .. attribute:: httpr
                                                                
                                                                	httpr
                                                                	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                
                                                                .. attribute:: ipcbr
                                                                
                                                                	ipcbr
                                                                	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                
                                                                .. attribute:: ipv4_nh
                                                                
                                                                	ipv4 nh
                                                                	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                
                                                                .. attribute:: ipv6_nh
                                                                
                                                                	ipv6 nh
                                                                	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                
                                                                .. attribute:: mark
                                                                
                                                                	mark
                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                
                                                                .. attribute:: mark2
                                                                
                                                                	mark2
                                                                	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                
                                                                .. attribute:: mdi
                                                                
                                                                	mdi
                                                                	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                
                                                                .. attribute:: mdi_rtp
                                                                
                                                                	mdi rtp
                                                                	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                
                                                                .. attribute:: min_bw
                                                                
                                                                	min bw
                                                                	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                
                                                                .. attribute:: out_intf
                                                                
                                                                	out intf
                                                                	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                
                                                                .. attribute:: pbf
                                                                
                                                                	pbf
                                                                	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                
                                                                .. attribute:: pfc
                                                                
                                                                	pfc
                                                                	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                
                                                                .. attribute:: police
                                                                
                                                                	police
                                                                	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                
                                                                .. attribute:: prepaid_cfg
                                                                
                                                                	prepaid cfg
                                                                	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                
                                                                .. attribute:: prio
                                                                
                                                                	prio
                                                                	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                
                                                                .. attribute:: proxy_aaa
                                                                
                                                                	proxy aaa
                                                                	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                
                                                                .. attribute:: punt
                                                                
                                                                	punt
                                                                	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                
                                                                .. attribute:: qlimit
                                                                
                                                                	qlimit
                                                                	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                
                                                                .. attribute:: query_ancp
                                                                
                                                                	query ancp
                                                                	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                
                                                                .. attribute:: redirect
                                                                
                                                                	redirect
                                                                	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                
                                                                .. attribute:: rtp
                                                                
                                                                	rtp
                                                                	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                
                                                                .. attribute:: rtp_j2k
                                                                
                                                                	rtp j2k
                                                                	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                
                                                                .. attribute:: rtp_mmr
                                                                
                                                                	rtp mmr
                                                                	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                
                                                                .. attribute:: rtp_voice
                                                                
                                                                	rtp voice
                                                                	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                
                                                                .. attribute:: serv_func
                                                                
                                                                	serv func
                                                                	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                
                                                                .. attribute:: set_timer
                                                                
                                                                	set timer
                                                                	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                
                                                                .. attribute:: sfrag
                                                                
                                                                	sfrag
                                                                	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                
                                                                .. attribute:: shape
                                                                
                                                                	shape
                                                                	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                
                                                                .. attribute:: stop_timer
                                                                
                                                                	stop timer
                                                                	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                
                                                                .. attribute:: timeout_idle
                                                                
                                                                	timeout idle
                                                                	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                
                                                                .. attribute:: type
                                                                
                                                                	type
                                                                	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                
                                                                .. attribute:: wred
                                                                
                                                                	wred
                                                                	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                    self.yang_name = "actp"
                                                                    self.yang_parent_name = "policy-action-info-st"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                    self._child_list_classes = {}

                                                                    self.data_p = YLeaf(YType.uint32, "data-p")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                    self.accounting_event_aaa.parent = self
                                                                    self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                    self._children_yang_names.add("accounting-event-aaa")

                                                                    self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                    self.acct_aaa_list.parent = self
                                                                    self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                    self._children_yang_names.add("acct-aaa-list")

                                                                    self.act_template = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                    self.act_template.parent = self
                                                                    self._children_name_map["act_template"] = "act-template"
                                                                    self._children_yang_names.add("act-template")

                                                                    self.afm_react = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                    self.afm_react.parent = self
                                                                    self._children_name_map["afm_react"] = "afm-react"
                                                                    self._children_yang_names.add("afm-react")

                                                                    self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                    self.authen_aaa.parent = self
                                                                    self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                    self._children_yang_names.add("authen-aaa")

                                                                    self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                    self.authorize_id.parent = self
                                                                    self._children_name_map["authorize_id"] = "authorize-id"
                                                                    self._children_yang_names.add("authorize-id")

                                                                    self.bwrem = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                    self.bwrem.parent = self
                                                                    self._children_name_map["bwrem"] = "bwrem"
                                                                    self._children_yang_names.add("bwrem")

                                                                    self.cac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                    self.cac.parent = self
                                                                    self._children_name_map["cac"] = "cac"
                                                                    self._children_yang_names.add("cac")

                                                                    self.child_policy = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                    self.child_policy.parent = self
                                                                    self._children_name_map["child_policy"] = "child-policy"
                                                                    self._children_yang_names.add("child-policy")

                                                                    self.collect_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                    self.collect_id.parent = self
                                                                    self._children_name_map["collect_id"] = "collect-id"
                                                                    self._children_yang_names.add("collect-id")

                                                                    self.copy = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                    self.copy.parent = self
                                                                    self._children_name_map["copy"] = "copy"
                                                                    self._children_yang_names.add("copy")

                                                                    self.deact_template = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                    self.deact_template.parent = self
                                                                    self._children_name_map["deact_template"] = "deact-template"
                                                                    self._children_yang_names.add("deact-template")

                                                                    self.decode_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                    self.decode_id.parent = self
                                                                    self._children_name_map["decode_id"] = "decode-id"
                                                                    self._children_yang_names.add("decode-id")

                                                                    self.encap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                    self.encap.parent = self
                                                                    self._children_name_map["encap"] = "encap"
                                                                    self._children_yang_names.add("encap")

                                                                    self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                    self.flow_parm.parent = self
                                                                    self._children_name_map["flow_parm"] = "flow-parm"
                                                                    self._children_yang_names.add("flow-parm")

                                                                    self.fmm = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                    self.fmm.parent = self
                                                                    self._children_name_map["fmm"] = "fmm"
                                                                    self._children_yang_names.add("fmm")

                                                                    self.httpr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                    self.httpr.parent = self
                                                                    self._children_name_map["httpr"] = "httpr"
                                                                    self._children_yang_names.add("httpr")

                                                                    self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                    self.ipcbr.parent = self
                                                                    self._children_name_map["ipcbr"] = "ipcbr"
                                                                    self._children_yang_names.add("ipcbr")

                                                                    self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                    self.ipv4_nh.parent = self
                                                                    self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                    self._children_yang_names.add("ipv4-nh")

                                                                    self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                    self.ipv6_nh.parent = self
                                                                    self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                    self._children_yang_names.add("ipv6-nh")

                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                    self.mark.parent = self
                                                                    self._children_name_map["mark"] = "mark"
                                                                    self._children_yang_names.add("mark")

                                                                    self.mark2 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                    self.mark2.parent = self
                                                                    self._children_name_map["mark2"] = "mark2"
                                                                    self._children_yang_names.add("mark2")

                                                                    self.mdi = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                    self.mdi.parent = self
                                                                    self._children_name_map["mdi"] = "mdi"
                                                                    self._children_yang_names.add("mdi")

                                                                    self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                    self.mdi_rtp.parent = self
                                                                    self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                    self._children_yang_names.add("mdi-rtp")

                                                                    self.min_bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                    self.min_bw.parent = self
                                                                    self._children_name_map["min_bw"] = "min-bw"
                                                                    self._children_yang_names.add("min-bw")

                                                                    self.out_intf = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                    self.out_intf.parent = self
                                                                    self._children_name_map["out_intf"] = "out-intf"
                                                                    self._children_yang_names.add("out-intf")

                                                                    self.pbf = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                    self.pbf.parent = self
                                                                    self._children_name_map["pbf"] = "pbf"
                                                                    self._children_yang_names.add("pbf")

                                                                    self.pfc = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                    self.pfc.parent = self
                                                                    self._children_name_map["pfc"] = "pfc"
                                                                    self._children_yang_names.add("pfc")

                                                                    self.police = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                    self.police.parent = self
                                                                    self._children_name_map["police"] = "police"
                                                                    self._children_yang_names.add("police")

                                                                    self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                    self.prepaid_cfg.parent = self
                                                                    self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                    self._children_yang_names.add("prepaid-cfg")

                                                                    self.prio = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                    self.prio.parent = self
                                                                    self._children_name_map["prio"] = "prio"
                                                                    self._children_yang_names.add("prio")

                                                                    self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                    self.proxy_aaa.parent = self
                                                                    self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                    self._children_yang_names.add("proxy-aaa")

                                                                    self.punt = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                    self.punt.parent = self
                                                                    self._children_name_map["punt"] = "punt"
                                                                    self._children_yang_names.add("punt")

                                                                    self.qlimit = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                    self.qlimit.parent = self
                                                                    self._children_name_map["qlimit"] = "qlimit"
                                                                    self._children_yang_names.add("qlimit")

                                                                    self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                    self.query_ancp.parent = self
                                                                    self._children_name_map["query_ancp"] = "query-ancp"
                                                                    self._children_yang_names.add("query-ancp")

                                                                    self.redirect = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                    self.redirect.parent = self
                                                                    self._children_name_map["redirect"] = "redirect"
                                                                    self._children_yang_names.add("redirect")

                                                                    self.rtp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                    self.rtp.parent = self
                                                                    self._children_name_map["rtp"] = "rtp"
                                                                    self._children_yang_names.add("rtp")

                                                                    self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                    self.rtp_j2k.parent = self
                                                                    self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                    self._children_yang_names.add("rtp-j2k")

                                                                    self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                    self.rtp_mmr.parent = self
                                                                    self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                    self._children_yang_names.add("rtp-mmr")

                                                                    self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                    self.rtp_voice.parent = self
                                                                    self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                    self._children_yang_names.add("rtp-voice")

                                                                    self.serv_func = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                    self.serv_func.parent = self
                                                                    self._children_name_map["serv_func"] = "serv-func"
                                                                    self._children_yang_names.add("serv-func")

                                                                    self.set_timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                    self.set_timer.parent = self
                                                                    self._children_name_map["set_timer"] = "set-timer"
                                                                    self._children_yang_names.add("set-timer")

                                                                    self.sfrag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                    self.sfrag.parent = self
                                                                    self._children_name_map["sfrag"] = "sfrag"
                                                                    self._children_yang_names.add("sfrag")

                                                                    self.shape = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                    self.shape.parent = self
                                                                    self._children_name_map["shape"] = "shape"
                                                                    self._children_yang_names.add("shape")

                                                                    self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                    self.stop_timer.parent = self
                                                                    self._children_name_map["stop_timer"] = "stop-timer"
                                                                    self._children_yang_names.add("stop-timer")

                                                                    self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                    self.timeout_idle.parent = self
                                                                    self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                    self._children_yang_names.add("timeout-idle")

                                                                    self.wred = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                    self.wred.parent = self
                                                                    self._children_name_map["wred"] = "wred"
                                                                    self._children_yang_names.add("wred")
                                                                    self._segment_path = lambda: "actp"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                class AccountingEventAaa(Entity):
                                                                    """
                                                                    accounting event aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: action
                                                                    
                                                                    	action
                                                                    	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                        self.yang_name = "accounting-event-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.action = YLeaf(YType.enumeration, "action")
                                                                        self._segment_path = lambda: "accounting-event-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                class AcctAaaList(Entity):
                                                                    """
                                                                    acct aaa list
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                        self.yang_name = "acct-aaa-list"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.secs = YLeaf(YType.uint32, "secs")
                                                                        self._segment_path = lambda: "acct-aaa-list"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                class ActTemplate(Entity):
                                                                    """
                                                                    act template
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                        self.yang_name = "act-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.template_name = YLeaf(YType.str, "template-name")
                                                                        self._segment_path = lambda: "act-template"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                class AfmReact(Entity):
                                                                    """
                                                                    afm react
                                                                    
                                                                    .. attribute:: action_afmon_react_info
                                                                    
                                                                    	action afmon react info
                                                                    	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                        self.yang_name = "afm-react"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                        self.action_afmon_react_info = YList(self)
                                                                        self._segment_path = lambda: "afm-react"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                    class ActionAfmonReactInfo(Entity):
                                                                        """
                                                                        action afmon react info
                                                                        
                                                                        .. attribute:: alm_grp_thresh
                                                                        
                                                                        	Num/percent in grp
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        	**units**\: percentage
                                                                        
                                                                        .. attribute:: alm_severity
                                                                        
                                                                        	Major\|Minor\|... alarm
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: alm_type
                                                                        
                                                                        	Discrete \| grouped alarm
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: clone_ifh
                                                                        
                                                                        	Clone interface handle
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: criterion
                                                                        
                                                                        	React Criterion
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: description
                                                                        
                                                                        	Describing the oper
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: notif_actns
                                                                        
                                                                        	Bitmap of actions on alert
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: oper_id
                                                                        
                                                                        	React Operation ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: trig_level_1
                                                                        
                                                                        	Trigger threshold 1/lower
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: trig_level_2
                                                                        
                                                                        	Trigger upper threshold for range
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: trig_num_intvls
                                                                        
                                                                        	Averaged over N intvls
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: trig_relop
                                                                        
                                                                        	Trigger LT\|LE\|GT\|GE\|Range
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: trig_type
                                                                        
                                                                        	Immediate or averaged thresh trigger
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                            self.yang_name = "action-afmon-react-info"
                                                                            self.yang_parent_name = "afm-react"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                            self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                            self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                            self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                            self.criterion = YLeaf(YType.uint8, "criterion")

                                                                            self.description = YLeaf(YType.str, "description")

                                                                            self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                            self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                            self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                            self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                            self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                            self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                            self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                            self._segment_path = lambda: "action-afmon-react-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                class AuthenAaa(Entity):
                                                                    """
                                                                    authen aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: authen_password
                                                                    
                                                                    	authen password
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                        self.yang_name = "authen-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.authen_password = YLeaf(YType.str, "authen-password")
                                                                        self._segment_path = lambda: "authen-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                class AuthorizeId(Entity):
                                                                    """
                                                                    authorize id
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: password
                                                                    
                                                                    	password
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                        self.yang_name = "authorize-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.format_name = YLeaf(YType.str, "format-name")

                                                                        self.id = YLeaf(YType.uint8, "id")

                                                                        self.password = YLeaf(YType.str, "password")
                                                                        self._segment_path = lambda: "authorize-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                class Bwrem(Entity):
                                                                    """
                                                                    bwrem
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                        self.yang_name = "bwrem"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                        self._child_list_classes = {}

                                                                        self.bwrem = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")
                                                                        self._segment_path = lambda: "bwrem"


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "bwrem"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bwrem"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                class Cac(Entity):
                                                                    """
                                                                    cac
                                                                    
                                                                    .. attribute:: cac_type
                                                                    
                                                                    	cac type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: flow_rate
                                                                    
                                                                    	flow rate
                                                                    	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                    
                                                                    .. attribute:: idle_timeout
                                                                    
                                                                    	idle timeout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                        self.yang_name = "cac"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                        self._child_list_classes = {}

                                                                        self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                        self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                        self.flow_rate.parent = self
                                                                        self._children_name_map["flow_rate"] = "flow-rate"
                                                                        self._children_yang_names.add("flow-rate")

                                                                        self.rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._children_yang_names.add("rate")
                                                                        self._segment_path = lambda: "cac"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                    class FlowRate(Entity):
                                                                        """
                                                                        flow rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                            self.yang_name = "flow-rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "flow-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "cac"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                class ChildPolicy(Entity):
                                                                    """
                                                                    child policy
                                                                    
                                                                    .. attribute:: enc
                                                                    
                                                                    	enc
                                                                    	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                    
                                                                    .. attribute:: hd_info
                                                                    
                                                                    	hd info
                                                                    	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                    
                                                                    .. attribute:: info
                                                                    
                                                                    	info
                                                                    	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                        self.yang_name = "child-policy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                        self._child_list_classes = {}

                                                                        self.enc = YLeaf(YType.enumeration, "enc")

                                                                        self.hd_info = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                        self.hd_info.parent = self
                                                                        self._children_name_map["hd_info"] = "hd-info"
                                                                        self._children_yang_names.add("hd-info")

                                                                        self.info = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                        self.info.parent = self
                                                                        self._children_name_map["info"] = "info"
                                                                        self._children_yang_names.add("info")
                                                                        self._segment_path = lambda: "child-policy"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                    class HdInfo(Entity):
                                                                        """
                                                                        hd info
                                                                        
                                                                        .. attribute:: data_hd
                                                                        
                                                                        	data hd
                                                                        	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                            self.yang_name = "hd-info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                            self._child_list_classes = {}

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.data_hd = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                            self.data_hd.parent = self
                                                                            self._children_name_map["data_hd"] = "data-hd"
                                                                            self._children_yang_names.add("data-hd")
                                                                            self._segment_path = lambda: "hd-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                        class DataHd(Entity):
                                                                            """
                                                                            data hd
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                self.yang_name = "data-hd"
                                                                                self.yang_parent_name = "hd-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}
                                                                                self._segment_path = lambda: "data-hd"


                                                                    class Info(Entity):
                                                                        """
                                                                        info
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                            self.yang_name = "info"
                                                                            self.yang_parent_name = "child-policy"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")

                                                                            self.type = YLeaf(YType.enumeration, "type")
                                                                            self._segment_path = lambda: "info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                class CollectId(Entity):
                                                                    """
                                                                    collect id
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                        self.yang_name = "collect-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.id = YLeaf(YType.enumeration, "id")
                                                                        self._segment_path = lambda: "collect-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                class Copy(Entity):
                                                                    """
                                                                    copy
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: num_byte
                                                                    
                                                                    	number of bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node url
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                        self.yang_name = "copy"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.app_id = YLeaf(YType.uint32, "app-id")

                                                                        self.local_id = YLeaf(YType.uint32, "local-id")

                                                                        self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                        self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                        self.sn_name = YLeaf(YType.str, "sn-name")

                                                                        self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                        self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                        self._segment_path = lambda: "copy"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                class DeactTemplate(Entity):
                                                                    """
                                                                    deact template
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: template_name
                                                                    
                                                                    	template name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                        self.yang_name = "deact-template"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.template_name = YLeaf(YType.str, "template-name")
                                                                        self._segment_path = lambda: "deact-template"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                class DecodeId(Entity):
                                                                    """
                                                                    decode id
                                                                    
                                                                    .. attribute:: format_name
                                                                    
                                                                    	format name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: id
                                                                    
                                                                    	id
                                                                    	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                        self.yang_name = "decode-id"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.format_name = YLeaf(YType.str, "format-name")

                                                                        self.id = YLeaf(YType.enumeration, "id")
                                                                        self._segment_path = lambda: "decode-id"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                class Encap(Entity):
                                                                    """
                                                                    encap
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                        self.yang_name = "encap"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.seq = YLeaf(YType.uint8, "seq")
                                                                        self._segment_path = lambda: "encap"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                class FlowParm(Entity):
                                                                    """
                                                                    flow parm
                                                                    
                                                                    .. attribute:: flow_timeout
                                                                    
                                                                    	timeout in secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    .. attribute:: intvl_hist
                                                                    
                                                                    	num intervals of data stored on rtr
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_mon_flows
                                                                    
                                                                    	max simult flows monitored per policy class
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: mon_interval
                                                                    
                                                                    	monitored interval duration in secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: second
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                        self.yang_name = "flow-parm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                        self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                        self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                        self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                        self._segment_path = lambda: "flow-parm"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                class Fmm(Entity):
                                                                    """
                                                                    fmm
                                                                    
                                                                    .. attribute:: fmm_name
                                                                    
                                                                    	flow monitor name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..33
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                        self.yang_name = "fmm"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                        self._segment_path = lambda: "fmm"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                class Httpr(Entity):
                                                                    """
                                                                    httpr
                                                                    
                                                                    .. attribute:: redirect_url
                                                                    
                                                                    	redirect url
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                        self.yang_name = "httpr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                        self._segment_path = lambda: "httpr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                class Ipcbr(Entity):
                                                                    """
                                                                    ipcbr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: media_bit_rate
                                                                    
                                                                    	media data rate in bps
                                                                    	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                    
                                                                    .. attribute:: media_pkt_size
                                                                    
                                                                    	media packet size in bytes
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    	**units**\: byte
                                                                    
                                                                    .. attribute:: media_pkts_per_ip
                                                                    
                                                                    	media packets per ip pkt
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                        self.yang_name = "ipcbr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                        self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")

                                                                        self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                        self.media_bit_rate.parent = self
                                                                        self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                        self._children_yang_names.add("media-bit-rate")
                                                                        self._segment_path = lambda: "ipcbr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MediaBitRate(Entity):
                                                                        """
                                                                        media data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                            self.yang_name = "media-bit-rate"
                                                                            self.yang_parent_name = "ipcbr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "media-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                class Ipv4Nh(Entity):
                                                                    """
                                                                    ipv4 nh
                                                                    
                                                                    .. attribute:: action_ipv4_nh_info_array
                                                                    
                                                                    	action ipv4 nh info array
                                                                    	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                        self.yang_name = "ipv4-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                        self.action_ipv4_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv4-nh"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                    class ActionIpv4NhInfoArray(Entity):
                                                                        """
                                                                        action ipv4 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	nh addr
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv4-nh-info-array"
                                                                            self.yang_parent_name = "ipv4-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                            self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                            self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Ipv6Nh(Entity):
                                                                    """
                                                                    ipv6 nh
                                                                    
                                                                    .. attribute:: action_ipv6_nh_info_array
                                                                    
                                                                    	action ipv6 nh info array
                                                                    	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                        self.yang_name = "ipv6-nh"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                        self.action_ipv6_nh_info_array = YList(self)
                                                                        self._segment_path = lambda: "ipv6-nh"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                    class ActionIpv6NhInfoArray(Entity):
                                                                        """
                                                                        action ipv6 nh info array
                                                                        
                                                                        .. attribute:: nh_addr
                                                                        
                                                                        	IPV6 Address
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: vrf_name
                                                                        
                                                                        	Vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                            self.yang_name = "action-ipv6-nh-info-array"
                                                                            self.yang_parent_name = "ipv6-nh"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                            self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                            self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                class Mark(Entity):
                                                                    """
                                                                    mark
                                                                    
                                                                    .. attribute:: action_mark_info
                                                                    
                                                                    	action mark info
                                                                    	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                        self.yang_name = "mark"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                        self.action_mark_info = YList(self)
                                                                        self._segment_path = lambda: "mark"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                    class ActionMarkInfo(Entity):
                                                                        """
                                                                        action mark info
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                            self.yang_name = "action-mark-info"
                                                                            self.yang_parent_name = "mark"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                            self._segment_path = lambda: "action-mark-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                class Mark2(Entity):
                                                                    """
                                                                    mark2
                                                                    
                                                                    .. attribute:: action_mark2_info
                                                                    
                                                                    	action mark2 info
                                                                    	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                        self.yang_name = "mark2"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                        self.action_mark2_info = YList(self)
                                                                        self._segment_path = lambda: "mark2"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                    class ActionMark2Info(Entity):
                                                                        """
                                                                        action mark2 info
                                                                        
                                                                        .. attribute:: mark_flags
                                                                        
                                                                        	mark flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: value_overflow
                                                                        
                                                                        	value overflow
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                            self.yang_name = "action-mark2-info"
                                                                            self.yang_parent_name = "mark2"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")

                                                                            self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                            self._segment_path = lambda: "action-mark2-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                class Mdi(Entity):
                                                                    """
                                                                    mdi
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\:  list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                        self.yang_name = "mdi"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.pids = YLeafList(YType.uint32, "pids")

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")
                                                                        self._segment_path = lambda: "mdi"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                class MdiRtp(Entity):
                                                                    """
                                                                    mdi rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: filtered_pkt_rate
                                                                    
                                                                    	filtered packet rate
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: ip_bit_rate
                                                                    
                                                                    	data rate in bps
                                                                    	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                    
                                                                    .. attribute:: ip_pkt_rate
                                                                    
                                                                    	packet rate in pps
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pids
                                                                    
                                                                    	array of monitoredcd  pids
                                                                    	**type**\:  list of int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                        self.yang_name = "mdi-rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                        self._child_list_classes = {}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                        self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                        self.pids = YLeafList(YType.uint32, "pids")

                                                                        self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                        self.ip_bit_rate.parent = self
                                                                        self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                        self._children_yang_names.add("ip-bit-rate")
                                                                        self._segment_path = lambda: "mdi-rtp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                    class IpBitRate(Entity):
                                                                        """
                                                                        data rate in bps
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                            self.yang_name = "ip-bit-rate"
                                                                            self.yang_parent_name = "mdi-rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "ip-bit-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                class MinBw(Entity):
                                                                    """
                                                                    min bw
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                        self.yang_name = "min-bw"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                        self._child_list_classes = {}

                                                                        self.bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._children_yang_names.add("bw")
                                                                        self._segment_path = lambda: "min-bw"


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "min-bw"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bw"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                class OutIntf(Entity):
                                                                    """
                                                                    out intf
                                                                    
                                                                    .. attribute:: out_ifname
                                                                    
                                                                    	output interface name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                        self.yang_name = "out-intf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                        self._segment_path = lambda: "out-intf"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                class Pbf(Entity):
                                                                    """
                                                                    pbf
                                                                    
                                                                    .. attribute:: action_pbf_info_array
                                                                    
                                                                    	action pbf info array
                                                                    	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                        self.yang_name = "pbf"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                        self.action_pbf_info_array = YList(self)
                                                                        self._segment_path = lambda: "pbf"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                    class ActionPbfInfoArray(Entity):
                                                                        """
                                                                        action pbf info array
                                                                        
                                                                        .. attribute:: addr
                                                                        
                                                                        	v4 or v6 address
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                        
                                                                        .. attribute:: rt
                                                                        
                                                                        	route target
                                                                        	**type**\:  str
                                                                        
                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                        
                                                                        .. attribute:: rt_type
                                                                        
                                                                        	route target type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vrf
                                                                        
                                                                        	vrf name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                            self.yang_name = "action-pbf-info-array"
                                                                            self.yang_parent_name = "pbf"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.addr = YLeaf(YType.str, "addr")

                                                                            self.rt = YLeaf(YType.str, "rt")

                                                                            self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                            self.vrf = YLeaf(YType.str, "vrf")
                                                                            self._segment_path = lambda: "action-pbf-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                class Pfc(Entity):
                                                                    """
                                                                    pfc
                                                                    
                                                                    .. attribute:: buffer_size
                                                                    
                                                                    	buffer size
                                                                    	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                    
                                                                    .. attribute:: buffer_size_flag
                                                                    
                                                                    	buffer size flag
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: pause_threshold
                                                                    
                                                                    	pause threshold
                                                                    	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                    
                                                                    .. attribute:: pfc_pause_set
                                                                    
                                                                    	pfc pause set
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: resume_threshold
                                                                    
                                                                    	resume threshold
                                                                    	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                        self.yang_name = "pfc"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                        self._child_list_classes = {}

                                                                        self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                        self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                        self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                        self.buffer_size.parent = self
                                                                        self._children_name_map["buffer_size"] = "buffer-size"
                                                                        self._children_yang_names.add("buffer-size")

                                                                        self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                        self.pause_threshold.parent = self
                                                                        self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                        self._children_yang_names.add("pause-threshold")

                                                                        self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                        self.resume_threshold.parent = self
                                                                        self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                        self._children_yang_names.add("resume-threshold")
                                                                        self._segment_path = lambda: "pfc"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                    class BufferSize(Entity):
                                                                        """
                                                                        buffer size
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                            self.yang_name = "buffer-size"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "buffer-size"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                    class PauseThreshold(Entity):
                                                                        """
                                                                        pause threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                            self.yang_name = "pause-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "pause-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                    class ResumeThreshold(Entity):
                                                                        """
                                                                        resume threshold
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                            self.yang_name = "resume-threshold"
                                                                            self.yang_parent_name = "pfc"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "resume-threshold"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                class Police(Entity):
                                                                    """
                                                                    police
                                                                    
                                                                    .. attribute:: burst
                                                                    
                                                                    	burst
                                                                    	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                    
                                                                    .. attribute:: cdvt
                                                                    
                                                                    	cdvt
                                                                    	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                    
                                                                    .. attribute:: confclass_encode
                                                                    
                                                                    	confclass encode
                                                                    	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                    
                                                                    .. attribute:: confclass_p
                                                                    
                                                                    	confclass p
                                                                    	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                    
                                                                    .. attribute:: conform_actns
                                                                    
                                                                    	conform actns
                                                                    	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                    
                                                                    .. attribute:: excdclass_encode
                                                                    
                                                                    	excdclass encode
                                                                    	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                    
                                                                    .. attribute:: excdclass_p
                                                                    
                                                                    	excdclass p
                                                                    	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                    
                                                                    .. attribute:: exceed_actns
                                                                    
                                                                    	exceed actns
                                                                    	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: peak_burst
                                                                    
                                                                    	peak burst
                                                                    	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                    
                                                                    .. attribute:: peak_rate
                                                                    
                                                                    	peak rate
                                                                    	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                    
                                                                    .. attribute:: police_flags
                                                                    
                                                                    	police flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: rate
                                                                    
                                                                    	rate
                                                                    	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                    
                                                                    .. attribute:: sbuck_name
                                                                    
                                                                    	sbuck name
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: sbuck_type
                                                                    
                                                                    	sbuck type
                                                                    	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                    
                                                                    .. attribute:: violate_actns
                                                                    
                                                                    	violate actns
                                                                    	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                        self.yang_name = "police"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"burst" : ("burst", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                        self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                        self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                        self.burst = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                        self.burst.parent = self
                                                                        self._children_name_map["burst"] = "burst"
                                                                        self._children_yang_names.add("burst")

                                                                        self.cdvt = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                        self.cdvt.parent = self
                                                                        self._children_name_map["cdvt"] = "cdvt"
                                                                        self._children_yang_names.add("cdvt")

                                                                        self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                        self.confclass_encode.parent = self
                                                                        self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                        self._children_yang_names.add("confclass-encode")

                                                                        self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                        self.confclass_p.parent = self
                                                                        self._children_name_map["confclass_p"] = "confclass-p"
                                                                        self._children_yang_names.add("confclass-p")

                                                                        self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                        self.conform_actns.parent = self
                                                                        self._children_name_map["conform_actns"] = "conform-actns"
                                                                        self._children_yang_names.add("conform-actns")

                                                                        self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                        self.excdclass_encode.parent = self
                                                                        self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                        self._children_yang_names.add("excdclass-encode")

                                                                        self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                        self.excdclass_p.parent = self
                                                                        self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                        self._children_yang_names.add("excdclass-p")

                                                                        self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                        self.exceed_actns.parent = self
                                                                        self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                        self._children_yang_names.add("exceed-actns")

                                                                        self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                        self.peak_burst.parent = self
                                                                        self._children_name_map["peak_burst"] = "peak-burst"
                                                                        self._children_yang_names.add("peak-burst")

                                                                        self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                        self.peak_rate.parent = self
                                                                        self._children_name_map["peak_rate"] = "peak-rate"
                                                                        self._children_yang_names.add("peak-rate")

                                                                        self.rate = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                        self.rate.parent = self
                                                                        self._children_name_map["rate"] = "rate"
                                                                        self._children_yang_names.add("rate")

                                                                        self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                        self.violate_actns.parent = self
                                                                        self._children_name_map["violate_actns"] = "violate-actns"
                                                                        self._children_yang_names.add("violate-actns")
                                                                        self._segment_path = lambda: "police"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                    class Burst(Entity):
                                                                        """
                                                                        burst
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                            self.yang_name = "burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "burst"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                    class Cdvt(Entity):
                                                                        """
                                                                        cdvt
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                            self.yang_name = "cdvt"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "cdvt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                    class ConfclassEncode(Entity):
                                                                        """
                                                                        confclass encode
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                            self.yang_name = "confclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                            self._child_list_classes = {}

                                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._children_yang_names.add("inline-cmap")
                                                                            self._segment_path = lambda: "confclass-encode"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "confclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "inline-cmap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ConfclassP(Entity):
                                                                        """
                                                                        confclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                            self.yang_name = "confclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "confclass-p"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "confclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "class-map-bg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ConformActns(Entity):
                                                                        """
                                                                        conform actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                            self.yang_name = "conform-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "conform-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "conform-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class ExcdclassEncode(Entity):
                                                                        """
                                                                        excdclass encode
                                                                        
                                                                        .. attribute:: class_name
                                                                        
                                                                        	class name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd
                                                                        
                                                                        	hd
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..18446744073709551615
                                                                        
                                                                        .. attribute:: idx
                                                                        
                                                                        	idx
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: inline_cmap
                                                                        
                                                                        	inline cmap
                                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                            self.yang_name = "excdclass-encode"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                            self._child_list_classes = {}

                                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                            self.inline_cmap.parent = self
                                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                            self._children_yang_names.add("inline-cmap")
                                                                            self._segment_path = lambda: "excdclass-encode"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                        class InlineCmap(Entity):
                                                                            """
                                                                            inline cmap
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Inline Class\-Map flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_count
                                                                            
                                                                            	Number of Match infos
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Inline Class\-Map Mode Match any/all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                self.yang_name = "inline-cmap"
                                                                                self.yang_parent_name = "excdclass-encode"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "inline-cmap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "inline-cmap"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ExcdclassP(Entity):
                                                                        """
                                                                        excdclass p
                                                                        
                                                                        .. attribute:: class_map_bg
                                                                        
                                                                        	class map bg
                                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                            self.yang_name = "excdclass-p"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                            self.class_map_bg = YList(self)
                                                                            self._segment_path = lambda: "excdclass-p"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                        class ClassMapBg(Entity):
                                                                            """
                                                                            class map bg
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	description
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: match_infop
                                                                            
                                                                            	Pointer to the first Match info
                                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                            
                                                                            .. attribute:: mode
                                                                            
                                                                            	Class\-Map Mode Match any/Match all
                                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Name of the class\-map
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                self.yang_name = "class-map-bg"
                                                                                self.yang_parent_name = "excdclass-p"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                self._child_list_classes = {}

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                self.match_infop.parent = self
                                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                                self._children_yang_names.add("match-infop")
                                                                                self._segment_path = lambda: "class-map-bg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                            class MatchInfop(Entity):
                                                                                """
                                                                                Pointer to the first Match info
                                                                                
                                                                                .. attribute:: class_match_info_st
                                                                                
                                                                                	class match info st
                                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                    self.yang_name = "match-infop"
                                                                                    self.yang_parent_name = "class-map-bg"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                    self.class_match_info_st = YList(self)
                                                                                    self._segment_path = lambda: "match-infop"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                class ClassMatchInfoSt(Entity):
                                                                                    """
                                                                                    class match info st
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_data
                                                                                    
                                                                                    	Match criteria
                                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                        self.yang_name = "class-match-info-st"
                                                                                        self.yang_parent_name = "match-infop"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                        self.match_data.parent = self
                                                                                        self._children_name_map["match_data"] = "match-data"
                                                                                        self._children_yang_names.add("match-data")
                                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                    class MatchData(Entity):
                                                                                        """
                                                                                        Match criteria
                                                                                        
                                                                                        .. attribute:: access_interface
                                                                                        
                                                                                        	Access interface
                                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                        
                                                                                        .. attribute:: atm_clp
                                                                                        
                                                                                        	Match ATM CLP level
                                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                        
                                                                                        .. attribute:: auth_domain
                                                                                        
                                                                                        	Authenticated domain name
                                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                        
                                                                                        .. attribute:: auth_domain_regex
                                                                                        
                                                                                        	Authenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: auth_username
                                                                                        
                                                                                        	Authenticated User Name
                                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                        
                                                                                        .. attribute:: auth_username_regex
                                                                                        
                                                                                        	Authenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: authen_status
                                                                                        
                                                                                        	Authentication Status
                                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                        
                                                                                        .. attribute:: avail_id
                                                                                        
                                                                                        	Available Identifiers
                                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                        
                                                                                        .. attribute:: circuit_id
                                                                                        
                                                                                        	Circuit ID
                                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                        
                                                                                        .. attribute:: circuit_id_regex
                                                                                        
                                                                                        	Circuit ID RegEx
                                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                        
                                                                                        .. attribute:: cos
                                                                                        
                                                                                        	Match CoS array
                                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                        
                                                                                        .. attribute:: cos_inr
                                                                                        
                                                                                        	Match inner header CoS
                                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                        
                                                                                        .. attribute:: dei
                                                                                        
                                                                                        	Match DEI Bit
                                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                        
                                                                                        .. attribute:: dei_inr
                                                                                        
                                                                                        	Match inner DEI Bit
                                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id
                                                                                        
                                                                                        	Dhcp Client ID
                                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                        
                                                                                        .. attribute:: dhcp_client_id_regex
                                                                                        
                                                                                        	Dhcp Client ID RegEx
                                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                        
                                                                                        .. attribute:: discard_class
                                                                                        
                                                                                        	Match Discard Class array
                                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                        
                                                                                        .. attribute:: dnis
                                                                                        
                                                                                        	DNIS
                                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                        
                                                                                        .. attribute:: dnis_regex
                                                                                        
                                                                                        	DNIS Regular Expression
                                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                        
                                                                                        .. attribute:: domain
                                                                                        
                                                                                        	Domain Name
                                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                        
                                                                                        .. attribute:: domain_regex
                                                                                        
                                                                                        	Domain Regular Expression
                                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                        
                                                                                        .. attribute:: dscp
                                                                                        
                                                                                        	Match DSCP range array
                                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv4
                                                                                        
                                                                                        	Destination Address IPV4
                                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: dst_addr_ipv6
                                                                                        
                                                                                        	Destination Address IPV6
                                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: dst_mac
                                                                                        
                                                                                        	Match Destination MAC address
                                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                        
                                                                                        .. attribute:: dst_port
                                                                                        
                                                                                        	Destination port
                                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                        
                                                                                        .. attribute:: ether_service_acl
                                                                                        
                                                                                        	Ethernet\-Services Access\-list
                                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                        
                                                                                        .. attribute:: ethertype
                                                                                        
                                                                                        	Ethernet type
                                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                        
                                                                                        .. attribute:: flow_key_data
                                                                                        
                                                                                        	Flow key structure
                                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                        
                                                                                        .. attribute:: flow_tag
                                                                                        
                                                                                        	Match flow\-tag array
                                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                        
                                                                                        .. attribute:: fr_de
                                                                                        
                                                                                        	Match FR DE value
                                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                        
                                                                                        .. attribute:: fr_dlci
                                                                                        
                                                                                        	Match FR DLCI range array
                                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                        
                                                                                        .. attribute:: fragment_type
                                                                                        
                                                                                        	Fragment type
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: icmp_v4
                                                                                        
                                                                                        	Match ICMPV4 Protocol
                                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                        
                                                                                        .. attribute:: icmp_v6
                                                                                        
                                                                                        	Match ICMPV6 Protocol array
                                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                        
                                                                                        .. attribute:: icmpv4_code
                                                                                        
                                                                                        	Match ipv4 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                        
                                                                                        .. attribute:: icmpv4_type
                                                                                        
                                                                                        	Match ipv4 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                        
                                                                                        .. attribute:: icmpv6_code
                                                                                        
                                                                                        	Match ipv6 icmp code
                                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                        
                                                                                        .. attribute:: icmpv6_type
                                                                                        
                                                                                        	Match ipv6 icmp type
                                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                        
                                                                                        .. attribute:: input_interface
                                                                                        
                                                                                        	Input interface
                                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                        
                                                                                        .. attribute:: input_intfhdl
                                                                                        
                                                                                        	Input interface handle
                                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                        
                                                                                        .. attribute:: ipv4_acl
                                                                                        
                                                                                        	IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                        
                                                                                        .. attribute:: ipv4_dscp
                                                                                        
                                                                                        	IPv4 DSCP
                                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv4_packet_len
                                                                                        
                                                                                        	IPv4 packet length array
                                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv4_prec
                                                                                        
                                                                                        	IPv4 Precedence
                                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                        
                                                                                        .. attribute:: ipv6_acl
                                                                                        
                                                                                        	IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                        
                                                                                        .. attribute:: ipv6_dscp
                                                                                        
                                                                                        	IPv6 DSCP
                                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                        
                                                                                        .. attribute:: ipv6_packet_len
                                                                                        
                                                                                        	IPv6 packet length array
                                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                        
                                                                                        .. attribute:: ipv6_prec
                                                                                        
                                                                                        	IPv6 Precedence
                                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                        
                                                                                        .. attribute:: media_type
                                                                                        
                                                                                        	Media Type
                                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                        
                                                                                        .. attribute:: mlp_negotiated
                                                                                        
                                                                                        	MLP Negotiated
                                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                                        
                                                                                        	MPLS Disposition IPv4 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                                        
                                                                                        	MPLS Disposition IPv6 Access\-list
                                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                        
                                                                                        .. attribute:: mpls_exp
                                                                                        
                                                                                        	Match MPLS experimental topmost array
                                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                        
                                                                                        .. attribute:: mpls_exp_imp
                                                                                        
                                                                                        	Match MPLS experimental imposition array
                                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                        
                                                                                        .. attribute:: mpls_top_eos
                                                                                        
                                                                                        	MPLS Topmost EOS
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: mpls_top_label
                                                                                        
                                                                                        	MPLS Topmost LABEL
                                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                        
                                                                                        .. attribute:: nas_port
                                                                                        
                                                                                        	NAS Port
                                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                        
                                                                                        .. attribute:: packet_len
                                                                                        
                                                                                        	Match packet length array
                                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                        
                                                                                        .. attribute:: prec
                                                                                        
                                                                                        	Match Precedence array
                                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                        
                                                                                        .. attribute:: proto
                                                                                        
                                                                                        	Match Protocol array
                                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                        
                                                                                        .. attribute:: qos_group
                                                                                        
                                                                                        	Match QoS group array
                                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                        
                                                                                        .. attribute:: remote_id
                                                                                        
                                                                                        	Remote ID
                                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                        
                                                                                        .. attribute:: remote_id_regex
                                                                                        
                                                                                        	Remote ID RegEx
                                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                        
                                                                                        .. attribute:: service_name
                                                                                        
                                                                                        	Service Name
                                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                        
                                                                                        .. attribute:: service_name_regex
                                                                                        
                                                                                        	Service Name Regular Exp
                                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv4
                                                                                        
                                                                                        	Source Address IPV4
                                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                        
                                                                                        .. attribute:: src_addr_ipv6
                                                                                        
                                                                                        	Source Address IPV6
                                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                        
                                                                                        .. attribute:: src_addr_mac
                                                                                        
                                                                                        	Source Address MAC
                                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                        
                                                                                        .. attribute:: src_mac
                                                                                        
                                                                                        	Match Source MAC address
                                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                        
                                                                                        .. attribute:: src_port
                                                                                        
                                                                                        	Source port
                                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                        
                                                                                        .. attribute:: subs_protocol
                                                                                        
                                                                                        	Protocol
                                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                        
                                                                                        .. attribute:: tcp_flag
                                                                                        
                                                                                        	Match tcp flag value
                                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                        
                                                                                        .. attribute:: timer
                                                                                        
                                                                                        	Timer
                                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                        
                                                                                        .. attribute:: timer_regexp
                                                                                        
                                                                                        	Timer Regular Expression
                                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                        
                                                                                        .. attribute:: traffic_class
                                                                                        
                                                                                        	Match Traffic class array
                                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                        
                                                                                        .. attribute:: tunnel_name
                                                                                        
                                                                                        	Tunnel Name
                                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                        
                                                                                        .. attribute:: tunnel_name_regex
                                                                                        
                                                                                        	Tunnel Name Regular Expression
                                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                        
                                                                                        .. attribute:: unauth_domain
                                                                                        
                                                                                        	Unauthenticated Domain Name
                                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                        
                                                                                        .. attribute:: unauth_domain_regex
                                                                                        
                                                                                        	Unauthenticated Domain Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                        
                                                                                        .. attribute:: unauth_username
                                                                                        
                                                                                        	Unauthenticated User Name
                                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                        
                                                                                        .. attribute:: unauth_username_regex
                                                                                        
                                                                                        	Unauthenticated User Name RegEx
                                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                        
                                                                                        .. attribute:: user_name
                                                                                        
                                                                                        	User Name
                                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                        
                                                                                        .. attribute:: user_name_regex
                                                                                        
                                                                                        	User Name Regular Expression
                                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                        
                                                                                        .. attribute:: vendor_id
                                                                                        
                                                                                        	Vendor ID
                                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                        
                                                                                        .. attribute:: vendor_id_regex
                                                                                        
                                                                                        	Vendor ID RegEx
                                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                        
                                                                                        .. attribute:: vlan
                                                                                        
                                                                                        	Match VLAN array
                                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                        
                                                                                        .. attribute:: vlan_inr
                                                                                        
                                                                                        	Match inner header VLAN range array
                                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                            self.yang_name = "match-data"
                                                                                            self.yang_parent_name = "class-match-info-st"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                            self._child_list_classes = {}

                                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                            self.access_interface.parent = self
                                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                                            self._children_yang_names.add("access-interface")

                                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                            self.atm_clp.parent = self
                                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                                            self._children_yang_names.add("atm-clp")

                                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                            self.auth_domain.parent = self
                                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                                            self._children_yang_names.add("auth-domain")

                                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                            self.auth_domain_regex.parent = self
                                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                            self.auth_username.parent = self
                                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                                            self._children_yang_names.add("auth-username")

                                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                            self.auth_username_regex.parent = self
                                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                            self._children_yang_names.add("auth-username-regex")

                                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                            self.avail_id.parent = self
                                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                                            self._children_yang_names.add("avail-id")

                                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                            self.circuit_id.parent = self
                                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                                            self._children_yang_names.add("circuit-id")

                                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                            self.circuit_id_regex.parent = self
                                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                            self.cos.parent = self
                                                                                            self._children_name_map["cos"] = "cos"
                                                                                            self._children_yang_names.add("cos")

                                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                            self.cos_inr.parent = self
                                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                                            self._children_yang_names.add("cos-inr")

                                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                            self.dei.parent = self
                                                                                            self._children_name_map["dei"] = "dei"
                                                                                            self._children_yang_names.add("dei")

                                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                            self.dei_inr.parent = self
                                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                                            self._children_yang_names.add("dei-inr")

                                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                            self.dhcp_client_id.parent = self
                                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                            self.dhcp_client_id_regex.parent = self
                                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                            self.discard_class.parent = self
                                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                                            self._children_yang_names.add("discard-class")

                                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                            self.dnis.parent = self
                                                                                            self._children_name_map["dnis"] = "dnis"
                                                                                            self._children_yang_names.add("dnis")

                                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                            self.dnis_regex.parent = self
                                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                            self._children_yang_names.add("dnis-regex")

                                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                            self.domain.parent = self
                                                                                            self._children_name_map["domain"] = "domain"
                                                                                            self._children_yang_names.add("domain")

                                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                            self.domain_regex.parent = self
                                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                                            self._children_yang_names.add("domain-regex")

                                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                            self.dscp.parent = self
                                                                                            self._children_name_map["dscp"] = "dscp"
                                                                                            self._children_yang_names.add("dscp")

                                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                            self.dst_addr_ipv4.parent = self
                                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                            self.dst_addr_ipv6.parent = self
                                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                            self.dst_mac.parent = self
                                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                                            self._children_yang_names.add("dst-mac")

                                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                            self.dst_port.parent = self
                                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                                            self._children_yang_names.add("dst-port")

                                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                            self.ether_service_acl.parent = self
                                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                            self._children_yang_names.add("ether-service-acl")

                                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                            self.ethertype.parent = self
                                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                                            self._children_yang_names.add("ethertype")

                                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                            self.flow_key_data.parent = self
                                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                            self._children_yang_names.add("flow-key-data")

                                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                            self.flow_tag.parent = self
                                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                                            self._children_yang_names.add("flow-tag")

                                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                            self.fr_de.parent = self
                                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                                            self._children_yang_names.add("fr-de")

                                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                            self.fr_dlci.parent = self
                                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                            self._children_yang_names.add("fr-dlci")

                                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                            self.icmp_v4.parent = self
                                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                            self._children_yang_names.add("icmp-v4")

                                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                            self.icmp_v6.parent = self
                                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                            self._children_yang_names.add("icmp-v6")

                                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                            self.icmpv4_code.parent = self
                                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                            self._children_yang_names.add("icmpv4-code")

                                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                            self.icmpv4_type.parent = self
                                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                            self._children_yang_names.add("icmpv4-type")

                                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                            self.icmpv6_code.parent = self
                                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                            self._children_yang_names.add("icmpv6-code")

                                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                            self.icmpv6_type.parent = self
                                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                            self._children_yang_names.add("icmpv6-type")

                                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                            self.input_interface.parent = self
                                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                                            self._children_yang_names.add("input-interface")

                                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                            self.input_intfhdl.parent = self
                                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                            self._children_yang_names.add("input-intfhdl")

                                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                            self.ipv4_acl.parent = self
                                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                            self._children_yang_names.add("ipv4-acl")

                                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                            self.ipv4_dscp.parent = self
                                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                            self.ipv4_packet_len.parent = self
                                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                            self.ipv4_prec.parent = self
                                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                            self._children_yang_names.add("ipv4-prec")

                                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                            self.ipv6_acl.parent = self
                                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                            self._children_yang_names.add("ipv6-acl")

                                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                            self.ipv6_dscp.parent = self
                                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                            self.ipv6_packet_len.parent = self
                                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                            self.ipv6_prec.parent = self
                                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                            self._children_yang_names.add("ipv6-prec")

                                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                            self.media_type.parent = self
                                                                                            self._children_name_map["media_type"] = "media-type"
                                                                                            self._children_yang_names.add("media-type")

                                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                            self.mpls_exp.parent = self
                                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                            self._children_yang_names.add("mpls-exp")

                                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                            self.mpls_exp_imp.parent = self
                                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                            self.mpls_top_label.parent = self
                                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                            self._children_yang_names.add("mpls-top-label")

                                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                            self.nas_port.parent = self
                                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                                            self._children_yang_names.add("nas-port")

                                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                            self.packet_len.parent = self
                                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                                            self._children_yang_names.add("packet-len")

                                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                            self.prec.parent = self
                                                                                            self._children_name_map["prec"] = "prec"
                                                                                            self._children_yang_names.add("prec")

                                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                            self.proto.parent = self
                                                                                            self._children_name_map["proto"] = "proto"
                                                                                            self._children_yang_names.add("proto")

                                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                            self.qos_group.parent = self
                                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                                            self._children_yang_names.add("qos-group")

                                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                            self.remote_id.parent = self
                                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                                            self._children_yang_names.add("remote-id")

                                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                            self.remote_id_regex.parent = self
                                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                            self._children_yang_names.add("remote-id-regex")

                                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                            self.service_name.parent = self
                                                                                            self._children_name_map["service_name"] = "service-name"
                                                                                            self._children_yang_names.add("service-name")

                                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                            self.service_name_regex.parent = self
                                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                            self._children_yang_names.add("service-name-regex")

                                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                            self.src_addr_ipv4.parent = self
                                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                            self.src_addr_ipv6.parent = self
                                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                            self.src_addr_mac.parent = self
                                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                            self._children_yang_names.add("src-addr-mac")

                                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                            self.src_mac.parent = self
                                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                                            self._children_yang_names.add("src-mac")

                                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                            self.src_port.parent = self
                                                                                            self._children_name_map["src_port"] = "src-port"
                                                                                            self._children_yang_names.add("src-port")

                                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                            self.subs_protocol.parent = self
                                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                            self._children_yang_names.add("subs-protocol")

                                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                            self.tcp_flag.parent = self
                                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                            self._children_yang_names.add("tcp-flag")

                                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                            self.timer.parent = self
                                                                                            self._children_name_map["timer"] = "timer"
                                                                                            self._children_yang_names.add("timer")

                                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                            self.timer_regexp.parent = self
                                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                            self._children_yang_names.add("timer-regexp")

                                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                            self.traffic_class.parent = self
                                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                                            self._children_yang_names.add("traffic-class")

                                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                            self.tunnel_name.parent = self
                                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                            self._children_yang_names.add("tunnel-name")

                                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                            self.tunnel_name_regex.parent = self
                                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                            self.unauth_domain.parent = self
                                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                            self._children_yang_names.add("unauth-domain")

                                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                            self.unauth_domain_regex.parent = self
                                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                            self.unauth_username.parent = self
                                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                                            self._children_yang_names.add("unauth-username")

                                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                            self.unauth_username_regex.parent = self
                                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                            self.user_name.parent = self
                                                                                            self._children_name_map["user_name"] = "user-name"
                                                                                            self._children_yang_names.add("user-name")

                                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                            self.user_name_regex.parent = self
                                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                            self._children_yang_names.add("user-name-regex")

                                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                            self.vendor_id.parent = self
                                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                                            self._children_yang_names.add("vendor-id")

                                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                            self.vendor_id_regex.parent = self
                                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                            self.vlan.parent = self
                                                                                            self._children_name_map["vlan"] = "vlan"
                                                                                            self._children_yang_names.add("vlan")

                                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                            self.vlan_inr.parent = self
                                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                            self._children_yang_names.add("vlan-inr")
                                                                                            self._segment_path = lambda: "match-data"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                        class AccessInterface(Entity):
                                                                                            """
                                                                                            Access interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                self.yang_name = "access-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "access-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                        class AtmClp(Entity):
                                                                                            """
                                                                                            Match ATM CLP level
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                self.yang_name = "atm-clp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "atm-clp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                        class AuthDomain(Entity):
                                                                                            """
                                                                                            Authenticated domain name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                self.yang_name = "auth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                        class AuthDomainRegex(Entity):
                                                                                            """
                                                                                            Authenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                self.yang_name = "auth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                        class AuthUsername(Entity):
                                                                                            """
                                                                                            Authenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                self.yang_name = "auth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                        class AuthUsernameRegex(Entity):
                                                                                            """
                                                                                            Authenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "auth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                        class AvailId(Entity):
                                                                                            """
                                                                                            Available Identifiers
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                self.yang_name = "avail-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "avail-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                        class CircuitId(Entity):
                                                                                            """
                                                                                            Circuit ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                self.yang_name = "circuit-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                        class CircuitIdRegex(Entity):
                                                                                            """
                                                                                            Circuit ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                self.yang_name = "circuit-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                        class Cos(Entity):
                                                                                            """
                                                                                            Match CoS array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                self.yang_name = "cos"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                        class CosInr(Entity):
                                                                                            """
                                                                                            Match inner header CoS
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                self.yang_name = "cos-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "cos-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                        class Dei(Entity):
                                                                                            """
                                                                                            Match DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                self.yang_name = "dei"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                        class DeiInr(Entity):
                                                                                            """
                                                                                            Match inner DEI Bit
                                                                                            
                                                                                            .. attribute:: bit_value
                                                                                            
                                                                                            	Value of the DEI bit
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                self.yang_name = "dei-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                self._segment_path = lambda: "dei-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                        class DhcpClientId(Entity):
                                                                                            """
                                                                                            Dhcp Client ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                        class DhcpClientIdRegex(Entity):
                                                                                            """
                                                                                            Dhcp Client ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                        class DiscardClass(Entity):
                                                                                            """
                                                                                            Match Discard Class array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                self.yang_name = "discard-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "discard-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                        class Dnis(Entity):
                                                                                            """
                                                                                            DNIS
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                self.yang_name = "dnis"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                        class DnisRegex(Entity):
                                                                                            """
                                                                                            DNIS Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                self.yang_name = "dnis-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "dnis-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                        class Domain(Entity):
                                                                                            """
                                                                                            Domain Name
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                self.yang_name = "domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class DomainRegex(Entity):
                                                                                            """
                                                                                            Domain Regular Expression
                                                                                            
                                                                                            .. attribute:: domain_array
                                                                                            
                                                                                            	domain array
                                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                self.yang_name = "domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                self.domain_array = YList(self)
                                                                                                self._segment_path = lambda: "domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                            class DomainArray(Entity):
                                                                                                """
                                                                                                domain array
                                                                                                
                                                                                                .. attribute:: domain_name
                                                                                                
                                                                                                	domain name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                .. attribute:: format_name
                                                                                                
                                                                                                	format name
                                                                                                	**type**\:  str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                    self.yang_name = "domain-array"
                                                                                                    self.yang_parent_name = "domain-regex"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                                    self._segment_path = lambda: "domain-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                        class Dscp(Entity):
                                                                                            """
                                                                                            Match DSCP range array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                self.yang_name = "dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class DstAddrIpv4(Entity):
                                                                                            """
                                                                                            Destination Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstAddrIpv6(Entity):
                                                                                            """
                                                                                            Destination Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class DstMac(Entity):
                                                                                            """
                                                                                            Match Destination MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                self.yang_name = "dst-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "dst-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                        class DstPort(Entity):
                                                                                            """
                                                                                            Destination port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                self.yang_name = "dst-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "dst-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "dst-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class EtherServiceAcl(Entity):
                                                                                            """
                                                                                            Ethernet\-Services Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                self.yang_name = "ether-service-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                        class Ethertype(Entity):
                                                                                            """
                                                                                            Ethernet type
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                self.yang_name = "ethertype"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ethertype"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ethertype"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class FlowKeyData(Entity):
                                                                                            """
                                                                                            Flow key structure
                                                                                            
                                                                                            .. attribute:: flow_keys
                                                                                            
                                                                                            	flow keys
                                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                            
                                                                                            .. attribute:: idle_timeout
                                                                                            
                                                                                            	Idle timeout of flows (in seconds)
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            	**units**\: second
                                                                                            
                                                                                            .. attribute:: max_count
                                                                                            
                                                                                            	Maximum count of flows
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                self.yang_name = "flow-key-data"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                self._child_list_classes = {}

                                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                self.flow_keys.parent = self
                                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                self._children_yang_names.add("flow-keys")
                                                                                                self._segment_path = lambda: "flow-key-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                            class FlowKeys(Entity):
                                                                                                """
                                                                                                flow keys
                                                                                                
                                                                                                .. attribute:: keys
                                                                                                
                                                                                                	keys
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                
                                                                                                .. attribute:: num
                                                                                                
                                                                                                	num
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                    self.yang_name = "flow-keys"
                                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                        class FlowTag(Entity):
                                                                                            """
                                                                                            Match flow\-tag array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                self.yang_name = "flow-tag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "flow-tag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "flow-tag"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class FrDe(Entity):
                                                                                            """
                                                                                            Match FR DE value
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                self.yang_name = "fr-de"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "fr-de"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                        class FrDlci(Entity):
                                                                                            """
                                                                                            Match FR DLCI range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                self.yang_name = "fr-dlci"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "fr-dlci"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class IcmpV4(Entity):
                                                                                            """
                                                                                            Match ICMPV4 Protocol
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                self.yang_name = "icmp-v4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                        class IcmpV6(Entity):
                                                                                            """
                                                                                            Match ICMPV6 Protocol array
                                                                                            
                                                                                            .. attribute:: code
                                                                                            
                                                                                            	Protocol code
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	Protocol type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                self.yang_name = "icmp-v6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                                self._segment_path = lambda: "icmp-v6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                        class Icmpv4Code(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                self.yang_name = "icmpv4-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv4Type(Entity):
                                                                                            """
                                                                                            Match ipv4 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                self.yang_name = "icmpv4-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Code(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp code
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                self.yang_name = "icmpv6-code"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Icmpv6Type(Entity):
                                                                                            """
                                                                                            Match ipv6 icmp type
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                self.yang_name = "icmpv6-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class InputInterface(Entity):
                                                                                            """
                                                                                            Input interface
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                self.yang_name = "input-interface"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "input-interface"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                        class InputIntfhdl(Entity):
                                                                                            """
                                                                                            Input interface handle
                                                                                            
                                                                                            .. attribute:: uint64_array
                                                                                            
                                                                                            	uint64 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..18446744073709551615
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                self.yang_name = "input-intfhdl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                        class Ipv4Acl(Entity):
                                                                                            """
                                                                                            IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                self.yang_name = "ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                        class Ipv4Dscp(Entity):
                                                                                            """
                                                                                            IPv4 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                self.yang_name = "ipv4-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4PacketLen(Entity):
                                                                                            """
                                                                                            IPv4 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv4-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv4Prec(Entity):
                                                                                            """
                                                                                            IPv4 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                self.yang_name = "ipv4-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                        class Ipv6Acl(Entity):
                                                                                            """
                                                                                            IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                self.yang_name = "ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                        class Ipv6Dscp(Entity):
                                                                                            """
                                                                                            IPv6 DSCP
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                self.yang_name = "ipv6-dscp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6PacketLen(Entity):
                                                                                            """
                                                                                            IPv6 packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                self.yang_name = "ipv6-packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Ipv6Prec(Entity):
                                                                                            """
                                                                                            IPv6 Precedence
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                self.yang_name = "ipv6-prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                        class MediaType(Entity):
                                                                                            """
                                                                                            Media Type
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                self.yang_name = "media-type"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "media-type"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                        class MplsDispIpv4Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv4 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                        class MplsDispIpv6Acl(Entity):
                                                                                            """
                                                                                            MPLS Disposition IPv6 Access\-list
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                        class MplsExp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental topmost array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                self.yang_name = "mpls-exp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                        class MplsExpImp(Entity):
                                                                                            """
                                                                                            Match MPLS experimental imposition array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                self.yang_name = "mpls-exp-imp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                        class MplsTopLabel(Entity):
                                                                                            """
                                                                                            MPLS Topmost LABEL
                                                                                            
                                                                                            .. attribute:: uint32_rng_array
                                                                                            
                                                                                            	uint32 rng array
                                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                self.yang_name = "mpls-top-label"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                self.uint32_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                            class Uint32RngArray(Entity):
                                                                                                """
                                                                                                uint32 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                    self.yang_name = "uint32_rng_array"
                                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                        class NasPort(Entity):
                                                                                            """
                                                                                            NAS Port
                                                                                            
                                                                                            .. attribute:: nas_port_array
                                                                                            
                                                                                            	nas port array
                                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                self.yang_name = "nas-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                self.nas_port_array = YList(self)
                                                                                                self._segment_path = lambda: "nas-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                            class NasPortArray(Entity):
                                                                                                """
                                                                                                nas port array
                                                                                                
                                                                                                .. attribute:: operator
                                                                                                
                                                                                                	operator
                                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                
                                                                                                .. attribute:: sub_id
                                                                                                
                                                                                                	sub id
                                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	value
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                    self.yang_name = "nas-port-array"
                                                                                                    self.yang_parent_name = "nas-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                        class PacketLen(Entity):
                                                                                            """
                                                                                            Match packet length array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                self.yang_name = "packet-len"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "packet-len"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "packet-len"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class Prec(Entity):
                                                                                            """
                                                                                            Match Precedence array
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                self.yang_name = "prec"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "prec"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                        class Proto(Entity):
                                                                                            """
                                                                                            Match Protocol array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                self.yang_name = "proto"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "proto"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "proto"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class QosGroup(Entity):
                                                                                            """
                                                                                            Match QoS group array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                self.yang_name = "qos-group"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "qos-group"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "qos-group"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class RemoteId(Entity):
                                                                                            """
                                                                                            Remote ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                self.yang_name = "remote-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                        class RemoteIdRegex(Entity):
                                                                                            """
                                                                                            Remote ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                self.yang_name = "remote-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                        class ServiceName(Entity):
                                                                                            """
                                                                                            Service Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                self.yang_name = "service-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                        class ServiceNameRegex(Entity):
                                                                                            """
                                                                                            Service Name Regular Exp
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                self.yang_name = "service-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "service-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                        class SrcAddrIpv4(Entity):
                                                                                            """
                                                                                            Source Address IPV4
                                                                                            
                                                                                            .. attribute:: ipv4_addr_array
                                                                                            
                                                                                            	ipv4 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv4"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                self.ipv4_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                            class Ipv4AddrArray(Entity):
                                                                                                """
                                                                                                ipv4 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	mask
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrIpv6(Entity):
                                                                                            """
                                                                                            Source Address IPV6
                                                                                            
                                                                                            .. attribute:: ipv6_addr_array
                                                                                            
                                                                                            	ipv6 addr array
                                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                self.yang_name = "src-addr-ipv6"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                self.ipv6_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                            class Ipv6AddrArray(Entity):
                                                                                                """
                                                                                                ipv6 addr array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	IPV6 mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                .. attribute:: prefix
                                                                                                
                                                                                                	IPV6 prefix
                                                                                                	**type**\:  str
                                                                                                
                                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                        class SrcAddrMac(Entity):
                                                                                            """
                                                                                            Source Address MAC
                                                                                            
                                                                                            .. attribute:: mac_addr_array
                                                                                            
                                                                                            	mac addr array
                                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                self.yang_name = "src-addr-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                self.mac_addr_array = YList(self)
                                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                            class MacAddrArray(Entity):
                                                                                                """
                                                                                                mac addr array
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                    self.yang_name = "mac-addr-array"
                                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcMac(Entity):
                                                                                            """
                                                                                            Match Source MAC address
                                                                                            
                                                                                            .. attribute:: mac_addr
                                                                                            
                                                                                            	MAC address
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            .. attribute:: mask
                                                                                            
                                                                                            	MAC mask
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                self.yang_name = "src-mac"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                                self._segment_path = lambda: "src-mac"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                        class SrcPort(Entity):
                                                                                            """
                                                                                            Source port
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                self.yang_name = "src-port"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "src-port"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "src-port"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                        class SubsProtocol(Entity):
                                                                                            """
                                                                                            Protocol
                                                                                            
                                                                                            .. attribute:: uint8_array
                                                                                            
                                                                                            	uint8 array
                                                                                            	**type**\:  list of int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                self.yang_name = "subs-protocol"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                self._segment_path = lambda: "subs-protocol"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                        class TcpFlag(Entity):
                                                                                            """
                                                                                            Match tcp flag value
                                                                                            
                                                                                            .. attribute:: match_any
                                                                                            
                                                                                            	Match any TCP flag bit
                                                                                            	**type**\:  bool
                                                                                            
                                                                                            .. attribute:: value
                                                                                            
                                                                                            	Value of TCP flag
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..65535
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                self.yang_name = "tcp-flag"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                                self._segment_path = lambda: "tcp-flag"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                        class Timer(Entity):
                                                                                            """
                                                                                            Timer
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                self.yang_name = "timer"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                        class TimerRegexp(Entity):
                                                                                            """
                                                                                            Timer Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                self.yang_name = "timer-regexp"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "timer-regexp"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                        class TrafficClass(Entity):
                                                                                            """
                                                                                            Match Traffic class array
                                                                                            
                                                                                            .. attribute:: uint8_rng_array
                                                                                            
                                                                                            	uint8 rng array
                                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                self.yang_name = "traffic-class"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                self.uint8_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "traffic-class"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                            class Uint8RngArray(Entity):
                                                                                                """
                                                                                                uint8 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                    self.yang_name = "uint8_rng_array"
                                                                                                    self.yang_parent_name = "traffic-class"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                        class TunnelName(Entity):
                                                                                            """
                                                                                            Tunnel Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                self.yang_name = "tunnel-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                        class TunnelNameRegex(Entity):
                                                                                            """
                                                                                            Tunnel Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                self.yang_name = "tunnel-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                        class UnauthDomain(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                self.yang_name = "unauth-domain"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                        class UnauthDomainRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated Domain Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                self.yang_name = "unauth-domain-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                        class UnauthUsername(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                self.yang_name = "unauth-username"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                        class UnauthUsernameRegex(Entity):
                                                                                            """
                                                                                            Unauthenticated User Name RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                self.yang_name = "unauth-username-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                        class UserName(Entity):
                                                                                            """
                                                                                            User Name
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                self.yang_name = "user-name"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                        class UserNameRegex(Entity):
                                                                                            """
                                                                                            User Name Regular Expression
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                self.yang_name = "user-name-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "user-name-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                        class VendorId(Entity):
                                                                                            """
                                                                                            Vendor ID
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                self.yang_name = "vendor-id"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                        class VendorIdRegex(Entity):
                                                                                            """
                                                                                            Vendor ID RegEx
                                                                                            
                                                                                            .. attribute:: string_array
                                                                                            
                                                                                            	string array
                                                                                            	**type**\:  list of str
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                self.yang_name = "vendor-id-regex"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {}

                                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                        class Vlan(Entity):
                                                                                            """
                                                                                            Match VLAN array
                                                                                            
                                                                                            .. attribute:: vlan_id_array
                                                                                            
                                                                                            	vlan id array
                                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                self.yang_name = "vlan"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                self.vlan_id_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                            class VlanIdArray(Entity):
                                                                                                """
                                                                                                vlan id array
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	VLAN mask
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                    self.yang_name = "vlan-id-array"
                                                                                                    self.yang_parent_name = "vlan"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                        class VlanInr(Entity):
                                                                                            """
                                                                                            Match inner header VLAN range array
                                                                                            
                                                                                            .. attribute:: uint16_rng_array
                                                                                            
                                                                                            	uint16 rng array
                                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                self.yang_name = "vlan-inr"
                                                                                                self.yang_parent_name = "match-data"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {}
                                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                self.uint16_rng_array = YList(self)
                                                                                                self._segment_path = lambda: "vlan-inr"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                            class Uint16RngArray(Entity):
                                                                                                """
                                                                                                uint16 rng array
                                                                                                
                                                                                                .. attribute:: max
                                                                                                
                                                                                                	Upper limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: min
                                                                                                
                                                                                                	Lower limit of the range
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                    self.yang_name = "uint16_rng_array"
                                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                    class ExceedActns(Entity):
                                                                        """
                                                                        exceed actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                            self.yang_name = "exceed-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "exceed-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "exceed-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PeakBurst(Entity):
                                                                        """
                                                                        peak burst
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                            self.yang_name = "peak-burst"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "peak-burst"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                    class PeakRate(Entity):
                                                                        """
                                                                        peak rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                            self.yang_name = "peak-rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "peak-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                    class Rate(Entity):
                                                                        """
                                                                        rate
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                            self.yang_name = "rate"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                    class ViolateActns(Entity):
                                                                        """
                                                                        violate actns
                                                                        
                                                                        .. attribute:: police_action_array
                                                                        
                                                                        	police action array
                                                                        	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                            self.yang_name = "violate-actns"
                                                                            self.yang_parent_name = "police"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                            self.police_action_array = YList(self)
                                                                            self._segment_path = lambda: "violate-actns"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                        class PoliceActionArray(Entity):
                                                                            """
                                                                            police action array
                                                                            
                                                                            .. attribute:: mark
                                                                            
                                                                            	mark
                                                                            	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                self.yang_name = "police-action-array"
                                                                                self.yang_parent_name = "violate-actns"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.mark = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                self.mark.parent = self
                                                                                self._children_name_map["mark"] = "mark"
                                                                                self._children_yang_names.add("mark")
                                                                                self._segment_path = lambda: "police-action-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                            class Mark(Entity):
                                                                                """
                                                                                mark
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                    self.yang_name = "mark"
                                                                                    self.yang_parent_name = "police-action-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "mark"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                class PrepaidCfg(Entity):
                                                                    """
                                                                    prepaid cfg
                                                                    
                                                                    .. attribute:: prepaid_config_profile_name
                                                                    
                                                                    	prepaid config profile name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                        self.yang_name = "prepaid-cfg"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                        self._segment_path = lambda: "prepaid-cfg"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                class Prio(Entity):
                                                                    """
                                                                    prio
                                                                    
                                                                    .. attribute:: prio_lvl
                                                                    
                                                                    	prio lvl
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                        self.yang_name = "prio"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                        self._segment_path = lambda: "prio"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                class ProxyAaa(Entity):
                                                                    """
                                                                    proxy aaa
                                                                    
                                                                    .. attribute:: aaa_list_name
                                                                    
                                                                    	aaa list name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                        self.yang_name = "proxy-aaa"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                        self._segment_path = lambda: "proxy-aaa"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                class Punt(Entity):
                                                                    """
                                                                    punt
                                                                    
                                                                    .. attribute:: app_id
                                                                    
                                                                    	application ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: local_id
                                                                    
                                                                    	local ID
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_index
                                                                    
                                                                    	service node index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: sn_name
                                                                    
                                                                    	service node name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: sn_type
                                                                    
                                                                    	service node ID type
                                                                    	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                    
                                                                    .. attribute:: vsnode_type
                                                                    
                                                                    	vservice node type
                                                                    	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                        self.yang_name = "punt"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.app_id = YLeaf(YType.uint32, "app-id")

                                                                        self.local_id = YLeaf(YType.uint32, "local-id")

                                                                        self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                        self.sn_name = YLeaf(YType.str, "sn-name")

                                                                        self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                        self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                        self._segment_path = lambda: "punt"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                class Qlimit(Entity):
                                                                    """
                                                                    qlimit
                                                                    
                                                                    .. attribute:: action_qlimit_info_array
                                                                    
                                                                    	action qlimit info array
                                                                    	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                        self.yang_name = "qlimit"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                        self.action_qlimit_info_array = YList(self)
                                                                        self._segment_path = lambda: "qlimit"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                    class ActionQlimitInfoArray(Entity):
                                                                        """
                                                                        action qlimit info array
                                                                        
                                                                        .. attribute:: atmclp_qlim
                                                                        
                                                                        	atmclp qlim
                                                                        	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                        
                                                                        .. attribute:: match_values
                                                                        
                                                                        	match values
                                                                        	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                        
                                                                        .. attribute:: qlim
                                                                        
                                                                        	qlim
                                                                        	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                        
                                                                        .. attribute:: qlimit_flags
                                                                        
                                                                        	qlimit flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                            self.yang_name = "action-qlimit-info-array"
                                                                            self.yang_parent_name = "qlimit"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                            self._child_list_classes = {}

                                                                            self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                            self.atmclp_qlim.parent = self
                                                                            self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                            self._children_yang_names.add("atmclp-qlim")

                                                                            self.match_values = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                            self.match_values.parent = self
                                                                            self._children_name_map["match_values"] = "match-values"
                                                                            self._children_yang_names.add("match-values")

                                                                            self.qlim = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                            self.qlim.parent = self
                                                                            self._children_name_map["qlim"] = "qlim"
                                                                            self._children_yang_names.add("qlim")
                                                                            self._segment_path = lambda: "action-qlimit-info-array"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                        class AtmclpQlim(Entity):
                                                                            """
                                                                            atmclp qlim
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                self.yang_name = "atmclp-qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "atmclp-qlim"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                        class MatchValues(Entity):
                                                                            """
                                                                            match values
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                self.yang_name = "match-values"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-values"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-values"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Qlim(Entity):
                                                                            """
                                                                            qlim
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                self.yang_name = "qlim"
                                                                                self.yang_parent_name = "action-qlimit-info-array"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "qlim"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                class QueryAncp(Entity):
                                                                    """
                                                                    query ancp
                                                                    
                                                                    .. attribute:: enable
                                                                    
                                                                    	enable
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                        self.yang_name = "query-ancp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.enable = YLeaf(YType.uint8, "enable")
                                                                        self._segment_path = lambda: "query-ancp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                class Redirect(Entity):
                                                                    """
                                                                    redirect
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: value
                                                                    
                                                                    	value
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                        self.yang_name = "redirect"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.type = YLeaf(YType.uint8, "type")

                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                        self._segment_path = lambda: "redirect"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                class Rtp(Entity):
                                                                    """
                                                                    rtp
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                        self.yang_name = "rtp"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpJ2K(Entity):
                                                                    """
                                                                    rtp j2k
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                        self.yang_name = "rtp-j2k"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-j2k"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-j2k"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpMmr(Entity):
                                                                    """
                                                                    rtp mmr
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                        self.yang_name = "rtp-mmr"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-mmr"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-mmr"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                class RtpVoice(Entity):
                                                                    """
                                                                    rtp voice
                                                                    
                                                                    .. attribute:: action_metric_type
                                                                    
                                                                    	metric type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: clock_rate
                                                                    
                                                                    	clock rate
                                                                    	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                    
                                                                    .. attribute:: max_dropout
                                                                    
                                                                    	max dropout
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: max_misorder
                                                                    
                                                                    	max misorder
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: min_sequential
                                                                    
                                                                    	min sequential
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: seq_ext_cop4
                                                                    
                                                                    	enable seq extension cop4
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                        self.yang_name = "rtp-voice"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                        self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                        self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                        self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                        self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                        self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                        self.clock_rate = YList(self)
                                                                        self._segment_path = lambda: "rtp-voice"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                    class ClockRate(Entity):
                                                                        """
                                                                        clock rate
                                                                        
                                                                        .. attribute:: frequency
                                                                        
                                                                        	frequency
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pt
                                                                        
                                                                        	pt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                            self.yang_name = "clock-rate"
                                                                            self.yang_parent_name = "rtp-voice"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.frequency = YLeaf(YType.uint32, "frequency")

                                                                            self.pt = YLeaf(YType.uint32, "pt")
                                                                            self._segment_path = lambda: "clock-rate"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                class ServFunc(Entity):
                                                                    """
                                                                    serv func
                                                                    
                                                                    .. attribute:: meta_name
                                                                    
                                                                    	metadata name
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: path_id
                                                                    
                                                                    	service path id
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: service_index
                                                                    
                                                                    	service path index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..255
                                                                    
                                                                    .. attribute:: vs_index
                                                                    
                                                                    	vservice index
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                        self.yang_name = "serv-func"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.meta_name = YLeaf(YType.str, "meta-name")

                                                                        self.path_id = YLeaf(YType.uint32, "path-id")

                                                                        self.service_index = YLeaf(YType.uint8, "service-index")

                                                                        self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                        self._segment_path = lambda: "serv-func"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                class SetTimer(Entity):
                                                                    """
                                                                    set timer
                                                                    
                                                                    .. attribute:: absolute_time
                                                                    
                                                                    	absolute time
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: duration
                                                                    
                                                                    	duration
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                        self.yang_name = "set-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                        self.duration = YLeaf(YType.uint32, "duration")

                                                                        self.timer_name = YLeaf(YType.str, "timer-name")
                                                                        self._segment_path = lambda: "set-timer"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                class Sfrag(Entity):
                                                                    """
                                                                    sfrag
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Service Fragment Name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                        self.yang_name = "sfrag"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.name = YLeaf(YType.str, "name")
                                                                        self._segment_path = lambda: "sfrag"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                class Shape(Entity):
                                                                    """
                                                                    shape
                                                                    
                                                                    .. attribute:: be
                                                                    
                                                                    	be
                                                                    	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                    
                                                                    .. attribute:: bw
                                                                    
                                                                    	bw
                                                                    	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                        self.yang_name = "shape"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"be" : ("be", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                        self._child_list_classes = {}

                                                                        self.be = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                        self.be.parent = self
                                                                        self._children_name_map["be"] = "be"
                                                                        self._children_yang_names.add("be")

                                                                        self.bw = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                        self.bw.parent = self
                                                                        self._children_name_map["bw"] = "bw"
                                                                        self._children_yang_names.add("bw")
                                                                        self._segment_path = lambda: "shape"


                                                                    class Be(Entity):
                                                                        """
                                                                        be
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                            self.yang_name = "be"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "be"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                    class Bw(Entity):
                                                                        """
                                                                        bw
                                                                        
                                                                        .. attribute:: unit
                                                                        
                                                                        	unit
                                                                        	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                            self.yang_name = "bw"
                                                                            self.yang_parent_name = "shape"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.unit = YLeaf(YType.enumeration, "unit")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "bw"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                class StopTimer(Entity):
                                                                    """
                                                                    stop timer
                                                                    
                                                                    .. attribute:: timer_name
                                                                    
                                                                    	timer name
                                                                    	**type**\:  str
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                        self.yang_name = "stop-timer"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.timer_name = YLeaf(YType.str, "timer-name")
                                                                        self._segment_path = lambda: "stop-timer"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                class TimeoutIdle(Entity):
                                                                    """
                                                                    timeout idle
                                                                    
                                                                    .. attribute:: secs
                                                                    
                                                                    	secs
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                        self.yang_name = "timeout-idle"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {}

                                                                        self.secs = YLeaf(YType.uint32, "secs")
                                                                        self._segment_path = lambda: "timeout-idle"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                class Wred(Entity):
                                                                    """
                                                                    wred
                                                                    
                                                                    .. attribute:: action_wred_info
                                                                    
                                                                    	action wred info
                                                                    	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                        self.yang_name = "wred"
                                                                        self.yang_parent_name = "actp"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                        self.action_wred_info = YList(self)
                                                                        self._segment_path = lambda: "wred"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                    class ActionWredInfo(Entity):
                                                                        """
                                                                        action wred info
                                                                        
                                                                        .. attribute:: match_ranges
                                                                        
                                                                        	match ranges
                                                                        	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                        
                                                                        .. attribute:: max_threshold
                                                                        
                                                                        	max threshold
                                                                        	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                        
                                                                        .. attribute:: min_threshold
                                                                        
                                                                        	min threshold
                                                                        	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                        
                                                                        .. attribute:: probability
                                                                        
                                                                        	probability
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	cos/prec/dscp/ based WRED
                                                                        	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                        
                                                                        .. attribute:: wred_flags
                                                                        
                                                                        	wred flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                            self.yang_name = "action-wred-info"
                                                                            self.yang_parent_name = "wred"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.probability = YLeaf(YType.uint32, "probability")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                            self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                            self.match_ranges.parent = self
                                                                            self._children_name_map["match_ranges"] = "match-ranges"
                                                                            self._children_yang_names.add("match-ranges")

                                                                            self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                            self.max_threshold.parent = self
                                                                            self._children_name_map["max_threshold"] = "max-threshold"
                                                                            self._children_yang_names.add("max-threshold")

                                                                            self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                            self.min_threshold.parent = self
                                                                            self._children_name_map["min_threshold"] = "min-threshold"
                                                                            self._children_yang_names.add("min-threshold")
                                                                            self._segment_path = lambda: "action-wred-info"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                        class MatchRanges(Entity):
                                                                            """
                                                                            match ranges
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                self.yang_name = "match-ranges"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "match-ranges"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "match-ranges"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class MaxThreshold(Entity):
                                                                            """
                                                                            max threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                self.yang_name = "max-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "max-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                        class MinThreshold(Entity):
                                                                            """
                                                                            min threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                self.yang_name = "min-threshold"
                                                                                self.yang_parent_name = "action-wred-info"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "min-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                    class ClEncode(Entity):
                                                        """
                                                        cl encode
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: enc
                                                        
                                                        	enc
                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                        
                                                        .. attribute:: hd
                                                        
                                                        	hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..18446744073709551615
                                                        
                                                        .. attribute:: idx
                                                        
                                                        	idx
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: inline_cmap
                                                        
                                                        	inline cmap
                                                        	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                            self.yang_name = "cl-encode"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                            self._child_list_classes = {}

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                            self.hd = YLeaf(YType.uint64, "hd")

                                                            self.idx = YLeaf(YType.uint8, "idx")

                                                            self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                            self.inline_cmap.parent = self
                                                            self._children_name_map["inline_cmap"] = "inline-cmap"
                                                            self._children_yang_names.add("inline-cmap")
                                                            self._segment_path = lambda: "cl-encode"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                        class InlineCmap(Entity):
                                                            """
                                                            inline cmap
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	Inline Class\-Map flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_count
                                                            
                                                            	Number of Match infos
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Inline Class\-Map Mode Match any/all
                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                self.yang_name = "inline-cmap"
                                                                self.yang_parent_name = "cl-encode"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                self._child_list_classes = {}

                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                self.match_count = YLeaf(YType.uint32, "match-count")

                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._children_yang_names.add("match-infop")
                                                                self._segment_path = lambda: "inline-cmap"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "inline-cmap"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._children_yang_names.add("match-data")
                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                            self._child_list_classes = {}

                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                            self._children_yang_names.add("access-interface")

                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                            self._children_yang_names.add("atm-clp")

                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                            self._children_yang_names.add("auth-domain")

                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                            self._children_yang_names.add("auth-username")

                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                            self._children_yang_names.add("auth-username-regex")

                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                            self._children_yang_names.add("avail-id")

                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                            self._children_yang_names.add("circuit-id")

                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"
                                                                            self._children_yang_names.add("cos")

                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                            self._children_yang_names.add("cos-inr")

                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"
                                                                            self._children_yang_names.add("dei")

                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                            self._children_yang_names.add("dei-inr")

                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                            self._children_yang_names.add("discard-class")

                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"
                                                                            self._children_yang_names.add("dnis")

                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                            self._children_yang_names.add("dnis-regex")

                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"
                                                                            self._children_yang_names.add("domain")

                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                            self._children_yang_names.add("domain-regex")

                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"
                                                                            self._children_yang_names.add("dscp")

                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                            self._children_yang_names.add("dst-mac")

                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._children_yang_names.add("dst-port")

                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                            self._children_yang_names.add("ether-service-acl")

                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                            self._children_yang_names.add("ethertype")

                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                            self._children_yang_names.add("flow-key-data")

                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                            self._children_yang_names.add("flow-tag")

                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                            self._children_yang_names.add("fr-de")

                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                            self._children_yang_names.add("fr-dlci")

                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                            self._children_yang_names.add("icmp-v4")

                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                            self._children_yang_names.add("icmp-v6")

                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                            self._children_yang_names.add("icmpv4-code")

                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                            self._children_yang_names.add("icmpv4-type")

                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                            self._children_yang_names.add("icmpv6-code")

                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                            self._children_yang_names.add("icmpv6-type")

                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                            self._children_yang_names.add("input-interface")

                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                            self._children_yang_names.add("input-intfhdl")

                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                            self._children_yang_names.add("ipv4-acl")

                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                            self._children_yang_names.add("ipv4-prec")

                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                            self._children_yang_names.add("ipv6-acl")

                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                            self._children_yang_names.add("ipv6-prec")

                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"
                                                                            self._children_yang_names.add("media-type")

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                            self._children_yang_names.add("mpls-exp")

                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                            self._children_yang_names.add("mpls-top-label")

                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                            self._children_yang_names.add("nas-port")

                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                            self._children_yang_names.add("packet-len")

                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"
                                                                            self._children_yang_names.add("prec")

                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"
                                                                            self._children_yang_names.add("proto")

                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                            self._children_yang_names.add("qos-group")

                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                            self._children_yang_names.add("remote-id")

                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                            self._children_yang_names.add("remote-id-regex")

                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"
                                                                            self._children_yang_names.add("service-name")

                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                            self._children_yang_names.add("service-name-regex")

                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                            self._children_yang_names.add("src-addr-mac")

                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                            self._children_yang_names.add("src-mac")

                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"
                                                                            self._children_yang_names.add("src-port")

                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                            self._children_yang_names.add("subs-protocol")

                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                            self._children_yang_names.add("tcp-flag")

                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"
                                                                            self._children_yang_names.add("timer")

                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                            self._children_yang_names.add("timer-regexp")

                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                            self._children_yang_names.add("traffic-class")

                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                            self._children_yang_names.add("tunnel-name")

                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                            self._children_yang_names.add("unauth-domain")

                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                            self._children_yang_names.add("unauth-username")

                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"
                                                                            self._children_yang_names.add("user-name")

                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                            self._children_yang_names.add("user-name-regex")

                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                            self._children_yang_names.add("vendor-id")

                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"
                                                                            self._children_yang_names.add("vlan")

                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                            self._children_yang_names.add("vlan-inr")
                                                                            self._segment_path = lambda: "match-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "access-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "atm-clp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "avail-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "discard-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "dst-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                self._child_list_classes = {}

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._children_yang_names.add("flow-keys")
                                                                                self._segment_path = lambda: "flow-key-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "fr-de"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "input-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "media-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "src-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "subs-protocol"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "tcp-flag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer-regexp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                    class ClmpP(Entity):
                                                        """
                                                        clmp p
                                                        
                                                        .. attribute:: class_map_bg
                                                        
                                                        	class map bg
                                                        	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                            self.yang_name = "clmp-p"
                                                            self.yang_parent_name = "policy-class-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                            self.class_map_bg = YList(self)
                                                            self._segment_path = lambda: "clmp-p"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                        class ClassMapBg(Entity):
                                                            """
                                                            class map bg
                                                            
                                                            .. attribute:: description
                                                            
                                                            	description
                                                            	**type**\:  str
                                                            
                                                            .. attribute:: match_infop
                                                            
                                                            	Pointer to the first Match info
                                                            	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                            
                                                            .. attribute:: mode
                                                            
                                                            	Class\-Map Mode Match any/Match all
                                                            	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                            
                                                            .. attribute:: name
                                                            
                                                            	Name of the class\-map
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: type
                                                            
                                                            	Class\-Map Type QoS/PBR/Netflow/..
                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                self.yang_name = "class-map-bg"
                                                                self.yang_parent_name = "clmp-p"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                self._child_list_classes = {}

                                                                self.description = YLeaf(YType.str, "description")

                                                                self.mode = YLeaf(YType.enumeration, "mode")

                                                                self.name = YLeaf(YType.str, "name")

                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                self.match_infop = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                self.match_infop.parent = self
                                                                self._children_name_map["match_infop"] = "match-infop"
                                                                self._children_yang_names.add("match-infop")
                                                                self._segment_path = lambda: "class-map-bg"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                            class MatchInfop(Entity):
                                                                """
                                                                Pointer to the first Match info
                                                                
                                                                .. attribute:: class_match_info_st
                                                                
                                                                	class match info st
                                                                	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                    self.yang_name = "match-infop"
                                                                    self.yang_parent_name = "class-map-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                    self.class_match_info_st = YList(self)
                                                                    self._segment_path = lambda: "match-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                class ClassMatchInfoSt(Entity):
                                                                    """
                                                                    class match info st
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_data
                                                                    
                                                                    	Match criteria
                                                                    	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                        self.yang_name = "class-match-info-st"
                                                                        self.yang_parent_name = "match-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                        self.match_data.parent = self
                                                                        self._children_name_map["match_data"] = "match-data"
                                                                        self._children_yang_names.add("match-data")
                                                                        self._segment_path = lambda: "class-match-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                    class MatchData(Entity):
                                                                        """
                                                                        Match criteria
                                                                        
                                                                        .. attribute:: access_interface
                                                                        
                                                                        	Access interface
                                                                        	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                        
                                                                        .. attribute:: atm_clp
                                                                        
                                                                        	Match ATM CLP level
                                                                        	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                        
                                                                        .. attribute:: auth_domain
                                                                        
                                                                        	Authenticated domain name
                                                                        	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                        
                                                                        .. attribute:: auth_domain_regex
                                                                        
                                                                        	Authenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                        
                                                                        .. attribute:: auth_username
                                                                        
                                                                        	Authenticated User Name
                                                                        	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                        
                                                                        .. attribute:: auth_username_regex
                                                                        
                                                                        	Authenticated User Name RegEx
                                                                        	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                        
                                                                        .. attribute:: authen_status
                                                                        
                                                                        	Authentication Status
                                                                        	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                        
                                                                        .. attribute:: avail_id
                                                                        
                                                                        	Available Identifiers
                                                                        	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                        
                                                                        .. attribute:: circuit_id
                                                                        
                                                                        	Circuit ID
                                                                        	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                        
                                                                        .. attribute:: circuit_id_regex
                                                                        
                                                                        	Circuit ID RegEx
                                                                        	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                        
                                                                        .. attribute:: cos
                                                                        
                                                                        	Match CoS array
                                                                        	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                        
                                                                        .. attribute:: cos_inr
                                                                        
                                                                        	Match inner header CoS
                                                                        	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                        
                                                                        .. attribute:: dei
                                                                        
                                                                        	Match DEI Bit
                                                                        	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                        
                                                                        .. attribute:: dei_inr
                                                                        
                                                                        	Match inner DEI Bit
                                                                        	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                        
                                                                        .. attribute:: dhcp_client_id
                                                                        
                                                                        	Dhcp Client ID
                                                                        	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                        
                                                                        .. attribute:: dhcp_client_id_regex
                                                                        
                                                                        	Dhcp Client ID RegEx
                                                                        	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                        
                                                                        .. attribute:: discard_class
                                                                        
                                                                        	Match Discard Class array
                                                                        	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                        
                                                                        .. attribute:: dnis
                                                                        
                                                                        	DNIS
                                                                        	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                        
                                                                        .. attribute:: dnis_regex
                                                                        
                                                                        	DNIS Regular Expression
                                                                        	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                        
                                                                        .. attribute:: domain
                                                                        
                                                                        	Domain Name
                                                                        	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                        
                                                                        .. attribute:: domain_regex
                                                                        
                                                                        	Domain Regular Expression
                                                                        	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                        
                                                                        .. attribute:: dscp
                                                                        
                                                                        	Match DSCP range array
                                                                        	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv4
                                                                        
                                                                        	Destination Address IPV4
                                                                        	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                        
                                                                        .. attribute:: dst_addr_ipv6
                                                                        
                                                                        	Destination Address IPV6
                                                                        	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                        
                                                                        .. attribute:: dst_mac
                                                                        
                                                                        	Match Destination MAC address
                                                                        	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                        
                                                                        .. attribute:: dst_port
                                                                        
                                                                        	Destination port
                                                                        	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                        
                                                                        .. attribute:: ether_service_acl
                                                                        
                                                                        	Ethernet\-Services Access\-list
                                                                        	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                        
                                                                        .. attribute:: ethertype
                                                                        
                                                                        	Ethernet type
                                                                        	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                        
                                                                        .. attribute:: flow_key_data
                                                                        
                                                                        	Flow key structure
                                                                        	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                        
                                                                        .. attribute:: flow_tag
                                                                        
                                                                        	Match flow\-tag array
                                                                        	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                        
                                                                        .. attribute:: fr_de
                                                                        
                                                                        	Match FR DE value
                                                                        	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                        
                                                                        .. attribute:: fr_dlci
                                                                        
                                                                        	Match FR DLCI range array
                                                                        	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                        
                                                                        .. attribute:: fragment_type
                                                                        
                                                                        	Fragment type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: icmp_v4
                                                                        
                                                                        	Match ICMPV4 Protocol
                                                                        	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                        
                                                                        .. attribute:: icmp_v6
                                                                        
                                                                        	Match ICMPV6 Protocol array
                                                                        	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                        
                                                                        .. attribute:: icmpv4_code
                                                                        
                                                                        	Match ipv4 icmp code
                                                                        	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                        
                                                                        .. attribute:: icmpv4_type
                                                                        
                                                                        	Match ipv4 icmp type
                                                                        	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                        
                                                                        .. attribute:: icmpv6_code
                                                                        
                                                                        	Match ipv6 icmp code
                                                                        	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                        
                                                                        .. attribute:: icmpv6_type
                                                                        
                                                                        	Match ipv6 icmp type
                                                                        	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                        
                                                                        .. attribute:: input_interface
                                                                        
                                                                        	Input interface
                                                                        	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                        
                                                                        .. attribute:: input_intfhdl
                                                                        
                                                                        	Input interface handle
                                                                        	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                        
                                                                        .. attribute:: ipv4_acl
                                                                        
                                                                        	IPv4 Access\-list
                                                                        	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                        
                                                                        .. attribute:: ipv4_dscp
                                                                        
                                                                        	IPv4 DSCP
                                                                        	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                        
                                                                        .. attribute:: ipv4_packet_len
                                                                        
                                                                        	IPv4 packet length array
                                                                        	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                        
                                                                        .. attribute:: ipv4_prec
                                                                        
                                                                        	IPv4 Precedence
                                                                        	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                        
                                                                        .. attribute:: ipv6_acl
                                                                        
                                                                        	IPv6 Access\-list
                                                                        	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                        
                                                                        .. attribute:: ipv6_dscp
                                                                        
                                                                        	IPv6 DSCP
                                                                        	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                        
                                                                        .. attribute:: ipv6_packet_len
                                                                        
                                                                        	IPv6 packet length array
                                                                        	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                        
                                                                        .. attribute:: ipv6_prec
                                                                        
                                                                        	IPv6 Precedence
                                                                        	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                        
                                                                        .. attribute:: media_type
                                                                        
                                                                        	Media Type
                                                                        	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                        
                                                                        .. attribute:: mlp_negotiated
                                                                        
                                                                        	MLP Negotiated
                                                                        	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv4_acl
                                                                        
                                                                        	MPLS Disposition IPv4 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                        
                                                                        .. attribute:: mpls_disp_ipv6_acl
                                                                        
                                                                        	MPLS Disposition IPv6 Access\-list
                                                                        	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                        
                                                                        .. attribute:: mpls_exp
                                                                        
                                                                        	Match MPLS experimental topmost array
                                                                        	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                        
                                                                        .. attribute:: mpls_exp_imp
                                                                        
                                                                        	Match MPLS experimental imposition array
                                                                        	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                        
                                                                        .. attribute:: mpls_top_eos
                                                                        
                                                                        	MPLS Topmost EOS
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: mpls_top_label
                                                                        
                                                                        	MPLS Topmost LABEL
                                                                        	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                        
                                                                        .. attribute:: nas_port
                                                                        
                                                                        	NAS Port
                                                                        	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                        
                                                                        .. attribute:: packet_len
                                                                        
                                                                        	Match packet length array
                                                                        	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                        
                                                                        .. attribute:: prec
                                                                        
                                                                        	Match Precedence array
                                                                        	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                        
                                                                        .. attribute:: proto
                                                                        
                                                                        	Match Protocol array
                                                                        	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                        
                                                                        .. attribute:: qos_group
                                                                        
                                                                        	Match QoS group array
                                                                        	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                        
                                                                        .. attribute:: remote_id
                                                                        
                                                                        	Remote ID
                                                                        	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                        
                                                                        .. attribute:: remote_id_regex
                                                                        
                                                                        	Remote ID RegEx
                                                                        	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                        
                                                                        .. attribute:: service_name
                                                                        
                                                                        	Service Name
                                                                        	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                        
                                                                        .. attribute:: service_name_regex
                                                                        
                                                                        	Service Name Regular Exp
                                                                        	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                        
                                                                        .. attribute:: src_addr_ipv4
                                                                        
                                                                        	Source Address IPV4
                                                                        	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                        
                                                                        .. attribute:: src_addr_ipv6
                                                                        
                                                                        	Source Address IPV6
                                                                        	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                        
                                                                        .. attribute:: src_addr_mac
                                                                        
                                                                        	Source Address MAC
                                                                        	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                        
                                                                        .. attribute:: src_mac
                                                                        
                                                                        	Match Source MAC address
                                                                        	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                        
                                                                        .. attribute:: src_port
                                                                        
                                                                        	Source port
                                                                        	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                        
                                                                        .. attribute:: subs_protocol
                                                                        
                                                                        	Protocol
                                                                        	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                        
                                                                        .. attribute:: tcp_flag
                                                                        
                                                                        	Match tcp flag value
                                                                        	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                        
                                                                        .. attribute:: timer
                                                                        
                                                                        	Timer
                                                                        	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                        
                                                                        .. attribute:: timer_regexp
                                                                        
                                                                        	Timer Regular Expression
                                                                        	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                        
                                                                        .. attribute:: traffic_class
                                                                        
                                                                        	Match Traffic class array
                                                                        	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                        
                                                                        .. attribute:: tunnel_name
                                                                        
                                                                        	Tunnel Name
                                                                        	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                        
                                                                        .. attribute:: tunnel_name_regex
                                                                        
                                                                        	Tunnel Name Regular Expression
                                                                        	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                        
                                                                        .. attribute:: unauth_domain
                                                                        
                                                                        	Unauthenticated Domain Name
                                                                        	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                        
                                                                        .. attribute:: unauth_domain_regex
                                                                        
                                                                        	Unauthenticated Domain Name RegEx
                                                                        	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                        
                                                                        .. attribute:: unauth_username
                                                                        
                                                                        	Unauthenticated User Name
                                                                        	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                        
                                                                        .. attribute:: unauth_username_regex
                                                                        
                                                                        	Unauthenticated User Name RegEx
                                                                        	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                        
                                                                        .. attribute:: user_name
                                                                        
                                                                        	User Name
                                                                        	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                        
                                                                        .. attribute:: user_name_regex
                                                                        
                                                                        	User Name Regular Expression
                                                                        	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                        
                                                                        .. attribute:: vendor_id
                                                                        
                                                                        	Vendor ID
                                                                        	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                        
                                                                        .. attribute:: vendor_id_regex
                                                                        
                                                                        	Vendor ID RegEx
                                                                        	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                        
                                                                        .. attribute:: vlan
                                                                        
                                                                        	Match VLAN array
                                                                        	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                        
                                                                        .. attribute:: vlan_inr
                                                                        
                                                                        	Match inner header VLAN range array
                                                                        	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                            self.yang_name = "match-data"
                                                                            self.yang_parent_name = "class-match-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                            self._child_list_classes = {}

                                                                            self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                            self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                            self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                            self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.access_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                            self.access_interface.parent = self
                                                                            self._children_name_map["access_interface"] = "access-interface"
                                                                            self._children_yang_names.add("access-interface")

                                                                            self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                            self.atm_clp.parent = self
                                                                            self._children_name_map["atm_clp"] = "atm-clp"
                                                                            self._children_yang_names.add("atm-clp")

                                                                            self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                            self.auth_domain.parent = self
                                                                            self._children_name_map["auth_domain"] = "auth-domain"
                                                                            self._children_yang_names.add("auth-domain")

                                                                            self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                            self.auth_domain_regex.parent = self
                                                                            self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                            self._children_yang_names.add("auth-domain-regex")

                                                                            self.auth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                            self.auth_username.parent = self
                                                                            self._children_name_map["auth_username"] = "auth-username"
                                                                            self._children_yang_names.add("auth-username")

                                                                            self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                            self.auth_username_regex.parent = self
                                                                            self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                            self._children_yang_names.add("auth-username-regex")

                                                                            self.avail_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                            self.avail_id.parent = self
                                                                            self._children_name_map["avail_id"] = "avail-id"
                                                                            self._children_yang_names.add("avail-id")

                                                                            self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                            self.circuit_id.parent = self
                                                                            self._children_name_map["circuit_id"] = "circuit-id"
                                                                            self._children_yang_names.add("circuit-id")

                                                                            self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                            self.circuit_id_regex.parent = self
                                                                            self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                            self._children_yang_names.add("circuit-id-regex")

                                                                            self.cos = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                            self.cos.parent = self
                                                                            self._children_name_map["cos"] = "cos"
                                                                            self._children_yang_names.add("cos")

                                                                            self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                            self.cos_inr.parent = self
                                                                            self._children_name_map["cos_inr"] = "cos-inr"
                                                                            self._children_yang_names.add("cos-inr")

                                                                            self.dei = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                            self.dei.parent = self
                                                                            self._children_name_map["dei"] = "dei"
                                                                            self._children_yang_names.add("dei")

                                                                            self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                            self.dei_inr.parent = self
                                                                            self._children_name_map["dei_inr"] = "dei-inr"
                                                                            self._children_yang_names.add("dei-inr")

                                                                            self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                            self.dhcp_client_id.parent = self
                                                                            self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                            self._children_yang_names.add("dhcp-client-id")

                                                                            self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                            self.dhcp_client_id_regex.parent = self
                                                                            self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                            self._children_yang_names.add("dhcp-client-id-regex")

                                                                            self.discard_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                            self.discard_class.parent = self
                                                                            self._children_name_map["discard_class"] = "discard-class"
                                                                            self._children_yang_names.add("discard-class")

                                                                            self.dnis = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                            self.dnis.parent = self
                                                                            self._children_name_map["dnis"] = "dnis"
                                                                            self._children_yang_names.add("dnis")

                                                                            self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                            self.dnis_regex.parent = self
                                                                            self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                            self._children_yang_names.add("dnis-regex")

                                                                            self.domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                            self.domain.parent = self
                                                                            self._children_name_map["domain"] = "domain"
                                                                            self._children_yang_names.add("domain")

                                                                            self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                            self.domain_regex.parent = self
                                                                            self._children_name_map["domain_regex"] = "domain-regex"
                                                                            self._children_yang_names.add("domain-regex")

                                                                            self.dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                            self.dscp.parent = self
                                                                            self._children_name_map["dscp"] = "dscp"
                                                                            self._children_yang_names.add("dscp")

                                                                            self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                            self.dst_addr_ipv4.parent = self
                                                                            self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                            self._children_yang_names.add("dst-addr-ipv4")

                                                                            self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                            self.dst_addr_ipv6.parent = self
                                                                            self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                            self._children_yang_names.add("dst-addr-ipv6")

                                                                            self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                            self.dst_mac.parent = self
                                                                            self._children_name_map["dst_mac"] = "dst-mac"
                                                                            self._children_yang_names.add("dst-mac")

                                                                            self.dst_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                            self.dst_port.parent = self
                                                                            self._children_name_map["dst_port"] = "dst-port"
                                                                            self._children_yang_names.add("dst-port")

                                                                            self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                            self.ether_service_acl.parent = self
                                                                            self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                            self._children_yang_names.add("ether-service-acl")

                                                                            self.ethertype = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                            self.ethertype.parent = self
                                                                            self._children_name_map["ethertype"] = "ethertype"
                                                                            self._children_yang_names.add("ethertype")

                                                                            self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                            self.flow_key_data.parent = self
                                                                            self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                            self._children_yang_names.add("flow-key-data")

                                                                            self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                            self.flow_tag.parent = self
                                                                            self._children_name_map["flow_tag"] = "flow-tag"
                                                                            self._children_yang_names.add("flow-tag")

                                                                            self.fr_de = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                            self.fr_de.parent = self
                                                                            self._children_name_map["fr_de"] = "fr-de"
                                                                            self._children_yang_names.add("fr-de")

                                                                            self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                            self.fr_dlci.parent = self
                                                                            self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                            self._children_yang_names.add("fr-dlci")

                                                                            self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                            self.icmp_v4.parent = self
                                                                            self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                            self._children_yang_names.add("icmp-v4")

                                                                            self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                            self.icmp_v6.parent = self
                                                                            self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                            self._children_yang_names.add("icmp-v6")

                                                                            self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                            self.icmpv4_code.parent = self
                                                                            self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                            self._children_yang_names.add("icmpv4-code")

                                                                            self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                            self.icmpv4_type.parent = self
                                                                            self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                            self._children_yang_names.add("icmpv4-type")

                                                                            self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                            self.icmpv6_code.parent = self
                                                                            self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                            self._children_yang_names.add("icmpv6-code")

                                                                            self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                            self.icmpv6_type.parent = self
                                                                            self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                            self._children_yang_names.add("icmpv6-type")

                                                                            self.input_interface = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                            self.input_interface.parent = self
                                                                            self._children_name_map["input_interface"] = "input-interface"
                                                                            self._children_yang_names.add("input-interface")

                                                                            self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                            self.input_intfhdl.parent = self
                                                                            self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                            self._children_yang_names.add("input-intfhdl")

                                                                            self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                            self.ipv4_acl.parent = self
                                                                            self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                            self._children_yang_names.add("ipv4-acl")

                                                                            self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                            self.ipv4_dscp.parent = self
                                                                            self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                            self._children_yang_names.add("ipv4-dscp")

                                                                            self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                            self.ipv4_packet_len.parent = self
                                                                            self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                            self._children_yang_names.add("ipv4-packet-len")

                                                                            self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                            self.ipv4_prec.parent = self
                                                                            self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                            self._children_yang_names.add("ipv4-prec")

                                                                            self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                            self.ipv6_acl.parent = self
                                                                            self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                            self._children_yang_names.add("ipv6-acl")

                                                                            self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                            self.ipv6_dscp.parent = self
                                                                            self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                            self._children_yang_names.add("ipv6-dscp")

                                                                            self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                            self.ipv6_packet_len.parent = self
                                                                            self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                            self._children_yang_names.add("ipv6-packet-len")

                                                                            self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                            self.ipv6_prec.parent = self
                                                                            self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                            self._children_yang_names.add("ipv6-prec")

                                                                            self.media_type = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                            self.media_type.parent = self
                                                                            self._children_name_map["media_type"] = "media-type"
                                                                            self._children_yang_names.add("media-type")

                                                                            self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                            self.mpls_disp_ipv4_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                            self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                            self.mpls_disp_ipv6_acl.parent = self
                                                                            self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                            self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                            self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                            self.mpls_exp.parent = self
                                                                            self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                            self._children_yang_names.add("mpls-exp")

                                                                            self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                            self.mpls_exp_imp.parent = self
                                                                            self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                            self._children_yang_names.add("mpls-exp-imp")

                                                                            self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                            self.mpls_top_label.parent = self
                                                                            self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                            self._children_yang_names.add("mpls-top-label")

                                                                            self.nas_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                            self.nas_port.parent = self
                                                                            self._children_name_map["nas_port"] = "nas-port"
                                                                            self._children_yang_names.add("nas-port")

                                                                            self.packet_len = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                            self.packet_len.parent = self
                                                                            self._children_name_map["packet_len"] = "packet-len"
                                                                            self._children_yang_names.add("packet-len")

                                                                            self.prec = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                            self.prec.parent = self
                                                                            self._children_name_map["prec"] = "prec"
                                                                            self._children_yang_names.add("prec")

                                                                            self.proto = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                            self.proto.parent = self
                                                                            self._children_name_map["proto"] = "proto"
                                                                            self._children_yang_names.add("proto")

                                                                            self.qos_group = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                            self.qos_group.parent = self
                                                                            self._children_name_map["qos_group"] = "qos-group"
                                                                            self._children_yang_names.add("qos-group")

                                                                            self.remote_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                            self.remote_id.parent = self
                                                                            self._children_name_map["remote_id"] = "remote-id"
                                                                            self._children_yang_names.add("remote-id")

                                                                            self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                            self.remote_id_regex.parent = self
                                                                            self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                            self._children_yang_names.add("remote-id-regex")

                                                                            self.service_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                            self.service_name.parent = self
                                                                            self._children_name_map["service_name"] = "service-name"
                                                                            self._children_yang_names.add("service-name")

                                                                            self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                            self.service_name_regex.parent = self
                                                                            self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                            self._children_yang_names.add("service-name-regex")

                                                                            self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                            self.src_addr_ipv4.parent = self
                                                                            self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                            self._children_yang_names.add("src-addr-ipv4")

                                                                            self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                            self.src_addr_ipv6.parent = self
                                                                            self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                            self._children_yang_names.add("src-addr-ipv6")

                                                                            self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                            self.src_addr_mac.parent = self
                                                                            self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                            self._children_yang_names.add("src-addr-mac")

                                                                            self.src_mac = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                            self.src_mac.parent = self
                                                                            self._children_name_map["src_mac"] = "src-mac"
                                                                            self._children_yang_names.add("src-mac")

                                                                            self.src_port = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                            self.src_port.parent = self
                                                                            self._children_name_map["src_port"] = "src-port"
                                                                            self._children_yang_names.add("src-port")

                                                                            self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                            self.subs_protocol.parent = self
                                                                            self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                            self._children_yang_names.add("subs-protocol")

                                                                            self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                            self.tcp_flag.parent = self
                                                                            self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                            self._children_yang_names.add("tcp-flag")

                                                                            self.timer = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                            self.timer.parent = self
                                                                            self._children_name_map["timer"] = "timer"
                                                                            self._children_yang_names.add("timer")

                                                                            self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                            self.timer_regexp.parent = self
                                                                            self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                            self._children_yang_names.add("timer-regexp")

                                                                            self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                            self.traffic_class.parent = self
                                                                            self._children_name_map["traffic_class"] = "traffic-class"
                                                                            self._children_yang_names.add("traffic-class")

                                                                            self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                            self.tunnel_name.parent = self
                                                                            self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                            self._children_yang_names.add("tunnel-name")

                                                                            self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                            self.tunnel_name_regex.parent = self
                                                                            self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                            self._children_yang_names.add("tunnel-name-regex")

                                                                            self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                            self.unauth_domain.parent = self
                                                                            self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                            self._children_yang_names.add("unauth-domain")

                                                                            self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                            self.unauth_domain_regex.parent = self
                                                                            self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                            self._children_yang_names.add("unauth-domain-regex")

                                                                            self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                            self.unauth_username.parent = self
                                                                            self._children_name_map["unauth_username"] = "unauth-username"
                                                                            self._children_yang_names.add("unauth-username")

                                                                            self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                            self.unauth_username_regex.parent = self
                                                                            self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                            self._children_yang_names.add("unauth-username-regex")

                                                                            self.user_name = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                            self.user_name.parent = self
                                                                            self._children_name_map["user_name"] = "user-name"
                                                                            self._children_yang_names.add("user-name")

                                                                            self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                            self.user_name_regex.parent = self
                                                                            self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                            self._children_yang_names.add("user-name-regex")

                                                                            self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                            self.vendor_id.parent = self
                                                                            self._children_name_map["vendor_id"] = "vendor-id"
                                                                            self._children_yang_names.add("vendor-id")

                                                                            self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                            self.vendor_id_regex.parent = self
                                                                            self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                            self._children_yang_names.add("vendor-id-regex")

                                                                            self.vlan = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                            self.vlan.parent = self
                                                                            self._children_name_map["vlan"] = "vlan"
                                                                            self._children_yang_names.add("vlan")

                                                                            self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                            self.vlan_inr.parent = self
                                                                            self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                            self._children_yang_names.add("vlan-inr")
                                                                            self._segment_path = lambda: "match-data"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                        class AccessInterface(Entity):
                                                                            """
                                                                            Access interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                self.yang_name = "access-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "access-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                        class AtmClp(Entity):
                                                                            """
                                                                            Match ATM CLP level
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                self.yang_name = "atm-clp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "atm-clp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                        class AuthDomain(Entity):
                                                                            """
                                                                            Authenticated domain name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                self.yang_name = "auth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                        class AuthDomainRegex(Entity):
                                                                            """
                                                                            Authenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                self.yang_name = "auth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                        class AuthUsername(Entity):
                                                                            """
                                                                            Authenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                self.yang_name = "auth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                        class AuthUsernameRegex(Entity):
                                                                            """
                                                                            Authenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                self.yang_name = "auth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "auth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                        class AvailId(Entity):
                                                                            """
                                                                            Available Identifiers
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                self.yang_name = "avail-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "avail-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                        class CircuitId(Entity):
                                                                            """
                                                                            Circuit ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                self.yang_name = "circuit-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                        class CircuitIdRegex(Entity):
                                                                            """
                                                                            Circuit ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                self.yang_name = "circuit-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "circuit-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                        class Cos(Entity):
                                                                            """
                                                                            Match CoS array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                self.yang_name = "cos"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                        class CosInr(Entity):
                                                                            """
                                                                            Match inner header CoS
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                self.yang_name = "cos-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "cos-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                        class Dei(Entity):
                                                                            """
                                                                            Match DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                self.yang_name = "dei"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                        class DeiInr(Entity):
                                                                            """
                                                                            Match inner DEI Bit
                                                                            
                                                                            .. attribute:: bit_value
                                                                            
                                                                            	Value of the DEI bit
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                self.yang_name = "dei-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                self._segment_path = lambda: "dei-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                        class DhcpClientId(Entity):
                                                                            """
                                                                            Dhcp Client ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                self.yang_name = "dhcp-client-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                        class DhcpClientIdRegex(Entity):
                                                                            """
                                                                            Dhcp Client ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                self.yang_name = "dhcp-client-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dhcp-client-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                        class DiscardClass(Entity):
                                                                            """
                                                                            Match Discard Class array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                self.yang_name = "discard-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "discard-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                        class Dnis(Entity):
                                                                            """
                                                                            DNIS
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                self.yang_name = "dnis"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                        class DnisRegex(Entity):
                                                                            """
                                                                            DNIS Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                self.yang_name = "dnis-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "dnis-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                        class Domain(Entity):
                                                                            """
                                                                            Domain Name
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                self.yang_name = "domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class DomainRegex(Entity):
                                                                            """
                                                                            Domain Regular Expression
                                                                            
                                                                            .. attribute:: domain_array
                                                                            
                                                                            	domain array
                                                                            	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                self.yang_name = "domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                self.domain_array = YList(self)
                                                                                self._segment_path = lambda: "domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                            class DomainArray(Entity):
                                                                                """
                                                                                domain array
                                                                                
                                                                                .. attribute:: domain_name
                                                                                
                                                                                	domain name
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: format_name
                                                                                
                                                                                	format name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                    self.yang_name = "domain-array"
                                                                                    self.yang_parent_name = "domain-regex"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                    self.format_name = YLeaf(YType.str, "format-name")
                                                                                    self._segment_path = lambda: "domain-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                        class Dscp(Entity):
                                                                            """
                                                                            Match DSCP range array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                self.yang_name = "dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class DstAddrIpv4(Entity):
                                                                            """
                                                                            Destination Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstAddrIpv6(Entity):
                                                                            """
                                                                            Destination Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                self.yang_name = "dst-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "dst-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "dst-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class DstMac(Entity):
                                                                            """
                                                                            Match Destination MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                self.yang_name = "dst-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "dst-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                        class DstPort(Entity):
                                                                            """
                                                                            Destination port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                self.yang_name = "dst-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "dst-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "dst-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class EtherServiceAcl(Entity):
                                                                            """
                                                                            Ethernet\-Services Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                self.yang_name = "ether-service-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ether-service-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                        class Ethertype(Entity):
                                                                            """
                                                                            Ethernet type
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                self.yang_name = "ethertype"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ethertype"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ethertype"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class FlowKeyData(Entity):
                                                                            """
                                                                            Flow key structure
                                                                            
                                                                            .. attribute:: flow_keys
                                                                            
                                                                            	flow keys
                                                                            	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	Idle timeout of flows (in seconds)
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: max_count
                                                                            
                                                                            	Maximum count of flows
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                self.yang_name = "flow-key-data"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                self._child_list_classes = {}

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                self.flow_keys.parent = self
                                                                                self._children_name_map["flow_keys"] = "flow-keys"
                                                                                self._children_yang_names.add("flow-keys")
                                                                                self._segment_path = lambda: "flow-key-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                            class FlowKeys(Entity):
                                                                                """
                                                                                flow keys
                                                                                
                                                                                .. attribute:: keys
                                                                                
                                                                                	keys
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: num
                                                                                
                                                                                	num
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                    self.yang_name = "flow-keys"
                                                                                    self.yang_parent_name = "flow-key-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.keys = YLeaf(YType.str, "keys")

                                                                                    self.num = YLeaf(YType.uint8, "num")
                                                                                    self._segment_path = lambda: "flow-keys"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                        class FlowTag(Entity):
                                                                            """
                                                                            Match flow\-tag array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                self.yang_name = "flow-tag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "flow-tag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "flow-tag"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class FrDe(Entity):
                                                                            """
                                                                            Match FR DE value
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                self.yang_name = "fr-de"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "fr-de"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                        class FrDlci(Entity):
                                                                            """
                                                                            Match FR DLCI range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                self.yang_name = "fr-dlci"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "fr-dlci"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "fr-dlci"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class IcmpV4(Entity):
                                                                            """
                                                                            Match ICMPV4 Protocol
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                self.yang_name = "icmp-v4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                        class IcmpV6(Entity):
                                                                            """
                                                                            Match ICMPV6 Protocol array
                                                                            
                                                                            .. attribute:: code
                                                                            
                                                                            	Protocol code
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	Protocol type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                self.yang_name = "icmp-v6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.code = YLeaf(YType.uint8, "code")

                                                                                self.type = YLeaf(YType.uint8, "type")
                                                                                self._segment_path = lambda: "icmp-v6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                        class Icmpv4Code(Entity):
                                                                            """
                                                                            Match ipv4 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                self.yang_name = "icmpv4-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv4Type(Entity):
                                                                            """
                                                                            Match ipv4 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                self.yang_name = "icmpv4-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv4-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv4-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Code(Entity):
                                                                            """
                                                                            Match ipv6 icmp code
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                self.yang_name = "icmpv6-code"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-code"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-code"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Icmpv6Type(Entity):
                                                                            """
                                                                            Match ipv6 icmp type
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                self.yang_name = "icmpv6-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "icmpv6-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "icmpv6-type"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class InputInterface(Entity):
                                                                            """
                                                                            Input interface
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                self.yang_name = "input-interface"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "input-interface"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                        class InputIntfhdl(Entity):
                                                                            """
                                                                            Input interface handle
                                                                            
                                                                            .. attribute:: uint64_array
                                                                            
                                                                            	uint64 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                self.yang_name = "input-intfhdl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                self._segment_path = lambda: "input-intfhdl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                        class Ipv4Acl(Entity):
                                                                            """
                                                                            IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                self.yang_name = "ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                        class Ipv4Dscp(Entity):
                                                                            """
                                                                            IPv4 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                self.yang_name = "ipv4-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv4-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4PacketLen(Entity):
                                                                            """
                                                                            IPv4 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                self.yang_name = "ipv4-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv4-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv4Prec(Entity):
                                                                            """
                                                                            IPv4 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                self.yang_name = "ipv4-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv4-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                        class Ipv6Acl(Entity):
                                                                            """
                                                                            IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                self.yang_name = "ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                        class Ipv6Dscp(Entity):
                                                                            """
                                                                            IPv6 DSCP
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                self.yang_name = "ipv6-dscp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-dscp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "ipv6-dscp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6PacketLen(Entity):
                                                                            """
                                                                            IPv6 packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                self.yang_name = "ipv6-packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "ipv6-packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Ipv6Prec(Entity):
                                                                            """
                                                                            IPv6 Precedence
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                self.yang_name = "ipv6-prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "ipv6-prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                        class MediaType(Entity):
                                                                            """
                                                                            Media Type
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                self.yang_name = "media-type"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "media-type"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                        class MplsDispIpv4Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv4 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv4-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                        class MplsDispIpv6Acl(Entity):
                                                                            """
                                                                            MPLS Disposition IPv6 Access\-list
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                self.yang_name = "mpls-disp-ipv6-acl"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                        class MplsExp(Entity):
                                                                            """
                                                                            Match MPLS experimental topmost array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                self.yang_name = "mpls-exp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                        class MplsExpImp(Entity):
                                                                            """
                                                                            Match MPLS experimental imposition array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                self.yang_name = "mpls-exp-imp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "mpls-exp-imp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                        class MplsTopLabel(Entity):
                                                                            """
                                                                            MPLS Topmost LABEL
                                                                            
                                                                            .. attribute:: uint32_rng_array
                                                                            
                                                                            	uint32 rng array
                                                                            	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                self.yang_name = "mpls-top-label"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                self.uint32_rng_array = YList(self)
                                                                                self._segment_path = lambda: "mpls-top-label"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                            class Uint32RngArray(Entity):
                                                                                """
                                                                                uint32 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                    self.yang_name = "uint32_rng_array"
                                                                                    self.yang_parent_name = "mpls-top-label"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint32, "max")

                                                                                    self.min = YLeaf(YType.uint32, "min")
                                                                                    self._segment_path = lambda: "uint32_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                        class NasPort(Entity):
                                                                            """
                                                                            NAS Port
                                                                            
                                                                            .. attribute:: nas_port_array
                                                                            
                                                                            	nas port array
                                                                            	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                self.yang_name = "nas-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                self.nas_port_array = YList(self)
                                                                                self._segment_path = lambda: "nas-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                            class NasPortArray(Entity):
                                                                                """
                                                                                nas port array
                                                                                
                                                                                .. attribute:: operator
                                                                                
                                                                                	operator
                                                                                	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                
                                                                                .. attribute:: sub_id
                                                                                
                                                                                	sub id
                                                                                	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                    self.yang_name = "nas-port-array"
                                                                                    self.yang_parent_name = "nas-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.operator = YLeaf(YType.enumeration, "operator")

                                                                                    self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "nas-port-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                        class PacketLen(Entity):
                                                                            """
                                                                            Match packet length array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                self.yang_name = "packet-len"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "packet-len"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "packet-len"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class Prec(Entity):
                                                                            """
                                                                            Match Precedence array
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                self.yang_name = "prec"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "prec"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                        class Proto(Entity):
                                                                            """
                                                                            Match Protocol array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                self.yang_name = "proto"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "proto"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "proto"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class QosGroup(Entity):
                                                                            """
                                                                            Match QoS group array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                self.yang_name = "qos-group"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "qos-group"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "qos-group"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class RemoteId(Entity):
                                                                            """
                                                                            Remote ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                self.yang_name = "remote-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                        class RemoteIdRegex(Entity):
                                                                            """
                                                                            Remote ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                self.yang_name = "remote-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "remote-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                        class ServiceName(Entity):
                                                                            """
                                                                            Service Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                self.yang_name = "service-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                        class ServiceNameRegex(Entity):
                                                                            """
                                                                            Service Name Regular Exp
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                self.yang_name = "service-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "service-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                        class SrcAddrIpv4(Entity):
                                                                            """
                                                                            Source Address IPV4
                                                                            
                                                                            .. attribute:: ipv4_addr_array
                                                                            
                                                                            	ipv4 addr array
                                                                            	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                self.yang_name = "src-addr-ipv4"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                self.ipv4_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv4"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                            class Ipv4AddrArray(Entity):
                                                                                """
                                                                                ipv4 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	mask
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv4-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv4"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.str, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv4-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrIpv6(Entity):
                                                                            """
                                                                            Source Address IPV6
                                                                            
                                                                            .. attribute:: ipv6_addr_array
                                                                            
                                                                            	ipv6 addr array
                                                                            	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                self.yang_name = "src-addr-ipv6"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                self.ipv6_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-ipv6"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                            class Ipv6AddrArray(Entity):
                                                                                """
                                                                                ipv6 addr array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	IPV6 mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: prefix
                                                                                
                                                                                	IPV6 prefix
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                    self.yang_name = "ipv6-addr-array"
                                                                                    self.yang_parent_name = "src-addr-ipv6"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint32, "mask")

                                                                                    self.prefix = YLeaf(YType.str, "prefix")
                                                                                    self._segment_path = lambda: "ipv6-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                        class SrcAddrMac(Entity):
                                                                            """
                                                                            Source Address MAC
                                                                            
                                                                            .. attribute:: mac_addr_array
                                                                            
                                                                            	mac addr array
                                                                            	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                self.yang_name = "src-addr-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                self.mac_addr_array = YList(self)
                                                                                self._segment_path = lambda: "src-addr-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                            class MacAddrArray(Entity):
                                                                                """
                                                                                mac addr array
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                    self.yang_name = "mac-addr-array"
                                                                                    self.yang_parent_name = "src-addr-mac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "mac-addr-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                        class SrcMac(Entity):
                                                                            """
                                                                            Match Source MAC address
                                                                            
                                                                            .. attribute:: mac_addr
                                                                            
                                                                            	MAC address
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: mask
                                                                            
                                                                            	MAC mask
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                self.yang_name = "src-mac"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                self.mask = YLeafList(YType.uint16, "mask")
                                                                                self._segment_path = lambda: "src-mac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                        class SrcPort(Entity):
                                                                            """
                                                                            Source port
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                self.yang_name = "src-port"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "src-port"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "src-port"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class SubsProtocol(Entity):
                                                                            """
                                                                            Protocol
                                                                            
                                                                            .. attribute:: uint8_array
                                                                            
                                                                            	uint8 array
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                self.yang_name = "subs-protocol"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                self._segment_path = lambda: "subs-protocol"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                        class TcpFlag(Entity):
                                                                            """
                                                                            Match tcp flag value
                                                                            
                                                                            .. attribute:: match_any
                                                                            
                                                                            	Match any TCP flag bit
                                                                            	**type**\:  bool
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	Value of TCP flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                self.yang_name = "tcp-flag"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "tcp-flag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                        class Timer(Entity):
                                                                            """
                                                                            Timer
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                self.yang_name = "timer"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                        class TimerRegexp(Entity):
                                                                            """
                                                                            Timer Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                self.yang_name = "timer-regexp"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "timer-regexp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                        class TrafficClass(Entity):
                                                                            """
                                                                            Match Traffic class array
                                                                            
                                                                            .. attribute:: uint8_rng_array
                                                                            
                                                                            	uint8 rng array
                                                                            	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                self.yang_name = "traffic-class"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                self.uint8_rng_array = YList(self)
                                                                                self._segment_path = lambda: "traffic-class"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                            class Uint8RngArray(Entity):
                                                                                """
                                                                                uint8 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                    self.yang_name = "uint8_rng_array"
                                                                                    self.yang_parent_name = "traffic-class"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint8, "max")

                                                                                    self.min = YLeaf(YType.uint8, "min")
                                                                                    self._segment_path = lambda: "uint8_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                        class TunnelName(Entity):
                                                                            """
                                                                            Tunnel Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                self.yang_name = "tunnel-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                        class TunnelNameRegex(Entity):
                                                                            """
                                                                            Tunnel Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                self.yang_name = "tunnel-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "tunnel-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                        class UnauthDomain(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                self.yang_name = "unauth-domain"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                        class UnauthDomainRegex(Entity):
                                                                            """
                                                                            Unauthenticated Domain Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                self.yang_name = "unauth-domain-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-domain-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                        class UnauthUsername(Entity):
                                                                            """
                                                                            Unauthenticated User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                self.yang_name = "unauth-username"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                        class UnauthUsernameRegex(Entity):
                                                                            """
                                                                            Unauthenticated User Name RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                self.yang_name = "unauth-username-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "unauth-username-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                        class UserName(Entity):
                                                                            """
                                                                            User Name
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                self.yang_name = "user-name"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                        class UserNameRegex(Entity):
                                                                            """
                                                                            User Name Regular Expression
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                self.yang_name = "user-name-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "user-name-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                        class VendorId(Entity):
                                                                            """
                                                                            Vendor ID
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                self.yang_name = "vendor-id"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                        class VendorIdRegex(Entity):
                                                                            """
                                                                            Vendor ID RegEx
                                                                            
                                                                            .. attribute:: string_array
                                                                            
                                                                            	string array
                                                                            	**type**\:  list of str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                self.yang_name = "vendor-id-regex"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.string_array = YLeafList(YType.str, "string-array")
                                                                                self._segment_path = lambda: "vendor-id-regex"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                        class Vlan(Entity):
                                                                            """
                                                                            Match VLAN array
                                                                            
                                                                            .. attribute:: vlan_id_array
                                                                            
                                                                            	vlan id array
                                                                            	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                self.yang_name = "vlan"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                self.vlan_id_array = YList(self)
                                                                                self._segment_path = lambda: "vlan"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                            class VlanIdArray(Entity):
                                                                                """
                                                                                vlan id array
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	VLAN mask
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                    self.yang_name = "vlan-id-array"
                                                                                    self.yang_parent_name = "vlan"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mask = YLeaf(YType.uint16, "mask")

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "vlan-id-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                        class VlanInr(Entity):
                                                                            """
                                                                            Match inner header VLAN range array
                                                                            
                                                                            .. attribute:: uint16_rng_array
                                                                            
                                                                            	uint16 rng array
                                                                            	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                self.yang_name = "vlan-inr"
                                                                                self.yang_parent_name = "match-data"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                self.uint16_rng_array = YList(self)
                                                                                self._segment_path = lambda: "vlan-inr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                            class Uint16RngArray(Entity):
                                                                                """
                                                                                uint16 rng array
                                                                                
                                                                                .. attribute:: max
                                                                                
                                                                                	Upper limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: min
                                                                                
                                                                                	Lower limit of the range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                    self.yang_name = "uint16_rng_array"
                                                                                    self.yang_parent_name = "vlan-inr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.max = YLeaf(YType.uint16, "max")

                                                                                    self.min = YLeaf(YType.uint16, "min")
                                                                                    self._segment_path = lambda: "uint16_rng_array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                    class PmapVarList(Entity):
                                        """
                                        pmap var list
                                        
                                        .. attribute:: offset
                                        
                                        	offset
                                        	**type**\:  list of int
                                        
                                        	**range:** 0..255
                                        
                                        .. attribute:: pmap_var_list_arr
                                        
                                        	pmap var list arr
                                        	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList, self).__init__()

                                            self.yang_name = "pmap-var-list"
                                            self.yang_parent_name = "policy-map-bg"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                            self.offset = YLeafList(YType.uint8, "offset")

                                            self.pmap_var_list_arr = YList(self)
                                            self._segment_path = lambda: "pmap-var-list"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                        class PmapVarListArr(Entity):
                                            """
                                            pmap var list arr
                                            
                                            .. attribute:: id
                                            
                                            	id
                                            	**type**\:  int
                                            
                                            	**range:** 0..4294967295
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\:  str
                                            
                                            	**length:** 0..32
                                            
                                            .. attribute:: val
                                            
                                            	val
                                            	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                self.yang_name = "pmap-var-list-arr"
                                                self.yang_parent_name = "pmap-var-list"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"val" : ("val", PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                self._child_list_classes = {}

                                                self.id = YLeaf(YType.uint32, "id")

                                                self.name = YLeaf(YType.str, "name")

                                                self.val = PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                self.val.parent = self
                                                self._children_name_map["val"] = "val"
                                                self._children_yang_names.add("val")
                                                self._segment_path = lambda: "pmap-var-list-arr"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                            class Val(Entity):
                                                """
                                                val
                                                
                                                .. attribute:: class_name
                                                
                                                	class name
                                                	**type**\:  str
                                                
                                                	**length:** 0..65
                                                
                                                .. attribute:: dscp_val
                                                
                                                	dscp val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: param_uint32_val
                                                
                                                	param uint32 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: prec_val
                                                
                                                	prec val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: type
                                                
                                                	type
                                                	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                
                                                .. attribute:: uint16_val
                                                
                                                	uint16 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..65535
                                                
                                                .. attribute:: uint32_val
                                                
                                                	uint32 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: uint8_val
                                                
                                                	uint8 val
                                                	**type**\:  int
                                                
                                                	**range:** 0..255
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                    self.yang_name = "val"
                                                    self.yang_parent_name = "pmap-var-list-arr"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {}

                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                    self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                    self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                    self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                    self.type = YLeaf(YType.enumeration, "type")

                                                    self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                    self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                    self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                    self._segment_path = lambda: "val"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapTypes.PolicyMapType.PolicyMaps.PolicyMap.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                class PolicyMapUnusedTypes(Entity):
                    """
                    Policy\-map unused table
                    
                    .. attribute:: policy_map_unused_type
                    
                    	Policy\-map unused
                    	**type**\: list of    :py:class:`PolicyMapUnusedType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes, self).__init__()

                        self.yang_name = "policy-map-unused-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"policy-map-unused-type" : ("policy_map_unused_type", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType)}

                        self.policy_map_unused_type = YList(self)
                        self._segment_path = lambda: "policy-map-unused-types"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes, [], name, value)


                    class PolicyMapUnusedType(Entity):
                        """
                        Policy\-map unused
                        
                        .. attribute:: type  <key>
                        
                        	The application type
                        	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: unuseds
                        
                        	Policy\-map unused
                        	**type**\:   :py:class:`Unuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, self).__init__()

                            self.yang_name = "policy-map-unused-type"
                            self.yang_parent_name = "policy-map-unused-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"unuseds" : ("unuseds", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds)}
                            self._child_list_classes = {}

                            self.type = YLeaf(YType.enumeration, "type")

                            self.unuseds = PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds()
                            self.unuseds.parent = self
                            self._children_name_map["unuseds"] = "unuseds"
                            self._children_yang_names.add("unuseds")
                            self._segment_path = lambda: "policy-map-unused-type" + "[type='" + self.type.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType, ['type'], name, value)


                        class Unuseds(Entity):
                            """
                            Policy\-map unused
                            
                            .. attribute:: unused
                            
                            	Policy\-map unused information
                            	**type**\: list of    :py:class:`Unused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, self).__init__()

                                self.yang_name = "unuseds"
                                self.yang_parent_name = "policy-map-unused-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"unused" : ("unused", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused)}

                                self.unused = YList(self)
                                self._segment_path = lambda: "unuseds"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds, [], name, value)


                            class Unused(Entity):
                                """
                                Policy\-map unused information
                                
                                .. attribute:: policy_map_name  <key>
                                
                                	Name of policy\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference>`
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects>`
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, self).__init__()

                                    self.yang_name = "unused"
                                    self.yang_parent_name = "unuseds"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference)}

                                    self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                    self.object_type = YLeaf(YType.enumeration, "object-type")

                                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                                    self.transient = YLeaf(YType.boolean, "transient")

                                    self.class_map_reference = YList(self)
                                    self.objects = YList(self)
                                    self.reference = YList(self)
                                    self._segment_path = lambda: "unused" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference>`
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference)}

                                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\:  str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.object_type = YLeaf(YType.enumeration, "object-type")

                                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                            self._segment_path = lambda: "policy-map-reference"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_name = YLeaf(YType.str, "object-name")
                                        self._segment_path = lambda: "objects"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Objects, ['object_name'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                        self._segment_path = lambda: "reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.PolicyMapUnusedTypes.PolicyMapUnusedType.Unuseds.Unused.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                class TransientPolicyMapTypeXr(Entity):
                    """
                    Application type of transient policy\-map
                    
                    .. attribute:: transient_policy_map_type
                    
                    	Transient policy\-map type
                    	**type**\: list of    :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr, self).__init__()

                        self.yang_name = "transient-policy-map-type-xr"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"transient-policy-map-type" : ("transient_policy_map_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType)}

                        self.transient_policy_map_type = YList(self)
                        self._segment_path = lambda: "transient-policy-map-type-xr"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr, [], name, value)


                    class TransientPolicyMapType(Entity):
                        """
                        Transient policy\-map type
                        
                        .. attribute:: type  <key>
                        
                        	The application type
                        	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: transient_policy_map_names
                        
                        	Transient policy\-map definition table
                        	**type**\:   :py:class:`TransientPolicyMapNames <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, self).__init__()

                            self.yang_name = "transient-policy-map-type"
                            self.yang_parent_name = "transient-policy-map-type-xr"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"transient-policy-map-names" : ("transient_policy_map_names", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames)}
                            self._child_list_classes = {}

                            self.type = YLeaf(YType.enumeration, "type")

                            self.transient_policy_map_names = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames()
                            self.transient_policy_map_names.parent = self
                            self._children_name_map["transient_policy_map_names"] = "transient-policy-map-names"
                            self._children_yang_names.add("transient-policy-map-names")
                            self._segment_path = lambda: "transient-policy-map-type" + "[type='" + self.type.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType, ['type'], name, value)


                        class TransientPolicyMapNames(Entity):
                            """
                            Transient policy\-map definition table
                            
                            .. attribute:: transient_policy_map_name
                            
                            	Transient policy\-map definition table
                            	**type**\: list of    :py:class:`TransientPolicyMapName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, self).__init__()

                                self.yang_name = "transient-policy-map-names"
                                self.yang_parent_name = "transient-policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"transient-policy-map-name" : ("transient_policy_map_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName)}

                                self.transient_policy_map_name = YList(self)
                                self._segment_path = lambda: "transient-policy-map-names"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames, [], name, value)


                            class TransientPolicyMapName(Entity):
                                """
                                Transient policy\-map definition table
                                
                                .. attribute:: policy_map_name  <key>
                                
                                	Name of policy\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_handles
                                
                                	Transient policy\-map class handle table
                                	**type**\:   :py:class:`ClassHandles <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles>`
                                
                                .. attribute:: class_seq_nums
                                
                                	Transient policy\-map sequence number table
                                	**type**\:   :py:class:`ClassSeqNums <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums>`
                                
                                .. attribute:: definition
                                
                                	Transient Policy\-map type name
                                	**type**\:   :py:class:`Definition <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition>`
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, self).__init__()

                                    self.yang_name = "transient-policy-map-name"
                                    self.yang_parent_name = "transient-policy-map-names"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {"class-handles" : ("class_handles", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles), "class-seq-nums" : ("class_seq_nums", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums), "definition" : ("definition", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition)}
                                    self._child_list_classes = {}

                                    self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                    self.class_handles = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles()
                                    self.class_handles.parent = self
                                    self._children_name_map["class_handles"] = "class-handles"
                                    self._children_yang_names.add("class-handles")

                                    self.class_seq_nums = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums()
                                    self.class_seq_nums.parent = self
                                    self._children_name_map["class_seq_nums"] = "class-seq-nums"
                                    self._children_yang_names.add("class-seq-nums")

                                    self.definition = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition()
                                    self.definition.parent = self
                                    self._children_name_map["definition"] = "definition"
                                    self._children_yang_names.add("definition")
                                    self._segment_path = lambda: "transient-policy-map-name" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName, ['policy_map_name'], name, value)


                                class ClassHandles(Entity):
                                    """
                                    Transient policy\-map class handle table
                                    
                                    .. attribute:: class_handle
                                    
                                    	Transient policy\-map class handle
                                    	**type**\: list of    :py:class:`ClassHandle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, self).__init__()

                                        self.yang_name = "class-handles"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"class-handle" : ("class_handle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle)}

                                        self.class_handle = YList(self)
                                        self._segment_path = lambda: "class-handles"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles, [], name, value)


                                    class ClassHandle(Entity):
                                        """
                                        Transient policy\-map class handle
                                        
                                        .. attribute:: inline_classhandle  <key>
                                        
                                        	inline class handle
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: policy_map_bg
                                        
                                        	policy map bg
                                        	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, self).__init__()

                                            self.yang_name = "class-handle"
                                            self.yang_parent_name = "class-handles"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg)}

                                            self.inline_classhandle = YLeaf(YType.int32, "inline-classhandle")

                                            self.policy_map_bg = YList(self)
                                            self._segment_path = lambda: "class-handle" + "[inline-classhandle='" + self.inline_classhandle.get() + "']"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle, ['inline_classhandle'], name, value)


                                        class PolicyMapBg(Entity):
                                            """
                                            policy map bg
                                            
                                            .. attribute:: description
                                            
                                            	description
                                            	**type**\:  str
                                            
                                            .. attribute:: event_infop
                                            
                                            	event infop
                                            	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: pmap_var_list
                                            
                                            	pmap var list
                                            	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList>`
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, self).__init__()

                                                self.yang_name = "policy-map-bg"
                                                self.yang_parent_name = "class-handle"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList)}
                                                self._child_list_classes = {}

                                                self.description = YLeaf(YType.str, "description")

                                                self.name = YLeaf(YType.str, "name")

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop()
                                                self.event_infop.parent = self
                                                self._children_name_map["event_infop"] = "event-infop"
                                                self._children_yang_names.add("event-infop")

                                                self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList()
                                                self.pmap_var_list.parent = self
                                                self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                                self._children_yang_names.add("pmap-var-list")
                                                self._segment_path = lambda: "policy-map-bg"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                            class EventInfop(Entity):
                                                """
                                                event infop
                                                
                                                .. attribute:: policy_event_info_bg
                                                
                                                	policy event info bg
                                                	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, self).__init__()

                                                    self.yang_name = "event-infop"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                    self.policy_event_info_bg = YList(self)
                                                    self._segment_path = lambda: "event-infop"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop, [], name, value)


                                                class PolicyEventInfoBg(Entity):
                                                    """
                                                    policy event info bg
                                                    
                                                    .. attribute:: avl_tree
                                                    
                                                    	avl tree
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: class_infop
                                                    
                                                    	class infop
                                                    	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                    
                                                    .. attribute:: cond_eval
                                                    
                                                    	cond eval
                                                    	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                    
                                                    .. attribute:: event_type
                                                    
                                                    	event type
                                                    	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                        self.yang_name = "policy-event-info-bg"
                                                        self.yang_parent_name = "event-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                        self._child_list_classes = {}

                                                        self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                        self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                        self.event_type = YLeaf(YType.enumeration, "event-type")

                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                        self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                        self.class_infop.parent = self
                                                        self._children_name_map["class_infop"] = "class-infop"
                                                        self._children_yang_names.add("class-infop")
                                                        self._segment_path = lambda: "policy-event-info-bg"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                    class ClassInfop(Entity):
                                                        """
                                                        class infop
                                                        
                                                        .. attribute:: policy_class_info_bg
                                                        
                                                        	policy class info bg
                                                        	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                            self.yang_name = "class-infop"
                                                            self.yang_parent_name = "policy-event-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                            self.policy_class_info_bg = YList(self)
                                                            self._segment_path = lambda: "class-infop"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                        class PolicyClassInfoBg(Entity):
                                                            """
                                                            policy class info bg
                                                            
                                                            .. attribute:: act_infop
                                                            
                                                            	act infop
                                                            	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                            
                                                            .. attribute:: cl_encode
                                                            
                                                            	cl encode
                                                            	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                            
                                                            .. attribute:: clmp_p
                                                            
                                                            	clmp p
                                                            	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                            
                                                            .. attribute:: ctype
                                                            
                                                            	ctype
                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: exe_strat
                                                            
                                                            	exe strat
                                                            	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: num_actions
                                                            
                                                            	num actions
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: policy_class_hd
                                                            
                                                            	policy class hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: version
                                                            
                                                            	version
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                                self.yang_name = "policy-class-info-bg"
                                                                self.yang_parent_name = "class-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                                self._child_list_classes = {}

                                                                self.ctype = YLeaf(YType.enumeration, "ctype")

                                                                self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                                self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                                self.seq = YLeaf(YType.uint32, "seq")

                                                                self.version = YLeaf(YType.uint8, "version")

                                                                self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                                self.act_infop.parent = self
                                                                self._children_name_map["act_infop"] = "act-infop"
                                                                self._children_yang_names.add("act-infop")

                                                                self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                                self.cl_encode.parent = self
                                                                self._children_name_map["cl_encode"] = "cl-encode"
                                                                self._children_yang_names.add("cl-encode")

                                                                self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                                self.clmp_p.parent = self
                                                                self._children_name_map["clmp_p"] = "clmp-p"
                                                                self._children_yang_names.add("clmp-p")
                                                                self._segment_path = lambda: "policy-class-info-bg"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                            class ActInfop(Entity):
                                                                """
                                                                act infop
                                                                
                                                                .. attribute:: policy_action_info_st
                                                                
                                                                	policy action info st
                                                                	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                    self.yang_name = "act-infop"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                    self.policy_action_info_st = YList(self)
                                                                    self._segment_path = lambda: "act-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                                class PolicyActionInfoSt(Entity):
                                                                    """
                                                                    policy action info st
                                                                    
                                                                    .. attribute:: actp
                                                                    
                                                                    	actp
                                                                    	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                        self.yang_name = "policy-action-info-st"
                                                                        self.yang_parent_name = "act-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"actp" : ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint16, "flags")

                                                                        self.seq = YLeaf(YType.uint16, "seq")

                                                                        self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                        self.actp.parent = self
                                                                        self._children_name_map["actp"] = "actp"
                                                                        self._children_yang_names.add("actp")
                                                                        self._segment_path = lambda: "policy-action-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                    class Actp(Entity):
                                                                        """
                                                                        actp
                                                                        
                                                                        .. attribute:: accounting_event_aaa
                                                                        
                                                                        	accounting event aaa
                                                                        	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                        
                                                                        .. attribute:: acct_aaa_list
                                                                        
                                                                        	acct aaa list
                                                                        	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                        
                                                                        .. attribute:: act_template
                                                                        
                                                                        	act template
                                                                        	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                        
                                                                        .. attribute:: afm_react
                                                                        
                                                                        	afm react
                                                                        	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                        
                                                                        .. attribute:: authen_aaa
                                                                        
                                                                        	authen aaa
                                                                        	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                        
                                                                        .. attribute:: authorize_id
                                                                        
                                                                        	authorize id
                                                                        	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                        
                                                                        .. attribute:: cac
                                                                        
                                                                        	cac
                                                                        	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                        
                                                                        .. attribute:: child_policy
                                                                        
                                                                        	child policy
                                                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                        
                                                                        .. attribute:: collect_id
                                                                        
                                                                        	collect id
                                                                        	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                        
                                                                        .. attribute:: copy
                                                                        
                                                                        	copy
                                                                        	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                        
                                                                        .. attribute:: data_p
                                                                        
                                                                        	data p
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: deact_template
                                                                        
                                                                        	deact template
                                                                        	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                        
                                                                        .. attribute:: decode_id
                                                                        
                                                                        	decode id
                                                                        	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                        
                                                                        .. attribute:: encap
                                                                        
                                                                        	encap
                                                                        	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                        
                                                                        .. attribute:: flow_parm
                                                                        
                                                                        	flow parm
                                                                        	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                        
                                                                        .. attribute:: fmm
                                                                        
                                                                        	fmm
                                                                        	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                        
                                                                        .. attribute:: httpr
                                                                        
                                                                        	httpr
                                                                        	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                        
                                                                        .. attribute:: ipcbr
                                                                        
                                                                        	ipcbr
                                                                        	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                        
                                                                        .. attribute:: ipv4_nh
                                                                        
                                                                        	ipv4 nh
                                                                        	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                        
                                                                        .. attribute:: ipv6_nh
                                                                        
                                                                        	ipv6 nh
                                                                        	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                        
                                                                        .. attribute:: mark2
                                                                        
                                                                        	mark2
                                                                        	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                        
                                                                        .. attribute:: mdi
                                                                        
                                                                        	mdi
                                                                        	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                        
                                                                        .. attribute:: mdi_rtp
                                                                        
                                                                        	mdi rtp
                                                                        	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                        
                                                                        .. attribute:: min_bw
                                                                        
                                                                        	min bw
                                                                        	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                        
                                                                        .. attribute:: out_intf
                                                                        
                                                                        	out intf
                                                                        	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                        
                                                                        .. attribute:: pbf
                                                                        
                                                                        	pbf
                                                                        	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                        
                                                                        .. attribute:: pfc
                                                                        
                                                                        	pfc
                                                                        	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                        
                                                                        .. attribute:: police
                                                                        
                                                                        	police
                                                                        	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                        
                                                                        .. attribute:: prepaid_cfg
                                                                        
                                                                        	prepaid cfg
                                                                        	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                        
                                                                        .. attribute:: prio
                                                                        
                                                                        	prio
                                                                        	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                        
                                                                        .. attribute:: proxy_aaa
                                                                        
                                                                        	proxy aaa
                                                                        	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                        
                                                                        .. attribute:: punt
                                                                        
                                                                        	punt
                                                                        	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                        
                                                                        .. attribute:: qlimit
                                                                        
                                                                        	qlimit
                                                                        	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                        
                                                                        .. attribute:: query_ancp
                                                                        
                                                                        	query ancp
                                                                        	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                        
                                                                        .. attribute:: redirect
                                                                        
                                                                        	redirect
                                                                        	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                        
                                                                        .. attribute:: rtp
                                                                        
                                                                        	rtp
                                                                        	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                        
                                                                        .. attribute:: rtp_j2k
                                                                        
                                                                        	rtp j2k
                                                                        	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                        
                                                                        .. attribute:: rtp_mmr
                                                                        
                                                                        	rtp mmr
                                                                        	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                        
                                                                        .. attribute:: rtp_voice
                                                                        
                                                                        	rtp voice
                                                                        	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                        
                                                                        .. attribute:: serv_func
                                                                        
                                                                        	serv func
                                                                        	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                        
                                                                        .. attribute:: set_timer
                                                                        
                                                                        	set timer
                                                                        	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                        
                                                                        .. attribute:: sfrag
                                                                        
                                                                        	sfrag
                                                                        	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                        
                                                                        .. attribute:: shape
                                                                        
                                                                        	shape
                                                                        	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                        
                                                                        .. attribute:: stop_timer
                                                                        
                                                                        	stop timer
                                                                        	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                        
                                                                        .. attribute:: timeout_idle
                                                                        
                                                                        	timeout idle
                                                                        	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: wred
                                                                        
                                                                        	wred
                                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                            self.yang_name = "actp"
                                                                            self.yang_parent_name = "policy-action-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                            self._child_list_classes = {}

                                                                            self.data_p = YLeaf(YType.uint32, "data-p")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                            self.accounting_event_aaa.parent = self
                                                                            self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                            self._children_yang_names.add("accounting-event-aaa")

                                                                            self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                            self.acct_aaa_list.parent = self
                                                                            self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                            self._children_yang_names.add("acct-aaa-list")

                                                                            self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                            self.act_template.parent = self
                                                                            self._children_name_map["act_template"] = "act-template"
                                                                            self._children_yang_names.add("act-template")

                                                                            self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                            self.afm_react.parent = self
                                                                            self._children_name_map["afm_react"] = "afm-react"
                                                                            self._children_yang_names.add("afm-react")

                                                                            self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                            self.authen_aaa.parent = self
                                                                            self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                            self._children_yang_names.add("authen-aaa")

                                                                            self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                            self.authorize_id.parent = self
                                                                            self._children_name_map["authorize_id"] = "authorize-id"
                                                                            self._children_yang_names.add("authorize-id")

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")

                                                                            self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                            self.cac.parent = self
                                                                            self._children_name_map["cac"] = "cac"
                                                                            self._children_yang_names.add("cac")

                                                                            self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                            self.child_policy.parent = self
                                                                            self._children_name_map["child_policy"] = "child-policy"
                                                                            self._children_yang_names.add("child-policy")

                                                                            self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                            self.collect_id.parent = self
                                                                            self._children_name_map["collect_id"] = "collect-id"
                                                                            self._children_yang_names.add("collect-id")

                                                                            self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                            self.copy.parent = self
                                                                            self._children_name_map["copy"] = "copy"
                                                                            self._children_yang_names.add("copy")

                                                                            self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                            self.deact_template.parent = self
                                                                            self._children_name_map["deact_template"] = "deact-template"
                                                                            self._children_yang_names.add("deact-template")

                                                                            self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                            self.decode_id.parent = self
                                                                            self._children_name_map["decode_id"] = "decode-id"
                                                                            self._children_yang_names.add("decode-id")

                                                                            self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                            self.encap.parent = self
                                                                            self._children_name_map["encap"] = "encap"
                                                                            self._children_yang_names.add("encap")

                                                                            self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                            self.flow_parm.parent = self
                                                                            self._children_name_map["flow_parm"] = "flow-parm"
                                                                            self._children_yang_names.add("flow-parm")

                                                                            self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                            self.fmm.parent = self
                                                                            self._children_name_map["fmm"] = "fmm"
                                                                            self._children_yang_names.add("fmm")

                                                                            self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                            self.httpr.parent = self
                                                                            self._children_name_map["httpr"] = "httpr"
                                                                            self._children_yang_names.add("httpr")

                                                                            self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                            self.ipcbr.parent = self
                                                                            self._children_name_map["ipcbr"] = "ipcbr"
                                                                            self._children_yang_names.add("ipcbr")

                                                                            self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                            self.ipv4_nh.parent = self
                                                                            self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                            self._children_yang_names.add("ipv4-nh")

                                                                            self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                            self.ipv6_nh.parent = self
                                                                            self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                            self._children_yang_names.add("ipv6-nh")

                                                                            self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._children_yang_names.add("mark")

                                                                            self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                            self.mark2.parent = self
                                                                            self._children_name_map["mark2"] = "mark2"
                                                                            self._children_yang_names.add("mark2")

                                                                            self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                            self.mdi.parent = self
                                                                            self._children_name_map["mdi"] = "mdi"
                                                                            self._children_yang_names.add("mdi")

                                                                            self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                            self.mdi_rtp.parent = self
                                                                            self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                            self._children_yang_names.add("mdi-rtp")

                                                                            self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                            self.min_bw.parent = self
                                                                            self._children_name_map["min_bw"] = "min-bw"
                                                                            self._children_yang_names.add("min-bw")

                                                                            self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                            self.out_intf.parent = self
                                                                            self._children_name_map["out_intf"] = "out-intf"
                                                                            self._children_yang_names.add("out-intf")

                                                                            self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                            self.pbf.parent = self
                                                                            self._children_name_map["pbf"] = "pbf"
                                                                            self._children_yang_names.add("pbf")

                                                                            self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                            self.pfc.parent = self
                                                                            self._children_name_map["pfc"] = "pfc"
                                                                            self._children_yang_names.add("pfc")

                                                                            self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                            self.police.parent = self
                                                                            self._children_name_map["police"] = "police"
                                                                            self._children_yang_names.add("police")

                                                                            self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                            self.prepaid_cfg.parent = self
                                                                            self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                            self._children_yang_names.add("prepaid-cfg")

                                                                            self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                            self.prio.parent = self
                                                                            self._children_name_map["prio"] = "prio"
                                                                            self._children_yang_names.add("prio")

                                                                            self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                            self.proxy_aaa.parent = self
                                                                            self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                            self._children_yang_names.add("proxy-aaa")

                                                                            self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                            self.punt.parent = self
                                                                            self._children_name_map["punt"] = "punt"
                                                                            self._children_yang_names.add("punt")

                                                                            self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                            self.qlimit.parent = self
                                                                            self._children_name_map["qlimit"] = "qlimit"
                                                                            self._children_yang_names.add("qlimit")

                                                                            self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                            self.query_ancp.parent = self
                                                                            self._children_name_map["query_ancp"] = "query-ancp"
                                                                            self._children_yang_names.add("query-ancp")

                                                                            self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                            self.redirect.parent = self
                                                                            self._children_name_map["redirect"] = "redirect"
                                                                            self._children_yang_names.add("redirect")

                                                                            self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                            self.rtp.parent = self
                                                                            self._children_name_map["rtp"] = "rtp"
                                                                            self._children_yang_names.add("rtp")

                                                                            self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                            self.rtp_j2k.parent = self
                                                                            self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                            self._children_yang_names.add("rtp-j2k")

                                                                            self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                            self.rtp_mmr.parent = self
                                                                            self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                            self._children_yang_names.add("rtp-mmr")

                                                                            self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                            self.rtp_voice.parent = self
                                                                            self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                            self._children_yang_names.add("rtp-voice")

                                                                            self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                            self.serv_func.parent = self
                                                                            self._children_name_map["serv_func"] = "serv-func"
                                                                            self._children_yang_names.add("serv-func")

                                                                            self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                            self.set_timer.parent = self
                                                                            self._children_name_map["set_timer"] = "set-timer"
                                                                            self._children_yang_names.add("set-timer")

                                                                            self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                            self.sfrag.parent = self
                                                                            self._children_name_map["sfrag"] = "sfrag"
                                                                            self._children_yang_names.add("sfrag")

                                                                            self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                            self.shape.parent = self
                                                                            self._children_name_map["shape"] = "shape"
                                                                            self._children_yang_names.add("shape")

                                                                            self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                            self.stop_timer.parent = self
                                                                            self._children_name_map["stop_timer"] = "stop-timer"
                                                                            self._children_yang_names.add("stop-timer")

                                                                            self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                            self.timeout_idle.parent = self
                                                                            self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                            self._children_yang_names.add("timeout-idle")

                                                                            self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                            self.wred.parent = self
                                                                            self._children_name_map["wred"] = "wred"
                                                                            self._children_yang_names.add("wred")
                                                                            self._segment_path = lambda: "actp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                        class AccountingEventAaa(Entity):
                                                                            """
                                                                            accounting event aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: action
                                                                            
                                                                            	action
                                                                            	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                                self.yang_name = "accounting-event-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.action = YLeaf(YType.enumeration, "action")
                                                                                self._segment_path = lambda: "accounting-event-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                        class AcctAaaList(Entity):
                                                                            """
                                                                            acct aaa list
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                                self.yang_name = "acct-aaa-list"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.secs = YLeaf(YType.uint32, "secs")
                                                                                self._segment_path = lambda: "acct-aaa-list"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                        class ActTemplate(Entity):
                                                                            """
                                                                            act template
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                                self.yang_name = "act-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.template_name = YLeaf(YType.str, "template-name")
                                                                                self._segment_path = lambda: "act-template"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                        class AfmReact(Entity):
                                                                            """
                                                                            afm react
                                                                            
                                                                            .. attribute:: action_afmon_react_info
                                                                            
                                                                            	action afmon react info
                                                                            	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                                self.yang_name = "afm-react"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                                self.action_afmon_react_info = YList(self)
                                                                                self._segment_path = lambda: "afm-react"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                            class ActionAfmonReactInfo(Entity):
                                                                                """
                                                                                action afmon react info
                                                                                
                                                                                .. attribute:: alm_grp_thresh
                                                                                
                                                                                	Num/percent in grp
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: percentage
                                                                                
                                                                                .. attribute:: alm_severity
                                                                                
                                                                                	Major\|Minor\|... alarm
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: alm_type
                                                                                
                                                                                	Discrete \| grouped alarm
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: clone_ifh
                                                                                
                                                                                	Clone interface handle
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: criterion
                                                                                
                                                                                	React Criterion
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	Describing the oper
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: notif_actns
                                                                                
                                                                                	Bitmap of actions on alert
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: oper_id
                                                                                
                                                                                	React Operation ID
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: trig_level_1
                                                                                
                                                                                	Trigger threshold 1/lower
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: trig_level_2
                                                                                
                                                                                	Trigger upper threshold for range
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: trig_num_intvls
                                                                                
                                                                                	Averaged over N intvls
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: trig_relop
                                                                                
                                                                                	Trigger LT\|LE\|GT\|GE\|Range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_type
                                                                                
                                                                                	Immediate or averaged thresh trigger
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                    self.yang_name = "action-afmon-react-info"
                                                                                    self.yang_parent_name = "afm-react"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                    self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                    self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                    self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                    self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                    self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                    self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                    self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                    self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                    self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                    self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                    self._segment_path = lambda: "action-afmon-react-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                        class AuthenAaa(Entity):
                                                                            """
                                                                            authen aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: authen_password
                                                                            
                                                                            	authen password
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                                self.yang_name = "authen-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.authen_password = YLeaf(YType.str, "authen-password")
                                                                                self._segment_path = lambda: "authen-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                        class AuthorizeId(Entity):
                                                                            """
                                                                            authorize id
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: password
                                                                            
                                                                            	password
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                                self.yang_name = "authorize-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")

                                                                                self.id = YLeaf(YType.uint8, "id")

                                                                                self.password = YLeaf(YType.str, "password")
                                                                                self._segment_path = lambda: "authorize-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: bwrem
                                                                            
                                                                            	bwrem
                                                                            	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                                self._child_list_classes = {}

                                                                                self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                                self.bwrem.parent = self
                                                                                self._children_name_map["bwrem"] = "bwrem"
                                                                                self._children_yang_names.add("bwrem")
                                                                                self._segment_path = lambda: "bwrem"


                                                                            class Bwrem(Entity):
                                                                                """
                                                                                bwrem
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                    self.yang_name = "bwrem"
                                                                                    self.yang_parent_name = "bwrem"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bwrem"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                        class Cac(Entity):
                                                                            """
                                                                            cac
                                                                            
                                                                            .. attribute:: cac_type
                                                                            
                                                                            	cac type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: flow_rate
                                                                            
                                                                            	flow rate
                                                                            	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	idle timeout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                                self.yang_name = "cac"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                                self._child_list_classes = {}

                                                                                self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                                self.flow_rate.parent = self
                                                                                self._children_name_map["flow_rate"] = "flow-rate"
                                                                                self._children_yang_names.add("flow-rate")

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._children_yang_names.add("rate")
                                                                                self._segment_path = lambda: "cac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                            class FlowRate(Entity):
                                                                                """
                                                                                flow rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                    self.yang_name = "flow-rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "flow-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                        class ChildPolicy(Entity):
                                                                            """
                                                                            child policy
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd_info
                                                                            
                                                                            	hd info
                                                                            	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                            
                                                                            .. attribute:: info
                                                                            
                                                                            	info
                                                                            	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                                self.yang_name = "child-policy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                                self._child_list_classes = {}

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                                self.hd_info.parent = self
                                                                                self._children_name_map["hd_info"] = "hd-info"
                                                                                self._children_yang_names.add("hd-info")

                                                                                self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                                self.info.parent = self
                                                                                self._children_name_map["info"] = "info"
                                                                                self._children_yang_names.add("info")
                                                                                self._segment_path = lambda: "child-policy"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                            class HdInfo(Entity):
                                                                                """
                                                                                hd info
                                                                                
                                                                                .. attribute:: data_hd
                                                                                
                                                                                	data hd
                                                                                	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                    self.yang_name = "hd-info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                    self._child_list_classes = {}

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                    self.data_hd.parent = self
                                                                                    self._children_name_map["data_hd"] = "data-hd"
                                                                                    self._children_yang_names.add("data-hd")
                                                                                    self._segment_path = lambda: "hd-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                                class DataHd(Entity):
                                                                                    """
                                                                                    data hd
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                        self.yang_name = "data-hd"
                                                                                        self.yang_parent_name = "hd-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}
                                                                                        self._segment_path = lambda: "data-hd"


                                                                            class Info(Entity):
                                                                                """
                                                                                info
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                    self.yang_name = "info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")
                                                                                    self._segment_path = lambda: "info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class CollectId(Entity):
                                                                            """
                                                                            collect id
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                                self.yang_name = "collect-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.id = YLeaf(YType.enumeration, "id")
                                                                                self._segment_path = lambda: "collect-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                        class Copy(Entity):
                                                                            """
                                                                            copy
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: num_byte
                                                                            
                                                                            	number of bytes
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node url
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                                self.yang_name = "copy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.app_id = YLeaf(YType.uint32, "app-id")

                                                                                self.local_id = YLeaf(YType.uint32, "local-id")

                                                                                self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                                self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                                self.sn_name = YLeaf(YType.str, "sn-name")

                                                                                self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                                self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                                self._segment_path = lambda: "copy"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                        class DeactTemplate(Entity):
                                                                            """
                                                                            deact template
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                                self.yang_name = "deact-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.template_name = YLeaf(YType.str, "template-name")
                                                                                self._segment_path = lambda: "deact-template"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                        class DecodeId(Entity):
                                                                            """
                                                                            decode id
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                                self.yang_name = "decode-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.format_name = YLeaf(YType.str, "format-name")

                                                                                self.id = YLeaf(YType.enumeration, "id")
                                                                                self._segment_path = lambda: "decode-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                        class Encap(Entity):
                                                                            """
                                                                            encap
                                                                            
                                                                            .. attribute:: seq
                                                                            
                                                                            	seq
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                                self.yang_name = "encap"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.seq = YLeaf(YType.uint8, "seq")
                                                                                self._segment_path = lambda: "encap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                        class FlowParm(Entity):
                                                                            """
                                                                            flow parm
                                                                            
                                                                            .. attribute:: flow_timeout
                                                                            
                                                                            	timeout in secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: intvl_hist
                                                                            
                                                                            	num intervals of data stored on rtr
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_mon_flows
                                                                            
                                                                            	max simult flows monitored per policy class
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: mon_interval
                                                                            
                                                                            	monitored interval duration in secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                                self.yang_name = "flow-parm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                                self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                                self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                                self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                                self._segment_path = lambda: "flow-parm"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                        class Fmm(Entity):
                                                                            """
                                                                            fmm
                                                                            
                                                                            .. attribute:: fmm_name
                                                                            
                                                                            	flow monitor name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..33
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                                self.yang_name = "fmm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                                self._segment_path = lambda: "fmm"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                        class Httpr(Entity):
                                                                            """
                                                                            httpr
                                                                            
                                                                            .. attribute:: redirect_url
                                                                            
                                                                            	redirect url
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                                self.yang_name = "httpr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                                self._segment_path = lambda: "httpr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                        class Ipcbr(Entity):
                                                                            """
                                                                            ipcbr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: media_bit_rate
                                                                            
                                                                            	media data rate in bps
                                                                            	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                            
                                                                            .. attribute:: media_pkt_size
                                                                            
                                                                            	media packet size in bytes
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: media_pkts_per_ip
                                                                            
                                                                            	media packets per ip pkt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                                self.yang_name = "ipcbr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                                self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")

                                                                                self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                                self.media_bit_rate.parent = self
                                                                                self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                                self._children_yang_names.add("media-bit-rate")
                                                                                self._segment_path = lambda: "ipcbr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                            class MediaBitRate(Entity):
                                                                                """
                                                                                media data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                    self.yang_name = "media-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "media-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                        class Ipv4Nh(Entity):
                                                                            """
                                                                            ipv4 nh
                                                                            
                                                                            .. attribute:: action_ipv4_nh_info_array
                                                                            
                                                                            	action ipv4 nh info array
                                                                            	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                                self.yang_name = "ipv4-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                                self.action_ipv4_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-nh"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                            class ActionIpv4NhInfoArray(Entity):
                                                                                """
                                                                                action ipv4 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	nh addr
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv4-nh-info-array"
                                                                                    self.yang_parent_name = "ipv4-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                    self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                    self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Ipv6Nh(Entity):
                                                                            """
                                                                            ipv6 nh
                                                                            
                                                                            .. attribute:: action_ipv6_nh_info_array
                                                                            
                                                                            	action ipv6 nh info array
                                                                            	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                                self.yang_name = "ipv6-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                                self.action_ipv6_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-nh"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                            class ActionIpv6NhInfoArray(Entity):
                                                                                """
                                                                                action ipv6 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	IPV6 Address
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv6-nh-info-array"
                                                                                    self.yang_parent_name = "ipv6-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                    self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                    self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: action_mark_info
                                                                            
                                                                            	action mark info
                                                                            	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                                self.action_mark_info = YList(self)
                                                                                self._segment_path = lambda: "mark"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                            class ActionMarkInfo(Entity):
                                                                                """
                                                                                action mark info
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                    self.yang_name = "action-mark-info"
                                                                                    self.yang_parent_name = "mark"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "action-mark-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                        class Mark2(Entity):
                                                                            """
                                                                            mark2
                                                                            
                                                                            .. attribute:: action_mark2_info
                                                                            
                                                                            	action mark2 info
                                                                            	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                                self.yang_name = "mark2"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                                self.action_mark2_info = YList(self)
                                                                                self._segment_path = lambda: "mark2"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                            class ActionMark2Info(Entity):
                                                                                """
                                                                                action mark2 info
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value_overflow
                                                                                
                                                                                	value overflow
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                    self.yang_name = "action-mark2-info"
                                                                                    self.yang_parent_name = "mark2"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                    self.type = YLeaf(YType.uint8, "type")

                                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                                    self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                    self._segment_path = lambda: "action-mark2-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                        class Mdi(Entity):
                                                                            """
                                                                            mdi
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                                self.yang_name = "mdi"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.pids = YLeafList(YType.uint32, "pids")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")
                                                                                self._segment_path = lambda: "mdi"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MdiRtp(Entity):
                                                                            """
                                                                            mdi rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                                self.yang_name = "mdi-rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.pids = YLeafList(YType.uint32, "pids")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")
                                                                                self._segment_path = lambda: "mdi-rtp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi-rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MinBw(Entity):
                                                                            """
                                                                            min bw
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                                self.yang_name = "min-bw"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                                self._child_list_classes = {}

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._children_yang_names.add("bw")
                                                                                self._segment_path = lambda: "min-bw"


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "min-bw"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bw"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                        class OutIntf(Entity):
                                                                            """
                                                                            out intf
                                                                            
                                                                            .. attribute:: out_ifname
                                                                            
                                                                            	output interface name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                                self.yang_name = "out-intf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                                self._segment_path = lambda: "out-intf"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                        class Pbf(Entity):
                                                                            """
                                                                            pbf
                                                                            
                                                                            .. attribute:: action_pbf_info_array
                                                                            
                                                                            	action pbf info array
                                                                            	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                                self.yang_name = "pbf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                                self.action_pbf_info_array = YList(self)
                                                                                self._segment_path = lambda: "pbf"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                            class ActionPbfInfoArray(Entity):
                                                                                """
                                                                                action pbf info array
                                                                                
                                                                                .. attribute:: addr
                                                                                
                                                                                	v4 or v6 address
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: rt
                                                                                
                                                                                	route target
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: rt_type
                                                                                
                                                                                	route target type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: vrf
                                                                                
                                                                                	vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                    self.yang_name = "action-pbf-info-array"
                                                                                    self.yang_parent_name = "pbf"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.addr = YLeaf(YType.str, "addr")

                                                                                    self.rt = YLeaf(YType.str, "rt")

                                                                                    self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                    self.vrf = YLeaf(YType.str, "vrf")
                                                                                    self._segment_path = lambda: "action-pbf-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                        class Pfc(Entity):
                                                                            """
                                                                            pfc
                                                                            
                                                                            .. attribute:: buffer_size
                                                                            
                                                                            	buffer size
                                                                            	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                            
                                                                            .. attribute:: buffer_size_flag
                                                                            
                                                                            	buffer size flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pause_threshold
                                                                            
                                                                            	pause threshold
                                                                            	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                            
                                                                            .. attribute:: pfc_pause_set
                                                                            
                                                                            	pfc pause set
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: resume_threshold
                                                                            
                                                                            	resume threshold
                                                                            	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                                self.yang_name = "pfc"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                                self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                                self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                                self.buffer_size.parent = self
                                                                                self._children_name_map["buffer_size"] = "buffer-size"
                                                                                self._children_yang_names.add("buffer-size")

                                                                                self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                                self.pause_threshold.parent = self
                                                                                self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                                self._children_yang_names.add("pause-threshold")

                                                                                self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                                self.resume_threshold.parent = self
                                                                                self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                                self._children_yang_names.add("resume-threshold")
                                                                                self._segment_path = lambda: "pfc"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                            class BufferSize(Entity):
                                                                                """
                                                                                buffer size
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                    self.yang_name = "buffer-size"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "buffer-size"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                            class PauseThreshold(Entity):
                                                                                """
                                                                                pause threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                    self.yang_name = "pause-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "pause-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                            class ResumeThreshold(Entity):
                                                                                """
                                                                                resume threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                    self.yang_name = "resume-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "resume-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                        class Police(Entity):
                                                                            """
                                                                            police
                                                                            
                                                                            .. attribute:: burst
                                                                            
                                                                            	burst
                                                                            	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                            
                                                                            .. attribute:: cdvt
                                                                            
                                                                            	cdvt
                                                                            	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                            
                                                                            .. attribute:: confclass_encode
                                                                            
                                                                            	confclass encode
                                                                            	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                            
                                                                            .. attribute:: confclass_p
                                                                            
                                                                            	confclass p
                                                                            	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                            
                                                                            .. attribute:: conform_actns
                                                                            
                                                                            	conform actns
                                                                            	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                            
                                                                            .. attribute:: excdclass_encode
                                                                            
                                                                            	excdclass encode
                                                                            	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                            
                                                                            .. attribute:: excdclass_p
                                                                            
                                                                            	excdclass p
                                                                            	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                            
                                                                            .. attribute:: exceed_actns
                                                                            
                                                                            	exceed actns
                                                                            	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: peak_burst
                                                                            
                                                                            	peak burst
                                                                            	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                            
                                                                            .. attribute:: peak_rate
                                                                            
                                                                            	peak rate
                                                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                            
                                                                            .. attribute:: police_flags
                                                                            
                                                                            	police flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                            
                                                                            .. attribute:: sbuck_name
                                                                            
                                                                            	sbuck name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: sbuck_type
                                                                            
                                                                            	sbuck type
                                                                            	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                            
                                                                            .. attribute:: violate_actns
                                                                            
                                                                            	violate actns
                                                                            	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                                self.yang_name = "police"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"burst" : ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                                self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                                self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                                self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                                self.burst.parent = self
                                                                                self._children_name_map["burst"] = "burst"
                                                                                self._children_yang_names.add("burst")

                                                                                self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                                self.cdvt.parent = self
                                                                                self._children_name_map["cdvt"] = "cdvt"
                                                                                self._children_yang_names.add("cdvt")

                                                                                self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                                self.confclass_encode.parent = self
                                                                                self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                                self._children_yang_names.add("confclass-encode")

                                                                                self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                                self.confclass_p.parent = self
                                                                                self._children_name_map["confclass_p"] = "confclass-p"
                                                                                self._children_yang_names.add("confclass-p")

                                                                                self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                                self.conform_actns.parent = self
                                                                                self._children_name_map["conform_actns"] = "conform-actns"
                                                                                self._children_yang_names.add("conform-actns")

                                                                                self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                                self.excdclass_encode.parent = self
                                                                                self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                                self._children_yang_names.add("excdclass-encode")

                                                                                self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                                self.excdclass_p.parent = self
                                                                                self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                                self._children_yang_names.add("excdclass-p")

                                                                                self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                                self.exceed_actns.parent = self
                                                                                self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                                self._children_yang_names.add("exceed-actns")

                                                                                self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                                self.peak_burst.parent = self
                                                                                self._children_name_map["peak_burst"] = "peak-burst"
                                                                                self._children_yang_names.add("peak-burst")

                                                                                self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                                self.peak_rate.parent = self
                                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                                                self._children_yang_names.add("peak-rate")

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._children_yang_names.add("rate")

                                                                                self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                                self.violate_actns.parent = self
                                                                                self._children_name_map["violate_actns"] = "violate-actns"
                                                                                self._children_yang_names.add("violate-actns")
                                                                                self._segment_path = lambda: "police"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                            class Burst(Entity):
                                                                                """
                                                                                burst
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                    self.yang_name = "burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "burst"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                            class Cdvt(Entity):
                                                                                """
                                                                                cdvt
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                    self.yang_name = "cdvt"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "cdvt"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                            class ConfclassEncode(Entity):
                                                                                """
                                                                                confclass encode
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                    self.yang_name = "confclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                    self._child_list_classes = {}

                                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._children_yang_names.add("inline-cmap")
                                                                                    self._segment_path = lambda: "confclass-encode"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "confclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "inline-cmap"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ConfclassP(Entity):
                                                                                """
                                                                                confclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                    self.yang_name = "confclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "confclass-p"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "confclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "class-map-bg"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ConformActns(Entity):
                                                                                """
                                                                                conform actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                    self.yang_name = "conform-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "conform-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "conform-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                            class ExcdclassEncode(Entity):
                                                                                """
                                                                                excdclass encode
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                    self.yang_name = "excdclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                    self._child_list_classes = {}

                                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._children_yang_names.add("inline-cmap")
                                                                                    self._segment_path = lambda: "excdclass-encode"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "excdclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "inline-cmap"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ExcdclassP(Entity):
                                                                                """
                                                                                excdclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                    self.yang_name = "excdclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "excdclass-p"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "excdclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "class-map-bg"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ExceedActns(Entity):
                                                                                """
                                                                                exceed actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                    self.yang_name = "exceed-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "exceed-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "exceed-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                            class PeakBurst(Entity):
                                                                                """
                                                                                peak burst
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                    self.yang_name = "peak-burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "peak-burst"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                            class PeakRate(Entity):
                                                                                """
                                                                                peak rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                    self.yang_name = "peak-rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "peak-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                            class ViolateActns(Entity):
                                                                                """
                                                                                violate actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                    self.yang_name = "violate-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "violate-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "violate-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PrepaidCfg(Entity):
                                                                            """
                                                                            prepaid cfg
                                                                            
                                                                            .. attribute:: prepaid_config_profile_name
                                                                            
                                                                            	prepaid config profile name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                                self.yang_name = "prepaid-cfg"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                                self._segment_path = lambda: "prepaid-cfg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                        class Prio(Entity):
                                                                            """
                                                                            prio
                                                                            
                                                                            .. attribute:: prio_lvl
                                                                            
                                                                            	prio lvl
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                                self.yang_name = "prio"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                                self._segment_path = lambda: "prio"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                        class ProxyAaa(Entity):
                                                                            """
                                                                            proxy aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                                self.yang_name = "proxy-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                                self._segment_path = lambda: "proxy-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                        class Punt(Entity):
                                                                            """
                                                                            punt
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                                self.yang_name = "punt"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.app_id = YLeaf(YType.uint32, "app-id")

                                                                                self.local_id = YLeaf(YType.uint32, "local-id")

                                                                                self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                                self.sn_name = YLeaf(YType.str, "sn-name")

                                                                                self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                                self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                                self._segment_path = lambda: "punt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                        class Qlimit(Entity):
                                                                            """
                                                                            qlimit
                                                                            
                                                                            .. attribute:: action_qlimit_info_array
                                                                            
                                                                            	action qlimit info array
                                                                            	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                                self.yang_name = "qlimit"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                                self.action_qlimit_info_array = YList(self)
                                                                                self._segment_path = lambda: "qlimit"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                            class ActionQlimitInfoArray(Entity):
                                                                                """
                                                                                action qlimit info array
                                                                                
                                                                                .. attribute:: atmclp_qlim
                                                                                
                                                                                	atmclp qlim
                                                                                	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                                
                                                                                .. attribute:: match_values
                                                                                
                                                                                	match values
                                                                                	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                                
                                                                                .. attribute:: qlim
                                                                                
                                                                                	qlim
                                                                                	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                                
                                                                                .. attribute:: qlimit_flags
                                                                                
                                                                                	qlimit flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                    self.yang_name = "action-qlimit-info-array"
                                                                                    self.yang_parent_name = "qlimit"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                    self._child_list_classes = {}

                                                                                    self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                    self.atmclp_qlim.parent = self
                                                                                    self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                    self._children_yang_names.add("atmclp-qlim")

                                                                                    self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                    self.match_values.parent = self
                                                                                    self._children_name_map["match_values"] = "match-values"
                                                                                    self._children_yang_names.add("match-values")

                                                                                    self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                    self.qlim.parent = self
                                                                                    self._children_name_map["qlim"] = "qlim"
                                                                                    self._children_yang_names.add("qlim")
                                                                                    self._segment_path = lambda: "action-qlimit-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                                class AtmclpQlim(Entity):
                                                                                    """
                                                                                    atmclp qlim
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                        self.yang_name = "atmclp-qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "atmclp-qlim"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                                class MatchValues(Entity):
                                                                                    """
                                                                                    match values
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                        self.yang_name = "match-values"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-values"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-values"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Qlim(Entity):
                                                                                    """
                                                                                    qlim
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                        self.yang_name = "qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "qlim"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                        class QueryAncp(Entity):
                                                                            """
                                                                            query ancp
                                                                            
                                                                            .. attribute:: enable
                                                                            
                                                                            	enable
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                                self.yang_name = "query-ancp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.enable = YLeaf(YType.uint8, "enable")
                                                                                self._segment_path = lambda: "query-ancp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                        class Redirect(Entity):
                                                                            """
                                                                            redirect
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                                self.yang_name = "redirect"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "redirect"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                        class Rtp(Entity):
                                                                            """
                                                                            rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                                self.yang_name = "rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpJ2K(Entity):
                                                                            """
                                                                            rtp j2k
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                                self.yang_name = "rtp-j2k"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-j2k"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-j2k"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpMmr(Entity):
                                                                            """
                                                                            rtp mmr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                                self.yang_name = "rtp-mmr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-mmr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-mmr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpVoice(Entity):
                                                                            """
                                                                            rtp voice
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                                self.yang_name = "rtp-voice"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-voice"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-voice"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class ServFunc(Entity):
                                                                            """
                                                                            serv func
                                                                            
                                                                            .. attribute:: meta_name
                                                                            
                                                                            	metadata name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: path_id
                                                                            
                                                                            	service path id
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: service_index
                                                                            
                                                                            	service path index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vs_index
                                                                            
                                                                            	vservice index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                                self.yang_name = "serv-func"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.meta_name = YLeaf(YType.str, "meta-name")

                                                                                self.path_id = YLeaf(YType.uint32, "path-id")

                                                                                self.service_index = YLeaf(YType.uint8, "service-index")

                                                                                self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                                self._segment_path = lambda: "serv-func"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                        class SetTimer(Entity):
                                                                            """
                                                                            set timer
                                                                            
                                                                            .. attribute:: absolute_time
                                                                            
                                                                            	absolute time
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: duration
                                                                            
                                                                            	duration
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                                self.yang_name = "set-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                                self.duration = YLeaf(YType.uint32, "duration")

                                                                                self.timer_name = YLeaf(YType.str, "timer-name")
                                                                                self._segment_path = lambda: "set-timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                        class Sfrag(Entity):
                                                                            """
                                                                            sfrag
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Service Fragment Name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                                self.yang_name = "sfrag"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")
                                                                                self._segment_path = lambda: "sfrag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                        class Shape(Entity):
                                                                            """
                                                                            shape
                                                                            
                                                                            .. attribute:: be
                                                                            
                                                                            	be
                                                                            	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                                self.yang_name = "shape"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"be" : ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                                self._child_list_classes = {}

                                                                                self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                                self.be.parent = self
                                                                                self._children_name_map["be"] = "be"
                                                                                self._children_yang_names.add("be")

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._children_yang_names.add("bw")
                                                                                self._segment_path = lambda: "shape"


                                                                            class Be(Entity):
                                                                                """
                                                                                be
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                    self.yang_name = "be"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "be"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bw"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                        class StopTimer(Entity):
                                                                            """
                                                                            stop timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                                self.yang_name = "stop-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.timer_name = YLeaf(YType.str, "timer-name")
                                                                                self._segment_path = lambda: "stop-timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                        class TimeoutIdle(Entity):
                                                                            """
                                                                            timeout idle
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                                self.yang_name = "timeout-idle"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.secs = YLeaf(YType.uint32, "secs")
                                                                                self._segment_path = lambda: "timeout-idle"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                        class Wred(Entity):
                                                                            """
                                                                            wred
                                                                            
                                                                            .. attribute:: action_wred_info
                                                                            
                                                                            	action wred info
                                                                            	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                                self.yang_name = "wred"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                                self.action_wred_info = YList(self)
                                                                                self._segment_path = lambda: "wred"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                            class ActionWredInfo(Entity):
                                                                                """
                                                                                action wred info
                                                                                
                                                                                .. attribute:: match_ranges
                                                                                
                                                                                	match ranges
                                                                                	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                                
                                                                                .. attribute:: max_threshold
                                                                                
                                                                                	max threshold
                                                                                	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                                
                                                                                .. attribute:: min_threshold
                                                                                
                                                                                	min threshold
                                                                                	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                                
                                                                                .. attribute:: probability
                                                                                
                                                                                	probability
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	cos/prec/dscp/ based WRED
                                                                                	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                                
                                                                                .. attribute:: wred_flags
                                                                                
                                                                                	wred flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                    self.yang_name = "action-wred-info"
                                                                                    self.yang_parent_name = "wred"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                    self._child_list_classes = {}

                                                                                    self.probability = YLeaf(YType.uint32, "probability")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                    self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                    self.match_ranges.parent = self
                                                                                    self._children_name_map["match_ranges"] = "match-ranges"
                                                                                    self._children_yang_names.add("match-ranges")

                                                                                    self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                    self.max_threshold.parent = self
                                                                                    self._children_name_map["max_threshold"] = "max-threshold"
                                                                                    self._children_yang_names.add("max-threshold")

                                                                                    self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                    self.min_threshold.parent = self
                                                                                    self._children_name_map["min_threshold"] = "min-threshold"
                                                                                    self._children_yang_names.add("min-threshold")
                                                                                    self._segment_path = lambda: "action-wred-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                                class MatchRanges(Entity):
                                                                                    """
                                                                                    match ranges
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                        self.yang_name = "match-ranges"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-ranges"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-ranges"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class MaxThreshold(Entity):
                                                                                    """
                                                                                    max threshold
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                        self.yang_name = "max-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "max-threshold"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                                class MinThreshold(Entity):
                                                                                    """
                                                                                    min threshold
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                        self.yang_name = "min-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "min-threshold"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                            class ClEncode(Entity):
                                                                """
                                                                cl encode
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	class name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                .. attribute:: hd
                                                                
                                                                	hd
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: idx
                                                                
                                                                	idx
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: inline_cmap
                                                                
                                                                	inline cmap
                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                    self.yang_name = "cl-encode"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                    self._child_list_classes = {}

                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                    self.inline_cmap.parent = self
                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                    self._children_yang_names.add("inline-cmap")
                                                                    self._segment_path = lambda: "cl-encode"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                class InlineCmap(Entity):
                                                                    """
                                                                    inline cmap
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Inline Class\-Map flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_count
                                                                    
                                                                    	Number of Match infos
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Inline Class\-Map Mode Match any/all
                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                        self.yang_name = "inline-cmap"
                                                                        self.yang_parent_name = "cl-encode"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._children_yang_names.add("match-infop")
                                                                        self._segment_path = lambda: "inline-cmap"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "inline-cmap"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._children_yang_names.add("match-data")
                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                    self._child_list_classes = {}

                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                    self._children_yang_names.add("access-interface")

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                    self._children_yang_names.add("atm-clp")

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                    self._children_yang_names.add("auth-domain")

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                    self._children_yang_names.add("auth-username")

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                    self._children_yang_names.add("avail-id")

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                    self._children_yang_names.add("circuit-id")

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"
                                                                                    self._children_yang_names.add("cos")

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                    self._children_yang_names.add("cos-inr")

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"
                                                                                    self._children_yang_names.add("dei")

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                    self._children_yang_names.add("dei-inr")

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                    self._children_yang_names.add("discard-class")

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                    self._children_yang_names.add("dnis")

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"
                                                                                    self._children_yang_names.add("domain")

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                    self._children_yang_names.add("domain-regex")

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                    self._children_yang_names.add("dscp")

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                    self._children_yang_names.add("dst-mac")

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._children_yang_names.add("dst-port")

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                    self._children_yang_names.add("ethertype")

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                    self._children_yang_names.add("flow-tag")

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                    self._children_yang_names.add("fr-de")

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                    self._children_yang_names.add("input-interface")

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                    self._children_yang_names.add("media-type")

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                    self._children_yang_names.add("nas-port")

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                    self._children_yang_names.add("packet-len")

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"
                                                                                    self._children_yang_names.add("prec")

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"
                                                                                    self._children_yang_names.add("proto")

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                    self._children_yang_names.add("qos-group")

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                    self._children_yang_names.add("remote-id")

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                    self._children_yang_names.add("service-name")

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                    self._children_yang_names.add("src-mac")

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                    self._children_yang_names.add("src-port")

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"
                                                                                    self._children_yang_names.add("timer")

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                    self._children_yang_names.add("traffic-class")

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                    self._children_yang_names.add("unauth-username")

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                    self._children_yang_names.add("user-name")

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                    self._children_yang_names.add("vendor-id")

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                    self._children_yang_names.add("vlan")

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                    self._segment_path = lambda: "match-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "access-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "avail-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "discard-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                        self._child_list_classes = {}

                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._children_yang_names.add("flow-keys")
                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "fr-de"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "input-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "media-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "src-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                            class ClmpP(Entity):
                                                                """
                                                                clmp p
                                                                
                                                                .. attribute:: class_map_bg
                                                                
                                                                	class map bg
                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                    self.yang_name = "clmp-p"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                    self.class_map_bg = YList(self)
                                                                    self._segment_path = lambda: "clmp-p"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                                class ClassMapBg(Entity):
                                                                    """
                                                                    class map bg
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	description
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Class\-Map Mode Match any/Match all
                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Name of the class\-map
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                        self.yang_name = "class-map-bg"
                                                                        self.yang_parent_name = "clmp-p"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                        self._child_list_classes = {}

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._children_yang_names.add("match-infop")
                                                                        self._segment_path = lambda: "class-map-bg"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "class-map-bg"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._children_yang_names.add("match-data")
                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                    self._child_list_classes = {}

                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                    self._children_yang_names.add("access-interface")

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                    self._children_yang_names.add("atm-clp")

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                    self._children_yang_names.add("auth-domain")

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                    self._children_yang_names.add("auth-username")

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                    self._children_yang_names.add("avail-id")

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                    self._children_yang_names.add("circuit-id")

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"
                                                                                    self._children_yang_names.add("cos")

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                    self._children_yang_names.add("cos-inr")

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"
                                                                                    self._children_yang_names.add("dei")

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                    self._children_yang_names.add("dei-inr")

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                    self._children_yang_names.add("discard-class")

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                    self._children_yang_names.add("dnis")

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"
                                                                                    self._children_yang_names.add("domain")

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                    self._children_yang_names.add("domain-regex")

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                    self._children_yang_names.add("dscp")

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                    self._children_yang_names.add("dst-mac")

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._children_yang_names.add("dst-port")

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                    self._children_yang_names.add("ethertype")

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                    self._children_yang_names.add("flow-tag")

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                    self._children_yang_names.add("fr-de")

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                    self._children_yang_names.add("input-interface")

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                    self._children_yang_names.add("media-type")

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                    self._children_yang_names.add("nas-port")

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                    self._children_yang_names.add("packet-len")

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"
                                                                                    self._children_yang_names.add("prec")

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"
                                                                                    self._children_yang_names.add("proto")

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                    self._children_yang_names.add("qos-group")

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                    self._children_yang_names.add("remote-id")

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                    self._children_yang_names.add("service-name")

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                    self._children_yang_names.add("src-mac")

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                    self._children_yang_names.add("src-port")

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"
                                                                                    self._children_yang_names.add("timer")

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                    self._children_yang_names.add("traffic-class")

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                    self._children_yang_names.add("unauth-username")

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                    self._children_yang_names.add("user-name")

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                    self._children_yang_names.add("vendor-id")

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                    self._children_yang_names.add("vlan")

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                    self._segment_path = lambda: "match-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "access-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "avail-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "discard-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                        self._child_list_classes = {}

                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._children_yang_names.add("flow-keys")
                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "fr-de"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "input-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "media-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "src-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                            class PmapVarList(Entity):
                                                """
                                                pmap var list
                                                
                                                .. attribute:: offset
                                                
                                                	offset
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: pmap_var_list_arr
                                                
                                                	pmap var list arr
                                                	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, self).__init__()

                                                    self.yang_name = "pmap-var-list"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                    self.offset = YLeafList(YType.uint8, "offset")

                                                    self.pmap_var_list_arr = YList(self)
                                                    self._segment_path = lambda: "pmap-var-list"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                                class PmapVarListArr(Entity):
                                                    """
                                                    pmap var list arr
                                                    
                                                    .. attribute:: id
                                                    
                                                    	id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..32
                                                    
                                                    .. attribute:: val
                                                    
                                                    	val
                                                    	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                        self.yang_name = "pmap-var-list-arr"
                                                        self.yang_parent_name = "pmap-var-list"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"val" : ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                        self._child_list_classes = {}

                                                        self.id = YLeaf(YType.uint32, "id")

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                        self.val.parent = self
                                                        self._children_name_map["val"] = "val"
                                                        self._children_yang_names.add("val")
                                                        self._segment_path = lambda: "pmap-var-list-arr"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                    class Val(Entity):
                                                        """
                                                        val
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: dscp_val
                                                        
                                                        	dscp val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: param_uint32_val
                                                        
                                                        	param uint32 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: prec_val
                                                        
                                                        	prec val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: type
                                                        
                                                        	type
                                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                        
                                                        .. attribute:: uint16_val
                                                        
                                                        	uint16 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: uint32_val
                                                        
                                                        	uint32 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: uint8_val
                                                        
                                                        	uint8 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                            self.yang_name = "val"
                                                            self.yang_parent_name = "pmap-var-list-arr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                            self.type = YLeaf(YType.enumeration, "type")

                                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                            self._segment_path = lambda: "val"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassHandles.ClassHandle.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class ClassSeqNums(Entity):
                                    """
                                    Transient policy\-map sequence number table
                                    
                                    .. attribute:: class_seq_num
                                    
                                    	Transient policy\-map sequence number
                                    	**type**\: list of    :py:class:`ClassSeqNum <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, self).__init__()

                                        self.yang_name = "class-seq-nums"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"class-seq-num" : ("class_seq_num", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum)}

                                        self.class_seq_num = YList(self)
                                        self._segment_path = lambda: "class-seq-nums"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums, [], name, value)


                                    class ClassSeqNum(Entity):
                                        """
                                        Transient policy\-map sequence number
                                        
                                        .. attribute:: sequence_num  <key>
                                        
                                        	sequence number
                                        	**type**\:  int
                                        
                                        	**range:** \-2147483648..2147483647
                                        
                                        .. attribute:: policy_map_bg
                                        
                                        	policy map bg
                                        	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, self).__init__()

                                            self.yang_name = "class-seq-num"
                                            self.yang_parent_name = "class-seq-nums"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg)}

                                            self.sequence_num = YLeaf(YType.int32, "sequence-num")

                                            self.policy_map_bg = YList(self)
                                            self._segment_path = lambda: "class-seq-num" + "[sequence-num='" + self.sequence_num.get() + "']"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum, ['sequence_num'], name, value)


                                        class PolicyMapBg(Entity):
                                            """
                                            policy map bg
                                            
                                            .. attribute:: description
                                            
                                            	description
                                            	**type**\:  str
                                            
                                            .. attribute:: event_infop
                                            
                                            	event infop
                                            	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop>`
                                            
                                            .. attribute:: name
                                            
                                            	name
                                            	**type**\:  str
                                            
                                            	**length:** 0..65
                                            
                                            .. attribute:: pmap_var_list
                                            
                                            	pmap var list
                                            	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList>`
                                            
                                            .. attribute:: type
                                            
                                            	type
                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, self).__init__()

                                                self.yang_name = "policy-map-bg"
                                                self.yang_parent_name = "class-seq-num"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList)}
                                                self._child_list_classes = {}

                                                self.description = YLeaf(YType.str, "description")

                                                self.name = YLeaf(YType.str, "name")

                                                self.type = YLeaf(YType.enumeration, "type")

                                                self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop()
                                                self.event_infop.parent = self
                                                self._children_name_map["event_infop"] = "event-infop"
                                                self._children_yang_names.add("event-infop")

                                                self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList()
                                                self.pmap_var_list.parent = self
                                                self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                                self._children_yang_names.add("pmap-var-list")
                                                self._segment_path = lambda: "policy-map-bg"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                            class EventInfop(Entity):
                                                """
                                                event infop
                                                
                                                .. attribute:: policy_event_info_bg
                                                
                                                	policy event info bg
                                                	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, self).__init__()

                                                    self.yang_name = "event-infop"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                    self.policy_event_info_bg = YList(self)
                                                    self._segment_path = lambda: "event-infop"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop, [], name, value)


                                                class PolicyEventInfoBg(Entity):
                                                    """
                                                    policy event info bg
                                                    
                                                    .. attribute:: avl_tree
                                                    
                                                    	avl tree
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..18446744073709551615
                                                    
                                                    .. attribute:: class_infop
                                                    
                                                    	class infop
                                                    	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                    
                                                    .. attribute:: cond_eval
                                                    
                                                    	cond eval
                                                    	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                    
                                                    .. attribute:: event_type
                                                    
                                                    	event type
                                                    	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                    
                                                    .. attribute:: flags
                                                    
                                                    	flags
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                        self.yang_name = "policy-event-info-bg"
                                                        self.yang_parent_name = "event-infop"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                        self._child_list_classes = {}

                                                        self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                        self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                        self.event_type = YLeaf(YType.enumeration, "event-type")

                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                        self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                        self.class_infop.parent = self
                                                        self._children_name_map["class_infop"] = "class-infop"
                                                        self._children_yang_names.add("class-infop")
                                                        self._segment_path = lambda: "policy-event-info-bg"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                    class ClassInfop(Entity):
                                                        """
                                                        class infop
                                                        
                                                        .. attribute:: policy_class_info_bg
                                                        
                                                        	policy class info bg
                                                        	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                            self.yang_name = "class-infop"
                                                            self.yang_parent_name = "policy-event-info-bg"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                            self.policy_class_info_bg = YList(self)
                                                            self._segment_path = lambda: "class-infop"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                        class PolicyClassInfoBg(Entity):
                                                            """
                                                            policy class info bg
                                                            
                                                            .. attribute:: act_infop
                                                            
                                                            	act infop
                                                            	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                            
                                                            .. attribute:: cl_encode
                                                            
                                                            	cl encode
                                                            	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                            
                                                            .. attribute:: clmp_p
                                                            
                                                            	clmp p
                                                            	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                            
                                                            .. attribute:: ctype
                                                            
                                                            	ctype
                                                            	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                            
                                                            .. attribute:: exe_strat
                                                            
                                                            	exe strat
                                                            	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                            
                                                            .. attribute:: flags
                                                            
                                                            	flags
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: num_actions
                                                            
                                                            	num actions
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..65535
                                                            
                                                            .. attribute:: policy_class_hd
                                                            
                                                            	policy class hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: seq
                                                            
                                                            	seq
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..4294967295
                                                            
                                                            .. attribute:: version
                                                            
                                                            	version
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                                self.yang_name = "policy-class-info-bg"
                                                                self.yang_parent_name = "class-infop"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                                self._child_list_classes = {}

                                                                self.ctype = YLeaf(YType.enumeration, "ctype")

                                                                self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                                self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                                self.seq = YLeaf(YType.uint32, "seq")

                                                                self.version = YLeaf(YType.uint8, "version")

                                                                self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                                self.act_infop.parent = self
                                                                self._children_name_map["act_infop"] = "act-infop"
                                                                self._children_yang_names.add("act-infop")

                                                                self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                                self.cl_encode.parent = self
                                                                self._children_name_map["cl_encode"] = "cl-encode"
                                                                self._children_yang_names.add("cl-encode")

                                                                self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                                self.clmp_p.parent = self
                                                                self._children_name_map["clmp_p"] = "clmp-p"
                                                                self._children_yang_names.add("clmp-p")
                                                                self._segment_path = lambda: "policy-class-info-bg"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                            class ActInfop(Entity):
                                                                """
                                                                act infop
                                                                
                                                                .. attribute:: policy_action_info_st
                                                                
                                                                	policy action info st
                                                                	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                    self.yang_name = "act-infop"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                    self.policy_action_info_st = YList(self)
                                                                    self._segment_path = lambda: "act-infop"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                                class PolicyActionInfoSt(Entity):
                                                                    """
                                                                    policy action info st
                                                                    
                                                                    .. attribute:: actp
                                                                    
                                                                    	actp
                                                                    	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    .. attribute:: seq
                                                                    
                                                                    	seq
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..65535
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                        self.yang_name = "policy-action-info-st"
                                                                        self.yang_parent_name = "act-infop"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"actp" : ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint16, "flags")

                                                                        self.seq = YLeaf(YType.uint16, "seq")

                                                                        self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                        self.actp.parent = self
                                                                        self._children_name_map["actp"] = "actp"
                                                                        self._children_yang_names.add("actp")
                                                                        self._segment_path = lambda: "policy-action-info-st"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                    class Actp(Entity):
                                                                        """
                                                                        actp
                                                                        
                                                                        .. attribute:: accounting_event_aaa
                                                                        
                                                                        	accounting event aaa
                                                                        	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                        
                                                                        .. attribute:: acct_aaa_list
                                                                        
                                                                        	acct aaa list
                                                                        	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                        
                                                                        .. attribute:: act_template
                                                                        
                                                                        	act template
                                                                        	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                        
                                                                        .. attribute:: afm_react
                                                                        
                                                                        	afm react
                                                                        	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                        
                                                                        .. attribute:: authen_aaa
                                                                        
                                                                        	authen aaa
                                                                        	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                        
                                                                        .. attribute:: authorize_id
                                                                        
                                                                        	authorize id
                                                                        	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                        
                                                                        .. attribute:: cac
                                                                        
                                                                        	cac
                                                                        	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                        
                                                                        .. attribute:: child_policy
                                                                        
                                                                        	child policy
                                                                        	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                        
                                                                        .. attribute:: collect_id
                                                                        
                                                                        	collect id
                                                                        	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                        
                                                                        .. attribute:: copy
                                                                        
                                                                        	copy
                                                                        	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                        
                                                                        .. attribute:: data_p
                                                                        
                                                                        	data p
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: deact_template
                                                                        
                                                                        	deact template
                                                                        	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                        
                                                                        .. attribute:: decode_id
                                                                        
                                                                        	decode id
                                                                        	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                        
                                                                        .. attribute:: encap
                                                                        
                                                                        	encap
                                                                        	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                        
                                                                        .. attribute:: flow_parm
                                                                        
                                                                        	flow parm
                                                                        	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                        
                                                                        .. attribute:: fmm
                                                                        
                                                                        	fmm
                                                                        	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                        
                                                                        .. attribute:: httpr
                                                                        
                                                                        	httpr
                                                                        	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                        
                                                                        .. attribute:: ipcbr
                                                                        
                                                                        	ipcbr
                                                                        	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                        
                                                                        .. attribute:: ipv4_nh
                                                                        
                                                                        	ipv4 nh
                                                                        	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                        
                                                                        .. attribute:: ipv6_nh
                                                                        
                                                                        	ipv6 nh
                                                                        	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                        
                                                                        .. attribute:: mark
                                                                        
                                                                        	mark
                                                                        	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                        
                                                                        .. attribute:: mark2
                                                                        
                                                                        	mark2
                                                                        	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                        
                                                                        .. attribute:: mdi
                                                                        
                                                                        	mdi
                                                                        	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                        
                                                                        .. attribute:: mdi_rtp
                                                                        
                                                                        	mdi rtp
                                                                        	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                        
                                                                        .. attribute:: min_bw
                                                                        
                                                                        	min bw
                                                                        	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                        
                                                                        .. attribute:: out_intf
                                                                        
                                                                        	out intf
                                                                        	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                        
                                                                        .. attribute:: pbf
                                                                        
                                                                        	pbf
                                                                        	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                        
                                                                        .. attribute:: pfc
                                                                        
                                                                        	pfc
                                                                        	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                        
                                                                        .. attribute:: police
                                                                        
                                                                        	police
                                                                        	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                        
                                                                        .. attribute:: prepaid_cfg
                                                                        
                                                                        	prepaid cfg
                                                                        	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                        
                                                                        .. attribute:: prio
                                                                        
                                                                        	prio
                                                                        	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                        
                                                                        .. attribute:: proxy_aaa
                                                                        
                                                                        	proxy aaa
                                                                        	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                        
                                                                        .. attribute:: punt
                                                                        
                                                                        	punt
                                                                        	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                        
                                                                        .. attribute:: qlimit
                                                                        
                                                                        	qlimit
                                                                        	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                        
                                                                        .. attribute:: query_ancp
                                                                        
                                                                        	query ancp
                                                                        	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                        
                                                                        .. attribute:: redirect
                                                                        
                                                                        	redirect
                                                                        	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                        
                                                                        .. attribute:: rtp
                                                                        
                                                                        	rtp
                                                                        	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                        
                                                                        .. attribute:: rtp_j2k
                                                                        
                                                                        	rtp j2k
                                                                        	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                        
                                                                        .. attribute:: rtp_mmr
                                                                        
                                                                        	rtp mmr
                                                                        	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                        
                                                                        .. attribute:: rtp_voice
                                                                        
                                                                        	rtp voice
                                                                        	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                        
                                                                        .. attribute:: serv_func
                                                                        
                                                                        	serv func
                                                                        	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                        
                                                                        .. attribute:: set_timer
                                                                        
                                                                        	set timer
                                                                        	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                        
                                                                        .. attribute:: sfrag
                                                                        
                                                                        	sfrag
                                                                        	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                        
                                                                        .. attribute:: shape
                                                                        
                                                                        	shape
                                                                        	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                        
                                                                        .. attribute:: stop_timer
                                                                        
                                                                        	stop timer
                                                                        	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                        
                                                                        .. attribute:: timeout_idle
                                                                        
                                                                        	timeout idle
                                                                        	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: wred
                                                                        
                                                                        	wred
                                                                        	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                            self.yang_name = "actp"
                                                                            self.yang_parent_name = "policy-action-info-st"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                            self._child_list_classes = {}

                                                                            self.data_p = YLeaf(YType.uint32, "data-p")

                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                            self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                            self.accounting_event_aaa.parent = self
                                                                            self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                            self._children_yang_names.add("accounting-event-aaa")

                                                                            self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                            self.acct_aaa_list.parent = self
                                                                            self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                            self._children_yang_names.add("acct-aaa-list")

                                                                            self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                            self.act_template.parent = self
                                                                            self._children_name_map["act_template"] = "act-template"
                                                                            self._children_yang_names.add("act-template")

                                                                            self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                            self.afm_react.parent = self
                                                                            self._children_name_map["afm_react"] = "afm-react"
                                                                            self._children_yang_names.add("afm-react")

                                                                            self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                            self.authen_aaa.parent = self
                                                                            self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                            self._children_yang_names.add("authen-aaa")

                                                                            self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                            self.authorize_id.parent = self
                                                                            self._children_name_map["authorize_id"] = "authorize-id"
                                                                            self._children_yang_names.add("authorize-id")

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")

                                                                            self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                            self.cac.parent = self
                                                                            self._children_name_map["cac"] = "cac"
                                                                            self._children_yang_names.add("cac")

                                                                            self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                            self.child_policy.parent = self
                                                                            self._children_name_map["child_policy"] = "child-policy"
                                                                            self._children_yang_names.add("child-policy")

                                                                            self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                            self.collect_id.parent = self
                                                                            self._children_name_map["collect_id"] = "collect-id"
                                                                            self._children_yang_names.add("collect-id")

                                                                            self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                            self.copy.parent = self
                                                                            self._children_name_map["copy"] = "copy"
                                                                            self._children_yang_names.add("copy")

                                                                            self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                            self.deact_template.parent = self
                                                                            self._children_name_map["deact_template"] = "deact-template"
                                                                            self._children_yang_names.add("deact-template")

                                                                            self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                            self.decode_id.parent = self
                                                                            self._children_name_map["decode_id"] = "decode-id"
                                                                            self._children_yang_names.add("decode-id")

                                                                            self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                            self.encap.parent = self
                                                                            self._children_name_map["encap"] = "encap"
                                                                            self._children_yang_names.add("encap")

                                                                            self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                            self.flow_parm.parent = self
                                                                            self._children_name_map["flow_parm"] = "flow-parm"
                                                                            self._children_yang_names.add("flow-parm")

                                                                            self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                            self.fmm.parent = self
                                                                            self._children_name_map["fmm"] = "fmm"
                                                                            self._children_yang_names.add("fmm")

                                                                            self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                            self.httpr.parent = self
                                                                            self._children_name_map["httpr"] = "httpr"
                                                                            self._children_yang_names.add("httpr")

                                                                            self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                            self.ipcbr.parent = self
                                                                            self._children_name_map["ipcbr"] = "ipcbr"
                                                                            self._children_yang_names.add("ipcbr")

                                                                            self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                            self.ipv4_nh.parent = self
                                                                            self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                            self._children_yang_names.add("ipv4-nh")

                                                                            self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                            self.ipv6_nh.parent = self
                                                                            self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                            self._children_yang_names.add("ipv6-nh")

                                                                            self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                            self.mark.parent = self
                                                                            self._children_name_map["mark"] = "mark"
                                                                            self._children_yang_names.add("mark")

                                                                            self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                            self.mark2.parent = self
                                                                            self._children_name_map["mark2"] = "mark2"
                                                                            self._children_yang_names.add("mark2")

                                                                            self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                            self.mdi.parent = self
                                                                            self._children_name_map["mdi"] = "mdi"
                                                                            self._children_yang_names.add("mdi")

                                                                            self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                            self.mdi_rtp.parent = self
                                                                            self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                            self._children_yang_names.add("mdi-rtp")

                                                                            self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                            self.min_bw.parent = self
                                                                            self._children_name_map["min_bw"] = "min-bw"
                                                                            self._children_yang_names.add("min-bw")

                                                                            self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                            self.out_intf.parent = self
                                                                            self._children_name_map["out_intf"] = "out-intf"
                                                                            self._children_yang_names.add("out-intf")

                                                                            self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                            self.pbf.parent = self
                                                                            self._children_name_map["pbf"] = "pbf"
                                                                            self._children_yang_names.add("pbf")

                                                                            self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                            self.pfc.parent = self
                                                                            self._children_name_map["pfc"] = "pfc"
                                                                            self._children_yang_names.add("pfc")

                                                                            self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                            self.police.parent = self
                                                                            self._children_name_map["police"] = "police"
                                                                            self._children_yang_names.add("police")

                                                                            self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                            self.prepaid_cfg.parent = self
                                                                            self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                            self._children_yang_names.add("prepaid-cfg")

                                                                            self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                            self.prio.parent = self
                                                                            self._children_name_map["prio"] = "prio"
                                                                            self._children_yang_names.add("prio")

                                                                            self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                            self.proxy_aaa.parent = self
                                                                            self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                            self._children_yang_names.add("proxy-aaa")

                                                                            self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                            self.punt.parent = self
                                                                            self._children_name_map["punt"] = "punt"
                                                                            self._children_yang_names.add("punt")

                                                                            self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                            self.qlimit.parent = self
                                                                            self._children_name_map["qlimit"] = "qlimit"
                                                                            self._children_yang_names.add("qlimit")

                                                                            self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                            self.query_ancp.parent = self
                                                                            self._children_name_map["query_ancp"] = "query-ancp"
                                                                            self._children_yang_names.add("query-ancp")

                                                                            self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                            self.redirect.parent = self
                                                                            self._children_name_map["redirect"] = "redirect"
                                                                            self._children_yang_names.add("redirect")

                                                                            self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                            self.rtp.parent = self
                                                                            self._children_name_map["rtp"] = "rtp"
                                                                            self._children_yang_names.add("rtp")

                                                                            self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                            self.rtp_j2k.parent = self
                                                                            self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                            self._children_yang_names.add("rtp-j2k")

                                                                            self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                            self.rtp_mmr.parent = self
                                                                            self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                            self._children_yang_names.add("rtp-mmr")

                                                                            self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                            self.rtp_voice.parent = self
                                                                            self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                            self._children_yang_names.add("rtp-voice")

                                                                            self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                            self.serv_func.parent = self
                                                                            self._children_name_map["serv_func"] = "serv-func"
                                                                            self._children_yang_names.add("serv-func")

                                                                            self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                            self.set_timer.parent = self
                                                                            self._children_name_map["set_timer"] = "set-timer"
                                                                            self._children_yang_names.add("set-timer")

                                                                            self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                            self.sfrag.parent = self
                                                                            self._children_name_map["sfrag"] = "sfrag"
                                                                            self._children_yang_names.add("sfrag")

                                                                            self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                            self.shape.parent = self
                                                                            self._children_name_map["shape"] = "shape"
                                                                            self._children_yang_names.add("shape")

                                                                            self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                            self.stop_timer.parent = self
                                                                            self._children_name_map["stop_timer"] = "stop-timer"
                                                                            self._children_yang_names.add("stop-timer")

                                                                            self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                            self.timeout_idle.parent = self
                                                                            self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                            self._children_yang_names.add("timeout-idle")

                                                                            self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                            self.wred.parent = self
                                                                            self._children_name_map["wred"] = "wred"
                                                                            self._children_yang_names.add("wred")
                                                                            self._segment_path = lambda: "actp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                        class AccountingEventAaa(Entity):
                                                                            """
                                                                            accounting event aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: action
                                                                            
                                                                            	action
                                                                            	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                                self.yang_name = "accounting-event-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.action = YLeaf(YType.enumeration, "action")
                                                                                self._segment_path = lambda: "accounting-event-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                        class AcctAaaList(Entity):
                                                                            """
                                                                            acct aaa list
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                                self.yang_name = "acct-aaa-list"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.secs = YLeaf(YType.uint32, "secs")
                                                                                self._segment_path = lambda: "acct-aaa-list"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                        class ActTemplate(Entity):
                                                                            """
                                                                            act template
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                                self.yang_name = "act-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.template_name = YLeaf(YType.str, "template-name")
                                                                                self._segment_path = lambda: "act-template"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                        class AfmReact(Entity):
                                                                            """
                                                                            afm react
                                                                            
                                                                            .. attribute:: action_afmon_react_info
                                                                            
                                                                            	action afmon react info
                                                                            	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                                self.yang_name = "afm-react"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                                self.action_afmon_react_info = YList(self)
                                                                                self._segment_path = lambda: "afm-react"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                            class ActionAfmonReactInfo(Entity):
                                                                                """
                                                                                action afmon react info
                                                                                
                                                                                .. attribute:: alm_grp_thresh
                                                                                
                                                                                	Num/percent in grp
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: percentage
                                                                                
                                                                                .. attribute:: alm_severity
                                                                                
                                                                                	Major\|Minor\|... alarm
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: alm_type
                                                                                
                                                                                	Discrete \| grouped alarm
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: clone_ifh
                                                                                
                                                                                	Clone interface handle
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: criterion
                                                                                
                                                                                	React Criterion
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	Describing the oper
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: notif_actns
                                                                                
                                                                                	Bitmap of actions on alert
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: oper_id
                                                                                
                                                                                	React Operation ID
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: trig_level_1
                                                                                
                                                                                	Trigger threshold 1/lower
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: trig_level_2
                                                                                
                                                                                	Trigger upper threshold for range
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: trig_num_intvls
                                                                                
                                                                                	Averaged over N intvls
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: trig_relop
                                                                                
                                                                                	Trigger LT\|LE\|GT\|GE\|Range
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: trig_type
                                                                                
                                                                                	Immediate or averaged thresh trigger
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                    self.yang_name = "action-afmon-react-info"
                                                                                    self.yang_parent_name = "afm-react"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                    self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                    self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                    self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                    self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                    self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                    self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                    self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                    self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                    self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                    self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                    self._segment_path = lambda: "action-afmon-react-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                        class AuthenAaa(Entity):
                                                                            """
                                                                            authen aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: authen_password
                                                                            
                                                                            	authen password
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                                self.yang_name = "authen-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.authen_password = YLeaf(YType.str, "authen-password")
                                                                                self._segment_path = lambda: "authen-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                        class AuthorizeId(Entity):
                                                                            """
                                                                            authorize id
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: password
                                                                            
                                                                            	password
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                                self.yang_name = "authorize-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.format_name = YLeaf(YType.str, "format-name")

                                                                                self.id = YLeaf(YType.uint8, "id")

                                                                                self.password = YLeaf(YType.str, "password")
                                                                                self._segment_path = lambda: "authorize-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: bwrem
                                                                            
                                                                            	bwrem
                                                                            	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                                self._child_list_classes = {}

                                                                                self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                                self.bwrem.parent = self
                                                                                self._children_name_map["bwrem"] = "bwrem"
                                                                                self._children_yang_names.add("bwrem")
                                                                                self._segment_path = lambda: "bwrem"


                                                                            class Bwrem(Entity):
                                                                                """
                                                                                bwrem
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                    self.yang_name = "bwrem"
                                                                                    self.yang_parent_name = "bwrem"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bwrem"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                        class Cac(Entity):
                                                                            """
                                                                            cac
                                                                            
                                                                            .. attribute:: cac_type
                                                                            
                                                                            	cac type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: flow_rate
                                                                            
                                                                            	flow rate
                                                                            	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                            
                                                                            .. attribute:: idle_timeout
                                                                            
                                                                            	idle timeout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                                self.yang_name = "cac"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                                self._child_list_classes = {}

                                                                                self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                                self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                                self.flow_rate.parent = self
                                                                                self._children_name_map["flow_rate"] = "flow-rate"
                                                                                self._children_yang_names.add("flow-rate")

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._children_yang_names.add("rate")
                                                                                self._segment_path = lambda: "cac"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                            class FlowRate(Entity):
                                                                                """
                                                                                flow rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                    self.yang_name = "flow-rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "flow-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "cac"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                        class ChildPolicy(Entity):
                                                                            """
                                                                            child policy
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd_info
                                                                            
                                                                            	hd info
                                                                            	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                            
                                                                            .. attribute:: info
                                                                            
                                                                            	info
                                                                            	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                                self.yang_name = "child-policy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                                self._child_list_classes = {}

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                                self.hd_info.parent = self
                                                                                self._children_name_map["hd_info"] = "hd-info"
                                                                                self._children_yang_names.add("hd-info")

                                                                                self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                                self.info.parent = self
                                                                                self._children_name_map["info"] = "info"
                                                                                self._children_yang_names.add("info")
                                                                                self._segment_path = lambda: "child-policy"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                            class HdInfo(Entity):
                                                                                """
                                                                                hd info
                                                                                
                                                                                .. attribute:: data_hd
                                                                                
                                                                                	data hd
                                                                                	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                    self.yang_name = "hd-info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                    self._child_list_classes = {}

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                    self.data_hd.parent = self
                                                                                    self._children_name_map["data_hd"] = "data-hd"
                                                                                    self._children_yang_names.add("data-hd")
                                                                                    self._segment_path = lambda: "hd-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                                class DataHd(Entity):
                                                                                    """
                                                                                    data hd
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                        self.yang_name = "data-hd"
                                                                                        self.yang_parent_name = "hd-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}
                                                                                        self._segment_path = lambda: "data-hd"


                                                                            class Info(Entity):
                                                                                """
                                                                                info
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                    self.yang_name = "info"
                                                                                    self.yang_parent_name = "child-policy"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")
                                                                                    self._segment_path = lambda: "info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                        class CollectId(Entity):
                                                                            """
                                                                            collect id
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                                self.yang_name = "collect-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.id = YLeaf(YType.enumeration, "id")
                                                                                self._segment_path = lambda: "collect-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                        class Copy(Entity):
                                                                            """
                                                                            copy
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: num_byte
                                                                            
                                                                            	number of bytes
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node url
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                                self.yang_name = "copy"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.app_id = YLeaf(YType.uint32, "app-id")

                                                                                self.local_id = YLeaf(YType.uint32, "local-id")

                                                                                self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                                self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                                self.sn_name = YLeaf(YType.str, "sn-name")

                                                                                self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                                self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                                self._segment_path = lambda: "copy"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                        class DeactTemplate(Entity):
                                                                            """
                                                                            deact template
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: template_name
                                                                            
                                                                            	template name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                                self.yang_name = "deact-template"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.template_name = YLeaf(YType.str, "template-name")
                                                                                self._segment_path = lambda: "deact-template"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                        class DecodeId(Entity):
                                                                            """
                                                                            decode id
                                                                            
                                                                            .. attribute:: format_name
                                                                            
                                                                            	format name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: id
                                                                            
                                                                            	id
                                                                            	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                                self.yang_name = "decode-id"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.format_name = YLeaf(YType.str, "format-name")

                                                                                self.id = YLeaf(YType.enumeration, "id")
                                                                                self._segment_path = lambda: "decode-id"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                        class Encap(Entity):
                                                                            """
                                                                            encap
                                                                            
                                                                            .. attribute:: seq
                                                                            
                                                                            	seq
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                                self.yang_name = "encap"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.seq = YLeaf(YType.uint8, "seq")
                                                                                self._segment_path = lambda: "encap"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                        class FlowParm(Entity):
                                                                            """
                                                                            flow parm
                                                                            
                                                                            .. attribute:: flow_timeout
                                                                            
                                                                            	timeout in secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            .. attribute:: intvl_hist
                                                                            
                                                                            	num intervals of data stored on rtr
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_mon_flows
                                                                            
                                                                            	max simult flows monitored per policy class
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: mon_interval
                                                                            
                                                                            	monitored interval duration in secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: second
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                                self.yang_name = "flow-parm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                                self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                                self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                                self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                                self._segment_path = lambda: "flow-parm"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                        class Fmm(Entity):
                                                                            """
                                                                            fmm
                                                                            
                                                                            .. attribute:: fmm_name
                                                                            
                                                                            	flow monitor name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..33
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                                self.yang_name = "fmm"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                                self._segment_path = lambda: "fmm"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                        class Httpr(Entity):
                                                                            """
                                                                            httpr
                                                                            
                                                                            .. attribute:: redirect_url
                                                                            
                                                                            	redirect url
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                                self.yang_name = "httpr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                                self._segment_path = lambda: "httpr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                        class Ipcbr(Entity):
                                                                            """
                                                                            ipcbr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: media_bit_rate
                                                                            
                                                                            	media data rate in bps
                                                                            	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                            
                                                                            .. attribute:: media_pkt_size
                                                                            
                                                                            	media packet size in bytes
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            	**units**\: byte
                                                                            
                                                                            .. attribute:: media_pkts_per_ip
                                                                            
                                                                            	media packets per ip pkt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                                self.yang_name = "ipcbr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                                self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")

                                                                                self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                                self.media_bit_rate.parent = self
                                                                                self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                                self._children_yang_names.add("media-bit-rate")
                                                                                self._segment_path = lambda: "ipcbr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                            class MediaBitRate(Entity):
                                                                                """
                                                                                media data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                    self.yang_name = "media-bit-rate"
                                                                                    self.yang_parent_name = "ipcbr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "media-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                        class Ipv4Nh(Entity):
                                                                            """
                                                                            ipv4 nh
                                                                            
                                                                            .. attribute:: action_ipv4_nh_info_array
                                                                            
                                                                            	action ipv4 nh info array
                                                                            	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                                self.yang_name = "ipv4-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                                self.action_ipv4_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv4-nh"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                            class ActionIpv4NhInfoArray(Entity):
                                                                                """
                                                                                action ipv4 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	nh addr
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv4-nh-info-array"
                                                                                    self.yang_parent_name = "ipv4-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                    self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                    self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Ipv6Nh(Entity):
                                                                            """
                                                                            ipv6 nh
                                                                            
                                                                            .. attribute:: action_ipv6_nh_info_array
                                                                            
                                                                            	action ipv6 nh info array
                                                                            	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                                self.yang_name = "ipv6-nh"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                                self.action_ipv6_nh_info_array = YList(self)
                                                                                self._segment_path = lambda: "ipv6-nh"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                            class ActionIpv6NhInfoArray(Entity):
                                                                                """
                                                                                action ipv6 nh info array
                                                                                
                                                                                .. attribute:: nh_addr
                                                                                
                                                                                	IPV6 Address
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: vrf_name
                                                                                
                                                                                	Vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                    self.yang_name = "action-ipv6-nh-info-array"
                                                                                    self.yang_parent_name = "ipv6-nh"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                    self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                    self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                        class Mark(Entity):
                                                                            """
                                                                            mark
                                                                            
                                                                            .. attribute:: action_mark_info
                                                                            
                                                                            	action mark info
                                                                            	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                                self.yang_name = "mark"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                                self.action_mark_info = YList(self)
                                                                                self._segment_path = lambda: "mark"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                            class ActionMarkInfo(Entity):
                                                                                """
                                                                                action mark info
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                    self.yang_name = "action-mark-info"
                                                                                    self.yang_parent_name = "mark"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "action-mark-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                        class Mark2(Entity):
                                                                            """
                                                                            mark2
                                                                            
                                                                            .. attribute:: action_mark2_info
                                                                            
                                                                            	action mark2 info
                                                                            	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                                self.yang_name = "mark2"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                                self.action_mark2_info = YList(self)
                                                                                self._segment_path = lambda: "mark2"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                            class ActionMark2Info(Entity):
                                                                                """
                                                                                action mark2 info
                                                                                
                                                                                .. attribute:: mark_flags
                                                                                
                                                                                	mark flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: value_overflow
                                                                                
                                                                                	value overflow
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                    self.yang_name = "action-mark2-info"
                                                                                    self.yang_parent_name = "mark2"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                    self.type = YLeaf(YType.uint8, "type")

                                                                                    self.value = YLeaf(YType.uint32, "value")

                                                                                    self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                    self._segment_path = lambda: "action-mark2-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                        class Mdi(Entity):
                                                                            """
                                                                            mdi
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                                self.yang_name = "mdi"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.pids = YLeafList(YType.uint32, "pids")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")
                                                                                self._segment_path = lambda: "mdi"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MdiRtp(Entity):
                                                                            """
                                                                            mdi rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: filtered_pkt_rate
                                                                            
                                                                            	filtered packet rate
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: ip_bit_rate
                                                                            
                                                                            	data rate in bps
                                                                            	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                            
                                                                            .. attribute:: ip_pkt_rate
                                                                            
                                                                            	packet rate in pps
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pids
                                                                            
                                                                            	array of monitoredcd  pids
                                                                            	**type**\:  list of int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                                self.yang_name = "mdi-rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                                self._child_list_classes = {}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                                self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                                self.pids = YLeafList(YType.uint32, "pids")

                                                                                self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                                self.ip_bit_rate.parent = self
                                                                                self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                                self._children_yang_names.add("ip-bit-rate")
                                                                                self._segment_path = lambda: "mdi-rtp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                            class IpBitRate(Entity):
                                                                                """
                                                                                data rate in bps
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                    self.yang_name = "ip-bit-rate"
                                                                                    self.yang_parent_name = "mdi-rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "ip-bit-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MinBw(Entity):
                                                                            """
                                                                            min bw
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                                self.yang_name = "min-bw"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                                self._child_list_classes = {}

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._children_yang_names.add("bw")
                                                                                self._segment_path = lambda: "min-bw"


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "min-bw"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bw"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                        class OutIntf(Entity):
                                                                            """
                                                                            out intf
                                                                            
                                                                            .. attribute:: out_ifname
                                                                            
                                                                            	output interface name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                                self.yang_name = "out-intf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                                self._segment_path = lambda: "out-intf"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                        class Pbf(Entity):
                                                                            """
                                                                            pbf
                                                                            
                                                                            .. attribute:: action_pbf_info_array
                                                                            
                                                                            	action pbf info array
                                                                            	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                                self.yang_name = "pbf"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                                self.action_pbf_info_array = YList(self)
                                                                                self._segment_path = lambda: "pbf"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                            class ActionPbfInfoArray(Entity):
                                                                                """
                                                                                action pbf info array
                                                                                
                                                                                .. attribute:: addr
                                                                                
                                                                                	v4 or v6 address
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                
                                                                                .. attribute:: rt
                                                                                
                                                                                	route target
                                                                                	**type**\:  str
                                                                                
                                                                                	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                
                                                                                .. attribute:: rt_type
                                                                                
                                                                                	route target type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: vrf
                                                                                
                                                                                	vrf name
                                                                                	**type**\:  str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                    self.yang_name = "action-pbf-info-array"
                                                                                    self.yang_parent_name = "pbf"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.addr = YLeaf(YType.str, "addr")

                                                                                    self.rt = YLeaf(YType.str, "rt")

                                                                                    self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                    self.vrf = YLeaf(YType.str, "vrf")
                                                                                    self._segment_path = lambda: "action-pbf-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                        class Pfc(Entity):
                                                                            """
                                                                            pfc
                                                                            
                                                                            .. attribute:: buffer_size
                                                                            
                                                                            	buffer size
                                                                            	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                            
                                                                            .. attribute:: buffer_size_flag
                                                                            
                                                                            	buffer size flag
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pause_threshold
                                                                            
                                                                            	pause threshold
                                                                            	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                            
                                                                            .. attribute:: pfc_pause_set
                                                                            
                                                                            	pfc pause set
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: resume_threshold
                                                                            
                                                                            	resume threshold
                                                                            	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                                self.yang_name = "pfc"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                                self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                                self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                                self.buffer_size.parent = self
                                                                                self._children_name_map["buffer_size"] = "buffer-size"
                                                                                self._children_yang_names.add("buffer-size")

                                                                                self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                                self.pause_threshold.parent = self
                                                                                self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                                self._children_yang_names.add("pause-threshold")

                                                                                self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                                self.resume_threshold.parent = self
                                                                                self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                                self._children_yang_names.add("resume-threshold")
                                                                                self._segment_path = lambda: "pfc"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                            class BufferSize(Entity):
                                                                                """
                                                                                buffer size
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                    self.yang_name = "buffer-size"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "buffer-size"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                            class PauseThreshold(Entity):
                                                                                """
                                                                                pause threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                    self.yang_name = "pause-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "pause-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                            class ResumeThreshold(Entity):
                                                                                """
                                                                                resume threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                    self.yang_name = "resume-threshold"
                                                                                    self.yang_parent_name = "pfc"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "resume-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                        class Police(Entity):
                                                                            """
                                                                            police
                                                                            
                                                                            .. attribute:: burst
                                                                            
                                                                            	burst
                                                                            	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                            
                                                                            .. attribute:: cdvt
                                                                            
                                                                            	cdvt
                                                                            	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                            
                                                                            .. attribute:: confclass_encode
                                                                            
                                                                            	confclass encode
                                                                            	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                            
                                                                            .. attribute:: confclass_p
                                                                            
                                                                            	confclass p
                                                                            	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                            
                                                                            .. attribute:: conform_actns
                                                                            
                                                                            	conform actns
                                                                            	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                            
                                                                            .. attribute:: excdclass_encode
                                                                            
                                                                            	excdclass encode
                                                                            	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                            
                                                                            .. attribute:: excdclass_p
                                                                            
                                                                            	excdclass p
                                                                            	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                            
                                                                            .. attribute:: exceed_actns
                                                                            
                                                                            	exceed actns
                                                                            	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: peak_burst
                                                                            
                                                                            	peak burst
                                                                            	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                            
                                                                            .. attribute:: peak_rate
                                                                            
                                                                            	peak rate
                                                                            	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                            
                                                                            .. attribute:: police_flags
                                                                            
                                                                            	police flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: rate
                                                                            
                                                                            	rate
                                                                            	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                            
                                                                            .. attribute:: sbuck_name
                                                                            
                                                                            	sbuck name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: sbuck_type
                                                                            
                                                                            	sbuck type
                                                                            	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                            
                                                                            .. attribute:: violate_actns
                                                                            
                                                                            	violate actns
                                                                            	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                                self.yang_name = "police"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"burst" : ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                                self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                                self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                                self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                                self.burst.parent = self
                                                                                self._children_name_map["burst"] = "burst"
                                                                                self._children_yang_names.add("burst")

                                                                                self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                                self.cdvt.parent = self
                                                                                self._children_name_map["cdvt"] = "cdvt"
                                                                                self._children_yang_names.add("cdvt")

                                                                                self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                                self.confclass_encode.parent = self
                                                                                self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                                self._children_yang_names.add("confclass-encode")

                                                                                self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                                self.confclass_p.parent = self
                                                                                self._children_name_map["confclass_p"] = "confclass-p"
                                                                                self._children_yang_names.add("confclass-p")

                                                                                self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                                self.conform_actns.parent = self
                                                                                self._children_name_map["conform_actns"] = "conform-actns"
                                                                                self._children_yang_names.add("conform-actns")

                                                                                self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                                self.excdclass_encode.parent = self
                                                                                self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                                self._children_yang_names.add("excdclass-encode")

                                                                                self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                                self.excdclass_p.parent = self
                                                                                self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                                self._children_yang_names.add("excdclass-p")

                                                                                self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                                self.exceed_actns.parent = self
                                                                                self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                                self._children_yang_names.add("exceed-actns")

                                                                                self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                                self.peak_burst.parent = self
                                                                                self._children_name_map["peak_burst"] = "peak-burst"
                                                                                self._children_yang_names.add("peak-burst")

                                                                                self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                                self.peak_rate.parent = self
                                                                                self._children_name_map["peak_rate"] = "peak-rate"
                                                                                self._children_yang_names.add("peak-rate")

                                                                                self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                                self.rate.parent = self
                                                                                self._children_name_map["rate"] = "rate"
                                                                                self._children_yang_names.add("rate")

                                                                                self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                                self.violate_actns.parent = self
                                                                                self._children_name_map["violate_actns"] = "violate-actns"
                                                                                self._children_yang_names.add("violate-actns")
                                                                                self._segment_path = lambda: "police"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                            class Burst(Entity):
                                                                                """
                                                                                burst
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                    self.yang_name = "burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "burst"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                            class Cdvt(Entity):
                                                                                """
                                                                                cdvt
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                    self.yang_name = "cdvt"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "cdvt"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                            class ConfclassEncode(Entity):
                                                                                """
                                                                                confclass encode
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                    self.yang_name = "confclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                    self._child_list_classes = {}

                                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._children_yang_names.add("inline-cmap")
                                                                                    self._segment_path = lambda: "confclass-encode"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "confclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "inline-cmap"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ConfclassP(Entity):
                                                                                """
                                                                                confclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                    self.yang_name = "confclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "confclass-p"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "confclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "class-map-bg"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ConformActns(Entity):
                                                                                """
                                                                                conform actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                    self.yang_name = "conform-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "conform-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "conform-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                            class ExcdclassEncode(Entity):
                                                                                """
                                                                                excdclass encode
                                                                                
                                                                                .. attribute:: class_name
                                                                                
                                                                                	class name
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: enc
                                                                                
                                                                                	enc
                                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                                
                                                                                .. attribute:: hd
                                                                                
                                                                                	hd
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                .. attribute:: idx
                                                                                
                                                                                	idx
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: inline_cmap
                                                                                
                                                                                	inline cmap
                                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                    self.yang_name = "excdclass-encode"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                    self._child_list_classes = {}

                                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                    self.inline_cmap.parent = self
                                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                    self._children_yang_names.add("inline-cmap")
                                                                                    self._segment_path = lambda: "excdclass-encode"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                                class InlineCmap(Entity):
                                                                                    """
                                                                                    inline cmap
                                                                                    
                                                                                    .. attribute:: flags
                                                                                    
                                                                                    	Inline Class\-Map flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_count
                                                                                    
                                                                                    	Number of Match infos
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Inline Class\-Map Mode Match any/all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                        self.yang_name = "inline-cmap"
                                                                                        self.yang_parent_name = "excdclass-encode"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "inline-cmap"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "inline-cmap"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ExcdclassP(Entity):
                                                                                """
                                                                                excdclass p
                                                                                
                                                                                .. attribute:: class_map_bg
                                                                                
                                                                                	class map bg
                                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                    self.yang_name = "excdclass-p"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                    self.class_map_bg = YList(self)
                                                                                    self._segment_path = lambda: "excdclass-p"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                                class ClassMapBg(Entity):
                                                                                    """
                                                                                    class map bg
                                                                                    
                                                                                    .. attribute:: description
                                                                                    
                                                                                    	description
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: match_infop
                                                                                    
                                                                                    	Pointer to the first Match info
                                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                    
                                                                                    .. attribute:: mode
                                                                                    
                                                                                    	Class\-Map Mode Match any/Match all
                                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                    
                                                                                    .. attribute:: name
                                                                                    
                                                                                    	Name of the class\-map
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**length:** 0..65
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                        self.yang_name = "class-map-bg"
                                                                                        self.yang_parent_name = "excdclass-p"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                        self._child_list_classes = {}

                                                                                        self.description = YLeaf(YType.str, "description")

                                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                                        self.name = YLeaf(YType.str, "name")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                        self.match_infop.parent = self
                                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                                        self._children_yang_names.add("match-infop")
                                                                                        self._segment_path = lambda: "class-map-bg"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                    class MatchInfop(Entity):
                                                                                        """
                                                                                        Pointer to the first Match info
                                                                                        
                                                                                        .. attribute:: class_match_info_st
                                                                                        
                                                                                        	class match info st
                                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                            self.yang_name = "match-infop"
                                                                                            self.yang_parent_name = "class-map-bg"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                            self.class_match_info_st = YList(self)
                                                                                            self._segment_path = lambda: "match-infop"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                        class ClassMatchInfoSt(Entity):
                                                                                            """
                                                                                            class match info st
                                                                                            
                                                                                            .. attribute:: flags
                                                                                            
                                                                                            	Flags
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..4294967295
                                                                                            
                                                                                            .. attribute:: match_data
                                                                                            
                                                                                            	Match criteria
                                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                                self.yang_name = "class-match-info-st"
                                                                                                self.yang_parent_name = "match-infop"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                                self._child_list_classes = {}

                                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                                self.match_data.parent = self
                                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                                self._children_yang_names.add("match-data")
                                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                            class MatchData(Entity):
                                                                                                """
                                                                                                Match criteria
                                                                                                
                                                                                                .. attribute:: access_interface
                                                                                                
                                                                                                	Access interface
                                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                                
                                                                                                .. attribute:: atm_clp
                                                                                                
                                                                                                	Match ATM CLP level
                                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                                
                                                                                                .. attribute:: auth_domain
                                                                                                
                                                                                                	Authenticated domain name
                                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                                
                                                                                                .. attribute:: auth_domain_regex
                                                                                                
                                                                                                	Authenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: auth_username
                                                                                                
                                                                                                	Authenticated User Name
                                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                                
                                                                                                .. attribute:: auth_username_regex
                                                                                                
                                                                                                	Authenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: authen_status
                                                                                                
                                                                                                	Authentication Status
                                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                                
                                                                                                .. attribute:: avail_id
                                                                                                
                                                                                                	Available Identifiers
                                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                                
                                                                                                .. attribute:: circuit_id
                                                                                                
                                                                                                	Circuit ID
                                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                                
                                                                                                .. attribute:: circuit_id_regex
                                                                                                
                                                                                                	Circuit ID RegEx
                                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                                
                                                                                                .. attribute:: cos
                                                                                                
                                                                                                	Match CoS array
                                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                                
                                                                                                .. attribute:: cos_inr
                                                                                                
                                                                                                	Match inner header CoS
                                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                                
                                                                                                .. attribute:: dei
                                                                                                
                                                                                                	Match DEI Bit
                                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                                
                                                                                                .. attribute:: dei_inr
                                                                                                
                                                                                                	Match inner DEI Bit
                                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id
                                                                                                
                                                                                                	Dhcp Client ID
                                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                                
                                                                                                .. attribute:: dhcp_client_id_regex
                                                                                                
                                                                                                	Dhcp Client ID RegEx
                                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                                
                                                                                                .. attribute:: discard_class
                                                                                                
                                                                                                	Match Discard Class array
                                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                                
                                                                                                .. attribute:: dnis
                                                                                                
                                                                                                	DNIS
                                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                                
                                                                                                .. attribute:: dnis_regex
                                                                                                
                                                                                                	DNIS Regular Expression
                                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                                
                                                                                                .. attribute:: domain
                                                                                                
                                                                                                	Domain Name
                                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                                
                                                                                                .. attribute:: domain_regex
                                                                                                
                                                                                                	Domain Regular Expression
                                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                                
                                                                                                .. attribute:: dscp
                                                                                                
                                                                                                	Match DSCP range array
                                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv4
                                                                                                
                                                                                                	Destination Address IPV4
                                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: dst_addr_ipv6
                                                                                                
                                                                                                	Destination Address IPV6
                                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: dst_mac
                                                                                                
                                                                                                	Match Destination MAC address
                                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                                
                                                                                                .. attribute:: dst_port
                                                                                                
                                                                                                	Destination port
                                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                                
                                                                                                .. attribute:: ether_service_acl
                                                                                                
                                                                                                	Ethernet\-Services Access\-list
                                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                                
                                                                                                .. attribute:: ethertype
                                                                                                
                                                                                                	Ethernet type
                                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                                
                                                                                                .. attribute:: flow_key_data
                                                                                                
                                                                                                	Flow key structure
                                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                                
                                                                                                .. attribute:: flow_tag
                                                                                                
                                                                                                	Match flow\-tag array
                                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                                
                                                                                                .. attribute:: fr_de
                                                                                                
                                                                                                	Match FR DE value
                                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                                
                                                                                                .. attribute:: fr_dlci
                                                                                                
                                                                                                	Match FR DLCI range array
                                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                                
                                                                                                .. attribute:: fragment_type
                                                                                                
                                                                                                	Fragment type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: icmp_v4
                                                                                                
                                                                                                	Match ICMPV4 Protocol
                                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                                
                                                                                                .. attribute:: icmp_v6
                                                                                                
                                                                                                	Match ICMPV6 Protocol array
                                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                                
                                                                                                .. attribute:: icmpv4_code
                                                                                                
                                                                                                	Match ipv4 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                                
                                                                                                .. attribute:: icmpv4_type
                                                                                                
                                                                                                	Match ipv4 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                                
                                                                                                .. attribute:: icmpv6_code
                                                                                                
                                                                                                	Match ipv6 icmp code
                                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                                
                                                                                                .. attribute:: icmpv6_type
                                                                                                
                                                                                                	Match ipv6 icmp type
                                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                                
                                                                                                .. attribute:: input_interface
                                                                                                
                                                                                                	Input interface
                                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                                
                                                                                                .. attribute:: input_intfhdl
                                                                                                
                                                                                                	Input interface handle
                                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                                
                                                                                                .. attribute:: ipv4_acl
                                                                                                
                                                                                                	IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                                
                                                                                                .. attribute:: ipv4_dscp
                                                                                                
                                                                                                	IPv4 DSCP
                                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv4_packet_len
                                                                                                
                                                                                                	IPv4 packet length array
                                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv4_prec
                                                                                                
                                                                                                	IPv4 Precedence
                                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                                
                                                                                                .. attribute:: ipv6_acl
                                                                                                
                                                                                                	IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                                
                                                                                                .. attribute:: ipv6_dscp
                                                                                                
                                                                                                	IPv6 DSCP
                                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                                
                                                                                                .. attribute:: ipv6_packet_len
                                                                                                
                                                                                                	IPv6 packet length array
                                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                                
                                                                                                .. attribute:: ipv6_prec
                                                                                                
                                                                                                	IPv6 Precedence
                                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                                
                                                                                                .. attribute:: media_type
                                                                                                
                                                                                                	Media Type
                                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                                
                                                                                                .. attribute:: mlp_negotiated
                                                                                                
                                                                                                	MLP Negotiated
                                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                                
                                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                                
                                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                                
                                                                                                .. attribute:: mpls_exp
                                                                                                
                                                                                                	Match MPLS experimental topmost array
                                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                                
                                                                                                .. attribute:: mpls_exp_imp
                                                                                                
                                                                                                	Match MPLS experimental imposition array
                                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                                
                                                                                                .. attribute:: mpls_top_eos
                                                                                                
                                                                                                	MPLS Topmost EOS
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: mpls_top_label
                                                                                                
                                                                                                	MPLS Topmost LABEL
                                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                                
                                                                                                .. attribute:: nas_port
                                                                                                
                                                                                                	NAS Port
                                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                                
                                                                                                .. attribute:: packet_len
                                                                                                
                                                                                                	Match packet length array
                                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                                
                                                                                                .. attribute:: prec
                                                                                                
                                                                                                	Match Precedence array
                                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                                
                                                                                                .. attribute:: proto
                                                                                                
                                                                                                	Match Protocol array
                                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                                
                                                                                                .. attribute:: qos_group
                                                                                                
                                                                                                	Match QoS group array
                                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                                
                                                                                                .. attribute:: remote_id
                                                                                                
                                                                                                	Remote ID
                                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                                
                                                                                                .. attribute:: remote_id_regex
                                                                                                
                                                                                                	Remote ID RegEx
                                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                                
                                                                                                .. attribute:: service_name
                                                                                                
                                                                                                	Service Name
                                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                                
                                                                                                .. attribute:: service_name_regex
                                                                                                
                                                                                                	Service Name Regular Exp
                                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv4
                                                                                                
                                                                                                	Source Address IPV4
                                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                                
                                                                                                .. attribute:: src_addr_ipv6
                                                                                                
                                                                                                	Source Address IPV6
                                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                                
                                                                                                .. attribute:: src_addr_mac
                                                                                                
                                                                                                	Source Address MAC
                                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                                
                                                                                                .. attribute:: src_mac
                                                                                                
                                                                                                	Match Source MAC address
                                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                                
                                                                                                .. attribute:: src_port
                                                                                                
                                                                                                	Source port
                                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                                
                                                                                                .. attribute:: subs_protocol
                                                                                                
                                                                                                	Protocol
                                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                                
                                                                                                .. attribute:: tcp_flag
                                                                                                
                                                                                                	Match tcp flag value
                                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                                
                                                                                                .. attribute:: timer
                                                                                                
                                                                                                	Timer
                                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                                
                                                                                                .. attribute:: timer_regexp
                                                                                                
                                                                                                	Timer Regular Expression
                                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                                
                                                                                                .. attribute:: traffic_class
                                                                                                
                                                                                                	Match Traffic class array
                                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                                
                                                                                                .. attribute:: tunnel_name
                                                                                                
                                                                                                	Tunnel Name
                                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                                
                                                                                                .. attribute:: tunnel_name_regex
                                                                                                
                                                                                                	Tunnel Name Regular Expression
                                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	type
                                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                                
                                                                                                .. attribute:: unauth_domain
                                                                                                
                                                                                                	Unauthenticated Domain Name
                                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                                
                                                                                                .. attribute:: unauth_domain_regex
                                                                                                
                                                                                                	Unauthenticated Domain Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                                
                                                                                                .. attribute:: unauth_username
                                                                                                
                                                                                                	Unauthenticated User Name
                                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                                
                                                                                                .. attribute:: unauth_username_regex
                                                                                                
                                                                                                	Unauthenticated User Name RegEx
                                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                                
                                                                                                .. attribute:: user_name
                                                                                                
                                                                                                	User Name
                                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                                
                                                                                                .. attribute:: user_name_regex
                                                                                                
                                                                                                	User Name Regular Expression
                                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                                
                                                                                                .. attribute:: vendor_id
                                                                                                
                                                                                                	Vendor ID
                                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                                
                                                                                                .. attribute:: vendor_id_regex
                                                                                                
                                                                                                	Vendor ID RegEx
                                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                                
                                                                                                .. attribute:: vlan
                                                                                                
                                                                                                	Match VLAN array
                                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                                
                                                                                                .. attribute:: vlan_inr
                                                                                                
                                                                                                	Match inner header VLAN range array
                                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                    self.yang_name = "match-data"
                                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                    self.access_interface.parent = self
                                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                                    self._children_yang_names.add("access-interface")

                                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                    self.atm_clp.parent = self
                                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                    self._children_yang_names.add("atm-clp")

                                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                    self.auth_domain.parent = self
                                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                    self._children_yang_names.add("auth-domain")

                                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                    self.auth_domain_regex.parent = self
                                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                    self.auth_username.parent = self
                                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                                    self._children_yang_names.add("auth-username")

                                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                    self.auth_username_regex.parent = self
                                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                    self.avail_id.parent = self
                                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                                    self._children_yang_names.add("avail-id")

                                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                    self.circuit_id.parent = self
                                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                    self._children_yang_names.add("circuit-id")

                                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                    self.circuit_id_regex.parent = self
                                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                    self.cos.parent = self
                                                                                                    self._children_name_map["cos"] = "cos"
                                                                                                    self._children_yang_names.add("cos")

                                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                    self.cos_inr.parent = self
                                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                    self._children_yang_names.add("cos-inr")

                                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                    self.dei.parent = self
                                                                                                    self._children_name_map["dei"] = "dei"
                                                                                                    self._children_yang_names.add("dei")

                                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                    self.dei_inr.parent = self
                                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                    self._children_yang_names.add("dei-inr")

                                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                    self.dhcp_client_id.parent = self
                                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                    self.discard_class.parent = self
                                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                                    self._children_yang_names.add("discard-class")

                                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                    self.dnis.parent = self
                                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                                    self._children_yang_names.add("dnis")

                                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                    self.dnis_regex.parent = self
                                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                    self.domain.parent = self
                                                                                                    self._children_name_map["domain"] = "domain"
                                                                                                    self._children_yang_names.add("domain")

                                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                    self.domain_regex.parent = self
                                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                    self._children_yang_names.add("domain-regex")

                                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                    self.dscp.parent = self
                                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                                    self._children_yang_names.add("dscp")

                                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                    self.dst_addr_ipv4.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                    self.dst_addr_ipv6.parent = self
                                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                    self.dst_mac.parent = self
                                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                    self._children_yang_names.add("dst-mac")

                                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                    self.dst_port.parent = self
                                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                                    self._children_yang_names.add("dst-port")

                                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                    self.ether_service_acl.parent = self
                                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                    self.ethertype.parent = self
                                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                                    self._children_yang_names.add("ethertype")

                                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                    self.flow_key_data.parent = self
                                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                    self.flow_tag.parent = self
                                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                    self._children_yang_names.add("flow-tag")

                                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                    self.fr_de.parent = self
                                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                                    self._children_yang_names.add("fr-de")

                                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                    self.fr_dlci.parent = self
                                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                    self.icmp_v4.parent = self
                                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                    self.icmp_v6.parent = self
                                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                    self.icmpv4_code.parent = self
                                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                    self.icmpv4_type.parent = self
                                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                    self.icmpv6_code.parent = self
                                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                    self.icmpv6_type.parent = self
                                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                    self.input_interface.parent = self
                                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                                    self._children_yang_names.add("input-interface")

                                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                    self.input_intfhdl.parent = self
                                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                    self.ipv4_acl.parent = self
                                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                    self.ipv4_dscp.parent = self
                                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                    self.ipv4_packet_len.parent = self
                                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                    self.ipv4_prec.parent = self
                                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                    self.ipv6_acl.parent = self
                                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                    self.ipv6_dscp.parent = self
                                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                    self.ipv6_packet_len.parent = self
                                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                    self.ipv6_prec.parent = self
                                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                    self.media_type.parent = self
                                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                                    self._children_yang_names.add("media-type")

                                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                    self.mpls_exp.parent = self
                                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                    self.mpls_exp_imp.parent = self
                                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                    self.mpls_top_label.parent = self
                                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                    self.nas_port.parent = self
                                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                                    self._children_yang_names.add("nas-port")

                                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                    self.packet_len.parent = self
                                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                                    self._children_yang_names.add("packet-len")

                                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                    self.prec.parent = self
                                                                                                    self._children_name_map["prec"] = "prec"
                                                                                                    self._children_yang_names.add("prec")

                                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                    self.proto.parent = self
                                                                                                    self._children_name_map["proto"] = "proto"
                                                                                                    self._children_yang_names.add("proto")

                                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                    self.qos_group.parent = self
                                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                                    self._children_yang_names.add("qos-group")

                                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                    self.remote_id.parent = self
                                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                                    self._children_yang_names.add("remote-id")

                                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                    self.remote_id_regex.parent = self
                                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                    self.service_name.parent = self
                                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                                    self._children_yang_names.add("service-name")

                                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                    self.service_name_regex.parent = self
                                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                    self.src_addr_ipv4.parent = self
                                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                    self.src_addr_ipv6.parent = self
                                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                    self.src_addr_mac.parent = self
                                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                    self.src_mac.parent = self
                                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                                    self._children_yang_names.add("src-mac")

                                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                    self.src_port.parent = self
                                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                                    self._children_yang_names.add("src-port")

                                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                    self.subs_protocol.parent = self
                                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                    self.tcp_flag.parent = self
                                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                    self.timer.parent = self
                                                                                                    self._children_name_map["timer"] = "timer"
                                                                                                    self._children_yang_names.add("timer")

                                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                    self.timer_regexp.parent = self
                                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                    self.traffic_class.parent = self
                                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                    self._children_yang_names.add("traffic-class")

                                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                    self.tunnel_name.parent = self
                                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                    self.tunnel_name_regex.parent = self
                                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                    self.unauth_domain.parent = self
                                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                    self.unauth_domain_regex.parent = self
                                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                    self.unauth_username.parent = self
                                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                    self._children_yang_names.add("unauth-username")

                                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                    self.unauth_username_regex.parent = self
                                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                    self.user_name.parent = self
                                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                                    self._children_yang_names.add("user-name")

                                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                    self.user_name_regex.parent = self
                                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                    self.vendor_id.parent = self
                                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                    self._children_yang_names.add("vendor-id")

                                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                    self.vendor_id_regex.parent = self
                                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                    self.vlan.parent = self
                                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                                    self._children_yang_names.add("vlan")

                                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                    self.vlan_inr.parent = self
                                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                                    self._segment_path = lambda: "match-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                                class AccessInterface(Entity):
                                                                                                    """
                                                                                                    Access interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                        self.yang_name = "access-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "access-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                                class AtmClp(Entity):
                                                                                                    """
                                                                                                    Match ATM CLP level
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                        self.yang_name = "atm-clp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                                class AuthDomain(Entity):
                                                                                                    """
                                                                                                    Authenticated domain name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                        self.yang_name = "auth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                                class AuthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "auth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                                class AuthUsername(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                        self.yang_name = "auth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                                class AuthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Authenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "auth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                                class AvailId(Entity):
                                                                                                    """
                                                                                                    Available Identifiers
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                        self.yang_name = "avail-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "avail-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                                class CircuitId(Entity):
                                                                                                    """
                                                                                                    Circuit ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                        self.yang_name = "circuit-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                                class CircuitIdRegex(Entity):
                                                                                                    """
                                                                                                    Circuit ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                        self.yang_name = "circuit-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                                class Cos(Entity):
                                                                                                    """
                                                                                                    Match CoS array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                        self.yang_name = "cos"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                                class CosInr(Entity):
                                                                                                    """
                                                                                                    Match inner header CoS
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                        self.yang_name = "cos-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                                class Dei(Entity):
                                                                                                    """
                                                                                                    Match DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                        self.yang_name = "dei"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                                class DeiInr(Entity):
                                                                                                    """
                                                                                                    Match inner DEI Bit
                                                                                                    
                                                                                                    .. attribute:: bit_value
                                                                                                    
                                                                                                    	Value of the DEI bit
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                        self.yang_name = "dei-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                                class DhcpClientId(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                                class DhcpClientIdRegex(Entity):
                                                                                                    """
                                                                                                    Dhcp Client ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                                class DiscardClass(Entity):
                                                                                                    """
                                                                                                    Match Discard Class array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                        self.yang_name = "discard-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "discard-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                                class Dnis(Entity):
                                                                                                    """
                                                                                                    DNIS
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                        self.yang_name = "dnis"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                                class DnisRegex(Entity):
                                                                                                    """
                                                                                                    DNIS Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                        self.yang_name = "dnis-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                                class Domain(Entity):
                                                                                                    """
                                                                                                    Domain Name
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                        self.yang_name = "domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class DomainRegex(Entity):
                                                                                                    """
                                                                                                    Domain Regular Expression
                                                                                                    
                                                                                                    .. attribute:: domain_array
                                                                                                    
                                                                                                    	domain array
                                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                        self.yang_name = "domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                        self.domain_array = YList(self)
                                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                    class DomainArray(Entity):
                                                                                                        """
                                                                                                        domain array
                                                                                                        
                                                                                                        .. attribute:: domain_name
                                                                                                        
                                                                                                        	domain name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        .. attribute:: format_name
                                                                                                        
                                                                                                        	format name
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                            self.yang_name = "domain-array"
                                                                                                            self.yang_parent_name = "domain-regex"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                                            self._segment_path = lambda: "domain-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                                class Dscp(Entity):
                                                                                                    """
                                                                                                    Match DSCP range array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                        self.yang_name = "dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class DstAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Destination Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class DstMac(Entity):
                                                                                                    """
                                                                                                    Match Destination MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                        self.yang_name = "dst-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                                class DstPort(Entity):
                                                                                                    """
                                                                                                    Destination port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                        self.yang_name = "dst-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "dst-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "dst-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class EtherServiceAcl(Entity):
                                                                                                    """
                                                                                                    Ethernet\-Services Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                        self.yang_name = "ether-service-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                                class Ethertype(Entity):
                                                                                                    """
                                                                                                    Ethernet type
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                        self.yang_name = "ethertype"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ethertype"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ethertype"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class FlowKeyData(Entity):
                                                                                                    """
                                                                                                    Flow key structure
                                                                                                    
                                                                                                    .. attribute:: flow_keys
                                                                                                    
                                                                                                    	flow keys
                                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                    
                                                                                                    .. attribute:: idle_timeout
                                                                                                    
                                                                                                    	Idle timeout of flows (in seconds)
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    	**units**\: second
                                                                                                    
                                                                                                    .. attribute:: max_count
                                                                                                    
                                                                                                    	Maximum count of flows
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                        self.yang_name = "flow-key-data"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                        self.flow_keys.parent = self
                                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                        self._children_yang_names.add("flow-keys")
                                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                    class FlowKeys(Entity):
                                                                                                        """
                                                                                                        flow keys
                                                                                                        
                                                                                                        .. attribute:: keys
                                                                                                        
                                                                                                        	keys
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                        
                                                                                                        .. attribute:: num
                                                                                                        
                                                                                                        	num
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                            self.yang_name = "flow-keys"
                                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                                class FlowTag(Entity):
                                                                                                    """
                                                                                                    Match flow\-tag array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                        self.yang_name = "flow-tag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "flow-tag"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class FrDe(Entity):
                                                                                                    """
                                                                                                    Match FR DE value
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                        self.yang_name = "fr-de"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "fr-de"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                                class FrDlci(Entity):
                                                                                                    """
                                                                                                    Match FR DLCI range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                        self.yang_name = "fr-dlci"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class IcmpV4(Entity):
                                                                                                    """
                                                                                                    Match ICMPV4 Protocol
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                        self.yang_name = "icmp-v4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                                class IcmpV6(Entity):
                                                                                                    """
                                                                                                    Match ICMPV6 Protocol array
                                                                                                    
                                                                                                    .. attribute:: code
                                                                                                    
                                                                                                    	Protocol code
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: type
                                                                                                    
                                                                                                    	Protocol type
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                        self.yang_name = "icmp-v6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                                class Icmpv4Code(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                        self.yang_name = "icmpv4-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv4Type(Entity):
                                                                                                    """
                                                                                                    Match ipv4 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                        self.yang_name = "icmpv4-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Code(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp code
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                        self.yang_name = "icmpv6-code"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Icmpv6Type(Entity):
                                                                                                    """
                                                                                                    Match ipv6 icmp type
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                        self.yang_name = "icmpv6-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class InputInterface(Entity):
                                                                                                    """
                                                                                                    Input interface
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                        self.yang_name = "input-interface"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "input-interface"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                                class InputIntfhdl(Entity):
                                                                                                    """
                                                                                                    Input interface handle
                                                                                                    
                                                                                                    .. attribute:: uint64_array
                                                                                                    
                                                                                                    	uint64 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..18446744073709551615
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                        self.yang_name = "input-intfhdl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                                class Ipv4Acl(Entity):
                                                                                                    """
                                                                                                    IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                        self.yang_name = "ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                                class Ipv4Dscp(Entity):
                                                                                                    """
                                                                                                    IPv4 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv4-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv4 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv4Prec(Entity):
                                                                                                    """
                                                                                                    IPv4 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                        self.yang_name = "ipv4-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                                class Ipv6Acl(Entity):
                                                                                                    """
                                                                                                    IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                        self.yang_name = "ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                                class Ipv6Dscp(Entity):
                                                                                                    """
                                                                                                    IPv6 DSCP
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                        self.yang_name = "ipv6-dscp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6PacketLen(Entity):
                                                                                                    """
                                                                                                    IPv6 packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Ipv6Prec(Entity):
                                                                                                    """
                                                                                                    IPv6 Precedence
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                        self.yang_name = "ipv6-prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                                class MediaType(Entity):
                                                                                                    """
                                                                                                    Media Type
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                        self.yang_name = "media-type"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "media-type"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                                class MplsDispIpv4Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                                class MplsDispIpv6Acl(Entity):
                                                                                                    """
                                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                                class MplsExp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental topmost array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                                class MplsExpImp(Entity):
                                                                                                    """
                                                                                                    Match MPLS experimental imposition array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                                class MplsTopLabel(Entity):
                                                                                                    """
                                                                                                    MPLS Topmost LABEL
                                                                                                    
                                                                                                    .. attribute:: uint32_rng_array
                                                                                                    
                                                                                                    	uint32 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                        self.yang_name = "mpls-top-label"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                        self.uint32_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                    class Uint32RngArray(Entity):
                                                                                                        """
                                                                                                        uint32 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                            self.yang_name = "uint32_rng_array"
                                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                                class NasPort(Entity):
                                                                                                    """
                                                                                                    NAS Port
                                                                                                    
                                                                                                    .. attribute:: nas_port_array
                                                                                                    
                                                                                                    	nas port array
                                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                        self.yang_name = "nas-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                        self.nas_port_array = YList(self)
                                                                                                        self._segment_path = lambda: "nas-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                    class NasPortArray(Entity):
                                                                                                        """
                                                                                                        nas port array
                                                                                                        
                                                                                                        .. attribute:: operator
                                                                                                        
                                                                                                        	operator
                                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                        
                                                                                                        .. attribute:: sub_id
                                                                                                        
                                                                                                        	sub id
                                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                        
                                                                                                        .. attribute:: value
                                                                                                        
                                                                                                        	value
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                            self.yang_name = "nas-port-array"
                                                                                                            self.yang_parent_name = "nas-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                                class PacketLen(Entity):
                                                                                                    """
                                                                                                    Match packet length array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                        self.yang_name = "packet-len"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "packet-len"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "packet-len"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class Prec(Entity):
                                                                                                    """
                                                                                                    Match Precedence array
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                        self.yang_name = "prec"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "prec"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                                class Proto(Entity):
                                                                                                    """
                                                                                                    Match Protocol array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                        self.yang_name = "proto"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "proto"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "proto"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class QosGroup(Entity):
                                                                                                    """
                                                                                                    Match QoS group array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                        self.yang_name = "qos-group"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "qos-group"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "qos-group"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class RemoteId(Entity):
                                                                                                    """
                                                                                                    Remote ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                        self.yang_name = "remote-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                                class RemoteIdRegex(Entity):
                                                                                                    """
                                                                                                    Remote ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                        self.yang_name = "remote-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                                class ServiceName(Entity):
                                                                                                    """
                                                                                                    Service Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                        self.yang_name = "service-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                                class ServiceNameRegex(Entity):
                                                                                                    """
                                                                                                    Service Name Regular Exp
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                        self.yang_name = "service-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                                class SrcAddrIpv4(Entity):
                                                                                                    """
                                                                                                    Source Address IPV4
                                                                                                    
                                                                                                    .. attribute:: ipv4_addr_array
                                                                                                    
                                                                                                    	ipv4 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                        self.ipv4_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                    class Ipv4AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv4 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	mask
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrIpv6(Entity):
                                                                                                    """
                                                                                                    Source Address IPV6
                                                                                                    
                                                                                                    .. attribute:: ipv6_addr_array
                                                                                                    
                                                                                                    	ipv6 addr array
                                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                        self.ipv6_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                    class Ipv6AddrArray(Entity):
                                                                                                        """
                                                                                                        ipv6 addr array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	IPV6 mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..4294967295
                                                                                                        
                                                                                                        .. attribute:: prefix
                                                                                                        
                                                                                                        	IPV6 prefix
                                                                                                        	**type**\:  str
                                                                                                        
                                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                                class SrcAddrMac(Entity):
                                                                                                    """
                                                                                                    Source Address MAC
                                                                                                    
                                                                                                    .. attribute:: mac_addr_array
                                                                                                    
                                                                                                    	mac addr array
                                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                        self.yang_name = "src-addr-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                        self.mac_addr_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                    class MacAddrArray(Entity):
                                                                                                        """
                                                                                                        mac addr array
                                                                                                        
                                                                                                        .. attribute:: mac_addr
                                                                                                        
                                                                                                        	MAC address
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	MAC mask
                                                                                                        	**type**\:  list of int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                            self.yang_name = "mac-addr-array"
                                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcMac(Entity):
                                                                                                    """
                                                                                                    Match Source MAC address
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                        self.yang_name = "src-mac"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "src-mac"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                                class SrcPort(Entity):
                                                                                                    """
                                                                                                    Source port
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                        self.yang_name = "src-port"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "src-port"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "src-port"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                                class SubsProtocol(Entity):
                                                                                                    """
                                                                                                    Protocol
                                                                                                    
                                                                                                    .. attribute:: uint8_array
                                                                                                    
                                                                                                    	uint8 array
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                        self.yang_name = "subs-protocol"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                                class TcpFlag(Entity):
                                                                                                    """
                                                                                                    Match tcp flag value
                                                                                                    
                                                                                                    .. attribute:: match_any
                                                                                                    
                                                                                                    	Match any TCP flag bit
                                                                                                    	**type**\:  bool
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	Value of TCP flag
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                        self.yang_name = "tcp-flag"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                                class Timer(Entity):
                                                                                                    """
                                                                                                    Timer
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                        self.yang_name = "timer"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                                class TimerRegexp(Entity):
                                                                                                    """
                                                                                                    Timer Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                        self.yang_name = "timer-regexp"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                                class TrafficClass(Entity):
                                                                                                    """
                                                                                                    Match Traffic class array
                                                                                                    
                                                                                                    .. attribute:: uint8_rng_array
                                                                                                    
                                                                                                    	uint8 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                        self.yang_name = "traffic-class"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                        self.uint8_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                    class Uint8RngArray(Entity):
                                                                                                        """
                                                                                                        uint8 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..255
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                            self.yang_name = "uint8_rng_array"
                                                                                                            self.yang_parent_name = "traffic-class"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                                class TunnelName(Entity):
                                                                                                    """
                                                                                                    Tunnel Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                        self.yang_name = "tunnel-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                                class TunnelNameRegex(Entity):
                                                                                                    """
                                                                                                    Tunnel Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                                class UnauthDomain(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                        self.yang_name = "unauth-domain"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                                class UnauthDomainRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated Domain Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                                class UnauthUsername(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                        self.yang_name = "unauth-username"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                                class UnauthUsernameRegex(Entity):
                                                                                                    """
                                                                                                    Unauthenticated User Name RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                        self.yang_name = "unauth-username-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                                class UserName(Entity):
                                                                                                    """
                                                                                                    User Name
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                        self.yang_name = "user-name"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                                class UserNameRegex(Entity):
                                                                                                    """
                                                                                                    User Name Regular Expression
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                        self.yang_name = "user-name-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                                class VendorId(Entity):
                                                                                                    """
                                                                                                    Vendor ID
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                        self.yang_name = "vendor-id"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                                class VendorIdRegex(Entity):
                                                                                                    """
                                                                                                    Vendor ID RegEx
                                                                                                    
                                                                                                    .. attribute:: string_array
                                                                                                    
                                                                                                    	string array
                                                                                                    	**type**\:  list of str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                        self.yang_name = "vendor-id-regex"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                                class Vlan(Entity):
                                                                                                    """
                                                                                                    Match VLAN array
                                                                                                    
                                                                                                    .. attribute:: vlan_id_array
                                                                                                    
                                                                                                    	vlan id array
                                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                        self.yang_name = "vlan"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                        self.vlan_id_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                    class VlanIdArray(Entity):
                                                                                                        """
                                                                                                        vlan id array
                                                                                                        
                                                                                                        .. attribute:: mask
                                                                                                        
                                                                                                        	VLAN mask
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                            self.yang_name = "vlan-id-array"
                                                                                                            self.yang_parent_name = "vlan"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                                class VlanInr(Entity):
                                                                                                    """
                                                                                                    Match inner header VLAN range array
                                                                                                    
                                                                                                    .. attribute:: uint16_rng_array
                                                                                                    
                                                                                                    	uint16 rng array
                                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                        self.yang_name = "vlan-inr"
                                                                                                        self.yang_parent_name = "match-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                        self.uint16_rng_array = YList(self)
                                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                    class Uint16RngArray(Entity):
                                                                                                        """
                                                                                                        uint16 rng array
                                                                                                        
                                                                                                        .. attribute:: max
                                                                                                        
                                                                                                        	Upper limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        .. attribute:: min
                                                                                                        
                                                                                                        	Lower limit of the range
                                                                                                        	**type**\:  int
                                                                                                        
                                                                                                        	**range:** 0..65535
                                                                                                        
                                                                                                        

                                                                                                        """

                                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                                        _revision = '2017-05-27'

                                                                                                        def __init__(self):
                                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                            self.yang_name = "uint16_rng_array"
                                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                                            self.is_top_level_class = False
                                                                                                            self.has_list_ancestor = True
                                                                                                            self._child_container_classes = {}
                                                                                                            self._child_list_classes = {}

                                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                                        def __setattr__(self, name, value):
                                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class ExceedActns(Entity):
                                                                                """
                                                                                exceed actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                    self.yang_name = "exceed-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "exceed-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "exceed-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                            class PeakBurst(Entity):
                                                                                """
                                                                                peak burst
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                    self.yang_name = "peak-burst"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "peak-burst"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                            class PeakRate(Entity):
                                                                                """
                                                                                peak rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                    self.yang_name = "peak-rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "peak-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                            class Rate(Entity):
                                                                                """
                                                                                rate
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                    self.yang_name = "rate"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                            class ViolateActns(Entity):
                                                                                """
                                                                                violate actns
                                                                                
                                                                                .. attribute:: police_action_array
                                                                                
                                                                                	police action array
                                                                                	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                    self.yang_name = "violate-actns"
                                                                                    self.yang_parent_name = "police"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                    self.police_action_array = YList(self)
                                                                                    self._segment_path = lambda: "violate-actns"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                                class PoliceActionArray(Entity):
                                                                                    """
                                                                                    police action array
                                                                                    
                                                                                    .. attribute:: mark
                                                                                    
                                                                                    	mark
                                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                        self.yang_name = "police-action-array"
                                                                                        self.yang_parent_name = "violate-actns"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                        self._child_list_classes = {}

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                        self.mark.parent = self
                                                                                        self._children_name_map["mark"] = "mark"
                                                                                        self._children_yang_names.add("mark")
                                                                                        self._segment_path = lambda: "police-action-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                    class Mark(Entity):
                                                                                        """
                                                                                        mark
                                                                                        
                                                                                        .. attribute:: mark_flags
                                                                                        
                                                                                        	mark flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: type
                                                                                        
                                                                                        	type
                                                                                        	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                            self.yang_name = "mark"
                                                                                            self.yang_parent_name = "police-action-array"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                            self.type = YLeaf(YType.enumeration, "type")

                                                                                            self.value = YLeaf(YType.uint16, "value")
                                                                                            self._segment_path = lambda: "mark"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PrepaidCfg(Entity):
                                                                            """
                                                                            prepaid cfg
                                                                            
                                                                            .. attribute:: prepaid_config_profile_name
                                                                            
                                                                            	prepaid config profile name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                                self.yang_name = "prepaid-cfg"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                                self._segment_path = lambda: "prepaid-cfg"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                        class Prio(Entity):
                                                                            """
                                                                            prio
                                                                            
                                                                            .. attribute:: prio_lvl
                                                                            
                                                                            	prio lvl
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                                self.yang_name = "prio"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                                self._segment_path = lambda: "prio"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                        class ProxyAaa(Entity):
                                                                            """
                                                                            proxy aaa
                                                                            
                                                                            .. attribute:: aaa_list_name
                                                                            
                                                                            	aaa list name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                                self.yang_name = "proxy-aaa"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                                self._segment_path = lambda: "proxy-aaa"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                        class Punt(Entity):
                                                                            """
                                                                            punt
                                                                            
                                                                            .. attribute:: app_id
                                                                            
                                                                            	application ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: local_id
                                                                            
                                                                            	local ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_index
                                                                            
                                                                            	service node index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: sn_name
                                                                            
                                                                            	service node name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: sn_type
                                                                            
                                                                            	service node ID type
                                                                            	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                            
                                                                            .. attribute:: vsnode_type
                                                                            
                                                                            	vservice node type
                                                                            	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                                self.yang_name = "punt"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.app_id = YLeaf(YType.uint32, "app-id")

                                                                                self.local_id = YLeaf(YType.uint32, "local-id")

                                                                                self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                                self.sn_name = YLeaf(YType.str, "sn-name")

                                                                                self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                                self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                                self._segment_path = lambda: "punt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                        class Qlimit(Entity):
                                                                            """
                                                                            qlimit
                                                                            
                                                                            .. attribute:: action_qlimit_info_array
                                                                            
                                                                            	action qlimit info array
                                                                            	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                                self.yang_name = "qlimit"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                                self.action_qlimit_info_array = YList(self)
                                                                                self._segment_path = lambda: "qlimit"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                            class ActionQlimitInfoArray(Entity):
                                                                                """
                                                                                action qlimit info array
                                                                                
                                                                                .. attribute:: atmclp_qlim
                                                                                
                                                                                	atmclp qlim
                                                                                	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                                
                                                                                .. attribute:: match_values
                                                                                
                                                                                	match values
                                                                                	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                                
                                                                                .. attribute:: qlim
                                                                                
                                                                                	qlim
                                                                                	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                                
                                                                                .. attribute:: qlimit_flags
                                                                                
                                                                                	qlimit flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                    self.yang_name = "action-qlimit-info-array"
                                                                                    self.yang_parent_name = "qlimit"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                    self._child_list_classes = {}

                                                                                    self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                    self.atmclp_qlim.parent = self
                                                                                    self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                    self._children_yang_names.add("atmclp-qlim")

                                                                                    self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                    self.match_values.parent = self
                                                                                    self._children_name_map["match_values"] = "match-values"
                                                                                    self._children_yang_names.add("match-values")

                                                                                    self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                    self.qlim.parent = self
                                                                                    self._children_name_map["qlim"] = "qlim"
                                                                                    self._children_yang_names.add("qlim")
                                                                                    self._segment_path = lambda: "action-qlimit-info-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                                class AtmclpQlim(Entity):
                                                                                    """
                                                                                    atmclp qlim
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                        self.yang_name = "atmclp-qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "atmclp-qlim"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                                class MatchValues(Entity):
                                                                                    """
                                                                                    match values
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                        self.yang_name = "match-values"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-values"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-values"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Qlim(Entity):
                                                                                    """
                                                                                    qlim
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                        self.yang_name = "qlim"
                                                                                        self.yang_parent_name = "action-qlimit-info-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "qlim"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                        class QueryAncp(Entity):
                                                                            """
                                                                            query ancp
                                                                            
                                                                            .. attribute:: enable
                                                                            
                                                                            	enable
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                                self.yang_name = "query-ancp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.enable = YLeaf(YType.uint8, "enable")
                                                                                self._segment_path = lambda: "query-ancp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                        class Redirect(Entity):
                                                                            """
                                                                            redirect
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                                self.yang_name = "redirect"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "redirect"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                        class Rtp(Entity):
                                                                            """
                                                                            rtp
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                                self.yang_name = "rtp"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpJ2K(Entity):
                                                                            """
                                                                            rtp j2k
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                                self.yang_name = "rtp-j2k"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-j2k"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-j2k"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpMmr(Entity):
                                                                            """
                                                                            rtp mmr
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                                self.yang_name = "rtp-mmr"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-mmr"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-mmr"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class RtpVoice(Entity):
                                                                            """
                                                                            rtp voice
                                                                            
                                                                            .. attribute:: action_metric_type
                                                                            
                                                                            	metric type
                                                                            	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                            
                                                                            .. attribute:: clock_rate
                                                                            
                                                                            	clock rate
                                                                            	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                            
                                                                            .. attribute:: max_dropout
                                                                            
                                                                            	max dropout
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: max_misorder
                                                                            
                                                                            	max misorder
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: min_sequential
                                                                            
                                                                            	min sequential
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: seq_ext_cop4
                                                                            
                                                                            	enable seq extension cop4
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                                self.yang_name = "rtp-voice"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                                self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                                self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                                self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                                self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                                self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                                self.clock_rate = YList(self)
                                                                                self._segment_path = lambda: "rtp-voice"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                            class ClockRate(Entity):
                                                                                """
                                                                                clock rate
                                                                                
                                                                                .. attribute:: frequency
                                                                                
                                                                                	frequency
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: pt
                                                                                
                                                                                	pt
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                    self.yang_name = "clock-rate"
                                                                                    self.yang_parent_name = "rtp-voice"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                    self.pt = YLeaf(YType.uint32, "pt")
                                                                                    self._segment_path = lambda: "clock-rate"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                        class ServFunc(Entity):
                                                                            """
                                                                            serv func
                                                                            
                                                                            .. attribute:: meta_name
                                                                            
                                                                            	metadata name
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: path_id
                                                                            
                                                                            	service path id
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: service_index
                                                                            
                                                                            	service path index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vs_index
                                                                            
                                                                            	vservice index
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                                self.yang_name = "serv-func"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.meta_name = YLeaf(YType.str, "meta-name")

                                                                                self.path_id = YLeaf(YType.uint32, "path-id")

                                                                                self.service_index = YLeaf(YType.uint8, "service-index")

                                                                                self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                                self._segment_path = lambda: "serv-func"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                        class SetTimer(Entity):
                                                                            """
                                                                            set timer
                                                                            
                                                                            .. attribute:: absolute_time
                                                                            
                                                                            	absolute time
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: duration
                                                                            
                                                                            	duration
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                                self.yang_name = "set-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                                self.duration = YLeaf(YType.uint32, "duration")

                                                                                self.timer_name = YLeaf(YType.str, "timer-name")
                                                                                self._segment_path = lambda: "set-timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                        class Sfrag(Entity):
                                                                            """
                                                                            sfrag
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	Service Fragment Name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                                self.yang_name = "sfrag"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")
                                                                                self._segment_path = lambda: "sfrag"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                        class Shape(Entity):
                                                                            """
                                                                            shape
                                                                            
                                                                            .. attribute:: be
                                                                            
                                                                            	be
                                                                            	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                            
                                                                            .. attribute:: bw
                                                                            
                                                                            	bw
                                                                            	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                                self.yang_name = "shape"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"be" : ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                                self._child_list_classes = {}

                                                                                self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                                self.be.parent = self
                                                                                self._children_name_map["be"] = "be"
                                                                                self._children_yang_names.add("be")

                                                                                self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                                self.bw.parent = self
                                                                                self._children_name_map["bw"] = "bw"
                                                                                self._children_yang_names.add("bw")
                                                                                self._segment_path = lambda: "shape"


                                                                            class Be(Entity):
                                                                                """
                                                                                be
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                    self.yang_name = "be"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "be"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                            class Bw(Entity):
                                                                                """
                                                                                bw
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                    self.yang_name = "bw"
                                                                                    self.yang_parent_name = "shape"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "bw"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                        class StopTimer(Entity):
                                                                            """
                                                                            stop timer
                                                                            
                                                                            .. attribute:: timer_name
                                                                            
                                                                            	timer name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                                self.yang_name = "stop-timer"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.timer_name = YLeaf(YType.str, "timer-name")
                                                                                self._segment_path = lambda: "stop-timer"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                        class TimeoutIdle(Entity):
                                                                            """
                                                                            timeout idle
                                                                            
                                                                            .. attribute:: secs
                                                                            
                                                                            	secs
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                                self.yang_name = "timeout-idle"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.secs = YLeaf(YType.uint32, "secs")
                                                                                self._segment_path = lambda: "timeout-idle"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                        class Wred(Entity):
                                                                            """
                                                                            wred
                                                                            
                                                                            .. attribute:: action_wred_info
                                                                            
                                                                            	action wred info
                                                                            	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                                self.yang_name = "wred"
                                                                                self.yang_parent_name = "actp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                                self.action_wred_info = YList(self)
                                                                                self._segment_path = lambda: "wred"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                            class ActionWredInfo(Entity):
                                                                                """
                                                                                action wred info
                                                                                
                                                                                .. attribute:: match_ranges
                                                                                
                                                                                	match ranges
                                                                                	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                                
                                                                                .. attribute:: max_threshold
                                                                                
                                                                                	max threshold
                                                                                	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                                
                                                                                .. attribute:: min_threshold
                                                                                
                                                                                	min threshold
                                                                                	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                                
                                                                                .. attribute:: probability
                                                                                
                                                                                	probability
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	cos/prec/dscp/ based WRED
                                                                                	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                                
                                                                                .. attribute:: wred_flags
                                                                                
                                                                                	wred flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                    self.yang_name = "action-wred-info"
                                                                                    self.yang_parent_name = "wred"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                    self._child_list_classes = {}

                                                                                    self.probability = YLeaf(YType.uint32, "probability")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                    self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                    self.match_ranges.parent = self
                                                                                    self._children_name_map["match_ranges"] = "match-ranges"
                                                                                    self._children_yang_names.add("match-ranges")

                                                                                    self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                    self.max_threshold.parent = self
                                                                                    self._children_name_map["max_threshold"] = "max-threshold"
                                                                                    self._children_yang_names.add("max-threshold")

                                                                                    self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                    self.min_threshold.parent = self
                                                                                    self._children_name_map["min_threshold"] = "min-threshold"
                                                                                    self._children_yang_names.add("min-threshold")
                                                                                    self._segment_path = lambda: "action-wred-info"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                                class MatchRanges(Entity):
                                                                                    """
                                                                                    match ranges
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                        self.yang_name = "match-ranges"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "match-ranges"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "match-ranges"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class MaxThreshold(Entity):
                                                                                    """
                                                                                    max threshold
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                        self.yang_name = "max-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "max-threshold"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                                class MinThreshold(Entity):
                                                                                    """
                                                                                    min threshold
                                                                                    
                                                                                    .. attribute:: unit
                                                                                    
                                                                                    	unit
                                                                                    	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                        self.yang_name = "min-threshold"
                                                                                        self.yang_parent_name = "action-wred-info"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.unit = YLeaf(YType.enumeration, "unit")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "min-threshold"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                            class ClEncode(Entity):
                                                                """
                                                                cl encode
                                                                
                                                                .. attribute:: class_name
                                                                
                                                                	class name
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: enc
                                                                
                                                                	enc
                                                                	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                
                                                                .. attribute:: hd
                                                                
                                                                	hd
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..18446744073709551615
                                                                
                                                                .. attribute:: idx
                                                                
                                                                	idx
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..255
                                                                
                                                                .. attribute:: inline_cmap
                                                                
                                                                	inline cmap
                                                                	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                    self.yang_name = "cl-encode"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                    self._child_list_classes = {}

                                                                    self.class_name = YLeaf(YType.str, "class-name")

                                                                    self.enc = YLeaf(YType.enumeration, "enc")

                                                                    self.hd = YLeaf(YType.uint64, "hd")

                                                                    self.idx = YLeaf(YType.uint8, "idx")

                                                                    self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                    self.inline_cmap.parent = self
                                                                    self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                    self._children_yang_names.add("inline-cmap")
                                                                    self._segment_path = lambda: "cl-encode"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                class InlineCmap(Entity):
                                                                    """
                                                                    inline cmap
                                                                    
                                                                    .. attribute:: flags
                                                                    
                                                                    	Inline Class\-Map flags
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_count
                                                                    
                                                                    	Number of Match infos
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Inline Class\-Map Mode Match any/all
                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                        self.yang_name = "inline-cmap"
                                                                        self.yang_parent_name = "cl-encode"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                        self._child_list_classes = {}

                                                                        self.flags = YLeaf(YType.uint32, "flags")

                                                                        self.match_count = YLeaf(YType.uint32, "match-count")

                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._children_yang_names.add("match-infop")
                                                                        self._segment_path = lambda: "inline-cmap"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "inline-cmap"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._children_yang_names.add("match-data")
                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                    self._child_list_classes = {}

                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                    self._children_yang_names.add("access-interface")

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                    self._children_yang_names.add("atm-clp")

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                    self._children_yang_names.add("auth-domain")

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                    self._children_yang_names.add("auth-username")

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                    self._children_yang_names.add("avail-id")

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                    self._children_yang_names.add("circuit-id")

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"
                                                                                    self._children_yang_names.add("cos")

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                    self._children_yang_names.add("cos-inr")

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"
                                                                                    self._children_yang_names.add("dei")

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                    self._children_yang_names.add("dei-inr")

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                    self._children_yang_names.add("discard-class")

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                    self._children_yang_names.add("dnis")

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"
                                                                                    self._children_yang_names.add("domain")

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                    self._children_yang_names.add("domain-regex")

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                    self._children_yang_names.add("dscp")

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                    self._children_yang_names.add("dst-mac")

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._children_yang_names.add("dst-port")

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                    self._children_yang_names.add("ethertype")

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                    self._children_yang_names.add("flow-tag")

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                    self._children_yang_names.add("fr-de")

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                    self._children_yang_names.add("input-interface")

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                    self._children_yang_names.add("media-type")

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                    self._children_yang_names.add("nas-port")

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                    self._children_yang_names.add("packet-len")

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"
                                                                                    self._children_yang_names.add("prec")

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"
                                                                                    self._children_yang_names.add("proto")

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                    self._children_yang_names.add("qos-group")

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                    self._children_yang_names.add("remote-id")

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                    self._children_yang_names.add("service-name")

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                    self._children_yang_names.add("src-mac")

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                    self._children_yang_names.add("src-port")

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"
                                                                                    self._children_yang_names.add("timer")

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                    self._children_yang_names.add("traffic-class")

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                    self._children_yang_names.add("unauth-username")

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                    self._children_yang_names.add("user-name")

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                    self._children_yang_names.add("vendor-id")

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                    self._children_yang_names.add("vlan")

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                    self._segment_path = lambda: "match-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "access-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "avail-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "discard-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                        self._child_list_classes = {}

                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._children_yang_names.add("flow-keys")
                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "fr-de"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "input-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "media-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "src-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                            class ClmpP(Entity):
                                                                """
                                                                clmp p
                                                                
                                                                .. attribute:: class_map_bg
                                                                
                                                                	class map bg
                                                                	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                    self.yang_name = "clmp-p"
                                                                    self.yang_parent_name = "policy-class-info-bg"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {}
                                                                    self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                    self.class_map_bg = YList(self)
                                                                    self._segment_path = lambda: "clmp-p"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                                class ClassMapBg(Entity):
                                                                    """
                                                                    class map bg
                                                                    
                                                                    .. attribute:: description
                                                                    
                                                                    	description
                                                                    	**type**\:  str
                                                                    
                                                                    .. attribute:: match_infop
                                                                    
                                                                    	Pointer to the first Match info
                                                                    	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                    
                                                                    .. attribute:: mode
                                                                    
                                                                    	Class\-Map Mode Match any/Match all
                                                                    	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                    
                                                                    .. attribute:: name
                                                                    
                                                                    	Name of the class\-map
                                                                    	**type**\:  str
                                                                    
                                                                    	**length:** 0..65
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	Class\-Map Type QoS/PBR/Netflow/..
                                                                    	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                        self.yang_name = "class-map-bg"
                                                                        self.yang_parent_name = "clmp-p"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                        self._child_list_classes = {}

                                                                        self.description = YLeaf(YType.str, "description")

                                                                        self.mode = YLeaf(YType.enumeration, "mode")

                                                                        self.name = YLeaf(YType.str, "name")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                        self.match_infop.parent = self
                                                                        self._children_name_map["match_infop"] = "match-infop"
                                                                        self._children_yang_names.add("match-infop")
                                                                        self._segment_path = lambda: "class-map-bg"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                    class MatchInfop(Entity):
                                                                        """
                                                                        Pointer to the first Match info
                                                                        
                                                                        .. attribute:: class_match_info_st
                                                                        
                                                                        	class match info st
                                                                        	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                            self.yang_name = "match-infop"
                                                                            self.yang_parent_name = "class-map-bg"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                            self.class_match_info_st = YList(self)
                                                                            self._segment_path = lambda: "match-infop"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                        class ClassMatchInfoSt(Entity):
                                                                            """
                                                                            class match info st
                                                                            
                                                                            .. attribute:: flags
                                                                            
                                                                            	Flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: match_data
                                                                            
                                                                            	Match criteria
                                                                            	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                self.yang_name = "class-match-info-st"
                                                                                self.yang_parent_name = "match-infop"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                self._child_list_classes = {}

                                                                                self.flags = YLeaf(YType.uint32, "flags")

                                                                                self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                self.match_data.parent = self
                                                                                self._children_name_map["match_data"] = "match-data"
                                                                                self._children_yang_names.add("match-data")
                                                                                self._segment_path = lambda: "class-match-info-st"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                            class MatchData(Entity):
                                                                                """
                                                                                Match criteria
                                                                                
                                                                                .. attribute:: access_interface
                                                                                
                                                                                	Access interface
                                                                                	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                
                                                                                .. attribute:: atm_clp
                                                                                
                                                                                	Match ATM CLP level
                                                                                	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                
                                                                                .. attribute:: auth_domain
                                                                                
                                                                                	Authenticated domain name
                                                                                	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                
                                                                                .. attribute:: auth_domain_regex
                                                                                
                                                                                	Authenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                
                                                                                .. attribute:: auth_username
                                                                                
                                                                                	Authenticated User Name
                                                                                	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                
                                                                                .. attribute:: auth_username_regex
                                                                                
                                                                                	Authenticated User Name RegEx
                                                                                	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                
                                                                                .. attribute:: authen_status
                                                                                
                                                                                	Authentication Status
                                                                                	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                
                                                                                .. attribute:: avail_id
                                                                                
                                                                                	Available Identifiers
                                                                                	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                
                                                                                .. attribute:: circuit_id
                                                                                
                                                                                	Circuit ID
                                                                                	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                
                                                                                .. attribute:: circuit_id_regex
                                                                                
                                                                                	Circuit ID RegEx
                                                                                	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                
                                                                                .. attribute:: cos
                                                                                
                                                                                	Match CoS array
                                                                                	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                
                                                                                .. attribute:: cos_inr
                                                                                
                                                                                	Match inner header CoS
                                                                                	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                
                                                                                .. attribute:: dei
                                                                                
                                                                                	Match DEI Bit
                                                                                	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                
                                                                                .. attribute:: dei_inr
                                                                                
                                                                                	Match inner DEI Bit
                                                                                	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                
                                                                                .. attribute:: dhcp_client_id
                                                                                
                                                                                	Dhcp Client ID
                                                                                	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                
                                                                                .. attribute:: dhcp_client_id_regex
                                                                                
                                                                                	Dhcp Client ID RegEx
                                                                                	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                
                                                                                .. attribute:: discard_class
                                                                                
                                                                                	Match Discard Class array
                                                                                	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                
                                                                                .. attribute:: dnis
                                                                                
                                                                                	DNIS
                                                                                	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                
                                                                                .. attribute:: dnis_regex
                                                                                
                                                                                	DNIS Regular Expression
                                                                                	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                
                                                                                .. attribute:: domain
                                                                                
                                                                                	Domain Name
                                                                                	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                
                                                                                .. attribute:: domain_regex
                                                                                
                                                                                	Domain Regular Expression
                                                                                	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                
                                                                                .. attribute:: dscp
                                                                                
                                                                                	Match DSCP range array
                                                                                	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv4
                                                                                
                                                                                	Destination Address IPV4
                                                                                	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                
                                                                                .. attribute:: dst_addr_ipv6
                                                                                
                                                                                	Destination Address IPV6
                                                                                	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                
                                                                                .. attribute:: dst_mac
                                                                                
                                                                                	Match Destination MAC address
                                                                                	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                
                                                                                .. attribute:: dst_port
                                                                                
                                                                                	Destination port
                                                                                	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                
                                                                                .. attribute:: ether_service_acl
                                                                                
                                                                                	Ethernet\-Services Access\-list
                                                                                	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                
                                                                                .. attribute:: ethertype
                                                                                
                                                                                	Ethernet type
                                                                                	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                
                                                                                .. attribute:: flow_key_data
                                                                                
                                                                                	Flow key structure
                                                                                	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                
                                                                                .. attribute:: flow_tag
                                                                                
                                                                                	Match flow\-tag array
                                                                                	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                
                                                                                .. attribute:: fr_de
                                                                                
                                                                                	Match FR DE value
                                                                                	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                
                                                                                .. attribute:: fr_dlci
                                                                                
                                                                                	Match FR DLCI range array
                                                                                	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                
                                                                                .. attribute:: fragment_type
                                                                                
                                                                                	Fragment type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: icmp_v4
                                                                                
                                                                                	Match ICMPV4 Protocol
                                                                                	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                
                                                                                .. attribute:: icmp_v6
                                                                                
                                                                                	Match ICMPV6 Protocol array
                                                                                	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                
                                                                                .. attribute:: icmpv4_code
                                                                                
                                                                                	Match ipv4 icmp code
                                                                                	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                
                                                                                .. attribute:: icmpv4_type
                                                                                
                                                                                	Match ipv4 icmp type
                                                                                	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                
                                                                                .. attribute:: icmpv6_code
                                                                                
                                                                                	Match ipv6 icmp code
                                                                                	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                
                                                                                .. attribute:: icmpv6_type
                                                                                
                                                                                	Match ipv6 icmp type
                                                                                	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                
                                                                                .. attribute:: input_interface
                                                                                
                                                                                	Input interface
                                                                                	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                
                                                                                .. attribute:: input_intfhdl
                                                                                
                                                                                	Input interface handle
                                                                                	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                
                                                                                .. attribute:: ipv4_acl
                                                                                
                                                                                	IPv4 Access\-list
                                                                                	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                
                                                                                .. attribute:: ipv4_dscp
                                                                                
                                                                                	IPv4 DSCP
                                                                                	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                
                                                                                .. attribute:: ipv4_packet_len
                                                                                
                                                                                	IPv4 packet length array
                                                                                	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                
                                                                                .. attribute:: ipv4_prec
                                                                                
                                                                                	IPv4 Precedence
                                                                                	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                
                                                                                .. attribute:: ipv6_acl
                                                                                
                                                                                	IPv6 Access\-list
                                                                                	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                
                                                                                .. attribute:: ipv6_dscp
                                                                                
                                                                                	IPv6 DSCP
                                                                                	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                
                                                                                .. attribute:: ipv6_packet_len
                                                                                
                                                                                	IPv6 packet length array
                                                                                	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                
                                                                                .. attribute:: ipv6_prec
                                                                                
                                                                                	IPv6 Precedence
                                                                                	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                
                                                                                .. attribute:: media_type
                                                                                
                                                                                	Media Type
                                                                                	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                
                                                                                .. attribute:: mlp_negotiated
                                                                                
                                                                                	MLP Negotiated
                                                                                	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv4_acl
                                                                                
                                                                                	MPLS Disposition IPv4 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                
                                                                                .. attribute:: mpls_disp_ipv6_acl
                                                                                
                                                                                	MPLS Disposition IPv6 Access\-list
                                                                                	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                
                                                                                .. attribute:: mpls_exp
                                                                                
                                                                                	Match MPLS experimental topmost array
                                                                                	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                
                                                                                .. attribute:: mpls_exp_imp
                                                                                
                                                                                	Match MPLS experimental imposition array
                                                                                	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                
                                                                                .. attribute:: mpls_top_eos
                                                                                
                                                                                	MPLS Topmost EOS
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: mpls_top_label
                                                                                
                                                                                	MPLS Topmost LABEL
                                                                                	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                
                                                                                .. attribute:: nas_port
                                                                                
                                                                                	NAS Port
                                                                                	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                
                                                                                .. attribute:: packet_len
                                                                                
                                                                                	Match packet length array
                                                                                	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                
                                                                                .. attribute:: prec
                                                                                
                                                                                	Match Precedence array
                                                                                	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                
                                                                                .. attribute:: proto
                                                                                
                                                                                	Match Protocol array
                                                                                	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                
                                                                                .. attribute:: qos_group
                                                                                
                                                                                	Match QoS group array
                                                                                	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                
                                                                                .. attribute:: remote_id
                                                                                
                                                                                	Remote ID
                                                                                	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                
                                                                                .. attribute:: remote_id_regex
                                                                                
                                                                                	Remote ID RegEx
                                                                                	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                
                                                                                .. attribute:: service_name
                                                                                
                                                                                	Service Name
                                                                                	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                
                                                                                .. attribute:: service_name_regex
                                                                                
                                                                                	Service Name Regular Exp
                                                                                	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                
                                                                                .. attribute:: src_addr_ipv4
                                                                                
                                                                                	Source Address IPV4
                                                                                	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                
                                                                                .. attribute:: src_addr_ipv6
                                                                                
                                                                                	Source Address IPV6
                                                                                	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                
                                                                                .. attribute:: src_addr_mac
                                                                                
                                                                                	Source Address MAC
                                                                                	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                
                                                                                .. attribute:: src_mac
                                                                                
                                                                                	Match Source MAC address
                                                                                	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                
                                                                                .. attribute:: src_port
                                                                                
                                                                                	Source port
                                                                                	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                
                                                                                .. attribute:: subs_protocol
                                                                                
                                                                                	Protocol
                                                                                	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                
                                                                                .. attribute:: tcp_flag
                                                                                
                                                                                	Match tcp flag value
                                                                                	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                
                                                                                .. attribute:: timer
                                                                                
                                                                                	Timer
                                                                                	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                
                                                                                .. attribute:: timer_regexp
                                                                                
                                                                                	Timer Regular Expression
                                                                                	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                
                                                                                .. attribute:: traffic_class
                                                                                
                                                                                	Match Traffic class array
                                                                                	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                
                                                                                .. attribute:: tunnel_name
                                                                                
                                                                                	Tunnel Name
                                                                                	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                
                                                                                .. attribute:: tunnel_name_regex
                                                                                
                                                                                	Tunnel Name Regular Expression
                                                                                	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                
                                                                                .. attribute:: unauth_domain
                                                                                
                                                                                	Unauthenticated Domain Name
                                                                                	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                
                                                                                .. attribute:: unauth_domain_regex
                                                                                
                                                                                	Unauthenticated Domain Name RegEx
                                                                                	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                
                                                                                .. attribute:: unauth_username
                                                                                
                                                                                	Unauthenticated User Name
                                                                                	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                
                                                                                .. attribute:: unauth_username_regex
                                                                                
                                                                                	Unauthenticated User Name RegEx
                                                                                	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                
                                                                                .. attribute:: user_name
                                                                                
                                                                                	User Name
                                                                                	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                
                                                                                .. attribute:: user_name_regex
                                                                                
                                                                                	User Name Regular Expression
                                                                                	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                
                                                                                .. attribute:: vendor_id
                                                                                
                                                                                	Vendor ID
                                                                                	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                
                                                                                .. attribute:: vendor_id_regex
                                                                                
                                                                                	Vendor ID RegEx
                                                                                	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                
                                                                                .. attribute:: vlan
                                                                                
                                                                                	Match VLAN array
                                                                                	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                
                                                                                .. attribute:: vlan_inr
                                                                                
                                                                                	Match inner header VLAN range array
                                                                                	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                    self.yang_name = "match-data"
                                                                                    self.yang_parent_name = "class-match-info-st"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                    self._child_list_classes = {}

                                                                                    self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                    self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                    self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                    self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                    self.access_interface.parent = self
                                                                                    self._children_name_map["access_interface"] = "access-interface"
                                                                                    self._children_yang_names.add("access-interface")

                                                                                    self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                    self.atm_clp.parent = self
                                                                                    self._children_name_map["atm_clp"] = "atm-clp"
                                                                                    self._children_yang_names.add("atm-clp")

                                                                                    self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                    self.auth_domain.parent = self
                                                                                    self._children_name_map["auth_domain"] = "auth-domain"
                                                                                    self._children_yang_names.add("auth-domain")

                                                                                    self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                    self.auth_domain_regex.parent = self
                                                                                    self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                    self._children_yang_names.add("auth-domain-regex")

                                                                                    self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                    self.auth_username.parent = self
                                                                                    self._children_name_map["auth_username"] = "auth-username"
                                                                                    self._children_yang_names.add("auth-username")

                                                                                    self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                    self.auth_username_regex.parent = self
                                                                                    self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                    self._children_yang_names.add("auth-username-regex")

                                                                                    self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                    self.avail_id.parent = self
                                                                                    self._children_name_map["avail_id"] = "avail-id"
                                                                                    self._children_yang_names.add("avail-id")

                                                                                    self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                    self.circuit_id.parent = self
                                                                                    self._children_name_map["circuit_id"] = "circuit-id"
                                                                                    self._children_yang_names.add("circuit-id")

                                                                                    self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                    self.circuit_id_regex.parent = self
                                                                                    self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                    self._children_yang_names.add("circuit-id-regex")

                                                                                    self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                    self.cos.parent = self
                                                                                    self._children_name_map["cos"] = "cos"
                                                                                    self._children_yang_names.add("cos")

                                                                                    self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                    self.cos_inr.parent = self
                                                                                    self._children_name_map["cos_inr"] = "cos-inr"
                                                                                    self._children_yang_names.add("cos-inr")

                                                                                    self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                    self.dei.parent = self
                                                                                    self._children_name_map["dei"] = "dei"
                                                                                    self._children_yang_names.add("dei")

                                                                                    self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                    self.dei_inr.parent = self
                                                                                    self._children_name_map["dei_inr"] = "dei-inr"
                                                                                    self._children_yang_names.add("dei-inr")

                                                                                    self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                    self.dhcp_client_id.parent = self
                                                                                    self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                    self._children_yang_names.add("dhcp-client-id")

                                                                                    self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                    self.dhcp_client_id_regex.parent = self
                                                                                    self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                    self._children_yang_names.add("dhcp-client-id-regex")

                                                                                    self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                    self.discard_class.parent = self
                                                                                    self._children_name_map["discard_class"] = "discard-class"
                                                                                    self._children_yang_names.add("discard-class")

                                                                                    self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                    self.dnis.parent = self
                                                                                    self._children_name_map["dnis"] = "dnis"
                                                                                    self._children_yang_names.add("dnis")

                                                                                    self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                    self.dnis_regex.parent = self
                                                                                    self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                    self._children_yang_names.add("dnis-regex")

                                                                                    self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                    self.domain.parent = self
                                                                                    self._children_name_map["domain"] = "domain"
                                                                                    self._children_yang_names.add("domain")

                                                                                    self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                    self.domain_regex.parent = self
                                                                                    self._children_name_map["domain_regex"] = "domain-regex"
                                                                                    self._children_yang_names.add("domain-regex")

                                                                                    self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                    self.dscp.parent = self
                                                                                    self._children_name_map["dscp"] = "dscp"
                                                                                    self._children_yang_names.add("dscp")

                                                                                    self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                    self.dst_addr_ipv4.parent = self
                                                                                    self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                    self._children_yang_names.add("dst-addr-ipv4")

                                                                                    self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                    self.dst_addr_ipv6.parent = self
                                                                                    self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                    self._children_yang_names.add("dst-addr-ipv6")

                                                                                    self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                    self.dst_mac.parent = self
                                                                                    self._children_name_map["dst_mac"] = "dst-mac"
                                                                                    self._children_yang_names.add("dst-mac")

                                                                                    self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                    self.dst_port.parent = self
                                                                                    self._children_name_map["dst_port"] = "dst-port"
                                                                                    self._children_yang_names.add("dst-port")

                                                                                    self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                    self.ether_service_acl.parent = self
                                                                                    self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                    self._children_yang_names.add("ether-service-acl")

                                                                                    self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                    self.ethertype.parent = self
                                                                                    self._children_name_map["ethertype"] = "ethertype"
                                                                                    self._children_yang_names.add("ethertype")

                                                                                    self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                    self.flow_key_data.parent = self
                                                                                    self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                    self._children_yang_names.add("flow-key-data")

                                                                                    self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                    self.flow_tag.parent = self
                                                                                    self._children_name_map["flow_tag"] = "flow-tag"
                                                                                    self._children_yang_names.add("flow-tag")

                                                                                    self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                    self.fr_de.parent = self
                                                                                    self._children_name_map["fr_de"] = "fr-de"
                                                                                    self._children_yang_names.add("fr-de")

                                                                                    self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                    self.fr_dlci.parent = self
                                                                                    self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                    self._children_yang_names.add("fr-dlci")

                                                                                    self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                    self.icmp_v4.parent = self
                                                                                    self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                    self._children_yang_names.add("icmp-v4")

                                                                                    self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                    self.icmp_v6.parent = self
                                                                                    self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                    self._children_yang_names.add("icmp-v6")

                                                                                    self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                    self.icmpv4_code.parent = self
                                                                                    self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                    self._children_yang_names.add("icmpv4-code")

                                                                                    self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                    self.icmpv4_type.parent = self
                                                                                    self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                    self._children_yang_names.add("icmpv4-type")

                                                                                    self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                    self.icmpv6_code.parent = self
                                                                                    self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                    self._children_yang_names.add("icmpv6-code")

                                                                                    self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                    self.icmpv6_type.parent = self
                                                                                    self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                    self._children_yang_names.add("icmpv6-type")

                                                                                    self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                    self.input_interface.parent = self
                                                                                    self._children_name_map["input_interface"] = "input-interface"
                                                                                    self._children_yang_names.add("input-interface")

                                                                                    self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                    self.input_intfhdl.parent = self
                                                                                    self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                    self._children_yang_names.add("input-intfhdl")

                                                                                    self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                    self.ipv4_acl.parent = self
                                                                                    self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                    self._children_yang_names.add("ipv4-acl")

                                                                                    self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                    self.ipv4_dscp.parent = self
                                                                                    self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                    self._children_yang_names.add("ipv4-dscp")

                                                                                    self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                    self.ipv4_packet_len.parent = self
                                                                                    self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                    self._children_yang_names.add("ipv4-packet-len")

                                                                                    self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                    self.ipv4_prec.parent = self
                                                                                    self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                    self._children_yang_names.add("ipv4-prec")

                                                                                    self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                    self.ipv6_acl.parent = self
                                                                                    self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                    self._children_yang_names.add("ipv6-acl")

                                                                                    self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                    self.ipv6_dscp.parent = self
                                                                                    self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                    self._children_yang_names.add("ipv6-dscp")

                                                                                    self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                    self.ipv6_packet_len.parent = self
                                                                                    self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                    self._children_yang_names.add("ipv6-packet-len")

                                                                                    self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                    self.ipv6_prec.parent = self
                                                                                    self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                    self._children_yang_names.add("ipv6-prec")

                                                                                    self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                    self.media_type.parent = self
                                                                                    self._children_name_map["media_type"] = "media-type"
                                                                                    self._children_yang_names.add("media-type")

                                                                                    self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                    self.mpls_disp_ipv4_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                    self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                    self.mpls_disp_ipv6_acl.parent = self
                                                                                    self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                    self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                    self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                    self.mpls_exp.parent = self
                                                                                    self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                    self._children_yang_names.add("mpls-exp")

                                                                                    self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                    self.mpls_exp_imp.parent = self
                                                                                    self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                    self._children_yang_names.add("mpls-exp-imp")

                                                                                    self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                    self.mpls_top_label.parent = self
                                                                                    self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                    self._children_yang_names.add("mpls-top-label")

                                                                                    self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                    self.nas_port.parent = self
                                                                                    self._children_name_map["nas_port"] = "nas-port"
                                                                                    self._children_yang_names.add("nas-port")

                                                                                    self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                    self.packet_len.parent = self
                                                                                    self._children_name_map["packet_len"] = "packet-len"
                                                                                    self._children_yang_names.add("packet-len")

                                                                                    self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                    self.prec.parent = self
                                                                                    self._children_name_map["prec"] = "prec"
                                                                                    self._children_yang_names.add("prec")

                                                                                    self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                    self.proto.parent = self
                                                                                    self._children_name_map["proto"] = "proto"
                                                                                    self._children_yang_names.add("proto")

                                                                                    self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                    self.qos_group.parent = self
                                                                                    self._children_name_map["qos_group"] = "qos-group"
                                                                                    self._children_yang_names.add("qos-group")

                                                                                    self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                    self.remote_id.parent = self
                                                                                    self._children_name_map["remote_id"] = "remote-id"
                                                                                    self._children_yang_names.add("remote-id")

                                                                                    self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                    self.remote_id_regex.parent = self
                                                                                    self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                    self._children_yang_names.add("remote-id-regex")

                                                                                    self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                    self.service_name.parent = self
                                                                                    self._children_name_map["service_name"] = "service-name"
                                                                                    self._children_yang_names.add("service-name")

                                                                                    self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                    self.service_name_regex.parent = self
                                                                                    self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                    self._children_yang_names.add("service-name-regex")

                                                                                    self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                    self.src_addr_ipv4.parent = self
                                                                                    self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                    self._children_yang_names.add("src-addr-ipv4")

                                                                                    self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                    self.src_addr_ipv6.parent = self
                                                                                    self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                    self._children_yang_names.add("src-addr-ipv6")

                                                                                    self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                    self.src_addr_mac.parent = self
                                                                                    self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                    self._children_yang_names.add("src-addr-mac")

                                                                                    self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                    self.src_mac.parent = self
                                                                                    self._children_name_map["src_mac"] = "src-mac"
                                                                                    self._children_yang_names.add("src-mac")

                                                                                    self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                    self.src_port.parent = self
                                                                                    self._children_name_map["src_port"] = "src-port"
                                                                                    self._children_yang_names.add("src-port")

                                                                                    self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                    self.subs_protocol.parent = self
                                                                                    self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                    self._children_yang_names.add("subs-protocol")

                                                                                    self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                    self.tcp_flag.parent = self
                                                                                    self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                    self._children_yang_names.add("tcp-flag")

                                                                                    self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                    self.timer.parent = self
                                                                                    self._children_name_map["timer"] = "timer"
                                                                                    self._children_yang_names.add("timer")

                                                                                    self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                    self.timer_regexp.parent = self
                                                                                    self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                    self._children_yang_names.add("timer-regexp")

                                                                                    self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                    self.traffic_class.parent = self
                                                                                    self._children_name_map["traffic_class"] = "traffic-class"
                                                                                    self._children_yang_names.add("traffic-class")

                                                                                    self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                    self.tunnel_name.parent = self
                                                                                    self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                    self._children_yang_names.add("tunnel-name")

                                                                                    self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                    self.tunnel_name_regex.parent = self
                                                                                    self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                    self._children_yang_names.add("tunnel-name-regex")

                                                                                    self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                    self.unauth_domain.parent = self
                                                                                    self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                    self._children_yang_names.add("unauth-domain")

                                                                                    self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                    self.unauth_domain_regex.parent = self
                                                                                    self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                    self._children_yang_names.add("unauth-domain-regex")

                                                                                    self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                    self.unauth_username.parent = self
                                                                                    self._children_name_map["unauth_username"] = "unauth-username"
                                                                                    self._children_yang_names.add("unauth-username")

                                                                                    self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                    self.unauth_username_regex.parent = self
                                                                                    self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                    self._children_yang_names.add("unauth-username-regex")

                                                                                    self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                    self.user_name.parent = self
                                                                                    self._children_name_map["user_name"] = "user-name"
                                                                                    self._children_yang_names.add("user-name")

                                                                                    self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                    self.user_name_regex.parent = self
                                                                                    self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                    self._children_yang_names.add("user-name-regex")

                                                                                    self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                    self.vendor_id.parent = self
                                                                                    self._children_name_map["vendor_id"] = "vendor-id"
                                                                                    self._children_yang_names.add("vendor-id")

                                                                                    self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                    self.vendor_id_regex.parent = self
                                                                                    self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                    self._children_yang_names.add("vendor-id-regex")

                                                                                    self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                    self.vlan.parent = self
                                                                                    self._children_name_map["vlan"] = "vlan"
                                                                                    self._children_yang_names.add("vlan")

                                                                                    self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                    self.vlan_inr.parent = self
                                                                                    self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                    self._children_yang_names.add("vlan-inr")
                                                                                    self._segment_path = lambda: "match-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                class AccessInterface(Entity):
                                                                                    """
                                                                                    Access interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                        self.yang_name = "access-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "access-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                class AtmClp(Entity):
                                                                                    """
                                                                                    Match ATM CLP level
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                        self.yang_name = "atm-clp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "atm-clp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                class AuthDomain(Entity):
                                                                                    """
                                                                                    Authenticated domain name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                        self.yang_name = "auth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                class AuthDomainRegex(Entity):
                                                                                    """
                                                                                    Authenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                        self.yang_name = "auth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                class AuthUsername(Entity):
                                                                                    """
                                                                                    Authenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                        self.yang_name = "auth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                class AuthUsernameRegex(Entity):
                                                                                    """
                                                                                    Authenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "auth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "auth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                class AvailId(Entity):
                                                                                    """
                                                                                    Available Identifiers
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                        self.yang_name = "avail-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "avail-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                class CircuitId(Entity):
                                                                                    """
                                                                                    Circuit ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                        self.yang_name = "circuit-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                class CircuitIdRegex(Entity):
                                                                                    """
                                                                                    Circuit ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                        self.yang_name = "circuit-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "circuit-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                class Cos(Entity):
                                                                                    """
                                                                                    Match CoS array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                        self.yang_name = "cos"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                class CosInr(Entity):
                                                                                    """
                                                                                    Match inner header CoS
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                        self.yang_name = "cos-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "cos-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                class Dei(Entity):
                                                                                    """
                                                                                    Match DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                        self.yang_name = "dei"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                class DeiInr(Entity):
                                                                                    """
                                                                                    Match inner DEI Bit
                                                                                    
                                                                                    .. attribute:: bit_value
                                                                                    
                                                                                    	Value of the DEI bit
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                        self.yang_name = "dei-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                        self._segment_path = lambda: "dei-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                class DhcpClientId(Entity):
                                                                                    """
                                                                                    Dhcp Client ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                class DhcpClientIdRegex(Entity):
                                                                                    """
                                                                                    Dhcp Client ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                        self.yang_name = "dhcp-client-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                class DiscardClass(Entity):
                                                                                    """
                                                                                    Match Discard Class array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                        self.yang_name = "discard-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "discard-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                class Dnis(Entity):
                                                                                    """
                                                                                    DNIS
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                        self.yang_name = "dnis"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                class DnisRegex(Entity):
                                                                                    """
                                                                                    DNIS Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                        self.yang_name = "dnis-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "dnis-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                class Domain(Entity):
                                                                                    """
                                                                                    Domain Name
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                        self.yang_name = "domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class DomainRegex(Entity):
                                                                                    """
                                                                                    Domain Regular Expression
                                                                                    
                                                                                    .. attribute:: domain_array
                                                                                    
                                                                                    	domain array
                                                                                    	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                        self.yang_name = "domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                        self.domain_array = YList(self)
                                                                                        self._segment_path = lambda: "domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                    class DomainArray(Entity):
                                                                                        """
                                                                                        domain array
                                                                                        
                                                                                        .. attribute:: domain_name
                                                                                        
                                                                                        	domain name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        .. attribute:: format_name
                                                                                        
                                                                                        	format name
                                                                                        	**type**\:  str
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                            self.yang_name = "domain-array"
                                                                                            self.yang_parent_name = "domain-regex"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                            self.format_name = YLeaf(YType.str, "format-name")
                                                                                            self._segment_path = lambda: "domain-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                class Dscp(Entity):
                                                                                    """
                                                                                    Match DSCP range array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                        self.yang_name = "dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class DstAddrIpv4(Entity):
                                                                                    """
                                                                                    Destination Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstAddrIpv6(Entity):
                                                                                    """
                                                                                    Destination Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                        self.yang_name = "dst-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "dst-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class DstMac(Entity):
                                                                                    """
                                                                                    Match Destination MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                        self.yang_name = "dst-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "dst-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                class DstPort(Entity):
                                                                                    """
                                                                                    Destination port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                        self.yang_name = "dst-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "dst-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "dst-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class EtherServiceAcl(Entity):
                                                                                    """
                                                                                    Ethernet\-Services Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                        self.yang_name = "ether-service-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ether-service-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                class Ethertype(Entity):
                                                                                    """
                                                                                    Ethernet type
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                        self.yang_name = "ethertype"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ethertype"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ethertype"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class FlowKeyData(Entity):
                                                                                    """
                                                                                    Flow key structure
                                                                                    
                                                                                    .. attribute:: flow_keys
                                                                                    
                                                                                    	flow keys
                                                                                    	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                    
                                                                                    .. attribute:: idle_timeout
                                                                                    
                                                                                    	Idle timeout of flows (in seconds)
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    	**units**\: second
                                                                                    
                                                                                    .. attribute:: max_count
                                                                                    
                                                                                    	Maximum count of flows
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                        self.yang_name = "flow-key-data"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                        self._child_list_classes = {}

                                                                                        self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                        self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                        self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                        self.flow_keys.parent = self
                                                                                        self._children_name_map["flow_keys"] = "flow-keys"
                                                                                        self._children_yang_names.add("flow-keys")
                                                                                        self._segment_path = lambda: "flow-key-data"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                    class FlowKeys(Entity):
                                                                                        """
                                                                                        flow keys
                                                                                        
                                                                                        .. attribute:: keys
                                                                                        
                                                                                        	keys
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                        
                                                                                        .. attribute:: num
                                                                                        
                                                                                        	num
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                            self.yang_name = "flow-keys"
                                                                                            self.yang_parent_name = "flow-key-data"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.keys = YLeaf(YType.str, "keys")

                                                                                            self.num = YLeaf(YType.uint8, "num")
                                                                                            self._segment_path = lambda: "flow-keys"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                class FlowTag(Entity):
                                                                                    """
                                                                                    Match flow\-tag array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                        self.yang_name = "flow-tag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "flow-tag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "flow-tag"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class FrDe(Entity):
                                                                                    """
                                                                                    Match FR DE value
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                        self.yang_name = "fr-de"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "fr-de"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                class FrDlci(Entity):
                                                                                    """
                                                                                    Match FR DLCI range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                        self.yang_name = "fr-dlci"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "fr-dlci"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "fr-dlci"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class IcmpV4(Entity):
                                                                                    """
                                                                                    Match ICMPV4 Protocol
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                        self.yang_name = "icmp-v4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                class IcmpV6(Entity):
                                                                                    """
                                                                                    Match ICMPV6 Protocol array
                                                                                    
                                                                                    .. attribute:: code
                                                                                    
                                                                                    	Protocol code
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	Protocol type
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                        self.yang_name = "icmp-v6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.code = YLeaf(YType.uint8, "code")

                                                                                        self.type = YLeaf(YType.uint8, "type")
                                                                                        self._segment_path = lambda: "icmp-v6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                class Icmpv4Code(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                        self.yang_name = "icmpv4-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv4Type(Entity):
                                                                                    """
                                                                                    Match ipv4 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                        self.yang_name = "icmpv4-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv4-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv4-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Code(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp code
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                        self.yang_name = "icmpv6-code"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-code"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-code"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Icmpv6Type(Entity):
                                                                                    """
                                                                                    Match ipv6 icmp type
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                        self.yang_name = "icmpv6-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "icmpv6-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "icmpv6-type"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class InputInterface(Entity):
                                                                                    """
                                                                                    Input interface
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                        self.yang_name = "input-interface"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "input-interface"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                class InputIntfhdl(Entity):
                                                                                    """
                                                                                    Input interface handle
                                                                                    
                                                                                    .. attribute:: uint64_array
                                                                                    
                                                                                    	uint64 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..18446744073709551615
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                        self.yang_name = "input-intfhdl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                        self._segment_path = lambda: "input-intfhdl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                class Ipv4Acl(Entity):
                                                                                    """
                                                                                    IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                        self.yang_name = "ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                class Ipv4Dscp(Entity):
                                                                                    """
                                                                                    IPv4 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                        self.yang_name = "ipv4-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv4-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4PacketLen(Entity):
                                                                                    """
                                                                                    IPv4 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv4-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv4-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv4-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv4Prec(Entity):
                                                                                    """
                                                                                    IPv4 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                        self.yang_name = "ipv4-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv4-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                class Ipv6Acl(Entity):
                                                                                    """
                                                                                    IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                        self.yang_name = "ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                class Ipv6Dscp(Entity):
                                                                                    """
                                                                                    IPv6 DSCP
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                        self.yang_name = "ipv6-dscp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-dscp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "ipv6-dscp"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6PacketLen(Entity):
                                                                                    """
                                                                                    IPv6 packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                        self.yang_name = "ipv6-packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "ipv6-packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "ipv6-packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Ipv6Prec(Entity):
                                                                                    """
                                                                                    IPv6 Precedence
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                        self.yang_name = "ipv6-prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "ipv6-prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                class MediaType(Entity):
                                                                                    """
                                                                                    Media Type
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                        self.yang_name = "media-type"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "media-type"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                class MplsDispIpv4Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv4 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv4-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                class MplsDispIpv6Acl(Entity):
                                                                                    """
                                                                                    MPLS Disposition IPv6 Access\-list
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                        self.yang_name = "mpls-disp-ipv6-acl"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                class MplsExp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental topmost array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                        self.yang_name = "mpls-exp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                class MplsExpImp(Entity):
                                                                                    """
                                                                                    Match MPLS experimental imposition array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                        self.yang_name = "mpls-exp-imp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "mpls-exp-imp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                class MplsTopLabel(Entity):
                                                                                    """
                                                                                    MPLS Topmost LABEL
                                                                                    
                                                                                    .. attribute:: uint32_rng_array
                                                                                    
                                                                                    	uint32 rng array
                                                                                    	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                        self.yang_name = "mpls-top-label"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                        self.uint32_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "mpls-top-label"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                    class Uint32RngArray(Entity):
                                                                                        """
                                                                                        uint32 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                            self.yang_name = "uint32_rng_array"
                                                                                            self.yang_parent_name = "mpls-top-label"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint32, "max")

                                                                                            self.min = YLeaf(YType.uint32, "min")
                                                                                            self._segment_path = lambda: "uint32_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                class NasPort(Entity):
                                                                                    """
                                                                                    NAS Port
                                                                                    
                                                                                    .. attribute:: nas_port_array
                                                                                    
                                                                                    	nas port array
                                                                                    	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                        self.yang_name = "nas-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                        self.nas_port_array = YList(self)
                                                                                        self._segment_path = lambda: "nas-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                    class NasPortArray(Entity):
                                                                                        """
                                                                                        nas port array
                                                                                        
                                                                                        .. attribute:: operator
                                                                                        
                                                                                        	operator
                                                                                        	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                        
                                                                                        .. attribute:: sub_id
                                                                                        
                                                                                        	sub id
                                                                                        	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                        
                                                                                        .. attribute:: value
                                                                                        
                                                                                        	value
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                            self.yang_name = "nas-port-array"
                                                                                            self.yang_parent_name = "nas-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.operator = YLeaf(YType.enumeration, "operator")

                                                                                            self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                                            self._segment_path = lambda: "nas-port-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                class PacketLen(Entity):
                                                                                    """
                                                                                    Match packet length array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                        self.yang_name = "packet-len"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "packet-len"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "packet-len"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class Prec(Entity):
                                                                                    """
                                                                                    Match Precedence array
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                        self.yang_name = "prec"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "prec"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                class Proto(Entity):
                                                                                    """
                                                                                    Match Protocol array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                        self.yang_name = "proto"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "proto"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "proto"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class QosGroup(Entity):
                                                                                    """
                                                                                    Match QoS group array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                        self.yang_name = "qos-group"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "qos-group"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "qos-group"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class RemoteId(Entity):
                                                                                    """
                                                                                    Remote ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                        self.yang_name = "remote-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                class RemoteIdRegex(Entity):
                                                                                    """
                                                                                    Remote ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                        self.yang_name = "remote-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "remote-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                class ServiceName(Entity):
                                                                                    """
                                                                                    Service Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                        self.yang_name = "service-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                class ServiceNameRegex(Entity):
                                                                                    """
                                                                                    Service Name Regular Exp
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                        self.yang_name = "service-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "service-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                class SrcAddrIpv4(Entity):
                                                                                    """
                                                                                    Source Address IPV4
                                                                                    
                                                                                    .. attribute:: ipv4_addr_array
                                                                                    
                                                                                    	ipv4 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv4"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                        self.ipv4_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv4"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                    class Ipv4AddrArray(Entity):
                                                                                        """
                                                                                        ipv4 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	mask
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv4-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv4"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.str, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv4-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrIpv6(Entity):
                                                                                    """
                                                                                    Source Address IPV6
                                                                                    
                                                                                    .. attribute:: ipv6_addr_array
                                                                                    
                                                                                    	ipv6 addr array
                                                                                    	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                        self.yang_name = "src-addr-ipv6"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                        self.ipv6_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-ipv6"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                    class Ipv6AddrArray(Entity):
                                                                                        """
                                                                                        ipv6 addr array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	IPV6 mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: prefix
                                                                                        
                                                                                        	IPV6 prefix
                                                                                        	**type**\:  str
                                                                                        
                                                                                        	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                            self.yang_name = "ipv6-addr-array"
                                                                                            self.yang_parent_name = "src-addr-ipv6"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint32, "mask")

                                                                                            self.prefix = YLeaf(YType.str, "prefix")
                                                                                            self._segment_path = lambda: "ipv6-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                class SrcAddrMac(Entity):
                                                                                    """
                                                                                    Source Address MAC
                                                                                    
                                                                                    .. attribute:: mac_addr_array
                                                                                    
                                                                                    	mac addr array
                                                                                    	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                        self.yang_name = "src-addr-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                        self.mac_addr_array = YList(self)
                                                                                        self._segment_path = lambda: "src-addr-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                    class MacAddrArray(Entity):
                                                                                        """
                                                                                        mac addr array
                                                                                        
                                                                                        .. attribute:: mac_addr
                                                                                        
                                                                                        	MAC address
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	MAC mask
                                                                                        	**type**\:  list of int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                            self.yang_name = "mac-addr-array"
                                                                                            self.yang_parent_name = "src-addr-mac"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                            self.mask = YLeafList(YType.uint16, "mask")
                                                                                            self._segment_path = lambda: "mac-addr-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                class SrcMac(Entity):
                                                                                    """
                                                                                    Match Source MAC address
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                        self.yang_name = "src-mac"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "src-mac"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                class SrcPort(Entity):
                                                                                    """
                                                                                    Source port
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                        self.yang_name = "src-port"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "src-port"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "src-port"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                class SubsProtocol(Entity):
                                                                                    """
                                                                                    Protocol
                                                                                    
                                                                                    .. attribute:: uint8_array
                                                                                    
                                                                                    	uint8 array
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                        self.yang_name = "subs-protocol"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                        self._segment_path = lambda: "subs-protocol"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                class TcpFlag(Entity):
                                                                                    """
                                                                                    Match tcp flag value
                                                                                    
                                                                                    .. attribute:: match_any
                                                                                    
                                                                                    	Match any TCP flag bit
                                                                                    	**type**\:  bool
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	Value of TCP flag
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                        self.yang_name = "tcp-flag"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "tcp-flag"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                class Timer(Entity):
                                                                                    """
                                                                                    Timer
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                        self.yang_name = "timer"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                class TimerRegexp(Entity):
                                                                                    """
                                                                                    Timer Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                        self.yang_name = "timer-regexp"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "timer-regexp"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                class TrafficClass(Entity):
                                                                                    """
                                                                                    Match Traffic class array
                                                                                    
                                                                                    .. attribute:: uint8_rng_array
                                                                                    
                                                                                    	uint8 rng array
                                                                                    	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                        self.yang_name = "traffic-class"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                        self.uint8_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "traffic-class"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                    class Uint8RngArray(Entity):
                                                                                        """
                                                                                        uint8 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..255
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                            self.yang_name = "uint8_rng_array"
                                                                                            self.yang_parent_name = "traffic-class"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint8, "max")

                                                                                            self.min = YLeaf(YType.uint8, "min")
                                                                                            self._segment_path = lambda: "uint8_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                class TunnelName(Entity):
                                                                                    """
                                                                                    Tunnel Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                        self.yang_name = "tunnel-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                class TunnelNameRegex(Entity):
                                                                                    """
                                                                                    Tunnel Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                        self.yang_name = "tunnel-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "tunnel-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                class UnauthDomain(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                        self.yang_name = "unauth-domain"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                class UnauthDomainRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated Domain Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                        self.yang_name = "unauth-domain-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-domain-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                class UnauthUsername(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                        self.yang_name = "unauth-username"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                class UnauthUsernameRegex(Entity):
                                                                                    """
                                                                                    Unauthenticated User Name RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                        self.yang_name = "unauth-username-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "unauth-username-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                class UserName(Entity):
                                                                                    """
                                                                                    User Name
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                        self.yang_name = "user-name"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                class UserNameRegex(Entity):
                                                                                    """
                                                                                    User Name Regular Expression
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                        self.yang_name = "user-name-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "user-name-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                class VendorId(Entity):
                                                                                    """
                                                                                    Vendor ID
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                        self.yang_name = "vendor-id"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                class VendorIdRegex(Entity):
                                                                                    """
                                                                                    Vendor ID RegEx
                                                                                    
                                                                                    .. attribute:: string_array
                                                                                    
                                                                                    	string array
                                                                                    	**type**\:  list of str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                        self.yang_name = "vendor-id-regex"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.string_array = YLeafList(YType.str, "string-array")
                                                                                        self._segment_path = lambda: "vendor-id-regex"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                class Vlan(Entity):
                                                                                    """
                                                                                    Match VLAN array
                                                                                    
                                                                                    .. attribute:: vlan_id_array
                                                                                    
                                                                                    	vlan id array
                                                                                    	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                        self.yang_name = "vlan"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                        self.vlan_id_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                    class VlanIdArray(Entity):
                                                                                        """
                                                                                        vlan id array
                                                                                        
                                                                                        .. attribute:: mask
                                                                                        
                                                                                        	VLAN mask
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                            self.yang_name = "vlan-id-array"
                                                                                            self.yang_parent_name = "vlan"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.mask = YLeaf(YType.uint16, "mask")

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "vlan-id-array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                class VlanInr(Entity):
                                                                                    """
                                                                                    Match inner header VLAN range array
                                                                                    
                                                                                    .. attribute:: uint16_rng_array
                                                                                    
                                                                                    	uint16 rng array
                                                                                    	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                        self.yang_name = "vlan-inr"
                                                                                        self.yang_parent_name = "match-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                        self.uint16_rng_array = YList(self)
                                                                                        self._segment_path = lambda: "vlan-inr"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                    class Uint16RngArray(Entity):
                                                                                        """
                                                                                        uint16 rng array
                                                                                        
                                                                                        .. attribute:: max
                                                                                        
                                                                                        	Upper limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        .. attribute:: min
                                                                                        
                                                                                        	Lower limit of the range
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..65535
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                            self.yang_name = "uint16_rng_array"
                                                                                            self.yang_parent_name = "vlan-inr"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {}
                                                                                            self._child_list_classes = {}

                                                                                            self.max = YLeaf(YType.uint16, "max")

                                                                                            self.min = YLeaf(YType.uint16, "min")
                                                                                            self._segment_path = lambda: "uint16_rng_array"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                            class PmapVarList(Entity):
                                                """
                                                pmap var list
                                                
                                                .. attribute:: offset
                                                
                                                	offset
                                                	**type**\:  list of int
                                                
                                                	**range:** 0..255
                                                
                                                .. attribute:: pmap_var_list_arr
                                                
                                                	pmap var list arr
                                                	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, self).__init__()

                                                    self.yang_name = "pmap-var-list"
                                                    self.yang_parent_name = "policy-map-bg"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {}
                                                    self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                    self.offset = YLeafList(YType.uint8, "offset")

                                                    self.pmap_var_list_arr = YList(self)
                                                    self._segment_path = lambda: "pmap-var-list"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                                class PmapVarListArr(Entity):
                                                    """
                                                    pmap var list arr
                                                    
                                                    .. attribute:: id
                                                    
                                                    	id
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: name
                                                    
                                                    	name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..32
                                                    
                                                    .. attribute:: val
                                                    
                                                    	val
                                                    	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                        self.yang_name = "pmap-var-list-arr"
                                                        self.yang_parent_name = "pmap-var-list"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {"val" : ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                        self._child_list_classes = {}

                                                        self.id = YLeaf(YType.uint32, "id")

                                                        self.name = YLeaf(YType.str, "name")

                                                        self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                        self.val.parent = self
                                                        self._children_name_map["val"] = "val"
                                                        self._children_yang_names.add("val")
                                                        self._segment_path = lambda: "pmap-var-list-arr"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                    class Val(Entity):
                                                        """
                                                        val
                                                        
                                                        .. attribute:: class_name
                                                        
                                                        	class name
                                                        	**type**\:  str
                                                        
                                                        	**length:** 0..65
                                                        
                                                        .. attribute:: dscp_val
                                                        
                                                        	dscp val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: param_uint32_val
                                                        
                                                        	param uint32 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: prec_val
                                                        
                                                        	prec val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        .. attribute:: type
                                                        
                                                        	type
                                                        	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                        
                                                        .. attribute:: uint16_val
                                                        
                                                        	uint16 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: uint32_val
                                                        
                                                        	uint32 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: uint8_val
                                                        
                                                        	uint8 val
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                            self.yang_name = "val"
                                                            self.yang_parent_name = "pmap-var-list-arr"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {}
                                                            self._child_list_classes = {}

                                                            self.class_name = YLeaf(YType.str, "class-name")

                                                            self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                            self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                            self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                            self.type = YLeaf(YType.enumeration, "type")

                                                            self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                            self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                            self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                            self._segment_path = lambda: "val"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.ClassSeqNums.ClassSeqNum.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                                class Definition(Entity):
                                    """
                                    Transient Policy\-map type name
                                    
                                    .. attribute:: policy_map_bg
                                    
                                    	policy map bg
                                    	**type**\: list of    :py:class:`PolicyMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg>`
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, self).__init__()

                                        self.yang_name = "definition"
                                        self.yang_parent_name = "transient-policy-map-name"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-bg" : ("policy_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg)}

                                        self.policy_map_bg = YList(self)
                                        self._segment_path = lambda: "definition"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition, [], name, value)


                                    class PolicyMapBg(Entity):
                                        """
                                        policy map bg
                                        
                                        .. attribute:: description
                                        
                                        	description
                                        	**type**\:  str
                                        
                                        .. attribute:: event_infop
                                        
                                        	event infop
                                        	**type**\:   :py:class:`EventInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop>`
                                        
                                        .. attribute:: name
                                        
                                        	name
                                        	**type**\:  str
                                        
                                        	**length:** 0..65
                                        
                                        .. attribute:: pmap_var_list
                                        
                                        	pmap var list
                                        	**type**\:   :py:class:`PmapVarList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList>`
                                        
                                        .. attribute:: type
                                        
                                        	type
                                        	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, self).__init__()

                                            self.yang_name = "policy-map-bg"
                                            self.yang_parent_name = "definition"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {"event-infop" : ("event_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop), "pmap-var-list" : ("pmap_var_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList)}
                                            self._child_list_classes = {}

                                            self.description = YLeaf(YType.str, "description")

                                            self.name = YLeaf(YType.str, "name")

                                            self.type = YLeaf(YType.enumeration, "type")

                                            self.event_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop()
                                            self.event_infop.parent = self
                                            self._children_name_map["event_infop"] = "event-infop"
                                            self._children_yang_names.add("event-infop")

                                            self.pmap_var_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList()
                                            self.pmap_var_list.parent = self
                                            self._children_name_map["pmap_var_list"] = "pmap-var-list"
                                            self._children_yang_names.add("pmap-var-list")
                                            self._segment_path = lambda: "policy-map-bg"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg, ['description', 'name', 'type'], name, value)


                                        class EventInfop(Entity):
                                            """
                                            event infop
                                            
                                            .. attribute:: policy_event_info_bg
                                            
                                            	policy event info bg
                                            	**type**\: list of    :py:class:`PolicyEventInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, self).__init__()

                                                self.yang_name = "event-infop"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"policy-event-info-bg" : ("policy_event_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg)}

                                                self.policy_event_info_bg = YList(self)
                                                self._segment_path = lambda: "event-infop"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop, [], name, value)


                                            class PolicyEventInfoBg(Entity):
                                                """
                                                policy event info bg
                                                
                                                .. attribute:: avl_tree
                                                
                                                	avl tree
                                                	**type**\:  int
                                                
                                                	**range:** 0..18446744073709551615
                                                
                                                .. attribute:: class_infop
                                                
                                                	class infop
                                                	**type**\:   :py:class:`ClassInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop>`
                                                
                                                .. attribute:: cond_eval
                                                
                                                	cond eval
                                                	**type**\:   :py:class:`PeventCondEvalEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventCondEvalEn>`
                                                
                                                .. attribute:: event_type
                                                
                                                	event type
                                                	**type**\:   :py:class:`PeventTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PeventTypeEn>`
                                                
                                                .. attribute:: flags
                                                
                                                	flags
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, self).__init__()

                                                    self.yang_name = "policy-event-info-bg"
                                                    self.yang_parent_name = "event-infop"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"class-infop" : ("class_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop)}
                                                    self._child_list_classes = {}

                                                    self.avl_tree = YLeaf(YType.uint64, "avl-tree")

                                                    self.cond_eval = YLeaf(YType.enumeration, "cond-eval")

                                                    self.event_type = YLeaf(YType.enumeration, "event-type")

                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                    self.class_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop()
                                                    self.class_infop.parent = self
                                                    self._children_name_map["class_infop"] = "class-infop"
                                                    self._children_yang_names.add("class-infop")
                                                    self._segment_path = lambda: "policy-event-info-bg"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg, ['avl_tree', 'cond_eval', 'event_type', 'flags'], name, value)


                                                class ClassInfop(Entity):
                                                    """
                                                    class infop
                                                    
                                                    .. attribute:: policy_class_info_bg
                                                    
                                                    	policy class info bg
                                                    	**type**\: list of    :py:class:`PolicyClassInfoBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg>`
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, self).__init__()

                                                        self.yang_name = "class-infop"
                                                        self.yang_parent_name = "policy-event-info-bg"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {"policy-class-info-bg" : ("policy_class_info_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg)}

                                                        self.policy_class_info_bg = YList(self)
                                                        self._segment_path = lambda: "class-infop"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop, [], name, value)


                                                    class PolicyClassInfoBg(Entity):
                                                        """
                                                        policy class info bg
                                                        
                                                        .. attribute:: act_infop
                                                        
                                                        	act infop
                                                        	**type**\:   :py:class:`ActInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop>`
                                                        
                                                        .. attribute:: cl_encode
                                                        
                                                        	cl encode
                                                        	**type**\:   :py:class:`ClEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode>`
                                                        
                                                        .. attribute:: clmp_p
                                                        
                                                        	clmp p
                                                        	**type**\:   :py:class:`ClmpP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP>`
                                                        
                                                        .. attribute:: ctype
                                                        
                                                        	ctype
                                                        	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                        
                                                        .. attribute:: exe_strat
                                                        
                                                        	exe strat
                                                        	**type**\:   :py:class:`PclassExecStratEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PclassExecStratEn>`
                                                        
                                                        .. attribute:: flags
                                                        
                                                        	flags
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: num_actions
                                                        
                                                        	num actions
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..65535
                                                        
                                                        .. attribute:: policy_class_hd
                                                        
                                                        	policy class hd
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: seq
                                                        
                                                        	seq
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..4294967295
                                                        
                                                        .. attribute:: version
                                                        
                                                        	version
                                                        	**type**\:  int
                                                        
                                                        	**range:** 0..255
                                                        
                                                        

                                                        """

                                                        _prefix = 'infra-policymgr-oper'
                                                        _revision = '2017-05-27'

                                                        def __init__(self):
                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, self).__init__()

                                                            self.yang_name = "policy-class-info-bg"
                                                            self.yang_parent_name = "class-infop"
                                                            self.is_top_level_class = False
                                                            self.has_list_ancestor = True
                                                            self._child_container_classes = {"act-infop" : ("act_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop), "cl-encode" : ("cl_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode), "clmp-p" : ("clmp_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP)}
                                                            self._child_list_classes = {}

                                                            self.ctype = YLeaf(YType.enumeration, "ctype")

                                                            self.exe_strat = YLeaf(YType.enumeration, "exe-strat")

                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                            self.num_actions = YLeaf(YType.uint16, "num-actions")

                                                            self.policy_class_hd = YLeaf(YType.uint32, "policy-class-hd")

                                                            self.seq = YLeaf(YType.uint32, "seq")

                                                            self.version = YLeaf(YType.uint8, "version")

                                                            self.act_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop()
                                                            self.act_infop.parent = self
                                                            self._children_name_map["act_infop"] = "act-infop"
                                                            self._children_yang_names.add("act-infop")

                                                            self.cl_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode()
                                                            self.cl_encode.parent = self
                                                            self._children_name_map["cl_encode"] = "cl-encode"
                                                            self._children_yang_names.add("cl-encode")

                                                            self.clmp_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP()
                                                            self.clmp_p.parent = self
                                                            self._children_name_map["clmp_p"] = "clmp-p"
                                                            self._children_yang_names.add("clmp-p")
                                                            self._segment_path = lambda: "policy-class-info-bg"

                                                        def __setattr__(self, name, value):
                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg, ['ctype', 'exe_strat', 'flags', 'num_actions', 'policy_class_hd', 'seq', 'version'], name, value)


                                                        class ActInfop(Entity):
                                                            """
                                                            act infop
                                                            
                                                            .. attribute:: policy_action_info_st
                                                            
                                                            	policy action info st
                                                            	**type**\: list of    :py:class:`PolicyActionInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, self).__init__()

                                                                self.yang_name = "act-infop"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"policy-action-info-st" : ("policy_action_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt)}

                                                                self.policy_action_info_st = YList(self)
                                                                self._segment_path = lambda: "act-infop"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop, [], name, value)


                                                            class PolicyActionInfoSt(Entity):
                                                                """
                                                                policy action info st
                                                                
                                                                .. attribute:: actp
                                                                
                                                                	actp
                                                                	**type**\:   :py:class:`Actp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp>`
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                .. attribute:: seq
                                                                
                                                                	seq
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..65535
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, self).__init__()

                                                                    self.yang_name = "policy-action-info-st"
                                                                    self.yang_parent_name = "act-infop"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"actp" : ("actp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint16, "flags")

                                                                    self.seq = YLeaf(YType.uint16, "seq")

                                                                    self.actp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp()
                                                                    self.actp.parent = self
                                                                    self._children_name_map["actp"] = "actp"
                                                                    self._children_yang_names.add("actp")
                                                                    self._segment_path = lambda: "policy-action-info-st"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt, ['flags', 'seq'], name, value)


                                                                class Actp(Entity):
                                                                    """
                                                                    actp
                                                                    
                                                                    .. attribute:: accounting_event_aaa
                                                                    
                                                                    	accounting event aaa
                                                                    	**type**\:   :py:class:`AccountingEventAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa>`
                                                                    
                                                                    .. attribute:: acct_aaa_list
                                                                    
                                                                    	acct aaa list
                                                                    	**type**\:   :py:class:`AcctAaaList <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList>`
                                                                    
                                                                    .. attribute:: act_template
                                                                    
                                                                    	act template
                                                                    	**type**\:   :py:class:`ActTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate>`
                                                                    
                                                                    .. attribute:: afm_react
                                                                    
                                                                    	afm react
                                                                    	**type**\:   :py:class:`AfmReact <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact>`
                                                                    
                                                                    .. attribute:: authen_aaa
                                                                    
                                                                    	authen aaa
                                                                    	**type**\:   :py:class:`AuthenAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa>`
                                                                    
                                                                    .. attribute:: authorize_id
                                                                    
                                                                    	authorize id
                                                                    	**type**\:   :py:class:`AuthorizeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId>`
                                                                    
                                                                    .. attribute:: bwrem
                                                                    
                                                                    	bwrem
                                                                    	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem>`
                                                                    
                                                                    .. attribute:: cac
                                                                    
                                                                    	cac
                                                                    	**type**\:   :py:class:`Cac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac>`
                                                                    
                                                                    .. attribute:: child_policy
                                                                    
                                                                    	child policy
                                                                    	**type**\:   :py:class:`ChildPolicy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy>`
                                                                    
                                                                    .. attribute:: collect_id
                                                                    
                                                                    	collect id
                                                                    	**type**\:   :py:class:`CollectId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId>`
                                                                    
                                                                    .. attribute:: copy
                                                                    
                                                                    	copy
                                                                    	**type**\:   :py:class:`Copy <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy>`
                                                                    
                                                                    .. attribute:: data_p
                                                                    
                                                                    	data p
                                                                    	**type**\:  int
                                                                    
                                                                    	**range:** 0..4294967295
                                                                    
                                                                    .. attribute:: deact_template
                                                                    
                                                                    	deact template
                                                                    	**type**\:   :py:class:`DeactTemplate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate>`
                                                                    
                                                                    .. attribute:: decode_id
                                                                    
                                                                    	decode id
                                                                    	**type**\:   :py:class:`DecodeId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId>`
                                                                    
                                                                    .. attribute:: encap
                                                                    
                                                                    	encap
                                                                    	**type**\:   :py:class:`Encap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap>`
                                                                    
                                                                    .. attribute:: flow_parm
                                                                    
                                                                    	flow parm
                                                                    	**type**\:   :py:class:`FlowParm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm>`
                                                                    
                                                                    .. attribute:: fmm
                                                                    
                                                                    	fmm
                                                                    	**type**\:   :py:class:`Fmm <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm>`
                                                                    
                                                                    .. attribute:: httpr
                                                                    
                                                                    	httpr
                                                                    	**type**\:   :py:class:`Httpr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr>`
                                                                    
                                                                    .. attribute:: ipcbr
                                                                    
                                                                    	ipcbr
                                                                    	**type**\:   :py:class:`Ipcbr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr>`
                                                                    
                                                                    .. attribute:: ipv4_nh
                                                                    
                                                                    	ipv4 nh
                                                                    	**type**\:   :py:class:`Ipv4Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh>`
                                                                    
                                                                    .. attribute:: ipv6_nh
                                                                    
                                                                    	ipv6 nh
                                                                    	**type**\:   :py:class:`Ipv6Nh <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh>`
                                                                    
                                                                    .. attribute:: mark
                                                                    
                                                                    	mark
                                                                    	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark>`
                                                                    
                                                                    .. attribute:: mark2
                                                                    
                                                                    	mark2
                                                                    	**type**\:   :py:class:`Mark2 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2>`
                                                                    
                                                                    .. attribute:: mdi
                                                                    
                                                                    	mdi
                                                                    	**type**\:   :py:class:`Mdi <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi>`
                                                                    
                                                                    .. attribute:: mdi_rtp
                                                                    
                                                                    	mdi rtp
                                                                    	**type**\:   :py:class:`MdiRtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp>`
                                                                    
                                                                    .. attribute:: min_bw
                                                                    
                                                                    	min bw
                                                                    	**type**\:   :py:class:`MinBw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw>`
                                                                    
                                                                    .. attribute:: out_intf
                                                                    
                                                                    	out intf
                                                                    	**type**\:   :py:class:`OutIntf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf>`
                                                                    
                                                                    .. attribute:: pbf
                                                                    
                                                                    	pbf
                                                                    	**type**\:   :py:class:`Pbf <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf>`
                                                                    
                                                                    .. attribute:: pfc
                                                                    
                                                                    	pfc
                                                                    	**type**\:   :py:class:`Pfc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc>`
                                                                    
                                                                    .. attribute:: police
                                                                    
                                                                    	police
                                                                    	**type**\:   :py:class:`Police <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police>`
                                                                    
                                                                    .. attribute:: prepaid_cfg
                                                                    
                                                                    	prepaid cfg
                                                                    	**type**\:   :py:class:`PrepaidCfg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg>`
                                                                    
                                                                    .. attribute:: prio
                                                                    
                                                                    	prio
                                                                    	**type**\:   :py:class:`Prio <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio>`
                                                                    
                                                                    .. attribute:: proxy_aaa
                                                                    
                                                                    	proxy aaa
                                                                    	**type**\:   :py:class:`ProxyAaa <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa>`
                                                                    
                                                                    .. attribute:: punt
                                                                    
                                                                    	punt
                                                                    	**type**\:   :py:class:`Punt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt>`
                                                                    
                                                                    .. attribute:: qlimit
                                                                    
                                                                    	qlimit
                                                                    	**type**\:   :py:class:`Qlimit <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit>`
                                                                    
                                                                    .. attribute:: query_ancp
                                                                    
                                                                    	query ancp
                                                                    	**type**\:   :py:class:`QueryAncp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp>`
                                                                    
                                                                    .. attribute:: redirect
                                                                    
                                                                    	redirect
                                                                    	**type**\:   :py:class:`Redirect <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect>`
                                                                    
                                                                    .. attribute:: rtp
                                                                    
                                                                    	rtp
                                                                    	**type**\:   :py:class:`Rtp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp>`
                                                                    
                                                                    .. attribute:: rtp_j2k
                                                                    
                                                                    	rtp j2k
                                                                    	**type**\:   :py:class:`RtpJ2K <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K>`
                                                                    
                                                                    .. attribute:: rtp_mmr
                                                                    
                                                                    	rtp mmr
                                                                    	**type**\:   :py:class:`RtpMmr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr>`
                                                                    
                                                                    .. attribute:: rtp_voice
                                                                    
                                                                    	rtp voice
                                                                    	**type**\:   :py:class:`RtpVoice <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice>`
                                                                    
                                                                    .. attribute:: serv_func
                                                                    
                                                                    	serv func
                                                                    	**type**\:   :py:class:`ServFunc <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc>`
                                                                    
                                                                    .. attribute:: set_timer
                                                                    
                                                                    	set timer
                                                                    	**type**\:   :py:class:`SetTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer>`
                                                                    
                                                                    .. attribute:: sfrag
                                                                    
                                                                    	sfrag
                                                                    	**type**\:   :py:class:`Sfrag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag>`
                                                                    
                                                                    .. attribute:: shape
                                                                    
                                                                    	shape
                                                                    	**type**\:   :py:class:`Shape <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape>`
                                                                    
                                                                    .. attribute:: stop_timer
                                                                    
                                                                    	stop timer
                                                                    	**type**\:   :py:class:`StopTimer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer>`
                                                                    
                                                                    .. attribute:: timeout_idle
                                                                    
                                                                    	timeout idle
                                                                    	**type**\:   :py:class:`TimeoutIdle <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle>`
                                                                    
                                                                    .. attribute:: type
                                                                    
                                                                    	type
                                                                    	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                    
                                                                    .. attribute:: wred
                                                                    
                                                                    	wred
                                                                    	**type**\:   :py:class:`Wred <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, self).__init__()

                                                                        self.yang_name = "actp"
                                                                        self.yang_parent_name = "policy-action-info-st"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {"accounting-event-aaa" : ("accounting_event_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa), "acct-aaa-list" : ("acct_aaa_list", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList), "act-template" : ("act_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate), "afm-react" : ("afm_react", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact), "authen-aaa" : ("authen_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa), "authorize-id" : ("authorize_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId), "bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem), "cac" : ("cac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac), "child-policy" : ("child_policy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy), "collect-id" : ("collect_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId), "copy" : ("copy", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy), "deact-template" : ("deact_template", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate), "decode-id" : ("decode_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId), "encap" : ("encap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap), "flow-parm" : ("flow_parm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm), "fmm" : ("fmm", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm), "httpr" : ("httpr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr), "ipcbr" : ("ipcbr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr), "ipv4-nh" : ("ipv4_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh), "ipv6-nh" : ("ipv6_nh", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh), "mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark), "mark2" : ("mark2", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2), "mdi" : ("mdi", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi), "mdi-rtp" : ("mdi_rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp), "min-bw" : ("min_bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw), "out-intf" : ("out_intf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf), "pbf" : ("pbf", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf), "pfc" : ("pfc", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc), "police" : ("police", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police), "prepaid-cfg" : ("prepaid_cfg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg), "prio" : ("prio", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio), "proxy-aaa" : ("proxy_aaa", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa), "punt" : ("punt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt), "qlimit" : ("qlimit", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit), "query-ancp" : ("query_ancp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp), "redirect" : ("redirect", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect), "rtp" : ("rtp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp), "rtp-j2k" : ("rtp_j2k", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K), "rtp-mmr" : ("rtp_mmr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr), "rtp-voice" : ("rtp_voice", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice), "serv-func" : ("serv_func", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc), "set-timer" : ("set_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer), "sfrag" : ("sfrag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag), "shape" : ("shape", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape), "stop-timer" : ("stop_timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer), "timeout-idle" : ("timeout_idle", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle), "wred" : ("wred", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred)}
                                                                        self._child_list_classes = {}

                                                                        self.data_p = YLeaf(YType.uint32, "data-p")

                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                        self.accounting_event_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa()
                                                                        self.accounting_event_aaa.parent = self
                                                                        self._children_name_map["accounting_event_aaa"] = "accounting-event-aaa"
                                                                        self._children_yang_names.add("accounting-event-aaa")

                                                                        self.acct_aaa_list = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList()
                                                                        self.acct_aaa_list.parent = self
                                                                        self._children_name_map["acct_aaa_list"] = "acct-aaa-list"
                                                                        self._children_yang_names.add("acct-aaa-list")

                                                                        self.act_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate()
                                                                        self.act_template.parent = self
                                                                        self._children_name_map["act_template"] = "act-template"
                                                                        self._children_yang_names.add("act-template")

                                                                        self.afm_react = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact()
                                                                        self.afm_react.parent = self
                                                                        self._children_name_map["afm_react"] = "afm-react"
                                                                        self._children_yang_names.add("afm-react")

                                                                        self.authen_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa()
                                                                        self.authen_aaa.parent = self
                                                                        self._children_name_map["authen_aaa"] = "authen-aaa"
                                                                        self._children_yang_names.add("authen-aaa")

                                                                        self.authorize_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId()
                                                                        self.authorize_id.parent = self
                                                                        self._children_name_map["authorize_id"] = "authorize-id"
                                                                        self._children_yang_names.add("authorize-id")

                                                                        self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem()
                                                                        self.bwrem.parent = self
                                                                        self._children_name_map["bwrem"] = "bwrem"
                                                                        self._children_yang_names.add("bwrem")

                                                                        self.cac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac()
                                                                        self.cac.parent = self
                                                                        self._children_name_map["cac"] = "cac"
                                                                        self._children_yang_names.add("cac")

                                                                        self.child_policy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy()
                                                                        self.child_policy.parent = self
                                                                        self._children_name_map["child_policy"] = "child-policy"
                                                                        self._children_yang_names.add("child-policy")

                                                                        self.collect_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId()
                                                                        self.collect_id.parent = self
                                                                        self._children_name_map["collect_id"] = "collect-id"
                                                                        self._children_yang_names.add("collect-id")

                                                                        self.copy = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy()
                                                                        self.copy.parent = self
                                                                        self._children_name_map["copy"] = "copy"
                                                                        self._children_yang_names.add("copy")

                                                                        self.deact_template = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate()
                                                                        self.deact_template.parent = self
                                                                        self._children_name_map["deact_template"] = "deact-template"
                                                                        self._children_yang_names.add("deact-template")

                                                                        self.decode_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId()
                                                                        self.decode_id.parent = self
                                                                        self._children_name_map["decode_id"] = "decode-id"
                                                                        self._children_yang_names.add("decode-id")

                                                                        self.encap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap()
                                                                        self.encap.parent = self
                                                                        self._children_name_map["encap"] = "encap"
                                                                        self._children_yang_names.add("encap")

                                                                        self.flow_parm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm()
                                                                        self.flow_parm.parent = self
                                                                        self._children_name_map["flow_parm"] = "flow-parm"
                                                                        self._children_yang_names.add("flow-parm")

                                                                        self.fmm = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm()
                                                                        self.fmm.parent = self
                                                                        self._children_name_map["fmm"] = "fmm"
                                                                        self._children_yang_names.add("fmm")

                                                                        self.httpr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr()
                                                                        self.httpr.parent = self
                                                                        self._children_name_map["httpr"] = "httpr"
                                                                        self._children_yang_names.add("httpr")

                                                                        self.ipcbr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr()
                                                                        self.ipcbr.parent = self
                                                                        self._children_name_map["ipcbr"] = "ipcbr"
                                                                        self._children_yang_names.add("ipcbr")

                                                                        self.ipv4_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh()
                                                                        self.ipv4_nh.parent = self
                                                                        self._children_name_map["ipv4_nh"] = "ipv4-nh"
                                                                        self._children_yang_names.add("ipv4-nh")

                                                                        self.ipv6_nh = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh()
                                                                        self.ipv6_nh.parent = self
                                                                        self._children_name_map["ipv6_nh"] = "ipv6-nh"
                                                                        self._children_yang_names.add("ipv6-nh")

                                                                        self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark()
                                                                        self.mark.parent = self
                                                                        self._children_name_map["mark"] = "mark"
                                                                        self._children_yang_names.add("mark")

                                                                        self.mark2 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2()
                                                                        self.mark2.parent = self
                                                                        self._children_name_map["mark2"] = "mark2"
                                                                        self._children_yang_names.add("mark2")

                                                                        self.mdi = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi()
                                                                        self.mdi.parent = self
                                                                        self._children_name_map["mdi"] = "mdi"
                                                                        self._children_yang_names.add("mdi")

                                                                        self.mdi_rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp()
                                                                        self.mdi_rtp.parent = self
                                                                        self._children_name_map["mdi_rtp"] = "mdi-rtp"
                                                                        self._children_yang_names.add("mdi-rtp")

                                                                        self.min_bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw()
                                                                        self.min_bw.parent = self
                                                                        self._children_name_map["min_bw"] = "min-bw"
                                                                        self._children_yang_names.add("min-bw")

                                                                        self.out_intf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf()
                                                                        self.out_intf.parent = self
                                                                        self._children_name_map["out_intf"] = "out-intf"
                                                                        self._children_yang_names.add("out-intf")

                                                                        self.pbf = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf()
                                                                        self.pbf.parent = self
                                                                        self._children_name_map["pbf"] = "pbf"
                                                                        self._children_yang_names.add("pbf")

                                                                        self.pfc = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc()
                                                                        self.pfc.parent = self
                                                                        self._children_name_map["pfc"] = "pfc"
                                                                        self._children_yang_names.add("pfc")

                                                                        self.police = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police()
                                                                        self.police.parent = self
                                                                        self._children_name_map["police"] = "police"
                                                                        self._children_yang_names.add("police")

                                                                        self.prepaid_cfg = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg()
                                                                        self.prepaid_cfg.parent = self
                                                                        self._children_name_map["prepaid_cfg"] = "prepaid-cfg"
                                                                        self._children_yang_names.add("prepaid-cfg")

                                                                        self.prio = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio()
                                                                        self.prio.parent = self
                                                                        self._children_name_map["prio"] = "prio"
                                                                        self._children_yang_names.add("prio")

                                                                        self.proxy_aaa = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa()
                                                                        self.proxy_aaa.parent = self
                                                                        self._children_name_map["proxy_aaa"] = "proxy-aaa"
                                                                        self._children_yang_names.add("proxy-aaa")

                                                                        self.punt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt()
                                                                        self.punt.parent = self
                                                                        self._children_name_map["punt"] = "punt"
                                                                        self._children_yang_names.add("punt")

                                                                        self.qlimit = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit()
                                                                        self.qlimit.parent = self
                                                                        self._children_name_map["qlimit"] = "qlimit"
                                                                        self._children_yang_names.add("qlimit")

                                                                        self.query_ancp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp()
                                                                        self.query_ancp.parent = self
                                                                        self._children_name_map["query_ancp"] = "query-ancp"
                                                                        self._children_yang_names.add("query-ancp")

                                                                        self.redirect = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect()
                                                                        self.redirect.parent = self
                                                                        self._children_name_map["redirect"] = "redirect"
                                                                        self._children_yang_names.add("redirect")

                                                                        self.rtp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp()
                                                                        self.rtp.parent = self
                                                                        self._children_name_map["rtp"] = "rtp"
                                                                        self._children_yang_names.add("rtp")

                                                                        self.rtp_j2k = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K()
                                                                        self.rtp_j2k.parent = self
                                                                        self._children_name_map["rtp_j2k"] = "rtp-j2k"
                                                                        self._children_yang_names.add("rtp-j2k")

                                                                        self.rtp_mmr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr()
                                                                        self.rtp_mmr.parent = self
                                                                        self._children_name_map["rtp_mmr"] = "rtp-mmr"
                                                                        self._children_yang_names.add("rtp-mmr")

                                                                        self.rtp_voice = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice()
                                                                        self.rtp_voice.parent = self
                                                                        self._children_name_map["rtp_voice"] = "rtp-voice"
                                                                        self._children_yang_names.add("rtp-voice")

                                                                        self.serv_func = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc()
                                                                        self.serv_func.parent = self
                                                                        self._children_name_map["serv_func"] = "serv-func"
                                                                        self._children_yang_names.add("serv-func")

                                                                        self.set_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer()
                                                                        self.set_timer.parent = self
                                                                        self._children_name_map["set_timer"] = "set-timer"
                                                                        self._children_yang_names.add("set-timer")

                                                                        self.sfrag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag()
                                                                        self.sfrag.parent = self
                                                                        self._children_name_map["sfrag"] = "sfrag"
                                                                        self._children_yang_names.add("sfrag")

                                                                        self.shape = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape()
                                                                        self.shape.parent = self
                                                                        self._children_name_map["shape"] = "shape"
                                                                        self._children_yang_names.add("shape")

                                                                        self.stop_timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer()
                                                                        self.stop_timer.parent = self
                                                                        self._children_name_map["stop_timer"] = "stop-timer"
                                                                        self._children_yang_names.add("stop-timer")

                                                                        self.timeout_idle = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle()
                                                                        self.timeout_idle.parent = self
                                                                        self._children_name_map["timeout_idle"] = "timeout-idle"
                                                                        self._children_yang_names.add("timeout-idle")

                                                                        self.wred = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred()
                                                                        self.wred.parent = self
                                                                        self._children_name_map["wred"] = "wred"
                                                                        self._children_yang_names.add("wred")
                                                                        self._segment_path = lambda: "actp"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp, ['data_p', 'type'], name, value)


                                                                    class AccountingEventAaa(Entity):
                                                                        """
                                                                        accounting event aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: action
                                                                        
                                                                        	action
                                                                        	**type**\:   :py:class:`AcctEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.AcctEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, self).__init__()

                                                                            self.yang_name = "accounting-event-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.action = YLeaf(YType.enumeration, "action")
                                                                            self._segment_path = lambda: "accounting-event-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AccountingEventAaa, ['aaa_list_name', 'action'], name, value)


                                                                    class AcctAaaList(Entity):
                                                                        """
                                                                        acct aaa list
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, self).__init__()

                                                                            self.yang_name = "acct-aaa-list"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "acct-aaa-list"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AcctAaaList, ['aaa_list_name', 'secs'], name, value)


                                                                    class ActTemplate(Entity):
                                                                        """
                                                                        act template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, self).__init__()

                                                                            self.yang_name = "act-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "act-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ActTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class AfmReact(Entity):
                                                                        """
                                                                        afm react
                                                                        
                                                                        .. attribute:: action_afmon_react_info
                                                                        
                                                                        	action afmon react info
                                                                        	**type**\: list of    :py:class:`ActionAfmonReactInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, self).__init__()

                                                                            self.yang_name = "afm-react"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-afmon-react-info" : ("action_afmon_react_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo)}

                                                                            self.action_afmon_react_info = YList(self)
                                                                            self._segment_path = lambda: "afm-react"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact, [], name, value)


                                                                        class ActionAfmonReactInfo(Entity):
                                                                            """
                                                                            action afmon react info
                                                                            
                                                                            .. attribute:: alm_grp_thresh
                                                                            
                                                                            	Num/percent in grp
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            	**units**\: percentage
                                                                            
                                                                            .. attribute:: alm_severity
                                                                            
                                                                            	Major\|Minor\|... alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: alm_type
                                                                            
                                                                            	Discrete \| grouped alarm
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: clone_ifh
                                                                            
                                                                            	Clone interface handle
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: criterion
                                                                            
                                                                            	React Criterion
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: description
                                                                            
                                                                            	Describing the oper
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: notif_actns
                                                                            
                                                                            	Bitmap of actions on alert
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: oper_id
                                                                            
                                                                            	React Operation ID
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_level_1
                                                                            
                                                                            	Trigger threshold 1/lower
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_level_2
                                                                            
                                                                            	Trigger upper threshold for range
                                                                            	**type**\:  str
                                                                            
                                                                            .. attribute:: trig_num_intvls
                                                                            
                                                                            	Averaged over N intvls
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: trig_relop
                                                                            
                                                                            	Trigger LT\|LE\|GT\|GE\|Range
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: trig_type
                                                                            
                                                                            	Immediate or averaged thresh trigger
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, self).__init__()

                                                                                self.yang_name = "action-afmon-react-info"
                                                                                self.yang_parent_name = "afm-react"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.alm_grp_thresh = YLeaf(YType.uint16, "alm-grp-thresh")

                                                                                self.alm_severity = YLeaf(YType.uint8, "alm-severity")

                                                                                self.alm_type = YLeaf(YType.uint8, "alm-type")

                                                                                self.clone_ifh = YLeaf(YType.uint32, "clone-ifh")

                                                                                self.criterion = YLeaf(YType.uint8, "criterion")

                                                                                self.description = YLeaf(YType.str, "description")

                                                                                self.notif_actns = YLeaf(YType.uint8, "notif-actns")

                                                                                self.oper_id = YLeaf(YType.uint32, "oper-id")

                                                                                self.trig_level_1 = YLeaf(YType.str, "trig-level-1")

                                                                                self.trig_level_2 = YLeaf(YType.str, "trig-level-2")

                                                                                self.trig_num_intvls = YLeaf(YType.uint32, "trig-num-intvls")

                                                                                self.trig_relop = YLeaf(YType.uint8, "trig-relop")

                                                                                self.trig_type = YLeaf(YType.uint8, "trig-type")
                                                                                self._segment_path = lambda: "action-afmon-react-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AfmReact.ActionAfmonReactInfo, ['alm_grp_thresh', 'alm_severity', 'alm_type', 'clone_ifh', 'criterion', 'description', 'notif_actns', 'oper_id', 'trig_level_1', 'trig_level_2', 'trig_num_intvls', 'trig_relop', 'trig_type'], name, value)


                                                                    class AuthenAaa(Entity):
                                                                        """
                                                                        authen aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: authen_password
                                                                        
                                                                        	authen password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, self).__init__()

                                                                            self.yang_name = "authen-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.authen_password = YLeaf(YType.str, "authen-password")
                                                                            self._segment_path = lambda: "authen-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthenAaa, ['aaa_list_name', 'authen_password'], name, value)


                                                                    class AuthorizeId(Entity):
                                                                        """
                                                                        authorize id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: password
                                                                        
                                                                        	password
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, self).__init__()

                                                                            self.yang_name = "authorize-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.uint8, "id")

                                                                            self.password = YLeaf(YType.str, "password")
                                                                            self._segment_path = lambda: "authorize-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.AuthorizeId, ['aaa_list_name', 'format_name', 'id', 'password'], name, value)


                                                                    class Bwrem(Entity):
                                                                        """
                                                                        bwrem
                                                                        
                                                                        .. attribute:: bwrem
                                                                        
                                                                        	bwrem
                                                                        	**type**\:   :py:class:`Bwrem <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem, self).__init__()

                                                                            self.yang_name = "bwrem"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bwrem" : ("bwrem", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem)}
                                                                            self._child_list_classes = {}

                                                                            self.bwrem = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem()
                                                                            self.bwrem.parent = self
                                                                            self._children_name_map["bwrem"] = "bwrem"
                                                                            self._children_yang_names.add("bwrem")
                                                                            self._segment_path = lambda: "bwrem"


                                                                        class Bwrem(Entity):
                                                                            """
                                                                            bwrem
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, self).__init__()

                                                                                self.yang_name = "bwrem"
                                                                                self.yang_parent_name = "bwrem"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bwrem"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Bwrem.Bwrem, ['unit', 'value'], name, value)


                                                                    class Cac(Entity):
                                                                        """
                                                                        cac
                                                                        
                                                                        .. attribute:: cac_type
                                                                        
                                                                        	cac type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: flow_rate
                                                                        
                                                                        	flow rate
                                                                        	**type**\:   :py:class:`FlowRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate>`
                                                                        
                                                                        .. attribute:: idle_timeout
                                                                        
                                                                        	idle timeout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..65535
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, self).__init__()

                                                                            self.yang_name = "cac"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"flow-rate" : ("flow_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate)}
                                                                            self._child_list_classes = {}

                                                                            self.cac_type = YLeaf(YType.uint8, "cac-type")

                                                                            self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                            self.flow_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate()
                                                                            self.flow_rate.parent = self
                                                                            self._children_name_map["flow_rate"] = "flow-rate"
                                                                            self._children_yang_names.add("flow-rate")

                                                                            self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")
                                                                            self._segment_path = lambda: "cac"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac, ['cac_type', 'idle_timeout'], name, value)


                                                                        class FlowRate(Entity):
                                                                            """
                                                                            flow rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, self).__init__()

                                                                                self.yang_name = "flow-rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "flow-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.FlowRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "cac"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Cac.Rate, ['unit', 'value'], name, value)


                                                                    class ChildPolicy(Entity):
                                                                        """
                                                                        child policy
                                                                        
                                                                        .. attribute:: enc
                                                                        
                                                                        	enc
                                                                        	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                        
                                                                        .. attribute:: hd_info
                                                                        
                                                                        	hd info
                                                                        	**type**\:   :py:class:`HdInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo>`
                                                                        
                                                                        .. attribute:: info
                                                                        
                                                                        	info
                                                                        	**type**\:   :py:class:`Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, self).__init__()

                                                                            self.yang_name = "child-policy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"hd-info" : ("hd_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo), "info" : ("info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info)}
                                                                            self._child_list_classes = {}

                                                                            self.enc = YLeaf(YType.enumeration, "enc")

                                                                            self.hd_info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo()
                                                                            self.hd_info.parent = self
                                                                            self._children_name_map["hd_info"] = "hd-info"
                                                                            self._children_yang_names.add("hd-info")

                                                                            self.info = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info()
                                                                            self.info.parent = self
                                                                            self._children_name_map["info"] = "info"
                                                                            self._children_yang_names.add("info")
                                                                            self._segment_path = lambda: "child-policy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy, ['enc'], name, value)


                                                                        class HdInfo(Entity):
                                                                            """
                                                                            hd info
                                                                            
                                                                            .. attribute:: data_hd
                                                                            
                                                                            	data hd
                                                                            	**type**\:   :py:class:`DataHd <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, self).__init__()

                                                                                self.yang_name = "hd-info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"data-hd" : ("data_hd", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd)}
                                                                                self._child_list_classes = {}

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.data_hd = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd()
                                                                                self.data_hd.parent = self
                                                                                self._children_name_map["data_hd"] = "data-hd"
                                                                                self._children_yang_names.add("data-hd")
                                                                                self._segment_path = lambda: "hd-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo, ['hd'], name, value)


                                                                            class DataHd(Entity):
                                                                                """
                                                                                data hd
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.HdInfo.DataHd, self).__init__()

                                                                                    self.yang_name = "data-hd"
                                                                                    self.yang_parent_name = "hd-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}
                                                                                    self._segment_path = lambda: "data-hd"


                                                                        class Info(Entity):
                                                                            """
                                                                            info
                                                                            
                                                                            .. attribute:: name
                                                                            
                                                                            	name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`PolicyMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyMapTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, self).__init__()

                                                                                self.yang_name = "info"
                                                                                self.yang_parent_name = "child-policy"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.name = YLeaf(YType.str, "name")

                                                                                self.type = YLeaf(YType.enumeration, "type")
                                                                                self._segment_path = lambda: "info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ChildPolicy.Info, ['name', 'type'], name, value)


                                                                    class CollectId(Entity):
                                                                        """
                                                                        collect id
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`IdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.IdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, self).__init__()

                                                                            self.yang_name = "collect-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "collect-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.CollectId, ['aaa_list_name', 'id'], name, value)


                                                                    class Copy(Entity):
                                                                        """
                                                                        copy
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: num_byte
                                                                        
                                                                        	number of bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node url
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, self).__init__()

                                                                            self.yang_name = "copy"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.num_byte = YLeaf(YType.uint32, "num-byte")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "copy"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Copy, ['app_id', 'local_id', 'num_byte', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class DeactTemplate(Entity):
                                                                        """
                                                                        deact template
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: template_name
                                                                        
                                                                        	template name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, self).__init__()

                                                                            self.yang_name = "deact-template"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.template_name = YLeaf(YType.str, "template-name")
                                                                            self._segment_path = lambda: "deact-template"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DeactTemplate, ['aaa_list_name', 'flags', 'template_name'], name, value)


                                                                    class DecodeId(Entity):
                                                                        """
                                                                        decode id
                                                                        
                                                                        .. attribute:: format_name
                                                                        
                                                                        	format name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: id
                                                                        
                                                                        	id
                                                                        	**type**\:   :py:class:`DecodeIdentifierEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DecodeIdentifierEn>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, self).__init__()

                                                                            self.yang_name = "decode-id"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.format_name = YLeaf(YType.str, "format-name")

                                                                            self.id = YLeaf(YType.enumeration, "id")
                                                                            self._segment_path = lambda: "decode-id"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.DecodeId, ['format_name', 'id'], name, value)


                                                                    class Encap(Entity):
                                                                        """
                                                                        encap
                                                                        
                                                                        .. attribute:: seq
                                                                        
                                                                        	seq
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, self).__init__()

                                                                            self.yang_name = "encap"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.seq = YLeaf(YType.uint8, "seq")
                                                                            self._segment_path = lambda: "encap"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Encap, ['seq'], name, value)


                                                                    class FlowParm(Entity):
                                                                        """
                                                                        flow parm
                                                                        
                                                                        .. attribute:: flow_timeout
                                                                        
                                                                        	timeout in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        .. attribute:: intvl_hist
                                                                        
                                                                        	num intervals of data stored on rtr
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_mon_flows
                                                                        
                                                                        	max simult flows monitored per policy class
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: mon_interval
                                                                        
                                                                        	monitored interval duration in secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: second
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, self).__init__()

                                                                            self.yang_name = "flow-parm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.flow_timeout = YLeaf(YType.uint32, "flow-timeout")

                                                                            self.intvl_hist = YLeaf(YType.uint32, "intvl-hist")

                                                                            self.max_mon_flows = YLeaf(YType.uint32, "max-mon-flows")

                                                                            self.mon_interval = YLeaf(YType.uint32, "mon-interval")
                                                                            self._segment_path = lambda: "flow-parm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.FlowParm, ['flow_timeout', 'intvl_hist', 'max_mon_flows', 'mon_interval'], name, value)


                                                                    class Fmm(Entity):
                                                                        """
                                                                        fmm
                                                                        
                                                                        .. attribute:: fmm_name
                                                                        
                                                                        	flow monitor name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..33
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, self).__init__()

                                                                            self.yang_name = "fmm"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.fmm_name = YLeaf(YType.str, "fmm-name")
                                                                            self._segment_path = lambda: "fmm"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Fmm, ['fmm_name'], name, value)


                                                                    class Httpr(Entity):
                                                                        """
                                                                        httpr
                                                                        
                                                                        .. attribute:: redirect_url
                                                                        
                                                                        	redirect url
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, self).__init__()

                                                                            self.yang_name = "httpr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.redirect_url = YLeaf(YType.str, "redirect-url")
                                                                            self._segment_path = lambda: "httpr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Httpr, ['redirect_url'], name, value)


                                                                    class Ipcbr(Entity):
                                                                        """
                                                                        ipcbr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: media_bit_rate
                                                                        
                                                                        	media data rate in bps
                                                                        	**type**\:   :py:class:`MediaBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate>`
                                                                        
                                                                        .. attribute:: media_pkt_size
                                                                        
                                                                        	media packet size in bytes
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        	**units**\: byte
                                                                        
                                                                        .. attribute:: media_pkts_per_ip
                                                                        
                                                                        	media packets per ip pkt
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, self).__init__()

                                                                            self.yang_name = "ipcbr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate), "media-bit-rate" : ("media_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.media_pkt_size = YLeaf(YType.uint32, "media-pkt-size")

                                                                            self.media_pkts_per_ip = YLeaf(YType.uint32, "media-pkts-per-ip")

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")

                                                                            self.media_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate()
                                                                            self.media_bit_rate.parent = self
                                                                            self._children_name_map["media_bit_rate"] = "media-bit-rate"
                                                                            self._children_yang_names.add("media-bit-rate")
                                                                            self._segment_path = lambda: "ipcbr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr, ['action_metric_type', 'ip_pkt_rate', 'media_pkt_size', 'media_pkts_per_ip'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.IpBitRate, ['unit', 'value'], name, value)


                                                                        class MediaBitRate(Entity):
                                                                            """
                                                                            media data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, self).__init__()

                                                                                self.yang_name = "media-bit-rate"
                                                                                self.yang_parent_name = "ipcbr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "media-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipcbr.MediaBitRate, ['unit', 'value'], name, value)


                                                                    class Ipv4Nh(Entity):
                                                                        """
                                                                        ipv4 nh
                                                                        
                                                                        .. attribute:: action_ipv4_nh_info_array
                                                                        
                                                                        	action ipv4 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv4NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, self).__init__()

                                                                            self.yang_name = "ipv4-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv4-nh-info-array" : ("action_ipv4_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray)}

                                                                            self.action_ipv4_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv4-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh, [], name, value)


                                                                        class ActionIpv4NhInfoArray(Entity):
                                                                            """
                                                                            action ipv4 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	nh addr
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv4-nh-info-array"
                                                                                self.yang_parent_name = "ipv4-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv4-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv4Nh.ActionIpv4NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Ipv6Nh(Entity):
                                                                        """
                                                                        ipv6 nh
                                                                        
                                                                        .. attribute:: action_ipv6_nh_info_array
                                                                        
                                                                        	action ipv6 nh info array
                                                                        	**type**\: list of    :py:class:`ActionIpv6NhInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, self).__init__()

                                                                            self.yang_name = "ipv6-nh"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-ipv6-nh-info-array" : ("action_ipv6_nh_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray)}

                                                                            self.action_ipv6_nh_info_array = YList(self)
                                                                            self._segment_path = lambda: "ipv6-nh"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh, [], name, value)


                                                                        class ActionIpv6NhInfoArray(Entity):
                                                                            """
                                                                            action ipv6 nh info array
                                                                            
                                                                            .. attribute:: nh_addr
                                                                            
                                                                            	IPV6 Address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: vrf_name
                                                                            
                                                                            	Vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, self).__init__()

                                                                                self.yang_name = "action-ipv6-nh-info-array"
                                                                                self.yang_parent_name = "ipv6-nh"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.nh_addr = YLeaf(YType.str, "nh-addr")

                                                                                self.vrf_name = YLeaf(YType.str, "vrf-name")
                                                                                self._segment_path = lambda: "action-ipv6-nh-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Ipv6Nh.ActionIpv6NhInfoArray, ['nh_addr', 'vrf_name'], name, value)


                                                                    class Mark(Entity):
                                                                        """
                                                                        mark
                                                                        
                                                                        .. attribute:: action_mark_info
                                                                        
                                                                        	action mark info
                                                                        	**type**\: list of    :py:class:`ActionMarkInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, self).__init__()

                                                                            self.yang_name = "mark"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark-info" : ("action_mark_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo)}

                                                                            self.action_mark_info = YList(self)
                                                                            self._segment_path = lambda: "mark"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark, [], name, value)


                                                                        class ActionMarkInfo(Entity):
                                                                            """
                                                                            action mark info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, self).__init__()

                                                                                self.yang_name = "action-mark-info"
                                                                                self.yang_parent_name = "mark"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.value = YLeaf(YType.uint16, "value")
                                                                                self._segment_path = lambda: "action-mark-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark.ActionMarkInfo, ['mark_flags', 'type', 'value'], name, value)


                                                                    class Mark2(Entity):
                                                                        """
                                                                        mark2
                                                                        
                                                                        .. attribute:: action_mark2_info
                                                                        
                                                                        	action mark2 info
                                                                        	**type**\: list of    :py:class:`ActionMark2Info <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, self).__init__()

                                                                            self.yang_name = "mark2"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-mark2-info" : ("action_mark2_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info)}

                                                                            self.action_mark2_info = YList(self)
                                                                            self._segment_path = lambda: "mark2"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2, [], name, value)


                                                                        class ActionMark2Info(Entity):
                                                                            """
                                                                            action mark2 info
                                                                            
                                                                            .. attribute:: mark_flags
                                                                            
                                                                            	mark flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: value_overflow
                                                                            
                                                                            	value overflow
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..65535
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, self).__init__()

                                                                                self.yang_name = "action-mark2-info"
                                                                                self.yang_parent_name = "mark2"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.mark_flags = YLeaf(YType.uint8, "mark-flags")

                                                                                self.type = YLeaf(YType.uint8, "type")

                                                                                self.value = YLeaf(YType.uint32, "value")

                                                                                self.value_overflow = YLeaf(YType.uint16, "value-overflow")
                                                                                self._segment_path = lambda: "action-mark2-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mark2.ActionMark2Info, ['mark_flags', 'type', 'value', 'value_overflow'], name, value)


                                                                    class Mdi(Entity):
                                                                        """
                                                                        mdi
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, self).__init__()

                                                                            self.yang_name = "mdi"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Mdi.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MdiRtp(Entity):
                                                                        """
                                                                        mdi rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: filtered_pkt_rate
                                                                        
                                                                        	filtered packet rate
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: ip_bit_rate
                                                                        
                                                                        	data rate in bps
                                                                        	**type**\:   :py:class:`IpBitRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate>`
                                                                        
                                                                        .. attribute:: ip_pkt_rate
                                                                        
                                                                        	packet rate in pps
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pids
                                                                        
                                                                        	array of monitoredcd  pids
                                                                        	**type**\:  list of int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, self).__init__()

                                                                            self.yang_name = "mdi-rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"ip-bit-rate" : ("ip_bit_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate)}
                                                                            self._child_list_classes = {}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.filtered_pkt_rate = YLeaf(YType.uint32, "filtered-pkt-rate")

                                                                            self.ip_pkt_rate = YLeaf(YType.uint32, "ip-pkt-rate")

                                                                            self.pids = YLeafList(YType.uint32, "pids")

                                                                            self.ip_bit_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate()
                                                                            self.ip_bit_rate.parent = self
                                                                            self._children_name_map["ip_bit_rate"] = "ip-bit-rate"
                                                                            self._children_yang_names.add("ip-bit-rate")
                                                                            self._segment_path = lambda: "mdi-rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp, ['action_metric_type', 'filtered_pkt_rate', 'ip_pkt_rate', 'pids'], name, value)


                                                                        class IpBitRate(Entity):
                                                                            """
                                                                            data rate in bps
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, self).__init__()

                                                                                self.yang_name = "ip-bit-rate"
                                                                                self.yang_parent_name = "mdi-rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "ip-bit-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MdiRtp.IpBitRate, ['unit', 'value'], name, value)


                                                                    class MinBw(Entity):
                                                                        """
                                                                        min bw
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw, self).__init__()

                                                                            self.yang_name = "min-bw"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "min-bw"


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "min-bw"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.MinBw.Bw, ['unit', 'value'], name, value)


                                                                    class OutIntf(Entity):
                                                                        """
                                                                        out intf
                                                                        
                                                                        .. attribute:: out_ifname
                                                                        
                                                                        	output interface name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, self).__init__()

                                                                            self.yang_name = "out-intf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.out_ifname = YLeaf(YType.str, "out-ifname")
                                                                            self._segment_path = lambda: "out-intf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.OutIntf, ['out_ifname'], name, value)


                                                                    class Pbf(Entity):
                                                                        """
                                                                        pbf
                                                                        
                                                                        .. attribute:: action_pbf_info_array
                                                                        
                                                                        	action pbf info array
                                                                        	**type**\: list of    :py:class:`ActionPbfInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, self).__init__()

                                                                            self.yang_name = "pbf"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-pbf-info-array" : ("action_pbf_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray)}

                                                                            self.action_pbf_info_array = YList(self)
                                                                            self._segment_path = lambda: "pbf"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf, [], name, value)


                                                                        class ActionPbfInfoArray(Entity):
                                                                            """
                                                                            action pbf info array
                                                                            
                                                                            .. attribute:: addr
                                                                            
                                                                            	v4 or v6 address
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                            
                                                                            .. attribute:: rt
                                                                            
                                                                            	route target
                                                                            	**type**\:  str
                                                                            
                                                                            	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                            
                                                                            .. attribute:: rt_type
                                                                            
                                                                            	route target type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: vrf
                                                                            
                                                                            	vrf name
                                                                            	**type**\:  str
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, self).__init__()

                                                                                self.yang_name = "action-pbf-info-array"
                                                                                self.yang_parent_name = "pbf"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.addr = YLeaf(YType.str, "addr")

                                                                                self.rt = YLeaf(YType.str, "rt")

                                                                                self.rt_type = YLeaf(YType.uint8, "rt-type")

                                                                                self.vrf = YLeaf(YType.str, "vrf")
                                                                                self._segment_path = lambda: "action-pbf-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pbf.ActionPbfInfoArray, ['addr', 'rt', 'rt_type', 'vrf'], name, value)


                                                                    class Pfc(Entity):
                                                                        """
                                                                        pfc
                                                                        
                                                                        .. attribute:: buffer_size
                                                                        
                                                                        	buffer size
                                                                        	**type**\:   :py:class:`BufferSize <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize>`
                                                                        
                                                                        .. attribute:: buffer_size_flag
                                                                        
                                                                        	buffer size flag
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: pause_threshold
                                                                        
                                                                        	pause threshold
                                                                        	**type**\:   :py:class:`PauseThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold>`
                                                                        
                                                                        .. attribute:: pfc_pause_set
                                                                        
                                                                        	pfc pause set
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: resume_threshold
                                                                        
                                                                        	resume threshold
                                                                        	**type**\:   :py:class:`ResumeThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, self).__init__()

                                                                            self.yang_name = "pfc"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"buffer-size" : ("buffer_size", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize), "pause-threshold" : ("pause_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold), "resume-threshold" : ("resume_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold)}
                                                                            self._child_list_classes = {}

                                                                            self.buffer_size_flag = YLeaf(YType.uint32, "buffer-size-flag")

                                                                            self.pfc_pause_set = YLeaf(YType.uint32, "pfc-pause-set")

                                                                            self.buffer_size = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize()
                                                                            self.buffer_size.parent = self
                                                                            self._children_name_map["buffer_size"] = "buffer-size"
                                                                            self._children_yang_names.add("buffer-size")

                                                                            self.pause_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold()
                                                                            self.pause_threshold.parent = self
                                                                            self._children_name_map["pause_threshold"] = "pause-threshold"
                                                                            self._children_yang_names.add("pause-threshold")

                                                                            self.resume_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold()
                                                                            self.resume_threshold.parent = self
                                                                            self._children_name_map["resume_threshold"] = "resume-threshold"
                                                                            self._children_yang_names.add("resume-threshold")
                                                                            self._segment_path = lambda: "pfc"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc, ['buffer_size_flag', 'pfc_pause_set'], name, value)


                                                                        class BufferSize(Entity):
                                                                            """
                                                                            buffer size
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, self).__init__()

                                                                                self.yang_name = "buffer-size"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "buffer-size"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.BufferSize, ['unit', 'value'], name, value)


                                                                        class PauseThreshold(Entity):
                                                                            """
                                                                            pause threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, self).__init__()

                                                                                self.yang_name = "pause-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "pause-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.PauseThreshold, ['unit', 'value'], name, value)


                                                                        class ResumeThreshold(Entity):
                                                                            """
                                                                            resume threshold
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, self).__init__()

                                                                                self.yang_name = "resume-threshold"
                                                                                self.yang_parent_name = "pfc"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "resume-threshold"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Pfc.ResumeThreshold, ['unit', 'value'], name, value)


                                                                    class Police(Entity):
                                                                        """
                                                                        police
                                                                        
                                                                        .. attribute:: burst
                                                                        
                                                                        	burst
                                                                        	**type**\:   :py:class:`Burst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst>`
                                                                        
                                                                        .. attribute:: cdvt
                                                                        
                                                                        	cdvt
                                                                        	**type**\:   :py:class:`Cdvt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt>`
                                                                        
                                                                        .. attribute:: confclass_encode
                                                                        
                                                                        	confclass encode
                                                                        	**type**\:   :py:class:`ConfclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode>`
                                                                        
                                                                        .. attribute:: confclass_p
                                                                        
                                                                        	confclass p
                                                                        	**type**\:   :py:class:`ConfclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP>`
                                                                        
                                                                        .. attribute:: conform_actns
                                                                        
                                                                        	conform actns
                                                                        	**type**\:   :py:class:`ConformActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns>`
                                                                        
                                                                        .. attribute:: excdclass_encode
                                                                        
                                                                        	excdclass encode
                                                                        	**type**\:   :py:class:`ExcdclassEncode <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode>`
                                                                        
                                                                        .. attribute:: excdclass_p
                                                                        
                                                                        	excdclass p
                                                                        	**type**\:   :py:class:`ExcdclassP <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP>`
                                                                        
                                                                        .. attribute:: exceed_actns
                                                                        
                                                                        	exceed actns
                                                                        	**type**\:   :py:class:`ExceedActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns>`
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: peak_burst
                                                                        
                                                                        	peak burst
                                                                        	**type**\:   :py:class:`PeakBurst <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst>`
                                                                        
                                                                        .. attribute:: peak_rate
                                                                        
                                                                        	peak rate
                                                                        	**type**\:   :py:class:`PeakRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate>`
                                                                        
                                                                        .. attribute:: police_flags
                                                                        
                                                                        	police flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: rate
                                                                        
                                                                        	rate
                                                                        	**type**\:   :py:class:`Rate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate>`
                                                                        
                                                                        .. attribute:: sbuck_name
                                                                        
                                                                        	sbuck name
                                                                        	**type**\:  str
                                                                        
                                                                        	**length:** 0..65
                                                                        
                                                                        .. attribute:: sbuck_type
                                                                        
                                                                        	sbuck type
                                                                        	**type**\:   :py:class:`SharedBucketType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.SharedBucketType>`
                                                                        
                                                                        .. attribute:: violate_actns
                                                                        
                                                                        	violate actns
                                                                        	**type**\:   :py:class:`ViolateActns <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, self).__init__()

                                                                            self.yang_name = "police"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"burst" : ("burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst), "cdvt" : ("cdvt", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt), "confclass-encode" : ("confclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode), "confclass-p" : ("confclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP), "conform-actns" : ("conform_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns), "excdclass-encode" : ("excdclass_encode", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode), "excdclass-p" : ("excdclass_p", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP), "exceed-actns" : ("exceed_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns), "peak-burst" : ("peak_burst", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst), "peak-rate" : ("peak_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate), "rate" : ("rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate), "violate-actns" : ("violate_actns", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.police_flags = YLeaf(YType.uint32, "police-flags")

                                                                            self.sbuck_name = YLeaf(YType.str, "sbuck-name")

                                                                            self.sbuck_type = YLeaf(YType.enumeration, "sbuck-type")

                                                                            self.burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst()
                                                                            self.burst.parent = self
                                                                            self._children_name_map["burst"] = "burst"
                                                                            self._children_yang_names.add("burst")

                                                                            self.cdvt = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt()
                                                                            self.cdvt.parent = self
                                                                            self._children_name_map["cdvt"] = "cdvt"
                                                                            self._children_yang_names.add("cdvt")

                                                                            self.confclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode()
                                                                            self.confclass_encode.parent = self
                                                                            self._children_name_map["confclass_encode"] = "confclass-encode"
                                                                            self._children_yang_names.add("confclass-encode")

                                                                            self.confclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP()
                                                                            self.confclass_p.parent = self
                                                                            self._children_name_map["confclass_p"] = "confclass-p"
                                                                            self._children_yang_names.add("confclass-p")

                                                                            self.conform_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns()
                                                                            self.conform_actns.parent = self
                                                                            self._children_name_map["conform_actns"] = "conform-actns"
                                                                            self._children_yang_names.add("conform-actns")

                                                                            self.excdclass_encode = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode()
                                                                            self.excdclass_encode.parent = self
                                                                            self._children_name_map["excdclass_encode"] = "excdclass-encode"
                                                                            self._children_yang_names.add("excdclass-encode")

                                                                            self.excdclass_p = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP()
                                                                            self.excdclass_p.parent = self
                                                                            self._children_name_map["excdclass_p"] = "excdclass-p"
                                                                            self._children_yang_names.add("excdclass-p")

                                                                            self.exceed_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns()
                                                                            self.exceed_actns.parent = self
                                                                            self._children_name_map["exceed_actns"] = "exceed-actns"
                                                                            self._children_yang_names.add("exceed-actns")

                                                                            self.peak_burst = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst()
                                                                            self.peak_burst.parent = self
                                                                            self._children_name_map["peak_burst"] = "peak-burst"
                                                                            self._children_yang_names.add("peak-burst")

                                                                            self.peak_rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate()
                                                                            self.peak_rate.parent = self
                                                                            self._children_name_map["peak_rate"] = "peak-rate"
                                                                            self._children_yang_names.add("peak-rate")

                                                                            self.rate = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate()
                                                                            self.rate.parent = self
                                                                            self._children_name_map["rate"] = "rate"
                                                                            self._children_yang_names.add("rate")

                                                                            self.violate_actns = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns()
                                                                            self.violate_actns.parent = self
                                                                            self._children_name_map["violate_actns"] = "violate-actns"
                                                                            self._children_yang_names.add("violate-actns")
                                                                            self._segment_path = lambda: "police"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police, ['flags', 'police_flags', 'sbuck_name', 'sbuck_type'], name, value)


                                                                        class Burst(Entity):
                                                                            """
                                                                            burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, self).__init__()

                                                                                self.yang_name = "burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Burst, ['unit', 'value'], name, value)


                                                                        class Cdvt(Entity):
                                                                            """
                                                                            cdvt
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, self).__init__()

                                                                                self.yang_name = "cdvt"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "cdvt"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Cdvt, ['unit', 'value'], name, value)


                                                                        class ConfclassEncode(Entity):
                                                                            """
                                                                            confclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, self).__init__()

                                                                                self.yang_name = "confclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "confclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "confclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConfclassP(Entity):
                                                                            """
                                                                            confclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, self).__init__()

                                                                                self.yang_name = "confclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "confclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "confclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConfclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ConformActns(Entity):
                                                                            """
                                                                            conform actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, self).__init__()

                                                                                self.yang_name = "conform-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "conform-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "conform-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ConformActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class ExcdclassEncode(Entity):
                                                                            """
                                                                            excdclass encode
                                                                            
                                                                            .. attribute:: class_name
                                                                            
                                                                            	class name
                                                                            	**type**\:  str
                                                                            
                                                                            	**length:** 0..65
                                                                            
                                                                            .. attribute:: enc
                                                                            
                                                                            	enc
                                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                                            
                                                                            .. attribute:: hd
                                                                            
                                                                            	hd
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..18446744073709551615
                                                                            
                                                                            .. attribute:: idx
                                                                            
                                                                            	idx
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: inline_cmap
                                                                            
                                                                            	inline cmap
                                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, self).__init__()

                                                                                self.yang_name = "excdclass-encode"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap)}
                                                                                self._child_list_classes = {}

                                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap()
                                                                                self.inline_cmap.parent = self
                                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                                self._children_yang_names.add("inline-cmap")
                                                                                self._segment_path = lambda: "excdclass-encode"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                                            class InlineCmap(Entity):
                                                                                """
                                                                                inline cmap
                                                                                
                                                                                .. attribute:: flags
                                                                                
                                                                                	Inline Class\-Map flags
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_count
                                                                                
                                                                                	Number of Match infos
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Inline Class\-Map Mode Match any/all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, self).__init__()

                                                                                    self.yang_name = "inline-cmap"
                                                                                    self.yang_parent_name = "excdclass-encode"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "inline-cmap"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "inline-cmap"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExcdclassP(Entity):
                                                                            """
                                                                            excdclass p
                                                                            
                                                                            .. attribute:: class_map_bg
                                                                            
                                                                            	class map bg
                                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, self).__init__()

                                                                                self.yang_name = "excdclass-p"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg)}

                                                                                self.class_map_bg = YList(self)
                                                                                self._segment_path = lambda: "excdclass-p"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP, [], name, value)


                                                                            class ClassMapBg(Entity):
                                                                                """
                                                                                class map bg
                                                                                
                                                                                .. attribute:: description
                                                                                
                                                                                	description
                                                                                	**type**\:  str
                                                                                
                                                                                .. attribute:: match_infop
                                                                                
                                                                                	Pointer to the first Match info
                                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop>`
                                                                                
                                                                                .. attribute:: mode
                                                                                
                                                                                	Class\-Map Mode Match any/Match all
                                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                                
                                                                                .. attribute:: name
                                                                                
                                                                                	Name of the class\-map
                                                                                	**type**\:  str
                                                                                
                                                                                	**length:** 0..65
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, self).__init__()

                                                                                    self.yang_name = "class-map-bg"
                                                                                    self.yang_parent_name = "excdclass-p"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop)}
                                                                                    self._child_list_classes = {}

                                                                                    self.description = YLeaf(YType.str, "description")

                                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                                    self.name = YLeaf(YType.str, "name")

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop()
                                                                                    self.match_infop.parent = self
                                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                                    self._children_yang_names.add("match-infop")
                                                                                    self._segment_path = lambda: "class-map-bg"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                                class MatchInfop(Entity):
                                                                                    """
                                                                                    Pointer to the first Match info
                                                                                    
                                                                                    .. attribute:: class_match_info_st
                                                                                    
                                                                                    	class match info st
                                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, self).__init__()

                                                                                        self.yang_name = "match-infop"
                                                                                        self.yang_parent_name = "class-map-bg"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                                        self.class_match_info_st = YList(self)
                                                                                        self._segment_path = lambda: "match-infop"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop, [], name, value)


                                                                                    class ClassMatchInfoSt(Entity):
                                                                                        """
                                                                                        class match info st
                                                                                        
                                                                                        .. attribute:: flags
                                                                                        
                                                                                        	Flags
                                                                                        	**type**\:  int
                                                                                        
                                                                                        	**range:** 0..4294967295
                                                                                        
                                                                                        .. attribute:: match_data
                                                                                        
                                                                                        	Match criteria
                                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                                        
                                                                                        

                                                                                        """

                                                                                        _prefix = 'infra-policymgr-oper'
                                                                                        _revision = '2017-05-27'

                                                                                        def __init__(self):
                                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                                            self.yang_name = "class-match-info-st"
                                                                                            self.yang_parent_name = "match-infop"
                                                                                            self.is_top_level_class = False
                                                                                            self.has_list_ancestor = True
                                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                                            self._child_list_classes = {}

                                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                                            self.match_data.parent = self
                                                                                            self._children_name_map["match_data"] = "match-data"
                                                                                            self._children_yang_names.add("match-data")
                                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                                        def __setattr__(self, name, value):
                                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                                        class MatchData(Entity):
                                                                                            """
                                                                                            Match criteria
                                                                                            
                                                                                            .. attribute:: access_interface
                                                                                            
                                                                                            	Access interface
                                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                                            
                                                                                            .. attribute:: atm_clp
                                                                                            
                                                                                            	Match ATM CLP level
                                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                                            
                                                                                            .. attribute:: auth_domain
                                                                                            
                                                                                            	Authenticated domain name
                                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                                            
                                                                                            .. attribute:: auth_domain_regex
                                                                                            
                                                                                            	Authenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: auth_username
                                                                                            
                                                                                            	Authenticated User Name
                                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                                            
                                                                                            .. attribute:: auth_username_regex
                                                                                            
                                                                                            	Authenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: authen_status
                                                                                            
                                                                                            	Authentication Status
                                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                                            
                                                                                            .. attribute:: avail_id
                                                                                            
                                                                                            	Available Identifiers
                                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                                            
                                                                                            .. attribute:: circuit_id
                                                                                            
                                                                                            	Circuit ID
                                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                                            
                                                                                            .. attribute:: circuit_id_regex
                                                                                            
                                                                                            	Circuit ID RegEx
                                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                                            
                                                                                            .. attribute:: cos
                                                                                            
                                                                                            	Match CoS array
                                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                                            
                                                                                            .. attribute:: cos_inr
                                                                                            
                                                                                            	Match inner header CoS
                                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                                            
                                                                                            .. attribute:: dei
                                                                                            
                                                                                            	Match DEI Bit
                                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                                            
                                                                                            .. attribute:: dei_inr
                                                                                            
                                                                                            	Match inner DEI Bit
                                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id
                                                                                            
                                                                                            	Dhcp Client ID
                                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                                            
                                                                                            .. attribute:: dhcp_client_id_regex
                                                                                            
                                                                                            	Dhcp Client ID RegEx
                                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                                            
                                                                                            .. attribute:: discard_class
                                                                                            
                                                                                            	Match Discard Class array
                                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                                            
                                                                                            .. attribute:: dnis
                                                                                            
                                                                                            	DNIS
                                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                                            
                                                                                            .. attribute:: dnis_regex
                                                                                            
                                                                                            	DNIS Regular Expression
                                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                                            
                                                                                            .. attribute:: domain
                                                                                            
                                                                                            	Domain Name
                                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                                            
                                                                                            .. attribute:: domain_regex
                                                                                            
                                                                                            	Domain Regular Expression
                                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                                            
                                                                                            .. attribute:: dscp
                                                                                            
                                                                                            	Match DSCP range array
                                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv4
                                                                                            
                                                                                            	Destination Address IPV4
                                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: dst_addr_ipv6
                                                                                            
                                                                                            	Destination Address IPV6
                                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: dst_mac
                                                                                            
                                                                                            	Match Destination MAC address
                                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                                            
                                                                                            .. attribute:: dst_port
                                                                                            
                                                                                            	Destination port
                                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                                            
                                                                                            .. attribute:: ether_service_acl
                                                                                            
                                                                                            	Ethernet\-Services Access\-list
                                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                                            
                                                                                            .. attribute:: ethertype
                                                                                            
                                                                                            	Ethernet type
                                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                                            
                                                                                            .. attribute:: flow_key_data
                                                                                            
                                                                                            	Flow key structure
                                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                                            
                                                                                            .. attribute:: flow_tag
                                                                                            
                                                                                            	Match flow\-tag array
                                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                                            
                                                                                            .. attribute:: fr_de
                                                                                            
                                                                                            	Match FR DE value
                                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                                            
                                                                                            .. attribute:: fr_dlci
                                                                                            
                                                                                            	Match FR DLCI range array
                                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                                            
                                                                                            .. attribute:: fragment_type
                                                                                            
                                                                                            	Fragment type
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: icmp_v4
                                                                                            
                                                                                            	Match ICMPV4 Protocol
                                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                                            
                                                                                            .. attribute:: icmp_v6
                                                                                            
                                                                                            	Match ICMPV6 Protocol array
                                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                                            
                                                                                            .. attribute:: icmpv4_code
                                                                                            
                                                                                            	Match ipv4 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                                            
                                                                                            .. attribute:: icmpv4_type
                                                                                            
                                                                                            	Match ipv4 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                                            
                                                                                            .. attribute:: icmpv6_code
                                                                                            
                                                                                            	Match ipv6 icmp code
                                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                                            
                                                                                            .. attribute:: icmpv6_type
                                                                                            
                                                                                            	Match ipv6 icmp type
                                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                                            
                                                                                            .. attribute:: input_interface
                                                                                            
                                                                                            	Input interface
                                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                                            
                                                                                            .. attribute:: input_intfhdl
                                                                                            
                                                                                            	Input interface handle
                                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                                            
                                                                                            .. attribute:: ipv4_acl
                                                                                            
                                                                                            	IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                                            
                                                                                            .. attribute:: ipv4_dscp
                                                                                            
                                                                                            	IPv4 DSCP
                                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv4_packet_len
                                                                                            
                                                                                            	IPv4 packet length array
                                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv4_prec
                                                                                            
                                                                                            	IPv4 Precedence
                                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                                            
                                                                                            .. attribute:: ipv6_acl
                                                                                            
                                                                                            	IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                                            
                                                                                            .. attribute:: ipv6_dscp
                                                                                            
                                                                                            	IPv6 DSCP
                                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                                            
                                                                                            .. attribute:: ipv6_packet_len
                                                                                            
                                                                                            	IPv6 packet length array
                                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                                            
                                                                                            .. attribute:: ipv6_prec
                                                                                            
                                                                                            	IPv6 Precedence
                                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                                            
                                                                                            .. attribute:: media_type
                                                                                            
                                                                                            	Media Type
                                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                                            
                                                                                            .. attribute:: mlp_negotiated
                                                                                            
                                                                                            	MLP Negotiated
                                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                                            
                                                                                            	MPLS Disposition IPv4 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                                            
                                                                                            	MPLS Disposition IPv6 Access\-list
                                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                                            
                                                                                            .. attribute:: mpls_exp
                                                                                            
                                                                                            	Match MPLS experimental topmost array
                                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                                            
                                                                                            .. attribute:: mpls_exp_imp
                                                                                            
                                                                                            	Match MPLS experimental imposition array
                                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                                            
                                                                                            .. attribute:: mpls_top_eos
                                                                                            
                                                                                            	MPLS Topmost EOS
                                                                                            	**type**\:  int
                                                                                            
                                                                                            	**range:** 0..255
                                                                                            
                                                                                            .. attribute:: mpls_top_label
                                                                                            
                                                                                            	MPLS Topmost LABEL
                                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                                            
                                                                                            .. attribute:: nas_port
                                                                                            
                                                                                            	NAS Port
                                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                                            
                                                                                            .. attribute:: packet_len
                                                                                            
                                                                                            	Match packet length array
                                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                                            
                                                                                            .. attribute:: prec
                                                                                            
                                                                                            	Match Precedence array
                                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                                            
                                                                                            .. attribute:: proto
                                                                                            
                                                                                            	Match Protocol array
                                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                                            
                                                                                            .. attribute:: qos_group
                                                                                            
                                                                                            	Match QoS group array
                                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                                            
                                                                                            .. attribute:: remote_id
                                                                                            
                                                                                            	Remote ID
                                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                                            
                                                                                            .. attribute:: remote_id_regex
                                                                                            
                                                                                            	Remote ID RegEx
                                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                                            
                                                                                            .. attribute:: service_name
                                                                                            
                                                                                            	Service Name
                                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                                            
                                                                                            .. attribute:: service_name_regex
                                                                                            
                                                                                            	Service Name Regular Exp
                                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv4
                                                                                            
                                                                                            	Source Address IPV4
                                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                                            
                                                                                            .. attribute:: src_addr_ipv6
                                                                                            
                                                                                            	Source Address IPV6
                                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                                            
                                                                                            .. attribute:: src_addr_mac
                                                                                            
                                                                                            	Source Address MAC
                                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                                            
                                                                                            .. attribute:: src_mac
                                                                                            
                                                                                            	Match Source MAC address
                                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                                            
                                                                                            .. attribute:: src_port
                                                                                            
                                                                                            	Source port
                                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                                            
                                                                                            .. attribute:: subs_protocol
                                                                                            
                                                                                            	Protocol
                                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                                            
                                                                                            .. attribute:: tcp_flag
                                                                                            
                                                                                            	Match tcp flag value
                                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                                            
                                                                                            .. attribute:: timer
                                                                                            
                                                                                            	Timer
                                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                                            
                                                                                            .. attribute:: timer_regexp
                                                                                            
                                                                                            	Timer Regular Expression
                                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                                            
                                                                                            .. attribute:: traffic_class
                                                                                            
                                                                                            	Match Traffic class array
                                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                                            
                                                                                            .. attribute:: tunnel_name
                                                                                            
                                                                                            	Tunnel Name
                                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                                            
                                                                                            .. attribute:: tunnel_name_regex
                                                                                            
                                                                                            	Tunnel Name Regular Expression
                                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                                            
                                                                                            .. attribute:: type
                                                                                            
                                                                                            	type
                                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                                            
                                                                                            .. attribute:: unauth_domain
                                                                                            
                                                                                            	Unauthenticated Domain Name
                                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                                            
                                                                                            .. attribute:: unauth_domain_regex
                                                                                            
                                                                                            	Unauthenticated Domain Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                                            
                                                                                            .. attribute:: unauth_username
                                                                                            
                                                                                            	Unauthenticated User Name
                                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                                            
                                                                                            .. attribute:: unauth_username_regex
                                                                                            
                                                                                            	Unauthenticated User Name RegEx
                                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                                            
                                                                                            .. attribute:: user_name
                                                                                            
                                                                                            	User Name
                                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                                            
                                                                                            .. attribute:: user_name_regex
                                                                                            
                                                                                            	User Name Regular Expression
                                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                                            
                                                                                            .. attribute:: vendor_id
                                                                                            
                                                                                            	Vendor ID
                                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                                            
                                                                                            .. attribute:: vendor_id_regex
                                                                                            
                                                                                            	Vendor ID RegEx
                                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                                            
                                                                                            .. attribute:: vlan
                                                                                            
                                                                                            	Match VLAN array
                                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                                            
                                                                                            .. attribute:: vlan_inr
                                                                                            
                                                                                            	Match inner header VLAN range array
                                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                                            
                                                                                            

                                                                                            """

                                                                                            _prefix = 'infra-policymgr-oper'
                                                                                            _revision = '2017-05-27'

                                                                                            def __init__(self):
                                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                                self.yang_name = "match-data"
                                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                                self.is_top_level_class = False
                                                                                                self.has_list_ancestor = True
                                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                                self._child_list_classes = {}

                                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                                self.access_interface.parent = self
                                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                                self._children_yang_names.add("access-interface")

                                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                                self.atm_clp.parent = self
                                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                                self._children_yang_names.add("atm-clp")

                                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                                self.auth_domain.parent = self
                                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                                self._children_yang_names.add("auth-domain")

                                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                                self.auth_domain_regex.parent = self
                                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                                self.auth_username.parent = self
                                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                                self._children_yang_names.add("auth-username")

                                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                                self.auth_username_regex.parent = self
                                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                                self.avail_id.parent = self
                                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                                self._children_yang_names.add("avail-id")

                                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                                self.circuit_id.parent = self
                                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                                self._children_yang_names.add("circuit-id")

                                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                                self.circuit_id_regex.parent = self
                                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                                self.cos.parent = self
                                                                                                self._children_name_map["cos"] = "cos"
                                                                                                self._children_yang_names.add("cos")

                                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                                self.cos_inr.parent = self
                                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                                self._children_yang_names.add("cos-inr")

                                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                                self.dei.parent = self
                                                                                                self._children_name_map["dei"] = "dei"
                                                                                                self._children_yang_names.add("dei")

                                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                                self.dei_inr.parent = self
                                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                                self._children_yang_names.add("dei-inr")

                                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                                self.dhcp_client_id.parent = self
                                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                                self.dhcp_client_id_regex.parent = self
                                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                                self.discard_class.parent = self
                                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                                self._children_yang_names.add("discard-class")

                                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                                self.dnis.parent = self
                                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                                self._children_yang_names.add("dnis")

                                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                                self.dnis_regex.parent = self
                                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                                self._children_yang_names.add("dnis-regex")

                                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                                self.domain.parent = self
                                                                                                self._children_name_map["domain"] = "domain"
                                                                                                self._children_yang_names.add("domain")

                                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                                self.domain_regex.parent = self
                                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                                self._children_yang_names.add("domain-regex")

                                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                                self.dscp.parent = self
                                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                                self._children_yang_names.add("dscp")

                                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                                self.dst_addr_ipv4.parent = self
                                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                                self.dst_addr_ipv6.parent = self
                                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                                self.dst_mac.parent = self
                                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                                self._children_yang_names.add("dst-mac")

                                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                                self.dst_port.parent = self
                                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                                self._children_yang_names.add("dst-port")

                                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                                self.ether_service_acl.parent = self
                                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                                self.ethertype.parent = self
                                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                                self._children_yang_names.add("ethertype")

                                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                                self.flow_key_data.parent = self
                                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                                self._children_yang_names.add("flow-key-data")

                                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                                self.flow_tag.parent = self
                                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                                self._children_yang_names.add("flow-tag")

                                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                                self.fr_de.parent = self
                                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                                self._children_yang_names.add("fr-de")

                                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                                self.fr_dlci.parent = self
                                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                                self._children_yang_names.add("fr-dlci")

                                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                                self.icmp_v4.parent = self
                                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                                self._children_yang_names.add("icmp-v4")

                                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                                self.icmp_v6.parent = self
                                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                                self._children_yang_names.add("icmp-v6")

                                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                                self.icmpv4_code.parent = self
                                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                                self.icmpv4_type.parent = self
                                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                                self.icmpv6_code.parent = self
                                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                                self.icmpv6_type.parent = self
                                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                                self.input_interface.parent = self
                                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                                self._children_yang_names.add("input-interface")

                                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                                self.input_intfhdl.parent = self
                                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                                self.ipv4_acl.parent = self
                                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                                self.ipv4_dscp.parent = self
                                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                                self.ipv4_packet_len.parent = self
                                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                                self.ipv4_prec.parent = self
                                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                                self.ipv6_acl.parent = self
                                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                                self.ipv6_dscp.parent = self
                                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                                self.ipv6_packet_len.parent = self
                                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                                self.ipv6_prec.parent = self
                                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                                self.media_type.parent = self
                                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                                self._children_yang_names.add("media-type")

                                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                                self.mpls_exp.parent = self
                                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                                self._children_yang_names.add("mpls-exp")

                                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                                self.mpls_exp_imp.parent = self
                                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                                self.mpls_top_label.parent = self
                                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                                self.nas_port.parent = self
                                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                                self._children_yang_names.add("nas-port")

                                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                                self.packet_len.parent = self
                                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                                self._children_yang_names.add("packet-len")

                                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                                self.prec.parent = self
                                                                                                self._children_name_map["prec"] = "prec"
                                                                                                self._children_yang_names.add("prec")

                                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                                self.proto.parent = self
                                                                                                self._children_name_map["proto"] = "proto"
                                                                                                self._children_yang_names.add("proto")

                                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                                self.qos_group.parent = self
                                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                                self._children_yang_names.add("qos-group")

                                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                                self.remote_id.parent = self
                                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                                self._children_yang_names.add("remote-id")

                                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                                self.remote_id_regex.parent = self
                                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                                self.service_name.parent = self
                                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                                self._children_yang_names.add("service-name")

                                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                                self.service_name_regex.parent = self
                                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                                self._children_yang_names.add("service-name-regex")

                                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                                self.src_addr_ipv4.parent = self
                                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                                self.src_addr_ipv6.parent = self
                                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                                self.src_addr_mac.parent = self
                                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                                self.src_mac.parent = self
                                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                                self._children_yang_names.add("src-mac")

                                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                                self.src_port.parent = self
                                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                                self._children_yang_names.add("src-port")

                                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                                self.subs_protocol.parent = self
                                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                                self._children_yang_names.add("subs-protocol")

                                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                                self.tcp_flag.parent = self
                                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                                self._children_yang_names.add("tcp-flag")

                                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                                self.timer.parent = self
                                                                                                self._children_name_map["timer"] = "timer"
                                                                                                self._children_yang_names.add("timer")

                                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                                self.timer_regexp.parent = self
                                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                                self._children_yang_names.add("timer-regexp")

                                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                                self.traffic_class.parent = self
                                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                                self._children_yang_names.add("traffic-class")

                                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                                self.tunnel_name.parent = self
                                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                                self._children_yang_names.add("tunnel-name")

                                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                                self.tunnel_name_regex.parent = self
                                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                                self.unauth_domain.parent = self
                                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                                self._children_yang_names.add("unauth-domain")

                                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                                self.unauth_domain_regex.parent = self
                                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                                self.unauth_username.parent = self
                                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                                self._children_yang_names.add("unauth-username")

                                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                                self.unauth_username_regex.parent = self
                                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                                self.user_name.parent = self
                                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                                self._children_yang_names.add("user-name")

                                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                                self.user_name_regex.parent = self
                                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                                self._children_yang_names.add("user-name-regex")

                                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                                self.vendor_id.parent = self
                                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                                self._children_yang_names.add("vendor-id")

                                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                                self.vendor_id_regex.parent = self
                                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                                self.vlan.parent = self
                                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                                self._children_yang_names.add("vlan")

                                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                                self.vlan_inr.parent = self
                                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                                self._children_yang_names.add("vlan-inr")
                                                                                                self._segment_path = lambda: "match-data"

                                                                                            def __setattr__(self, name, value):
                                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                                            class AccessInterface(Entity):
                                                                                                """
                                                                                                Access interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                                    self.yang_name = "access-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "access-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                                            class AtmClp(Entity):
                                                                                                """
                                                                                                Match ATM CLP level
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                                    self.yang_name = "atm-clp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                                            class AuthDomain(Entity):
                                                                                                """
                                                                                                Authenticated domain name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                                    self.yang_name = "auth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                                            class AuthDomainRegex(Entity):
                                                                                                """
                                                                                                Authenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "auth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                                            class AuthUsername(Entity):
                                                                                                """
                                                                                                Authenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                                    self.yang_name = "auth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                                            class AuthUsernameRegex(Entity):
                                                                                                """
                                                                                                Authenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "auth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                                            class AvailId(Entity):
                                                                                                """
                                                                                                Available Identifiers
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                                    self.yang_name = "avail-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "avail-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                                            class CircuitId(Entity):
                                                                                                """
                                                                                                Circuit ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                                    self.yang_name = "circuit-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                                            class CircuitIdRegex(Entity):
                                                                                                """
                                                                                                Circuit ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                                    self.yang_name = "circuit-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                                            class Cos(Entity):
                                                                                                """
                                                                                                Match CoS array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                                    self.yang_name = "cos"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                                            class CosInr(Entity):
                                                                                                """
                                                                                                Match inner header CoS
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                                    self.yang_name = "cos-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                                            class Dei(Entity):
                                                                                                """
                                                                                                Match DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                                    self.yang_name = "dei"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                                            class DeiInr(Entity):
                                                                                                """
                                                                                                Match inner DEI Bit
                                                                                                
                                                                                                .. attribute:: bit_value
                                                                                                
                                                                                                	Value of the DEI bit
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..4294967295
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                                    self.yang_name = "dei-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                                            class DhcpClientId(Entity):
                                                                                                """
                                                                                                Dhcp Client ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                                            class DhcpClientIdRegex(Entity):
                                                                                                """
                                                                                                Dhcp Client ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                                            class DiscardClass(Entity):
                                                                                                """
                                                                                                Match Discard Class array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                                    self.yang_name = "discard-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "discard-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                                            class Dnis(Entity):
                                                                                                """
                                                                                                DNIS
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                                    self.yang_name = "dnis"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                                            class DnisRegex(Entity):
                                                                                                """
                                                                                                DNIS Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                                    self.yang_name = "dnis-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                                            class Domain(Entity):
                                                                                                """
                                                                                                Domain Name
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                                    self.yang_name = "domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class DomainRegex(Entity):
                                                                                                """
                                                                                                Domain Regular Expression
                                                                                                
                                                                                                .. attribute:: domain_array
                                                                                                
                                                                                                	domain array
                                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                                    self.yang_name = "domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                                    self.domain_array = YList(self)
                                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                                class DomainArray(Entity):
                                                                                                    """
                                                                                                    domain array
                                                                                                    
                                                                                                    .. attribute:: domain_name
                                                                                                    
                                                                                                    	domain name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    .. attribute:: format_name
                                                                                                    
                                                                                                    	format name
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                                        self.yang_name = "domain-array"
                                                                                                        self.yang_parent_name = "domain-regex"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                                        self._segment_path = lambda: "domain-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                                            class Dscp(Entity):
                                                                                                """
                                                                                                Match DSCP range array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                                    self.yang_name = "dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class DstAddrIpv4(Entity):
                                                                                                """
                                                                                                Destination Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstAddrIpv6(Entity):
                                                                                                """
                                                                                                Destination Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class DstMac(Entity):
                                                                                                """
                                                                                                Match Destination MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                                    self.yang_name = "dst-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                                            class DstPort(Entity):
                                                                                                """
                                                                                                Destination port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                                    self.yang_name = "dst-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "dst-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "dst-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class EtherServiceAcl(Entity):
                                                                                                """
                                                                                                Ethernet\-Services Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                                    self.yang_name = "ether-service-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                                            class Ethertype(Entity):
                                                                                                """
                                                                                                Ethernet type
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                                    self.yang_name = "ethertype"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ethertype"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ethertype"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class FlowKeyData(Entity):
                                                                                                """
                                                                                                Flow key structure
                                                                                                
                                                                                                .. attribute:: flow_keys
                                                                                                
                                                                                                	flow keys
                                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                                
                                                                                                .. attribute:: idle_timeout
                                                                                                
                                                                                                	Idle timeout of flows (in seconds)
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                	**units**\: second
                                                                                                
                                                                                                .. attribute:: max_count
                                                                                                
                                                                                                	Maximum count of flows
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                                    self.yang_name = "flow-key-data"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                                    self.flow_keys.parent = self
                                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                                    self._children_yang_names.add("flow-keys")
                                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                                class FlowKeys(Entity):
                                                                                                    """
                                                                                                    flow keys
                                                                                                    
                                                                                                    .. attribute:: keys
                                                                                                    
                                                                                                    	keys
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                                    
                                                                                                    .. attribute:: num
                                                                                                    
                                                                                                    	num
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                                        self.yang_name = "flow-keys"
                                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                                            class FlowTag(Entity):
                                                                                                """
                                                                                                Match flow\-tag array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                                    self.yang_name = "flow-tag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "flow-tag"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class FrDe(Entity):
                                                                                                """
                                                                                                Match FR DE value
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                                    self.yang_name = "fr-de"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "fr-de"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                                            class FrDlci(Entity):
                                                                                                """
                                                                                                Match FR DLCI range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                                    self.yang_name = "fr-dlci"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class IcmpV4(Entity):
                                                                                                """
                                                                                                Match ICMPV4 Protocol
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                                    self.yang_name = "icmp-v4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                                            class IcmpV6(Entity):
                                                                                                """
                                                                                                Match ICMPV6 Protocol array
                                                                                                
                                                                                                .. attribute:: code
                                                                                                
                                                                                                	Protocol code
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                .. attribute:: type
                                                                                                
                                                                                                	Protocol type
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                                    self.yang_name = "icmp-v6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                                            class Icmpv4Code(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                                    self.yang_name = "icmpv4-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv4Type(Entity):
                                                                                                """
                                                                                                Match ipv4 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                                    self.yang_name = "icmpv4-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Code(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp code
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                                    self.yang_name = "icmpv6-code"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Icmpv6Type(Entity):
                                                                                                """
                                                                                                Match ipv6 icmp type
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                                    self.yang_name = "icmpv6-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class InputInterface(Entity):
                                                                                                """
                                                                                                Input interface
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                                    self.yang_name = "input-interface"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "input-interface"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                                            class InputIntfhdl(Entity):
                                                                                                """
                                                                                                Input interface handle
                                                                                                
                                                                                                .. attribute:: uint64_array
                                                                                                
                                                                                                	uint64 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..18446744073709551615
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                                    self.yang_name = "input-intfhdl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                                            class Ipv4Acl(Entity):
                                                                                                """
                                                                                                IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                                    self.yang_name = "ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                                            class Ipv4Dscp(Entity):
                                                                                                """
                                                                                                IPv4 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv4-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4PacketLen(Entity):
                                                                                                """
                                                                                                IPv4 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv4Prec(Entity):
                                                                                                """
                                                                                                IPv4 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                                    self.yang_name = "ipv4-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                                            class Ipv6Acl(Entity):
                                                                                                """
                                                                                                IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                                    self.yang_name = "ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                                            class Ipv6Dscp(Entity):
                                                                                                """
                                                                                                IPv6 DSCP
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                                    self.yang_name = "ipv6-dscp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6PacketLen(Entity):
                                                                                                """
                                                                                                IPv6 packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Ipv6Prec(Entity):
                                                                                                """
                                                                                                IPv6 Precedence
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                                    self.yang_name = "ipv6-prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                                            class MediaType(Entity):
                                                                                                """
                                                                                                Media Type
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                                    self.yang_name = "media-type"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "media-type"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                                            class MplsDispIpv4Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv4 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                                            class MplsDispIpv6Acl(Entity):
                                                                                                """
                                                                                                MPLS Disposition IPv6 Access\-list
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                                            class MplsExp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental topmost array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                                            class MplsExpImp(Entity):
                                                                                                """
                                                                                                Match MPLS experimental imposition array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                                            class MplsTopLabel(Entity):
                                                                                                """
                                                                                                MPLS Topmost LABEL
                                                                                                
                                                                                                .. attribute:: uint32_rng_array
                                                                                                
                                                                                                	uint32 rng array
                                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                                    self.yang_name = "mpls-top-label"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                                    self.uint32_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                                class Uint32RngArray(Entity):
                                                                                                    """
                                                                                                    uint32 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                                        self.yang_name = "uint32_rng_array"
                                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                                            class NasPort(Entity):
                                                                                                """
                                                                                                NAS Port
                                                                                                
                                                                                                .. attribute:: nas_port_array
                                                                                                
                                                                                                	nas port array
                                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                                    self.yang_name = "nas-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                                    self.nas_port_array = YList(self)
                                                                                                    self._segment_path = lambda: "nas-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                                class NasPortArray(Entity):
                                                                                                    """
                                                                                                    nas port array
                                                                                                    
                                                                                                    .. attribute:: operator
                                                                                                    
                                                                                                    	operator
                                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                                    
                                                                                                    .. attribute:: sub_id
                                                                                                    
                                                                                                    	sub id
                                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                                    
                                                                                                    .. attribute:: value
                                                                                                    
                                                                                                    	value
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                                        self.yang_name = "nas-port-array"
                                                                                                        self.yang_parent_name = "nas-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                                            class PacketLen(Entity):
                                                                                                """
                                                                                                Match packet length array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                                    self.yang_name = "packet-len"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "packet-len"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "packet-len"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class Prec(Entity):
                                                                                                """
                                                                                                Match Precedence array
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                                    self.yang_name = "prec"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "prec"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                                            class Proto(Entity):
                                                                                                """
                                                                                                Match Protocol array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                                    self.yang_name = "proto"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "proto"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "proto"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class QosGroup(Entity):
                                                                                                """
                                                                                                Match QoS group array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                                    self.yang_name = "qos-group"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "qos-group"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "qos-group"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class RemoteId(Entity):
                                                                                                """
                                                                                                Remote ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                                    self.yang_name = "remote-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                                            class RemoteIdRegex(Entity):
                                                                                                """
                                                                                                Remote ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                                    self.yang_name = "remote-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                                            class ServiceName(Entity):
                                                                                                """
                                                                                                Service Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                                    self.yang_name = "service-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                                            class ServiceNameRegex(Entity):
                                                                                                """
                                                                                                Service Name Regular Exp
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                                    self.yang_name = "service-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                                            class SrcAddrIpv4(Entity):
                                                                                                """
                                                                                                Source Address IPV4
                                                                                                
                                                                                                .. attribute:: ipv4_addr_array
                                                                                                
                                                                                                	ipv4 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                                    self.ipv4_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                                class Ipv4AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv4 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	mask
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrIpv6(Entity):
                                                                                                """
                                                                                                Source Address IPV6
                                                                                                
                                                                                                .. attribute:: ipv6_addr_array
                                                                                                
                                                                                                	ipv6 addr array
                                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                                    self.ipv6_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                                class Ipv6AddrArray(Entity):
                                                                                                    """
                                                                                                    ipv6 addr array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	IPV6 mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..4294967295
                                                                                                    
                                                                                                    .. attribute:: prefix
                                                                                                    
                                                                                                    	IPV6 prefix
                                                                                                    	**type**\:  str
                                                                                                    
                                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                                            class SrcAddrMac(Entity):
                                                                                                """
                                                                                                Source Address MAC
                                                                                                
                                                                                                .. attribute:: mac_addr_array
                                                                                                
                                                                                                	mac addr array
                                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                                    self.yang_name = "src-addr-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                                    self.mac_addr_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                                class MacAddrArray(Entity):
                                                                                                    """
                                                                                                    mac addr array
                                                                                                    
                                                                                                    .. attribute:: mac_addr
                                                                                                    
                                                                                                    	MAC address
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	MAC mask
                                                                                                    	**type**\:  list of int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                                        self.yang_name = "mac-addr-array"
                                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcMac(Entity):
                                                                                                """
                                                                                                Match Source MAC address
                                                                                                
                                                                                                .. attribute:: mac_addr
                                                                                                
                                                                                                	MAC address
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                .. attribute:: mask
                                                                                                
                                                                                                	MAC mask
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                                    self.yang_name = "src-mac"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                                    self._segment_path = lambda: "src-mac"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                                            class SrcPort(Entity):
                                                                                                """
                                                                                                Source port
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                                    self.yang_name = "src-port"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "src-port"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "src-port"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                                            class SubsProtocol(Entity):
                                                                                                """
                                                                                                Protocol
                                                                                                
                                                                                                .. attribute:: uint8_array
                                                                                                
                                                                                                	uint8 array
                                                                                                	**type**\:  list of int
                                                                                                
                                                                                                	**range:** 0..255
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                                    self.yang_name = "subs-protocol"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                                            class TcpFlag(Entity):
                                                                                                """
                                                                                                Match tcp flag value
                                                                                                
                                                                                                .. attribute:: match_any
                                                                                                
                                                                                                	Match any TCP flag bit
                                                                                                	**type**\:  bool
                                                                                                
                                                                                                .. attribute:: value
                                                                                                
                                                                                                	Value of TCP flag
                                                                                                	**type**\:  int
                                                                                                
                                                                                                	**range:** 0..65535
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                                    self.yang_name = "tcp-flag"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                                            class Timer(Entity):
                                                                                                """
                                                                                                Timer
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                                    self.yang_name = "timer"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                                            class TimerRegexp(Entity):
                                                                                                """
                                                                                                Timer Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                                    self.yang_name = "timer-regexp"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                                            class TrafficClass(Entity):
                                                                                                """
                                                                                                Match Traffic class array
                                                                                                
                                                                                                .. attribute:: uint8_rng_array
                                                                                                
                                                                                                	uint8 rng array
                                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                                    self.yang_name = "traffic-class"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                                    self.uint8_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                                class Uint8RngArray(Entity):
                                                                                                    """
                                                                                                    uint8 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..255
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                                        self.yang_name = "uint8_rng_array"
                                                                                                        self.yang_parent_name = "traffic-class"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                                            class TunnelName(Entity):
                                                                                                """
                                                                                                Tunnel Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                                    self.yang_name = "tunnel-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                                            class TunnelNameRegex(Entity):
                                                                                                """
                                                                                                Tunnel Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                                            class UnauthDomain(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                                    self.yang_name = "unauth-domain"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                                            class UnauthDomainRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated Domain Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                                            class UnauthUsername(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                                    self.yang_name = "unauth-username"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                                            class UnauthUsernameRegex(Entity):
                                                                                                """
                                                                                                Unauthenticated User Name RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                                    self.yang_name = "unauth-username-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                                            class UserName(Entity):
                                                                                                """
                                                                                                User Name
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                                    self.yang_name = "user-name"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                                            class UserNameRegex(Entity):
                                                                                                """
                                                                                                User Name Regular Expression
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                                    self.yang_name = "user-name-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                                            class VendorId(Entity):
                                                                                                """
                                                                                                Vendor ID
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                                    self.yang_name = "vendor-id"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                                            class VendorIdRegex(Entity):
                                                                                                """
                                                                                                Vendor ID RegEx
                                                                                                
                                                                                                .. attribute:: string_array
                                                                                                
                                                                                                	string array
                                                                                                	**type**\:  list of str
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                                    self.yang_name = "vendor-id-regex"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {}

                                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                                            class Vlan(Entity):
                                                                                                """
                                                                                                Match VLAN array
                                                                                                
                                                                                                .. attribute:: vlan_id_array
                                                                                                
                                                                                                	vlan id array
                                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                                    self.yang_name = "vlan"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                                    self.vlan_id_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                                class VlanIdArray(Entity):
                                                                                                    """
                                                                                                    vlan id array
                                                                                                    
                                                                                                    .. attribute:: mask
                                                                                                    
                                                                                                    	VLAN mask
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                                        self.yang_name = "vlan-id-array"
                                                                                                        self.yang_parent_name = "vlan"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                                            class VlanInr(Entity):
                                                                                                """
                                                                                                Match inner header VLAN range array
                                                                                                
                                                                                                .. attribute:: uint16_rng_array
                                                                                                
                                                                                                	uint16 rng array
                                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                                
                                                                                                

                                                                                                """

                                                                                                _prefix = 'infra-policymgr-oper'
                                                                                                _revision = '2017-05-27'

                                                                                                def __init__(self):
                                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                                    self.yang_name = "vlan-inr"
                                                                                                    self.yang_parent_name = "match-data"
                                                                                                    self.is_top_level_class = False
                                                                                                    self.has_list_ancestor = True
                                                                                                    self._child_container_classes = {}
                                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                                    self.uint16_rng_array = YList(self)
                                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                                def __setattr__(self, name, value):
                                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                                class Uint16RngArray(Entity):
                                                                                                    """
                                                                                                    uint16 rng array
                                                                                                    
                                                                                                    .. attribute:: max
                                                                                                    
                                                                                                    	Upper limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    .. attribute:: min
                                                                                                    
                                                                                                    	Lower limit of the range
                                                                                                    	**type**\:  int
                                                                                                    
                                                                                                    	**range:** 0..65535
                                                                                                    
                                                                                                    

                                                                                                    """

                                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                                    _revision = '2017-05-27'

                                                                                                    def __init__(self):
                                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                                        self.yang_name = "uint16_rng_array"
                                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                                        self.is_top_level_class = False
                                                                                                        self.has_list_ancestor = True
                                                                                                        self._child_container_classes = {}
                                                                                                        self._child_list_classes = {}

                                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                                    def __setattr__(self, name, value):
                                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExcdclassP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                                        class ExceedActns(Entity):
                                                                            """
                                                                            exceed actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, self).__init__()

                                                                                self.yang_name = "exceed-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "exceed-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "exceed-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ExceedActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                        class PeakBurst(Entity):
                                                                            """
                                                                            peak burst
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, self).__init__()

                                                                                self.yang_name = "peak-burst"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-burst"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakBurst, ['unit', 'value'], name, value)


                                                                        class PeakRate(Entity):
                                                                            """
                                                                            peak rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, self).__init__()

                                                                                self.yang_name = "peak-rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "peak-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.PeakRate, ['unit', 'value'], name, value)


                                                                        class Rate(Entity):
                                                                            """
                                                                            rate
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, self).__init__()

                                                                                self.yang_name = "rate"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.Rate, ['unit', 'value'], name, value)


                                                                        class ViolateActns(Entity):
                                                                            """
                                                                            violate actns
                                                                            
                                                                            .. attribute:: police_action_array
                                                                            
                                                                            	police action array
                                                                            	**type**\: list of    :py:class:`PoliceActionArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, self).__init__()

                                                                                self.yang_name = "violate-actns"
                                                                                self.yang_parent_name = "police"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {"police-action-array" : ("police_action_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray)}

                                                                                self.police_action_array = YList(self)
                                                                                self._segment_path = lambda: "violate-actns"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns, [], name, value)


                                                                            class PoliceActionArray(Entity):
                                                                                """
                                                                                police action array
                                                                                
                                                                                .. attribute:: mark
                                                                                
                                                                                	mark
                                                                                	**type**\:   :py:class:`Mark <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark>`
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	type
                                                                                	**type**\:   :py:class:`PoliceActionTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PoliceActionTypeEn>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, self).__init__()

                                                                                    self.yang_name = "police-action-array"
                                                                                    self.yang_parent_name = "violate-actns"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"mark" : ("mark", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark)}
                                                                                    self._child_list_classes = {}

                                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                                    self.mark = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark()
                                                                                    self.mark.parent = self
                                                                                    self._children_name_map["mark"] = "mark"
                                                                                    self._children_yang_names.add("mark")
                                                                                    self._segment_path = lambda: "police-action-array"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray, ['type'], name, value)


                                                                                class Mark(Entity):
                                                                                    """
                                                                                    mark
                                                                                    
                                                                                    .. attribute:: mark_flags
                                                                                    
                                                                                    	mark flags
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: type
                                                                                    
                                                                                    	type
                                                                                    	**type**\:   :py:class:`MarkTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MarkTypeEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, self).__init__()

                                                                                        self.yang_name = "mark"
                                                                                        self.yang_parent_name = "police-action-array"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mark_flags = YLeaf(YType.uint32, "mark-flags")

                                                                                        self.type = YLeaf(YType.enumeration, "type")

                                                                                        self.value = YLeaf(YType.uint16, "value")
                                                                                        self._segment_path = lambda: "mark"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Police.ViolateActns.PoliceActionArray.Mark, ['mark_flags', 'type', 'value'], name, value)


                                                                    class PrepaidCfg(Entity):
                                                                        """
                                                                        prepaid cfg
                                                                        
                                                                        .. attribute:: prepaid_config_profile_name
                                                                        
                                                                        	prepaid config profile name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, self).__init__()

                                                                            self.yang_name = "prepaid-cfg"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prepaid_config_profile_name = YLeaf(YType.str, "prepaid-config-profile-name")
                                                                            self._segment_path = lambda: "prepaid-cfg"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.PrepaidCfg, ['prepaid_config_profile_name'], name, value)


                                                                    class Prio(Entity):
                                                                        """
                                                                        prio
                                                                        
                                                                        .. attribute:: prio_lvl
                                                                        
                                                                        	prio lvl
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, self).__init__()

                                                                            self.yang_name = "prio"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.prio_lvl = YLeaf(YType.uint32, "prio-lvl")
                                                                            self._segment_path = lambda: "prio"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Prio, ['prio_lvl'], name, value)


                                                                    class ProxyAaa(Entity):
                                                                        """
                                                                        proxy aaa
                                                                        
                                                                        .. attribute:: aaa_list_name
                                                                        
                                                                        	aaa list name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, self).__init__()

                                                                            self.yang_name = "proxy-aaa"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.aaa_list_name = YLeaf(YType.str, "aaa-list-name")
                                                                            self._segment_path = lambda: "proxy-aaa"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ProxyAaa, ['aaa_list_name'], name, value)


                                                                    class Punt(Entity):
                                                                        """
                                                                        punt
                                                                        
                                                                        .. attribute:: app_id
                                                                        
                                                                        	application ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: local_id
                                                                        
                                                                        	local ID
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_index
                                                                        
                                                                        	service node index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: sn_name
                                                                        
                                                                        	service node name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: sn_type
                                                                        
                                                                        	service node ID type
                                                                        	**type**\:   :py:class:`DpssSnidTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.DpssSnidTypeEn>`
                                                                        
                                                                        .. attribute:: vsnode_type
                                                                        
                                                                        	vservice node type
                                                                        	**type**\:   :py:class:`VsvcServiceTypeT <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.VsvcServiceTypeT>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, self).__init__()

                                                                            self.yang_name = "punt"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.app_id = YLeaf(YType.uint32, "app-id")

                                                                            self.local_id = YLeaf(YType.uint32, "local-id")

                                                                            self.sn_index = YLeaf(YType.uint32, "sn-index")

                                                                            self.sn_name = YLeaf(YType.str, "sn-name")

                                                                            self.sn_type = YLeaf(YType.enumeration, "sn-type")

                                                                            self.vsnode_type = YLeaf(YType.enumeration, "vsnode-type")
                                                                            self._segment_path = lambda: "punt"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Punt, ['app_id', 'local_id', 'sn_index', 'sn_name', 'sn_type', 'vsnode_type'], name, value)


                                                                    class Qlimit(Entity):
                                                                        """
                                                                        qlimit
                                                                        
                                                                        .. attribute:: action_qlimit_info_array
                                                                        
                                                                        	action qlimit info array
                                                                        	**type**\: list of    :py:class:`ActionQlimitInfoArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, self).__init__()

                                                                            self.yang_name = "qlimit"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-qlimit-info-array" : ("action_qlimit_info_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray)}

                                                                            self.action_qlimit_info_array = YList(self)
                                                                            self._segment_path = lambda: "qlimit"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit, [], name, value)


                                                                        class ActionQlimitInfoArray(Entity):
                                                                            """
                                                                            action qlimit info array
                                                                            
                                                                            .. attribute:: atmclp_qlim
                                                                            
                                                                            	atmclp qlim
                                                                            	**type**\:   :py:class:`AtmclpQlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim>`
                                                                            
                                                                            .. attribute:: match_values
                                                                            
                                                                            	match values
                                                                            	**type**\:   :py:class:`MatchValues <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues>`
                                                                            
                                                                            .. attribute:: qlim
                                                                            
                                                                            	qlim
                                                                            	**type**\:   :py:class:`Qlim <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim>`
                                                                            
                                                                            .. attribute:: qlimit_flags
                                                                            
                                                                            	qlimit flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`QlimitTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.QlimitTypeEn>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, self).__init__()

                                                                                self.yang_name = "action-qlimit-info-array"
                                                                                self.yang_parent_name = "qlimit"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"atmclp-qlim" : ("atmclp_qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim), "match-values" : ("match_values", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues), "qlim" : ("qlim", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim)}
                                                                                self._child_list_classes = {}

                                                                                self.qlimit_flags = YLeaf(YType.uint32, "qlimit-flags")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.atmclp_qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim()
                                                                                self.atmclp_qlim.parent = self
                                                                                self._children_name_map["atmclp_qlim"] = "atmclp-qlim"
                                                                                self._children_yang_names.add("atmclp-qlim")

                                                                                self.match_values = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues()
                                                                                self.match_values.parent = self
                                                                                self._children_name_map["match_values"] = "match-values"
                                                                                self._children_yang_names.add("match-values")

                                                                                self.qlim = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim()
                                                                                self.qlim.parent = self
                                                                                self._children_name_map["qlim"] = "qlim"
                                                                                self._children_yang_names.add("qlim")
                                                                                self._segment_path = lambda: "action-qlimit-info-array"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray, ['qlimit_flags', 'type'], name, value)


                                                                            class AtmclpQlim(Entity):
                                                                                """
                                                                                atmclp qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, self).__init__()

                                                                                    self.yang_name = "atmclp-qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "atmclp-qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.AtmclpQlim, ['unit', 'value'], name, value)


                                                                            class MatchValues(Entity):
                                                                                """
                                                                                match values
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, self).__init__()

                                                                                    self.yang_name = "match-values"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-values"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-values"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.MatchValues.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Qlim(Entity):
                                                                                """
                                                                                qlim
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, self).__init__()

                                                                                    self.yang_name = "qlim"
                                                                                    self.yang_parent_name = "action-qlimit-info-array"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "qlim"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Qlimit.ActionQlimitInfoArray.Qlim, ['unit', 'value'], name, value)


                                                                    class QueryAncp(Entity):
                                                                        """
                                                                        query ancp
                                                                        
                                                                        .. attribute:: enable
                                                                        
                                                                        	enable
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, self).__init__()

                                                                            self.yang_name = "query-ancp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.enable = YLeaf(YType.uint8, "enable")
                                                                            self._segment_path = lambda: "query-ancp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.QueryAncp, ['enable'], name, value)


                                                                    class Redirect(Entity):
                                                                        """
                                                                        redirect
                                                                        
                                                                        .. attribute:: type
                                                                        
                                                                        	type
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: value
                                                                        
                                                                        	value
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, self).__init__()

                                                                            self.yang_name = "redirect"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.type = YLeaf(YType.uint8, "type")

                                                                            self.value = YLeaf(YType.uint32, "value")
                                                                            self._segment_path = lambda: "redirect"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Redirect, ['type', 'value'], name, value)


                                                                    class Rtp(Entity):
                                                                        """
                                                                        rtp
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, self).__init__()

                                                                            self.yang_name = "rtp"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Rtp.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpJ2K(Entity):
                                                                        """
                                                                        rtp j2k
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, self).__init__()

                                                                            self.yang_name = "rtp-j2k"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-j2k"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-j2k"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpJ2K.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpMmr(Entity):
                                                                        """
                                                                        rtp mmr
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, self).__init__()

                                                                            self.yang_name = "rtp-mmr"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-mmr"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-mmr"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpMmr.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class RtpVoice(Entity):
                                                                        """
                                                                        rtp voice
                                                                        
                                                                        .. attribute:: action_metric_type
                                                                        
                                                                        	metric type
                                                                        	**type**\:   :py:class:`PolicyActionEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyActionEn>`
                                                                        
                                                                        .. attribute:: clock_rate
                                                                        
                                                                        	clock rate
                                                                        	**type**\: list of    :py:class:`ClockRate <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate>`
                                                                        
                                                                        .. attribute:: max_dropout
                                                                        
                                                                        	max dropout
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: max_misorder
                                                                        
                                                                        	max misorder
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: min_sequential
                                                                        
                                                                        	min sequential
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: seq_ext_cop4
                                                                        
                                                                        	enable seq extension cop4
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, self).__init__()

                                                                            self.yang_name = "rtp-voice"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"clock-rate" : ("clock_rate", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate)}

                                                                            self.action_metric_type = YLeaf(YType.enumeration, "action-metric-type")

                                                                            self.max_dropout = YLeaf(YType.uint32, "max-dropout")

                                                                            self.max_misorder = YLeaf(YType.uint32, "max-misorder")

                                                                            self.min_sequential = YLeaf(YType.uint32, "min-sequential")

                                                                            self.seq_ext_cop4 = YLeaf(YType.uint32, "seq-ext-cop4")

                                                                            self.clock_rate = YList(self)
                                                                            self._segment_path = lambda: "rtp-voice"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice, ['action_metric_type', 'max_dropout', 'max_misorder', 'min_sequential', 'seq_ext_cop4'], name, value)


                                                                        class ClockRate(Entity):
                                                                            """
                                                                            clock rate
                                                                            
                                                                            .. attribute:: frequency
                                                                            
                                                                            	frequency
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: pt
                                                                            
                                                                            	pt
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, self).__init__()

                                                                                self.yang_name = "clock-rate"
                                                                                self.yang_parent_name = "rtp-voice"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.frequency = YLeaf(YType.uint32, "frequency")

                                                                                self.pt = YLeaf(YType.uint32, "pt")
                                                                                self._segment_path = lambda: "clock-rate"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.RtpVoice.ClockRate, ['frequency', 'pt'], name, value)


                                                                    class ServFunc(Entity):
                                                                        """
                                                                        serv func
                                                                        
                                                                        .. attribute:: meta_name
                                                                        
                                                                        	metadata name
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: path_id
                                                                        
                                                                        	service path id
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: service_index
                                                                        
                                                                        	service path index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..255
                                                                        
                                                                        .. attribute:: vs_index
                                                                        
                                                                        	vservice index
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, self).__init__()

                                                                            self.yang_name = "serv-func"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.meta_name = YLeaf(YType.str, "meta-name")

                                                                            self.path_id = YLeaf(YType.uint32, "path-id")

                                                                            self.service_index = YLeaf(YType.uint8, "service-index")

                                                                            self.vs_index = YLeaf(YType.uint32, "vs-index")
                                                                            self._segment_path = lambda: "serv-func"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.ServFunc, ['meta_name', 'path_id', 'service_index', 'vs_index'], name, value)


                                                                    class SetTimer(Entity):
                                                                        """
                                                                        set timer
                                                                        
                                                                        .. attribute:: absolute_time
                                                                        
                                                                        	absolute time
                                                                        	**type**\:  str
                                                                        
                                                                        .. attribute:: duration
                                                                        
                                                                        	duration
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, self).__init__()

                                                                            self.yang_name = "set-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.absolute_time = YLeaf(YType.str, "absolute-time")

                                                                            self.duration = YLeaf(YType.uint32, "duration")

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "set-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.SetTimer, ['absolute_time', 'duration', 'timer_name'], name, value)


                                                                    class Sfrag(Entity):
                                                                        """
                                                                        sfrag
                                                                        
                                                                        .. attribute:: name
                                                                        
                                                                        	Service Fragment Name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, self).__init__()

                                                                            self.yang_name = "sfrag"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.name = YLeaf(YType.str, "name")
                                                                            self._segment_path = lambda: "sfrag"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Sfrag, ['name'], name, value)


                                                                    class Shape(Entity):
                                                                        """
                                                                        shape
                                                                        
                                                                        .. attribute:: be
                                                                        
                                                                        	be
                                                                        	**type**\:   :py:class:`Be <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be>`
                                                                        
                                                                        .. attribute:: bw
                                                                        
                                                                        	bw
                                                                        	**type**\:   :py:class:`Bw <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape, self).__init__()

                                                                            self.yang_name = "shape"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"be" : ("be", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be), "bw" : ("bw", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw)}
                                                                            self._child_list_classes = {}

                                                                            self.be = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be()
                                                                            self.be.parent = self
                                                                            self._children_name_map["be"] = "be"
                                                                            self._children_yang_names.add("be")

                                                                            self.bw = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw()
                                                                            self.bw.parent = self
                                                                            self._children_name_map["bw"] = "bw"
                                                                            self._children_yang_names.add("bw")
                                                                            self._segment_path = lambda: "shape"


                                                                        class Be(Entity):
                                                                            """
                                                                            be
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, self).__init__()

                                                                                self.yang_name = "be"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "be"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Be, ['unit', 'value'], name, value)


                                                                        class Bw(Entity):
                                                                            """
                                                                            bw
                                                                            
                                                                            .. attribute:: unit
                                                                            
                                                                            	unit
                                                                            	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                            
                                                                            .. attribute:: value
                                                                            
                                                                            	value
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, self).__init__()

                                                                                self.yang_name = "bw"
                                                                                self.yang_parent_name = "shape"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {}
                                                                                self._child_list_classes = {}

                                                                                self.unit = YLeaf(YType.enumeration, "unit")

                                                                                self.value = YLeaf(YType.uint32, "value")
                                                                                self._segment_path = lambda: "bw"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Shape.Bw, ['unit', 'value'], name, value)


                                                                    class StopTimer(Entity):
                                                                        """
                                                                        stop timer
                                                                        
                                                                        .. attribute:: timer_name
                                                                        
                                                                        	timer name
                                                                        	**type**\:  str
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, self).__init__()

                                                                            self.yang_name = "stop-timer"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.timer_name = YLeaf(YType.str, "timer-name")
                                                                            self._segment_path = lambda: "stop-timer"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.StopTimer, ['timer_name'], name, value)


                                                                    class TimeoutIdle(Entity):
                                                                        """
                                                                        timeout idle
                                                                        
                                                                        .. attribute:: secs
                                                                        
                                                                        	secs
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, self).__init__()

                                                                            self.yang_name = "timeout-idle"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {}

                                                                            self.secs = YLeaf(YType.uint32, "secs")
                                                                            self._segment_path = lambda: "timeout-idle"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.TimeoutIdle, ['secs'], name, value)


                                                                    class Wred(Entity):
                                                                        """
                                                                        wred
                                                                        
                                                                        .. attribute:: action_wred_info
                                                                        
                                                                        	action wred info
                                                                        	**type**\: list of    :py:class:`ActionWredInfo <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, self).__init__()

                                                                            self.yang_name = "wred"
                                                                            self.yang_parent_name = "actp"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {}
                                                                            self._child_list_classes = {"action-wred-info" : ("action_wred_info", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo)}

                                                                            self.action_wred_info = YList(self)
                                                                            self._segment_path = lambda: "wred"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred, [], name, value)


                                                                        class ActionWredInfo(Entity):
                                                                            """
                                                                            action wred info
                                                                            
                                                                            .. attribute:: match_ranges
                                                                            
                                                                            	match ranges
                                                                            	**type**\:   :py:class:`MatchRanges <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges>`
                                                                            
                                                                            .. attribute:: max_threshold
                                                                            
                                                                            	max threshold
                                                                            	**type**\:   :py:class:`MaxThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold>`
                                                                            
                                                                            .. attribute:: min_threshold
                                                                            
                                                                            	min threshold
                                                                            	**type**\:   :py:class:`MinThreshold <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold>`
                                                                            
                                                                            .. attribute:: probability
                                                                            
                                                                            	probability
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	cos/prec/dscp/ based WRED
                                                                            	**type**\:   :py:class:`WredTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.WredTypeEn>`
                                                                            
                                                                            .. attribute:: wred_flags
                                                                            
                                                                            	wred flags
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..4294967295
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, self).__init__()

                                                                                self.yang_name = "action-wred-info"
                                                                                self.yang_parent_name = "wred"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"match-ranges" : ("match_ranges", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges), "max-threshold" : ("max_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold), "min-threshold" : ("min_threshold", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold)}
                                                                                self._child_list_classes = {}

                                                                                self.probability = YLeaf(YType.uint32, "probability")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.wred_flags = YLeaf(YType.uint32, "wred-flags")

                                                                                self.match_ranges = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges()
                                                                                self.match_ranges.parent = self
                                                                                self._children_name_map["match_ranges"] = "match-ranges"
                                                                                self._children_yang_names.add("match-ranges")

                                                                                self.max_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold()
                                                                                self.max_threshold.parent = self
                                                                                self._children_name_map["max_threshold"] = "max-threshold"
                                                                                self._children_yang_names.add("max-threshold")

                                                                                self.min_threshold = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold()
                                                                                self.min_threshold.parent = self
                                                                                self._children_name_map["min_threshold"] = "min-threshold"
                                                                                self._children_yang_names.add("min-threshold")
                                                                                self._segment_path = lambda: "action-wred-info"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo, ['probability', 'type', 'wred_flags'], name, value)


                                                                            class MatchRanges(Entity):
                                                                                """
                                                                                match ranges
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, self).__init__()

                                                                                    self.yang_name = "match-ranges"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "match-ranges"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "match-ranges"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MatchRanges.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class MaxThreshold(Entity):
                                                                                """
                                                                                max threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, self).__init__()

                                                                                    self.yang_name = "max-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "max-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MaxThreshold, ['unit', 'value'], name, value)


                                                                            class MinThreshold(Entity):
                                                                                """
                                                                                min threshold
                                                                                
                                                                                .. attribute:: unit
                                                                                
                                                                                	unit
                                                                                	**type**\:   :py:class:`PolicyParamUnitType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyParamUnitType>`
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	value
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, self).__init__()

                                                                                    self.yang_name = "min-threshold"
                                                                                    self.yang_parent_name = "action-wred-info"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.unit = YLeaf(YType.enumeration, "unit")

                                                                                    self.value = YLeaf(YType.uint32, "value")
                                                                                    self._segment_path = lambda: "min-threshold"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ActInfop.PolicyActionInfoSt.Actp.Wred.ActionWredInfo.MinThreshold, ['unit', 'value'], name, value)


                                                        class ClEncode(Entity):
                                                            """
                                                            cl encode
                                                            
                                                            .. attribute:: class_name
                                                            
                                                            	class name
                                                            	**type**\:  str
                                                            
                                                            	**length:** 0..65
                                                            
                                                            .. attribute:: enc
                                                            
                                                            	enc
                                                            	**type**\:   :py:class:`PolicyObjEncEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyObjEncEn>`
                                                            
                                                            .. attribute:: hd
                                                            
                                                            	hd
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..18446744073709551615
                                                            
                                                            .. attribute:: idx
                                                            
                                                            	idx
                                                            	**type**\:  int
                                                            
                                                            	**range:** 0..255
                                                            
                                                            .. attribute:: inline_cmap
                                                            
                                                            	inline cmap
                                                            	**type**\:   :py:class:`InlineCmap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, self).__init__()

                                                                self.yang_name = "cl-encode"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {"inline-cmap" : ("inline_cmap", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap)}
                                                                self._child_list_classes = {}

                                                                self.class_name = YLeaf(YType.str, "class-name")

                                                                self.enc = YLeaf(YType.enumeration, "enc")

                                                                self.hd = YLeaf(YType.uint64, "hd")

                                                                self.idx = YLeaf(YType.uint8, "idx")

                                                                self.inline_cmap = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap()
                                                                self.inline_cmap.parent = self
                                                                self._children_name_map["inline_cmap"] = "inline-cmap"
                                                                self._children_yang_names.add("inline-cmap")
                                                                self._segment_path = lambda: "cl-encode"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode, ['class_name', 'enc', 'hd', 'idx'], name, value)


                                                            class InlineCmap(Entity):
                                                                """
                                                                inline cmap
                                                                
                                                                .. attribute:: flags
                                                                
                                                                	Inline Class\-Map flags
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_count
                                                                
                                                                	Number of Match infos
                                                                	**type**\:  int
                                                                
                                                                	**range:** 0..4294967295
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Inline Class\-Map Mode Match any/all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, self).__init__()

                                                                    self.yang_name = "inline-cmap"
                                                                    self.yang_parent_name = "cl-encode"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.flags = YLeaf(YType.uint32, "flags")

                                                                    self.match_count = YLeaf(YType.uint32, "match-count")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "inline-cmap"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap, ['flags', 'match_count', 'mode'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "inline-cmap"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClEncode.InlineCmap.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                                        class ClmpP(Entity):
                                                            """
                                                            clmp p
                                                            
                                                            .. attribute:: class_map_bg
                                                            
                                                            	class map bg
                                                            	**type**\: list of    :py:class:`ClassMapBg <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg>`
                                                            
                                                            

                                                            """

                                                            _prefix = 'infra-policymgr-oper'
                                                            _revision = '2017-05-27'

                                                            def __init__(self):
                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, self).__init__()

                                                                self.yang_name = "clmp-p"
                                                                self.yang_parent_name = "policy-class-info-bg"
                                                                self.is_top_level_class = False
                                                                self.has_list_ancestor = True
                                                                self._child_container_classes = {}
                                                                self._child_list_classes = {"class-map-bg" : ("class_map_bg", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg)}

                                                                self.class_map_bg = YList(self)
                                                                self._segment_path = lambda: "clmp-p"

                                                            def __setattr__(self, name, value):
                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP, [], name, value)


                                                            class ClassMapBg(Entity):
                                                                """
                                                                class map bg
                                                                
                                                                .. attribute:: description
                                                                
                                                                	description
                                                                	**type**\:  str
                                                                
                                                                .. attribute:: match_infop
                                                                
                                                                	Pointer to the first Match info
                                                                	**type**\:   :py:class:`MatchInfop <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop>`
                                                                
                                                                .. attribute:: mode
                                                                
                                                                	Class\-Map Mode Match any/Match all
                                                                	**type**\:   :py:class:`ClassMapModeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapModeEn>`
                                                                
                                                                .. attribute:: name
                                                                
                                                                	Name of the class\-map
                                                                	**type**\:  str
                                                                
                                                                	**length:** 0..65
                                                                
                                                                .. attribute:: type
                                                                
                                                                	Class\-Map Type QoS/PBR/Netflow/..
                                                                	**type**\:   :py:class:`ClassMapTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.ClassMapTypeEn>`
                                                                
                                                                

                                                                """

                                                                _prefix = 'infra-policymgr-oper'
                                                                _revision = '2017-05-27'

                                                                def __init__(self):
                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, self).__init__()

                                                                    self.yang_name = "class-map-bg"
                                                                    self.yang_parent_name = "clmp-p"
                                                                    self.is_top_level_class = False
                                                                    self.has_list_ancestor = True
                                                                    self._child_container_classes = {"match-infop" : ("match_infop", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop)}
                                                                    self._child_list_classes = {}

                                                                    self.description = YLeaf(YType.str, "description")

                                                                    self.mode = YLeaf(YType.enumeration, "mode")

                                                                    self.name = YLeaf(YType.str, "name")

                                                                    self.type = YLeaf(YType.enumeration, "type")

                                                                    self.match_infop = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop()
                                                                    self.match_infop.parent = self
                                                                    self._children_name_map["match_infop"] = "match-infop"
                                                                    self._children_yang_names.add("match-infop")
                                                                    self._segment_path = lambda: "class-map-bg"

                                                                def __setattr__(self, name, value):
                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg, ['description', 'mode', 'name', 'type'], name, value)


                                                                class MatchInfop(Entity):
                                                                    """
                                                                    Pointer to the first Match info
                                                                    
                                                                    .. attribute:: class_match_info_st
                                                                    
                                                                    	class match info st
                                                                    	**type**\: list of    :py:class:`ClassMatchInfoSt <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt>`
                                                                    
                                                                    

                                                                    """

                                                                    _prefix = 'infra-policymgr-oper'
                                                                    _revision = '2017-05-27'

                                                                    def __init__(self):
                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, self).__init__()

                                                                        self.yang_name = "match-infop"
                                                                        self.yang_parent_name = "class-map-bg"
                                                                        self.is_top_level_class = False
                                                                        self.has_list_ancestor = True
                                                                        self._child_container_classes = {}
                                                                        self._child_list_classes = {"class-match-info-st" : ("class_match_info_st", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt)}

                                                                        self.class_match_info_st = YList(self)
                                                                        self._segment_path = lambda: "match-infop"

                                                                    def __setattr__(self, name, value):
                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop, [], name, value)


                                                                    class ClassMatchInfoSt(Entity):
                                                                        """
                                                                        class match info st
                                                                        
                                                                        .. attribute:: flags
                                                                        
                                                                        	Flags
                                                                        	**type**\:  int
                                                                        
                                                                        	**range:** 0..4294967295
                                                                        
                                                                        .. attribute:: match_data
                                                                        
                                                                        	Match criteria
                                                                        	**type**\:   :py:class:`MatchData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData>`
                                                                        
                                                                        

                                                                        """

                                                                        _prefix = 'infra-policymgr-oper'
                                                                        _revision = '2017-05-27'

                                                                        def __init__(self):
                                                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, self).__init__()

                                                                            self.yang_name = "class-match-info-st"
                                                                            self.yang_parent_name = "match-infop"
                                                                            self.is_top_level_class = False
                                                                            self.has_list_ancestor = True
                                                                            self._child_container_classes = {"match-data" : ("match_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData)}
                                                                            self._child_list_classes = {}

                                                                            self.flags = YLeaf(YType.uint32, "flags")

                                                                            self.match_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData()
                                                                            self.match_data.parent = self
                                                                            self._children_name_map["match_data"] = "match-data"
                                                                            self._children_yang_names.add("match-data")
                                                                            self._segment_path = lambda: "class-match-info-st"

                                                                        def __setattr__(self, name, value):
                                                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt, ['flags'], name, value)


                                                                        class MatchData(Entity):
                                                                            """
                                                                            Match criteria
                                                                            
                                                                            .. attribute:: access_interface
                                                                            
                                                                            	Access interface
                                                                            	**type**\:   :py:class:`AccessInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface>`
                                                                            
                                                                            .. attribute:: atm_clp
                                                                            
                                                                            	Match ATM CLP level
                                                                            	**type**\:   :py:class:`AtmClp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp>`
                                                                            
                                                                            .. attribute:: auth_domain
                                                                            
                                                                            	Authenticated domain name
                                                                            	**type**\:   :py:class:`AuthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain>`
                                                                            
                                                                            .. attribute:: auth_domain_regex
                                                                            
                                                                            	Authenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`AuthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex>`
                                                                            
                                                                            .. attribute:: auth_username
                                                                            
                                                                            	Authenticated User Name
                                                                            	**type**\:   :py:class:`AuthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername>`
                                                                            
                                                                            .. attribute:: auth_username_regex
                                                                            
                                                                            	Authenticated User Name RegEx
                                                                            	**type**\:   :py:class:`AuthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex>`
                                                                            
                                                                            .. attribute:: authen_status
                                                                            
                                                                            	Authentication Status
                                                                            	**type**\:   :py:class:`MatchAuthenStatusEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchAuthenStatusEn>`
                                                                            
                                                                            .. attribute:: avail_id
                                                                            
                                                                            	Available Identifiers
                                                                            	**type**\:   :py:class:`AvailId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId>`
                                                                            
                                                                            .. attribute:: circuit_id
                                                                            
                                                                            	Circuit ID
                                                                            	**type**\:   :py:class:`CircuitId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId>`
                                                                            
                                                                            .. attribute:: circuit_id_regex
                                                                            
                                                                            	Circuit ID RegEx
                                                                            	**type**\:   :py:class:`CircuitIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex>`
                                                                            
                                                                            .. attribute:: cos
                                                                            
                                                                            	Match CoS array
                                                                            	**type**\:   :py:class:`Cos <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos>`
                                                                            
                                                                            .. attribute:: cos_inr
                                                                            
                                                                            	Match inner header CoS
                                                                            	**type**\:   :py:class:`CosInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr>`
                                                                            
                                                                            .. attribute:: dei
                                                                            
                                                                            	Match DEI Bit
                                                                            	**type**\:   :py:class:`Dei <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei>`
                                                                            
                                                                            .. attribute:: dei_inr
                                                                            
                                                                            	Match inner DEI Bit
                                                                            	**type**\:   :py:class:`DeiInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr>`
                                                                            
                                                                            .. attribute:: dhcp_client_id
                                                                            
                                                                            	Dhcp Client ID
                                                                            	**type**\:   :py:class:`DhcpClientId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId>`
                                                                            
                                                                            .. attribute:: dhcp_client_id_regex
                                                                            
                                                                            	Dhcp Client ID RegEx
                                                                            	**type**\:   :py:class:`DhcpClientIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex>`
                                                                            
                                                                            .. attribute:: discard_class
                                                                            
                                                                            	Match Discard Class array
                                                                            	**type**\:   :py:class:`DiscardClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass>`
                                                                            
                                                                            .. attribute:: dnis
                                                                            
                                                                            	DNIS
                                                                            	**type**\:   :py:class:`Dnis <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis>`
                                                                            
                                                                            .. attribute:: dnis_regex
                                                                            
                                                                            	DNIS Regular Expression
                                                                            	**type**\:   :py:class:`DnisRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex>`
                                                                            
                                                                            .. attribute:: domain
                                                                            
                                                                            	Domain Name
                                                                            	**type**\:   :py:class:`Domain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain>`
                                                                            
                                                                            .. attribute:: domain_regex
                                                                            
                                                                            	Domain Regular Expression
                                                                            	**type**\:   :py:class:`DomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex>`
                                                                            
                                                                            .. attribute:: dscp
                                                                            
                                                                            	Match DSCP range array
                                                                            	**type**\:   :py:class:`Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv4
                                                                            
                                                                            	Destination Address IPV4
                                                                            	**type**\:   :py:class:`DstAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4>`
                                                                            
                                                                            .. attribute:: dst_addr_ipv6
                                                                            
                                                                            	Destination Address IPV6
                                                                            	**type**\:   :py:class:`DstAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6>`
                                                                            
                                                                            .. attribute:: dst_mac
                                                                            
                                                                            	Match Destination MAC address
                                                                            	**type**\:   :py:class:`DstMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac>`
                                                                            
                                                                            .. attribute:: dst_port
                                                                            
                                                                            	Destination port
                                                                            	**type**\:   :py:class:`DstPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort>`
                                                                            
                                                                            .. attribute:: ether_service_acl
                                                                            
                                                                            	Ethernet\-Services Access\-list
                                                                            	**type**\:   :py:class:`EtherServiceAcl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl>`
                                                                            
                                                                            .. attribute:: ethertype
                                                                            
                                                                            	Ethernet type
                                                                            	**type**\:   :py:class:`Ethertype <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype>`
                                                                            
                                                                            .. attribute:: flow_key_data
                                                                            
                                                                            	Flow key structure
                                                                            	**type**\:   :py:class:`FlowKeyData <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData>`
                                                                            
                                                                            .. attribute:: flow_tag
                                                                            
                                                                            	Match flow\-tag array
                                                                            	**type**\:   :py:class:`FlowTag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag>`
                                                                            
                                                                            .. attribute:: fr_de
                                                                            
                                                                            	Match FR DE value
                                                                            	**type**\:   :py:class:`FrDe <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe>`
                                                                            
                                                                            .. attribute:: fr_dlci
                                                                            
                                                                            	Match FR DLCI range array
                                                                            	**type**\:   :py:class:`FrDlci <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci>`
                                                                            
                                                                            .. attribute:: fragment_type
                                                                            
                                                                            	Fragment type
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: icmp_v4
                                                                            
                                                                            	Match ICMPV4 Protocol
                                                                            	**type**\:   :py:class:`IcmpV4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4>`
                                                                            
                                                                            .. attribute:: icmp_v6
                                                                            
                                                                            	Match ICMPV6 Protocol array
                                                                            	**type**\:   :py:class:`IcmpV6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6>`
                                                                            
                                                                            .. attribute:: icmpv4_code
                                                                            
                                                                            	Match ipv4 icmp code
                                                                            	**type**\:   :py:class:`Icmpv4Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code>`
                                                                            
                                                                            .. attribute:: icmpv4_type
                                                                            
                                                                            	Match ipv4 icmp type
                                                                            	**type**\:   :py:class:`Icmpv4Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type>`
                                                                            
                                                                            .. attribute:: icmpv6_code
                                                                            
                                                                            	Match ipv6 icmp code
                                                                            	**type**\:   :py:class:`Icmpv6Code <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code>`
                                                                            
                                                                            .. attribute:: icmpv6_type
                                                                            
                                                                            	Match ipv6 icmp type
                                                                            	**type**\:   :py:class:`Icmpv6Type <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type>`
                                                                            
                                                                            .. attribute:: input_interface
                                                                            
                                                                            	Input interface
                                                                            	**type**\:   :py:class:`InputInterface <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface>`
                                                                            
                                                                            .. attribute:: input_intfhdl
                                                                            
                                                                            	Input interface handle
                                                                            	**type**\:   :py:class:`InputIntfhdl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl>`
                                                                            
                                                                            .. attribute:: ipv4_acl
                                                                            
                                                                            	IPv4 Access\-list
                                                                            	**type**\:   :py:class:`Ipv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl>`
                                                                            
                                                                            .. attribute:: ipv4_dscp
                                                                            
                                                                            	IPv4 DSCP
                                                                            	**type**\:   :py:class:`Ipv4Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp>`
                                                                            
                                                                            .. attribute:: ipv4_packet_len
                                                                            
                                                                            	IPv4 packet length array
                                                                            	**type**\:   :py:class:`Ipv4PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen>`
                                                                            
                                                                            .. attribute:: ipv4_prec
                                                                            
                                                                            	IPv4 Precedence
                                                                            	**type**\:   :py:class:`Ipv4Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec>`
                                                                            
                                                                            .. attribute:: ipv6_acl
                                                                            
                                                                            	IPv6 Access\-list
                                                                            	**type**\:   :py:class:`Ipv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl>`
                                                                            
                                                                            .. attribute:: ipv6_dscp
                                                                            
                                                                            	IPv6 DSCP
                                                                            	**type**\:   :py:class:`Ipv6Dscp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp>`
                                                                            
                                                                            .. attribute:: ipv6_packet_len
                                                                            
                                                                            	IPv6 packet length array
                                                                            	**type**\:   :py:class:`Ipv6PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen>`
                                                                            
                                                                            .. attribute:: ipv6_prec
                                                                            
                                                                            	IPv6 Precedence
                                                                            	**type**\:   :py:class:`Ipv6Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec>`
                                                                            
                                                                            .. attribute:: media_type
                                                                            
                                                                            	Media Type
                                                                            	**type**\:   :py:class:`MediaType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType>`
                                                                            
                                                                            .. attribute:: mlp_negotiated
                                                                            
                                                                            	MLP Negotiated
                                                                            	**type**\:   :py:class:`MatchMlpNegotiatedEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchMlpNegotiatedEn>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv4_acl
                                                                            
                                                                            	MPLS Disposition IPv4 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv4Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl>`
                                                                            
                                                                            .. attribute:: mpls_disp_ipv6_acl
                                                                            
                                                                            	MPLS Disposition IPv6 Access\-list
                                                                            	**type**\:   :py:class:`MplsDispIpv6Acl <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl>`
                                                                            
                                                                            .. attribute:: mpls_exp
                                                                            
                                                                            	Match MPLS experimental topmost array
                                                                            	**type**\:   :py:class:`MplsExp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp>`
                                                                            
                                                                            .. attribute:: mpls_exp_imp
                                                                            
                                                                            	Match MPLS experimental imposition array
                                                                            	**type**\:   :py:class:`MplsExpImp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp>`
                                                                            
                                                                            .. attribute:: mpls_top_eos
                                                                            
                                                                            	MPLS Topmost EOS
                                                                            	**type**\:  int
                                                                            
                                                                            	**range:** 0..255
                                                                            
                                                                            .. attribute:: mpls_top_label
                                                                            
                                                                            	MPLS Topmost LABEL
                                                                            	**type**\:   :py:class:`MplsTopLabel <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel>`
                                                                            
                                                                            .. attribute:: nas_port
                                                                            
                                                                            	NAS Port
                                                                            	**type**\:   :py:class:`NasPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort>`
                                                                            
                                                                            .. attribute:: packet_len
                                                                            
                                                                            	Match packet length array
                                                                            	**type**\:   :py:class:`PacketLen <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen>`
                                                                            
                                                                            .. attribute:: prec
                                                                            
                                                                            	Match Precedence array
                                                                            	**type**\:   :py:class:`Prec <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec>`
                                                                            
                                                                            .. attribute:: proto
                                                                            
                                                                            	Match Protocol array
                                                                            	**type**\:   :py:class:`Proto <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto>`
                                                                            
                                                                            .. attribute:: qos_group
                                                                            
                                                                            	Match QoS group array
                                                                            	**type**\:   :py:class:`QosGroup <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup>`
                                                                            
                                                                            .. attribute:: remote_id
                                                                            
                                                                            	Remote ID
                                                                            	**type**\:   :py:class:`RemoteId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId>`
                                                                            
                                                                            .. attribute:: remote_id_regex
                                                                            
                                                                            	Remote ID RegEx
                                                                            	**type**\:   :py:class:`RemoteIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex>`
                                                                            
                                                                            .. attribute:: service_name
                                                                            
                                                                            	Service Name
                                                                            	**type**\:   :py:class:`ServiceName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName>`
                                                                            
                                                                            .. attribute:: service_name_regex
                                                                            
                                                                            	Service Name Regular Exp
                                                                            	**type**\:   :py:class:`ServiceNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex>`
                                                                            
                                                                            .. attribute:: src_addr_ipv4
                                                                            
                                                                            	Source Address IPV4
                                                                            	**type**\:   :py:class:`SrcAddrIpv4 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4>`
                                                                            
                                                                            .. attribute:: src_addr_ipv6
                                                                            
                                                                            	Source Address IPV6
                                                                            	**type**\:   :py:class:`SrcAddrIpv6 <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6>`
                                                                            
                                                                            .. attribute:: src_addr_mac
                                                                            
                                                                            	Source Address MAC
                                                                            	**type**\:   :py:class:`SrcAddrMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac>`
                                                                            
                                                                            .. attribute:: src_mac
                                                                            
                                                                            	Match Source MAC address
                                                                            	**type**\:   :py:class:`SrcMac <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac>`
                                                                            
                                                                            .. attribute:: src_port
                                                                            
                                                                            	Source port
                                                                            	**type**\:   :py:class:`SrcPort <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort>`
                                                                            
                                                                            .. attribute:: subs_protocol
                                                                            
                                                                            	Protocol
                                                                            	**type**\:   :py:class:`SubsProtocol <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol>`
                                                                            
                                                                            .. attribute:: tcp_flag
                                                                            
                                                                            	Match tcp flag value
                                                                            	**type**\:   :py:class:`TcpFlag <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag>`
                                                                            
                                                                            .. attribute:: timer
                                                                            
                                                                            	Timer
                                                                            	**type**\:   :py:class:`Timer <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer>`
                                                                            
                                                                            .. attribute:: timer_regexp
                                                                            
                                                                            	Timer Regular Expression
                                                                            	**type**\:   :py:class:`TimerRegexp <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp>`
                                                                            
                                                                            .. attribute:: traffic_class
                                                                            
                                                                            	Match Traffic class array
                                                                            	**type**\:   :py:class:`TrafficClass <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass>`
                                                                            
                                                                            .. attribute:: tunnel_name
                                                                            
                                                                            	Tunnel Name
                                                                            	**type**\:   :py:class:`TunnelName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName>`
                                                                            
                                                                            .. attribute:: tunnel_name_regex
                                                                            
                                                                            	Tunnel Name Regular Expression
                                                                            	**type**\:   :py:class:`TunnelNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex>`
                                                                            
                                                                            .. attribute:: type
                                                                            
                                                                            	type
                                                                            	**type**\:   :py:class:`MatchTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchTypeEn>`
                                                                            
                                                                            .. attribute:: unauth_domain
                                                                            
                                                                            	Unauthenticated Domain Name
                                                                            	**type**\:   :py:class:`UnauthDomain <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain>`
                                                                            
                                                                            .. attribute:: unauth_domain_regex
                                                                            
                                                                            	Unauthenticated Domain Name RegEx
                                                                            	**type**\:   :py:class:`UnauthDomainRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex>`
                                                                            
                                                                            .. attribute:: unauth_username
                                                                            
                                                                            	Unauthenticated User Name
                                                                            	**type**\:   :py:class:`UnauthUsername <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername>`
                                                                            
                                                                            .. attribute:: unauth_username_regex
                                                                            
                                                                            	Unauthenticated User Name RegEx
                                                                            	**type**\:   :py:class:`UnauthUsernameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex>`
                                                                            
                                                                            .. attribute:: user_name
                                                                            
                                                                            	User Name
                                                                            	**type**\:   :py:class:`UserName <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName>`
                                                                            
                                                                            .. attribute:: user_name_regex
                                                                            
                                                                            	User Name Regular Expression
                                                                            	**type**\:   :py:class:`UserNameRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex>`
                                                                            
                                                                            .. attribute:: vendor_id
                                                                            
                                                                            	Vendor ID
                                                                            	**type**\:   :py:class:`VendorId <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId>`
                                                                            
                                                                            .. attribute:: vendor_id_regex
                                                                            
                                                                            	Vendor ID RegEx
                                                                            	**type**\:   :py:class:`VendorIdRegex <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex>`
                                                                            
                                                                            .. attribute:: vlan
                                                                            
                                                                            	Match VLAN array
                                                                            	**type**\:   :py:class:`Vlan <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan>`
                                                                            
                                                                            .. attribute:: vlan_inr
                                                                            
                                                                            	Match inner header VLAN range array
                                                                            	**type**\:   :py:class:`VlanInr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr>`
                                                                            
                                                                            

                                                                            """

                                                                            _prefix = 'infra-policymgr-oper'
                                                                            _revision = '2017-05-27'

                                                                            def __init__(self):
                                                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, self).__init__()

                                                                                self.yang_name = "match-data"
                                                                                self.yang_parent_name = "class-match-info-st"
                                                                                self.is_top_level_class = False
                                                                                self.has_list_ancestor = True
                                                                                self._child_container_classes = {"access-interface" : ("access_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface), "atm-clp" : ("atm_clp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp), "auth-domain" : ("auth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain), "auth-domain-regex" : ("auth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex), "auth-username" : ("auth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername), "auth-username-regex" : ("auth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex), "avail-id" : ("avail_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId), "circuit-id" : ("circuit_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId), "circuit-id-regex" : ("circuit_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex), "cos" : ("cos", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos), "cos-inr" : ("cos_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr), "dei" : ("dei", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei), "dei-inr" : ("dei_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr), "dhcp-client-id" : ("dhcp_client_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId), "dhcp-client-id-regex" : ("dhcp_client_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex), "discard-class" : ("discard_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass), "dnis" : ("dnis", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis), "dnis-regex" : ("dnis_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex), "domain" : ("domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain), "domain-regex" : ("domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex), "dscp" : ("dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp), "dst-addr-ipv4" : ("dst_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4), "dst-addr-ipv6" : ("dst_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6), "dst-mac" : ("dst_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac), "dst-port" : ("dst_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort), "ether-service-acl" : ("ether_service_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl), "ethertype" : ("ethertype", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype), "flow-key-data" : ("flow_key_data", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData), "flow-tag" : ("flow_tag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag), "fr-de" : ("fr_de", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe), "fr-dlci" : ("fr_dlci", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci), "icmp-v4" : ("icmp_v4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4), "icmp-v6" : ("icmp_v6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6), "icmpv4-code" : ("icmpv4_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code), "icmpv4-type" : ("icmpv4_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type), "icmpv6-code" : ("icmpv6_code", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code), "icmpv6-type" : ("icmpv6_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type), "input-interface" : ("input_interface", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface), "input-intfhdl" : ("input_intfhdl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl), "ipv4-acl" : ("ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl), "ipv4-dscp" : ("ipv4_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp), "ipv4-packet-len" : ("ipv4_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen), "ipv4-prec" : ("ipv4_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec), "ipv6-acl" : ("ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl), "ipv6-dscp" : ("ipv6_dscp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp), "ipv6-packet-len" : ("ipv6_packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen), "ipv6-prec" : ("ipv6_prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec), "media-type" : ("media_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType), "mpls-disp-ipv4-acl" : ("mpls_disp_ipv4_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl), "mpls-disp-ipv6-acl" : ("mpls_disp_ipv6_acl", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl), "mpls-exp" : ("mpls_exp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp), "mpls-exp-imp" : ("mpls_exp_imp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp), "mpls-top-label" : ("mpls_top_label", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel), "nas-port" : ("nas_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort), "packet-len" : ("packet_len", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen), "prec" : ("prec", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec), "proto" : ("proto", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto), "qos-group" : ("qos_group", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup), "remote-id" : ("remote_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId), "remote-id-regex" : ("remote_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex), "service-name" : ("service_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName), "service-name-regex" : ("service_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex), "src-addr-ipv4" : ("src_addr_ipv4", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4), "src-addr-ipv6" : ("src_addr_ipv6", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6), "src-addr-mac" : ("src_addr_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac), "src-mac" : ("src_mac", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac), "src-port" : ("src_port", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort), "subs-protocol" : ("subs_protocol", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol), "tcp-flag" : ("tcp_flag", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag), "timer" : ("timer", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer), "timer-regexp" : ("timer_regexp", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp), "traffic-class" : ("traffic_class", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass), "tunnel-name" : ("tunnel_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName), "tunnel-name-regex" : ("tunnel_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex), "unauth-domain" : ("unauth_domain", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain), "unauth-domain-regex" : ("unauth_domain_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex), "unauth-username" : ("unauth_username", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername), "unauth-username-regex" : ("unauth_username_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex), "user-name" : ("user_name", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName), "user-name-regex" : ("user_name_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex), "vendor-id" : ("vendor_id", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId), "vendor-id-regex" : ("vendor_id_regex", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex), "vlan" : ("vlan", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan), "vlan-inr" : ("vlan_inr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr)}
                                                                                self._child_list_classes = {}

                                                                                self.authen_status = YLeaf(YType.enumeration, "authen-status")

                                                                                self.fragment_type = YLeaf(YType.uint8, "fragment-type")

                                                                                self.mlp_negotiated = YLeaf(YType.enumeration, "mlp-negotiated")

                                                                                self.mpls_top_eos = YLeaf(YType.uint8, "mpls-top-eos")

                                                                                self.type = YLeaf(YType.enumeration, "type")

                                                                                self.access_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface()
                                                                                self.access_interface.parent = self
                                                                                self._children_name_map["access_interface"] = "access-interface"
                                                                                self._children_yang_names.add("access-interface")

                                                                                self.atm_clp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp()
                                                                                self.atm_clp.parent = self
                                                                                self._children_name_map["atm_clp"] = "atm-clp"
                                                                                self._children_yang_names.add("atm-clp")

                                                                                self.auth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain()
                                                                                self.auth_domain.parent = self
                                                                                self._children_name_map["auth_domain"] = "auth-domain"
                                                                                self._children_yang_names.add("auth-domain")

                                                                                self.auth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex()
                                                                                self.auth_domain_regex.parent = self
                                                                                self._children_name_map["auth_domain_regex"] = "auth-domain-regex"
                                                                                self._children_yang_names.add("auth-domain-regex")

                                                                                self.auth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername()
                                                                                self.auth_username.parent = self
                                                                                self._children_name_map["auth_username"] = "auth-username"
                                                                                self._children_yang_names.add("auth-username")

                                                                                self.auth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex()
                                                                                self.auth_username_regex.parent = self
                                                                                self._children_name_map["auth_username_regex"] = "auth-username-regex"
                                                                                self._children_yang_names.add("auth-username-regex")

                                                                                self.avail_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId()
                                                                                self.avail_id.parent = self
                                                                                self._children_name_map["avail_id"] = "avail-id"
                                                                                self._children_yang_names.add("avail-id")

                                                                                self.circuit_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId()
                                                                                self.circuit_id.parent = self
                                                                                self._children_name_map["circuit_id"] = "circuit-id"
                                                                                self._children_yang_names.add("circuit-id")

                                                                                self.circuit_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex()
                                                                                self.circuit_id_regex.parent = self
                                                                                self._children_name_map["circuit_id_regex"] = "circuit-id-regex"
                                                                                self._children_yang_names.add("circuit-id-regex")

                                                                                self.cos = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos()
                                                                                self.cos.parent = self
                                                                                self._children_name_map["cos"] = "cos"
                                                                                self._children_yang_names.add("cos")

                                                                                self.cos_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr()
                                                                                self.cos_inr.parent = self
                                                                                self._children_name_map["cos_inr"] = "cos-inr"
                                                                                self._children_yang_names.add("cos-inr")

                                                                                self.dei = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei()
                                                                                self.dei.parent = self
                                                                                self._children_name_map["dei"] = "dei"
                                                                                self._children_yang_names.add("dei")

                                                                                self.dei_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr()
                                                                                self.dei_inr.parent = self
                                                                                self._children_name_map["dei_inr"] = "dei-inr"
                                                                                self._children_yang_names.add("dei-inr")

                                                                                self.dhcp_client_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId()
                                                                                self.dhcp_client_id.parent = self
                                                                                self._children_name_map["dhcp_client_id"] = "dhcp-client-id"
                                                                                self._children_yang_names.add("dhcp-client-id")

                                                                                self.dhcp_client_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex()
                                                                                self.dhcp_client_id_regex.parent = self
                                                                                self._children_name_map["dhcp_client_id_regex"] = "dhcp-client-id-regex"
                                                                                self._children_yang_names.add("dhcp-client-id-regex")

                                                                                self.discard_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass()
                                                                                self.discard_class.parent = self
                                                                                self._children_name_map["discard_class"] = "discard-class"
                                                                                self._children_yang_names.add("discard-class")

                                                                                self.dnis = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis()
                                                                                self.dnis.parent = self
                                                                                self._children_name_map["dnis"] = "dnis"
                                                                                self._children_yang_names.add("dnis")

                                                                                self.dnis_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex()
                                                                                self.dnis_regex.parent = self
                                                                                self._children_name_map["dnis_regex"] = "dnis-regex"
                                                                                self._children_yang_names.add("dnis-regex")

                                                                                self.domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain()
                                                                                self.domain.parent = self
                                                                                self._children_name_map["domain"] = "domain"
                                                                                self._children_yang_names.add("domain")

                                                                                self.domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex()
                                                                                self.domain_regex.parent = self
                                                                                self._children_name_map["domain_regex"] = "domain-regex"
                                                                                self._children_yang_names.add("domain-regex")

                                                                                self.dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp()
                                                                                self.dscp.parent = self
                                                                                self._children_name_map["dscp"] = "dscp"
                                                                                self._children_yang_names.add("dscp")

                                                                                self.dst_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4()
                                                                                self.dst_addr_ipv4.parent = self
                                                                                self._children_name_map["dst_addr_ipv4"] = "dst-addr-ipv4"
                                                                                self._children_yang_names.add("dst-addr-ipv4")

                                                                                self.dst_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6()
                                                                                self.dst_addr_ipv6.parent = self
                                                                                self._children_name_map["dst_addr_ipv6"] = "dst-addr-ipv6"
                                                                                self._children_yang_names.add("dst-addr-ipv6")

                                                                                self.dst_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac()
                                                                                self.dst_mac.parent = self
                                                                                self._children_name_map["dst_mac"] = "dst-mac"
                                                                                self._children_yang_names.add("dst-mac")

                                                                                self.dst_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort()
                                                                                self.dst_port.parent = self
                                                                                self._children_name_map["dst_port"] = "dst-port"
                                                                                self._children_yang_names.add("dst-port")

                                                                                self.ether_service_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl()
                                                                                self.ether_service_acl.parent = self
                                                                                self._children_name_map["ether_service_acl"] = "ether-service-acl"
                                                                                self._children_yang_names.add("ether-service-acl")

                                                                                self.ethertype = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype()
                                                                                self.ethertype.parent = self
                                                                                self._children_name_map["ethertype"] = "ethertype"
                                                                                self._children_yang_names.add("ethertype")

                                                                                self.flow_key_data = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData()
                                                                                self.flow_key_data.parent = self
                                                                                self._children_name_map["flow_key_data"] = "flow-key-data"
                                                                                self._children_yang_names.add("flow-key-data")

                                                                                self.flow_tag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag()
                                                                                self.flow_tag.parent = self
                                                                                self._children_name_map["flow_tag"] = "flow-tag"
                                                                                self._children_yang_names.add("flow-tag")

                                                                                self.fr_de = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe()
                                                                                self.fr_de.parent = self
                                                                                self._children_name_map["fr_de"] = "fr-de"
                                                                                self._children_yang_names.add("fr-de")

                                                                                self.fr_dlci = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci()
                                                                                self.fr_dlci.parent = self
                                                                                self._children_name_map["fr_dlci"] = "fr-dlci"
                                                                                self._children_yang_names.add("fr-dlci")

                                                                                self.icmp_v4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4()
                                                                                self.icmp_v4.parent = self
                                                                                self._children_name_map["icmp_v4"] = "icmp-v4"
                                                                                self._children_yang_names.add("icmp-v4")

                                                                                self.icmp_v6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6()
                                                                                self.icmp_v6.parent = self
                                                                                self._children_name_map["icmp_v6"] = "icmp-v6"
                                                                                self._children_yang_names.add("icmp-v6")

                                                                                self.icmpv4_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code()
                                                                                self.icmpv4_code.parent = self
                                                                                self._children_name_map["icmpv4_code"] = "icmpv4-code"
                                                                                self._children_yang_names.add("icmpv4-code")

                                                                                self.icmpv4_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type()
                                                                                self.icmpv4_type.parent = self
                                                                                self._children_name_map["icmpv4_type"] = "icmpv4-type"
                                                                                self._children_yang_names.add("icmpv4-type")

                                                                                self.icmpv6_code = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code()
                                                                                self.icmpv6_code.parent = self
                                                                                self._children_name_map["icmpv6_code"] = "icmpv6-code"
                                                                                self._children_yang_names.add("icmpv6-code")

                                                                                self.icmpv6_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type()
                                                                                self.icmpv6_type.parent = self
                                                                                self._children_name_map["icmpv6_type"] = "icmpv6-type"
                                                                                self._children_yang_names.add("icmpv6-type")

                                                                                self.input_interface = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface()
                                                                                self.input_interface.parent = self
                                                                                self._children_name_map["input_interface"] = "input-interface"
                                                                                self._children_yang_names.add("input-interface")

                                                                                self.input_intfhdl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl()
                                                                                self.input_intfhdl.parent = self
                                                                                self._children_name_map["input_intfhdl"] = "input-intfhdl"
                                                                                self._children_yang_names.add("input-intfhdl")

                                                                                self.ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl()
                                                                                self.ipv4_acl.parent = self
                                                                                self._children_name_map["ipv4_acl"] = "ipv4-acl"
                                                                                self._children_yang_names.add("ipv4-acl")

                                                                                self.ipv4_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp()
                                                                                self.ipv4_dscp.parent = self
                                                                                self._children_name_map["ipv4_dscp"] = "ipv4-dscp"
                                                                                self._children_yang_names.add("ipv4-dscp")

                                                                                self.ipv4_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen()
                                                                                self.ipv4_packet_len.parent = self
                                                                                self._children_name_map["ipv4_packet_len"] = "ipv4-packet-len"
                                                                                self._children_yang_names.add("ipv4-packet-len")

                                                                                self.ipv4_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec()
                                                                                self.ipv4_prec.parent = self
                                                                                self._children_name_map["ipv4_prec"] = "ipv4-prec"
                                                                                self._children_yang_names.add("ipv4-prec")

                                                                                self.ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl()
                                                                                self.ipv6_acl.parent = self
                                                                                self._children_name_map["ipv6_acl"] = "ipv6-acl"
                                                                                self._children_yang_names.add("ipv6-acl")

                                                                                self.ipv6_dscp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp()
                                                                                self.ipv6_dscp.parent = self
                                                                                self._children_name_map["ipv6_dscp"] = "ipv6-dscp"
                                                                                self._children_yang_names.add("ipv6-dscp")

                                                                                self.ipv6_packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen()
                                                                                self.ipv6_packet_len.parent = self
                                                                                self._children_name_map["ipv6_packet_len"] = "ipv6-packet-len"
                                                                                self._children_yang_names.add("ipv6-packet-len")

                                                                                self.ipv6_prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec()
                                                                                self.ipv6_prec.parent = self
                                                                                self._children_name_map["ipv6_prec"] = "ipv6-prec"
                                                                                self._children_yang_names.add("ipv6-prec")

                                                                                self.media_type = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType()
                                                                                self.media_type.parent = self
                                                                                self._children_name_map["media_type"] = "media-type"
                                                                                self._children_yang_names.add("media-type")

                                                                                self.mpls_disp_ipv4_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl()
                                                                                self.mpls_disp_ipv4_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv4_acl"] = "mpls-disp-ipv4-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv4-acl")

                                                                                self.mpls_disp_ipv6_acl = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl()
                                                                                self.mpls_disp_ipv6_acl.parent = self
                                                                                self._children_name_map["mpls_disp_ipv6_acl"] = "mpls-disp-ipv6-acl"
                                                                                self._children_yang_names.add("mpls-disp-ipv6-acl")

                                                                                self.mpls_exp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp()
                                                                                self.mpls_exp.parent = self
                                                                                self._children_name_map["mpls_exp"] = "mpls-exp"
                                                                                self._children_yang_names.add("mpls-exp")

                                                                                self.mpls_exp_imp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp()
                                                                                self.mpls_exp_imp.parent = self
                                                                                self._children_name_map["mpls_exp_imp"] = "mpls-exp-imp"
                                                                                self._children_yang_names.add("mpls-exp-imp")

                                                                                self.mpls_top_label = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel()
                                                                                self.mpls_top_label.parent = self
                                                                                self._children_name_map["mpls_top_label"] = "mpls-top-label"
                                                                                self._children_yang_names.add("mpls-top-label")

                                                                                self.nas_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort()
                                                                                self.nas_port.parent = self
                                                                                self._children_name_map["nas_port"] = "nas-port"
                                                                                self._children_yang_names.add("nas-port")

                                                                                self.packet_len = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen()
                                                                                self.packet_len.parent = self
                                                                                self._children_name_map["packet_len"] = "packet-len"
                                                                                self._children_yang_names.add("packet-len")

                                                                                self.prec = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec()
                                                                                self.prec.parent = self
                                                                                self._children_name_map["prec"] = "prec"
                                                                                self._children_yang_names.add("prec")

                                                                                self.proto = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto()
                                                                                self.proto.parent = self
                                                                                self._children_name_map["proto"] = "proto"
                                                                                self._children_yang_names.add("proto")

                                                                                self.qos_group = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup()
                                                                                self.qos_group.parent = self
                                                                                self._children_name_map["qos_group"] = "qos-group"
                                                                                self._children_yang_names.add("qos-group")

                                                                                self.remote_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId()
                                                                                self.remote_id.parent = self
                                                                                self._children_name_map["remote_id"] = "remote-id"
                                                                                self._children_yang_names.add("remote-id")

                                                                                self.remote_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex()
                                                                                self.remote_id_regex.parent = self
                                                                                self._children_name_map["remote_id_regex"] = "remote-id-regex"
                                                                                self._children_yang_names.add("remote-id-regex")

                                                                                self.service_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName()
                                                                                self.service_name.parent = self
                                                                                self._children_name_map["service_name"] = "service-name"
                                                                                self._children_yang_names.add("service-name")

                                                                                self.service_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex()
                                                                                self.service_name_regex.parent = self
                                                                                self._children_name_map["service_name_regex"] = "service-name-regex"
                                                                                self._children_yang_names.add("service-name-regex")

                                                                                self.src_addr_ipv4 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4()
                                                                                self.src_addr_ipv4.parent = self
                                                                                self._children_name_map["src_addr_ipv4"] = "src-addr-ipv4"
                                                                                self._children_yang_names.add("src-addr-ipv4")

                                                                                self.src_addr_ipv6 = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6()
                                                                                self.src_addr_ipv6.parent = self
                                                                                self._children_name_map["src_addr_ipv6"] = "src-addr-ipv6"
                                                                                self._children_yang_names.add("src-addr-ipv6")

                                                                                self.src_addr_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac()
                                                                                self.src_addr_mac.parent = self
                                                                                self._children_name_map["src_addr_mac"] = "src-addr-mac"
                                                                                self._children_yang_names.add("src-addr-mac")

                                                                                self.src_mac = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac()
                                                                                self.src_mac.parent = self
                                                                                self._children_name_map["src_mac"] = "src-mac"
                                                                                self._children_yang_names.add("src-mac")

                                                                                self.src_port = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort()
                                                                                self.src_port.parent = self
                                                                                self._children_name_map["src_port"] = "src-port"
                                                                                self._children_yang_names.add("src-port")

                                                                                self.subs_protocol = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol()
                                                                                self.subs_protocol.parent = self
                                                                                self._children_name_map["subs_protocol"] = "subs-protocol"
                                                                                self._children_yang_names.add("subs-protocol")

                                                                                self.tcp_flag = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag()
                                                                                self.tcp_flag.parent = self
                                                                                self._children_name_map["tcp_flag"] = "tcp-flag"
                                                                                self._children_yang_names.add("tcp-flag")

                                                                                self.timer = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer()
                                                                                self.timer.parent = self
                                                                                self._children_name_map["timer"] = "timer"
                                                                                self._children_yang_names.add("timer")

                                                                                self.timer_regexp = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp()
                                                                                self.timer_regexp.parent = self
                                                                                self._children_name_map["timer_regexp"] = "timer-regexp"
                                                                                self._children_yang_names.add("timer-regexp")

                                                                                self.traffic_class = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass()
                                                                                self.traffic_class.parent = self
                                                                                self._children_name_map["traffic_class"] = "traffic-class"
                                                                                self._children_yang_names.add("traffic-class")

                                                                                self.tunnel_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName()
                                                                                self.tunnel_name.parent = self
                                                                                self._children_name_map["tunnel_name"] = "tunnel-name"
                                                                                self._children_yang_names.add("tunnel-name")

                                                                                self.tunnel_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex()
                                                                                self.tunnel_name_regex.parent = self
                                                                                self._children_name_map["tunnel_name_regex"] = "tunnel-name-regex"
                                                                                self._children_yang_names.add("tunnel-name-regex")

                                                                                self.unauth_domain = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain()
                                                                                self.unauth_domain.parent = self
                                                                                self._children_name_map["unauth_domain"] = "unauth-domain"
                                                                                self._children_yang_names.add("unauth-domain")

                                                                                self.unauth_domain_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex()
                                                                                self.unauth_domain_regex.parent = self
                                                                                self._children_name_map["unauth_domain_regex"] = "unauth-domain-regex"
                                                                                self._children_yang_names.add("unauth-domain-regex")

                                                                                self.unauth_username = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername()
                                                                                self.unauth_username.parent = self
                                                                                self._children_name_map["unauth_username"] = "unauth-username"
                                                                                self._children_yang_names.add("unauth-username")

                                                                                self.unauth_username_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex()
                                                                                self.unauth_username_regex.parent = self
                                                                                self._children_name_map["unauth_username_regex"] = "unauth-username-regex"
                                                                                self._children_yang_names.add("unauth-username-regex")

                                                                                self.user_name = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName()
                                                                                self.user_name.parent = self
                                                                                self._children_name_map["user_name"] = "user-name"
                                                                                self._children_yang_names.add("user-name")

                                                                                self.user_name_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex()
                                                                                self.user_name_regex.parent = self
                                                                                self._children_name_map["user_name_regex"] = "user-name-regex"
                                                                                self._children_yang_names.add("user-name-regex")

                                                                                self.vendor_id = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId()
                                                                                self.vendor_id.parent = self
                                                                                self._children_name_map["vendor_id"] = "vendor-id"
                                                                                self._children_yang_names.add("vendor-id")

                                                                                self.vendor_id_regex = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex()
                                                                                self.vendor_id_regex.parent = self
                                                                                self._children_name_map["vendor_id_regex"] = "vendor-id-regex"
                                                                                self._children_yang_names.add("vendor-id-regex")

                                                                                self.vlan = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan()
                                                                                self.vlan.parent = self
                                                                                self._children_name_map["vlan"] = "vlan"
                                                                                self._children_yang_names.add("vlan")

                                                                                self.vlan_inr = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr()
                                                                                self.vlan_inr.parent = self
                                                                                self._children_name_map["vlan_inr"] = "vlan-inr"
                                                                                self._children_yang_names.add("vlan-inr")
                                                                                self._segment_path = lambda: "match-data"

                                                                            def __setattr__(self, name, value):
                                                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData, ['authen_status', 'fragment_type', 'mlp_negotiated', 'mpls_top_eos', 'type'], name, value)


                                                                            class AccessInterface(Entity):
                                                                                """
                                                                                Access interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, self).__init__()

                                                                                    self.yang_name = "access-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "access-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AccessInterface, ['string_array'], name, value)


                                                                            class AtmClp(Entity):
                                                                                """
                                                                                Match ATM CLP level
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, self).__init__()

                                                                                    self.yang_name = "atm-clp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "atm-clp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AtmClp, ['uint8_array'], name, value)


                                                                            class AuthDomain(Entity):
                                                                                """
                                                                                Authenticated domain name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, self).__init__()

                                                                                    self.yang_name = "auth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomain, ['string_array'], name, value)


                                                                            class AuthDomainRegex(Entity):
                                                                                """
                                                                                Authenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, self).__init__()

                                                                                    self.yang_name = "auth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthDomainRegex, ['string_array'], name, value)


                                                                            class AuthUsername(Entity):
                                                                                """
                                                                                Authenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, self).__init__()

                                                                                    self.yang_name = "auth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsername, ['string_array'], name, value)


                                                                            class AuthUsernameRegex(Entity):
                                                                                """
                                                                                Authenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "auth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "auth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AuthUsernameRegex, ['string_array'], name, value)


                                                                            class AvailId(Entity):
                                                                                """
                                                                                Available Identifiers
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, self).__init__()

                                                                                    self.yang_name = "avail-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "avail-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.AvailId, ['uint8_array'], name, value)


                                                                            class CircuitId(Entity):
                                                                                """
                                                                                Circuit ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, self).__init__()

                                                                                    self.yang_name = "circuit-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitId, ['string_array'], name, value)


                                                                            class CircuitIdRegex(Entity):
                                                                                """
                                                                                Circuit ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, self).__init__()

                                                                                    self.yang_name = "circuit-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "circuit-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CircuitIdRegex, ['string_array'], name, value)


                                                                            class Cos(Entity):
                                                                                """
                                                                                Match CoS array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, self).__init__()

                                                                                    self.yang_name = "cos"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Cos, ['uint8_array'], name, value)


                                                                            class CosInr(Entity):
                                                                                """
                                                                                Match inner header CoS
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, self).__init__()

                                                                                    self.yang_name = "cos-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "cos-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.CosInr, ['uint8_array'], name, value)


                                                                            class Dei(Entity):
                                                                                """
                                                                                Match DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, self).__init__()

                                                                                    self.yang_name = "dei"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dei, ['bit_value'], name, value)


                                                                            class DeiInr(Entity):
                                                                                """
                                                                                Match inner DEI Bit
                                                                                
                                                                                .. attribute:: bit_value
                                                                                
                                                                                	Value of the DEI bit
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..4294967295
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, self).__init__()

                                                                                    self.yang_name = "dei-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.bit_value = YLeaf(YType.uint32, "bit-value")
                                                                                    self._segment_path = lambda: "dei-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DeiInr, ['bit_value'], name, value)


                                                                            class DhcpClientId(Entity):
                                                                                """
                                                                                Dhcp Client ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientId, ['string_array'], name, value)


                                                                            class DhcpClientIdRegex(Entity):
                                                                                """
                                                                                Dhcp Client ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, self).__init__()

                                                                                    self.yang_name = "dhcp-client-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dhcp-client-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DhcpClientIdRegex, ['string_array'], name, value)


                                                                            class DiscardClass(Entity):
                                                                                """
                                                                                Match Discard Class array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, self).__init__()

                                                                                    self.yang_name = "discard-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "discard-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DiscardClass, ['uint8_array'], name, value)


                                                                            class Dnis(Entity):
                                                                                """
                                                                                DNIS
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, self).__init__()

                                                                                    self.yang_name = "dnis"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dnis, ['string_array'], name, value)


                                                                            class DnisRegex(Entity):
                                                                                """
                                                                                DNIS Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, self).__init__()

                                                                                    self.yang_name = "dnis-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "dnis-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DnisRegex, ['string_array'], name, value)


                                                                            class Domain(Entity):
                                                                                """
                                                                                Domain Name
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, self).__init__()

                                                                                    self.yang_name = "domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Domain.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class DomainRegex(Entity):
                                                                                """
                                                                                Domain Regular Expression
                                                                                
                                                                                .. attribute:: domain_array
                                                                                
                                                                                	domain array
                                                                                	**type**\: list of    :py:class:`DomainArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, self).__init__()

                                                                                    self.yang_name = "domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"domain-array" : ("domain_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray)}

                                                                                    self.domain_array = YList(self)
                                                                                    self._segment_path = lambda: "domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex, [], name, value)


                                                                                class DomainArray(Entity):
                                                                                    """
                                                                                    domain array
                                                                                    
                                                                                    .. attribute:: domain_name
                                                                                    
                                                                                    	domain name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    .. attribute:: format_name
                                                                                    
                                                                                    	format name
                                                                                    	**type**\:  str
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, self).__init__()

                                                                                        self.yang_name = "domain-array"
                                                                                        self.yang_parent_name = "domain-regex"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.domain_name = YLeaf(YType.str, "domain-name")

                                                                                        self.format_name = YLeaf(YType.str, "format-name")
                                                                                        self._segment_path = lambda: "domain-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DomainRegex.DomainArray, ['domain_name', 'format_name'], name, value)


                                                                            class Dscp(Entity):
                                                                                """
                                                                                Match DSCP range array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, self).__init__()

                                                                                    self.yang_name = "dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class DstAddrIpv4(Entity):
                                                                                """
                                                                                Destination Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstAddrIpv6(Entity):
                                                                                """
                                                                                Destination Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, self).__init__()

                                                                                    self.yang_name = "dst-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "dst-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class DstMac(Entity):
                                                                                """
                                                                                Match Destination MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, self).__init__()

                                                                                    self.yang_name = "dst-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "dst-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstMac, ['mac_addr', 'mask'], name, value)


                                                                            class DstPort(Entity):
                                                                                """
                                                                                Destination port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, self).__init__()

                                                                                    self.yang_name = "dst-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "dst-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "dst-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.DstPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class EtherServiceAcl(Entity):
                                                                                """
                                                                                Ethernet\-Services Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, self).__init__()

                                                                                    self.yang_name = "ether-service-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ether-service-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.EtherServiceAcl, ['string_array'], name, value)


                                                                            class Ethertype(Entity):
                                                                                """
                                                                                Ethernet type
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, self).__init__()

                                                                                    self.yang_name = "ethertype"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ethertype"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ethertype"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ethertype.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class FlowKeyData(Entity):
                                                                                """
                                                                                Flow key structure
                                                                                
                                                                                .. attribute:: flow_keys
                                                                                
                                                                                	flow keys
                                                                                	**type**\:   :py:class:`FlowKeys <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys>`
                                                                                
                                                                                .. attribute:: idle_timeout
                                                                                
                                                                                	Idle timeout of flows (in seconds)
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                	**units**\: second
                                                                                
                                                                                .. attribute:: max_count
                                                                                
                                                                                	Maximum count of flows
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, self).__init__()

                                                                                    self.yang_name = "flow-key-data"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {"flow-keys" : ("flow_keys", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys)}
                                                                                    self._child_list_classes = {}

                                                                                    self.idle_timeout = YLeaf(YType.uint16, "idle-timeout")

                                                                                    self.max_count = YLeaf(YType.uint16, "max-count")

                                                                                    self.flow_keys = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys()
                                                                                    self.flow_keys.parent = self
                                                                                    self._children_name_map["flow_keys"] = "flow-keys"
                                                                                    self._children_yang_names.add("flow-keys")
                                                                                    self._segment_path = lambda: "flow-key-data"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData, ['idle_timeout', 'max_count'], name, value)


                                                                                class FlowKeys(Entity):
                                                                                    """
                                                                                    flow keys
                                                                                    
                                                                                    .. attribute:: keys
                                                                                    
                                                                                    	keys
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ([0\-9a\-fA\-F]{2}(\:[0\-9a\-fA\-F]{2})\*)?
                                                                                    
                                                                                    .. attribute:: num
                                                                                    
                                                                                    	num
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, self).__init__()

                                                                                        self.yang_name = "flow-keys"
                                                                                        self.yang_parent_name = "flow-key-data"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.keys = YLeaf(YType.str, "keys")

                                                                                        self.num = YLeaf(YType.uint8, "num")
                                                                                        self._segment_path = lambda: "flow-keys"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowKeyData.FlowKeys, ['keys', 'num'], name, value)


                                                                            class FlowTag(Entity):
                                                                                """
                                                                                Match flow\-tag array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, self).__init__()

                                                                                    self.yang_name = "flow-tag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "flow-tag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "flow-tag"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FlowTag.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class FrDe(Entity):
                                                                                """
                                                                                Match FR DE value
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, self).__init__()

                                                                                    self.yang_name = "fr-de"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "fr-de"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDe, ['uint8_array'], name, value)


                                                                            class FrDlci(Entity):
                                                                                """
                                                                                Match FR DLCI range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, self).__init__()

                                                                                    self.yang_name = "fr-dlci"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "fr-dlci"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "fr-dlci"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.FrDlci.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class IcmpV4(Entity):
                                                                                """
                                                                                Match ICMPV4 Protocol
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, self).__init__()

                                                                                    self.yang_name = "icmp-v4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV4, ['code', 'type'], name, value)


                                                                            class IcmpV6(Entity):
                                                                                """
                                                                                Match ICMPV6 Protocol array
                                                                                
                                                                                .. attribute:: code
                                                                                
                                                                                	Protocol code
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                .. attribute:: type
                                                                                
                                                                                	Protocol type
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, self).__init__()

                                                                                    self.yang_name = "icmp-v6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.code = YLeaf(YType.uint8, "code")

                                                                                    self.type = YLeaf(YType.uint8, "type")
                                                                                    self._segment_path = lambda: "icmp-v6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.IcmpV6, ['code', 'type'], name, value)


                                                                            class Icmpv4Code(Entity):
                                                                                """
                                                                                Match ipv4 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, self).__init__()

                                                                                    self.yang_name = "icmpv4-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv4Type(Entity):
                                                                                """
                                                                                Match ipv4 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, self).__init__()

                                                                                    self.yang_name = "icmpv4-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv4-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv4-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv4Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Code(Entity):
                                                                                """
                                                                                Match ipv6 icmp code
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, self).__init__()

                                                                                    self.yang_name = "icmpv6-code"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-code"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-code"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Code.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Icmpv6Type(Entity):
                                                                                """
                                                                                Match ipv6 icmp type
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, self).__init__()

                                                                                    self.yang_name = "icmpv6-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "icmpv6-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "icmpv6-type"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Icmpv6Type.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class InputInterface(Entity):
                                                                                """
                                                                                Input interface
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, self).__init__()

                                                                                    self.yang_name = "input-interface"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "input-interface"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputInterface, ['string_array'], name, value)


                                                                            class InputIntfhdl(Entity):
                                                                                """
                                                                                Input interface handle
                                                                                
                                                                                .. attribute:: uint64_array
                                                                                
                                                                                	uint64 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..18446744073709551615
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, self).__init__()

                                                                                    self.yang_name = "input-intfhdl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint64_array = YLeafList(YType.uint64, "uint64_array")
                                                                                    self._segment_path = lambda: "input-intfhdl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.InputIntfhdl, ['uint64_array'], name, value)


                                                                            class Ipv4Acl(Entity):
                                                                                """
                                                                                IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, self).__init__()

                                                                                    self.yang_name = "ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Acl, ['string_array'], name, value)


                                                                            class Ipv4Dscp(Entity):
                                                                                """
                                                                                IPv4 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, self).__init__()

                                                                                    self.yang_name = "ipv4-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv4-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4PacketLen(Entity):
                                                                                """
                                                                                IPv4 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv4-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv4-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv4-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv4Prec(Entity):
                                                                                """
                                                                                IPv4 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, self).__init__()

                                                                                    self.yang_name = "ipv4-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv4-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv4Prec, ['uint8_array'], name, value)


                                                                            class Ipv6Acl(Entity):
                                                                                """
                                                                                IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, self).__init__()

                                                                                    self.yang_name = "ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Acl, ['string_array'], name, value)


                                                                            class Ipv6Dscp(Entity):
                                                                                """
                                                                                IPv6 DSCP
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, self).__init__()

                                                                                    self.yang_name = "ipv6-dscp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-dscp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "ipv6-dscp"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Dscp.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6PacketLen(Entity):
                                                                                """
                                                                                IPv6 packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, self).__init__()

                                                                                    self.yang_name = "ipv6-packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "ipv6-packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "ipv6-packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Ipv6Prec(Entity):
                                                                                """
                                                                                IPv6 Precedence
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, self).__init__()

                                                                                    self.yang_name = "ipv6-prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "ipv6-prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Ipv6Prec, ['uint8_array'], name, value)


                                                                            class MediaType(Entity):
                                                                                """
                                                                                Media Type
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, self).__init__()

                                                                                    self.yang_name = "media-type"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "media-type"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MediaType, ['uint8_array'], name, value)


                                                                            class MplsDispIpv4Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv4 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv4-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv4-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv4Acl, ['string_array'], name, value)


                                                                            class MplsDispIpv6Acl(Entity):
                                                                                """
                                                                                MPLS Disposition IPv6 Access\-list
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, self).__init__()

                                                                                    self.yang_name = "mpls-disp-ipv6-acl"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "mpls-disp-ipv6-acl"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsDispIpv6Acl, ['string_array'], name, value)


                                                                            class MplsExp(Entity):
                                                                                """
                                                                                Match MPLS experimental topmost array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, self).__init__()

                                                                                    self.yang_name = "mpls-exp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExp, ['uint8_array'], name, value)


                                                                            class MplsExpImp(Entity):
                                                                                """
                                                                                Match MPLS experimental imposition array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, self).__init__()

                                                                                    self.yang_name = "mpls-exp-imp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "mpls-exp-imp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsExpImp, ['uint8_array'], name, value)


                                                                            class MplsTopLabel(Entity):
                                                                                """
                                                                                MPLS Topmost LABEL
                                                                                
                                                                                .. attribute:: uint32_rng_array
                                                                                
                                                                                	uint32 rng array
                                                                                	**type**\: list of    :py:class:`Uint32RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, self).__init__()

                                                                                    self.yang_name = "mpls-top-label"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint32_rng_array" : ("uint32_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray)}

                                                                                    self.uint32_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "mpls-top-label"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel, [], name, value)


                                                                                class Uint32RngArray(Entity):
                                                                                    """
                                                                                    uint32 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, self).__init__()

                                                                                        self.yang_name = "uint32_rng_array"
                                                                                        self.yang_parent_name = "mpls-top-label"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint32, "max")

                                                                                        self.min = YLeaf(YType.uint32, "min")
                                                                                        self._segment_path = lambda: "uint32_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.MplsTopLabel.Uint32RngArray, ['max', 'min'], name, value)


                                                                            class NasPort(Entity):
                                                                                """
                                                                                NAS Port
                                                                                
                                                                                .. attribute:: nas_port_array
                                                                                
                                                                                	nas port array
                                                                                	**type**\: list of    :py:class:`NasPortArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, self).__init__()

                                                                                    self.yang_name = "nas-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"nas-port-array" : ("nas_port_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray)}

                                                                                    self.nas_port_array = YList(self)
                                                                                    self._segment_path = lambda: "nas-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort, [], name, value)


                                                                                class NasPortArray(Entity):
                                                                                    """
                                                                                    nas port array
                                                                                    
                                                                                    .. attribute:: operator
                                                                                    
                                                                                    	operator
                                                                                    	**type**\:   :py:class:`MatchLogicalOperatorEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchLogicalOperatorEn>`
                                                                                    
                                                                                    .. attribute:: sub_id
                                                                                    
                                                                                    	sub id
                                                                                    	**type**\:   :py:class:`MatchNasPortSubIdEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.MatchNasPortSubIdEn>`
                                                                                    
                                                                                    .. attribute:: value
                                                                                    
                                                                                    	value
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, self).__init__()

                                                                                        self.yang_name = "nas-port-array"
                                                                                        self.yang_parent_name = "nas-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.operator = YLeaf(YType.enumeration, "operator")

                                                                                        self.sub_id = YLeaf(YType.enumeration, "sub-id")

                                                                                        self.value = YLeaf(YType.uint32, "value")
                                                                                        self._segment_path = lambda: "nas-port-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.NasPort.NasPortArray, ['operator', 'sub_id', 'value'], name, value)


                                                                            class PacketLen(Entity):
                                                                                """
                                                                                Match packet length array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, self).__init__()

                                                                                    self.yang_name = "packet-len"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "packet-len"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "packet-len"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.PacketLen.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class Prec(Entity):
                                                                                """
                                                                                Match Precedence array
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, self).__init__()

                                                                                    self.yang_name = "prec"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "prec"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Prec, ['uint8_array'], name, value)


                                                                            class Proto(Entity):
                                                                                """
                                                                                Match Protocol array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, self).__init__()

                                                                                    self.yang_name = "proto"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "proto"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "proto"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Proto.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class QosGroup(Entity):
                                                                                """
                                                                                Match QoS group array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, self).__init__()

                                                                                    self.yang_name = "qos-group"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "qos-group"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "qos-group"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.QosGroup.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class RemoteId(Entity):
                                                                                """
                                                                                Remote ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, self).__init__()

                                                                                    self.yang_name = "remote-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteId, ['string_array'], name, value)


                                                                            class RemoteIdRegex(Entity):
                                                                                """
                                                                                Remote ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, self).__init__()

                                                                                    self.yang_name = "remote-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "remote-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.RemoteIdRegex, ['string_array'], name, value)


                                                                            class ServiceName(Entity):
                                                                                """
                                                                                Service Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, self).__init__()

                                                                                    self.yang_name = "service-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceName, ['string_array'], name, value)


                                                                            class ServiceNameRegex(Entity):
                                                                                """
                                                                                Service Name Regular Exp
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, self).__init__()

                                                                                    self.yang_name = "service-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "service-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.ServiceNameRegex, ['string_array'], name, value)


                                                                            class SrcAddrIpv4(Entity):
                                                                                """
                                                                                Source Address IPV4
                                                                                
                                                                                .. attribute:: ipv4_addr_array
                                                                                
                                                                                	ipv4 addr array
                                                                                	**type**\: list of    :py:class:`Ipv4AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv4"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv4-addr-array" : ("ipv4_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray)}

                                                                                    self.ipv4_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv4"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4, [], name, value)


                                                                                class Ipv4AddrArray(Entity):
                                                                                    """
                                                                                    ipv4 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	mask
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** (([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])\\.){3}([0\-9]\|[1\-9][0\-9]\|1[0\-9][0\-9]\|2[0\-4][0\-9]\|25[0\-5])(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv4-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv4"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.str, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv4-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv4.Ipv4AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrIpv6(Entity):
                                                                                """
                                                                                Source Address IPV6
                                                                                
                                                                                .. attribute:: ipv6_addr_array
                                                                                
                                                                                	ipv6 addr array
                                                                                	**type**\: list of    :py:class:`Ipv6AddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, self).__init__()

                                                                                    self.yang_name = "src-addr-ipv6"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"ipv6-addr-array" : ("ipv6_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray)}

                                                                                    self.ipv6_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-ipv6"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6, [], name, value)


                                                                                class Ipv6AddrArray(Entity):
                                                                                    """
                                                                                    ipv6 addr array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	IPV6 mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..4294967295
                                                                                    
                                                                                    .. attribute:: prefix
                                                                                    
                                                                                    	IPV6 prefix
                                                                                    	**type**\:  str
                                                                                    
                                                                                    	**pattern:** ((\:\|[0\-9a\-fA\-F]{0,4})\:)([0\-9a\-fA\-F]{0,4}\:){0,5}((([0\-9a\-fA\-F]{0,4}\:)?(\:\|[0\-9a\-fA\-F]{0,4}))\|(((25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])\\.){3}(25[0\-5]\|2[0\-4][0\-9]\|[01]?[0\-9]?[0\-9])))(%[\\p{N}\\p{L}]+)?
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, self).__init__()

                                                                                        self.yang_name = "ipv6-addr-array"
                                                                                        self.yang_parent_name = "src-addr-ipv6"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint32, "mask")

                                                                                        self.prefix = YLeaf(YType.str, "prefix")
                                                                                        self._segment_path = lambda: "ipv6-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrIpv6.Ipv6AddrArray, ['mask', 'prefix'], name, value)


                                                                            class SrcAddrMac(Entity):
                                                                                """
                                                                                Source Address MAC
                                                                                
                                                                                .. attribute:: mac_addr_array
                                                                                
                                                                                	mac addr array
                                                                                	**type**\: list of    :py:class:`MacAddrArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, self).__init__()

                                                                                    self.yang_name = "src-addr-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"mac-addr-array" : ("mac_addr_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray)}

                                                                                    self.mac_addr_array = YList(self)
                                                                                    self._segment_path = lambda: "src-addr-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac, [], name, value)


                                                                                class MacAddrArray(Entity):
                                                                                    """
                                                                                    mac addr array
                                                                                    
                                                                                    .. attribute:: mac_addr
                                                                                    
                                                                                    	MAC address
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	MAC mask
                                                                                    	**type**\:  list of int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, self).__init__()

                                                                                        self.yang_name = "mac-addr-array"
                                                                                        self.yang_parent_name = "src-addr-mac"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                        self.mask = YLeafList(YType.uint16, "mask")
                                                                                        self._segment_path = lambda: "mac-addr-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcAddrMac.MacAddrArray, ['mac_addr', 'mask'], name, value)


                                                                            class SrcMac(Entity):
                                                                                """
                                                                                Match Source MAC address
                                                                                
                                                                                .. attribute:: mac_addr
                                                                                
                                                                                	MAC address
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                .. attribute:: mask
                                                                                
                                                                                	MAC mask
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, self).__init__()

                                                                                    self.yang_name = "src-mac"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.mac_addr = YLeafList(YType.uint16, "mac-addr")

                                                                                    self.mask = YLeafList(YType.uint16, "mask")
                                                                                    self._segment_path = lambda: "src-mac"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcMac, ['mac_addr', 'mask'], name, value)


                                                                            class SrcPort(Entity):
                                                                                """
                                                                                Source port
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, self).__init__()

                                                                                    self.yang_name = "src-port"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "src-port"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "src-port"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SrcPort.Uint16RngArray, ['max', 'min'], name, value)


                                                                            class SubsProtocol(Entity):
                                                                                """
                                                                                Protocol
                                                                                
                                                                                .. attribute:: uint8_array
                                                                                
                                                                                	uint8 array
                                                                                	**type**\:  list of int
                                                                                
                                                                                	**range:** 0..255
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, self).__init__()

                                                                                    self.yang_name = "subs-protocol"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.uint8_array = YLeafList(YType.uint8, "uint8_array")
                                                                                    self._segment_path = lambda: "subs-protocol"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.SubsProtocol, ['uint8_array'], name, value)


                                                                            class TcpFlag(Entity):
                                                                                """
                                                                                Match tcp flag value
                                                                                
                                                                                .. attribute:: match_any
                                                                                
                                                                                	Match any TCP flag bit
                                                                                	**type**\:  bool
                                                                                
                                                                                .. attribute:: value
                                                                                
                                                                                	Value of TCP flag
                                                                                	**type**\:  int
                                                                                
                                                                                	**range:** 0..65535
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, self).__init__()

                                                                                    self.yang_name = "tcp-flag"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.match_any = YLeaf(YType.boolean, "match-any")

                                                                                    self.value = YLeaf(YType.uint16, "value")
                                                                                    self._segment_path = lambda: "tcp-flag"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TcpFlag, ['match_any', 'value'], name, value)


                                                                            class Timer(Entity):
                                                                                """
                                                                                Timer
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, self).__init__()

                                                                                    self.yang_name = "timer"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Timer, ['string_array'], name, value)


                                                                            class TimerRegexp(Entity):
                                                                                """
                                                                                Timer Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, self).__init__()

                                                                                    self.yang_name = "timer-regexp"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "timer-regexp"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TimerRegexp, ['string_array'], name, value)


                                                                            class TrafficClass(Entity):
                                                                                """
                                                                                Match Traffic class array
                                                                                
                                                                                .. attribute:: uint8_rng_array
                                                                                
                                                                                	uint8 rng array
                                                                                	**type**\: list of    :py:class:`Uint8RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, self).__init__()

                                                                                    self.yang_name = "traffic-class"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint8_rng_array" : ("uint8_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray)}

                                                                                    self.uint8_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "traffic-class"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass, [], name, value)


                                                                                class Uint8RngArray(Entity):
                                                                                    """
                                                                                    uint8 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..255
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, self).__init__()

                                                                                        self.yang_name = "uint8_rng_array"
                                                                                        self.yang_parent_name = "traffic-class"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint8, "max")

                                                                                        self.min = YLeaf(YType.uint8, "min")
                                                                                        self._segment_path = lambda: "uint8_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TrafficClass.Uint8RngArray, ['max', 'min'], name, value)


                                                                            class TunnelName(Entity):
                                                                                """
                                                                                Tunnel Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, self).__init__()

                                                                                    self.yang_name = "tunnel-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelName, ['string_array'], name, value)


                                                                            class TunnelNameRegex(Entity):
                                                                                """
                                                                                Tunnel Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, self).__init__()

                                                                                    self.yang_name = "tunnel-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "tunnel-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.TunnelNameRegex, ['string_array'], name, value)


                                                                            class UnauthDomain(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, self).__init__()

                                                                                    self.yang_name = "unauth-domain"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomain, ['string_array'], name, value)


                                                                            class UnauthDomainRegex(Entity):
                                                                                """
                                                                                Unauthenticated Domain Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, self).__init__()

                                                                                    self.yang_name = "unauth-domain-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-domain-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthDomainRegex, ['string_array'], name, value)


                                                                            class UnauthUsername(Entity):
                                                                                """
                                                                                Unauthenticated User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, self).__init__()

                                                                                    self.yang_name = "unauth-username"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsername, ['string_array'], name, value)


                                                                            class UnauthUsernameRegex(Entity):
                                                                                """
                                                                                Unauthenticated User Name RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, self).__init__()

                                                                                    self.yang_name = "unauth-username-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "unauth-username-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UnauthUsernameRegex, ['string_array'], name, value)


                                                                            class UserName(Entity):
                                                                                """
                                                                                User Name
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, self).__init__()

                                                                                    self.yang_name = "user-name"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserName, ['string_array'], name, value)


                                                                            class UserNameRegex(Entity):
                                                                                """
                                                                                User Name Regular Expression
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, self).__init__()

                                                                                    self.yang_name = "user-name-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "user-name-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.UserNameRegex, ['string_array'], name, value)


                                                                            class VendorId(Entity):
                                                                                """
                                                                                Vendor ID
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, self).__init__()

                                                                                    self.yang_name = "vendor-id"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorId, ['string_array'], name, value)


                                                                            class VendorIdRegex(Entity):
                                                                                """
                                                                                Vendor ID RegEx
                                                                                
                                                                                .. attribute:: string_array
                                                                                
                                                                                	string array
                                                                                	**type**\:  list of str
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, self).__init__()

                                                                                    self.yang_name = "vendor-id-regex"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {}

                                                                                    self.string_array = YLeafList(YType.str, "string-array")
                                                                                    self._segment_path = lambda: "vendor-id-regex"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VendorIdRegex, ['string_array'], name, value)


                                                                            class Vlan(Entity):
                                                                                """
                                                                                Match VLAN array
                                                                                
                                                                                .. attribute:: vlan_id_array
                                                                                
                                                                                	vlan id array
                                                                                	**type**\: list of    :py:class:`VlanIdArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, self).__init__()

                                                                                    self.yang_name = "vlan"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"vlan-id-array" : ("vlan_id_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray)}

                                                                                    self.vlan_id_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan, [], name, value)


                                                                                class VlanIdArray(Entity):
                                                                                    """
                                                                                    vlan id array
                                                                                    
                                                                                    .. attribute:: mask
                                                                                    
                                                                                    	VLAN mask
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, self).__init__()

                                                                                        self.yang_name = "vlan-id-array"
                                                                                        self.yang_parent_name = "vlan"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.mask = YLeaf(YType.uint16, "mask")

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "vlan-id-array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.Vlan.VlanIdArray, ['mask', 'max', 'min'], name, value)


                                                                            class VlanInr(Entity):
                                                                                """
                                                                                Match inner header VLAN range array
                                                                                
                                                                                .. attribute:: uint16_rng_array
                                                                                
                                                                                	uint16 rng array
                                                                                	**type**\: list of    :py:class:`Uint16RngArray <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray>`
                                                                                
                                                                                

                                                                                """

                                                                                _prefix = 'infra-policymgr-oper'
                                                                                _revision = '2017-05-27'

                                                                                def __init__(self):
                                                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, self).__init__()

                                                                                    self.yang_name = "vlan-inr"
                                                                                    self.yang_parent_name = "match-data"
                                                                                    self.is_top_level_class = False
                                                                                    self.has_list_ancestor = True
                                                                                    self._child_container_classes = {}
                                                                                    self._child_list_classes = {"uint16_rng_array" : ("uint16_rng_array", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray)}

                                                                                    self.uint16_rng_array = YList(self)
                                                                                    self._segment_path = lambda: "vlan-inr"

                                                                                def __setattr__(self, name, value):
                                                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr, [], name, value)


                                                                                class Uint16RngArray(Entity):
                                                                                    """
                                                                                    uint16 rng array
                                                                                    
                                                                                    .. attribute:: max
                                                                                    
                                                                                    	Upper limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    .. attribute:: min
                                                                                    
                                                                                    	Lower limit of the range
                                                                                    	**type**\:  int
                                                                                    
                                                                                    	**range:** 0..65535
                                                                                    
                                                                                    

                                                                                    """

                                                                                    _prefix = 'infra-policymgr-oper'
                                                                                    _revision = '2017-05-27'

                                                                                    def __init__(self):
                                                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, self).__init__()

                                                                                        self.yang_name = "uint16_rng_array"
                                                                                        self.yang_parent_name = "vlan-inr"
                                                                                        self.is_top_level_class = False
                                                                                        self.has_list_ancestor = True
                                                                                        self._child_container_classes = {}
                                                                                        self._child_list_classes = {}

                                                                                        self.max = YLeaf(YType.uint16, "max")

                                                                                        self.min = YLeaf(YType.uint16, "min")
                                                                                        self._segment_path = lambda: "uint16_rng_array"

                                                                                    def __setattr__(self, name, value):
                                                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.EventInfop.PolicyEventInfoBg.ClassInfop.PolicyClassInfoBg.ClmpP.ClassMapBg.MatchInfop.ClassMatchInfoSt.MatchData.VlanInr.Uint16RngArray, ['max', 'min'], name, value)


                                        class PmapVarList(Entity):
                                            """
                                            pmap var list
                                            
                                            .. attribute:: offset
                                            
                                            	offset
                                            	**type**\:  list of int
                                            
                                            	**range:** 0..255
                                            
                                            .. attribute:: pmap_var_list_arr
                                            
                                            	pmap var list arr
                                            	**type**\: list of    :py:class:`PmapVarListArr <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr>`
                                            
                                            

                                            """

                                            _prefix = 'infra-policymgr-oper'
                                            _revision = '2017-05-27'

                                            def __init__(self):
                                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, self).__init__()

                                                self.yang_name = "pmap-var-list"
                                                self.yang_parent_name = "policy-map-bg"
                                                self.is_top_level_class = False
                                                self.has_list_ancestor = True
                                                self._child_container_classes = {}
                                                self._child_list_classes = {"pmap-var-list-arr" : ("pmap_var_list_arr", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr)}

                                                self.offset = YLeafList(YType.uint8, "offset")

                                                self.pmap_var_list_arr = YList(self)
                                                self._segment_path = lambda: "pmap-var-list"

                                            def __setattr__(self, name, value):
                                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList, ['offset'], name, value)


                                            class PmapVarListArr(Entity):
                                                """
                                                pmap var list arr
                                                
                                                .. attribute:: id
                                                
                                                	id
                                                	**type**\:  int
                                                
                                                	**range:** 0..4294967295
                                                
                                                .. attribute:: name
                                                
                                                	name
                                                	**type**\:  str
                                                
                                                	**length:** 0..32
                                                
                                                .. attribute:: val
                                                
                                                	val
                                                	**type**\:   :py:class:`Val <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val>`
                                                
                                                

                                                """

                                                _prefix = 'infra-policymgr-oper'
                                                _revision = '2017-05-27'

                                                def __init__(self):
                                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, self).__init__()

                                                    self.yang_name = "pmap-var-list-arr"
                                                    self.yang_parent_name = "pmap-var-list"
                                                    self.is_top_level_class = False
                                                    self.has_list_ancestor = True
                                                    self._child_container_classes = {"val" : ("val", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val)}
                                                    self._child_list_classes = {}

                                                    self.id = YLeaf(YType.uint32, "id")

                                                    self.name = YLeaf(YType.str, "name")

                                                    self.val = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val()
                                                    self.val.parent = self
                                                    self._children_name_map["val"] = "val"
                                                    self._children_yang_names.add("val")
                                                    self._segment_path = lambda: "pmap-var-list-arr"

                                                def __setattr__(self, name, value):
                                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr, ['id', 'name'], name, value)


                                                class Val(Entity):
                                                    """
                                                    val
                                                    
                                                    .. attribute:: class_name
                                                    
                                                    	class name
                                                    	**type**\:  str
                                                    
                                                    	**length:** 0..65
                                                    
                                                    .. attribute:: dscp_val
                                                    
                                                    	dscp val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: param_uint32_val
                                                    
                                                    	param uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: prec_val
                                                    
                                                    	prec val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    .. attribute:: type
                                                    
                                                    	type
                                                    	**type**\:   :py:class:`PlmgrVarTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrVarTypeEn>`
                                                    
                                                    .. attribute:: uint16_val
                                                    
                                                    	uint16 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..65535
                                                    
                                                    .. attribute:: uint32_val
                                                    
                                                    	uint32 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..4294967295
                                                    
                                                    .. attribute:: uint8_val
                                                    
                                                    	uint8 val
                                                    	**type**\:  int
                                                    
                                                    	**range:** 0..255
                                                    
                                                    

                                                    """

                                                    _prefix = 'infra-policymgr-oper'
                                                    _revision = '2017-05-27'

                                                    def __init__(self):
                                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, self).__init__()

                                                        self.yang_name = "val"
                                                        self.yang_parent_name = "pmap-var-list-arr"
                                                        self.is_top_level_class = False
                                                        self.has_list_ancestor = True
                                                        self._child_container_classes = {}
                                                        self._child_list_classes = {}

                                                        self.class_name = YLeaf(YType.str, "class-name")

                                                        self.dscp_val = YLeaf(YType.uint8, "dscp-val")

                                                        self.param_uint32_val = YLeaf(YType.uint32, "param-uint32-val")

                                                        self.prec_val = YLeaf(YType.uint8, "prec-val")

                                                        self.type = YLeaf(YType.enumeration, "type")

                                                        self.uint16_val = YLeaf(YType.uint16, "uint16_val")

                                                        self.uint32_val = YLeaf(YType.uint32, "uint32_val")

                                                        self.uint8_val = YLeaf(YType.uint8, "uint8_val")
                                                        self._segment_path = lambda: "val"

                                                    def __setattr__(self, name, value):
                                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypeXr.TransientPolicyMapType.TransientPolicyMapNames.TransientPolicyMapName.Definition.PolicyMapBg.PmapVarList.PmapVarListArr.Val, ['class_name', 'dscp_val', 'param_uint32_val', 'prec_val', 'type', 'uint16_val', 'uint32_val', 'uint8_val'], name, value)


                class TransientPolicyMapTypes(Entity):
                    """
                    Application type of transient policy\-map list
                    
                    .. attribute:: transient_policy_map_type
                    
                    	Transient policy\-map type
                    	**type**\: list of    :py:class:`TransientPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes, self).__init__()

                        self.yang_name = "transient-policy-map-types"
                        self.yang_parent_name = "policy-map"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"transient-policy-map-type" : ("transient_policy_map_type", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType)}

                        self.transient_policy_map_type = YList(self)
                        self._segment_path = lambda: "transient-policy-map-types"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes, [], name, value)


                    class TransientPolicyMapType(Entity):
                        """
                        Transient policy\-map type
                        
                        .. attribute:: type  <key>
                        
                        	The application type
                        	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                        
                        .. attribute:: transient_list_unuseds
                        
                        	Transient policy\-map list unused table
                        	**type**\:   :py:class:`TransientListUnuseds <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, self).__init__()

                            self.yang_name = "transient-policy-map-type"
                            self.yang_parent_name = "transient-policy-map-types"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {"transient-list-unuseds" : ("transient_list_unuseds", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds)}
                            self._child_list_classes = {}

                            self.type = YLeaf(YType.enumeration, "type")

                            self.transient_list_unuseds = PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds()
                            self.transient_list_unuseds.parent = self
                            self._children_name_map["transient_list_unuseds"] = "transient-list-unuseds"
                            self._children_yang_names.add("transient-list-unuseds")
                            self._segment_path = lambda: "transient-policy-map-type" + "[type='" + self.type.get() + "']"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType, ['type'], name, value)


                        class TransientListUnuseds(Entity):
                            """
                            Transient policy\-map list unused table
                            
                            .. attribute:: transient_list_unused
                            
                            	Policy\-map list unused
                            	**type**\: list of    :py:class:`TransientListUnused <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused>`
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, self).__init__()

                                self.yang_name = "transient-list-unuseds"
                                self.yang_parent_name = "transient-policy-map-type"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {"transient-list-unused" : ("transient_list_unused", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused)}

                                self.transient_list_unused = YList(self)
                                self._segment_path = lambda: "transient-list-unuseds"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds, [], name, value)


                            class TransientListUnused(Entity):
                                """
                                Policy\-map list unused
                                
                                .. attribute:: policy_map_name  <key>
                                
                                	Name of policy\-map
                                	**type**\:  str
                                
                                	**length:** 1..63
                                
                                .. attribute:: class_map_reference
                                
                                	Each Classmapdetails
                                	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference>`
                                
                                .. attribute:: object_type
                                
                                	Application type configured
                                	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                
                                .. attribute:: objects
                                
                                	Each object details
                                	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects>`
                                
                                .. attribute:: reference
                                
                                	Each Policymap details
                                	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference>`
                                
                                .. attribute:: total_objects
                                
                                	Total number of objects configured for a specific object type
                                	**type**\:  int
                                
                                	**range:** 0..4294967295
                                
                                .. attribute:: transient
                                
                                	Transient object
                                	**type**\:  bool
                                
                                

                                """

                                _prefix = 'infra-policymgr-oper'
                                _revision = '2017-05-27'

                                def __init__(self):
                                    super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, self).__init__()

                                    self.yang_name = "transient-list-unused"
                                    self.yang_parent_name = "transient-list-unuseds"
                                    self.is_top_level_class = False
                                    self.has_list_ancestor = True
                                    self._child_container_classes = {}
                                    self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference)}

                                    self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                    self.object_type = YLeaf(YType.enumeration, "object-type")

                                    self.total_objects = YLeaf(YType.uint32, "total-objects")

                                    self.transient = YLeaf(YType.boolean, "transient")

                                    self.class_map_reference = YList(self)
                                    self.objects = YList(self)
                                    self.reference = YList(self)
                                    self._segment_path = lambda: "transient-list-unused" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                                def __setattr__(self, name, value):
                                    self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused, ['policy_map_name', 'object_type', 'total_objects', 'transient'], name, value)


                                class ClassMapReference(Entity):
                                    """
                                    Each Classmapdetails
                                    
                                    .. attribute:: policy_map_reference
                                    
                                    	List of Policymaps referencing a Classmap
                                    	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference>`
                                    
                                    .. attribute:: total_reference_objects
                                    
                                    	Total number of Policymaps referencing a Classmap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, self).__init__()

                                        self.yang_name = "class-map-reference"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference)}

                                        self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                                        self.policy_map_reference = YList(self)
                                        self._segment_path = lambda: "class-map-reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference, ['total_reference_objects'], name, value)


                                    class PolicyMapReference(Entity):
                                        """
                                        List of Policymaps referencing a Classmap
                                        
                                        .. attribute:: object_type
                                        
                                        	Application type configured
                                        	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                                        
                                        .. attribute:: policy_map_name
                                        
                                        	Name of Policymap referencing a Classmap
                                        	**type**\:  str
                                        
                                        	**length:** 0..64
                                        
                                        

                                        """

                                        _prefix = 'infra-policymgr-oper'
                                        _revision = '2017-05-27'

                                        def __init__(self):
                                            super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, self).__init__()

                                            self.yang_name = "policy-map-reference"
                                            self.yang_parent_name = "class-map-reference"
                                            self.is_top_level_class = False
                                            self.has_list_ancestor = True
                                            self._child_container_classes = {}
                                            self._child_list_classes = {}

                                            self.object_type = YLeaf(YType.enumeration, "object-type")

                                            self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                            self._segment_path = lambda: "policy-map-reference"

                                        def __setattr__(self, name, value):
                                            self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                                class Objects(Entity):
                                    """
                                    Each object details
                                    
                                    .. attribute:: object_name
                                    
                                    	Name of object (Policymap/Classmap)
                                    	**type**\:  str
                                    
                                    	**length:** 0..64
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, self).__init__()

                                        self.yang_name = "objects"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.object_name = YLeaf(YType.str, "object-name")
                                        self._segment_path = lambda: "objects"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Objects, ['object_name'], name, value)


                                class Reference(Entity):
                                    """
                                    Each Policymap details
                                    
                                    .. attribute:: total_class_maps
                                    
                                    	Total number of Classmaps in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_flows
                                    
                                    	Total flows in a Policymap
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    .. attribute:: total_internal_reference_objects
                                    
                                    	Total number of internal reference objects
                                    	**type**\:  int
                                    
                                    	**range:** 0..4294967295
                                    
                                    

                                    """

                                    _prefix = 'infra-policymgr-oper'
                                    _revision = '2017-05-27'

                                    def __init__(self):
                                        super(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, self).__init__()

                                        self.yang_name = "reference"
                                        self.yang_parent_name = "transient-list-unused"
                                        self.is_top_level_class = False
                                        self.has_list_ancestor = True
                                        self._child_container_classes = {}
                                        self._child_list_classes = {}

                                        self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                                        self.total_flows = YLeaf(YType.uint32, "total-flows")

                                        self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                                        self._segment_path = lambda: "reference"

                                    def __setattr__(self, name, value):
                                        self._perform_setattr(PolicyManager.Nodes.Node.PolicyMap.TransientPolicyMapTypes.TransientPolicyMapType.TransientListUnuseds.TransientListUnused.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


            class Summary(Entity):
                """
                Summary of policy\-maps and class\-maps configured
                
                .. attribute:: class_maps
                
                	Summary of Classmap database
                	**type**\: list of    :py:class:`ClassMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps>`
                
                .. attribute:: policy_maps
                
                	Summary of Policymap database
                	**type**\: list of    :py:class:`PolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps>`
                
                .. attribute:: total_class_map_types
                
                	Total number of Classmap types configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_class_maps
                
                	Total number of Classmaps configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_policy_map_types
                
                	Total number of Policymap types configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                .. attribute:: total_policy_maps
                
                	Total number of Policymaps configured
                	**type**\:  int
                
                	**range:** 0..4294967295
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.Summary, self).__init__()

                    self.yang_name = "summary"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self._child_container_classes = {}
                    self._child_list_classes = {"class-maps" : ("class_maps", PolicyManager.Nodes.Node.Summary.ClassMaps), "policy-maps" : ("policy_maps", PolicyManager.Nodes.Node.Summary.PolicyMaps)}

                    self.total_class_map_types = YLeaf(YType.uint32, "total-class-map-types")

                    self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                    self.total_policy_map_types = YLeaf(YType.uint32, "total-policy-map-types")

                    self.total_policy_maps = YLeaf(YType.uint32, "total-policy-maps")

                    self.class_maps = YList(self)
                    self.policy_maps = YList(self)
                    self._segment_path = lambda: "summary"

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.Summary, ['total_class_map_types', 'total_class_maps', 'total_policy_map_types', 'total_policy_maps'], name, value)


                class ClassMaps(Entity):
                    """
                    Summary of Classmap database
                    
                    .. attribute:: class_map_reference
                    
                    	Each Classmapdetails
                    	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference>`
                    
                    .. attribute:: object_type
                    
                    	Application type configured
                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                    
                    .. attribute:: objects
                    
                    	Each object details
                    	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.Objects>`
                    
                    .. attribute:: reference
                    
                    	Each Policymap details
                    	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.Reference>`
                    
                    .. attribute:: total_objects
                    
                    	Total number of objects configured for a specific object type
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transient
                    
                    	Transient object
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.Summary.ClassMaps, self).__init__()

                        self.yang_name = "class-maps"
                        self.yang_parent_name = "summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.Summary.ClassMaps.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.Summary.ClassMaps.Reference)}

                        self.object_type = YLeaf(YType.enumeration, "object-type")

                        self.total_objects = YLeaf(YType.uint32, "total-objects")

                        self.transient = YLeaf(YType.boolean, "transient")

                        self.class_map_reference = YList(self)
                        self.objects = YList(self)
                        self.reference = YList(self)
                        self._segment_path = lambda: "class-maps"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps, ['object_type', 'total_objects', 'transient'], name, value)


                    class ClassMapReference(Entity):
                        """
                        Each Classmapdetails
                        
                        .. attribute:: policy_map_reference
                        
                        	List of Policymaps referencing a Classmap
                        	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference>`
                        
                        .. attribute:: total_reference_objects
                        
                        	Total number of Policymaps referencing a Classmap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference, self).__init__()

                            self.yang_name = "class-map-reference"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference)}

                            self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                            self.policy_map_reference = YList(self)
                            self._segment_path = lambda: "class-map-reference"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference, ['total_reference_objects'], name, value)


                        class PolicyMapReference(Entity):
                            """
                            List of Policymaps referencing a Classmap
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: policy_map_name
                            
                            	Name of Policymap referencing a Classmap
                            	**type**\:  str
                            
                            	**length:** 0..64
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference, self).__init__()

                                self.yang_name = "policy-map-reference"
                                self.yang_parent_name = "class-map-reference"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {}

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                self._segment_path = lambda: "policy-map-reference"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                    class Objects(Entity):
                        """
                        Each object details
                        
                        .. attribute:: object_name
                        
                        	Name of object (Policymap/Classmap)
                        	**type**\:  str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.Objects, self).__init__()

                            self.yang_name = "objects"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.object_name = YLeaf(YType.str, "object-name")
                            self._segment_path = lambda: "objects"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.Objects, ['object_name'], name, value)


                    class Reference(Entity):
                        """
                        Each Policymap details
                        
                        .. attribute:: total_class_maps
                        
                        	Total number of Classmaps in a Policymap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_flows
                        
                        	Total flows in a Policymap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_internal_reference_objects
                        
                        	Total number of internal reference objects
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.ClassMaps.Reference, self).__init__()

                            self.yang_name = "reference"
                            self.yang_parent_name = "class-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                            self.total_flows = YLeaf(YType.uint32, "total-flows")

                            self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                            self._segment_path = lambda: "reference"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.ClassMaps.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


                class PolicyMaps(Entity):
                    """
                    Summary of Policymap database
                    
                    .. attribute:: class_map_reference
                    
                    	Each Classmapdetails
                    	**type**\: list of    :py:class:`ClassMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference>`
                    
                    .. attribute:: object_type
                    
                    	Application type configured
                    	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                    
                    .. attribute:: objects
                    
                    	Each object details
                    	**type**\: list of    :py:class:`Objects <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects>`
                    
                    .. attribute:: reference
                    
                    	Each Policymap details
                    	**type**\: list of    :py:class:`Reference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference>`
                    
                    .. attribute:: total_objects
                    
                    	Total number of objects configured for a specific object type
                    	**type**\:  int
                    
                    	**range:** 0..4294967295
                    
                    .. attribute:: transient
                    
                    	Transient object
                    	**type**\:  bool
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.Summary.PolicyMaps, self).__init__()

                        self.yang_name = "policy-maps"
                        self.yang_parent_name = "summary"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {}
                        self._child_list_classes = {"class-map-reference" : ("class_map_reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference), "objects" : ("objects", PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects), "reference" : ("reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference)}

                        self.object_type = YLeaf(YType.enumeration, "object-type")

                        self.total_objects = YLeaf(YType.uint32, "total-objects")

                        self.transient = YLeaf(YType.boolean, "transient")

                        self.class_map_reference = YList(self)
                        self.objects = YList(self)
                        self.reference = YList(self)
                        self._segment_path = lambda: "policy-maps"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps, ['object_type', 'total_objects', 'transient'], name, value)


                    class ClassMapReference(Entity):
                        """
                        Each Classmapdetails
                        
                        .. attribute:: policy_map_reference
                        
                        	List of Policymaps referencing a Classmap
                        	**type**\: list of    :py:class:`PolicyMapReference <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference>`
                        
                        .. attribute:: total_reference_objects
                        
                        	Total number of Policymaps referencing a Classmap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference, self).__init__()

                            self.yang_name = "class-map-reference"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"policy-map-reference" : ("policy_map_reference", PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference)}

                            self.total_reference_objects = YLeaf(YType.uint32, "total-reference-objects")

                            self.policy_map_reference = YList(self)
                            self._segment_path = lambda: "class-map-reference"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference, ['total_reference_objects'], name, value)


                        class PolicyMapReference(Entity):
                            """
                            List of Policymaps referencing a Classmap
                            
                            .. attribute:: object_type
                            
                            	Application type configured
                            	**type**\:   :py:class:`PlmgrApplnTypeEn <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PlmgrApplnTypeEn>`
                            
                            .. attribute:: policy_map_name
                            
                            	Name of Policymap referencing a Classmap
                            	**type**\:  str
                            
                            	**length:** 0..64
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, self).__init__()

                                self.yang_name = "policy-map-reference"
                                self.yang_parent_name = "class-map-reference"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {}

                                self.object_type = YLeaf(YType.enumeration, "object-type")

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")
                                self._segment_path = lambda: "policy-map-reference"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.ClassMapReference.PolicyMapReference, ['object_type', 'policy_map_name'], name, value)


                    class Objects(Entity):
                        """
                        Each object details
                        
                        .. attribute:: object_name
                        
                        	Name of object (Policymap/Classmap)
                        	**type**\:  str
                        
                        	**length:** 0..64
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects, self).__init__()

                            self.yang_name = "objects"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.object_name = YLeaf(YType.str, "object-name")
                            self._segment_path = lambda: "objects"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.Objects, ['object_name'], name, value)


                    class Reference(Entity):
                        """
                        Each Policymap details
                        
                        .. attribute:: total_class_maps
                        
                        	Total number of Classmaps in a Policymap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_flows
                        
                        	Total flows in a Policymap
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_internal_reference_objects
                        
                        	Total number of internal reference objects
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference, self).__init__()

                            self.yang_name = "reference"
                            self.yang_parent_name = "policy-maps"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.total_class_maps = YLeaf(YType.uint32, "total-class-maps")

                            self.total_flows = YLeaf(YType.uint32, "total-flows")

                            self.total_internal_reference_objects = YLeaf(YType.uint32, "total-internal-reference-objects")
                            self._segment_path = lambda: "reference"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.Summary.PolicyMaps.Reference, ['total_class_maps', 'total_flows', 'total_internal_reference_objects'], name, value)


            class TargetPolicyMapTypes(Entity):
                """
                Targets of a policymap
                
                .. attribute:: target_policy_map_type
                
                	Policymgr application type
                	**type**\: list of    :py:class:`TargetPolicyMapType <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType>`
                
                

                """

                _prefix = 'infra-policymgr-oper'
                _revision = '2017-05-27'

                def __init__(self):
                    super(PolicyManager.Nodes.Node.TargetPolicyMapTypes, self).__init__()

                    self.yang_name = "target-policy-map-types"
                    self.yang_parent_name = "node"
                    self.is_top_level_class = False
                    self.has_list_ancestor = True
                    self._child_container_classes = {}
                    self._child_list_classes = {"target-policy-map-type" : ("target_policy_map_type", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType)}

                    self.target_policy_map_type = YList(self)
                    self._segment_path = lambda: "target-policy-map-types"

                def __setattr__(self, name, value):
                    self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes, [], name, value)


                class TargetPolicyMapType(Entity):
                    """
                    Policymgr application type
                    
                    .. attribute:: type  <key>
                    
                    	The application type
                    	**type**\:   :py:class:`PolicymgrPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicymgrPolicyMap>`
                    
                    .. attribute:: policy_map_target_summary
                    
                    	Policy\-map table
                    	**type**\:   :py:class:`PolicyMapTargetSummary <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary>`
                    
                    .. attribute:: policy_map_targets
                    
                    	Policy\-map table
                    	**type**\:   :py:class:`PolicyMapTargets <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets>`
                    
                    .. attribute:: target_summary_per_policy_maps
                    
                    	Policy\-map table per Policy\-map
                    	**type**\:   :py:class:`TargetSummaryPerPolicyMaps <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps>`
                    
                    

                    """

                    _prefix = 'infra-policymgr-oper'
                    _revision = '2017-05-27'

                    def __init__(self):
                        super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType, self).__init__()

                        self.yang_name = "target-policy-map-type"
                        self.yang_parent_name = "target-policy-map-types"
                        self.is_top_level_class = False
                        self.has_list_ancestor = True
                        self._child_container_classes = {"policy-map-target-summary" : ("policy_map_target_summary", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary), "policy-map-targets" : ("policy_map_targets", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets), "target-summary-per-policy-maps" : ("target_summary_per_policy_maps", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps)}
                        self._child_list_classes = {}

                        self.type = YLeaf(YType.enumeration, "type")

                        self.policy_map_target_summary = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary()
                        self.policy_map_target_summary.parent = self
                        self._children_name_map["policy_map_target_summary"] = "policy-map-target-summary"
                        self._children_yang_names.add("policy-map-target-summary")

                        self.policy_map_targets = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets()
                        self.policy_map_targets.parent = self
                        self._children_name_map["policy_map_targets"] = "policy-map-targets"
                        self._children_yang_names.add("policy-map-targets")

                        self.target_summary_per_policy_maps = PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps()
                        self.target_summary_per_policy_maps.parent = self
                        self._children_name_map["target_summary_per_policy_maps"] = "target-summary-per-policy-maps"
                        self._children_yang_names.add("target-summary-per-policy-maps")
                        self._segment_path = lambda: "target-policy-map-type" + "[type='" + self.type.get() + "']"

                    def __setattr__(self, name, value):
                        self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType, ['type'], name, value)


                    class PolicyMapTargetSummary(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: total_child_policy_maps_input_direction
                        
                        	Totalpolicymaps applied as child policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_child_policy_maps_output_direction
                        
                        	Totalpolicymaps applied as child policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_input_direction
                        
                        	Totalinterfaces with service\-policy in the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_interfaces_output_direction
                        
                        	Totalinterfaces with service\-policy in the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_input_direction
                        
                        	Total policymapsin the input direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        .. attribute:: total_policy_maps_output_direction
                        
                        	Total policymapsin the output direction
                        	**type**\:  int
                        
                        	**range:** 0..4294967295
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, self).__init__()

                            self.yang_name = "policy-map-target-summary"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {}

                            self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                            self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                            self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                            self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                            self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                            self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                            self._segment_path = lambda: "policy-map-target-summary"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargetSummary, ['total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)


                    class PolicyMapTargets(Entity):
                        """
                        Policy\-map table
                        
                        .. attribute:: policy_map_target
                        
                        	Policy\-map targets
                        	**type**\: list of    :py:class:`PolicyMapTarget <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, self).__init__()

                            self.yang_name = "policy-map-targets"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"policy-map-target" : ("policy_map_target", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget)}

                            self.policy_map_target = YList(self)
                            self._segment_path = lambda: "policy-map-targets"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets, [], name, value)


                        class PolicyMapTarget(Entity):
                            """
                            Policy\-map targets
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: parent_targets
                            
                            	parent targets
                            	**type**\:  list of str
                            
                            .. attribute:: targets
                            
                            	targets
                            	**type**\:  list of str
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, self).__init__()

                                self.yang_name = "policy-map-target"
                                self.yang_parent_name = "policy-map-targets"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.parent_targets = YLeafList(YType.str, "parent-targets")

                                self.targets = YLeafList(YType.str, "targets")
                                self._segment_path = lambda: "policy-map-target" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.PolicyMapTargets.PolicyMapTarget, ['policy_map_name', 'parent_targets', 'targets'], name, value)


                    class TargetSummaryPerPolicyMaps(Entity):
                        """
                        Policy\-map table per Policy\-map
                        
                        .. attribute:: target_summary_per_policy_map
                        
                        	Policy\-map targets summary
                        	**type**\: list of    :py:class:`TargetSummaryPerPolicyMap <ydk.models.cisco_ios_xr.Cisco_IOS_XR_infra_policymgr_oper.PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap>`
                        
                        

                        """

                        _prefix = 'infra-policymgr-oper'
                        _revision = '2017-05-27'

                        def __init__(self):
                            super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, self).__init__()

                            self.yang_name = "target-summary-per-policy-maps"
                            self.yang_parent_name = "target-policy-map-type"
                            self.is_top_level_class = False
                            self.has_list_ancestor = True
                            self._child_container_classes = {}
                            self._child_list_classes = {"target-summary-per-policy-map" : ("target_summary_per_policy_map", PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap)}

                            self.target_summary_per_policy_map = YList(self)
                            self._segment_path = lambda: "target-summary-per-policy-maps"

                        def __setattr__(self, name, value):
                            self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps, [], name, value)


                        class TargetSummaryPerPolicyMap(Entity):
                            """
                            Policy\-map targets summary
                            
                            .. attribute:: policy_map_name  <key>
                            
                            	Name of policy\-map
                            	**type**\:  str
                            
                            	**length:** 1..63
                            
                            .. attribute:: total_child_policy_maps_input_direction
                            
                            	Totalpolicymaps applied as child policy in the input direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_child_policy_maps_output_direction
                            
                            	Totalpolicymaps applied as child policy in the output direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_interfaces_input_direction
                            
                            	Totalinterfaces with service\-policy in the input direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_interfaces_output_direction
                            
                            	Totalinterfaces with service\-policy in the output direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_policy_maps_input_direction
                            
                            	Total policymapsin the input direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            .. attribute:: total_policy_maps_output_direction
                            
                            	Total policymapsin the output direction
                            	**type**\:  int
                            
                            	**range:** 0..4294967295
                            
                            

                            """

                            _prefix = 'infra-policymgr-oper'
                            _revision = '2017-05-27'

                            def __init__(self):
                                super(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, self).__init__()

                                self.yang_name = "target-summary-per-policy-map"
                                self.yang_parent_name = "target-summary-per-policy-maps"
                                self.is_top_level_class = False
                                self.has_list_ancestor = True
                                self._child_container_classes = {}
                                self._child_list_classes = {}

                                self.policy_map_name = YLeaf(YType.str, "policy-map-name")

                                self.total_child_policy_maps_input_direction = YLeaf(YType.uint32, "total-child-policy-maps-input-direction")

                                self.total_child_policy_maps_output_direction = YLeaf(YType.uint32, "total-child-policy-maps-output-direction")

                                self.total_interfaces_input_direction = YLeaf(YType.uint32, "total-interfaces-input-direction")

                                self.total_interfaces_output_direction = YLeaf(YType.uint32, "total-interfaces-output-direction")

                                self.total_policy_maps_input_direction = YLeaf(YType.uint32, "total-policy-maps-input-direction")

                                self.total_policy_maps_output_direction = YLeaf(YType.uint32, "total-policy-maps-output-direction")
                                self._segment_path = lambda: "target-summary-per-policy-map" + "[policy-map-name='" + self.policy_map_name.get() + "']"

                            def __setattr__(self, name, value):
                                self._perform_setattr(PolicyManager.Nodes.Node.TargetPolicyMapTypes.TargetPolicyMapType.TargetSummaryPerPolicyMaps.TargetSummaryPerPolicyMap, ['policy_map_name', 'total_child_policy_maps_input_direction', 'total_child_policy_maps_output_direction', 'total_interfaces_input_direction', 'total_interfaces_output_direction', 'total_policy_maps_input_direction', 'total_policy_maps_output_direction'], name, value)

    def clone_ptr(self):
        self._top_entity = PolicyManager()
        return self._top_entity

